#!/bin/sh

TOOLCHAIN_DIR=/usr/mipsel-linux-uclibc/bin/
# Added the line below. The line above is original
#TOOLCHAIN_DIR=/root/toolchain_mips/mips-linux/

# Sanjay - the line below is added by me since I don't see how the toolchain
# path would be added
#PATH=${PATH}:/root/toolchain_mips/bin
PATH=${PATH}:/usr/mipsel-linux-uclibc/bin
# gcc 2.96
CROSS_COMPILER_PREFIX=mipsel-uclibc-
# gcc 3.x
#CROSS_COMPILER_PREFIX=mipsel-linux-uclibc-

IFX_COMMON_DIR=${TOPDIR}/source/user/common
BUILD_DIR=${TOPDIR}/build/
BUILD_TOOLS_DIR=${TOPDIR}/tools/build_tools/
BUILD_ROOTFS_DIR=${BUILD_DIR}root_filesystem/

IFX_CFLAGS="-Os -fomit-frame-pointer -I${IFX_COMMON_DIR}/inc"
IFX_LDFLAGS="-L${BUILD_ROOTFS_DIR}lib"

MAKE=make

# Source Code Directory for complier
#IFX_APPS_SUBDIRS="Amazon ilmid oam"
IFX_APPS_SUBDIRS="Amazon ilmid oam iptablesapi ipqosapi"
#IFX_APPS_SUBDIRS="Amazon"
#OPENSOURCE_APPS_SUBDIRS="linux-atm-2.4.1 net-snmp-5.1 br2684ctl-20040226-1 dnrd-2.10 iproute2 mtd ntpclient bridge-utils 
OPENSOURCE_APPS_SUBDIRS="linux-atm-2.4.1 net-snmp-5.1 br2684ctl-20040226-1 iproute2 mtd ntpclient bridge-utils ez-ipupdate-3.0.11b7 iptables-1.2.9 ppp-2.4.2 zebra-0.94 goahead_web_server tftp-hpa-0.35"


TARGET=mips-linux
HOST=i386-redhat-linux 
BUILD=i386-pc-linux-gnu

IFX_CC=${CROSS_COMPILER_PREFIX}gcc
IFX_AR=${CROSS_COMPILER_PREFIX}ar
IFX_AS=${CROSS_COMPILER_PREFIX}as
IFX_LD=${CROSS_COMPILER_PREFIX}ld
IFX_NM=${CROSS_COMPILER_PREFIX}nm
IFX_STRIP=${CROSS_COMPILER_PREFIX}strip
IFX_RANLIB=${CROSS_COMPILER_PREFIX}ranlib
IFX_CXX=${CROSS_COMPILER_PREFIX}g++ 
IFX_CPP=${CROSS_COMPILER_PREFIX}cpp
IFX_OBJCOPY=${CROSS_COMPILER_PREFIX}objcopy
IFX_OBJDUMP=${CROSS_COMPILER_PREFIX}objdump
IFX_HOSTCC=gcc


IFX_COMMON_DIR=${TOPDIR}/source/user/common
IFX_SOURCE_DIR=${TOPDIR}/source/user/ifx/

USER_SOURCE_DIR=${TOPDIR}/source/user/
USER_IFXSOURCE_DIR=${TOPDIR}/source/user/ifx
USER_OPENSOURCE_DIR=${TOPDIR}/source/user/opensource/
KERNEL_SOURCE_DIR=${TOPDIR}/source/kernel/opensource/linux_2_4_20_mvl
RAMDISK_DIR=${TOPDIR}/source/rootfs/ramdisk

##################
# Functions
################

ifx_error_check ()
{
	if [ $1 -ne 0 ]
	then
        echo "ERROR: building $APPS_NAME fail, errno: $1"
        exit $1
	fi
}

