
/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : ifx_snmp_api.h
 * Author       : Subramani
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains function prototypes for:
 *                 1) Reading and writing data to the snmpd.conf file
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 *
 * $Log$
 * ===========================================================================
 */


/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */

#include<sys/types.h>
#include<signal.h>
#include <ifx_common.h>


/*
 * ===========================================================================
 *                           GLOBAL DEFINITIONS
 * ===========================================================================
 */
#define SNMP_PID_FILE_PATH "/var/run/snmpd_pid"

struct v3user {
 char username[25];
 int access;
};

typedef  int bool;


/*
 * ===========================================================================
 *                           EXPORTED FUNCTIONS
 * ===========================================================================
 */
bool IFX_SNMPd_Get_Conf(char * ro_community, char * rw_community,\
	bool *trap_enable, char * trap_host_ip, unsigned long *trap_port,\
       	char *trap_community);

bool IFX_SNMPd_Set_Conf(char * ro_community, char * rw_community,\
	bool *trap_enable,char * trap_host_ip, unsigned long *trap_port,\
       	char *trap_community);

int IFX_add_snmpv3_user(char *user, char *user_access, char *authProto, char *authPassPhrase,
		char *encrProto, char *encrPassPhrase);

int IFX_delete_snmpv3_user(char *user);

int IFX_get_all_snmpv3_users (struct v3user **pv3user, int *num_users);

int IFX_adsl_ioctl(int fd, int cmd, void *structptr);

int IFX_dev_open(const char *pathname, int flags);

int IFX_dev_close(int fd);
