/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>



CGI_TABLE_S FirewallMacTable[APPS_NUM_OF_ETHFTR_ENTRY];

int websUpdate_FirewallMac(int nCount)
{
	char_t sBuf[BUF_SIZE_1K];
	int nIndex = 0;
	memset(sBuf, 0, BUF_SIZE_1K);
	gsprintf(sBuf, T("%sCount=\"%d\"\n"), PREFIX_FIREWALLMAC, nCount);			
	
	for (nIndex=0; nIndex<nCount; nIndex++)
	{	
		char_t sLine[MAX_FILELINE_LEN];
		// Print following strings 
		// MAC_DENY_0="00:E0:18:E0:98:2E"
		// MAC_DENY_STAT0="0"
		gsprintf(sLine, T("%sSTAT%d=\"%d\"\n%s%d=\"%s\"\n"), PREFIX_FIREWALLMAC, nIndex, FirewallMacTable[nIndex].nState, PREFIX_FIREWALLMAC, nIndex, FirewallMacTable[nIndex].Data.sValue);

		//trace(8, sLine);
		gstrcat(sBuf, sLine);
	}

	//return (websSetCfgData(FILE_RC_CONF, TAG_FIREWALLMAC, 1, sBuf));
	return (websSetCfgData(FILE_RC_FIREWALL, TAG_FIREWALLMAC, 1, sBuf));
}

int ifx_get_MacControl(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t *name,*mode, sValue[MAX_DATA_LEN];
	memset(sValue, 0x00, MAX_DATA_LEN);

   	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
   	{
   		ifx_httpdError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}

	if ( !gstrcmp(name, T("check")) )
	{	
		if (ifx_GetCfgData(FILE_RC_FIREWALL, TAG_FIREWALLMAC_STAT, T("MAC_control"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "MAC_control not found");
			return -1;	
		}

		if (!gstrcmp(sValue, "1") )	// MAC control is enabled
		{
			gstrcpy(sValue, "1");
		}
		else
		{
			gstrcpy(sValue, "0");
		}	
		
	}
	else if ( !gstrcmp(name, T("unspecify")) )
	{	
		if (ifx_GetCfgData(FILE_RC_FIREWALL, TAG_FIREWALLMAC_STAT, T("MAC_Unspecified"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "MAC_Unspecified not found");
			return -1;	
		}

		if (!gstrcmp(sValue, "1") )	// Unspecified MAC is enabled
		{
			gstrcpy(sValue, "1");
		}
		else
		{
			gstrcpy(sValue, "0");
		}
		
	}
		
	if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0){
		ifx_httpdWrite(wp,T("checked"));
	}else if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0){
		ifx_httpdWrite(wp,T("checked"));
	}
	return 0;

}

int ifx_get_MacFilter(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t  sValue[MAX_DATA_LEN], sCommand[MAX_DATA_LEN], sMacAddr[MAX_DATA_LEN], sMacStat[MAX_DATA_LEN];
	int     nCount, nIndex;

	gsprintf(sCommand, T("%sCount"), PREFIX_FIREWALLMAC);
	if (ifx_GetCfgData(FILE_RC_FIREWALL, TAG_FIREWALLMAC, sCommand, sValue) == 0)
	{
		ifx_httpdError(wp, 200, T("%s not found"), sCommand);
		return -1;
	}
	
	nCount = gatoi(sValue);
	for (nIndex=0; nIndex<nCount; nIndex++)
	{
		// Get MAC Status
		gsprintf(sCommand, T("grep ^%sSTAT%d %s | cut -f2 -d'\"'"), PREFIX_FIREWALLMAC, nIndex, FILE_RC_FIREWALL);
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sMacStat) == 0)
		{
			ifx_httpdError(wp, 200, T("MAC_STAT_%dnot found"), nIndex);
			return -1;
		}
		
		// Get MAC Address
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"'"), PREFIX_FIREWALLMAC, nIndex, FILE_RC_FIREWALL);
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sMacAddr) == 0)
		{
			ifx_httpdError(wp, 204, T("MAC_DENY_%d not found"), nIndex);
			return -1;
		}
		
		// Print Html file
		ifx_httpdWrite(wp, T("<tr align=\"center\" bgcolor=\"#ffffff\">\n")); 
		ifx_httpdWrite(wp, T("<td width=\"24%\"><input type=\"CHECKBOX\" name=\"adconnect%d\" value=\"1\" %s></td>\n"), nIndex, (gstrcmp(sMacStat, "0") ? "checked" : ""));
		ifx_httpdWrite(wp, T("<td width=\"50%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), sMacAddr); 
		ifx_httpdWrite(wp, T("<td width=\"26%\"><center><input type=\"button\" name=\"relname\" value=\"Delete\" onClick=\"macrelease(%d);\"></center></td>\n"), nIndex); 
		ifx_httpdWrite(wp, T("</tr>\n"));
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////////
// firewall_mac.asp
//
void ifx_set_firewall_mac(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pCheck = ifx_httpdGetVar(wp, T("check"), T("")); 
	char_t	*pUnspecify = ifx_httpdGetVar(wp, T("unspecify"), T("")); 	
	char_t	*pAdd = ifx_httpdGetVar(wp, T("hostAdd1"), T(""));
	char_t	*pDel = ifx_httpdGetVar(wp, T("delflag"), T(""));
	char_t	sCheck[MAX_DATA_LEN];
	char_t	sUnspecify[MAX_DATA_LEN];
	int nIndex = 0, nCurNum = 0;
   	char_t	sBuf[MAX_DATA_LEN];
   	char_t	*padConnecti;

	// Get original data from file
	nCurNum = websSetData2Table(wp, FILE_RC_FIREWALL, TAG_FIREWALLMAC, PREFIX_FIREWALLMAC, FirewallMacTable);
	if (nCurNum == -1)
	{
		ifx_httpdError(wp, 200, "Insufficient data for firewall Mac table");
		return;
	}

	// Normal case, press 'Apply' only
	if ( !gstrcmp(pCheck, T("1")))
		gsprintf(sCheck, "MAC_control=%d\n", 1); 
	else
		gsprintf(sCheck, "MAC_control=%d\n", 0);

	if ( !gstrcmp(pUnspecify, T("1")))
		gsprintf(sUnspecify, "MAC_Unspecified=%d\n",1); 
	else
		gsprintf(sUnspecify, "MAC_Unspecified=%d\n",0);

	websSetCfgData(FILE_RC_FIREWALL, TAG_FIREWALLMAC_STAT, 2, sCheck, sUnspecify);

    
	// Get Allow Connect checkbox status
    	for (nIndex=0; nIndex<nCurNum; nIndex++)
    	{
        	gsprintf(sBuf, "adconnect%d", nIndex);
        	padConnecti = ifx_httpdGetVar(wp, sBuf, T(""));

		FirewallMacTable[nIndex].nState = (padConnecti[0] ? ETHFTR_CFG_ALLOW : ETHFTR_CFG_DENY);
		////trace(8, "adconnect%d=%d\n", nIndex, FirewallMacTable[nIndex].nState);
	}

	////////// Update Table to File ///////////////
	websUpdate_FirewallMac(nCurNum);

	// Submit data from press "Add" button
	if (pAdd[0])
	{
		char_t	*pMacfilterAdd0 = ifx_httpdGetVar(wp, T("macfilterAdd0"), T(""));			// Text
		char_t	*pMacfilterAdd1 = ifx_httpdGetVar(wp, T("macfilterAdd1"), T(""));			// Text
		char_t	*pMacfilterAdd2 = ifx_httpdGetVar(wp, T("macfilterAdd2"), T(""));			// Text
		char_t	*pMacfilterAdd3 = ifx_httpdGetVar(wp, T("macfilterAdd3"), T(""));			// Text
		char_t	*pMacfilterAdd4 = ifx_httpdGetVar(wp, T("macfilterAdd4"), T(""));			// Text
		char_t	*pMacfilterAdd5 = ifx_httpdGetVar(wp, T("macfilterAdd5"), T(""));			// Text		
		char_t	*pMacfilterAction = ifx_httpdGetVar(wp, T("macfilterAction"), T(""));		// checkbox
		char_t	sAddEntry[MAX_FILELINE_LEN];
		uint	nState = 0;

		gsprintf(sAddEntry, T("%s:%s:%s:%s:%s:%s"), pMacfilterAdd0, pMacfilterAdd1, pMacfilterAdd2, 
												 pMacfilterAdd3, pMacfilterAdd4, pMacfilterAdd5);

		if (pMacfilterAction[0])
			nState = ETHFTR_CFG_ALLOW;			// checked
		else
			nState = ETHFTR_CFG_DENY;	

		// Update table and system
		for (nIndex=0; nIndex<=nCurNum; nIndex++)
		{
			// 1st, check duplicated
			// 2nd, check empty space
			// 3rd, Add to latest entry
			if (gstrncmp(FirewallMacTable[nIndex].Data.sValue, sAddEntry, sizeof(sAddEntry)) == 0)
			{
				ifx_httpdError(wp, 200, "Duplicate Filter MAC address");
				return;
			}

			if (FirewallMacTable[nIndex].nIndex == 0 && !FirewallMacTable[nIndex].Data.sValue[0])
			{
				FirewallMacTable[nIndex].nIndex = nIndex;
				FirewallMacTable[nIndex].nState = nState;
				gstrcpy(FirewallMacTable[nIndex].Data.sValue, sAddEntry);

				nCurNum = nIndex+1;
				break;
			}
		}

		// No more space to add data
		if (nIndex > APPS_NUM_OF_ETHFTR_ENTRY)	
		{
			ifx_httpdError(wp, 200, T("Out of space to add static routing entry"));
			return;
		}

		////////// Update Table to File ///////////////
		websUpdate_FirewallMac(nCurNum);
	}

	// Submit data from press delete button
	if (!gstrcmp(pDel, T("1")))
	{
		char_t	*pDelIndex = ifx_httpdGetVar(wp, T("delindex"), T(""));
		int		nDelIndex = gatoi(pDelIndex);

		// Remove DelIndex from Table
		for (nIndex=0; nIndex<nCurNum; nIndex++)
		{
			if (nIndex >= nDelIndex)
			{	
				FirewallMacTable[nIndex].nIndex = FirewallMacTable[nIndex+1].nIndex;
				FirewallMacTable[nIndex].nState = FirewallMacTable[nIndex+1].nState;				
				gstrcpy(FirewallMacTable[nIndex].Data.sValue, FirewallMacTable[nIndex+1].Data.sValue);
			}
		}

		////////// Update Table to File ///////////////
		websUpdate_FirewallMac(nCurNum-1);
	}

	//Runtime Change
	websChg2ExeMode(FILE_RC_FIREWALL);	// chmod after update file
	system(FILE_RC_IPTABLES);       
	system(FILE_RC_FIREWALL);
                                    
	//add by calvinc 20040519 save to flash
	system(SERVICE_RESTORE);  
        //end addd	                
                                    
	ifx_httpdNextPage(wp);
}