/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/reboot.h>
#include	<ifx_common.h>
#include	<ctype.h>
#include 	<sys/ioctl.h>
#include	"./ifx_src_cgi.h"
#include	"ifx_httpd_method.h"

#include "ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#endif

#ifdef DMALLOC
#include "dmalloc.h"
#endif

extern struct connection_profil connection;
extern int16 NoOfPbEntries;
#if defined(ATA) || defined(IIP)
extern x_IFX_CM_AppAddressBookEntry xPBEntry[50];
#endif

//**************************** Global variables ********************************
char_t g_nCurrentUserName[12] = "";  //char_t	sCommand[MAX_DATA_LEN]; 
char_t g_nCurrentPassword[12] = "";  // Stores Current loged in password

int g_nCurrentUserLevel = 2;				//0:admin, 1:common user, 2:general user, default = 2
int g_nCurrentAPMode = 0;					//0:AP, 1:AP Client
int g_nCurrentConnectedAP_WEP=0;           // For Client Mode, 1:WEP enable, 0:WEP disable

extern int web_image_length;
extern int  websGetWanMode();
extern void websGetInterfaceIP(const char_t* pInterface, int nIdx, bool_t bBreak, char_t* pRetValue);
extern void websGetNetmask(const char_t* pInterface, int nReqIdx, bool_t bBreak, char_t* pRetValue);
extern void websGetGateway(int nReqIdx, bool_t bBreak, char_t* pRetValue);
extern int websGetCfgData2Table(httpd_t wp, const char_t* pFileName, char_t* pTag, const char_t* pSymbol, CGI_TABLE_S *pTable, int nTableType);
extern void websGetWanIface(char_t* pRetValue);

//***************************** Common API ********************************

int websSetData2Table(httpd_t wp, const char_t* pFileName, char_t* pTag, const char_t* pSymbol, CGI_TABLE_S *pTable)
{
	char_t  sValue[MAX_DATA_LEN], sCommand[MAX_FILELINE_LEN];
	int     nCount = 0, nIndex = 0;
	
	memset(pTable, 0, sizeof(*pTable));
	memset(sValue, 0, sizeof(sValue));
	memset(sCommand, 0, sizeof(sCommand));

	// All data should store as the following format
	// 		SymbolCount="10"
	// 		Symbol1="xxx"
	//		Symbol2="xxx"
	//		...
	// Example1:
	//	aliasIPCount="2"
	//	aliasIP0="10.2.2.100 netmask 255.255.255.0"
	//	aliasIP1="10.2.2.111 netmask 255.255.255.0"
	//
	// Example2:
	//	MAC_DENY_Count="2" 
	//	MAC_DENY_0="00:E0:18:E0:98:2E"
	// 	MAC_DENY_STAT0="0"
	//	MAC_DENY_1="00:E0:18:E0:98:3E"
	//	MAC_DENY_STAT1="1"
	//
	
	// 1st, get total count "XXXCount"
	gsprintf(sCommand, T("%sCount"), pSymbol);
	if (ifx_GetCfgData((char *)pFileName, pTag, sCommand, sValue) == 0)
	{
		ifx_httpdError(wp, 204, T("%sCount not found"), sCommand);
		return -1;
	}	

	nCount = gatoi(sValue);
	for (nIndex=0; nIndex<nCount; nIndex++)
	{	
		// Get value from file
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"'"), pSymbol, nIndex, pFileName);
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sValue) == 0)
		{
			ifx_httpdError(wp, 204, T("%s not found"), sCommand);
			return -1;
		}

		pTable[nIndex].nIndex = nIndex;
		gstrcpy(pTable[nIndex].Data.sValue, sValue);
		
		// Get status from file
		gsprintf(sCommand, T("grep ^%sSTAT%d %s | cut -f2 -d'\"'"), pSymbol, nIndex, pFileName);
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sValue) == 1)
		{
			if (!gstrcmp(sValue, "0"))
				pTable[nIndex].nState = 0;
			else
				pTable[nIndex].nState = 1;
		}
	}	

	return nCount;
}

void websChg2ExeMode(char_t* pFileName)
{
	char_t sBuf[MAX_DATA_LEN];
	gsprintf(sBuf, "chmod +x %s", pFileName);
	system(sBuf);	
}

int websUpdate_ClientFilter2File(int nClientFilter_Table_Size,CGI_TABLE_S *ClientFilterTable)
{
	int nIndex = 0, nClientFilter_Counter=0;
	char_t sBuf[BUF_SIZE_50K];
	memset(sBuf, 0, BUF_SIZE_1K);
	
	//count the table size
	for (nIndex=0; nIndex < nClientFilter_Table_Size; nIndex++)
	{
		if ( ClientFilterTable[nIndex].nIndex >= 0 )
		{
			nClientFilter_Counter++;
		}
	}	

	gsprintf(sBuf, T("%sCount=\"%d\"\n"), PREFIX_FIREWALL_CLIENTFILTER, nClientFilter_Counter);			

	nClientFilter_Counter=0;
	// update data from table to file
	for (nIndex=0; nIndex < nClientFilter_Table_Size; nIndex++)
	{
		if ( ClientFilterTable[nIndex].nIndex >= 0 )
		{
			char_t sLine[MAX_FILELINE_LEN];
			gsprintf(sLine, T("%sF%d=\"%d\"\n"), PREFIX_FIREWALL_CLIENTFILTER, \
				 nClientFilter_Counter, ClientFilterTable[nIndex].nState);
			gstrcat(sBuf, sLine);
			gsprintf(sLine, T("%sIP_START%d=\"%s\"\n"), PREFIX_FIREWALL_CLIENTFILTER, \
				nClientFilter_Counter,ClientFilterTable[nIndex].Data.CF_TABLE.sCF_IP_START);
			gstrcat(sBuf, sLine);
			gsprintf(sLine, T("%sIP_END%d=\"%s\"\n"), PREFIX_FIREWALL_CLIENTFILTER, \
				 nClientFilter_Counter,ClientFilterTable[nIndex].Data.CF_TABLE.sCF_IP_END);
			gstrcat(sBuf, sLine);
			gsprintf(sLine, T("%sPORT_START%d=\"%s\"\n"), PREFIX_FIREWALL_CLIENTFILTER, \
				nClientFilter_Counter,ClientFilterTable[nIndex].Data.CF_TABLE.sCF_PORT_START);
			gstrcat(sBuf, sLine);
			gsprintf(sLine, T("%sPORT_END%d=\"%s\"\n"), PREFIX_FIREWALL_CLIENTFILTER, \
				 nClientFilter_Counter,ClientFilterTable[nIndex].Data.CF_TABLE.sCF_PORT_END);
			gstrcat(sBuf, sLine);
			gsprintf(sLine, T("%sTYPE%d=\"%s\"\n"), PREFIX_FIREWALL_CLIENTFILTER, \
				 nClientFilter_Counter,ClientFilterTable[nIndex].Data.CF_TABLE.sCF_TYPE);
			gstrcat(sBuf, sLine);
			nClientFilter_Counter++;
		}
	}	
	return (websSetCfgData(FILE_RC_CONF, TAG_FIREWALL_CLIENTFILTER, 1, sBuf));
}

#if defined(IIP) || defined(ATA)
void ifx_set_qos_main(httpd_t wp, char_t *path, char_t *query)
{
        char_t  *pCheck, sCheck[MAX_FILELINE_LEN];

        a_assert(wp);
        memset(sCheck, 0x00, MAX_FILELINE_LEN);

        // Get value from ASP filz
        pCheck = ifx_httpdGetVar(wp, T("QosStatus"), T(""));

        if ( !gstrcmp(pCheck, "1") )
        {
                gsprintf(sCheck, T("QOS_ENABLE=\"%s\"\n"), pCheck);
        }
        else
        {
                gsprintf(sCheck, T("QOS_ENABLE=\"0\"\n"));
        }

        websSetCfgData(FILE_RC_CONF, TAG_QOS_CONFIG, 1, sCheck);

	// save setting
	if (ifx_web_Save_Setting()<=0)
	{
  		ifx_httpdError(wp, 200, "Fail to save Setting");
		return;
	}

        ifx_httpdNextPage(wp);
}

void ifx_set_qos_diffserv_setting(httpd_t wp, char_t *path, char_t *query)
{
        char_t  *pDsVoip = ifx_httpdGetVar(wp, T("DsVoip"), T(""));
        char_t  *pDsVs = ifx_httpdGetVar(wp, T("DsVs"), T(""));
        char_t  sDsVoip[MAX_DATA_LEN], sDsVs[MAX_DATA_LEN];

        // Set to rc.conf file
        if (!gstrcmp(pDsVoip, T("1")))
                gsprintf(sDsVoip, "DIFFSERV_DUT_VOIP=\"1\"\n");
        else
                gsprintf(sDsVoip, "DIFFSERV_DUT_VOIP=\"0\"\n");

        if (!gstrcmp(pDsVs, T("1")))
                gsprintf(sDsVs, "DIFFSERV_VIRTUAL_SERVER=\"1\"\n");
        else
                gsprintf(sDsVs, "DIFFSERV_VIRTUAL_SERVER=\"0\"\n");

        websSetCfgData(FILE_RC_CONF, TAG_QOS_DIFFSERV_CONFIG, 2, sDsVoip, sDsVs);

	// save setting
	system(SERVICE_RESTORE);
        //RunTime change.
    	system(SERVICE_QOS);

        ifx_httpdNextPage(wp);
}

int ifx_set_system_update_setting(httpd_t wp, char_t *path, char_t *query)
{
	char_t *pServer,*pFilename,*pMethod;
	char_t sServer[MAX_DATA_LEN/2],sFilename[MAX_DATA_LEN/2],sMethod[MAX_DATA_LEN/2];

	pServer = ifx_httpdGetVar(wp, T("update_server"), T(""));
	gsprintf(sServer, T("update_server=\"%s\"\n"), pServer);
	pFilename = ifx_httpdGetVar(wp, T("update_filename"), T(""));
	gsprintf(sFilename, T("update_filename=\"%s\"\n"), pFilename);
	pMethod = ifx_httpdGetVar(wp, T("update_method"), T(""));
	gsprintf(sMethod, T("update_method=\"%s\"\n"), pMethod);

	websSetCfgData(FILE_RC_CONF, TAG_UPDATE, 3,sServer,sFilename,sMethod);       

	system(SERVICE_UPDATE);
	ifx_httpdNextPage(wp);
	
	return 0;
	 

}

//////////////////////////////////////////////////////////////////////////////////
// voip_demo.asp
//
char* CodecCmd[] =
{
	"c01", "c02", "c07", "c08", "c09", "c0c", "c0d", "c0e", "c0f", "c0g",
	"c11", "c12", "c17", "c18", "c19", "c1c", "c1d", "c1e", "c1f", "c1g",
};  

char* VADCmd[] =
{
	"v00", "v01",
	"v10", "v11",
}; 

void ifx_set_voip_demo(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pcvChannel = ifx_httpdGetVar(wp, T("cvChannel"), T(""));
	char_t	*pcvContent = ifx_httpdGetVar(wp, T("cvContent"), T(""));	
	char_t	*pRoleType = ifx_httpdGetVar(wp, T("RoleType"), T(""));
	char_t	*pStatus = ifx_httpdGetVar(wp, T("status"), T(""));
	char_t	*pcvflag = ifx_httpdGetVar(wp, T("cvflag"), T(""));		
	char_t  scvChannel[MAX_FILELINE_LEN];
	char_t  scvContent[MAX_FILELINE_LEN];
	char_t  sRoleType[MAX_FILELINE_LEN];
	char_t  sStatus[MAX_FILELINE_LEN];
	char_t  sIfconfig_adm1[MAX_FILELINE_LEN], sDefaultRouter[MAX_FILELINE_LEN];
	char_t  sAliasStatus[MAX_DATA_LEN], sCommand[MAX_FILELINE_LEN];
	char_t  sIP[MAX_DATA_LEN];	
	
	a_assert(wp);
	memset(scvChannel, 0x00, MAX_FILELINE_LEN);
	memset(scvContent, 0x00, MAX_FILELINE_LEN);
	memset(sStatus, 0x00, MAX_FILELINE_LEN);
	memset(sRoleType, 0x00, MAX_FILELINE_LEN);	
	memset(sIfconfig_adm1, 0x00, MAX_FILELINE_LEN);	
	memset(sDefaultRouter, 0x00, MAX_FILELINE_LEN);
	memset(sAliasStatus, 0x00, MAX_DATA_LEN);
	memset(sCommand, 0x00, MAX_FILELINE_LEN);
	
	if (pcvflag == 0 || pcvChannel == 0 || pcvContent == 0 || pRoleType == 0 || pStatus ==0)
	{                               
		ifx_httpdError(wp, 200, T("Setup Error"));
		return;                     
	}   	


	if (gatoi(pcvflag) == 1)		// Press "Send" button to update CV data
	{
		// Update configure file 
		gsprintf(scvChannel, T("CVChannel=\"%d\"\n"), gatoi(pcvChannel));
		gsprintf(scvContent, T("CVContent=\"%d\"\n"), gatoi(pcvContent));		
		websSetCfgData(FILE_RC_CONF, TAG_VOIP_CV, 2, scvChannel, scvContent);
	
		// Change Codec/VAD setting to cfg_fifo
		if (atoi(pcvChannel) == 0 || atoi(pcvChannel) == 1)
		{
			gsprintf(sCommand, T("echo %s > %s"), CodecCmd[gatoi(pcvContent)+gatoi(pcvChannel)*10], FILE_CFG_FIFO);
		}
		else
		{
			gsprintf(sCommand, T("echo %s > %s"), VADCmd[gatoi(pcvContent)+(gatoi(pcvChannel)-2)*2], FILE_CFG_FIFO);
		}		

		system(sCommand);
		
		
	}
	else	// Press "Start" or "Stop" button
	{
		// Update configure file 
		gsprintf(sRoleType, T("RoleType=\"%d\"\n"), gatoi(pRoleType));
		gsprintf(sStatus, T("DemoStatus=\"%d\"\n"), gatoi(pStatus));	
		websSetCfgData(FILE_RC_CONF, TAG_VOIP_TAPIDEMO, 2, sRoleType, sStatus);
		
		//Runtime Change		
		if (gatoi(pStatus) == 1)	// Run Tapidemo command
		{
			if (gatoi(pRoleType) == 0) 	// ATA1
			{
				gstrcpy(sIP, "10.1.1.101");			
			}
			else	// ATA2
			{
				gstrcpy(sIP, "10.1.1.102");
			}
				
			gsprintf(sIfconfig_adm1, T("ifconfig_adm1=\"%s netmask 255.255.255.0\"\n"), sIP);
			gsprintf(sDefaultRouter, T("default_router=\"10.1.1.1\"\n"));                                   
			gsprintf(sAliasStatus, "aliasStatus=\"Disable\"\n");
			                                
			//Update rc.conf                
			websSetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, 3, sIfconfig_adm1, sDefaultRouter, sAliasStatus);		
			gsprintf(sCommand, "ipoption_adm1=\"FIXED\"\n");		
			websSetCfgData(FILE_RC_CONF, TAG_WAN_MAIN, 1,  sCommand);
					
			gsprintf(sCommand, T("ifconfig %s %s netmask 255.255.255.0"), ADM_WAN_IF, sIP);
			system(sCommand);              
			gsprintf(sCommand, T("/sbin/route add default gw 10.1.1.1"));
			system(sCommand);	                                    
			system(SERVICE_WAN_STOP);       
			system(SERVICE_NAT_RESTART);    
			system(SERVICE_FIREWALL_RESTART);
			system(SERVICE_UPNPD_RESTART);  
			system(SERVICE_DDNS_RESTART);
			system(SERVICE_DNS_START);
			system(SERVICE_TAPIDEMO_START);
		}
		else
		{
			system(SERVICE_TAPIDEMO_STOP);	
		}
		
		system(SERVICE_RESTORE);
	}	

	ifx_httpdNextPage(wp);
}


//////////////////////////////////////////////////////////////////////////////////// 
void ifx_set_voip_sip_keymgt_srtp(httpd_t wp, char_t *path, char_t *query)
{
#ifdef SRTP 
        char_t   *paddflag  = ifx_httpdGetVar(wp, T("addflag"), T(""));
        char_t   *pmodflag  = ifx_httpdGetVar(wp, T("modflag"), T(""));
        char_t   *pdelflag   = ifx_httpdGetVar(wp, T("delflag"), T(""));

        char_t  *psrtp_encr_tranf = ifx_httpdGetVar(wp, T("srtp_encr_tranf"), T(""));
        char_t  *psrtp_auth_tranf = ifx_httpdGetVar(wp, T("srtp_auth_tranf"), T(""));
        char_t  *pmasterkey  = ifx_httpdGetVar(wp, T("masterkey"), T(""));
        char_t  *pmastersalt   = ifx_httpdGetVar(wp, T("mastersalt"), T(""));
        char_t  *pmkiflag  = ifx_httpdGetVar(wp, T("mkiflag"), T(""));
        char_t  *pmkivalue  = ifx_httpdGetVar(wp, T("mkivalue"), T(""));
        char_t  *ptip = ifx_httpdGetVar(wp, T("tip"),T(""));
        char_t  *poldip = ifx_httpdGetVar(wp, T("oldip"),T(""));

        x_IFX_CM_Msg xCmMsg;
        a_assert(wp);
        memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
        xCmMsg.ucMsgType = IFX_CM_GET_REQ;
        xCmMsg.ucInfoType = IFX_CM_SRTP_KEY_CFG;
        xCmMsg.ucChannel = 0;

        if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
        {
           ifx_httpdError(wp, 200, T("Fail to receive data from CM Fax1\n"));
           return -1;
        }

    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_SRTP_KEY_CFG;
    xCmMsg.ucChannel = 0;

    /* fill the Structure */
     xCmMsg.uxData.xSrtpKeyCfg.eEncrAlgo = gatoi(psrtp_encr_tranf);
     xCmMsg.uxData.xSrtpKeyCfg.eAuthAlgo = gatoi(psrtp_auth_tranf);
     xCmMsg.uxData.xSrtpKeyCfg.unAuthTagLen = 80;
     xCmMsg.uxData.xSrtpKeyCfg.unSrtpPrefixLen = 0;
     xCmMsg.uxData.xSrtpKeyCfg.unPseudoRandomFunc = IFX_CM_AES_CM;
	  if (strlen(pmasterkey)!=16)
	  {
         ifx_httpdError(wp, 200, T("Invalid Master Key"));
         return;	 
	  }
	  
     strcpy(xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterKey,pmasterkey);
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMasterKeyLen = 128;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMasterSaltLen = 112;
     strcpy(xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterSalt, pmastersalt);
	  
	  if (strlen(pmastersalt)!=14)
	  {
         ifx_httpdError(wp, 200, T("Invalid Master Salt Key"));
         return;	 
	  }
	  
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unSesEncrKeyLen = 128;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unSesAuthKeyLen = 160;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unSesSaltKeyLen = 112;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiKeyDerivationRate = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ulFromIndex = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ulToIndex = IFX_CM_MAX_SRTP_LIFE_TIME-100;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ulSrtpMaxLifeTime = IFX_CM_MAX_SRTP_LIFE_TIME-100;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiSrtcpMaxLifeTime = IFX_CM_MAX_SRTCP_LIFE_TIME-100;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].cMkiIndicator = gatoi(pmkiflag);
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMkiLength = 4;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiMkiValue = gatoi(pmkivalue);
	  
	  /* if MKI flag is zero, set length and value to zero*/
	  if (xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].cMkiIndicator == 0)
	  {
       xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMkiLength = 0;
       xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiMkiValue = 0;
	  }
	  
     xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.uiSsrcValue = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.uiRoc = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.unSeqNumber = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.ulSrtcpIndex = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.unPort = 5000;
    
    if (strlen(ptip) == 0)
    {
         ifx_httpdError(wp, 200, T("Invalid IP Address"));
         return;	 
    }    
     
    if (gatoi(pmodflag) == 1)
	 {
       if (strcmp(poldip,ptip))
		 {
         ifx_httpdError(wp, 200, T("IP Address cannot be Modified"));
         return;	 
		 }
	 }

    strcpy(xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.acIpaddress,ptip);
    
    if (gatoi(pdelflag) == 1) /* press Del button */
    {
        xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.unPort = 0;
    }

    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
    	if (connection.allowed == 1)
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		else
		{
                ifx_httpdError(wp, 200, T("Fail to send IFX_CM_SRTP_KEY_CFG data to CM"));
        }
                return;
    }
    
    if (xCmMsg.ucMsgType == IFX_CM_SET_ERR_RSP)
    {
          ifx_httpdError(wp, 200, T("Invalid Operation"));
          return;
    }
    ifx_httpdNextPage(wp); 
#endif /* End of SRTP*/
}
////////////////////////////////////////////////////////////////////////////////////
void ifx_set_voip_sip_keymgt_srtcp(httpd_t wp, char_t *path, char_t *query)
{
#ifdef SRTP
        char_t   *paddflag  = ifx_httpdGetVar(wp, T("addflag"), T(""));
        char_t   *pmodflag  = ifx_httpdGetVar(wp, T("modflag"), T(""));
        char_t   *pdelflag   = ifx_httpdGetVar(wp, T("delflag"), T(""));

        char_t  *psrtp_encr_tranf = ifx_httpdGetVar(wp, T("srtp_encr_tranf"), T(""));
        char_t  *psrtp_auth_tranf = ifx_httpdGetVar(wp, T("srtp_auth_tranf"), T(""));
        char_t  *pmasterkey  = ifx_httpdGetVar(wp, T("masterkey"), T(""));
        char_t  *pmastersalt   = ifx_httpdGetVar(wp, T("mastersalt"), T(""));
        char_t  *pmkiflag  = ifx_httpdGetVar(wp, T("mkiflag"), T(""));
        char_t  *pmkivalue  = ifx_httpdGetVar(wp, T("mkivalue"), T(""));
        char_t  *ptip = ifx_httpdGetVar(wp, T("tip"),T(""));
        char_t  *poldip = ifx_httpdGetVar(wp, T("oldip"),T(""));

        x_IFX_CM_Msg xCmMsg;
        a_assert(wp);
        memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
        xCmMsg.ucMsgType = IFX_CM_GET_REQ;
        xCmMsg.ucInfoType = IFX_CM_SRTCP_KEY_CFG;
        xCmMsg.ucChannel = 0;

        if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
        {
           ifx_httpdError(wp, 200, T("Fail to receive data from CM Fax1\n"));
           return -1;
        }

    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_SRTCP_KEY_CFG;
    xCmMsg.ucChannel = 0;

    /* fill the Structure */
     xCmMsg.uxData.xSrtpKeyCfg.eEncrAlgo = gatoi(psrtp_encr_tranf);
     xCmMsg.uxData.xSrtpKeyCfg.eAuthAlgo = gatoi(psrtp_auth_tranf);
     xCmMsg.uxData.xSrtpKeyCfg.unAuthTagLen = 80;
     xCmMsg.uxData.xSrtpKeyCfg.unSrtpPrefixLen = 0;
     xCmMsg.uxData.xSrtpKeyCfg.unPseudoRandomFunc = IFX_CM_AES_CM;
     if (strlen(pmasterkey)!=16)
     {
         ifx_httpdError(wp, 200, T("Invalid Master Key"));
         return;
     }

     strcpy(xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterKey,pmasterkey);
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMasterKeyLen = 128;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMasterSaltLen = 112;
     strcpy(xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterSalt, pmastersalt);

     if (strlen(pmastersalt)!=14)
     {
         ifx_httpdError(wp, 200, T("Invalid Master Salt Key"));
         return;
     }

     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unSesEncrKeyLen = 128;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unSesAuthKeyLen = 160;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unSesSaltKeyLen = 112;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiKeyDerivationRate = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ulFromIndex = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ulToIndex = IFX_CM_MAX_SRTP_LIFE_TIME-100;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ulSrtpMaxLifeTime = IFX_CM_MAX_SRTP_LIFE_TIME-100;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiSrtcpMaxLifeTime = IFX_CM_MAX_SRTCP_LIFE_TIME-100;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].cMkiIndicator = gatoi(pmkiflag);
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMkiLength = 4;
     xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiMkiValue = gatoi(pmkivalue);

     /* if MKI flag is zero, set length and value to zero*/
     if (xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].cMkiIndicator == 0)
     {
       xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMkiLength = 0;
       xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiMkiValue = 0;
     }

     xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.uiSsrcValue = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.uiRoc = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.unSeqNumber = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.ulSrtcpIndex = 0;
     xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.unPort = 5000;

    if (strlen(ptip) == 0)
    {
         ifx_httpdError(wp, 200, T("Invalid IP Address"));
         return;
    }

   if ( IFX_ValidateIpAddress(ptip) < 0)
   {
             ifx_httpdError(wp, 200, T("Invalid IP address!!!"));
              return;
   }
   
    if (gatoi(pmodflag) == 1)
    {
       if (strcmp(poldip,ptip))
       {
         ifx_httpdError(wp, 200, T("IP Address cannot be Modified"));
         return;
       }
    }

    strcpy(xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.acIpaddress,ptip);

    if (gatoi(pdelflag) == 1) /* press Del button */
    {
        xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.unPort = 0;
    }

    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
    	if (connection.allowed == 1)
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		else
		{
                ifx_httpdError(wp, 200, T("Fail to send IFX_CM_SRTP_KEY_CFG data to CM"));
        }
                return;
    }

    if (xCmMsg.ucMsgType == IFX_CM_SET_ERR_RSP)
    {
          ifx_httpdError(wp, 200, T("Invalid Operation"));
          return;
    }
    ifx_httpdNextPage(wp);
#endif /* End of SRTP*/
}
#endif // #if defined(IIP) || defined(ATA)

void ifx_set_logout(httpd_t wp, char_t *path, char_t *query)
{
        //reset parameter
        connection.allowed = 0;
        connection.block = 0;
        memset(connection.ipaddr,0x00,sizeof(connection.ipaddr));
#if defined(ATA) || defined(IIP)
        IFX_CM_WebShut();
#endif
        ifx_httpdNextPage(wp);
}

#if defined(ATA) || defined(IIP)
/*******************************************************************************
 * *  Function Name : IFX_ValidateIpAddress
 * *  Description   :This function Check the IP Address.
 * *  Invoked Fns   :
 * *  Input Values  :char *
 * *  Output Values :
 * *  Return Value  : void
 * *  Note          :
 * ******************************************************************************/
char IFX_ValidateIpAddress (unsigned char* pszBuff)
{
  uint32 iCount = 0, iDotCount = 0;
  char8 acTemp[4];
  while(*pszBuff != '\0'){
    if(*pszBuff == '.'){
      iDotCount++;
      acTemp[iCount] = '\0';
      if((iCount > 0) && (atoi(acTemp) < 256)){
        memset(acTemp,'\0',4);
        iCount = 0;
        pszBuff++;
      }
      else{
        return -1;
      }
    }
    else{
      if(!isdigit(*pszBuff)){
        return -1;
      }
      acTemp[iCount++] = *pszBuff;
      pszBuff++;
      if(iCount > 3){
        return -1;
      }
    }
  }
  if(iCount<1 || atoi(acTemp)> 256 || iDotCount > 3){
    return -1;
  }
  return 0;
}
#endif
