/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"
#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

#ifdef WILDPASS
extern int g_nCurrentAPMode;
#endif

/////////////////////////////////////////////////////////////////////
//	login.asp
//
void ifx_set_login(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pPwdVerify = ifx_httpdGetVar(wp, T("pws"), T(""));
	char_t	sValue[MAX_DATA_LEN];

	//IFX_CM_WebInit();

	// Password found in rc.conf, else Password is NULL
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_SYSTEM_PASSWORD, T("Password"), sValue) == 0)
	{		
		ifx_debug_printf("### ifx_set_login : Cannot found password in rc.cof");
		ifx_httpdRedirect(wp,"login.asp");
		return;
	}	

	// Set password to system
	ifx_httpdSetPassword(sValue);

	ifx_debug_printf("User:%s, System:%s\n", pPwdVerify, ifx_httpdGetPassword());
	if (gstrcmp(ifx_httpdGetPassword(), pPwdVerify) == 0)
	{
		int i;
		if ( !connection.ipaddr[0])
		{	
	    		for (i = 0 ; i < 32 ; i++)
        	   	    connection.ipaddr[i] = wp->ipaddr[i];
		
			connection.time = time(NULL);
			ifx_debug_printf("###Inside ifx_set_login : connection.ipaddr is %s and wp->ipaddr is %s and connection.time is %d\n",connection.ipaddr,wp->ipaddr,connection.time);
		}else if (gstrcmp(connection.ipaddr,wp->ipaddr) == 0)
		{
			//Jeffrey1014
			//do nothing
			ifx_debug_printf("###Inside ifx_set_login : connection.ipaddr is %s\n",connection.ipaddr);
		}
		else
		{
			// duplicate admin....
			ifx_httpdError(wp, 200, T("<center><h1>Duplicate Administrator <br>This device is managed by %s currently!!<br></h1></center>"), connection.ipaddr);
			return;
		}
		
		connection.allowed = 1;
		g_nCurrentUserLevel = 0;


             #ifdef WILDPASS
                //check if AP client mode
                 //memset(sValue, 0x00, MAX_FILELINE_LEN);
                 if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, T("WLAN_CURRENT_MODE"), sValue) == 1)
		   {
		      ifx_debug_printf("###Inside ifx_set_login : WLAN_CURRENT_MODE is %s\n",sValue);
			if ( !gstrcmp(sValue, "1") )
			{   
			      //AP Client mode
				g_nCurrentAPMode = 1; //AP Client mode
			}					
		   }        		
		
#endif
		ifx_httpdNextPage(wp);
	}
	else
	{
		ifx_httpdRedirect(wp, T("loginerr.htm"));
	}
}