/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"
#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

#ifdef WILDPASS
extern int g_nCurrentAPMode;
#endif //#ifdef WILDPASS

int ifx_create_left_page(int eid, httpd_t wp, int argc, char_t **argv)
{
     char_t  sCommand[MAX_FILELINE_LEN];
     char_t  sIf[MAX_FILELINE_LEN];
     FILE*   fp;
     int        nProject_Index=1;   
     int        nProject=0;
     char     sProj[2],chProj;

#ifdef WILDPASS
    if (( g_nCurrentAPMode== 0) || (g_nCurrentAPMode== 2)) //AP mode or WDS mode       	
    {
#endif //#ifdef WILDPASS

// system
#ifdef CONFIG_CGI_OPEN_COMP_SYSTEM
    ifx_httpdWrite(wp, T("CreateNode('System','system_main.asp','System');\n"));
#ifdef CONFIG_CGI_SYSTEM_SP_CONFIG
    ifx_httpdWrite(wp, T("    CreateSubNode('S&P Config','system_sp.asp','System');\n"));
#endif    
#ifdef CONFIG_CGI_SYSTEM_HOST_NAME_CONFIG
    ifx_httpdWrite(wp, T("    CreateSubNode('Host Name Config','system_hostname.asp','System');\n"));
#endif //#ifdef CONFIG_CGI_SYSTEM_HOST_NAME_CONFIG

#ifdef CONFIG_CGI_SYSTEM_TIME
    ifx_httpdWrite(wp, T("    CreateSubNode('System Time','system_time.asp','System');\n"));
#endif //#ifdef CONFIG_CGI_SYSTEM_TIME

#ifdef CONFIG_CGI_SYSTEM_USER_SETTINGS
#ifdef GATEWAY
    ifx_httpdWrite(wp, T("    CreateSubNode('Administrator Settings','user_password.asp','System');\n"));
#else
    ifx_httpdWrite(wp, T("    CreateSubNode('User Settings','user_password.asp','System');\n"));
#endif
#endif //#ifdef CONFIG_CGI_SYSTEM_USER_SETTINGS

#ifdef CONFIG_CGI_SYSTEM_FIRMWARE_UPGRADE
    ifx_httpdWrite(wp, T("    CreateSubNode('Firmware Upgrade','system_upgrade.asp','System'); \n"));
#endif //#ifdef CONFIG_CGI_SYSTEM_FIRMWARE_UPGRADE

#ifdef CONFIG_CGI_SYSTEM_CONFIGURE
    ifx_httpdWrite(wp, T("    CreateSubNode('Configuration Tools','system_configure.asp','System'); \n"));
#endif //#ifdef CONFIG_CGI_SYSTEM_CONFIGURE

#ifdef CONFIG_CGI_SYSTEM_STATUS
    ifx_httpdWrite(wp, T("    CreateSubNode('System Status','system_status.asp','System'); \n"));
#endif //#ifdef CONFIG_CGI_SYSTEM_STATUS

#ifdef CONFIG_CGI_SYSTEM_LOG
    ifx_httpdWrite(wp, T("    CreateSubNode('System Log','system_log.asp','System'); \n"));
#endif //#ifdef CONFIG_CGI_SYSTEM_LOG

#ifdef CONFIG_CGI_SYSTEM_RESET
    ifx_httpdWrite(wp, T("    CreateSubNode('Reset','system_reset.asp','System');\n "));
#endif //#ifdef CONFIG_CGI_SYSTEM_RESET

    ifx_httpdWrite(wp, T("    ChangeDisplay('System'); \n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_SYSTEM

// WAN
#ifdef CONFIG_CGI_OPEN_COMP_WAN
    ifx_httpdWrite(wp, T("CreateNode('WAN','wan_main.asp','WAN');\n"));

#ifdef CONFIG_CGI_WAN_DYNAMIC_IP
    ifx_httpdWrite(wp, T("    CreateSubNode('Dynamic IP','wan_dhcp.asp','WAN');\n"));
#endif //#ifdef CONFIG_CGI_WAN_DYNAMIC_IP

#ifdef CONFIG_CGI_WAN_IP_SETTINGS
	memset(sIf, 0x00, MAX_FILELINE_LEN);
        if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, "aliasStatus", sIf) == 1)
        {
            if ( !gstrcmp(sIf, T("Enable")) )
            {
		ifx_httpdWrite(wp, T("    CreateSubNode('IP Settings','wan_static_alias.asp','WAN');\n"));
	    }
	    else
            {
                ifx_httpdWrite(wp, T("    CreateSubNode('IP Settings','wan_static.asp','WAN');\n"));
	    }
	}	
#endif //#ifdef CONFIG_CGI_WAN_IP_SETTINGS

#ifdef CONFIG_CGI_WAN_PPPPOE
    ifx_httpdWrite(wp, T("    CreateSubNode('PPPoE','wan_pppoe.asp','WAN');\n"));
#endif //#ifdef CONFIG_CGI_WAN_PPPPOE

#ifdef CONFIG_CGI_WAN_PPTP
    ifx_httpdWrite(wp, T("    CreateSubNode('PPTP','wan_pptp.asp','WAN');\n"));
#endif //#ifdef CONFIG_CGI_WAN_PPTP

#ifdef CONFIG_CGI_WAN_DNS
    ifx_httpdWrite(wp, T("    CreateSubNode('DNS','wan_dns.asp','WAN');\n"));
#endif //#ifdef CONFIG_CGI_WAN_DNS

    ifx_httpdWrite(wp, T("    ChangeDisplay('WAN');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_WAN

// LAN
#ifdef CONFIG_CGI_OPEN_COMP_LAN
    ifx_httpdWrite(wp, T("CreateNode('LAN','lan_main.htm','LAN');\n"));

#ifdef CONFIG_CGI_LAN_SETTINGS
	memset(sIf, 0x00, MAX_FILELINE_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_LAN_DHCPS, "dhcps_enable", sIf) == 1)
	{
		if ( !gstrcmp(sIf, "YES") )	//DHCP Enable
		{
			ifx_httpdWrite(wp, T("    CreateSubNode('LAN Settings','lan_dhcp.asp','LAN');\n"));
		}
		else						//DHCP Disable
		{
			ifx_httpdWrite(wp, T("    CreateSubNode('LAN Settings','lan_nodhcp.asp','LAN');\n"));
		}
	}
#endif //#ifdef CONFIG_CGI_LAN_SETTINGS

#ifdef CONFIG_CGI_LAN_DHCP_CLIENT_LIST
    ifx_httpdWrite(wp, T("    CreateSubNode('DHCP Client List','lan_dhcp_clients.asp','LAN');\n"));
#endif //#ifdef CONFIG_CGI_LAN_DHCP_CLIENT_LIST

    ifx_httpdWrite(wp, T("    ChangeDisplay('LAN');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_WAN

// LAN wireless
#ifdef CONFIG_CGI_OPEN_COMP_WLAN
	// check wireless modules on/off.
        memset(sCommand, 0x00, MAX_FILELINE_LEN);
        memset(sIf, 0x00, MAX_FILELINE_LEN);
        gsprintf(sCommand, T("ifconfig -a | grep ^%s | cut -f1 -d' '"), ADM_WLAN_IF);
        if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sIf) != 0)
        {
    		ifx_httpdWrite(wp, T("CreateNode('LAN Wireless','wireless_main.htm','LAN Wireless');\n"));

#ifdef CONFIG_CGI_WLAN_SETTINGS
    		ifx_httpdWrite(wp, T("    CreateSubNode('Setting','wireless_settings.asp','LAN Wireless');\n"));
#endif //#ifdef CONFIG_CGI_WLAN_SETTINGS

#ifdef CONFIG_CGI_WLAN_SECURITY
    		ifx_httpdWrite(wp, T("    CreateSubNode('Security','wireless_security.asp','LAN Wireless');\n"));
#endif //#ifdef CONFIG_CGI_WLAN_SECURITY

#ifdef WILDPASS
#ifdef CONFIG_CGI_WLAN_APMODE
    		ifx_httpdWrite(wp, T("    CreateSubNode('AP Mode','wireless_apmode.asp','LAN Wireless');\n"));
#endif //#ifdef CONFIG_CGI_WLAN_APMODE
#ifdef CONFIG_CGI_WLAN_WDSSETTINGS
           memset(sIf, 0x00, MAX_FILELINE_LEN);
           if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, "WLAN_CURRENT_MODE", sIf) == 1)
           {
             if ( !gstrcmp(sIf, "2") )       //WDS Enable
             {
             ifx_httpdWrite(wp, T("    CreateSubNode('WDS Setting','wireless_wdssettings.asp','LAN Wireless');\n"));
              }
                                                                                                                          
           }
 #endif //#ifdef CONFIG_CGI_WLAN_WDSSETTINGS
 #ifdef CONFIG_CGI_WLAN_11HSETTINGS
           memset(sIf, 0x00, MAX_FILELINE_LEN);
           //if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_OP_RATE", sIf) == 1)
           //{
          //   if ( !gstrcmp(sIf, "4") )       //11a Mode
           //  {
           //     ifx_httpdWrite(wp, T("    CreateSubNode('802.11h Setting','wireless_11hsettings.asp','LAN Wireless');\n"));
           //  }
                                                                                                                          
           //}

	   fp = fopen (FILE_11A_RFTYPE, "r");  //real code
          if (fp!=NULL)  
	  {     

 	    if (feof(fp)==0)
	    {
	       fgets(sProj, 2, fp);
	       ifx_debug_printf ("-----project index: %s\n",sProj); 
	       chProj=sProj[0];
	       ifx_debug_printf ("-----project index ch: %c\n",chProj); 
	       nProject_Index=atoi(sProj); //get project type
	       if (nProject_Index==2)
	    	   ifx_httpdWrite(wp, T("    CreateSubNode('802.11h Setting','wireless_11hsettings.asp','LAN Wireless');\n"));
	     }
	     fclose(fp);	        
	 }  
	
 #endif //#ifdef CONFIG_CGI_WLAN_11HSETTINGS
#endif //WILDPASS

    		ifx_httpdWrite(wp, T("    ChangeDisplay('LAN Wireless');\n"));
	}
#endif //#ifdef CONFIG_CGI_OPEN_COMP_WLAN
//wireless QOS(WILDPASS)
#ifdef WILDPASS
#ifdef CONFIG_CGI_OPEN_COMP_WQOS
 fp=fopen(FILE_11E_INFO,"r"); 
 if (fp!=NULL)
 {
              ifx_httpdWrite(wp, T("CreateNode('Wireless QOS','wireless_qossettings.asp','Wireless QOS');\n"));
       	ifx_httpdWrite(wp, T("    CreateSubNode('QOS QAP Setting','wireless_qosqap.asp','Wireless QOS');\n"));
		ifx_httpdWrite(wp, T("    CreateSubNode('QOS QSTA Setting','wireless_qosqsta.asp','Wireless QOS');\n"));
		ifx_httpdWrite(wp, T("    CreateSubNode('QOS DSCP Setting','wireless_qosdscp.asp','Wireless QOS');\n"));
             fclose(fp);
  ifx_httpdWrite(wp, T("    ChangeDisplay('Wireless QOS');\n"));
 }
#endif//#ifdef CONFIG_CGI_OPEN_COMP_WQOS
#endif //#ifdef WILDPASS 
// nat
#ifdef CONFIG_CGI_OPEN_COMP_NAT
    ifx_httpdWrite(wp, T("CreateNode('NAT','nat_main.htm','NAT');\n"));

#ifdef CONFIG_CGI_NAT_VIRTUAL_SERVER
    ifx_httpdWrite(wp, T("    CreateSubNode('Virtual Server','nat_virtualser.asp','NAT');\n"));
#endif //#ifdef CONFIG_CGI_NAT_VIRTUAL_SERVER

#ifdef CONFIG_CGI_NAT_PORT_MAPPING
    ifx_httpdWrite(wp, T("    CreateSubNode('Port Mapping','nat_portmap.asp','NAT');\n"));
#endif //#ifdef CONFIG_CGI_NAT_PORT_MAPPING

#ifdef CONFIG_CGI_NAT_ADDRESS_MAPPING    
	memset(sIf, 0x00, MAX_FILELINE_LEN);
       if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, "aliasStatus", sIf) == 1)
       {
       	if ( !gstrcmp(sIf, T("Enable")) )
            	{
			ifx_httpdWrite(wp, T("    CreateSubNode('Address Mapping','nat_addrmap.asp','NAT');\n"));	 
	    	}
	}
#endif //#ifdef CONFIG_CGI_NAT_ADDRESS_MAPPING

#ifdef CONFIG_CGI_NAT_DMZ
    ifx_httpdWrite(wp, T("    CreateSubNode('DMZ','firewall_dmz.asp','NAT');\n"));
#endif //#ifdef CONFIG_CGI_NAT_DMZ

    ifx_httpdWrite(wp, T("    ChangeDisplay('NAT');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_NAT

// firewall
#ifdef CONFIG_CGI_OPEN_COMP_FIREWALL
    ifx_httpdWrite(wp, T("CreateNode('Firewall','firewall_main.asp','Firewall');\n"));

#ifdef CONFIG_CGI_FIREWALL_OPTIONS
    ifx_httpdWrite(wp, T("    CreateSubNode('Firewall Options','firewall_disablewan.asp','Firewall');\n"));
#endif //#ifdef CONFIG_CGI_FIREWALL_OPTIONS

#ifdef CONFIG_CGI_FIREWALL_CLIENT_FILTERING
    ifx_httpdWrite(wp, T("    CreateSubNode('Client Filtering','firewall_clientfilter.asp','Firewall');\n"));
#endif //#ifdef CONFIG_CGI_FIREWALL_CLIENT_FILTERING

#ifdef CONFIG_CGI_FIREWALL_MAC_CONTROL
    ifx_httpdWrite(wp, T("    CreateSubNode('MAC Control','firewall_mac.asp','Firewall');\n"));
#endif //#ifdef CONFIG_CGI_FIREWALL_MAC_CONTROL

#ifdef CONFIG_CGI_FIREWALL_EMAIL_NOTIFY
    ifx_httpdWrite(wp, T("    CreateSubNode('Email Notification','firewall_notify.asp','Firewall');\n"));
#endif //CONFIG_CGI_FIREWALL_EMAIL_NOTIFY

    ifx_httpdWrite(wp, T("    ChangeDisplay('Firewall');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_FIREWALL

// route
#ifdef CONFIG_CGI_OPEN_COMP_ROUTE
    ifx_httpdWrite(wp, T("CreateNode('Route','route_main.htm','Route');\n"));

#ifdef CONFIG_CGI_ROUTE_STATIC
    ifx_httpdWrite(wp, T("    CreateSubNode('Static Routing','route_static.asp','Route');\n"));
#endif //#ifdef CONFIG_CGI_ROUTE_STATIC

#ifdef CONFIG_CGI_ROUTE_DYNAMIC
    ifx_httpdWrite(wp, T("    CreateSubNode('Dynamic Routing','route_dynamic.asp','Route');\n"));
#endif //CONFIG_CGI_ROUTE_DYNAMIC

#ifdef CONFIG_CGI_ROUTE_TABLE_LIST
    ifx_httpdWrite(wp, T("    CreateSubNode('Routing Table List','route_table.asp','Route');\n"));
#endif //#ifdef CONFIG_CGI_ROUTE_TABLE_LIST

    ifx_httpdWrite(wp, T("    ChangeDisplay('Route');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_ROUTE

// upnp
#ifdef CONFIG_CGI_OPEN_COMP_UPNP
    ifx_httpdWrite(wp, T("CreateNode('UPnP','upnp_main.htm','UPnP');\n"));

#ifdef CONFIG_CGI_UPNP_SETTINGS
    ifx_httpdWrite(wp, T("    CreateSubNode('Settings','upnp_config.asp','UPnP');\n"));
#endif //#ifdef CONFIG_CGI_UPNP_SETTINGS

    ifx_httpdWrite(wp, T("    ChangeDisplay('UPnP');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_UPNP

// ddns
#ifdef CONFIG_CGI_OPEN_COMP_DDNS
    ifx_httpdWrite(wp, T("CreateNode('DDNS','ddns_main.htm','DDNS');\n"));
    
#ifdef CONFIG_CGI_DDNS_SETTINGS
    ifx_httpdWrite(wp, T("    CreateSubNode('Settings','ddns_config.asp','DDNS');\n"));
#endif //#ifdef CONFIG_CGI_DDNS_SETTINGS

    ifx_httpdWrite(wp, T("    ChangeDisplay('DDNS');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_DDNS

// qos
#ifdef CONFIG_CGI_OPEN_COMP_QOS
    ifx_httpdWrite(wp, T("CreateNode('QoS','qos_main.htm','QoS');\n"));

#ifdef CONFIG_CGI_QOS_BUILD_IN_SWITCH_SETTING
    ifx_httpdWrite(wp, T("    CreateSubNode('Build-in Switch Setting','Qos_1.asp','QoS');\n"));
#endif //#ifdef CONFIG_CGI_QOS_BUILD_IN_SWITCH_SETTING

#ifdef CONFIG_CGI_QOS_EXTENDED_QOS_SETTING
    ifx_httpdWrite(wp, T("    CreateSubNode('Extended QoS Setting','Qos_2.asp','QoS');\n"));
#endif //#ifdef CONFIG_CGI_QOS_EXTENDED_QOS_SETTING

    ifx_httpdWrite(wp, T("    ChangeDisplay('UPnP');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_QOS

// vlan
#ifdef CONFIG_CGI_OPEN_COMP_VLAN
    ifx_httpdWrite(wp, T("CreateNode('Switch Enhancement','vlan_main.htm','Switch Enhancement');\n"));

#ifdef CONFIG_CGI_VLAN_STATIC_MAC_SETTING
    ifx_httpdWrite(wp, T("    CreateSubNode('Static MAC Setting','Qos_3.asp','Switch Enhancement');\n"));
#endif //#ifdef CONFIG_CGI_VLAN_STATIC_MAC_SETTING

#ifdef CONFIG_CGI_VLAN_SETTING
    ifx_httpdWrite(wp, T("    CreateSubNode('VLAN Setting','Qos_4.asp','Switch Enhancement');\n"));
#endif //#ifdef CONFIG_CGI_VLAN_SETTING

    ifx_httpdWrite(wp, T("    ChangeDisplay('UPnP');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_VLAN

// voip
#ifdef CONFIG_CGI_OPEN_COMP_VOIP
    ifx_httpdWrite(wp, T("CreateNode('VoIP','voip_main.asp','VoIP');\n"));

#ifdef CONFIG_CGI_VOIP_SIP_PROXY
    ifx_httpdWrite(wp, T("    CreateSubNode('SIP Setting','voip_sip_proxy.asp','VoIP');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_VOIP

    ifx_httpdWrite(wp, T("    ChangeDisplay('VoIP');\n"));
#endif //#if defined(ATA) || defined(IIP)

// Key management
#ifdef CONFIG_CGI_OPEN_COMP_KEYMGT
    ifx_httpdWrite(wp, T("CreateNode('VoIP','srtp_keymgt_main.asp','Key Management');\n"));

#ifdef CONFIG_CGI_SRTCP_KEYMGT_SRTCP
    ifx_httpdWrite(wp, T("    CreateSubNode('SRTCP Key Setting','srtp_keymgt_srtcp.asp','Key Management');\n"));
#endif //#ifdef CONFIG_CGI_SRTCP_KEYMGT_SRTCP

#ifdef CONFIG_CGI_SRTP_KEYMGT_SRTCP
    ifx_httpdWrite(wp, T("    CreateSubNode('SRTP Key Setting','srtp_keymgt_srtp.asp','Key Management');\n"));
#endif //#ifdef CONFIG_CGI_SRTP_KEYMGT_SRTCP

    ifx_httpdWrite(wp, T("    ChangeDisplay('Key Management');\n"));
#endif //#ifdef CONFIG_CGI_OPEN_COMP_KEYMGT

#ifdef WILDPASS
    }
    else
    {
       ifx_httpdWrite(wp, T("CreateNode('System','system_main.asp','System');\n"));
    	ifx_httpdWrite(wp, T("    CreateSubNode('Host Name Config','system_hostname.asp','System');\n"));
    	//ifx_httpdWrite(wp, T("    CreateSubNode('System Time','system_time.asp','System');\n"));
    	ifx_httpdWrite(wp, T("    CreateSubNode('User Settings','user_password.asp','System');\n"));
    	ifx_httpdWrite(wp, T("    CreateSubNode('Firmware Upgrade','system_upgrade.asp','System'); \n"));       
       ifx_httpdWrite(wp, T("    CreateSubNode('Configuration Tools','system_configure.asp','System'); \n"));
    	ifx_httpdWrite(wp, T("    CreateSubNode('System Status','system_status.asp','System'); \n"));	
    	//ifx_httpdWrite(wp, T("    CreateSubNode('System Log','system_log.asp','System'); \n"));
    	ifx_httpdWrite(wp, T("    CreateSubNode('Reset','system_reset.asp','System');\n "));
    	ifx_httpdWrite(wp, T("    ChangeDisplay('System'); \n"));	
	// LAN
    	ifx_httpdWrite(wp, T("CreateNode('LAN','lan_main.htm','LAN');\n"));
   	ifx_httpdWrite(wp, T("    CreateSubNode('LAN Settings','lan_nodhcp.asp','LAN');\n"));   	
	ifx_httpdWrite(wp, T("    CreateSubNode('DHCP Client','udhcpc_apclient.asp','LAN');\n"));   
    	ifx_httpdWrite(wp, T("    ChangeDisplay('LAN');\n"));
	//LAN Wireless
	ifx_httpdWrite(wp, T("CreateNode('LAN Wireless','wireless_main.htm','LAN Wireless');\n"));
    	ifx_httpdWrite(wp, T("    CreateSubNode('Setting','wireless_settings.asp','LAN Wireless');\n"));
    	ifx_httpdWrite(wp, T("    CreateSubNode('AP Mode','wireless_apmode.asp','LAN Wireless');\n"));
    	ifx_httpdWrite(wp, T("    ChangeDisplay('LAN Wireless');\n"));
    } //wireless client mode

#endif //#ifdef WILDPASS
    return 0;
}
