/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"
#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_menu_setup_nat(int eid, httpd_t wp, int argc, char_t **argv)
{
	int 		DATA;

	DATA =  ifx_get_AliasStatus(eid,wp,argc,argv);
	if(DATA == 1)
	{
		ifx_httpdWrite(wp,"<img src=\"images/p6.gif\" width=\"10\" height=\"10\" align=\"absmiddle\">");
		ifx_httpdWrite(wp,"<a href=\"nat_addrmap.asp\" target=\"main2\"><font size=\"1\">Address Mapping</font></a><br>");
	}
	return 0;
}

void ifx_Nat_PageTitle(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t  str[20];

	memset(str, 0x00, 20);

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return ;
	}	

#ifdef ATA
	strcpy(str, "ATA");
#endif
#if defined(SPURS) && defined (ATA)
	strcpy(str, "WATA");
#endif

#ifdef GATEWAY
	strcpy(str, "Router");
#endif

#if defined(SPURS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

#if defined(WILDPASS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

	if (!gstrcmp(name, T("nat_mainpage")))
	{
		ifx_httpdWrite(wp,T("Network Address Translation (NAT) allows multiple users at your local site to access \n"
							"the Internet through a single public IP address or multiple public IP addresses.\n"
							"NAT can also prevent hacker attacks by mapping local addresses to public addresses\n"
							"for key services such as the Web or FTP."));
	}else
	if (!gstrcmp(name, T("nat_virtualserpage")))
	{
		ifx_httpdWrite(wp,T("You can configure the %s as a virtual\n"
							"server so that remote users accessing services such as the Web or FTP at your local site via public\n"
							"IP addresses can be automatically redirected to local servers configured with private IP addresses.\n"
							"In other words, depending on the requested service (TCP/UDP port numbers), the %s redirects\n"
							"the external service request to the appropriate server (located at another internal\n"
							"IP address).."),str,str);
	}
	else
	if (!gstrcmp(name, T("nat_virtualserpage_rm")))
	{
		ifx_httpdWrite(wp, "The public port number can not be 8080.Because it will have a collision with the %s web service.", str);
	}
	else
	if (!gstrcmp(name, T("nat_addrmappage")))
	{
		ifx_httpdWrite(wp,T("When the WAN interface has more than one IP address, the %s is able to map each public\n"
							"IP address to a group of private IP addresses.\n"
							"By doing this, you can fully utilize your public\n"
							"IP addresses."),str);
	}else
	if (!gstrcmp(name, T("nat_portmappage")))
	{
		ifx_httpdWrite(wp,T("For some applications, you need to assign a set or a range of ports to a specified local machine\n"
							"to route the packets. %s allows the user to configure the needed port mappings to suit\n"
							"such applications.."),str);
	}
}