/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_firewall_dmz(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	sValue[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(command, 0x00, MAX_FILELINE_LEN);

	if ( !gstrcmp(name, T("C1")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_DMZ, T("DMZ_ENABLE"), sValue) == 1)
		{
			if ( !gstrcmp(sValue, "1") )
			{
				gstrcpy(sValue, "checked");
			}
			else
			{
				gstrcpy(sValue, "");
			}

			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("dmzip1")) )
	{
		
		gsprintf(command, T("grep %s %s | cut -f2 -d\\\" | cut -f1 -d."), "DMZ_HOST", FILE_RC_CONF);
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("dmzip2")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 -d\\\" | cut -f2 -d."), "DMZ_HOST", FILE_RC_CONF);
		
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("dmzip3")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 -d\\\" | cut -f3 -d."), "DMZ_HOST", FILE_RC_CONF);
		
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("dmzip4")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 -d\\\" | cut -f4 -d."), "DMZ_HOST", FILE_RC_CONF);
		
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	
	return 0;
}


void ifx_set_firewall_dmz(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pCheck, *pDmzIP1, *pDmzIP2, *pDmzIP3, *pDmzIP4;
	char_t	sCheck[MAX_FILELINE_LEN], sDmzIP[MAX_FILELINE_LEN];

	a_assert(wp);
	memset(sCheck, 0x00, MAX_FILELINE_LEN);
	memset(sDmzIP, 0x00, MAX_FILELINE_LEN);

	// Get value from ASP file
	pCheck = ifx_httpdGetVar(wp, T("C1"), T(""));
	pDmzIP1 = ifx_httpdGetVar(wp, T("dmzip1"), T(""));
	pDmzIP2 = ifx_httpdGetVar(wp, T("dmzip2"), T(""));
	pDmzIP3 = ifx_httpdGetVar(wp, T("dmzip3"), T(""));
	pDmzIP4 = ifx_httpdGetVar(wp, T("dmzip4"), T(""));

	if ( !gstrcmp(pCheck, "1") )
	{
		gsprintf(sCheck, T("DMZ_ENABLE=\"%s\"\n"), pCheck);
	}
	else
	{
		gsprintf(sCheck, T("DMZ_ENABLE=\"0\"\n"));
	}

	gsprintf(sDmzIP, T("DMZ_HOST=\"%s.%s.%s.%s\"\n"), pDmzIP1, pDmzIP2, pDmzIP3, pDmzIP4);

	websSetCfgData(FILE_RC_CONF, TAG_FIREWALL_DMZ, 2, sCheck, sDmzIP);
	
	//Runtime Change
	system(SERVICE_NAT_RESTART);
	system(SERVICE_FIREWALL_RESTART);

	system(SERVICE_RESTORE);
	
	ifx_httpdNextPage(wp);
}
