/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>


int ifx_get_nat_virtualser(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	buf[MAX_DATA_LEN], sAlias[MAX_DATA_LEN], sMapIP[MAX_DATA_LEN];
	char_t	sValue[MAX_FILELINE_LEN], sServerIP[MAX_DATA_LEN], sWanIP[MAX_DATA_LEN];
	char_t	getCommand[MAX_FILELINE_LEN], setCommand[MAX_FILELINE_LEN];
	int		i, idx = 0, nAliasIPNum = 0,DATA=0;

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

	if ( !gstrcmp(name, T("natvirtualser")) )
	{	
	memset(setCommand, 0x00, MAX_FILELINE_LEN);
	memset(sServerIP, 0x00, MAX_DATA_LEN);
	memset(sWanIP, 0x00, MAX_DATA_LEN);

	websGetInterfaceIP(ADM_LAN_IF, 3, FALSE, sServerIP);
	websGetInterfaceIP(ADM_WAN_IF, 4, FALSE, sWanIP); // Move from loop

	for (i = 1; i <= NAT_RD_LINK_NUM; i++)
	{
		ifx_httpdWrite(wp, T("\t\t\t<tr align=center bgcolor=#ffffff>\n"));
		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap>%d</td>\n"), i);
		
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, "aliasStatus", sAlias) == 1)
		{
			if ( !gstrcmp(sAlias, T("Enable")) ) 
			{
				ifx_httpdWrite(wp, T("\t\t\t\t<td><font color=\"#FFFFCC\" size=\"2\" face=\"Arial, Helvetica, sans-serif\">\n"));
				
				if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, "aliasIPCount", sValue) == 1)				
				{
					nAliasIPNum = gatoi(sValue);
					memset(buf, 0x00, MAX_DATA_LEN);
					gsprintf(buf, T("NATVS_MIP%d"), i);

					ifx_httpdWrite(wp, T("\t\t\t\t\t<select name=\"%s\" size=\"1\">\n"), buf);
					
					if (nAliasIPNum == 0)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\" selected>%s</option>\n"), sWanIP, sWanIP);
					}
					else
					if (nAliasIPNum > 0)
					{
						memset(sMapIP, 0x00, MAX_DATA_LEN);

						if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_VIRTUALSER, buf, sMapIP) == 1)
						{}

						for (idx = 0; idx < nAliasIPNum; idx++)
						{
							char *pWantIp;
							memset(sValue, 0x00, MAX_FILELINE_LEN);
							memset(getCommand, 0x00, MAX_FILELINE_LEN);
							gsprintf(buf, T("%s%d"), PREFIX_ALIASIP, idx);
							if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, buf, getCommand) == 1)					
							{
								if ((pWantIp = strtok(getCommand, " ")) == NULL) 	// Didnot found string like "10.1.1.1 netmask 255.255.255.0"
									strcpy(sValue, getCommand);
								else
									strcpy(sValue, pWantIp);
								
								if ( !gstrcmp(sValue, sMapIP) )
								{
									ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\" selected>%s</option>\n"), sValue, sValue);
								}
								else
								{
									ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\">%s</option>\n"), sValue, sValue);
								}
							}
						}

						if ( !gstrcmp(sWanIP, sMapIP) )
						{
							ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\" selected>%s</option>\n"), sWanIP, sWanIP);
						}
						else
						{
							ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\">%s</option>\n"), sWanIP, sWanIP);
						}
					}
					ifx_httpdWrite(wp, T("\t\t\t\t\t</select>\n"));
				}
	
				ifx_httpdWrite(wp, T("\t\t\t\t</td>\n"));
			}
		}

		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap>\n"));

		memset(buf, 0x00, MAX_DATA_LEN);
   		memset(sValue, 0x00, MAX_FILELINE_LEN);

		gsprintf(buf, T("NATVS_PIP%d"), i);
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_VIRTUALSER, buf, sValue) == 0)
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s\n"), sServerIP);
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxlength=\"3\" name=\"%s\" size=\"3\" value=\"\"></font></td>\n"), buf);
		}
		else
		{
			// We only need the last IP field, ex: 192.168.1.3 -> 3
			char *token;
			int nIdx = 0;
			token = strtok(sValue, ".");
			while (token != NULL && nIdx < 3)
			{
				token = strtok(NULL, ".");
				nIdx++;
			}		
			strcpy(sValue, (const char_t*)token);
			
			ifx_httpdWrite(wp, T("\t\t\t\t\t<font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s\n"), sServerIP);
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxlength=\"3\" name=\"%s\" size=\"3\" value=\"%s\"></font></td>\n"), buf, sValue);
		}
		
		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap> <font size=\"2\" face=\"Arial, Helvetica, sans-serif\">\n"));

		memset(buf, 0x00, MAX_DATA_LEN);
   		memset(sValue, 0x00, MAX_FILELINE_LEN);
	
		gsprintf(buf, T("NATVS_PPORT%d"), i);
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_VIRTUALSER, buf, sValue) == 0)
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"5\" name=\"%s\" size=\"6\" value=\"\"></font></td>\n"), buf);
		}
		else
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"5\" name=\"%s\" size=\"6\" value=\"%s\"></font></td>\n"), buf, sValue);
		}

		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap> <font size=\"2\" face=\"Arial, Helvetica, sans-serif\">\n"));

		memset(buf, 0x00, MAX_DATA_LEN);
   		memset(sValue, 0x00, MAX_FILELINE_LEN);
		
		gsprintf(buf, T("NATVS_PTYPE%d"), i);
		
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_VIRTUALSER, buf, sValue) == 0)
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" style=\"background : ffffff;\" name=\"%s\" value=\"1\"%s>TCP\n"), buf, " CHECKED");
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" style=\"background : ffffff;\" name=\"%s\" value=\"2\">UDP</font></td>\n"), buf);
		}
		else
		{
			if ( !gstrcmp(sValue, PROTOCOL_TYPE_TCP) )
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" style=\"background : ffffff;\" name=\"%s\" value=\"1\"%s>TCP\n"), buf, " CHECKED");
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" style=\"background : ffffff;\" name=\"%s\" value=\"2\"%s>UDP</font></td>\n"), buf, "");
			}
			else
			if ( !gstrcmp(sValue, PROTOCOL_TYPE_UDP) )
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" style=\"background : ffffff;\" name=\"%s\" value=\"1\"%s>TCP\n"), buf, "");
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" style=\"background : ffffff;\" name=\"%s\" value=\"2\"%s>UDP</font></td>\n"), buf, " CHECKED");
			}
		}

		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap> <font size=\"2\" face=\"Arial, Helvetica, sans-serif\">\n"));

		memset(buf, 0x00, MAX_DATA_LEN);
   		memset(sValue, 0x00, MAX_FILELINE_LEN);
		
		gsprintf(buf, T("NATVS_PUPORT%d"), i);
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_VIRTUALSER, buf, sValue) == 0)
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"5\" name=\"%s\" size=\"6\" value=\"\"></td></font></td>\n"), buf);
		}
		else
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"5\" name=\"%s\" size=\"6\" value=\"%s\"></td></font></td>\n"), buf, sValue);
		}

		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap> <font face=\"Arial, Helvetica, sans-serif\" size=\"2\">\n"));

		//Get f# value from rc.iptables file.
		memset(buf, 0x00, MAX_DATA_LEN);
		memset(sValue, 0x00, MAX_FILELINE_LEN);
		gsprintf(buf, T("NATVS_F%d"), i);
		
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_VIRTUALSER, buf, sValue) == 0)
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"checkbox\" name=\"%s\" value=\"1\"></font></td>\n"), buf);
		}
		else
		{
			if ( !gstrcmp(sValue, "1") )
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"checkbox\" name=\"%s\" value=\"1\"%s></font></td>\n"), buf, " CHECKED");
			}
			else
			if ( !gstrcmp(sValue, "0") )
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"checkbox\" name=\"%s\" value=\"1\"%s></font></td>\n"), buf, "");
			}
		}

		ifx_httpdWrite(wp, T("\t\t\t</tr>\n"));
	}
	
	}else
	if ( !gstrcmp(name, T("natvirtualserTitleBar")) )
	{
		DATA = ifx_get_AliasStatus(eid,wp,argc,argv);
		if(DATA == 1)
 			ifx_httpdWrite(wp, T("<th nowrap>Mapping IP</th>"));
	}

        return 0;
}


void ifx_set_nat_virtualser(httpd_t wp, char_t *path, char_t *query)
{
        char_t  *pMIP, *pPriIP, *pPriPort, *pPriType, *pPubPort, *pFunc;
        char_t  sAlias[MAX_DATA_LEN];
        char_t  *buffer, buf[MAX_DATA_LEN], sMIP[NAT_RD_LINK_NUM][MAX_DATA_LEN];
        char_t  sPIP[NAT_RD_LINK_NUM][MAX_DATA_LEN], sPport[NAT_RD_LINK_NUM][MAX_DATA_LEN];
        char_t  sPtype[NAT_RD_LINK_NUM][MAX_DATA_LEN], sPubPort[NAT_RD_LINK_NUM][MAX_DATA_LEN];
        char_t  sFunc[NAT_RD_LINK_NUM][MAX_DATA_LEN], sServerIP[MAX_DATA_LEN];
        char_t  sWanIface[MAX_DATA_LEN];
    	int         i;
		
        a_assert(wp);

        //trace(8, T("--> nat_virtualser set of sServerIP is %s\n"), sServerIP);
        for (i = 0; i < NAT_RD_LINK_NUM; i++)
        {
                //Set NATVS_PIP# to rc.iptables.
                memset(sPIP[i], 0x00, MAX_DATA_LEN);
                memset(buf, 0x00, MAX_DATA_LEN);

                gsprintf(buf, T("NATVS_PIP%d"), i+1);
                pPriIP  = ifx_httpdGetVar(wp, buf, T(""));

                if (pPriIP[0])
                {
                        memset(sServerIP, 0x00, MAX_DATA_LEN);
                        websGetInterfaceIP(ADM_LAN_IF, 3, FALSE, sServerIP);
                        gsprintf(sPIP[i], T("%s=\"%s%s\"\n"), buf, sServerIP, pPriIP);
                }
                else
                {
                        gsprintf(sPIP[i], T("%s=\"\"\n"), buf);
                }
	

		//Set NATVS_PPORT# to rc.iptables.
		memset(sPport[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_DATA_LEN);
		gsprintf(buf, T("NATVS_PPORT%d"), i+1);
		pPriPort	= ifx_httpdGetVar(wp, buf, T(""));

		if (pPriPort[0])
		{
			gsprintf(sPport[i], T("%s=\"%s\"\n"), buf, pPriPort);
		}
		else
		{
			gsprintf(sPport[i], T("%s=\"\"\n"), buf);
		}
		
		//Set NATVS_PTYPE# to rc.iptables.		
		memset(sPtype[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_DATA_LEN);
		gsprintf(buf, T("NATVS_PTYPE%d"), i+1);
		pPriType	= ifx_httpdGetVar(wp, buf, T(""));

		if (pPriType[0])
		{
			if (!gstrcmp(pPriType, T("1")))
			{
				gsprintf(sPtype[i], T("%s=\"%s\"\n"), buf, PROTOCOL_TYPE_TCP);
			}
			else
			if (!gstrcmp(pPriType, T("2")))
			{
				gsprintf(sPtype[i], T("%s=\"%s\"\n"), buf, PROTOCOL_TYPE_UDP);
			}
		}
		else
		{
			gsprintf(sPtype[i], T("NATVS_%s=\"%s\"\n"), buf, PROTOCOL_TYPE_TCP);
		}
		
		//Set NATVS_PUPORT# to rc.iptables.
		memset(sPubPort[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_DATA_LEN);
		gsprintf(buf, T("NATVS_PUPORT%d"), i+1);
		pPubPort	= ifx_httpdGetVar(wp, buf, T(""));

		if (pPubPort[0])
		{
			gsprintf(sPubPort[i], T("%s=\"%s\"\n"), buf, pPubPort);
		}
		else
		{
			gsprintf(sPubPort[i], T("%s=\"\"\n"), buf);
		}

		//Set NATVS_F# to rc.iptables.
		memset(sFunc[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_DATA_LEN);
		gsprintf(buf, T("NATVS_F%d"), i+1);
		pFunc	= ifx_httpdGetVar(wp, buf, T(""));

		if (!gstrcmp(pFunc, "1"))
		{
			if ( (pPriIP && *pPriIP) && (pPriPort && *pPriPort) &&
				 (pPriType && *pPriType) && (pPubPort && *pPubPort) )
			{
				gsprintf(sFunc[i], T("%s=\"%s\"\n"), buf, pFunc);
				
				//Set NATVS_MIP# to rc.iptables.
				memset(sMIP[i], 0x00, MAX_DATA_LEN);
				memset(buf, 0x00, MAX_DATA_LEN);
		
				gsprintf(buf, T("NATVS_MIP%d"), i+1);
				
				if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, "aliasStatus", sAlias) == 1)
				{
					if ( !gstrcmp(sAlias, "Enable") ) 
					{
						pMIP	= ifx_httpdGetVar(wp, buf, T(""));
						gsprintf(sMIP[i], T("%s=\"%s\"\n"), buf, pMIP);
					}
					else
					{
						memset(sServerIP, 0x00, MAX_DATA_LEN);
					       memset(sWanIface, 0x00, MAX_DATA_LEN);
					       websGetWanIface(sWanIface);			// Depends on current wan mode
						websGetInterfaceIP(sWanIface, 4, FALSE, sServerIP);
						gsprintf(sMIP[i], T("%s=\"%s\"\n"), buf, sServerIP);
					}
				}
			}
			else
			{
				gsprintf(sFunc[i], T("%s=\"0\"\n"), buf);
			}
		}
		else
		{
			gsprintf(sFunc[i], T("%s=\"0\"\n"), buf);
			gsprintf(sMIP[i], T("NATVS_MIP%d=\"\"\n"), i+1);
		}
	}

	buffer = (char_t*)malloc(sizeof(char_t)*(BUF_SIZE_50K));
	gstrcpy (buffer, "");
	gsprintf(buf, T("NATVS_NUM=\"%d\"\n"), NAT_RD_LINK_NUM);
	gstrcat (buffer, buf);
	
	for (i = 0; i < NAT_RD_LINK_NUM; i++)
	{
		gstrcat(buffer, sPIP[i]);
		gstrcat(buffer, sPport[i]);
		gstrcat(buffer, sPtype[i]);
		gstrcat(buffer, sPubPort[i]);
		gstrcat(buffer, sFunc[i]);
		gstrcat(buffer, sMIP[i]);
	}


	websSetCfgData(FILE_RC_IPTABLES, TAG_NAT_VIRTUALSER, 1, buffer);

	if (buffer && *buffer)
                free(buffer);

	//Runtime Change
	websChg2ExeMode(FILE_RC_IPTABLES);
	websChg2ExeMode(FILE_RC_FIREWALL);
	system(SERVICE_NAT_RESTART);
	system(SERVICE_FIREWALL_RESTART);
	system(SERVICE_RESTORE);
	
	ifx_httpdNextPage(wp);
}
