/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#ifdef CONFIG_CGI_OPEN_COMP_QOS
#include	"ifx_emf.h"
                              #include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_qos_setting(int eid, httpd_t wp, int argc, char_t **argv)
{
	 int 	i,nSelIdx;
        char_t  *name, sValue[MAX_FILELINE_LEN];

        if (ejArgs(argc, argv, T("%s"), &name) < 1)
        {
                ifx_httpdError(wp, 400, T("Insufficient args\n"));
                return -1;
        }

        memset(sValue, 0x00, MAX_FILELINE_LEN);
	if( !gstrcmp(name, T("priorityVLAN")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "priority_setting", "stream_classification_802_1", sValue) == 1 )
              {
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosYESNOMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosYESNOMode[i].str);
			}
		}
  		//ejSetResult(eid, sValue);
	
	}else
	if( !gstrcmp(name, T("Lanpriority")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "priority_setting", "lan_priority", sValue) == 1 )
              {
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosZero2SevenMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosZero2SevenMode[i].str);
			}
		}
	}else
	if( !gstrcmp(name, T("PCpriority")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "priority_setting", "pc_priority", sValue) == 1 )
              {
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosZero2SevenMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosZero2SevenMode[i].str);
			}	
		}
	}else
	if( !gstrcmp(name, T("IPPhonepriority")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "priority_setting", "ipphone_priority", sValue) == 1 )
              {
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosZero2SevenMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosZero2SevenMode[i].str);
			}	
		}
	
	}else
	if( !gstrcmp(name, T("L2L3Priority")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "diff_priorities", "diff_pri", sValue) == 1 )
              {
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosL2L3Mode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosL2L3Mode[i].str);
			}	
		}
	
	}else
	if ( !gstrcmp(name, T("MappingTableLayer2")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "mapping_table", T("layer2"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Hostname is not found");
			return -1;	
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }else
	if ( !gstrcmp(name, T("MappingTableLayer3")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "mapping_table", T("layer3"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Hostname is not found");
			return -1;	
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }else
	if( !gstrcmp(name, T("handlingqueuespriority")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "handling_que_priority", "hdl_pri", sValue) == 1 )
              {
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosHandlingQueuesMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosHandlingQueuesMode[i].str);
			}	
		}
	
	}else
	if( !gstrcmp(name, T("portbasedpriority")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "port_priority", "port_priority_status", sValue) == 1 )
              {
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosYESNOMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosYESNOMode[i].str);
			}	
		}
	
	}else

	if( !gstrcmp(name, T("lanport")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "port_priority", "lan_port", sValue) == 1 )
              {
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosLowHighMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosLowHighMode[i].str);
			}	
		}
	
	}else
	if( !gstrcmp(name, T("pcport")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "port_priority", "pc_port", sValue) == 1 )
              {
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosLowHighMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosLowHighMode[i].str);
			}	
		}
	
	}else
	if( !gstrcmp(name, T("ipphoneport")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "port_priority", "ipphone_port", sValue) == 1 )
              {
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosLowHighMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosLowHighMode[i].str);
			}	
		}
	
	}

	return 0;
}

void ifx_set_qos_setting(httpd_t wp, char_t *path, char_t *query)
{
	char_t  *ppriorityVLAN,*pLanpriority,*pPCpriority,*pIPPhonepriority,*pL2L3Priority,*pMappingTableLayer2,
		     *pMappingTableLayer3,*phandlingqueuespriority,*pportbasedpriority,*planport,*ppcport,*pipphoneport;
	//*pCriticaltraffic,,*pvoiceminiport,*pvoicemaxport
	
	char_t   spriorityVLAN[MAX_DATA_LEN],sLanpriority[MAX_DATA_LEN],
		    sPCpriority[MAX_DATA_LEN],sIPPhonepriority[MAX_DATA_LEN],sL2L3Priority[MAX_DATA_LEN],
		    sMappingTableLayer2[MAX_DATA_LEN],sMappingTableLayer3[MAX_DATA_LEN],shandlingqueuespriority[MAX_DATA_LEN],
		    sportbasedpriority[MAX_DATA_LEN],slanport[MAX_DATA_LEN],spcport[MAX_DATA_LEN],
		    sipphoneport[MAX_DATA_LEN];
	//sCriticaltraffic[MAX_DATA_LEN],,svoiceminiport[MAX_DATA_LEN],svoicemaxport[MAX_DATA_LEN]
	
	 // Set to rc.conf file
	 // 1
#if 0	 
	pCriticaltraffic = ifx_httpdGetVar(wp, T("Criticaltraffic"), T(""));
 	gsprintf(sCriticaltraffic, T("critical_traffic=\"%s\"\n"), pCriticaltraffic);
#endif	

	 // 2
	 ppriorityVLAN = ifx_httpdGetVar(wp, T("priorityVLAN"), T(""));
	gsprintf(spriorityVLAN, T("stream_classification_802_1=\"%s\"\n"), ppriorityVLAN);

	 // 3
	 pLanpriority = ifx_httpdGetVar(wp, T("Lanpriority"), T(""));
	gsprintf(sLanpriority, T("lan_priority=\"%s\"\n"), pLanpriority);

	 // 4
	 pPCpriority = ifx_httpdGetVar(wp, T("PCpriority"), T(""));	 
	gsprintf(sPCpriority, T("pc_priority=\"%s\"\n"), pPCpriority);

	 // 5
	 pIPPhonepriority = ifx_httpdGetVar(wp, T("IPPhonepriority"), T(""));
	gsprintf(sIPPhonepriority, T("ipphone_priority=\"%s\"\n"), pIPPhonepriority);

	 // 6
	 pL2L3Priority =  ifx_httpdGetVar(wp, T("L2L3Priority"), T(""));
	gsprintf(sL2L3Priority, T("diff_pri=\"%s\"\n"), pL2L3Priority);

	//7
	 pMappingTableLayer2 =  ifx_httpdGetVar(wp, T("MappingTableLayer2"), T(""));
	gsprintf(sMappingTableLayer2, T("layer2=\"%s\"\n"), pMappingTableLayer2);

	//8
	 pMappingTableLayer3 =  ifx_httpdGetVar(wp, T("MappingTableLayer3"), T(""));
	gsprintf(sMappingTableLayer3, T("layer3=\"%s\"\n"), pMappingTableLayer3);

	 // 9
	phandlingqueuespriority =  ifx_httpdGetVar(wp, T("handlingqueuespriority"), T(""));
	gsprintf(shandlingqueuespriority, T("hdl_pri=\"%s\"\n"), phandlingqueuespriority);
	
	 // 10
	 pportbasedpriority =  ifx_httpdGetVar(wp, T("portbasedpriority"), T(""));
	 gsprintf(sportbasedpriority, T("port_priority_status=\"%s\"\n"), pportbasedpriority);
	
	 // 11
	 planport =  ifx_httpdGetVar(wp, T("lanport"), T(""));
	 gsprintf(slanport, T("lan_port=\"%s\"\n"), planport);
	
	 // 12
	 ppcport =  ifx_httpdGetVar(wp, T("pcport"), T(""));
	 gsprintf(spcport, T("pc_port=\"%s\"\n"), ppcport);
	 
	 // 13
	 pipphoneport =  ifx_httpdGetVar(wp, T("ipphoneport"), T(""));
	 gsprintf(sipphoneport, T("ipphone_port=\"%s\"\n"), pipphoneport);
#if 0
	 //14
	 pvoiceminiport =  ifx_httpdGetVar(wp, T("voiceminiport"), T(""));
	 gsprintf(svoiceminiport, T("voice_port_min=\"%s\"\n"), pvoiceminiport);

	 //15
	 pvoicemaxport =  ifx_httpdGetVar(wp, T("voicemaxport"), T(""));
	 gsprintf(svoicemaxport, T("voice_port_max=\"%s\"\n"), pvoicemaxport);
#endif	 

//	websSetCfgData(FILE_RC_CONF, "builtin_switch", 1, sCriticaltraffic);
	websSetCfgData(FILE_RC_CONF, "priority_setting", 4, spriorityVLAN, sLanpriority,sPCpriority,sIPPhonepriority);
	websSetCfgData(FILE_RC_CONF, "diff_priorities", 1, sL2L3Priority);
	websSetCfgData(FILE_RC_CONF, "mapping_table", 2, sMappingTableLayer2, sMappingTableLayer3);
	websSetCfgData(FILE_RC_CONF, "handling_que_priority", 1, shandlingqueuespriority);
	websSetCfgData(FILE_RC_CONF, "port_priority", 4, sportbasedpriority, slanport,spcport,sipphoneport);
//	websSetCfgData(FILE_RC_CONF, "voice_port_range", 2, svoiceminiport, svoicemaxport);
	// save setting
	#if 0
	if (ifx_web_Save_Setting()<=0)
	{
  		ifx_httpdError(wp, 200, "Fail to save Setting");
		return;
	}
	#else
	system(SERVICE_RESTORE);
	#endif

	//<<add_code_here
    	//system(SERVICE_QOS_RESTART);
    	//system(SERVICE_RESTORE);

	system(SERVICE_QOS);
        ifx_httpdNextPage(wp);

}
#endif //#ifdef CONFIG_CGI_OPEN_COMP_QOS
