/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"
#include 	"ifx_httpd_method.h"

#include	 "ifx_common_defs.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_systemmain(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	str[20];
	
	memset(str, 0x00, 20);
	
#ifdef ATA
	strcpy(str, "ATA");
#endif
#if defined(SPURS) && defined (ATA)
	strcpy(str, "WATA");
#endif

#ifdef GATEWAY
	strcpy(str, "Router");
#endif

#if defined(SPURS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

#if defined(WILDPASS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

#ifndef IIP
	ifx_httpdWrite(wp,T("The %s supports advanced functions like hacker attack" 
   						" detection, client filtering, virtual servers, special"
   						"  application access, and a virtual DMZ host."), str);
#else
	ifx_httpdWrite(wp,T("The INCA-IP LAN Phone supports advanced functions like"
   						"Call Forwarding, Call Transfer, Call On Hold and 3-Party"
   						"Conferencing."));
#endif

	return 0;
}


void ifx_System_PageTitle(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t  str[20];

	memset(str, 0x00, 20);
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return ;
	}	

#ifdef ATA
	strcpy(str, "ATA");
#endif
#if defined(SPURS) && defined (ATA)
	strcpy(str, "WATA");
#endif

#ifdef GATEWAY
	strcpy(str, "Router");
#endif

#if defined(SPURS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

#if defined(WILDPASS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

	if (!gstrcmp(name, T("System_Resetpage")))
	{
	ifx_httpdWrite(wp, T("In the event that\n"
						 "the %s stops responding correctly or in some way stops\n"
						 "functioning, you can perform a reset. Your settings will not be\n"
						 "changed. To perform the reset, click on the \"Reset\" button below. You\n"
						 "will be asked to confirm your decision. The reset will be complete	\n"
						 "when the power light stops blinking."),str);
	}else
	if (!gstrcmp(name, T("System_ResetTitlepage")))
	{
	ifx_httpdWrite(wp,"Reset %s",str);
	}
	else
	if (!gstrcmp(name, T("System_Statuspage")))
	{
	ifx_httpdWrite(wp,T("You can use the Status screen to see the connection status\n"
						 "for the %ss' WAN/LAN interfaces, firmware and hardware version numbers,\n"
						 "and the number of connected clients to your network."),str);
	}else
	if (!gstrcmp(name, T("System_FirewareUpgradepage")))
	{
	ifx_httpdWrite(wp,"Infineon Inc. may create new firmware for your %s to improve functionality and performance.",str);
	}else
	if (!gstrcmp(name, T("System_Timepage")))
	{
	ifx_httpdWrite(wp,T("Connecting to a Simple Network Time Protocol (SNTP) server allows the %s\n"
						 "to synchronize the system clock to the global Internet.  The synchronized clock\n"
						 "in the %s is used to recored the security log and control client filtering."),str,str);
	}else
	if (!gstrcmp(name, T("System_Restorepage")))
	{
	ifx_httpdWrite(wp,T("To restore the factory default settings of the %s, click on"
						 "the \"Restore\" button.  You will be asked to confirm your decision."),str);
	}else
	if (!gstrcmp(name, T("System_Configurepage")))
	{
	ifx_httpdWrite(wp,T("Use the \"Backup Settings\" tool to save the %s's current configuration to a"
						 "file named \"config.bin\" on your PC. You can then use the \"Restore Settings\" tool to"
						 "restore the saved configuration of the %s.  Alternately, you can use the"
						 "\"Restore to Factory Defaults\" tool to force the %s to perform reset and"
						 "restore the original factory settings."),str,str,str);
	}else
	if (!gstrcmp(name, T("System_Hostnamepage")))
	{
	ifx_httpdWrite(wp,T("Enter the host name representing your host and the domain name you want to config, then you\n"
						 "can doing web configuration by typing the whole name you config instead by typing the ip address."));
	}else
	if (!gstrcmp(name, T("System_Logpage")))
	{
	ifx_httpdWrite(wp,"View any attempts that have been made to gain access to your network.");
	}else
	if(!gstrcmp(name, T("System_ResetReturnpage")))
	{
	ifx_httpdWrite(wp,"Your %s has successfully been reset.&nbsp;",str);
	}else
	if(!gstrcmp(name, T("System_ResetReturnTitlepage")))
	{
	ifx_httpdWrite(wp,"Reset %s Successfully",str);
	}else
	if(!gstrcmp(name, T("System_ResetReturn_PowerBlinkingpage")))
	{
	ifx_httpdWrite(wp,"Please wait until the power light stops blinking.");
	}
	else
	if (!gstrcmp(name, T("System_BackupReturnpage")))
	{
		ifx_httpdWrite(wp, "Your %s has successfully restored settings.&nbsp;", str);
	}
	else
	if (!gstrcmp(name, T("System_Passwordpage")))
	{
		ifx_httpdWrite(wp, T("Set a password to restrict management access to the %s.\n"
						 "If you want to manage the %s from a remote location (outside of the local network), you must \n"
						 "also specify the IP address of the remote PC."), str, str);
	}
	else
	if (!gstrcmp(name, T("Wizard_Hostpage")))
	{
		ifx_httpdWrite(wp, "Enter the unique host name for the %s, and the domain name of your organization.", str);
	}
	else
	if (!gstrcmp(name, T("Wizard_TimeZonepage")))
	{
		ifx_httpdWrite(wp, T("You must set the time zone in order to set your synchronized clock in the \n"
	  					   "%s.  This clock is used to record the system log and control client filtering."), str);
	}
	else
	if (!gstrcmp(name, T("Wizard_WanTypepage")))
	{
		ifx_httpdWrite(wp, T("Some xDSL Internet Service Providers may assign a fixed IP address for your"
	  					   "%s. If you have been provided with this information, choose this"
	  					   "option and enter the assigned IP address, subnet mask, gateway IP and DNS"
	  					   "IP addresses for your %s."), str, str);
	}
}