/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"
#include 	"ifx_httpd_method.h"


#include 	"ifx_common_defs.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

extern int web_image_length;

//////////////////////////////////////////////////////////////////////////////////
// system_restore.asp
//

void ifx_set_system_restore(httpd_t wp, char_t *path, char_t *query)
{
	char_t sCommand[MAX_FILELINE_LEN];
	//a_assert(wp); //need to be modified
	
	
	memset(sCommand, 0x00, MAX_FILELINE_LEN);
	ifx_httpdNextPage(wp);//websNextPage(wp);
	//clear flash's current content	
	system("/usr/sbin/rawaccess -e"); 
	//reboot
	//sleep(3);
	//system("reboot&"); //need to be modified
	reboot(RB_AUTOBOOT);
	
}

//////////////////////////////////////////////////////////////////////////////////
// system_backup.asp
//
void ifx_set_system_backup(httpd_t wp, char_t *path, char_t *query)
{
	char_t sCommand[MAX_FILELINE_LEN];
	//a_assert(wp);
	
	memset(sCommand, 0x00, MAX_FILELINE_LEN);

	//trace(8, " trace before rawaccess -b.............\n"); //need to be modified
	printf(" trace before rawaccess -b.............\n");

	//printf("before rawaccess -b.............\n");
	printf(" before rawaccess -b.............\n");
	//clear flash's current content
	gsprintf(sCommand, T("/usr/sbin/rawaccess -b /ifx/web/conf.bak"));
	system(sCommand); 
	//printf("after rawaccess -b.............\n");
	printf("after rawaccess -b.............\n");

        // Display update result			
	
	ifx_httpdNextPage(wp);//websNextPage(wp);	
	
}


void ifx_set_system_restore_fromfile(httpd_t wp, char_t *path, char_t *query)
{
    int     locWrite;
    int     nLeft;
    unsigned int     nWrite;
    unsigned int iBufOff = 0; 
    int		j = 0;
    int     nRet;
    int     fh=0;
    int     filesize;
    pid_t pid;
    char wbuf[FLASH_BlOCK_SIZE];
    FILE *fp;

    // assume as firmware upload
    //trace(8, "Start downloading.............\n");
    printf("-------ifx_set_system_restore_fromfile--------\n");    
    printf("-------Start downloading--------\n");
    locWrite = 0;
    //nLeft = wp->multiDatalen; 
    nLeft = web_image_length;
    filesize=nLeft;

    //trace(8, T("file size is %d\n"), nLeft);
    printf("file size is %d\n", nLeft);

    fp = fopen("/tmp/web_image","rb");
	// TBM: Need add image header check 1st
    fh = open("/tmp/conf.bak", O_RDWR|O_CREAT); //create this file
    if ( fh == -1 )
    {		
		//trace(8, "open conf.bak fail -------------\n");
		//websError(wp, 200, T("Cannot open/create %s file"), "/tmp/conf.bak");
		//close(fh);
		ifx_httpdError(wp, 200, T("Cannot open/create %s file"), "/tmp/conf.bak");
		close(fh); 
		return;
    }
    else
    {
	        printf("--begin to write data into conf.bak!--\n");
	        //close(fh);

//#if 0

		nWrite = 15000;	//15k
		while (nLeft > 0)
		{		

			//lseek(fh, locWrite, SEEK_SET);		// Begin at 0x00
			printf("--begin to write 1!--\n");
			if(nLeft > nWrite)
			{
				fread(wbuf,sizeof(char),nWrite,fp);
				printf("--begin to write nwrite!--\n");
			}
			else
			{
				fread(wbuf,sizeof(char),nLeft,fp);
				printf("--begin to write nleft!--\n");
			}

			iBufOff = nWrite*j;
			
			if (nWrite > nLeft) 	nWrite = nLeft;
			//nRet = write(fh, &(wp->multiData[locWrite]), nWrite);

			nRet = write(fh, &wbuf+iBufOff, nWrite);
			if (nRet < nWrite)      
			{ 
				//ifx_httpdError(wp, 200, T("File write failed.<br>  locWrite=%d numLeft=%d numWrite=%d Size=%d bytes."), locWrite, nLeft, nWrite, ifx_data_ptr.multiDatalen);
				ifx_httpdError(wp, 200, T("Error."));
				close(fh);          
				return;			    
			}                       
			//locWrite += nWrite;     
		 	nLeft 	 -= nWrite;
		 	j++;  
			
			//trace(8, T("file left size is %d\n"), nLeft);
			printf("file left size is %d\n", nLeft);
			printf("j is %d\n", j);
			
		
	 	}
	 	
		close(fh);
		
		if (nLeft == 0)
		{
			// Display update result
			//websNextPage(wp);

			// Display update result			
		       ifx_httpdWrite(wp,T("<HTML>"));	
   			ifx_httpdWrite(wp, T("<center><b>Restore file success, system will reboot now</b></center>"));
            		ifx_httpdWrite(wp,T("</HTML>"));   			
			ifx_httpdDone(wp, 200);

		      
	    		//trace(8, "Start to restore-------------\n");
	    		//trace(8, "Start to restore-------------\n");
			//trace(8, "Start to restore-------------\n");
			printf("Start to restore-------------\n");
			printf("Start to restore-------------\n");
			printf("Start to restore-------------\n");
			
			system("/usr/sbin/rawaccess -e"); //temp mark
			//trace(8, "After rawaccess -e -------------\n");
			//trace(8, "After rawaccess -e -------------\n");
			//trace(8, "Before rawaccess -d -------------\n");
			printf("After rawaccess -e -------------\n");
			printf("After rawaccess -e -------------\n");
			printf("Before rawaccess -d -------------\n");
			system("/usr/sbin/rawaccess -d /tmp/conf.bak");//temp mark
			//system("/usr/sbin/rawaccess -d /tmp/web_image");
			//trace(8, "After rawaccess -d -------------\n");
			//trace(8, "After rawaccess -d -------------\n");
			//trace(8, "After rawaccess -d -------------\n");
			printf("After rawaccess -d -------------\n");
			printf("After rawaccess -d -------------\n");
			printf("After rawaccess -d -------------\n");
			//system("rm -f /tmp/conf.bak");			
	                sleep(3);//temp mark
                     //trace(8, "reboot -------------\n");	
			//trace(8, T("file size is %d---\n"), filesize);  
			printf("before reboot -------------\n");
			printf("file size is %d\n", filesize);
			//system("reboot&");

			if ((pid = fork()) == 0) {
		  	    	reboot(RB_AUTOBOOT);
		         	 _exit(0);//temp mark
			printf("after reboot -------------\n");
		    	}
		        waitpid (pid, NULL, 0);
		}
		else
		{			
			//websError(wp, 200, T("nLeft=%d locWrite=%d Size=%d bytes."), nLeft, locWrite, wp->multiDatalen);
			//return;
			ifx_httpdError(wp, 200, T("Error"));
			return;
		}			
//#endif
 }

}


