/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <net/if.h>
#include <net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include "ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>



int  ifx_get_Securitylog (int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sCommand[MAX_FILELINE_LEN];
	char_t	sValue[MAX_FILELINE_LEN];
	int		nLine = 0, nReturn;

   	memset(sCommand, 0x00, MAX_FILELINE_LEN);

	// RTH: Not only one line, 
	gsprintf(sCommand, T("tail -n %d %s | cut -f1 -d*"), APPS_SECURITYLOG_NUM, FILE_MESSAGES);
	do
	{
		char_t sLine[3];
		nLine++;
		gsprintf(sLine, "%d", nLine);

		nReturn = ifx_GetCfgData((char_t*)sCommand, NULL, sLine, sValue);
		if ( nReturn == 0 ) break;		// File not found
		ifx_httpdWrite(wp, T("%s\n"), sValue);
//		ifx_httpdWrite(wp, T("%s<BR>"), sValue);

	}while(nLine <= APPS_SECURITYLOG_NUM && sValue[0]);
	
	return 0;
}

void ifx_set_system_log(httpd_t wp, char_t *path, char_t *query)
{
	char_t	sCommand[MAX_DATA_LEN];
	char_t	*pClear = ifx_httpdGetVar(wp, T("securityclear"), T(""));

	if ( !gstrcmp(pClear, T("Clear")))
	{
		//gsprintf(sCommand, "rm -f %s", FILE_MESSAGES);
		sprintf(sCommand, "echo \"Clear Log file at \"`date` > %s", FILE_MESSAGES);		
		system(sCommand);
	}

	ifx_httpdNextPage(wp);
}
