/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include "ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

//////////////////////////////////////////////////////////////////////////////////
// system_hostname.asp, wizard_host.asp
//
int ifx_get_SystemHostName_sp(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sCommand[MAX_DATA_LEN];
	char_t	sHostname[MAX_DATA_LEN];

	// Get full hostname (EX:adm5120.admtek.com.tw)
//	gstrcpy(sCommand, T("hostname"));
	if ( ifx_GetCfgData(FILE_RC_CONF, TAG_SP, "spact", sHostname) == 0)
//	if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sHostname) == 0)
	{
		ifx_httpdError(wp, 200, T("Hostname not found"));
		return -1;
	}

//	strtok(sHostname, ".");
	ifx_httpdWrite(wp, T("%s"), sHostname);
	return 0 ;
}

int ifx_get_SystemDomainName_sp(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sCommand[MAX_DATA_LEN];
	char_t	sHostname[MAX_DATA_LEN];
	int		pos = 0;
	
	// Get full hostname (EX:adm5120.admtek.com.tw)	
	gstrcpy(sCommand, T("hostname"));
	if ( ifx_GetCfgData(FILE_RC_CONF, TAG_SP, "spdeact", sHostname) == 0)
//	if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sHostname) == 0)
	{
		ifx_httpdError(wp, 200, T("Domainname not found"));
		return -1;
	}
	
//	pos = strcspn(sHostname, ".");
	ifx_httpdWrite(wp, T("%s"), sHostname);
	return 0 ;
}

//////////////////////////////////////////////////////////////////////////////////
// wizard_host.asp
//
void ifx_set_wizard_host_sp(httpd_t wp, char_t *path, char_t *query)
{
	char_t *pHostname, *pDomainname;
	char_t sHostname[MAX_DATA_LEN];
	char_t sCommand[MAX_DATA_LEN];

	memset(sHostname, 0, MAX_DATA_LEN);
	memset(sCommand, 0, MAX_DATA_LEN);

	// Get value for ASP file
	pHostname = ifx_httpdGetVar(wp, T("HostName"), T("")); 
	pDomainname = ifx_httpdGetVar(wp, T("DomainName"), T("")); 

	if (pHostname == 0 || pDomainname ==0)
	{
		ifx_httpdError(wp, 200, T("Setup Error"));
		return;
	}

	gsprintf(sHostname, "spact=\"%s\"\nspdeact=\"%s\"\n", pHostname,pDomainname);


	// Update rc.conf in ramdisk
	if (websSetCfgData(FILE_RC_CONF, TAG_SP, 1, sHostname) == 0)
	{
		ifx_httpdError(wp, 200, "Fail to set hostname");
		return;
	}
	gsprintf(sHostname, "echo \"%s\" > /nv/spact\n echo \"%s\" > /nv/spdeact\n ", pHostname,pDomainname);
        system(sHostname);
        system(SERVICE_RESTORE);
        ifx_httpdNextPage(wp);


#if 0
	gsprintf(sHostname, "spdeact=\"%s\"\n", pDomainname);


	// Update rc.conf in ramdisk
	if (websSetCfgData(FILE_RC_CONF, TAG_HOSTNAME, 1, sHostname) == 0)
	{
		ifx_httpdError(wp, 200, "Fail to set hostname");
		return;
	}
#endif
#if 0
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_LAN_DHCPS, "dhcps_enable", sCommand) == 1)
        {
                if ( !gstrcmp(sCommand, "YES") )  //DHCP Enable
                {
			memset(sCommand, 0x00, MAX_DATA_LEN);
			gsprintf(sCommand, "option\tdomain\t%s\n", pDomainname);
                }
                else                                                    //DHCP Disable
                {
			memset(sCommand, 0x00, MAX_DATA_LEN);
			gsprintf(sCommand, "#option\tdomain\t\n");
                }
	}

	// Update udhcpd.conf in ramdisk
	if (websSetCfgData(FILE_UDHCPD_CONF, TAG_HOSTNAME, 1, sCommand) == 0)
	{
		ifx_httpdError(wp, 200, "Fail to set Domain name");
		return;
	}

	// set Hostname
	system(SERVICE_DHCPS_STOP);
	system(SERVICE_DHCPS_START);
	system(SERVICE_RC_HOST);
	system(SERVICE_DNS_RESTART);
	system(SERVICE_RESTORE);
	ifx_httpdNextPage(wp);
#endif
}
