/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

CGI_ENUMSEL_S web_Enum_TimeZoneList [] =
{
    { 0, "(GMT-12:00) Eniwetok, Kwajalein"},
    { 1, "(GMT-11:00) Midway Island, Samoa"},
    { 2, "(GMT-10:00) Hawaii"},
    { 3, "(GMT-09:00) Alaska"},
    { 4, "(GMT-08:00) Pacific Time (US & Canada); Tijuana"},
    { 5, "(GMT-07:00) Arizona"},
    { 6, "(GMT-07:00) Mountain Time (US & Canada)"},
    { 7, "(GMT-06:00) Central America"},
    { 8, "(GMT-06:00) Central Time (US & Canada)"},
    { 9, "(GMT-06:00) Mexico City"},
    {10, "(GMT-06:00) Saskatchewan"},
    {11, "(GMT-05:00) Bogota, Lima, Quito"},
    {12, "(GMT-05:00) Eastern Time (US & Canada)"},
    {13, "(GMT-05:00) Indiana (East)"},
    {14, "(GMT-04:00) Atlantic Time (Canada)"},
    {15, "(GMT-04:00) Caracas, La Paz"},
    {16, "(GMT-04:00) Santiago"},
    {17, "(GMT-03:30) Newfoundland"},
    {18, "(GMT-03:00) Brasilia"},
    {19, "(GMT-03:00) Buenos Aires, Georgetown"},
    {20, "(GMT-03:00) Greenland"},
    {21, "(GMT-02:00) Mid-Atlantic"},
    {22, "(GMT-01:00) Azores"},
    {23, "(GMT-01:00) Cape Verde Is."},
    {24, "(GMT) Casablanca, Monrovia"},
    {25, "(GMT) Greenwich Mean Time: Dublin, Edinburgh, Lisbon, London"},
    {26, "(GMT+01:00) Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna"},
    {27, "(GMT+01:00) Belgrade, Bratislava, Budapest, Ljubljana, Prague"},
    {28, "(GMT+01:00) Brussels, Copenhagen, Madrid, Paris"}, 
    {29, "(GMT+01:00) Sarajevo, Sofija, Warsaw, Zagreb, Skopje, Vilnius"},
    {30, "(GMT+01:00) West Central Africa"},
    {31, "(GMT+02:00) Athens, Istanbul, Minsk"},
    {32, "(GMT+02:00) Bucharest"},
    {33, "(GMT+02:00) Cairo"},
    {34, "(GMT+02:00) Harare, Pretoria"},
    {35, "(GMT+02:00) Helsinki, Riga, Tallinn"},
    {36, "(GMT+02:00) Jerusalem"},
    {37, "(GMT+03:00) Baghdad"},
    {38, "(GMT+03:00) Kuwait, Riyadh"},
    {39, "(GMT+03:00) Moscow, St. Petersburg, Volgograd"},
    {40, "(GMT+03:00) Nairobi"},
    {41, "(GMT+03:30) Tehran"},
    {42, "(GMT+04:00) Abu Dhabi, Muscat"},
    {43, "(GMT+04:00) Baku, Tbilisi, Yerevan"},
    {44, "(GMT+04:30) Kabul"},
    {45, "(GMT+05:00) Ekaterinburg"},
    {46, "(GMT+05:00) Islamabad, Karachi, Tashkent"},
    {47, "(GMT+05:30) Calcutta, Chennai, Mumbai, New Delhi"},
    {48, "(GMT+05:45) Kathmandu"},
    {49, "(GMT+06:00) Almaty, Novosibirsk"},
    {50, "(GMT+06:00) Astana, Dhaka"},
    {51, "(GMT+06:00) Sri, Jayawardenepura"},
    {52, "(GMT+06:30) Rangoon"},
    {53, "(GMT+07:00) Bangkok, Hanoi, Jakarta"},
    {54, "(GMT+07:00) Krasnoyarsk"},
    {55, "(GMT+08:00) Beijing, Chongqing, Hong Kong, Urumqi"},
    {56, "(GMT+08:00) Irkutsk, Ulaan Bataar"},
    {57, "(GMT+08:00) Kuala Lumpur, Singapore"},
    {58, "(GMT+08:00) Perth"},
    {59, "(GMT+08:00) Taipei"},
    {60, "(GMT+09:00) Osaka, Sapporo, Toyko"},
    {61, "(GMT+09:00) Seoul"},
    {62, "(GMT+09:00) Yakutsk"},
    {63, "(GMT+09:30) Adelaide"},
    {64, "(GMT+09:30) Darwin"},
    {65, "(GMT+10:00) Brisbane"},
    {66, "(GMT+10:00) Canberra, Melbourne, Sydney"},
    {67, "(GMT+10:00) Guam, Port Moresby"},
    {68, "(GMT+10:00) Hobart"},
    {69, "(GMT+10:00) Vladivostok"},
    {70, "(GMT+11:00) Magadan, Solamon, New Caledonia"},
    {71, "(GMT+12:00) Auckland, Wellington"},
    {72, "(GMT+12:00) Fiji, Kamchatka, Marshall Is."},
    {73, "(GMT+13:00) Nuku'alofa"}
};


static  int TimeZone_Map[] =
{
	+12,			// TZ_ENEWETAK_KWAJALEIN,  	// TZ=CST-12
	+11,            // TZ_MIDWAY_ISLAND,      
	+10,            // TZ_HAWAII,             
	+9,             // TZ_ALASKA,             
	+8,             // TZ_PACIFIC,            
	+7,             // TZ_ARIZONA,            
	+7,             // TZ_MOUNTAIN,           
	+6,             // TZ_CENTRAL_AMERICA,    
	+6,             // TZ_CENTRAL,            
	+6,             // TZ_MEXICO_CITY,        
	+6,             // TZ_SASKATCHEWAN,       
	+5,             // TZ_BOGOTA,             
	+5,             // TZ_EASTERN,            
	+5,             // TZ_INDIANA,            
	+4,             // TZ_ATLANTIC,           
	+4,             // TZ_CARACAS,            
	+4,             // TZ_SANTIAGO,           
	+3.5,           // TZ_NEWFOUNDLAND,       
	+3,             // TZ_BRASILIA,           
	+3,             // TZ_BUENOS,             
	+3,             // TZ_GREENLAND,          
	+2,             // TZ_MID_ATLANTIC,       
	+1,             // TZ_AZORES,             
	+1,             // TZ_CAPE_VERDE_IS,      
	+0,              // TZ_CASABLANCA,         
	+0,              // TZ_GREENWICH_MEAN_TIME,
	-1,              // TZ_AMSTERDAM,          
	-1,              // TZ_BELGRADE,           
	-1,              // TZ_BRUSSELS,           
	-1,              // TZ_SARAJEVO,           
	-1,              // TZ_WEST_CENTRAL_AFRICA,
	-2,              // TZ_ATHENS,             
	-2,              // TZ_BUCHAREST,          
	-2,              // TZ_CAIRO,              
	-2,              // TZ_HARARE,             
	-2,              // TZ_HELSINKI,           
	-2,              // TZ_JERUSALEM,          
	-3,              // TZ_BAGHDAD,            
	-3,              // TZ_KUWAIT,             
	-3,              // TZ_MOSCOW,             
	-3,              // TZ_NAIROBI,            
	-3.5,            // TZ_TEHRAN,             
	-4,              // TZ_ABU_DHABI,          
	-4,              // TZ_BAKU,               
	-4.5,            // TZ_KABUL,              
	-5,              // TZ_EKATERINBURG,       
	-5,              // TZ_ISLAMABAD,          
	-5.5,            // TZ_CALCUTTA,           
	-5.75,           // TZ_KATHMANDU,          
	-6,              // TZ_ALMATY,             
	-6,              // TZ_ASTANA,             
	-6,              // TZ_SRI_JAYAWARDENEPURA,
	-6.5,            // TZ_RANGOON,            
	-7,              // TZ_BANGKOK,            
	-7,              // TZ_KRASNOYARSK,        
	-8,              // TZ_BEIJING,            
	-8,              // TZ_IRKUTSK,            
	-8,              // TZ_SINGAPORE,          
	-8,              // TZ_PERTH,              
	-8,              // TZ_TAIPEI,             
	-9,              // TZ_TOKYO,              
	-9,              // TZ_SEOUL,              
	-9,              // TZ_YAKUTSK,            
	-9.5,              // TZ_ADELAIDE,           
	-9,              // TZ_DARWIN,             
	-10,              // TZ_BRISBANE,           
	-10,              // TZ_CANBERRA,           
	-10,              // TZ_GUAM,               
	-10,              // TZ_HOBART,             
	-10,              // TZ_VLADIVOSTOK,        
	-11,              // TZ_MAGADAN,            
	-12,              // TZ_AUCKLAND,           
	-12,              // TZ_FIJI,               
	-13              // TZ_NUKUALOFA,          
};
void ifx_set_wizard_tz(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*ptz  = ifx_httpdGetVar(wp, T("tz"), T("")); 
	char_t	sTimeZoneList[MAX_DATA_LEN], sTimeZone[MAX_DATA_LEN];
	char_t	sCST[MAX_DATA_LEN];
	char_t	*oldtz=0;

	memset(sTimeZoneList, 0, MAX_DATA_LEN);
	memset(sTimeZone, 0, MAX_DATA_LEN);
	memset(sCST, 0, MAX_DATA_LEN);

	// Update rc.conf
	gsprintf(sTimeZoneList, "TimeZoneList=%s\n", ptz);
	gsprintf(sTimeZone, "timezone=GMT%d\n", TimeZone_Map[gatoi(ptz)]);
	websSetCfgData(FILE_RC_CONF, TAG_TIME_ZONE, 2, sTimeZoneList, sTimeZone);

	
	memset(sTimeZone, 0x00, MAX_DATA_LEN);
	sprintf(sTimeZone, "TZ=GMT%d", TimeZone_Map[gatoi(ptz)]);

	setenv("TZ", "GMT-8", 1);
	tzset();
	oldtz = getenv("TZ");

	system(SERVICE_RESTORE);        
	
	ifx_httpdNextPage(wp);
}

int ifx_get_TimeSetting(int eid, httpd_t wp, int argc, char_t **argv)
{
        char_t  *name, sValue[MAX_DATA_LEN], s_ifx_webs_select[MAX_DATA_LEN];
        int     nIndex, nSelIndex;

  if (ejArgs(argc, argv, T("%s"), &name) < 1)
  {
    ifx_httpdError(wp, 400, T("Insufficient args\n"));
    return -1;
  }
  if ( !gstrcmp(name, T("TimeZone")) )
  {
        if (ifx_GetCfgData(FILE_RC_CONF, TAG_TIME_ZONE, "TimeZoneList", sValue) == 0)
        {
                nSelIndex = 0;
        }
        else
        {
                nSelIndex = gatoi(sValue);
        }

        for (nIndex=0; nIndex<sizeof(web_Enum_TimeZoneList)/sizeof(CGI_ENUMSEL_S); nIndex++)
        {
                // Get Selected option index from admweb.conf
                if (nIndex == nSelIndex)
                        gstrcpy(s_ifx_webs_select, "selected");
                else
                        gstrcpy(s_ifx_webs_select,"");

                ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, s_ifx_webs_select, web_Enum_TimeZoneList[nIndex].str);
        }

  }
  return 0 ;
}

CGI_ENUMSEL_S web_Enum_Daylight_StartMon [] =
{
	{0, "   "},
	{1, "JAN"},
	{2, "FEB"},
	{3, "MAR"},
	{4, "APR"},
	{5, "MAY"},
	{6, "JUN"},
	{7, "JUL"},
	{8, "AUG"},
	{9, "SEP"},
	{10,"OCT"},
	{11,"NOV"},
	{12,"DEC"}
};

int ifx_get_Daylight_StartMon(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t  sValue[MAX_DATA_LEN];
	int     nIndex, nSelIndex;
	
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_TIME_ZONE, "StartMon", sValue) == 0)
	{
		nSelIndex = 0;
		//trace(8, "StartMon value not found.\n");
	}
	else
	{
		//trace(8, "StartMon value is %s\n", sValue);
		nSelIndex = gatoi(sValue);		
	}
	
	for (nIndex=0; nIndex<sizeof(web_Enum_Daylight_StartMon)/sizeof(CGI_ENUMSEL_S); nIndex++)
	{	
		// Get Selected option index from admweb.conf
		if (nIndex == nSelIndex)
			gstrcpy(sValue, "selected");
		else 
			gstrcpy(sValue, "");
		
		ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Enum_Daylight_StartMon[nIndex].str);
	}
	return 0;
}

int ifx_get_Daylight_EndMon(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t  sValue[MAX_DATA_LEN];
	int     nIndex, nSelIndex;
	
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_TIME_ZONE, "EndMon", sValue) == 0)
	{
		nSelIndex = 0;
		//trace(8, "EndMon value not found.\n");
	}
	else
	{
		//trace(8, "EndMon value is %s\n", sValue);
		nSelIndex = gatoi(sValue);		
	}

	for (nIndex=0; nIndex<sizeof(web_Enum_Daylight_StartMon)/sizeof(CGI_ENUMSEL_S); nIndex++)
	{	
		// Get Selected option index from admweb.conf
		if (nIndex == nSelIndex)
			gstrcpy(sValue, "selected");
		else 
			gstrcpy(sValue, "");
		
		ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Enum_Daylight_StartMon[nIndex].str);
	}
	return 0;
}

CGI_ENUMSEL_S web_Enum_Daylight_StartDay [] =
{
	{0, "  "},
	{1, " 1"},
	{2, " 2"},
	{3, " 3"},
	{4, " 4"},
	{5, " 5"},
	{6, " 6"},
	{7, " 7"},
	{8, " 8"},
	{9, " 9"},
	{10,"10"},
	{11,"11"},
	{12,"12"},
	{13,"13"},
	{14,"14"},
	{15,"15"},
	{16,"16"},
	{17,"17"},
	{18,"18"},
	{19,"19"},
	{20,"20"},
	{21,"21"},
	{22,"22"},
	{23,"23"},
	{24,"24"},
	{25,"25"},
	{26,"26"},
	{27,"27"},
	{28,"28"},
	{29,"29"},
	{30,"30"},
	{31,"31"}
};

int ifx_get_Daylight_StartDay(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t  sValue[MAX_DATA_LEN];
	int     nIndex, nSelIndex;
	
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_TIME_ZONE, "StartDay", sValue) == 0)
	{
		nSelIndex = 0;
		//trace(8, "StartDay value not found.\n");
	}
	else
	{
		//trace(8, "StartDay value is %s\n", sValue);
		nSelIndex = gatoi(sValue);		
	}
	
	for (nIndex=0; nIndex<sizeof(web_Enum_Daylight_StartDay)/sizeof(CGI_ENUMSEL_S); nIndex++)
	{	
		// Get Selected option index from admweb.conf
		if (nIndex == nSelIndex)
			gstrcpy(sValue, "selected");
		else 
			gstrcpy(sValue, "");
		
		ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Enum_Daylight_StartDay[nIndex].str);
	}
	return 0;
}

int ifx_get_cfdaysave(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t  sValue[MAX_DATA_LEN];
	
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_TIME_ZONE, "cfdaysave", sValue) == 0)
	{
		gstrcpy(sValue, "0");
		//trace(8, "cfdaysave value not found.\n");
	}
	else
	{
		//trace(8, "cfdaysave value is %s\n", sValue);
	}
	
	return 0;
}

int ifx_get_Daylight_EndDay(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t  sValue[MAX_DATA_LEN];
	int     nIndex, nSelIndex;
	
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_TIME_ZONE, "EndDay", sValue) == 0)
	{
		nSelIndex = 0;
		//trace(8, "EndDay value not found.\n");
	}
	else
	{
		//trace(8, "EndDay value is %s\n", sValue);
		nSelIndex = gatoi(sValue);		
	}
	
	for (nIndex=0; nIndex<sizeof(web_Enum_Daylight_StartDay)/sizeof(CGI_ENUMSEL_S); nIndex++)
	{	
		// Get Selected option index from admweb.conf
		if (nIndex == nSelIndex)
			gstrcpy(sValue, "selected");
		else 
			gstrcpy(sValue, "");
		
		ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Enum_Daylight_StartDay[nIndex].str);
	}
	return 0;
}