/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

#if defined(ATA) || defined(IIP)
int ifx_get_voip_status(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}
	ifx_get_CM_status(wp, name);
}

int ifx_get_CM_status(httpd_t wp, char_t *name)
{
	x_IFX_CM_Msg xCmMsg;

	if ( !gstrcmp(name, T("web")) )
	{
	   	// Get Data from CM
		memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 	
	
	   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
		xCmMsg.ucInfoType = IFX_CM_SIP_CFG_PROXY;		
		xCmMsg.ucChannel = 0;
	
	    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
		{
			if (connection.allowed == 1)
			{
				ifx_httpdWrite(wp, T("0"));	//Login okay and CM is not exist.
			}
			else
			{
				ifx_httpdWrite(wp, T("1"));	//Login okay and CM is exist.
			}
		}
		else
		{
			ifx_httpdWrite(wp, T("1"));	//Login okay and CM is exist.
		}
	}
	else
	{
	   	// Get Data from CM
		memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 	
	
	   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
		xCmMsg.ucInfoType = IFX_CM_SIP_CFG_PROXY;		
		xCmMsg.ucChannel = atoi(name);

	    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
		{
			if (connection.allowed == 1)
			{
				return 0;	//Login okay and CM is not exist.
			}
			else
			{
				return 1;	//Login okay and CM is exist.
			}
		}
		else
		{
			return 1;
		}
	}
	return 1;
}
#endif //#if defined(ATA) || defined(IIP)

int ifx_get_user_password(int eid, httpd_t wp, int argc, char_t **argv)
{
#if defined(GATEWAY) || defined(WILDPASS)
	char_t	*name;
	char_t	sValue[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(command, 0x00, MAX_FILELINE_LEN);

	if ( !gstrcmp(name, T("C1")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_SYSTEM_PASSWORD_REMOTE, T("REMOTE_ENABLE"), sValue) == 1)
		{
			if ( !gstrcmp(sValue, "1") )
			{
				gstrcpy(sValue, "checked");
			}
			else
			{
				gstrcpy(sValue, "");
			}

			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("remoteip1")) )
	{
		
		gsprintf(command, T("grep %s %s | cut -f2 -d\\\" | cut -f1 -d."), "REMOTE_IP", FILE_RC_CONF);
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("remoteip2")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 -d\\\" | cut -f2 -d."), "REMOTE_IP", FILE_RC_CONF);
		
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("remoteip3")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 -d\\\" | cut -f3 -d."), "REMOTE_IP", FILE_RC_CONF);
		
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("remoteip4")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 -d\\\" | cut -f4 -d."), "REMOTE_IP", FILE_RC_CONF);
		
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("remoteport")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_SYSTEM_PASSWORD_REMOTE, T("REMOTE_PORT"), sValue) == 1)
		{
			
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}

#else

#ifdef ATA
	ifx_httpdWrite(wp,T("Freez();\n"));
#endif

#ifdef IIP
	ifx_httpdWrite(wp,T("Freez1();\n"));
#endif //#ifdef IIP

#endif //#if defined(GATEWAY) || defined(WILDPASS)

	return 0;

}


int ifx_get_user_password_behavior(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	sIdleTime[MAX_DATA_LEN];
	
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

	if (!gstrcmp(name, T("timeout")))
	{
		memset(sIdleTime, 0x00, MAX_DATA_LEN);
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_SYSTEM_AUTOLOGOUT, T("AutoLogoutTime"), sIdleTime) == 0)
		{		
			ifx_httpdError(wp, 200, T("Cannot get idle time."));
			return -1;
		}
		
		ifx_httpdWrite(wp,"%d", gatoi(sIdleTime)/60);
	}
	else
	if (!gstrcmp(name, T("evaltF")))
    {
#ifdef ATA
		ifx_httpdWrite(wp,"if (isNValidNum(document.tF0.userName.value))\n");
		ifx_httpdWrite(wp,"{\n");
		ifx_httpdWrite(wp,"alert('All fields cannot be blanked and the input value must be numeric.');\n");
		ifx_httpdWrite(wp,"return false;\n");
		ifx_httpdWrite(wp,"}\n");
#endif
	}else
	if(!gstrcmp(name, T("opType")))
	{
#ifdef ATA
			ifx_httpdWrite(wp,"<tr align=left>");
			ifx_httpdWrite(wp,"<td width=\"20%\"><font class=\"subtitle\">Port</font></td>");
			ifx_httpdWrite(wp,"<td width=\"80%\"><font class=\"subtitle\">");
			ifx_httpdWrite(wp,"<select name=\"port\" onChange=\"Freez();\" size=\"1\">");
			ifx_httpdWrite(wp,"<option value=0 selected>1</option>");
			ifx_httpdWrite(wp,"<option value=1>2</option>");
			ifx_httpdWrite(wp,"</select>");
			ifx_httpdWrite(wp,"</td>");
			ifx_httpdWrite(wp,"</tr>");
#endif
	}else
	if(!gstrcmp(name, T("ExtensionNumberorUserName")))
	{
#ifdef ATA
			ifx_httpdWrite(wp,"<td width=\"20%\" ><font class=\"subtitle\">Extension Number</font></td>");
#endif //#ifdef ATA
#ifdef IIP
			ifx_httpdWrite(wp,"<td width=\"20%\" ><font class=\"subtitle\">User Name</font></td>");
#endif  //#ifdef IIP
	}
	else
	if (!gstrcmp(name, T("portDisable")))
	{
#if defined(ATA) || defined(IIP)
		ifx_httpdWrite(wp,"document.tF0.port.disabled=true;\n");
#endif //#if defined(ATA) || defined(IIP)
	}
	else
	if (!gstrcmp(name, T("portEnable")))
	{
#if defined(ATA) || defined(IIP)
		ifx_httpdWrite(wp,"document.tF0.port.disabled=false;\n");
#endif //#if defined(ATA) || defined(IIP)
	}
	else
	if (!gstrcmp(name, T("userName")))
	{
#if defined(ATA) || defined(IIP)
		ifx_httpdWrite(wp,"document.tF0.userName.value=\"1\";\n");
#endif //#if defined(ATA) || defined(IIP)
#ifdef IIP
		ifx_httpdWrite(wp,"document.tF0.userName.value=\"ADMIN\";\n");
#endif //
	}


	return 0;
	

}

//////////////////////////////////////////////////////////////////////////////////
// user_password.asp
void ifx_set_user_password(httpd_t wp, char_t *path, char_t *query)
{
#if defined(GATEWAY) || defined(WILDPASS)
    char_t	*pCheck, *pRemoteIP1, *pRemoteIP2, *pRemoteIP3, *pRemoteIP4, *pPort;
    char_t	sCheck[MAX_FILELINE_LEN], sRemoteIP[MAX_FILELINE_LEN], sPort[MAX_FILELINE_LEN];
    char_t	*pUserOldPswd = ifx_httpdGetVar(wp, T("userOldPswd"), T("")) ; 
    char_t	*pUserNewPswd = ifx_httpdGetVar(wp, T("userNewPswd"), T("")); 
    char_t	*pUserConPswd = ifx_httpdGetVar(wp, T("userConPswd"), T(""));
    char_t	*pTimeout = ifx_httpdGetVar(wp, T("timeout"), T(""));
	char_t	sUserNewPswd[MAX_DATA_LEN];
	char_t	sSysPassword[MAX_DATA_LEN];
	char_t	sIdleTime[MAX_DATA_LEN];
	bool_t	bPassflag = FALSE;
	bool_t  bUpdatePassword = FALSE;
	
	
	//
    //	when they are all blank, it means "don't change current password"
    //
    int OpswdLen = gstrlen(pUserOldPswd);
	int NpswdLen = gstrlen(pUserNewPswd);
    int CpswdLen = gstrlen(pUserConPswd);
    
    memset(sUserNewPswd, 0x00, MAX_DATA_LEN);
    memset(sSysPassword, 0x00, MAX_DATA_LEN);
    memset(sIdleTime, 0x00, MAX_DATA_LEN);

       memset(sCheck, 0x00, MAX_FILELINE_LEN);
       memset(sPort, 0x00, MAX_FILELINE_LEN);
       memset(sRemoteIP, 0x00, MAX_FILELINE_LEN);

    // Get value from ASP file
       pCheck = ifx_httpdGetVar(wp, T("C1"), T(""));
       pRemoteIP1 = ifx_httpdGetVar(wp, T("remoteip1"), T(""));
	pRemoteIP2 = ifx_httpdGetVar(wp, T("remoteip2"), T(""));
	pRemoteIP3 = ifx_httpdGetVar(wp, T("remoteip3"), T(""));
	pRemoteIP4 = ifx_httpdGetVar(wp, T("remoteip4"), T(""));
	pPort =  ifx_httpdGetVar(wp, T("remoteport"), T(""));

	// Check variables here ...
	if (OpswdLen || NpswdLen || CpswdLen)
	{
	   bUpdatePassword = TRUE;
	if (pUserOldPswd == 0 ||
		gstrlen(pUserOldPswd) < APPS_PASSWORD_MIN_SIZE ||
		gstrlen(pUserOldPswd) > APPS_PASSWORD_MAX_SIZE)
	{
		ifx_httpdError(wp, 200, T("Old password error"));
		return;
	}
	
	if (pUserNewPswd == 0 ||
		gstrlen(pUserNewPswd) < APPS_PASSWORD_MIN_SIZE ||
		gstrlen(pUserNewPswd) > APPS_PASSWORD_MAX_SIZE)
	{
		ifx_httpdError(wp, 200, T("New password error"));
		return;
	}

	if (pUserConPswd == 0 ||
		gstrlen(pUserConPswd) < APPS_PASSWORD_MIN_SIZE ||
		gstrlen(pUserConPswd) > APPS_PASSWORD_MAX_SIZE)
	{
		ifx_httpdError(wp, 200, T("Confirm password error"));
		return;
	}
	}


	//write remote data
	if ( !gstrcmp(pCheck, "1") )
	{
		gsprintf(sCheck, T("REMOTE_ENABLE=\"%s\"\n"), pCheck);
	}
	else
	{
		gsprintf(sCheck, T("REMOTE_ENABLE=\"0\"\n"));
	}

	gsprintf(sRemoteIP, T("REMOTE_IP=\"%s.%s.%s.%s\"\n"), pRemoteIP1, pRemoteIP2, pRemoteIP3, pRemoteIP4);

	gsprintf(sPort, T("REMOTE_PORT=\"%s\"\n"), pPort);

	websSetCfgData(FILE_RC_CONF, TAG_SYSTEM_PASSWORD_REMOTE, 3, sCheck, sRemoteIP, sPort);

	
	//CHECK IF NEED TO UPDATE PASSWORD
	if (bUpdatePassword)
	{
	// Make sure input string exist
	if (OpswdLen || NpswdLen || CpswdLen)
	{
		// Password found in rc.conf, else Password is NULL
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_SYSTEM_PASSWORD, T("Password"), sSysPassword) == 0)
		{		
			ifx_httpdError(wp, 200, T("System password not found!"));
			return;
		}
		
		if (gstrcmp(sSysPassword, pUserOldPswd) != 0)
		{
			ifx_httpdError(wp, 200, T("<body><h2>Current Password not correct!!!</h2>\n"));
			return;
    	}

    	if (NpswdLen != 0 &&
    		(NpswdLen < APPS_PASSWORD_MIN_SIZE ||
    		NpswdLen > APPS_PASSWORD_MAX_SIZE))
    	{
			ifx_httpdError(wp, 200, T("<body><h2>ERROR: The New password is incorrect: the length of"
			"password must be between %d to %d characters.</h2>\n"),
			APPS_PASSWORD_MIN_SIZE, APPS_PASSWORD_MAX_SIZE);
			return;    	
        }

    	// Begining to send variable here.....
    	if (gstrcmp(pUserNewPswd, pUserConPswd) != 0)
    	{
			ifx_httpdError(wp, 200, T("<body><h2>ERROR: The Re-Enter Password for Verification must be"
			 "same as the New Password.</h2>\n"));
			return;    	
    	}
        	
        if (gstrcmp(pUserNewPswd, pUserOldPswd) != 0)
        {
        	bPassflag = TRUE;
        }
	}

	if (bPassflag)
	{
		gsprintf(sUserNewPswd, "Password=%s\n", pUserNewPswd);
		websSetCfgData(FILE_RC_CONF, TAG_SYSTEM_PASSWORD, 1, sUserNewPswd);
	}

	}

	if (pTimeout)
	{
		gsprintf(sIdleTime, "AutoLogoutTime=%d\n", atoi(pTimeout) * 60);
		websSetCfgData(FILE_RC_CONF, TAG_SYSTEM_AUTOLOGOUT, 1, sIdleTime);
	}

	//Runtime Change
	system(SERVICE_FIREWALL_RESTART);

	system(SERVICE_RESTORE);

	if (bUpdatePassword)
	ifx_httpdWrite(wp,T("<center><h1>Modify User Password Success!!! <br></h1></center>"));
	else	
	   ifx_httpdWrite(wp,T("<center><h1>Modify Remote Management Data  Success!!! <br></h1></center>"));
	
	return;
#else //#if defined(GATEWAY) || defined(WILDPASS)
    char_t	*pOpType = ifx_httpdGetVar(wp, T("opType"), T("")) ;  
    char_t	*pPort = ifx_httpdGetVar(wp, T("port"), T("")) ;  
    char_t	*pUserName = ifx_httpdGetVar(wp, T("userName"), T("")) ;                                 
    char_t	*pUserOldPswd = ifx_httpdGetVar(wp, T("userOldPswd"), T("")) ; 
    char_t	*pUserNewPswd = ifx_httpdGetVar(wp, T("userNewPswd"), T("")); 
    char_t	*pUserConPswd = ifx_httpdGetVar(wp, T("userConPswd"), T(""));
    char_t	*pTimeout = ifx_httpdGetVar(wp, T("timeout"), T(""));
	char_t	sIdleTime[MAX_DATA_LEN];
	char_t	sUserName[MAX_DATA_LEN];
	char_t	sUserPwd[MAX_DATA_LEN];
	int		nPort = -1;
    int nOpSelect=atoi(pOpType);
    int flag=0;
    x_IFX_CM_Msg xCmMsg;

	if (ifx_get_CM_status(wp, pPort)==1)
    {
    a_assert(wp);
    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));   
	    memset(sUserName, 0x00, MAX_DATA_LEN);
	    memset(sUserPwd, 0x00, MAX_DATA_LEN);

    xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    xCmMsg.ucInfoType = IFX_CM_APP_ADD_NEW_USR;
#ifdef IIP
    xCmMsg.ucChannel=0;
#endif
#ifdef ATA
    xCmMsg.ucChannel=atoi(pPort);
#endif

    if (IFX_CM_RecvDataFromCM(&xCmMsg)!=IFX_CM_SUCCESS)
    {
        ifx_httpdError(wp, 200, "Fail to get this user data from CM");
        ifx_httpdError(wp,200,T("Wrong Request type"));
        return;
    }
    //ifx_debug_printf("~~~~~~~~~~~~~~Port Number=%d, Port User:%s, Password:%s\n", atoi(pPort), xCmMsg.uxData.xAppUserCfg.ucName, xCmMsg.uxData.xAppUserCfg.ucPasswd);
   if (strlen(xCmMsg.uxData.xAppUserCfg.ucName)!=0)
   {
       flag=1;
   }
	}
	else
	{
		if (nOpSelect == 4) //Modify Logout Time
		{
			if (pTimeout)
			{
				gsprintf(sIdleTime, "AutoLogoutTime=%d\n", atoi(pTimeout) * 60);
				websSetCfgData(FILE_RC_CONF, TAG_SYSTEM_AUTOLOGOUT, 1, sIdleTime);
			}
			ifx_httpdWrite(wp,T("<center><h1>Succeed to modify logout time! <br></h1></center>"));
		} //Modify Logout Time
		else
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		return;
	}
	 
    if (nOpSelect==0)  //add new user
    {
		// Check variables here ...     
		if (pUserNewPswd == 0  || gstrlen(pUserNewPswd) > APPS_PASSWORD_MAX_SIZE)
		{                               
			ifx_httpdError(wp, 200, T("New password error"));
			return;                     
		}                               
		                            
		if (pUserConPswd == 0 || gstrlen(pUserConPswd) > APPS_PASSWORD_MAX_SIZE)
		{                               
			ifx_httpdError(wp, 200, T("Confirm password error"));
			return;                     
		}  
		if (flag==1)
		{                               
			ifx_httpdError(wp, 200, T("Max Users Reached, Cant Add New User"));
			return;                     
		}  
		
		if (strcmp(pUserName, T("1")) == 0 || isspace(pUserName[0]) != NULL)
		{
			ifx_httpdError(wp, 200, T("Can't add this number to be a user. Because administrator is using. And this filed can't with blank character leading."));
			return;
		}

		xCmMsg.ucMsgType = IFX_CM_SET_REQ;
		xCmMsg.ucInfoType = IFX_CM_APP_ADD_NEW_USR;
		xCmMsg.ucChannel=atoi(pPort);
		nPort = atoi(pPort);

		gsprintf(sUserName, "port%d=\"%s\"\n", nPort+1, pUserName);
		gsprintf(sUserPwd, "password%d=\"%s\"\n", nPort+1, pUserNewPswd);

		if (nPort == 0) //port 1
		{
			websSetCfgData(FILE_RC_CONF, TAG_PORT1_DATA, 2, sUserName, sUserPwd);
		}
		else
		if (nPort == 1) //port 2
		{
			websSetCfgData(FILE_RC_CONF, TAG_PORT2_DATA, 2, sUserName, sUserPwd);
		}
		
		strcpy(xCmMsg.uxData.xAppUserCfg.ucName, pUserName);
		strcpy(xCmMsg.uxData.xAppUserCfg.ucPasswd, pUserNewPswd);
		
		if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
		{
			if (connection.allowed == 1)
			{
				ifx_httpdRedirect(wp, "voip_status_return.htm");
			}
			else
			{
			ifx_httpdError(wp, 200, T("Fail to send ADD_NEW_USR data to CM"));
			}
			return;     	
		}
         
        	ifx_httpdWrite(wp,T("<center><h1>Add User Successful !!! <br></h1></center>"));
      		  return;

    }//if (nOpSelect==0)
    else if (nOpSelect==1) //Delete user
	{
		if (g_nCurrentUserLevel != 0)
		{
			ifx_httpdError(wp, 200, T("Only administrator can delete user!"));
			return;
		}

#ifdef ATA
		if (atoi(pUserName)==1)
		{
			ifx_httpdError(wp, 200, T("Administrator can not be deleted!"));
			return;
		}
#endif
#ifdef IIP
		if (!strcmp(pUserName,"ADMIN"))
		{
			ifx_httpdError(wp, 200, T("Administrator can not be deleted!"));
			return;
		}
#endif //#ifdef IIP

		if (flag==0)
		{
			ifx_httpdError(wp, 200, T("This User doesnt exist, cant Delete"));
			return;
		}

                if (strcmp(xCmMsg.uxData.xAppUserCfg.ucName,pUserName))
                {
			ifx_httpdError(wp, 200, T("This User doesnt exist, cant Delete"));
			return;
                }
   
		xCmMsg.ucMsgType = IFX_CM_SET_REQ;
		xCmMsg.ucInfoType =  IFX_CM_APP_DELETE_USER;
		xCmMsg.ucChannel=atoi(pPort);		
		nPort = atoi(pPort);
		strcpy(xCmMsg.uxData.xAppUserCfg.ucName,pUserName);
		strcpy(xCmMsg.uxData.xAppUserCfg.ucPasswd,pUserNewPswd);
		
		if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
		{
			if (connection.allowed == 1)
			{
				ifx_httpdRedirect(wp, "voip_status_return.htm");
			}
			else
			{
			ifx_httpdError(wp, 200, T("Fail to send DELETE_USER data to CM"));
			}
			return; 
		}

		gsprintf(sUserName, "port%d=\" \"\n", nPort+1);
		gsprintf(sUserPwd, "password%d=\" \"\n", nPort+1);

		if (nPort == 0) //port 1
		{
			websSetCfgData(FILE_RC_CONF, TAG_PORT1_DATA, 2, sUserName, sUserPwd);
		}
		else
		if (nPort == 1) //port 2
		{
			websSetCfgData(FILE_RC_CONF, TAG_PORT2_DATA, 2, sUserName, sUserPwd);
		}

		ifx_httpdWrite(wp,T("<center><h1>Delete User Successful!!! <br></h1></center>"));
		return;	
    }
    else if (nOpSelect==2) //Modify user password
    {
		                    
		if (pUserConPswd == 0 || gstrlen(pUserConPswd) > IFX_CM_APP_USER_PASSWD)
		{                               
			ifx_httpdError(wp, 200, T("Confirm password error"));
			return;                     
		}
		/*
		if (flag==0)
		{
			ifx_httpdError(wp, 200, T("This User doesn't exist, Cant Modify"));
			return;
		}
		*/
		// Check variables here ... 
#ifdef ATA	
   	if (atoi(pUserName)==1)
#endif
#ifdef IIP
   	if (!gstrcmp(pUserName,"ADMIN"))
#endif
		{
		
		   xCmMsg.ucMsgType = IFX_CM_SET_REQ;
		   xCmMsg.ucInfoType = IFX_CM_APP_MODIFY_ADMIN_PASSWD;
		   xCmMsg.ucChannel=0;		
	
			gsprintf(sUserName, "port0=\"%s\"\n", pUserName);
			gsprintf(sUserPwd, "password0=\"%s\"\n", pUserNewPswd);
			websSetCfgData(FILE_RC_CONF, TAG_PORT0_DATA, 2, sUserName, sUserPwd);

                   strcpy(xCmMsg.uxData.xAppModUserCfg.ucName,pUserName);
		   strcpy(xCmMsg.uxData.xAppModUserCfg.ucOldPasswd,pUserOldPswd);
		   strcpy(xCmMsg.uxData.xAppModUserCfg.ucNewPasswd,pUserNewPswd);
		
		   if (pUserOldPswd == 0  || gstrlen(pUserOldPswd) > IFX_CM_APP_USER_PASSWD
             || strcmp(g_nCurrentPassword,xCmMsg.uxData.xAppModUserCfg.ucOldPasswd))
         {
			   ifx_httpdError(wp, 200, T("Incorrect Current Password, Can't Modify"));
			   return;
         }

	      strcpy(g_nCurrentPassword,xCmMsg.uxData.xAppModUserCfg.ucNewPasswd); // keep current password
 
		   if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
		   {
		   	if (connection.allowed == 1)
			{
				ifx_httpdRedirect(wp, "voip_status_return.htm");
			}
			else
			{
			  ifx_httpdError(wp, 200, T("Fail to send MODIFY_ADMIN_PASSWD data to CM"));
			}
			  return;     	
		   }

		   ifx_httpdWrite(wp,T("<center><h1>Modify Admin Password Success!!! <br></h1></center>"));
		   return;         
		 }
	

		 if (flag==0)
		 {
			ifx_httpdError(wp, 200, T("This User doesn't exist, Cant Modify"));
			return;
		 }
		
                if (strcmp(xCmMsg.uxData.xAppUserCfg.ucName,pUserName))
                {
			ifx_httpdError(wp, 200, T("This User doesnt exist, cant Modify"));
			return;
                }
		
		 if (pUserOldPswd == 0  || gstrlen(pUserOldPswd) > IFX_CM_APP_USER_PASSWD
           || strcmp(g_nCurrentPassword,pUserOldPswd))
		{                               
			ifx_httpdError(wp, 200, T("Incorrect current Password, Cant Modify"));
			return;                     
		}                               
		                    
		if (pUserNewPswd == 0 || gstrlen(pUserNewPswd) > IFX_CM_APP_USER_PASSWD)
		{                               
			ifx_httpdError(wp, 200, T("New password error"));
			return;    
                }                 
		xCmMsg.ucMsgType = IFX_CM_SET_REQ;
		xCmMsg.ucInfoType = IFX_CM_APP_MODIFY_USER_PASSWD;
		xCmMsg.ucChannel=atoi(pPort);		
		nPort = atoi(pPort);

		gsprintf(sUserName, "port%d=\"%s\"\n", nPort+1, pUserName);
		gsprintf(sUserPwd, "password%d=\"%s\"\n", nPort+1, pUserNewPswd);

		if (nPort == 0) //port 1
		{
			websSetCfgData(FILE_RC_CONF, TAG_PORT1_DATA, 2, sUserName, sUserPwd);
		}
		else
		if (nPort == 1) //port 2
		{
			websSetCfgData(FILE_RC_CONF, TAG_PORT2_DATA, 2, sUserName, sUserPwd);
		}

		strcpy(xCmMsg.uxData.xAppModUserCfg.ucName,pUserName);
		strcpy(xCmMsg.uxData.xAppModUserCfg.ucOldPasswd,pUserOldPswd);
		strcpy(xCmMsg.uxData.xAppModUserCfg.ucNewPasswd,pUserNewPswd);
	   strcpy(g_nCurrentPassword,xCmMsg.uxData.xAppModUserCfg.ucNewPasswd); // keep current password 
		
		if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
		{
			if (connection.allowed == 1)
			{
				ifx_httpdRedirect(wp, "voip_status_return.htm");
			}
			else
			{
			ifx_httpdError(wp, 200, T("Fail to send MODIFY_USER_PASSWD data to CM"));
			}
			return;     	
		}

		ifx_httpdWrite(wp,T("<center><h1>Modify User Password Success!!! <br></h1></center>"));
		return;         

    }//Modify user password
    else if (nOpSelect==3) //reset user password
    {
		if (g_nCurrentUserLevel!=0)
		{
			ifx_httpdError(wp, 200, T("Only administrator can reset user password!"));
			return;
		}
		
		if (flag==0)
		{
			ifx_httpdError(wp, 200, T("This User doesnt exist, Cant Reset"));
			return;
		}
		xCmMsg.ucMsgType = IFX_CM_SET_REQ;
#ifdef IIP
      if (!gstrcmp(pUserName, "ADMIN"))
#endif
#ifdef ATA
      if (atoi(pUserName)==1)
#endif
      {
		   xCmMsg.ucInfoType = IFX_CM_APP_MODIFY_ADMIN_PASSWD;
		   ifx_httpdError(wp, 200, T("Cannot Reset Admin Password"));
			return;
      }
      else
      {
		xCmMsg.ucInfoType = IFX_CM_APP_MODIFY_USER_PASSWD;
                if (strcmp(xCmMsg.uxData.xAppUserCfg.ucName,pUserName))
                {
			ifx_httpdError(wp, 200, T("This User doesnt exist, cant Reset"));
			return;
                }
      }
		xCmMsg.ucChannel=atoi(pPort);
		nPort = atoi(pPort);

		gsprintf(sUserName, "port%d=\"%s\"\n", nPort+1, pUserName);
		gsprintf(sUserPwd, "password%d=\"%s\"\n", nPort+1, pUserNewPswd);

		if (nPort == 0) //port 1
		{
			websSetCfgData(FILE_RC_CONF, TAG_PORT1_DATA, 2, sUserName, sUserPwd);
		}
		else
		if (nPort == 1) //port 2
		{
			websSetCfgData(FILE_RC_CONF, TAG_PORT2_DATA, 2, sUserName, sUserPwd);
		}

		strcpy(xCmMsg.uxData.xAppModUserCfg.ucName,pUserName);
		strcpy(xCmMsg.uxData.xAppModUserCfg.ucOldPasswd,pUserOldPswd);
		strcpy(xCmMsg.uxData.xAppModUserCfg.ucNewPasswd,"");
		if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
		{
			if (connection.allowed == 1)
			{
				ifx_httpdRedirect(wp, "voip_status_return.htm");
			}
			else
			{
			ifx_httpdError(wp, 200, T("Fail to send MODIFY_USER_PASSWD data to CM"));
			}
			return;     	
		}

		ifx_httpdWrite(wp,T("<center><h1>Succeed to reset user password! <br></h1></center>"));
		return;
    }// //reset user password
    else if (nOpSelect == 4) //Modify Logout Time
    {
    	if (pTimeout)
		{
			gsprintf(sIdleTime, "AutoLogoutTime=%d\n", atoi(pTimeout) * 60);
			websSetCfgData(FILE_RC_CONF, TAG_SYSTEM_AUTOLOGOUT, 1, sIdleTime);
		}

		ifx_httpdWrite(wp,T("<center><h1>Succeed to modify logout time! <br></h1></center>"));
		return;
    } //Modify Logout Time
#endif // #if defined(GATEWAY) || defined(WILDPASS)
}
