/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>




//upnp_config.asp
int ifx_get_UpnpStatus(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t sValue[MAX_DATA_LEN];
	char_t	*name,*mode;
	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

	memset(sValue, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_UPNPCONFIG, T("upnp_enable"), sValue) == 0)
	{
		ifx_httpdError(wp, 200, "UPNP status not found");
		return -1;	
	}

	if (!gstrcmp(sValue, "YES") )	// Upnp is enabled
	{
		gstrcpy(sValue, "1");
	}
	else
	{
		gstrcpy(sValue, "0");
	}	
		
	if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0){
		ifx_httpdWrite(wp,T("checked"));
	}else if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0){
		ifx_httpdWrite(wp,T("checked"));
	}

	return 0;
}

void ifx_set_upnp_config(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pStatus = ifx_httpdGetVar(wp, T("UpnpStatus"), T(""));
	char_t	sStatus[MAX_DATA_LEN];
	char_t	sInternalIF[MAX_DATA_LEN];

	memset(sInternalIF, 0x00, MAX_DATA_LEN);
	a_assert(wp);
	memset(sStatus, 0x00, MAX_DATA_LEN);

	if ( !gstrcmp(pStatus, "1") )
	{
		gsprintf(sStatus, T("upnp_enable=\"YES\"\n"));		
		gsprintf(sInternalIF, T("%s"), ADM_LAN_IF);
	}
	else
	{
		gsprintf(sStatus, T("upnp_enable=\"NO\"\n"));
	}

	websSetCfgData(FILE_RC_CONF, TAG_UPNPCONFIG, 1, sStatus);

	if ( !gstrcmp(pStatus, "1") )
	{
		system(SERVICE_UPNPD_RESTART);		// Restart UPnP
	}
	else
	{
		system(SERVICE_UPNPD_STOP);
	}

	system(SERVICE_RESTORE);
	ifx_httpdNextPage(wp);
}


