/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>


CGI_TABLE_S VLANTable[APPS_NUM_OF_ETHFTR_ENTRY];

const int websGetPortNums2(char_t* pData, ST_NAT_PORT_MAP_LIST *pstPortList)
{
	int	i,  nStartPort = 0, nEndPort = 0;
	long	lPort;
	char_t	*pNextToken = pData;
	char_t	*pEnd;

    	i = 0;
    	while (*pNextToken)
    	{
		EATW(pNextToken);
		// Get port from string to long
		lPort = gstrtol(pNextToken, &pEnd, 10);
		
		
		EATW(pEnd);		

		if (*pEnd ==':' || *pEnd == 0 )
		{
			nStartPort = lPort;
			nEndPort = lPort;		
		}
		
		gsprintf(pstPortList[i].sRetValue, T("%d"), nStartPort);
		// Advanced to next clone index
		i++;
		
		// Continue for next port range
		/*
		if (*pEnd == 0)
		{
			nStartPort = lPort;
			nEndPort = lPort;
			//break;
		}*/
		
		pNextToken = pEnd + 1;
	} //end while(*pNextToken)


	//trace(8, T("websGetPortNums of i is %d\n"), i);
	return i;

}


int websUpdate_VLAN(int nCount)
{
	char_t sBuf[BUF_SIZE_1K];
	int nIndex = 0;
	memset(sBuf, 0, BUF_SIZE_1K);
	gsprintf(sBuf, T("%sCount=\"%d\"\n"), PREFIX_VLAN, nCount);			
	
	for (nIndex=0; nIndex<nCount; nIndex++)
	{	
		char_t sLine[MAX_FILELINE_LEN];
		// Print following strings 
		// MAC_DENY_0="00:E0:18:E0:98:2E"
		// MAC_DENY_STAT0="0"
		gsprintf(sLine, T("%sSTAT%d=\"%d\"\n%s%d=\"%s\"\n"), PREFIX_VLAN, nIndex, VLANTable[nIndex].nState, PREFIX_VLAN, nIndex, VLANTable[nIndex].Data.sValue);

		//trace(8, sLine);
		gstrcat(sBuf, sLine);
	}

	return (websSetCfgData(FILE_RC_CONF, TAG_VLAN, 1, sBuf));
}


int ifx_get_StaticMACTableFilter(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t  sValue[MAX_DATA_LEN], sCommand[MAX_DATA_LEN],//,tmpsValue[MAX_DATA_LEN],
		    sMACAddr[MAX_DATA_LEN],sLAN[MAX_DATA_LEN],sCrtiTraffic[MAX_DATA_LEN];//,sPC[MAX_DATA_LEN],sIPP[MAX_DATA_LEN]
	int     nCount, nIndex;
	int 	 idx;//,nRetNum[NAT_VS_LINK_NUM];
	ST_NAT_PORT_MAP_LIST	stPortList[NAT_VS_CLONE_NUM];

	gsprintf(sCommand, T("%sCount"), PREFIX_STAICMACLAN);
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_STAICMAC, sCommand, sValue) == 0)
	{
		ifx_httpdError(wp, 200, T("%s not found"), sCommand);
		return -1;
	}
	
	nCount = gatoi(sValue);
	
	for (nIndex=0; nIndex<nCount; nIndex++)
	{		
		
		gsprintf(sCommand, T("%s%d"), PREFIX_STAICMACLAN,nIndex);
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_STAICMAC, sCommand, sValue) == 0)
		{
			ifx_httpdError(wp, 200, T("%s not found"), sCommand);
			return -1;
		}

	

		//for (idx = 0; idx < 5; idx++)
		for (idx = 0; idx < 4; idx++)
		{
			stPortList[idx].nRangeIdx = 0;
			memset(stPortList[idx].sRetValue, 0x00, MAX_DATA_LEN);
		}

		// Print Html file
		ifx_httpdWrite(wp, T("<tr align=\"center\" bgcolor=\"#ffffff\">\n")); 
		// Get MAC
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f1 -d':'"), PREFIX_STAICMACLAN, nIndex, FILE_RC_CONF);		
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sMACAddr) == 0)
		{
			ifx_httpdError(wp, 204, "Alias IP not found");
			return -1;
		}
		#if 0
		// Get LAN
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f2 -d':'"), PREFIX_STAICMACLAN, nIndex, FILE_RC_CONF);		
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sLAN) == 0)
		{
			ifx_httpdError(wp, 204, "Alias IP not found");
			return -1;
		}
		// Get PC
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f3 -d':'"), PREFIX_STAICMACLAN, nIndex, FILE_RC_CONF);		
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sPC) == 0)
		{
			ifx_httpdError(wp, 204, "Alias IP not found");
			return -1;
		}
		#else
		// Get PORT
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f2 -d':'"), PREFIX_STAICMACLAN, nIndex, FILE_RC_CONF);		
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sLAN) == 0)
		{
			ifx_httpdError(wp, 204, "Alias IP not found");
			return -1;
		}
		#endif
		#if 0
		// Get IPP
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f4 -d':'"), PREFIX_STAICMACLAN, nIndex, FILE_RC_CONF);		
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sIPP) == 0)
		{
			ifx_httpdError(wp, 204, "Alias IP not found");
			return -1;
		}
		#endif
		// Get Crti-Traffic
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f3 -d':'"), PREFIX_STAICMACLAN, nIndex, FILE_RC_CONF);		
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sCrtiTraffic) == 0)
		{
			ifx_httpdError(wp, 204, "Alias IP not found");
			return -1;
		}	
		// Print Html file
#if 0
		ifx_httpdWrite(wp, T("<td width=\"30%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), sMACAddr);		
		ifx_httpdWrite(wp, T("<td width=\"30%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), sLAN);
//		ifx_httpdWrite(wp, T("<td width=\"20%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), sPC);							
//		ifx_httpdWrite(wp, T("<td width=\"18%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), sIPP);
		ifx_httpdWrite(wp, T("<td width=\"30%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), sCrtiTraffic);
		ifx_httpdWrite(wp, T("<td width=\"10%\"><center><input type=\"button\" name=\"relname\" value=\"Delete\" onClick=\"macrelease(%d);\"></center></td>\n"), nIndex); 
#else
		ifx_httpdWrite(wp, T("<td width=\"20%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), sMACAddr);
	       if(strcmp(sLAN,"0") == 0){
			ifx_httpdWrite(wp, T("<td width=\"20%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), "X");
			ifx_httpdWrite(wp, T("<td width=\"20%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), "");
	       }else
	       {
	       	ifx_httpdWrite(wp, T("<td width=\"20%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), "");
			ifx_httpdWrite(wp, T("<td width=\"20%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), "X");
	       }
		if(strcmp(sCrtiTraffic,"0") == 0)
			ifx_httpdWrite(wp, T("<td width=\"20%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), "");
		else
			ifx_httpdWrite(wp, T("<td width=\"20%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), "X");
		
		ifx_httpdWrite(wp, T("<td width=\"20%\"><center><input type=\"button\" name=\"relname\" value=\"Delete\" onClick=\"macrelease(%d);\"></center></td>\n"), nIndex); 		
#endif

		ifx_httpdWrite(wp, T("</tr>\n"));
	}

	return 0;
}


int ifx_get_VLANFilter(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t  sValue[MAX_DATA_LEN], sCommand[MAX_DATA_LEN];
	int     nCount, nIndex;
	int 	 idx,nRetNum[NAT_VS_LINK_NUM];
	ST_NAT_PORT_MAP_LIST	stPortList[NAT_VS_CLONE_NUM];

	gsprintf(sCommand, T("%sCount"), PREFIX_VLAN);
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_VLAN, sCommand, sValue) == 0)
	{
		ifx_httpdError(wp, 200, T("%s not found"), sCommand);
		return -1;
	}
	
	nCount = gatoi(sValue);
	
	for (nIndex=0; nIndex<nCount; nIndex++)
	{		
		
		gsprintf(sCommand, T("%s%d"), PREFIX_VLAN,nIndex);
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_VLAN, sCommand, sValue) == 0)
		{
			ifx_httpdError(wp, 200, T("%s not found"), sCommand);
			return -1;
		}

	

		for (idx = 0; idx < 6; idx++)
		{
			stPortList[idx].nRangeIdx = 0;
			memset(stPortList[idx].sRetValue, 0x00, MAX_DATA_LEN);
		}

		nRetNum[nIndex] = websGetPortNums2(sValue, stPortList);
		// Print Html file
		ifx_httpdWrite(wp, T("<tr align=\"center\" bgcolor=\"#ffffff\">\n")); 
		{
		
			for (idx = 0; idx <6; idx++)
			{
				ifx_httpdWrite(wp, T("<td width=\"15%\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), stPortList[idx].sRetValue); 										
			}		
		}
		
		ifx_httpdWrite(wp, T("<td width=\"10%\"><center><input type=\"button\" name=\"relname\" value=\"Delete\" onClick=\"macrelease(%d);\"></center></td>\n"), nIndex); 
		ifx_httpdWrite(wp, T("</tr>\n"));
	}

	return 0;
}


int ifx_get_Egress_Filtering_qos_setting(int eid, httpd_t wp, int argc, char_t **argv)
{
	 int 	i,nSelIdx;
        char_t  *name,*mode, sValue[MAX_FILELINE_LEN];

        if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
        {
                ifx_httpdError(wp, 400, T("Insufficient args\n"));
                return -1;
        }

        memset(sValue, 0x00, MAX_FILELINE_LEN);
	if ( !gstrcmp(name, T("NONVLANENTRY")) )
	 {		
		if(strcmp(mode,"VLANID") == 0)
	      {		
		 	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", T("vlan_id0"), sValue) == 0)
			{
				ifx_httpdError(wp, 200, "vlan_id0 is not found");
				return -1;	
			}
		
			ifx_httpdWrite(wp, T("%s"), sValue);
		}else
		if(strcmp(mode,"AcceptanceLANPort") == 0)
		{		
		 	if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "vlan_acc_lan0", sValue) == 1 )
              	{
              		nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosAlltaggedMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
				
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosAlltaggedMode[i].str);
				}
			}
	 	}	else
		if(strcmp(mode,"AcceptancePCPort") == 0)		 	
		 {		
		 	if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "vlan_acc_pc0", sValue) == 1 )
              	{
              		nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosAlltaggedMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
				      {		
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
		
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosAlltaggedMode[i].str);
				}
			}
		 }else
		if(strcmp(mode,"LANPortEgressRules") == 0)		 			 	
		 {		
		 	if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "vlan_egr_lan0", sValue) == 1 )
       	       {
              		nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosSendTaggedorNoneMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
				
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosSendTaggedorNoneMode[i].str);
				}
			}
		 }else
		if(strcmp(mode,"PCPortEgressRules") == 0)		 			 			 	
		 {		
		 	if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "vlan_egr_pc0", sValue) == 1 )
              	{
              		nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosSendTaggedorNoneMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
				
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosSendTaggedorNoneMode[i].str);
				}
			}
	 	}else
		if(strcmp(mode,"IPPPortEgressRules") == 0)		 			 			 			 	
	 	{		
		 	if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "vlan_egr_ipp0", sValue) == 1 )
              	{
              		nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosSendTaggedorNoneMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
				
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosSendTaggedorNoneMode[i].str);
				}
			}
		}
	 }else
	if ( !gstrcmp(name, T("SwitchEnhancementVLAN")) )
	 {
	 	
	 	if(strcmp(mode,"EnablVLAN") == 0)		 			 			 			 	 		
	 	{
	 		if (ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", T("vlan_status"), sValue) == 1)
	 		{
				nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosYESNOMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
				
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosYESNOMode[i].str);
				}
	 		}
	 	}
		#if 0
		else	 
	 	if(strcmp(mode,"lan_eg_port") == 0)		 			 			 			 	 		
	 	{
	 		if (ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", T("lan_eg_port"), sValue) == 1)
	 		{
				nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosSendTaggedorNoneMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
				
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosSendTaggedorNoneMode[i].str);
				}
	 		}
	 	}else
	 	if(strcmp(mode,"pc_eg_port") == 0)		 			 			 			 	 		
	 	{
	 		if (ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", T("pc_eg_port"), sValue) == 1)
	 		{
				nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosSendTaggedorNoneMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
				
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosSendTaggedorNoneMode[i].str);
				}
	 		}
	 	}else
	 	if(strcmp(mode,"ipp_eg_port") == 0)		 			 			 			 	 		
	 	{
	 		if (ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", T("ipp_eg_port"), sValue) == 1)
	 		{
				nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosSendTaggedorNoneMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
				
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosSendTaggedorNoneMode[i].str);
				}
	 		}
	 	}
		#endif
		else
	 	if(strcmp(mode,"accept_lan_port") == 0)		 			 			 			 	 		
	 	{
	 		if (ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", T("accept_lan_port"), sValue) == 1)
	 		{
				nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosAlltaggedMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
				
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosAlltaggedMode[i].str);
				}
	 		}
	 	}else
	 	if(strcmp(mode,"lan_port_vid") == 0)
	      {		
		 	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", T("lan_port_vid"), sValue) == 0)
			{
				ifx_httpdError(wp, 200, "lan_port_vid is not found");
				return -1;	
			}
		
			ifx_httpdWrite(wp, T("%s"), sValue);
		}else
		if(strcmp(mode,"accept_pc_port") == 0)		 			 			 			 	 		
	 	{
	 		if (ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", T("accept_pc_port"), sValue) == 1)
	 		{
				nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosAlltaggedMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
				
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosAlltaggedMode[i].str);
				}
	 		}
	 	}else
	 	if(strcmp(mode,"pc_port_vid") == 0)
	      {		
		 	if (ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", T("pc_port_vid"), sValue) == 0)
			{
				ifx_httpdError(wp, 200, "pc_port_vid is not found");
				return -1;	
			}
		
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
		#if 0
		else
		if ( !gstrcmp(mode, T("EgressPortNo")) )
	 	{		
	 		if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "eg_port_no", sValue) == 1 ) //??
              	{
              		nSelIdx = gatoi(sValue);

				for (i = 0; i < sizeof(web_Enum_QosZero2TwoMode)/sizeof(CGI_ENUMSEL_S); i++)
				{
					// Get Selected option index from rc.conf
					if (i == nSelIdx)
					{
						gstrcpy (sValue, " SELECTED");
					}
					else 
					{
						gstrcpy (sValue, "");
					}
					
					ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosZero2TwoMode[i].str);
				}
			}
		 }	
		#endif
	}
	else
  	if ( !gstrcmp(name, T("VLANENTRY")) )
  	{
  		if(strcmp(mode,"VLANID") == 0)
  		{
	  		if (ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", T("vlan_id0"), sValue) == 0)
			{
				ifx_httpdError(wp, 200, "vlan_id0 is not found");
				return -1;	
			}
		
			ifx_httpdWrite(wp, T("%s"), sValue);  			
  		
  		}else
  		if(strcmp(mode,"AcceptanceLANPort") == 0)
  		{
	  		if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "vlan_acc_lan0", sValue) == 0 )
       	       {
              		ifx_httpdError(wp, 200, "vlan_egr_lan0 is not found");
				return -1;	
			}
		
			ifx_httpdWrite(wp, T("%s"), sValue);
  		}else
  		if(strcmp(mode,"AcceptancePCPort") == 0)
  		{
	  		if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "vlan_acc_pc0", sValue) == 0 )
       	       {
              		ifx_httpdError(wp, 200, "vlan_acc_pc0 is not found");
				return -1;	
			}
		
			ifx_httpdWrite(wp, T("%s"), sValue);  		
  		}else
  		if(strcmp(mode,"LANPortEgressRules") == 0)
  		{
	  		if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "vlan_egr_lan0", sValue) == 0 )
       	       {
              		ifx_httpdError(wp, 200, "vlan_egr_lan0 is not found");
				return -1;	
			}
		
			ifx_httpdWrite(wp, T("%s"), sValue);  		
  		}else
  		if(strcmp(mode,"PCPortEgressRules") == 0)
  		{
	  		if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "vlan_egr_pc0", sValue) == 0 )
       	       {
              		ifx_httpdError(wp, 200, "vlan_acc_pc0 is not found");
				return -1;	
			}
		
			ifx_httpdWrite(wp, T("%s"), sValue);  		
  		}else
  		if(strcmp(mode,"IPPPortEgressRules") == 0)
  		{
	  		if ( ifx_GetCfgData(FILE_RC_CONF, "vlan_setting", "vlan_egr_ipp0", sValue) == 0 )
       	       {
              		ifx_httpdError(wp, 200, "vlan_egr_ipp0 is not found");
				return -1;	
			}
		
			ifx_httpdWrite(wp, T("%s"), sValue);  		
  		}
  	}

	 return 0;
}



void ifx_set_Egress_Filtering_qos_setting(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pVLAN,*pAcceptanceLANPort,*pAcceptancePCPort, 
			*pLANPortEgressRules,*pPCPortEgressRules,*pIPPPortEgressRules,
			*pEnableVLAN,
			*pacceptlanport,*planportvid,*pacceptpcport,*ppcportvid;
	//,*pEgressPortNO,*pippegport,*ppcegport,*planegport,;

	char_t	sVLAN[MAX_DATA_LEN/2], sAcceptanceLANPort[MAX_DATA_LEN/2],sAcceptancePCPort[MAX_DATA_LEN/2],
		   	sLANPortEgressRules[MAX_DATA_LEN/2],sPCPortEgressRules[MAX_DATA_LEN/2],sIPPPortEgressRules[MAX_DATA_LEN/2],
		   	sEnableVLAN[MAX_DATA_LEN/2],
		   	sacceptlanport[MAX_DATA_LEN/2],slanportvid[MAX_DATA_LEN/2],sacceptpcport[MAX_DATA_LEN/2],spcportvid[MAX_DATA_LEN/2];
		   	//sEgressPortNO[MAX_DATA_LEN/2],sippegport[MAX_DATA_LEN/2],spcegport[MAX_DATA_LEN/2],slanegport[MAX_DATA_LEN/2],;

//	char_t	*pAdd = ifx_httpdGetVar(wp, T("addflag"), T(""));
	char_t	*pAdd = ifx_httpdGetVar(wp, T("vlanAdd1"), T(""));
	char_t	*pDel = ifx_httpdGetVar(wp, T("delflag"), T(""));
	int nIndex = 0, nCurNum = 0;    
		   
	
	// Get original data from file  
	nCurNum = websSetData2Table(wp, FILE_RC_CONF, TAG_VLAN, PREFIX_VLAN, VLANTable);

	
	if (nCurNum == -1)              
	{                               
		ifx_httpdError(wp, 200, "Insufficient data for VLAN table");
		return;                     
	}         
	 // Set to rc.conf file
	 // 1
	pVLAN = ifx_httpdGetVar(wp, T("VLANID"), T(""));
 	gsprintf(sVLAN, T("vlan_id0=\"%s\"\n"), pVLAN);	

	 // 2
	 pAcceptanceLANPort = ifx_httpdGetVar(wp, T("AcceptanceLANPort"), T(""));
	gsprintf(sAcceptanceLANPort, T("vlan_acc_lan0=\"%s\"\n"), pAcceptanceLANPort);

	 // 3
	 pAcceptancePCPort = ifx_httpdGetVar(wp, T("AcceptancePCPort"), T(""));	 
	gsprintf(sAcceptancePCPort, T("vlan_acc_pc0=\"%s\"\n"), pAcceptancePCPort);

	
	// 4
	 pLANPortEgressRules =  ifx_httpdGetVar(wp, T("LANPortEgressRules"), T(""));
	gsprintf(sLANPortEgressRules, T("vlan_egr_lan0=\"%s\"\n"), pLANPortEgressRules);

	 // 5
	pPCPortEgressRules =  ifx_httpdGetVar(wp, T("PCPortEgressRules"), T(""));
	gsprintf(sPCPortEgressRules, T("vlan_egr_pc0=\"%s\"\n"), pPCPortEgressRules);

	 // 6
	pIPPPortEgressRules =  ifx_httpdGetVar(wp, T("IPPPortEgressRules"), T(""));
	gsprintf(sIPPPortEgressRules, T("vlan_egr_ipp0=\"%s\"\n"), pIPPPortEgressRules);

	//7
	pEnableVLAN = ifx_httpdGetVar(wp,"EnablVLAN", T(""));
	gsprintf(sEnableVLAN, T("vlan_status=\"%s\"\n"), pEnableVLAN);

#if 0
       // 8
	planegport = ifx_httpdGetVar(wp,"lan_eg_port", T(""));
	gsprintf(slanegport, T("lan_eg_port=\"%s\"\n"), planegport);

	// 9
	ppcegport = ifx_httpdGetVar(wp,"pc_eg_port", T(""));
	gsprintf(spcegport, T("pc_eg_port=\"%s\"\n"), ppcegport);

	// 10
	pippegport = ifx_httpdGetVar(wp,"ipp_eg_port", T(""));
	gsprintf(sippegport, T("ipp_eg_port=\"%s\"\n"), pippegport);
#endif
      // 11
      pacceptlanport = ifx_httpdGetVar(wp,"accept_lan_port", T(""));
	gsprintf(sacceptlanport, T("accept_lan_port=\"%s\"\n"), pacceptlanport);

      // 12
      planportvid = ifx_httpdGetVar(wp,"lan_port_vid", T(""));
	gsprintf(slanportvid, T("lan_port_vid=\"%s\"\n"), planportvid);

      // 13
      pacceptpcport = ifx_httpdGetVar(wp,"accept_pc_port", T(""));
	gsprintf(sacceptpcport, T("accept_pc_port=\"%s\"\n"), pacceptpcport);

      // 14
      ppcportvid = ifx_httpdGetVar(wp,"pc_port_vid", T(""));
	gsprintf(spcportvid, T("pc_port_vid=\"%s\"\n"), ppcportvid);
#if 0
	//15
	pEgressPortNO = ifx_httpdGetVar(wp,"EgressPortNo",T(""));
	gsprintf(sEgressPortNO, T("eg_port_no=\"%s\"\n"), pEgressPortNO);	
#endif	
#if 0
	websSetCfgData(FILE_RC_CONF, "vlan_setting", 15,sEnableVLAN,sVLAN,sAcceptanceLANPort,sAcceptancePCPort,sLANPortEgressRules,sPCPortEgressRules,sIPPPortEgressRules,
												slanegport,spcegport,sippegport,sacceptlanport,slanportvid,sacceptpcport,spcportvid,sEgressPortNO);
#else
	websSetCfgData(FILE_RC_CONF, "vlan_setting", 11,sEnableVLAN,sVLAN,sAcceptanceLANPort,sAcceptancePCPort,sLANPortEgressRules,sPCPortEgressRules,sIPPPortEgressRules,
												sacceptlanport,slanportvid,sacceptpcport,spcportvid);
#endif

      ////////// Update Table to File ///////////////
	websUpdate_VLAN(nCurNum);
	// Submit data from press "Add" button
	if (pAdd[0])                    
	{                               
		char_t	*pVLAN0 = ifx_httpdGetVar(wp, T("VLANID"), T(""));			// Text
		char_t	*pAcceptanceLANPort0 = ifx_httpdGetVar(wp, T("AcceptanceLANPort"), T(""));			// Text
		char_t	*pAcceptancePCPort0 = ifx_httpdGetVar(wp, T("AcceptancePCPort"), T(""));			// Text
		char_t	*pLANPortEgressRules0 = ifx_httpdGetVar(wp, T("LANPortEgressRules"), T(""));			// Text
		char_t	*pPCPortEgressRules0 = ifx_httpdGetVar(wp, T("PCPortEgressRules"), T(""));			// Text
		char_t	*pIPPPortEgressRules0 = ifx_httpdGetVar(wp, T("IPPPortEgressRules"), T(""));			// Text		
		
		char_t	sAddEntry[MAX_FILELINE_LEN];
		uint	nState = 0;         
                                    
		gsprintf(sAddEntry, T("%s:%s:%s:%s:%s:%s"), pVLAN0, pAcceptanceLANPort0, pAcceptancePCPort0, 
											 pLANPortEgressRules0, pPCPortEgressRules0, pIPPPortEgressRules0);
                                    
                                    
		// Update table and system  
		for (nIndex=0; nIndex<=nCurNum; nIndex++)
		{                           
			// 1st, check duplicated
			// 2nd, check empty space
			// 3rd, Add to latest entry
			
			if (gstrncmp(VLANTable[nIndex].Data.sValue, sAddEntry, sizeof(sAddEntry)) == 0)
			{                       
				ifx_httpdError(wp, 200, "Duplicate VLAN address");
				return;             
			}                       
                                    
			if (VLANTable[nIndex].nIndex == 0 && !VLANTable[nIndex].Data.sValue[0])
			{                       
				VLANTable[nIndex].nIndex = nIndex;
				VLANTable[nIndex].nState = nState;
				gstrcpy(VLANTable[nIndex].Data.sValue, sAddEntry);
                                    
				nCurNum = nIndex+1; 
				break;              
			}                       
		}                           

		// No more space to add data
		if (nIndex > APPS_NUM_OF_ETHFTR_ENTRY)	
		{                           
			ifx_httpdError(wp, 200, T("Out of space to add static routing entry"));
			return;                 
		}                           
                                    
		////////// Update Table to File ///////////////
		websUpdate_VLAN(nCurNum);
	}                               
                                    
	// Submit data from press delete button
	if (!gstrcmp(pDel, T("1")))     
	{                               
		char_t	*pDelIndex = ifx_httpdGetVar(wp, T("delindex"), T(""));
		int		nDelIndex = gatoi(pDelIndex);
                                    
		// Remove DelIndex from Table
		for (nIndex=0; nIndex<nCurNum; nIndex++)
		{                           
			if (nIndex >= nDelIndex)
			{	                    
				VLANTable[nIndex].nIndex = VLANTable[nIndex+1].nIndex;
				VLANTable[nIndex].nState = VLANTable[nIndex+1].nState;				
				gstrcpy(VLANTable[nIndex].Data.sValue, VLANTable[nIndex+1].Data.sValue);
			}                       
		}                           
                                    
		////////// Update Table to File ///////////////
		websUpdate_VLAN(nCurNum-1);
	}                               
	// save setting
	#if 0
	if (ifx_web_Save_Setting()<=0)
	{
  		ifx_httpdError(wp, 200, "Fail to save Setting");
		return;
	}
	#else
	websChg2ExeMode(FILE_RC_CONF);	// chmod after update file
	system(SERVICE_RESTORE);
	#endif

	 system(SERVICE_QOS);
        ifx_httpdNextPage(wp);
}
