/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

CGI_TABLE_S STATICMACTable[APPS_NUM_OF_ETHFTR_ENTRY];

int websUpdate_STATICMAC(int nCount)
{
	char_t sBuf[BUF_SIZE_1K];
	int nIndex = 0;
	memset(sBuf, 0, BUF_SIZE_1K);
	gsprintf(sBuf, T("%sCount=\"%d\"\n"), PREFIX_STAICMACLAN, nCount);			
	
	for (nIndex=0; nIndex<nCount; nIndex++)
	{	
		char_t sLine[MAX_FILELINE_LEN];
		// Print following strings 
		// MAC_DENY_0="00:E0:18:E0:98:2E"
		// MAC_DENY_STAT0="0"
		gsprintf(sLine, T("%sSTAT%d=\"%d\"\n%s%d=\"%s\"\n"), PREFIX_STAICMACLAN, nIndex, STATICMACTable[nIndex].nState, PREFIX_STAICMACLAN, nIndex, STATICMACTable[nIndex].Data.sValue);

		//trace(8, sLine);
		gstrcat(sBuf, sLine);
	}

	return (websSetCfgData(FILE_RC_CONF, TAG_STAICMAC, 1, sBuf));
}


int ifx_get_switch_enhancement_qos_setting(int eid, httpd_t wp, int argc, char_t **argv)
{
	 int 	i,nSelIdx;
        char_t  *name,*mode, sValue[MAX_FILELINE_LEN];

        if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
        {
                ifx_httpdError(wp, 400, T("Insufficient args\n"));
                return -1;
        }

        memset(sValue, 0x00, MAX_FILELINE_LEN);
	 if ( !gstrcmp(name, T("MACAddress")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "filter_setting", T("filter_mac0"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "macaddress is not found");
			return -1;	
		}
		if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
		{
		    gstrcpy(sValue, "");
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }
	else
	if ( !gstrcmp(name, T("filter_port")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_ROUTE_DYNAMIC, "filter_port0", sValue) == 1)
		{
			if ( !gstrcmp(sValue, "1") )	//Enable
			{
				gstrcpy(sValue, "1");
			}
			else							//Disable
			{
				gstrcpy(sValue, "0");
			}
		}
		//ejSetResult(eid, sValue);
		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0){
			ifx_httpdWrite(wp,T("checked"));
		}else if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0){
			ifx_httpdWrite(wp,T("checked"));
		}
	}	
	 else
	 if ( !gstrcmp(name, T("CriticalTraffic")) )
	 {		
		if ( ifx_GetCfgData(FILE_RC_CONF, "filter_setting", "filter_crit0", sValue) == 1 ) //??
              {
              	nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosYESNOMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosYESNOMode[i].str);
			}
		}	 
	 }
	 else
  	if ( !gstrcmp(name, T("STAICHMACENTRY")) )
  	{
  		if(strcmp(mode,"MACAddress") == 0)
  		{
	  		if (ifx_GetCfgData(FILE_RC_CONF, "filter_setting", T("filter_mac0"), sValue) == 0)
			{
				ifx_httpdError(wp, 200, "macaddress is not found");
				return -1;	
			}
			if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
			{
			    gstrcpy(sValue, "");
			}
			ifx_httpdWrite(wp, T("%s"), sValue);		
  		
  		}
		if(strcmp(mode,"filter_port") == 0)
  		{
  			if (ifx_GetCfgData(FILE_RC_CONF, "filter_setting", T("filter_port0"), sValue) == 0)
			{
				ifx_httpdError(wp, 200, "filter_port0 is not found");
				return -1;	
			}
		
			#if 0
			ifx_httpdWrite(wp, T("%s"), sValue);
			#else			
				if(strcmp(sValue,"0") == 0)
					ifx_httpdWrite(wp, T("X"));
				else
					ifx_httpdWrite(wp, T(""));
			#endif
				
  		}else
		if(strcmp(mode,"filter_port2") == 0)
  		{
  			if (ifx_GetCfgData(FILE_RC_CONF, "filter_setting", T("filter_port0"), sValue) == 0)
			{
				ifx_httpdError(wp, 200, "filter_port0 is not found");
				return -1;	
			}

			#if 0
				ifx_httpdWrite(wp, T("%s"), sValue);
			#else			
				if(strcmp(sValue,"0") == 0)
					ifx_httpdWrite(wp, T(""));
				else
					ifx_httpdWrite(wp, T("X"));
			#endif
				
  		}
		else
  		if(strcmp(mode,"CriticalTraffic") == 0)
  		{
	  		if (ifx_GetCfgData(FILE_RC_CONF, "filter_setting", T("filter_crit0"), sValue) == 0)
			{
				ifx_httpdError(wp, 200, "critical_traffic is not found");
				return -1;	
			}
		
			#if 0
			ifx_httpdWrite(wp, T("%s"), sValue);  			
			#else			
				if(strcmp(sValue,"0") == 0)
					ifx_httpdWrite(wp, T(""));
				else
					ifx_httpdWrite(wp, T("X"));
			#endif  		
  		}
  	}

	 return 0;	 

}

void ifx_set_switch_enhancement_qos_setting(httpd_t wp, char_t *path, char_t *query)
{
	char_t  *pMACAddress,*pCriticalTraffic,*pfilter_port;
	char_t  sMACAddress[MAX_DATA_LEN],sCriticalTraffic[MAX_DATA_LEN],sfilter_port[MAX_DATA_LEN];

	char_t	*pAdd = ifx_httpdGetVar(wp, T("staicmactableAdd1"), T(""));
	char_t	*pDel = ifx_httpdGetVar(wp, T("delflag"), T(""));

	int nIndex = 0, nCurNum = 0;    

	// Get original data from file  
	nCurNum = websSetData2Table(wp, FILE_RC_CONF, TAG_STAICMAC, PREFIX_STAICMACLAN, STATICMACTable);
	// Set to rc.conf file
	 // 1
	pMACAddress = ifx_httpdGetVar(wp, T("MACAddress"), T(""));
 	gsprintf(sMACAddress, T("filter_mac0=\"%s\"\n"), pMACAddress);

	pfilter_port = ifx_httpdGetVar(wp, T("filter_port"), T(""));
	
	if ( !gstrcmp(pfilter_port, "1") )	//Enable
	{
		gsprintf(sfilter_port, T("filter_port0=\"1\"\n"));
	}else
	{
		gsprintf(sfilter_port, T("filter_port0=\"0\"\n"));
	}

	 // 3
	 pCriticalTraffic = ifx_httpdGetVar(wp, T("CriticalTraffic"), T(""));
	gsprintf(sCriticalTraffic, T("filter_crit0=\"%s\"\n"), pCriticalTraffic);


	websSetCfgData(FILE_RC_CONF, "filter_setting", 3, sMACAddress, sfilter_port,sCriticalTraffic);


	//websUpdate_STATICMAC(nCurNum);

	// Submit data from press "Add" button

	if (pAdd[0])                    
	{                               
		char_t	*pMAC0 = ifx_httpdGetVar(wp, T("MACAddress"), T(""));			// Text
		//char_t *pfilterportlan0 = ifx_httpdGetVar(wp, T("filter_port_lan0"), T(""));							     
		//char_t *pfilterportpc0 = ifx_httpdGetVar(wp, T("filter_port_pc0"), T(""));
		char_t *pfilterport0 = ifx_httpdGetVar(wp, T("filter_port"), T(""));

		char_t	*pCriTraffic0 = ifx_httpdGetVar(wp, T("CriticalTraffic"), T(""));			// Text
		
		char_t	sAddEntry[MAX_FILELINE_LEN];
		uint	nState = 0;         

		ifx_debug_printf("-----------&&&&&&---->>>");
	      if ( !gstrcmp(pfilterport0, "1") )
 	     {
			pfilterport0 = "1";
	     }else
	     {
	 		pfilterport0 = "0";
		}
		
                                    
		//gsprintf(sAddEntry, T("%s:%s:%s:%s:%s"), pMAC0, pfilterportlan0,pfilterportpc0,pfilterportipp0,pCriTraffic0);
		//gsprintf(sAddEntry, T("%s:%s:%s:%s"), pMAC0, pfilterportlan0,pfilterportpc0,pCriTraffic0);
		gsprintf(sAddEntry, T("%s:%s:%s"), pMAC0, pfilterport0,pCriTraffic0);
		// Update table and system  
		for (nIndex=0; nIndex<=nCurNum; nIndex++)
		{                           
			// 1st, check duplicated
			// 2nd, check empty space
			// 3rd, Add to latest entry
			if (gstrncmp(STATICMACTable[nIndex].Data.sValue, sAddEntry, sizeof(sAddEntry)) == 0)
			{                       
				ifx_httpdError(wp, 200, "Duplicate Static mac address");
				return;             
			}                       
                                    
			if (STATICMACTable[nIndex].nIndex == 0 && !STATICMACTable[nIndex].Data.sValue[0])
			{                       
				STATICMACTable[nIndex].nIndex = nIndex;
				STATICMACTable[nIndex].nState = nState;
				gstrcpy(STATICMACTable[nIndex].Data.sValue, sAddEntry);
                                    
				nCurNum = nIndex+1; 
				break;              
			}                       
		}                           
                                    
		// No more space to add data
		if (nIndex > APPS_NUM_OF_ETHFTR_ENTRY)	
		{                           
			ifx_httpdError(wp, 200, T("Out of space to add static routing entry"));
			return;                 
		}                           
                                    
		////////// Update Table to File ///////////////
		websUpdate_STATICMAC(nCurNum);
	}                               
                                    
	// Submit data from press delete button
	if (!gstrcmp(pDel, T("1")))     
	{                               
		char_t	*pDelIndex = ifx_httpdGetVar(wp, T("delindex"), T(""));
		int		nDelIndex = gatoi(pDelIndex);
                                    
		// Remove DelIndex from Table
		for (nIndex=0; nIndex<nCurNum; nIndex++)
		{                           
			if (nIndex >= nDelIndex)
			{	                    
				STATICMACTable[nIndex].nIndex = STATICMACTable[nIndex+1].nIndex;
				STATICMACTable[nIndex].nState = STATICMACTable[nIndex+1].nState;				
				gstrcpy(STATICMACTable[nIndex].Data.sValue, STATICMACTable[nIndex+1].Data.sValue);
			}                       
		}                           
                                    
		////////// Update Table to File ///////////////
		websUpdate_STATICMAC(nCurNum-1);
	}

	// save setting
	/*
	if (ifx_web_Save_Setting()<=0)
	{
  		ifx_httpdError(wp, 200, "Fail to save Setting");
		return;
	}*/
	websChg2ExeMode(FILE_RC_CONF);	// chmod after update file
	system(SERVICE_RESTORE);

	system(SERVICE_QOS);

	 ifx_httpdNextPage(wp);

}

