/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include "ifx_common_defs.h"
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>


int ifx_get_voip_sip_jitter(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	sValue[MAX_DATA_LEN];
	
	x_IFX_CM_Msg xCmMsg;
	int nSelIndex = 0, nIndex = 0;
	float	fValue = 0;
	
	
   	// Get Data from CM
   	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_JITTERBUFF;		
	xCmMsg.ucChannel = 0;
    
    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		ifx_httpdError(wp, 200, T("Fail to receive JITTER data from CM\n"));
		return -1;
	}
         
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}

 	memset(sValue, 0x00, MAX_DATA_LEN);
   	
   	if (!gstrcmp(name, T("type")))
   	{
		nSelIndex = xCmMsg.uxData.xJbConfig.ucType-1;
	
		for (nIndex=0; nIndex<sizeof(web_JitterBufSetting_Types)/sizeof(CGI_ENUMSEL_S); nIndex++)
		{	
			// Get Selected option index from rc.conf
			if (nIndex == nSelIndex)
				gstrcpy(sValue, "selected");
			else 
				gstrcpy(sValue, "");
			
			ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_JitterBufSetting_Types[nIndex].str);
		}
   	}	
   	else if (!gstrcmp(name, T("scal")))
   	{
   		fValue=(float)(((float)(unsigned char)xCmMsg.uxData.xJbConfig.ucScalingFactor)/16);
   		
   		memset(sValue, 0x00, MAX_DATA_LEN);
   		gsprintf(sValue, T("%.4f"), fValue);

   		ifx_httpdWrite(wp, "%s", sValue);
   	}  		
    else if (!gstrcmp(name, T("init")))
   	{
   		ifx_httpdWrite(wp, "%d", (xCmMsg.uxData.xJbConfig.unInitialSize)/8);
   	}  	
   	else if (!gstrcmp(name, T("mx")))
   	{
   		ifx_httpdWrite(wp, "%d", (xCmMsg.uxData.xJbConfig.unMaxSize)/8);   
   	}  	
   	else if (!gstrcmp(name, T("min")))
   	{
   		ifx_httpdWrite(wp, "%d", (xCmMsg.uxData.xJbConfig.unMinSize)/8);   
   	}  	   
   	
   		
	return 0;
}



void ifx_set_voip_sip_jitter(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pType = ifx_httpdGetVar(wp, T("type"), T(""));
	char_t	*pScal = ifx_httpdGetVar(wp, T("scal"), T(""));
	char_t	*pInit = ifx_httpdGetVar(wp, T("init"), T(""));
	char_t	*pMax = ifx_httpdGetVar(wp, T("mx"), T(""));
	char_t	*pMin= ifx_httpdGetVar(wp, T("min"), T(""));

	char_t  sIPAddr[MAX_FILELINE_LEN];
	x_IFX_CM_Msg xCmMsg;
			
	a_assert(wp);
	memset(sIPAddr, 0x00, MAX_FILELINE_LEN);

	//<< sharont02022005 mark
	/*// Spec. defined that 0 will be accepted by CM.
	if (pType== 0 || pScal == 0 || pInit == 0 || pMax == 0 || pMin == 0)
	{
		ifx_httpdError(wp, 200, T("Setup Error"));
		return;
	}*/
	//>> sharont02022005 mark

     if ((gatoi(pMax) < gatoi(pInit)) || (gatoi(pMin) > gatoi(pInit)))
     {
          ifx_httpdError(wp, 200, T("Initial value is not correct!"));
          return;
     }

     if (gatoi(pMax) < gatoi(pMin) )
     {
          ifx_httpdError(wp, 200, T("Maximum value should not be less than minimun value!"));
          return;
     }

	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_JITTERBUFF;
	xCmMsg.ucChannel = 0;
	xCmMsg.uxData.xJbConfig.ucType = atoi(pType)+1;
	
	// (atof(pScal) * 16) ==> left shift
	// (atof(pScal) * 16) + 0.5 ==> ex. instead 1.37 + 0.5 to 1
	//							==> ex. instead 1.87 + 0.5 to 2
 	xCmMsg.uxData.xJbConfig.ucScalingFactor = ((atof(pScal) * 16) + 0.5);
	xCmMsg.uxData.xJbConfig.unInitialSize = (atoi(pInit) * 8);
	xCmMsg.uxData.xJbConfig.unMaxSize = (atoi(pMax) * 8);
	xCmMsg.uxData.xJbConfig.unMinSize = (atoi(pMin) * 8);
	
    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
		ifx_httpdError(wp, 200, T("Fail to send Jitter data to CM"));
		return;
    }

	ifx_httpdNextPage(wp);
}


