/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_voip_sip_other(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name,*mode;
	char_t	sValue[MAX_DATA_LEN];
	x_IFX_CM_Msg xCmMsg;
	int nSelIndex = 0, nIndex = 0;

   	// Get Data from CM
   	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_OTHER;		
	xCmMsg.ucChannel = 0;    
    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		ifx_httpdError(wp, 200, T("Fail to receive OTHER data from CM\n"));
		return -1;
	}
    
	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}

 	memset(sValue, 0x00, MAX_DATA_LEN);  
 	
 	if (!gstrcmp(name, T("ptl")))
   	{
		if (xCmMsg.uxData.xOtherCfg.ucTransportType == IFX_CM_SIP_TRPROTO_UDP && !strcmp(mode, "1"))
		  	ifx_httpdWrite(wp,T("checked")); //ejSetResult(eid, "1");
		else if (xCmMsg.uxData.xOtherCfg.ucTransportType == IFX_CM_SIP_TRPROTO_TCP && !strcmp(mode, "2"))
			ifx_httpdWrite(wp,T("checked")); //ejSetResult(eid, "2");
   	}   		
   	else if (!gstrcmp(name, T("hdr")))
   	{
		nSelIndex = xCmMsg.uxData.xOtherCfg.bUseCompactHdrs;
	
		for (nIndex=0; nIndex<sizeof(web_Enum_Status)/sizeof(CGI_ENUMSEL_S); nIndex++)
		{	
			// Get Selected option index from rc.conf
			if (nIndex == nSelIndex)
				gstrcpy(sValue, "selected");
			else 
				gstrcpy(sValue, "");
			
			ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Enum_Status[nIndex].str);
		}
   	}   
   	else if (!gstrcmp(name, T("silence")))
   	{
		nSelIndex = xCmMsg.uxData.xOtherCfg.bSilenceSupp;
	
		for (nIndex=0; nIndex<sizeof(web_Enum_Status)/sizeof(CGI_ENUMSEL_S); nIndex++)
		{	
			// Get Selected option index from rc.conf
			if (nIndex == nSelIndex)
				gstrcpy(sValue, "selected");
			else 
				gstrcpy(sValue, "");
			
			ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Enum_Status[nIndex].str);
		}
   	}
   	else if (!gstrcmp(name, T("noise")))
   	{
		nSelIndex = xCmMsg.uxData.xOtherCfg.bComfortNoise;
	
		for (nIndex=0; nIndex<sizeof(web_Enum_Status)/sizeof(CGI_ENUMSEL_S); nIndex++)
		{	
			// Get Selected option index from rc.conf
			if (nIndex == nSelIndex)
				gstrcpy(sValue, "selected");
			else 
				gstrcpy(sValue, "");
			
			ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Enum_Status[nIndex].str);
		}
   	}
   	else if (!gstrcmp(name, T("echo")))
   	{
		nSelIndex = xCmMsg.uxData.xOtherCfg.bEchoSupp;
	
		for (nIndex=0; nIndex<sizeof(web_Enum_Status)/sizeof(CGI_ENUMSEL_S); nIndex++)
		{	
			// Get Selected option index from rc.conf
			if (nIndex == nSelIndex)
				gstrcpy(sValue, "selected");
			else 
				gstrcpy(sValue, "");
			
			ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Enum_Status[nIndex].str);
		}
   	}
   	else if (!gstrcmp(name, T("dtmf")))
   	{
		nSelIndex = xCmMsg.uxData.xOtherCfg.eDtmfType;
	
		for (nIndex=0; nIndex<sizeof(web_Dtmf_Types)/sizeof(CGI_ENUMSEL_S); nIndex++)
		{	
			// Get Selected option index from rc.conf
			if (nIndex == nSelIndex)
				gstrcpy(sValue, "selected");
			else 
				gstrcpy(sValue, "");
			
			ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Dtmf_Types[nIndex].str);
		}
   	}   	
    else if (!gstrcmp(name, T("payload")))
   	{
   		ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xOtherCfg.ucDtmfPayloadValue);   
   	}  	
    
	return 0;
}



void ifx_set_voip_sip_other(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pProtocol = ifx_httpdGetVar(wp, T("ptl"), T(""));
	char_t	*pHdr = ifx_httpdGetVar(wp, T("hdr"), T(""));	
	char_t	*pSilence = ifx_httpdGetVar(wp, T("silence"), T(""));	
	char_t	*pNoise = ifx_httpdGetVar(wp, T("noise"), T(""));	
	char_t	*pEcho = ifx_httpdGetVar(wp, T("echo"), T(""));
	char_t	*pDtmf = ifx_httpdGetVar(wp, T("dtmf"), T(""));	
	char_t	*pPayload = ifx_httpdGetVar(wp, T("payload"), T(""));
	char_t  sIPAddr[MAX_FILELINE_LEN];
	x_IFX_CM_Msg xCmMsg;
			
	a_assert(wp);
	memset(sIPAddr, 0x00, MAX_FILELINE_LEN);
	
	if (pProtocol == 0 || pHdr == 0 || pSilence == 0 || pNoise == 0 || pEcho ==0 ||
		pDtmf == 0 || pPayload == 0)
	{                               
		ifx_httpdError(wp, 200, T("Setup Error"));
		return;                     
	}   
	
	if (atoi(pHdr ) < IFX_CM_OFF  || atoi(pHdr ) > IFX_CM_ON)
	{                               
		ifx_httpdError(wp, 200, T("Use Compact Header Error"));
		return;                     
	} 	
	
	if (atoi(pSilence ) < IFX_CM_OFF  || atoi(pSilence) > IFX_CM_ON)
	{                               
		ifx_httpdError(wp, 200, T("Silence Error"));
		return;                     
	} 	

	if (atoi(pNoise) < IFX_CM_OFF  || atoi(pNoise) > IFX_CM_ON)
	{                               
		ifx_httpdError(wp, 200, T("Noise Error"));
		return;                     
	} 	


	if (atoi(pEcho) < IFX_CM_OFF  || atoi(pEcho) > IFX_CM_ON)
	{                               
		ifx_httpdError(wp, 200, T("Echo Error"));
		return;                     
	} 	
	
	if (atoi(pDtmf) <IFX_CM_SIP_DTMF_NONE || atoi(pDtmf) > IFX_CM_SIP_DTMF_BOTH)
	{                               
		ifx_httpdError(wp, 200, T("DTMF Error"));
		return;                     
	}
		
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));     
    	xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_OTHER;
	xCmMsg.ucChannel = 0;	
	xCmMsg.uxData.xOtherCfg.bUseCompactHdrs= atoi(pHdr);
	xCmMsg.uxData.xOtherCfg.bSilenceSupp= atoi(pSilence);
	xCmMsg.uxData.xOtherCfg.bComfortNoise= atoi(pNoise);
	xCmMsg.uxData.xOtherCfg.bEchoSupp= atoi(pEcho);
	xCmMsg.uxData.xOtherCfg.eDtmfType= atoi(pDtmf);
	xCmMsg.uxData.xOtherCfg.ucDtmfPayloadValue= atoi(pPayload);
	if (atoi(pPayload) == 0)
	{
	  xCmMsg.uxData.xOtherCfg.ucDtmfPayloadValue= 96;
	}
	
	if ( !gstrcmp(pProtocol, "1") )
	{
		xCmMsg.uxData.xOtherCfg.ucTransportType =IFX_CM_SIP_TRPROTO_UDP;
	}
	else
	{
		xCmMsg.uxData.xOtherCfg.ucTransportType= IFX_CM_SIP_TRPROTO_TCP;
	}

    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
		ifx_httpdError(wp, 200, T("Fail to send OTHER data to CM"));
		return;     	
    }
//	websSuccess(wp);	
	ifx_httpdNextPage(wp);
}

