/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

/*****************************************************************************
 *  Function Name   : ifx_get_voip_sip_phone
 *  Description     : This function is called voip_sip_phone.asp page
 *  Input Values    : 
 *  Output Values   :
 *
 *  Return Value    : 0  - Success
 *                    -1 - Failure
 *  Notes           :
 ****************************************************************************/

int ifx_get_voip_sip_phone(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	x_IFX_CM_Msg xCmMsg;
	int nSelIndex = 0, nForwardType=0;
#ifdef IIP
	int nIndex=0; 
	char_t   sValue[MAX_DATA_LEN];
#endif

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}
   	//Caller ID port 0 	
   	// Get Data from CM
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));  
   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CALLER_ID;
	xCmMsg.ucChannel=0;	
		
    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		ifx_httpdError(wp, 200, T("Fail to receive Caller ID data 0 from CM\n"));
		return -1;
	}   
   	if (!gstrcmp(name, T("callid0")))
   	{
   		nSelIndex = xCmMsg.uxData.xCallIdCfg.ucCallIdFlag;
		ifx_httpdWrite(wp,T("%d"), nSelIndex);
   	}
   	//Caller ID port 1 	
   	// Get Data from CM
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));  
   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CALLER_ID;
	xCmMsg.ucChannel=1;	
		
    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		ifx_httpdError(wp, 200, T("Fail to receive Caller ID data 0 from CM\n"));
		return -1;
	}

	
   	if (!gstrcmp(name, T("callid1")))
   	{
		nSelIndex = xCmMsg.uxData.xCallIdCfg.ucCallIdFlag;
		ifx_httpdWrite(wp,T("%d"), nSelIndex);
   	}
#ifdef ATA
	if (!gstrcmp(name, T("room")))
    {
		ifx_httpdWrite(wp,T("1"));
	}
		
	if (!gstrcmp(name, T("voice")))
	{
		ifx_httpdWrite(wp,T("1"));
	}

	if (!gstrcmp(name, T("ringmute0")))
	{
		ifx_httpdWrite(wp,T("1"));
	}
#endif //#ifdef ATA

#ifdef IIP    
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_APP_ROOM_CFG;
	xCmMsg.ucChannel = 0;

	if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
 		ifx_httpdError(wp, 200, T("Fail to receive ROOM CFG data from CM\n"));
 		return -1;
	}
	if (!gstrcmp(name, T("room")))
	{
		nSelIndex = xCmMsg.uxData.xVoiceVolCfg.eRoomType;
		ifx_httpdWrite(wp,T("%d"), nSelIndex);
	}

	if (!gstrcmp(name, T("voice")))
	{
		nSelIndex = xCmMsg.uxData.xVoiceVolCfg.eVoiceVol;
	//printf(" <GET FUNCTION> the value of evoiceVol is %d\n",nSelIndex);
		ifx_httpdWrite(wp,T("%d"), nSelIndex);
	}
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_APP_ETH_LED_CFG;
	xCmMsg.ucChannel = 0;

	if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
 		ifx_httpdError(wp, 200, T("Fail to receive Ethernet Led data from CM\n"));
 		return -1;
	}
	memset(sValue, 0x00, MAX_DATA_LEN);
		
  	if (!gstrcmp(name, T("EthLed")))
	{
	    nSelIndex = xCmMsg.uxData.xEthLedCfg.ucEthPcLed;
	    for (nIndex=0; nIndex<2; nIndex++)
	    {
          	if (nIndex == nSelIndex)
	        	gstrcpy(sValue, "selected");
          	else
				gstrcpy(sValue, "");
          	ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Enum_VAD[nIndex].str);
		}
       	
		ifx_httpdWrite(wp, T(" </select>  </td>  </tr>  <tr>  <td width=\"20%\" ><font class=\"subtitle\">Ethernet LAN LED:</font></td> <td width=\"80%\"> <select name=\"ethlan\" size=\"1\">"));
		nSelIndex = xCmMsg.uxData.xEthLedCfg.ucEthLanLed;
		for (nIndex=0; nIndex<2; nIndex++)
	    {
	        // Get Selected option index from rc.conf
			if (nIndex == nSelIndex)
	            gstrcpy(sValue, "selected");
	        else
	            gstrcpy(sValue, "");
        	ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), nIndex, sValue, web_Enum_VAD[nIndex].str);
		}
#endif

    // Get Data from CM
    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));  
    xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    xCmMsg.ucInfoType = IFX_CM_APP_CALL_CFG;	
    xCmMsg.ucChannel=0;/*port 1*/	
		
    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
	ifx_httpdError(wp, 200, T("Fail to receive IFX_CM_APP_CALL_CFG data 0 from CM\n"));
	return -1;
    }   
    
   if( xCmMsg.uxData.xCallCfg.xSipFwd.ucType & IFX_CM_SIP_FWD_UNCOND)
   {
      nForwardType=0;
   }
   else if(xCmMsg.uxData.xCallCfg.xSipFwd.ucType & IFX_CM_SIP_FWD_ONBUSY)
   {
      nForwardType=2;
   }
   else
   {
      nForwardType=1;
   }

   if (!gstrcmp(name, T("dnd0")))
   {
	nSelIndex = xCmMsg.uxData.xCallCfg.ucDndFlag;
        ifx_httpdWrite(wp,T("%d"), nSelIndex);
   }
   	
	/* Shweta */
#ifdef IIP
   	if (!gstrcmp(name, T("ringmute0")))
   	{
		nSelIndex = xCmMsg.uxData.xCallCfg.ucRingMuteFlag;
       	 ifx_httpdWrite(wp,T("%d"), nSelIndex);
    	}
#endif /*IIP*/

   	
   if (!gstrcmp(name, T("fwdType0")))
   {
       ifx_httpdWrite(wp,T("%d"), nForwardType);
   }
   
  if (nForwardType==0 ) //unconditional 
  {
   
   if (!gstrcmp(name, T("fwds0")))
   {
	     nSelIndex = (xCmMsg.uxData.xCallCfg.xSipFwd.ucType & IFX_CM_SIP_FWD_UNCOND) ? 1 :0;
        ifx_httpdWrite(wp,T("%d"), nSelIndex);
   }
   	  if (!gstrcmp(name, T("fwdaddr0")))
   	  {
		if (xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.eAddrType != 0)
        {
		   nSelIndex = xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.eAddrType-1;
		}
        ifx_httpdWrite(wp,T("%d"), nSelIndex);
      }
          
      if (!gstrcmp(name, T("FwdDname0")))
   	  {
   		 ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.szDisplayName);   
   	  }
  	
   	  if (!gstrcmp(name, T("FwdUname0")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.szUserName);   
   	  }
  	
   	  if (!gstrcmp(name, T("FwdCall0")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.cCalledAddr);   
   	  }
 
   	  if (!gstrcmp(name, T("FwdPort0")))
   	  {
           if (!xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.uiPort)
           {
   		   ifx_httpdWrite(wp,T("%d"), 5060);
           }
           else
           {
   	      ifx_httpdWrite(wp,T("%d"), xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.uiPort);   
           }
   	  }  	   
		  
	   if (!gstrcmp(name, T("ptl0")))
	   {
         ifx_httpdWrite(wp,T("%d"),xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.ucAddrProto);
	  }
			  
  }   	
  else if (nForwardType==2)//busy
  {
   	  
   if (!gstrcmp(name, T("fwds0")))
   {
	     nSelIndex = (xCmMsg.uxData.xCallCfg.xSipFwd.ucType & IFX_CM_SIP_FWD_ONBUSY) ? 1:0;
        ifx_httpdWrite(wp,T("%d"), nSelIndex);
   }
   	  if (!gstrcmp(name, T("fwdaddr0")))
   	  {
  		if (xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.eAddrType != 0)
      {
		   nSelIndex = xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.eAddrType-1;
		}
                ifx_httpdWrite(wp,T("%d"), nSelIndex);
   }   	  
 	  
   	  if (!gstrcmp(name, T("FwdDname0")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.szDisplayName);   
   	  }  	
 
   	  if (!gstrcmp(name, T("FwdUname0")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.szUserName);   
   	  }  	
 
   	  if (!gstrcmp(name, T("FwdCall0")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.cCalledAddr);   
   	  } 
 
   	  if (!gstrcmp(name, T("FwdPort0")))
   	  {
             if (!xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.uiPort)
             {
   		   ifx_httpdWrite(wp,T("%d"), 5060);
             }
             else
             {
   		   ifx_httpdWrite(wp,T("%d"), xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.uiPort);   
             }
         } 	  
       if (!gstrcmp(name, T("ptl0")))
       {
         ifx_httpdWrite(wp,T("%d"),xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.ucAddrProto);
       }

  }//busy   	
  else
  {
   	  
   if (!gstrcmp(name, T("fwds0")))
   {
	     nSelIndex = (xCmMsg.uxData.xCallCfg.xSipFwd.ucType & IFX_CM_SIP_FWD_NOANSW)? 1:0;
        ifx_httpdWrite(wp,T("%d"), nSelIndex); 
   }
   if (!gstrcmp(name, T("fwdaddr0")))
   {
  
  		if (xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.eAddrType != 0)
      {
		   nSelIndex = xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.eAddrType-1;
		}
      ifx_httpdWrite(wp,T("%d"), nSelIndex);

   }   	  
   	  if (!gstrcmp(name, T("FwdDname0")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.szDisplayName);   
   	  }  	
   	  if (!gstrcmp(name, T("FwdUname0")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.szUserName);   
   	  }  	
   	  if (!gstrcmp(name, T("FwdCall0")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.cCalledAddr);   
   	  } 
   	  if (!gstrcmp(name, T("FwdPort0")))
   	  {
             if (!xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.uiPort)
             {
   		       ifx_httpdWrite(wp,T("%d"), 5060);
             }
             else
             {
   		       ifx_httpdWrite(wp,T("%d"), xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.uiPort);   
             }
         } 	  
       if (!gstrcmp(name, T("ptl0")))
       {
         ifx_httpdWrite(wp,T("%d"),xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.ucAddrProto);
		 }
			 
  } // No ans	 
   		
    //IFX_CM_APP_CALL_CFG
    // Get Data from CM
    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));  
    xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    xCmMsg.ucInfoType = IFX_CM_APP_CALL_CFG;	
    xCmMsg.ucChannel=1;/*port 2*/	
		
    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
	ifx_httpdError(wp, 200, T("Fail to receive IFX_CM_APP_CALL_CFG data 0 from CM\n"));
	return -1;
    }   

   if( xCmMsg.uxData.xCallCfg.xSipFwd.ucType & IFX_CM_SIP_FWD_UNCOND)
   {
      nForwardType=0;
   }
   else if(xCmMsg.uxData.xCallCfg.xSipFwd.ucType & IFX_CM_SIP_FWD_ONBUSY)
   {
      nForwardType=2;
   }
   else
   {
      nForwardType=1;
   }
   if (!gstrcmp(name, T("dnd1")))
   {
	nSelIndex = xCmMsg.uxData.xCallCfg.ucDndFlag;
        ifx_httpdWrite(wp,T("%d"), nSelIndex);
   }
   	
   	
   if (!gstrcmp(name, T("fwdType1")))
   {
       ifx_httpdWrite(wp,T("%d"), nForwardType);
   }
   
  if (nForwardType==0 ) //unconditional 
  {
   
     if (!gstrcmp(name, T("fwds1")))
  {
        nSelIndex = (xCmMsg.uxData.xCallCfg.xSipFwd.ucType & IFX_CM_SIP_FWD_UNCOND)?1:0;
        ifx_httpdWrite(wp,T("%d"), nSelIndex);
     }
   	  if (!gstrcmp(name, T("fwdaddr1")))
   	  {
  
  		if (xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.eAddrType != 0)
      {
		   nSelIndex = xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.eAddrType-1;
		}
                ifx_httpdWrite(wp,T("%d"), nSelIndex);
      }
          
          if (!gstrcmp(name, T("FwdDname1")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.szDisplayName);   
   	  }
  	
   	  if (!gstrcmp(name, T("FwdUname1")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.szUserName);   
   	  }
  	
   	  if (!gstrcmp(name, T("FwdCall1")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.cCalledAddr);   
   	  }
 
   	  if (!gstrcmp(name, T("FwdPort1")))
   	  {
          if (!xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.uiPort)
           {
   		   ifx_httpdWrite(wp,T("%d"), 5060);
           }
           else
           {
   		   ifx_httpdWrite(wp,T("%d"), xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.uiPort);   
           }
   	  }  	   
       if (!gstrcmp(name, T("ptl1")))
       {
         ifx_httpdWrite(wp,T("%d"),xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.ucAddrProto);
      }				 
  }   	
  else if (nForwardType==2)//busy
  {

   if (!gstrcmp(name, T("fwds1")))
   {
	     nSelIndex = (xCmMsg.uxData.xCallCfg.xSipFwd.ucType & IFX_CM_SIP_FWD_ONBUSY)? 1:0;
        ifx_httpdWrite(wp,T("%d"), nSelIndex);
   }
   	  if (!gstrcmp(name, T("fwdaddr1")))
   	  {
   	
  		if (xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.eAddrType != 0)
      {
		   nSelIndex = xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.eAddrType-1;
		}
        ifx_httpdWrite(wp,T("%d"), nSelIndex);

   	  }   	  
   	  if (!gstrcmp(name, T("FwdDname1")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.szDisplayName);   
   	  }  	
   	  if (!gstrcmp(name, T("FwdUname1")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.szUserName);   
   	  }  	
   	  if (!gstrcmp(name, T("FwdCall1")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.cCalledAddr);   
   	  } 
   	  if (!gstrcmp(name, T("FwdPort1")))
   	  {
             if (!xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.uiPort)
             {
   		   ifx_httpdWrite(wp,T("%d"), 5060);
             }
             else
             {
   		   ifx_httpdWrite(wp,T("%d"), xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.uiPort);   
             }
         } 	  
	    if (!gstrcmp(name, T("ptl1")))
		 {
		     ifx_httpdWrite(wp,T("%d"),xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.ucAddrProto);
		}					 
  }//busy   	
  else
  {
   		
   if (!gstrcmp(name, T("fwds1")))
   {
	     nSelIndex = (xCmMsg.uxData.xCallCfg.xSipFwd.ucType & IFX_CM_SIP_FWD_NOANSW)?1:0;
        ifx_httpdWrite(wp,T("%d"), nSelIndex);
   }
   if (!gstrcmp(name, T("fwdaddr1")))
   {
  
  		if (xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.eAddrType != 0)
      {
		   nSelIndex = xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.eAddrType-1;
	}
       ifx_httpdWrite(wp,T("%d"), nSelIndex);

    }   	  
   	  if (!gstrcmp(name, T("FwdDname1")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.szDisplayName);   
   	  }  	
   	  if (!gstrcmp(name, T("FwdUname1")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.szUserName);   
   	  }  	
   	  if (!gstrcmp(name, T("FwdCall1")))
   	  {
   		ifx_httpdWrite(wp, xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.cCalledAddr);   
   	  } 
   	  if (!gstrcmp(name, T("FwdPort1")))
   	  {
             if (!xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.uiPort)
             {
   		   ifx_httpdWrite(wp,T("%d"), 5060);
             }
             else
             {
   		   ifx_httpdWrite(wp,T("%d"), xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.uiPort);   
             }
         } 	  
	    if (!gstrcmp(name, T("ptl1")))
		 {
		     ifx_httpdWrite(wp,T("%d"),xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.ucAddrProto);
		}					 
  }
   		
	return 0;
}


void ifx_set_voip_sip_phone(httpd_t wp, char_t *path, char_t *query)
{
//	char_t	*pType  = ifx_httpdGetVar(wp, T("type"), T(""));
//	char_t	*pAddress = ifx_httpdGetVar(wp, T("address"), T(""));
//	char_t	*pHold = ifx_httpdGetVar(wp, T("hold"), T(""));	
#ifdef ATA	
	char_t	*pPort  = ifx_httpdGetVar(wp, T("port"), T(""));	
#endif        
	char_t	*pCallid  = ifx_httpdGetVar(wp, T("callid"), T(""));	
	char_t	*pDnd   = ifx_httpdGetVar(wp, T("dnd"), T(""));	
	/* Shweta */
#ifdef IIP	
	char_t  *pethpc = ifx_httpdGetVar(wp, T("ethpc"), T(""));	
    char_t  *pethlan = ifx_httpdGetVar(wp, T("ethlan"), T(""));	
	char_t	*pRingMute = ifx_httpdGetVar(wp, T("ringmute"), T(""));	
#endif	
	char_t	*pFwdStatus = ifx_httpdGetVar(wp, T("fwdStatus"), T(""));
	char_t	*pFwd  = ifx_httpdGetVar(wp, T("fwd"), T(""));
	char_t	*pAddtype = ifx_httpdGetVar(wp, T("addtype"), T(""));
	char_t	*pDname = ifx_httpdGetVar(wp, T("dname"), T(""));	
	char_t	*pUname  = ifx_httpdGetVar(wp, T("uname"), T(""));	
	char_t	*pCalladdr = ifx_httpdGetVar(wp, T("calladdr"), T(""));	
	char_t	*pPortNo = ifx_httpdGetVar(wp, T("portNo"), T(""));		
	char_t   *pProtocol = ifx_httpdGetVar(wp, T("ptl"), T(""));
#ifdef IIP	
   char_t   *pRoom     = ifx_httpdGetVar(wp,T("room"),T(""));
   char_t   *pVoice    = ifx_httpdGetVar(wp,T("voice"),T(""));
#endif   
	x_IFX_CM_Msg xCmMsg;
	
	a_assert(wp);	
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
     //set IFX_CM_SIP_CALLER_ID info then   
    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));  
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_SIP_CALLER_ID;

#ifdef ATA 
    xCmMsg.ucChannel = atoi(pPort);    
#endif
#ifdef IIP
  xCmMsg.ucChannel = 0;
#endif //#ifdef IIP

    xCmMsg.uxData.xCallIdCfg.ucCallIdFlag=atoi(pCallid); 
    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
    	if (connection.allowed == 1)
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		else
		{
		ifx_httpdError(wp, 200, T("Fail to send CALLER_ID data to CM"));
		}
		return;     	
    }

#ifdef IIP
	      //set IFX_CM_APP_ETH_LED_CFG info then
    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	 xCmMsg.ucInfoType = IFX_CM_APP_ETH_LED_CFG;
	 xCmMsg.ucChannel = 0;
	 xCmMsg.uxData.xEthLedCfg.ucEthPcLed=atoi(pethpc);
	 xCmMsg.uxData.xEthLedCfg.ucEthLanLed=atoi(pethlan);

	 if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
	 {
	      ifx_httpdError(wp, 200, T("Fail to send CALLER_ID data to CM"));
	      return;
	 }

    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_APP_ROOM_CFG;
    xCmMsg.ucChannel = 0;
    xCmMsg.uxData.xVoiceVolCfg.eRoomType=atoi(pRoom);
    xCmMsg.uxData.xVoiceVolCfg.eVoiceVol=atoi(pVoice);

    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
         ifx_httpdError(wp, 200, T("Fail to send Voice data to CM"));
         return;
    }

#endif


	 //set IFX_CM_SIP_CALL_CFG info then
	if (atoi(pFwdStatus) == 1)	// Check port when status is ON
	{
		if (atoi(pPortNo) !=0)
		{
		if (atoi(pPortNo) > 32768 || atoi(pPortNo) < 1024)
		{                               
			ifx_httpdError(wp, 200, T("Port number Error"));
			return;                     
		}
	}
	}
       
    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));  
    
    /* get data from CM and then set it selectivley*/    
    xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    xCmMsg.ucInfoType = IFX_CM_APP_CALL_CFG;
#ifdef ATA    
    xCmMsg.ucChannel =  atoi(pPort);
#endif
#ifdef IIP
    xCmMsg.ucChannel =0;
#endif
    
    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
      ifx_httpdError(wp, 200, T("Fail to receive IFX_CM_APP_CALL_CFG data 0 from CM\n"));
      return ;
    }
    
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_APP_CALL_CFG;

#ifdef ATA
    xCmMsg.ucChannel =  atoi(pPort);
#endif
#ifdef IIP
    xCmMsg.ucChannel =0;
#endif //#ifdef IIP

    xCmMsg.uxData.xCallCfg.ucDndFlag=atoi(pDnd);
	
/* Shweta */	 
#ifdef IIP
    xCmMsg.uxData.xCallCfg.ucRingMuteFlag = atoi(pRingMute);
#endif
    /* A validatation check for IP address */
    if ((atoi(pAddtype)+1 == IFX_CM_SIP_IP_ADDR) && (atoi(pFwdStatus)==1) )
    {
        if ( IFX_ValidateIpAddress(pCalladdr) < 0)
        {
             ifx_httpdError(wp, 200, T("Invalid IP address!!!"));
              return;
        }
    }

	 //printf(" THE FWD TYPE IS %d\n",atoi(pFwd));
    if (atoi(pFwd)==0)
    {
      if (atoi(pFwdStatus)==1)
      {
         xCmMsg.uxData.xCallCfg.xSipFwd.ucType |= IFX_CM_SIP_FWD_UNCOND;
      }
      else
      {
         xCmMsg.uxData.xCallCfg.xSipFwd.ucType &= ~IFX_CM_SIP_FWD_UNCOND;
      }

    	xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.eAddrType=atoi(pAddtype)+1;
    	strcpy(xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.szDisplayName,pDname);
    	strcpy(xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.szUserName,pUname);
    	strcpy(xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.cCalledAddr,pCalladdr);
    	xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.uiPort=atoi(pPortNo);
 	   if ( !gstrcmp(pProtocol, "1") )
		{
		   xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.ucAddrProto =IFX_CM_SIP_TRPROTO_UDP;
		}
		else if (!gstrcmp(pProtocol, "2") )
		{
		   xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.ucAddrProto = IFX_CM_SIP_TRPROTO_TCP;
      }
      else
         xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrUncon.ucAddrProto = IFX_CM_SIP_TRPROTO_NONE;
    }
    else if (atoi(pFwd)==2)	// Busy
    {
      if (atoi(pFwdStatus)==1)
    {
          xCmMsg.uxData.xCallCfg.xSipFwd.ucType |= IFX_CM_SIP_FWD_ONBUSY;
      }
      else
      {
          xCmMsg.uxData.xCallCfg.xSipFwd.ucType &= ~IFX_CM_SIP_FWD_ONBUSY;
      }
    	xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.eAddrType=atoi(pAddtype)+1;
    	strcpy(xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.szDisplayName,pDname);
    	strcpy(xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.szUserName,pUname);
    	strcpy(xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.cCalledAddr,pCalladdr);
    	xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.uiPort=atoi(pPortNo);
      if ( !gstrcmp(pProtocol, "1") )
      {
        xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.ucAddrProto =IFX_CM_SIP_TRPROTO_UDP;
      }
      else if (!gstrcmp(pProtocol, "2") )
      {
        xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.ucAddrProto = IFX_CM_SIP_TRPROTO_TCP;
      }
      else
        xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrBusy.ucAddrProto = IFX_CM_SIP_TRPROTO_NONE;
								
    }
	 else
	 {

      if (atoi(pFwdStatus)==1)
      {
          xCmMsg.uxData.xCallCfg.xSipFwd.ucType |= IFX_CM_SIP_FWD_NOANSW;
      }
      else
      {
          xCmMsg.uxData.xCallCfg.xSipFwd.ucType &= ~IFX_CM_SIP_FWD_NOANSW;
      }
    	xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.eAddrType=atoi(pAddtype)+1;
    	strcpy(xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.szDisplayName,pDname);
    	strcpy(xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.szUserName,pUname);
    	strcpy(xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.cCalledAddr,pCalladdr);
    	xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.uiPort=atoi(pPortNo);
      if ( !gstrcmp(pProtocol, "1") )
      {
        xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.ucAddrProto =IFX_CM_SIP_TRPROTO_UDP;
      }
      else if (!gstrcmp(pProtocol, "2") )
      {
        xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.ucAddrProto = IFX_CM_SIP_TRPROTO_TCP;
      }
      else
        xCmMsg.uxData.xCallCfg.xSipFwd.xFwdAddrNoAns.ucAddrProto = IFX_CM_SIP_TRPROTO_NONE;
	 }
    
    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
		ifx_httpdError(wp, 200, T("Fail to send CALL_CFG data to CM"));
		return;     	
    }
//	websSuccess(wp);	
	ifx_httpdNextPage(wp);
}

