/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>


int ifx_get_voip_sip_registrar(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name,*mode;
	char_t	sValue[MAX_DATA_LEN];
	int nSelIndex = 0, nIndex = 0;
	x_IFX_CM_Msg xCmMsg;
	
	
   	// Get Data from CM
   	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_REGISTRAR;		
	xCmMsg.ucChannel = 0;

    
	if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		ifx_httpdError(wp, 200, T("Fail to receive REGISTRAR data from CM\n"));
		return -1;
	}
         
	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}

 	memset(sValue, 0x00, MAX_DATA_LEN);  	
        if (!gstrcmp(name, T("rstatus")))
        {
                nSelIndex = xCmMsg.uxData.xRegCfg.ucFlag;

                for (nIndex=0; nIndex<sizeof(web_Enum_Status)/sizeof(CGI_ENUMSEL_S); nIndex++)
                {
                        // Get Selected option index from rc.conf
                        if (nIndex == nSelIndex)
                                gstrcpy(sValue, "selected");
                        else
                                gstrcpy(sValue, "");

                        ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), web_Enum_Status[nIndex].value, sValue, web_Enum_Status[nIndex].str);
                }
        }	

    if (!gstrcmp(name, T("IP1")))
   	{
   		ifx_httpdWrite(wp, T("%s"), xCmMsg.uxData.xRegCfg.cRegistrar);   
   	}
    else if (!gstrcmp(name, T("port")))
   	{
   		ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xRegCfg.unRegPort);   
   	}  	
    else if (!gstrcmp(name, T("ptl")))
   	{
		if (xCmMsg.uxData.xRegCfg.uiRegProtocol == IFX_CM_SIP_TRPROTO_UDP && !strcmp(mode, "1"))
		  	ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "1");
		else if (xCmMsg.uxData.xRegCfg.uiRegProtocol== IFX_CM_SIP_TRPROTO_TCP  && !strcmp(mode, "2"))
		  	ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "2");
		else if ( xCmMsg.uxData.xRegCfg.uiRegProtocol == IFX_CM_SIP_TRPROTO_NONE && !strcmp(mode, "0"))
			ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "0");
   	}   
   	else if (!gstrcmp(name, T("time")))
   	{
		ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xRegCfg.iRegExpirationTime); 
   	}  
   		
	return 0;
}


void ifx_set_voip_sip_registrar(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pIP1 = ifx_httpdGetVar(wp, T("IP1"), T(""));
	char_t	*pPort = ifx_httpdGetVar(wp, T("port"), T(""));	
	char_t	*pProtocol = ifx_httpdGetVar(wp, T("ptl"), T(""));
	char_t	*pExpTime= ifx_httpdGetVar(wp, T("time"), T(""));	
        char_t  *pStatus = ifx_httpdGetVar(wp, T("rstatus"), T(""));
	char_t  sIPAddr[MAX_FILELINE_LEN];
	x_IFX_CM_Msg xCmMsg;
				
	a_assert(wp);
	memset(sIPAddr, 0x00, MAX_FILELINE_LEN);
         
	if (pIP1 == 0 ||
		pPort == 0 ||pExpTime==0 ||pProtocol == 0)
	{                               
		ifx_httpdError(wp, 200, T("Setup Error"));
		return;                     
        }
        if (atoi(pStatus) > IFX_CM_ON  || atoi(pStatus) < IFX_CM_OFF)
        {
                ifx_httpdError(wp, 200, T("Registrar Status Error"));
                return;
        }	
	
        if (atoi(pStatus) == IFX_CM_ON)
        {
	   if (atoi(pPort) !=0)
		{
	   if (atoi(pPort) > 32768 || atoi(pPort) < 1024)
	   {                               
	      ifx_httpdError(wp, 200, T("Port number Error"));
	      return;                     
	   }
		}
	   
	   if (atoi(pExpTime) > 32768 || atoi(pExpTime) < 0)
	   {                               
		   ifx_httpdError(wp, 200, T("Expiration Time Error"));
		   return;                     
	   }
           memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
		   /*
      xCmMsg.uxData.xRegCfg.eAuthMethod = atoi(pMethod);
      */
 	   strcpy(xCmMsg.uxData.xRegCfg.cRegistrar,pIP1); 		
	   xCmMsg.uxData.xRegCfg.unRegPort = atoi(pPort);
	
	   if ( !gstrcmp(pProtocol, "1") )
	   {
		xCmMsg.uxData.xRegCfg.uiRegProtocol =IFX_CM_SIP_TRPROTO_UDP;
	   }
	   else if (!gstrcmp(pProtocol, "2") )
	   {
		xCmMsg.uxData.xRegCfg.uiRegProtocol = IFX_CM_SIP_TRPROTO_TCP;

	   }	
		else
		   xCmMsg.uxData.xRegCfg.uiRegProtocol = IFX_CM_SIP_TRPROTO_NONE;
		
	
	   xCmMsg.uxData.xRegCfg.iRegExpirationTime=atoi(pExpTime);
       }
       else
       {    /* IF REGISTAR OFF */

           memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
            xCmMsg.ucMsgType = IFX_CM_GET_REQ;
            xCmMsg.ucInfoType = IFX_CM_SIP_CFG_REGISTRAR;
            xCmMsg.ucChannel = 0;  /* For port 1*/

            // Get original data from CM
            if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
            {
                        ifx_httpdError(wp, 200, T("Fail to get PROXY data to CM"));
                        return;
            }
	         //xCmMsg.uxData.xRegCfg.iRegExpirationTime=3600;

       }

       xCmMsg.ucMsgType = IFX_CM_SET_REQ;
       xCmMsg.ucInfoType = IFX_CM_SIP_CFG_REGISTRAR;
       xCmMsg.ucChannel = 0;
       xCmMsg.uxData.xRegCfg.ucFlag = atoi(pStatus);
       if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
       {
       	if (connection.allowed == 1)
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		else
		{
  	        ifx_httpdError(wp, 200, T("Fail to send REGISTRAR data to CM"));
	  	}
	  return;     	
       }

//	websSuccess(wp);	
	ifx_httpdNextPage(wp);
}
	
