/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include "ifx_common_defs.h"
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_voip_sip_teluri(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	sValue[MAX_DATA_LEN];
	x_IFX_CM_Msg xCmMsg;
	
   	// Get Data from CM
   	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_TELURI;
	xCmMsg.ucChannel=0;		

    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		ifx_httpdError(wp, 200, T("Fail to receive TELURI data from CM\n"));
		return -1;
	}
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}

 	memset(sValue, 0x00, MAX_DATA_LEN);  	

   	if (!gstrcmp(name, T("country")))
   	{
   		ifx_httpdWrite(wp, xCmMsg.uxData.xTelUriCfg.acCountryCode);  
   	}  		
    else if (!gstrcmp(name, T("authInt")))
   	{
    		
   		ifx_httpdWrite(wp, xCmMsg.uxData.xTelUriCfg.acIntAccPref);   
   	}  	
   	else if (!gstrcmp(name, T("local")))
   	{
   		ifx_httpdWrite(wp, xCmMsg.uxData.xTelUriCfg.acLocAreaCode);   
   	}  	
   	else if (!gstrcmp(name, T("authlocal")))
   	{
   		ifx_httpdWrite(wp, xCmMsg.uxData.xTelUriCfg.acLongDistCallPref);   
   	}  
   		
	return 0;
}

void ifx_set_voip_sip_teluri(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pPortChg  = ifx_httpdGetVar(wp, T("pPortChg"), T(""));
	char_t	*pPort     = ifx_httpdGetVar(wp, T("port"), T(""));
	char_t	*pCountry = ifx_httpdGetVar(wp, T("country"), T(""));	
	char_t	*pAuthint  = ifx_httpdGetVar(wp, T("authInt"), T(""));	
	char_t	*pLocal   = ifx_httpdGetVar(wp, T("local"), T(""));	
	char_t	*pAuthlocal = ifx_httpdGetVar(wp, T("authlocal"), T(""));
	
	x_IFX_CM_Msg xCmMsg;
	
				
	a_assert(wp);
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	if ( pPortChg==0 || pPort== 0 || pCountry == 0 || pAuthint == 0 || pLocal == 0 || pAuthlocal == 0)
	{                               
		ifx_httpdError(wp, 200, T("Setup Error"));
		return;                     
	}
	
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));     
    	xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_TELURI;
	xCmMsg.ucChannel=atoi(pPort);

	strcpy(xCmMsg.uxData.xTelUriCfg.acCountryCode, pCountry);
	strcpy(xCmMsg.uxData.xTelUriCfg.acIntAccPref, pAuthint);
	strcpy(xCmMsg.uxData.xTelUriCfg.acLocAreaCode, pLocal);
	strcpy(xCmMsg.uxData.xTelUriCfg.acLongDistCallPref, pAuthlocal);
	
    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
    	if (connection.allowed == 1)
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		else
		{
		ifx_httpdError(wp, 200, T("Fail to send TELURI data to CM"));
		}
		return;     	
    }
//	websSuccess(wp);	
	ifx_httpdNextPage(wp);
}

