/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"
#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_wan_main(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;

	if (ejArgs(argc, argv, T("%s%s%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}	
	
	if (!gstrcmp(name, T("wanmainsubnmit")))
	{
#ifndef IIP
		ifx_httpdWrite(wp,"<tr>");
		ifx_httpdWrite(wp,"<table width=\"80%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">");
		ifx_httpdWrite(wp,"<tr>");
		ifx_httpdWrite(wp,"<td>");
		ifx_httpdWrite(wp,"<div align=\"right\">");
		ifx_httpdWrite(wp,"<a href=\"javascript:void(0);\" onClick=\"window.open('help.htm#wan', 'help', 'toolbar=0,status=0,menubar=0,scrollbars=1,resizable=1,width=530,height=400,left=150,top=150');\"><img src=\"images/help.gif\" width=\"57\" height=\"57\" border=\"0\"></a>");
		ifx_httpdWrite(wp,"<a href=\"javascript:document.forms[0].submit()\" onClick=\"return evaltF();\"><img src=\"images/apply1.gif\" width=\"56\" height=\"57\" border=\"0\"></a>");
		ifx_httpdWrite(wp,"<a href=\"javascript:document.tF0.reset()\"><img src=\"images/cancel.gif\" alt=\"\" border=\"0\" width=\"56\" height=\"57\" ></a>");
		ifx_httpdWrite(wp,"</div>");
		ifx_httpdWrite(wp,"</td>");
		ifx_httpdWrite(wp,"</tr>");
		ifx_httpdWrite(wp,"</table>");
		ifx_httpdWrite(wp,"</td>");
		ifx_httpdWrite(wp,"</tr>");
#endif //#ifdef IIP
	}else
	if (!gstrcmp(name, T("wanmain")))
	{
#ifdef IIP
			ifx_httpdWrite(wp,"<p><font class=\"title\"><b>LAN</b></font><br><br>");
			ifx_httpdWrite(wp,"<font class=\"subtitle\">");			
			ifx_httpdWrite(wp,"The INCA-IP LAN Phone can be connected to LAN  thru Static Configuration for the Network.");
			ifx_httpdWrite(wp,"</font></p>");
#else //#ifdef IIP
			ifx_httpdWrite(wp,"<p><font class=\"title\"><b>WAN</b></font><br><br>");
			ifx_httpdWrite(wp,"<font class=\"subtitle\">");
			ifx_httpdWrite(wp,"The Device can be connected to your service provider in any of the following ways:");
			ifx_httpdWrite(wp,"</font></p>");
			ifx_httpdWrite(wp,"<table border=0 cellspacing=1 cellpadding=5 width=\"90%\">");
			ifx_httpdWrite(wp,"<tr align=left bgcolor>");
			ifx_httpdWrite(wp,"<td  width=\"4%\">");			
			ifx_httpdWrite(wp,"<input name=\"WT\" type=\"radio\" value=\"1\"");

			if(websGetWanMode() == 1)
			{
				ifx_httpdWrite(wp,"checked"); 
			}
			else
			{
				ifx_httpdWrite(wp,"");
			}

			ifx_httpdWrite(wp,">");
			ifx_httpdWrite(wp,"</td>");
			ifx_httpdWrite(wp,"<td  width=\"20%\"><font class=\"subtitle\">Dynamic IP Address</font></td>");
			ifx_httpdWrite(wp,"<td  width=\"56%\"><font class=\"subtitle\">");
			ifx_httpdWrite(wp,"Obtain an IP address automatically from your service provider.</font>");
			ifx_httpdWrite(wp,"</td>");
			ifx_httpdWrite(wp,"</tr>");
			ifx_httpdWrite(wp,"<tr align=left>");
			ifx_httpdWrite(wp,"<td  width=\"4%\">");
			ifx_httpdWrite(wp,"<input name=\"WT\" type=\"radio\" value=\"2\"");
			
			if(websGetWanMode() == 2)
			{
				ifx_httpdWrite(wp,"checked");
			}
			else
			{
				ifx_httpdWrite(wp,"");
			}
			ifx_httpdWrite(wp,">");
			ifx_httpdWrite(wp,"</td>");
			ifx_httpdWrite(wp,"<td width=\"20%\"><font class=\"subtitle\">Static IP Address</font></td>");
			ifx_httpdWrite(wp,"<td width=\"56%\"><font class=\"subtitle\">");
			ifx_httpdWrite(wp,"Uses a static IP address. Your service provider gives a static IP address to access Internet services.</font>");
			ifx_httpdWrite(wp,"</td>");
			ifx_httpdWrite(wp,"</tr>");
			ifx_httpdWrite(wp,"<tr align=left> ");
			ifx_httpdWrite(wp,"<td width=\"4%\">");
			ifx_httpdWrite(wp,"<input name=\"WT\" type=\"radio\" value=\"3\"");

			if(websGetWanMode() == 3)
			{
				ifx_httpdWrite(wp,"checked"); 
			}
			else
			{
				ifx_httpdWrite(wp,"");			
			}
			ifx_httpdWrite(wp,">");
			ifx_httpdWrite(wp,"</td>");
			ifx_httpdWrite(wp,"<td width=\"20%\"><font class=\"subtitle\">PPPoE</font></td>");
			ifx_httpdWrite(wp,"<td width=\"56%\"><font class=\"subtitle\">");
			ifx_httpdWrite(wp,"PPP over Ethernet is a common connection method used for xDSL</font>");
			ifx_httpdWrite(wp,"</td>");
			ifx_httpdWrite(wp,"</tr>");
#ifdef CONFIG_CGI_WAN_PPTP
			ifx_httpdWrite(wp,"<tr align=left>");
			ifx_httpdWrite(wp,"<td width=\"4%\">");
			ifx_httpdWrite(wp,"<input name=\"WT\" type=\"radio\" value=\"4\"");

			if(websGetWanMode() == 4)
			{
				ifx_httpdWrite(wp,"checked"); 
			}
			else
			{
				ifx_httpdWrite(wp,"");		
			}
			ifx_httpdWrite(wp,">");
			ifx_httpdWrite(wp,"</td>");
			ifx_httpdWrite(wp,"<td width=\"20%\"><font class=\"subtitle\">PPTP</font></td>");
			ifx_httpdWrite(wp,"<td width=\"56%\"><font class=\"subtitle\">");
			ifx_httpdWrite(wp,"PPP Tunneling Protocol can support multi-protocol Virtual Private Networks (VPN).</font>");
#endif //#ifdef CONFIG_CGI_WAN_PPTP
#endif //#ifdef IIP
	}
	else
	if (!gstrcmp(name, T("wan_wizard_pptp")))
	{
#ifdef CONFIG_CGI_WAN_PPTP
			ifx_httpdWrite(wp,T("<p>\n"));
			ifx_httpdWrite(wp,T("<a href=\"frame_wizard_pptp.htm\" target=\"main1\" onMouseOut=\"MM_swapImgRestore()\" onMouseOver=\"MM_swapImage('Image12','','images/r_1.gif',1)\"><img src=\"images/r.gif\" width=\"19\" height=\"14\" border=\"0\" name=\"Image12\"></a>\n"));
			ifx_httpdWrite(wp,T("<img src=\"images/net_0018.gif\" width=\"32\" height=\"32\" align=\"absmiddle\" border=\"0\">\n"));
			ifx_httpdWrite(wp,T("<font color=#003366 face=\"Arial, Helvetica, sans-serif\" size=4>\n"));
			ifx_httpdWrite(wp,T("<a href=\"frame_wizard_pptp.htm\" target=\"main1\"><b>PPTP</b></a><br>\n"));
			ifx_httpdWrite(wp,T("</font>\n"));
			ifx_httpdWrite(wp,T("<font color=#003366 face=\"Arial\" size=\"2\">\n"));
			ifx_httpdWrite(wp,T("If your ISP provided you the PPTP Account, PPTP Password, Host Name,\n"));
			ifx_httpdWrite(wp,T("Service IP Address, IP Address, Subnet Mask and the Connection ID, then\n"));
			ifx_httpdWrite(wp,T("your ISP uses PPTP. You have to choose this option and enter the required information.\n"));
			ifx_httpdWrite(wp,T("</font></p>\n"));
#endif //#ifdef CONFIG_CGI_WAN_PPTP
	}
		return 0;
}



void ifx_Wan_PageTitle(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t  str[20];

	memset(str, 0x00, 20);
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return ;
	}	

#ifdef ATA
	strcpy(str, "ATA");
#endif
#if defined(SPURS) && defined (ATA)
	strcpy(str, "WATA");
#endif

#ifdef GATEWAY
	strcpy(str, "Router");
#endif

#if defined(SPURS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

#if defined(WILDPASS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif


	if (!gstrcmp(name, T("wan_dhcppage")))
	{
/*
	ifx_httpdWrite(wp,T("The Host Name is optional, but may be required by some Service Provider's.\n"
						 "The default MAC address is set to the WAN's physical interface on the %s.\n"
						 "If required by your Service Provider, use the \"Clone MAC Address\" button to\n"
						 "copy the MAC address of the Network Interface Card installed in your PC and replace\n"
						 "the WAN MAC address with this MAC address.\n"
						 "The BigPond login is optional, commonly used in Australia.  If your ISP need\n"
						 "you to do the BigPond login, please enable it and\n"
						 "fill the user name, password and the server name."
				),str);
*/
		 ifx_httpdWrite(wp, "If the Internet Service Provider does not provide any information to you, the %s will obtain IP address automatically by setting WAN Mode as Dynamic IP.", str); 
	}
	else
	if (!gstrcmp(name, T("wan_DhcpBigPondpage")))
	{
		ifx_httpdWrite(wp, "The default MAC address is set to the WAN's physical interface on the %s.", str);
	}
	else
	if (!gstrcmp(name, T("wan_pppoepage")))
	{
	ifx_httpdWrite(wp,T("Enter the PPPoE user name and password assigned by your Service Provider.\n"
						"The Service Name is normally optional, by may be required by some service providers.\n"
						"Enter a Maximum Idle Time (in minutes)to define a maximum period of time for which the Internet\n"
						"connection is maintained during inactivity.\n"
						"If the connection is inactive for longer than the defined Maximum Idle Time, then it will be dropped.\n"
						"You can enable the Auto-reconnect option to automatically re-establish the connection as\n"
						"soon as you attempt to access the Internet again.."));
	}else
	if (!gstrcmp(name, T("wan_pptppage")))
	{
	ifx_httpdWrite(wp,"If your Internet Service Provider requires the use of PPTP, enter the information below:");
	}else
	if (!gstrcmp(name, T("wan_pptppagenote")))
	{
	ifx_httpdWrite(wp,"Note: PPTP for a WAN connection is most popular in Europe.");
	}else
	if (!gstrcmp(name, T("wan_dnspage")))
	{
	ifx_httpdWrite(wp,T("A Domain Name system (DNS) server is like an index of IP addresses and Web addresses. If you type a Web address\n"
						"into you browser, such as <u>www.Infineon.com</u>, a DNS server will find that name in its index and find the matching\n"
						"IP address : 211.21.189.106.<br>\n"
						"Most ISPs provide a DNS server for speed and convenience. Since your Service Provider many connect to the Internet\n"
						"with dynamic IP settings, it is likely that the DNS server IP addresses are also provided dynamically. However, if there\n"
						"is a DNS server that you would rather use, you need to specify the IP address below."));
	}
}
