/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

CGI_TABLE_S IpAliasTable[IP_CFG_MAX_ALIAS_NUM];


#ifdef IIP
///////////////////////////////////////////////////////////////////////
//// get host info
int GetHostInfo(char8 *pc_Hostip)
{

    struct ifreq Interface;
    int iRetVal,i;
    int Fd;
    struct in_addr *pAddr;
     Fd =  socket(AF_INET, SOCK_DGRAM, 0);
     if(Fd<0)
     {
         //printf("\n Socket open failed");
     }
     memset(&Interface,0,sizeof(struct ifreq));
     Interface.ifr_ifru.ifru_addr.sa_family = AF_INET;

     strcpy(Interface.ifr_ifrn.ifrn_name,"eth0");
     iRetVal = ioctl(Fd,SIOCGIFADDR,&Interface);
     if(iRetVal < 0)
     {
        return -1;
     }
     Interface.ifr_ifru.ifru_addr.sa_family = AF_INET;
     for (i = 0; i < 16; i++)
          pAddr= (struct in_addr*)&Interface.ifr_ifru.ifru_addr.sa_data[2];
          strcpy(pc_Hostip,inet_ntoa(*pAddr));
       return iRetVal;
}

//////////////////////////////////////////////////////////////////
//Get net mask

int32 GetNetMask(uchar8 *IPName)
{
     struct ifreq Interface;
     int iRetVal=1,i;
     int Fd;
     struct in_addr *pAddr;
     Fd =  socket(AF_INET, SOCK_DGRAM, 0);
     if(Fd<0)
     {
         return -1;
     }
     memset(&Interface,0,sizeof(struct ifreq));
     Interface.ifr_ifru.ifru_addr.sa_family = AF_INET;
     strcpy(Interface.ifr_ifrn.ifrn_name,"eth0");
     iRetVal = ioctl(Fd,SIOCGIFNETMASK,&Interface);
     if(iRetVal < 0)
     {
         return -1;
     }
     Interface.ifr_ifru.ifru_addr.sa_family = AF_INET;
      for (i = 0; i < 16; i++)
      {
      }
      pAddr= (struct in_addr*)&Interface.ifr_ifru.ifru_addr.sa_data[2];
      strcpy(IPName,inet_ntoa(*pAddr));
      return iRetVal;
}
#endif //#ifdef IIP

//////////////////////////////////////////////////////////////////////////////////
// wan_static.asp, wan_static_alias.asp
//
int ifx_get_wanip(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t 	ipaddr[MAX_DATA_LEN];
	char_t 	*name;
#ifdef IIP
   char_t *ip;
#endif //#ifdef IIP
#ifdef IIP
	   	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	   	{
	      		ifx_httpdError(wp, 400, T("Insufficient args\n"));
	      		return -1;
	   	}	
	    	GetHostInfo(ipaddr);
	   	if ( !gstrcmp(name, T("IP1")) )
	   	{

	      		ip = strtok(ipaddr, ".");
	      		ifx_httpdWrite(wp, T("%s"), ip);
	   	}
	   	else if ( !gstrcmp(name, T("IP2")) )
	   	{
	      		ip = strtok(NULL, ".");
	      		ifx_httpdWrite(wp, T("%s"), ip);
	   	}
	   	else if ( !gstrcmp(name, T("IP3")) )
	   	{
	      		ip = strtok(NULL, ".");
	      		ifx_httpdWrite(wp, T("%s"), ip);
	   	}
	   	else if ( !gstrcmp(name, T("IP4")) )
	   	{
	      		ip = strtok(NULL, ".");
	      		ifx_httpdWrite(wp, T("%s"), ip);
	   	}
	   	else if ( !gstrcmp(name, T("dhcp")) )
	   	{
			x_IFX_CM_Msg xCmMsg;
			// Get Data from CM
			memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
			xCmMsg.ucMsgType = IFX_CM_GET_REQ;
			xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
			xCmMsg.ucChannel = 0;
			if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
			{
				ifx_httpdError(wp, 200, T("Fail to receive NETWORK CFG data from CM\n"));
				return -1;
			}
			system ("/sbin/fw_printenv dhcp > ./dhcp");
			
			xCmMsg.uxData.xNetAddrCfg.ucDhcp = 0;
			/* Read Dhcp and process DHCP info */
			{
				char8 acbuf[48];
				FILE * fd;
				fd = fopen ("./dhcp", "r");
				if (fd)
				{
					fscanf(fd,"%s",acbuf);
					if (strcmp(acbuf,"dhcp=off"))
					{
						xCmMsg.uxData.xNetAddrCfg.ucDhcp = 1;
					}
					fclose (fd);
					unlink("./dhcp");
				}
			}
			ifx_httpdWrite(wp, T("%d"),xCmMsg.uxData.xNetAddrCfg.ucDhcp);
	   	}
#else //#ifdef IIP
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
   	{
   		ifx_httpdError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}

	if ( !gstrcmp(name, T("IP1")) )
	{	
		websGetInterfaceIP(ADM_WAN_IF, 1, TRUE, ipaddr);	
		ifx_httpdWrite(wp, T("%s"), ipaddr);
	}
	else if ( !gstrcmp(name, T("IP2")) )
	{	
		websGetInterfaceIP(ADM_WAN_IF, 2, TRUE, ipaddr);	
		ifx_httpdWrite(wp, T("%s"), ipaddr);
	}
	else if ( !gstrcmp(name, T("IP3")) )
	{	
		websGetInterfaceIP(ADM_WAN_IF, 3, TRUE, ipaddr);	
		ifx_httpdWrite(wp, T("%s"), ipaddr);
	}
	else if ( !gstrcmp(name, T("IP4")) )
	{	
		websGetInterfaceIP(ADM_WAN_IF, 4, TRUE, ipaddr);	
		ifx_httpdWrite(wp, T("%s"), ipaddr);
	}
	//<< sharont12302004 modify
	else if ( !gstrcmp(name, T("dhcp")) )
   	{
   	   // mark this section, cause of not necessary for ATA,WATA,GATEWAY,WGATE
   	   // And with some modification for ASP page display normally.
   	   /*
  	   x_IFX_CM_Msg xCmMsg;
	   // Get Data from CM
	   memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	   xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	   xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
	   xCmMsg.ucChannel = 0;
	   if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	  {
	       ifx_httpdError(wp, 200, T("Fail to receive NETWORK CFG data from CM\n"));
	       return -1;
	   }

	   //ifx_httpdWrite(wp, T("%d"),xCmMsg.uxData.xNetAddrCfg.ucDhcp);
	   ifx_httpdWrite(wp, T("function InitForm()\n"));
	   ifx_httpdWrite(wp, T("{\n"));
	   ifx_httpdWrite(wp, T("\tdocument.tF0.dhcp.selectedIndex = %d\n", xCmMsg.uxData.xNetAddrCfg.ucDhcp));
	   ifx_httpdWrite(wp, T("\tOnchangedhcp();\n"));
	   ifx_httpdWrite(wp, T("}\n"));
	   */
   }
   else
   if (!gstrcmp(name, T("InitForm")))
   {
   		//ifx_httpdWrite(wp, T("onLoad=\"InitForm();\""));
   }
    //>> sharont12302004 modify
#endif	//#ifdef IIP

	return 0 ;
}

int ifx_get_WANStaticMask(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t sMask[MAX_DATA_LEN];
	char_t *name;
#ifdef IIP
   char_t *ip;
#endif //#ifdef IIP

#ifdef IIP
   		if (ejArgs(argc, argv, T("%s"), &name) < 1)
		{
      			ifx_httpdError(wp, 400, T("Insufficient args\n"));
      			return -1;
   		}
   		 GetNetMask(sMask);
   		if ( !gstrcmp(name, T("NM1")) )
   		{
     			ip = strtok(sMask, ".");
      			ifx_httpdWrite(wp, T("%s"), ip);
   		}
  		 else if ( !gstrcmp(name, T("NM2")) )
   		{
      			ip = strtok(NULL, ".");
      			ifx_httpdWrite(wp, T("%s"), ip);
   		}
   		else if ( !gstrcmp(name, T("NM3")) )
   		{
      			ip = strtok(NULL, ".");
      			ifx_httpdWrite(wp, T("%s"), ip);
   		}
   		else if ( !gstrcmp(name, T("NM4")) )
   		{
     			 ip = strtok(NULL, ".");
      			ifx_httpdWrite(wp, T("%s"), ip);
   		}
#else //#ifdef IIP
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

	if ( !gstrcmp(name, T("NM1")) )
	{	
		websGetNetmask(ADM_WAN_IF, 1, TRUE, sMask);	
		ifx_httpdWrite(wp, T("%s"), sMask);
	}
	else if ( !gstrcmp(name, T("NM2")) )
	{	
		websGetNetmask(ADM_WAN_IF, 2, TRUE, sMask);		
		ifx_httpdWrite(wp, T("%s"), sMask);
	}
	else if ( !gstrcmp(name, T("NM3")) )
	{	
		websGetNetmask(ADM_WAN_IF, 3, TRUE, sMask);	
		ifx_httpdWrite(wp, T("%s"), sMask);
	}
	else if ( !gstrcmp(name, T("NM4")) )
	{	
		websGetNetmask(ADM_WAN_IF, 4, TRUE, sMask);	
		ifx_httpdWrite(wp, T("%s"), sMask);
	}
#endif //#ifdef IIP

	return 0 ;
}

int ifx_get_WANStaticGateway(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sGateway[MAX_DATA_LEN];
	char_t 	*name;

#ifndef IIP
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

	if ( !gstrcmp(name, T("GIP1")) )
	{	
		websGetGateway(1, TRUE, sGateway);
		ifx_httpdWrite(wp, T("%s"), sGateway);
	}
	else if ( !gstrcmp(name, T("GIP2")) )
	{	
		websGetGateway(2, TRUE, sGateway);
		ifx_httpdWrite(wp, T("%s"), sGateway);
	}
	else if ( !gstrcmp(name, T("GIP3")) )
	{	
		websGetGateway(3, TRUE, sGateway);
		ifx_httpdWrite(wp, T("%s"), sGateway);
	}
	else if ( !gstrcmp(name, T("GIP4")) )
	{	
		websGetGateway(4, TRUE, sGateway);
		ifx_httpdWrite(wp, T("%s"), sGateway);
	}
#endif //#ifndef IIP
	return 0 ;
}

int	ifx_get_AliasTable (int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t  sValue[MAX_DATA_LEN], sCommand[MAX_DATA_LEN], sIP[MAX_DATA_LEN], sNetmask[MAX_DATA_LEN];
	int     nCount, nIndex;

	gsprintf(sCommand, T("%sCount"), PREFIX_ALIASIP);
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, sCommand, sValue) == 0)
	{
		ifx_httpdError(wp, 204, T("%s not found"), sCommand);
		return -1;
	}
	
	nCount = gatoi(sValue);
	for (nIndex=0; nIndex<nCount; nIndex++)
	{
		// Get IP
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f1 -d\" \""), PREFIX_ALIASIP, nIndex, FILE_RC_CONF);		
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sIP) == 0)
		{
			ifx_httpdError(wp, 204, "Alias IP not found");
			return -1;
		}
		
		// Get netmask
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f3 -d\" \""), PREFIX_ALIASIP, nIndex, FILE_RC_CONF);
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sNetmask) == 0)
		{
			ifx_httpdError(wp, 204, "Netmask not found");
			return -1;
		}
		
		// Print Html file
		ifx_httpdWrite(wp, T("\t\t<tr align=\"center\" bgcolor=\"#ffffff\">\n"));
		ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), sIP);		
		ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"), sNetmask);
		ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"button\" value=\"Delete\" onClick=\"aliasdel('%d');\"></td>\n"), nIndex);
		ifx_httpdWrite(wp, T("\t\t</tr>\n"));	
	}

	return 0;
}

int	ifx_get_AliasStatus (int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sValue[MAX_DATA_LEN];
	char_t 	*name;

#ifndef IIP	
	memset(sValue, 0x00, MAX_DATA_LEN);
	
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}
	if ( !gstrcmp(name, T("IsAlias")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, T("aliasStatus"), sValue) == 0)
		{
		 	ifx_httpdError(wp, 204, "Alias IP not found");
			return -1;	
		}
	
		if ( !gstrcmp(sValue, "Enable") )	//Enable Alias IP
		{
			ifx_httpdWrite(wp, T("true"));
		}
		else
		{
			ifx_httpdWrite(wp, T("false"));
		}
	}
	else
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, T("aliasStatus"), sValue) == 0)
		{
		 	ifx_httpdError(wp, 204, "Alias IP not found");
			return -1;	
		}
	
		if ( !gstrcmp(sValue, "Enable") )	//Enable Alias IP
		{
			gstrcpy(sValue, "1");
			return 1;
		}
		else
		{
			gstrcpy(sValue, "0");
			return 0;
		}
	}
#endif //#ifndef IIP

	return 0;
}






int ifx_get_wan_static(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	int		DATA2,UserLevel;
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}	

	//
	if (!gstrcmp(name, T("IPSettings")))
	{
#ifndef IIP
		ifx_httpdWrite(wp,T("Address, Subnet Mask and ISP Gateway Address provided."));
		ifx_httpdWrite(wp,"</font></p>");
#else
		ifx_httpdWrite(wp,T("Address and Subnet Mask provided. OR Enable DHCP to Dynamically Retreive the IP Address"));
		ifx_httpdWrite(wp,"</font></p>");
#endif //#ifndef IIP
	}else
	if(!gstrcmp(name, T("WanStaticMain")))
	{
#ifndef IIP
		ifx_httpdWrite(wp,"<tr>\n");
		ifx_httpdWrite(wp,"<td width=\"30%\"><font class=\"subtitle\">ISP Gateway Address</font></td>\n");
		ifx_httpdWrite(wp,"<td width=\"70%\">\n");
		ifx_httpdWrite(wp,"<input type=\"text\" name=\"GIP1\" size=\"4\" maxlength=\"3\" value=");
		strcpy(argv[0], "GIP1");
		ifx_get_WANStaticGateway(eid, wp, argc, argv);
		ifx_httpdWrite(wp,T(">.\n <input type=\"text\" name=\"GIP2\" size=\"4\" maxlength=\"3\" value="));
		strcpy(argv[0], "GIP2");
		ifx_get_WANStaticGateway(eid, wp, argc, argv);
		ifx_httpdWrite(wp,T(">.\n <input type=\"text\" name=\"GIP3\" size=\"4\" maxlength=\"3\" value="));
		strcpy(argv[0], "GIP3");			
		ifx_get_WANStaticGateway(eid, wp, argc, argv);
		ifx_httpdWrite(wp,T(">.\n <input type=\"text\" name=\"GIP4\" size=\"4\" maxlength=\"3\" value="));
		strcpy(argv[0], "GIP4");			
		ifx_get_WANStaticGateway(eid, wp, argc, argv);
		ifx_httpdWrite(wp,T(">\n"));			
		ifx_httpdWrite(wp,"</td>");
		ifx_httpdWrite(wp,"</tr>");
//			ifx_httpdWrite(wp,"tr><td>&nbsp;</td><td>&nbsp;</td></tr>");
		ifx_httpdWrite(wp,"<td>&nbsp;</td><td>&nbsp;</td></tr>");
		ifx_httpdWrite(wp,"<tr align=\"left\">");
		ifx_httpdWrite(wp,"<td width=\"30%\"><font class=\"subtitle\">Does ISP provide more IP addresses</font></td>");
		ifx_httpdWrite(wp,"<td width=\"70%\"><font class=\"subtitle\">");
		ifx_httpdWrite(wp,"<input type=\"checkbox\" name=\"IsAlias1\" onclick=\"GURL('wan_static_alias.asp')\">");
		ifx_httpdWrite(wp,"Yes</font>");
		ifx_httpdWrite(wp,"</td>");
		ifx_httpdWrite(wp,"</tr>");		
#else //#ifndef IIP
		ifx_httpdWrite(wp,"<tr>\n");
		ifx_httpdWrite(wp,"<td width=\"30%\"><font class=\"subtitle\">DHCP</font></td>\n");
		ifx_httpdWrite(wp,"<td width=\"70%\">\n");
		ifx_httpdWrite(wp,"<select name=\"dhcp\" size=\"1\" onChange=\"Onchangedhcp();\" >\n");
		ifx_httpdWrite(wp,"<option value=0 selected>OFF</option>\n");
		ifx_httpdWrite(wp,"<option value=1>ON</option>\n");
		ifx_httpdWrite(wp,"</select>\n");
		ifx_httpdWrite(wp,"</td>\n");
		ifx_httpdWrite(wp,"</tr>\n");
#endif //#ifndef IIP

	}else
	if (!gstrcmp(name, T("Onchangedhcp")))
	{
#ifdef IIP
			ifx_httpdWrite(wp, "function Onchangedhcp()\n");
			ifx_httpdWrite(wp, "{\n");
			ifx_httpdWrite(wp, "\tif (document.tF0.dhcp.selectedIndex > 0)\n");
			ifx_httpdWrite(wp, "\t{\n");
			ifx_httpdWrite(wp, "\t\tdocument.tF0.IP1.disabled = true;\n");
			ifx_httpdWrite(wp, "/t/tdocument.tF0.IP2.disabled = true;\n");
			ifx_httpdWrite(wp, "/t/tdocument.tF0.IP3.disabled = true;\n");
			ifx_httpdWrite(wp, "/t/tdocument.tF0.IP4.disabled = true;\n");
			ifx_httpdWrite(wp, "/t/tdocument.tF0.NM1.disabled = true;\n");
			ifx_httpdWrite(wp, "/t/tdocument.tF0.NM2.disabled = true;\n");
			ifx_httpdWrite(wp, "/t/tdocument.tF0.NM3.disabled = true;\n");
			ifx_httpdWrite(wp, "/t/tdocument.tF0.NM4.disabled = true;\n");
			ifx_httpdWrite(wp, "/t}\n");
			ifx_httpdWrite(wp, "\telse\n");
			ifx_httpdWrite(wp, "\t{\n");
			ifx_httpdWrite(wp, "\t\tdocument.tF0.IP1.disabled = false;\n");
			ifx_httpdWrite(wp, "\t\tdocument.tF0.IP2.disabled = false;\n");
			ifx_httpdWrite(wp, "\t\tdocument.tF0.IP3.disabled = false;\n");
			ifx_httpdWrite(wp, "\t\tdocument.tF0.IP4.disabled = false;\n");
			ifx_httpdWrite(wp, "\t\tdocument.tF0.NM1.disabled = false;\n");
			ifx_httpdWrite(wp, "\t\tdocument.tF0.NM2.disabled = false;\n");
			ifx_httpdWrite(wp, "\t\tdocument.tF0.NM3.disabled = false;\n");
			ifx_httpdWrite(wp, "\t\tdocument.tF0.NM4.disabled = false;\n");
			ifx_httpdWrite(wp, "\t}\n");
			ifx_httpdWrite(wp, "}\n");
#endif //#ifdef IIP
	}else
	if(!gstrcmp(name, T("linkpage")))
	{
		DATA2 = ifx_get_AliasStatus(eid,wp,argc,argv);
		if(DATA2 ==1)
		{
			ifx_httpdWrite(wp,"/wan_static_alias.asp");
		}else
		{
			ifx_httpdWrite(wp,"/wan_static.asp");
		}
	}else
	if(!gstrcmp(name, T("WanmainTitlebar")))//
	{
#ifndef IIP
		ifx_httpdWrite(wp,"<form action=\"/goform/ifx_set_wan\" method=\"post\" name=\"tF\">");
#else
		ifx_httpdWrite(wp,"<form  name=\"tF\">");
#endif //#ifndef IIP
	}else
	if(!gstrcmp(name, T("userlevel")))//
	{
		UserLevel = ifx_get_currentUser_authority_CGI( eid,  wp, argc, argv);
		if(UserLevel == 0)
		{
			ifx_httpdWrite(wp,"0");
		}else
		{
			ifx_httpdWrite(wp,"1");
		}
	}
		
	
	return 0;
}



void ifx_set_wan_static(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pIP1 = ifx_httpdGetVar(wp, T("IP1"), T(""));
	char_t	*pIP2 = ifx_httpdGetVar(wp, T("IP2"), T(""));
	char_t	*pIP3 = ifx_httpdGetVar(wp, T("IP3"), T(""));
	char_t	*pIP4 = ifx_httpdGetVar(wp, T("IP4"), T(""));
	char_t	*pNM1 = ifx_httpdGetVar(wp, T("NM1"), T(""));
	char_t	*pNM2 = ifx_httpdGetVar(wp, T("NM2"), T(""));
	char_t	*pNM3 = ifx_httpdGetVar(wp, T("NM3"), T(""));
	char_t	*pNM4 = ifx_httpdGetVar(wp, T("NM4"), T(""));
	char_t	*pGIP1 = ifx_httpdGetVar(wp, T("GIP1"), T(""));
	char_t	*pGIP2 = ifx_httpdGetVar(wp, T("GIP2"), T(""));
	char_t	*pGIP3 = ifx_httpdGetVar(wp, T("GIP3"), T(""));
	char_t	*pGIP4 = ifx_httpdGetVar(wp, T("GIP4"), T(""));
	char_t	*pIsAlias = ifx_httpdGetVar(wp, T("IsAlias1"), T(""));	
#ifdef IIP
	char_t	*pDhcp = ifx_httpdGetVar(wp, T("dhcp"), T(""));	
#endif
	char_t 	sCommand[MAX_FILELINE_LEN];
	char_t 	sIP[MAX_DATA_LEN], sNM[MAX_DATA_LEN], sGIP[MAX_DATA_LEN];
	char_t	sIfconfig_adm1[MAX_FILELINE_LEN], sDefaultRouter[MAX_FILELINE_LEN];
	char_t 	sAliasStatus[MAX_DATA_LEN];
	char_t	sBuf[BUF_SIZE_1K];
	int		nAlias = 0;
	 
#if defined(ATA) || defined(IIP)
        x_IFX_CM_Msg xCmMsg;
#endif
	 
	if ( pIP1 == 0 || gatoi(pIP1) > 255 || pIP2 == 0 || gatoi(pIP2) > 255 ||
         pIP3 == 0 || gatoi(pIP3) > 255 || pIP4 == 0 || gatoi(pIP4) > 255)
	{
    	ifx_httpdError(wp, 204, "Invalidate IP address"); 
    	return;
	}

	if ( pNM1 == 0 || gatoi(pNM1) > 255 || pNM2 == 0 || gatoi(pNM2) > 255 ||
         pNM3 == 0 || gatoi(pNM3) > 255 || pNM4 == 0 || gatoi(pNM4) > 255)
	{
    	ifx_httpdError(wp, 204, "Invalidate Netmask IP address"); 
    	return;
	}

	if ( pGIP1 == 0 || gatoi(pGIP1) > 255 ||  pGIP2 == 0 || gatoi(pGIP2) > 255 ||
         pGIP3 == 0 || gatoi(pGIP3) > 255 ||  pGIP4 == 0 || gatoi(pGIP4) > 255)
	{
    	ifx_httpdError(wp, 204, "Invalidate Getway IP address"); 
    	return;
	}

	// Collect data
	gsprintf(sIP,  T("%s.%s.%s.%s"), pIP1, pIP2, pIP3, pIP4);
	gsprintf(sNM, T("%s.%s.%s.%s"), pNM1, pNM2, pNM3, pNM4);
	gsprintf(sGIP, T("%s.%s.%s.%s"), pGIP1, pGIP2, pGIP3, pGIP4);

#ifdef ATA
   /* Populate the structure of CM*/
	   memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	   xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	   xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
	   xCmMsg.ucChannel =0;
	   strcpy(xCmMsg.uxData.xNetAddrCfg.aucIPAddress, sIP);
	   strcpy(xCmMsg.uxData.xNetAddrCfg.aucSubnetMask, sNM);

	   if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
	   {
	   	if (connection.allowed == 1)
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		else
		{
	      ifx_httpdError(wp, 200, T("Cant send Data to CM"));
	    }
	      return;
	   }
	   if (xCmMsg.ucMsgType == IFX_CM_SET_ERR_RSP)
	   {
	     ifx_httpdError(wp, 200, T("Call in Progress Cant Change Network Config"));
	     return;
	   }
#endif
	                                
	gsprintf(sIfconfig_adm1, T("ifconfig_adm1=\"%s netmask %s\"\n"), sIP, sNM);
	gsprintf(sDefaultRouter, T("default_router=\"%s\"\n"), sGIP);

	if (!gstrcmp(pIsAlias, T("ON")))
	{
		nAlias = 1;
		gsprintf(sAliasStatus, "aliasStatus=\"Enable\"\n");
	}
	else		
	{
		nAlias = 0;
		gsprintf(sAliasStatus, "aliasStatus=\"Disable\"\n");
	}
	
	//Update rc.conf
	websSetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, 3, sIfconfig_adm1, sDefaultRouter, sAliasStatus);

	// Reset All WAN connection in advance, this service will reset IP as well
	system(SERVICE_WAN_STOP);
	
	// Runtime update
	gsprintf(sCommand, T("ifconfig %s %s netmask %s"), ADM_WAN_IF, sIP, sNM);	
	system(sCommand); 
	gsprintf(sCommand, T("/sbin/route add default gw %s"), sGIP);
	system(sCommand);

	// Wan_static_alias.asp
	if (!gstrcmp(pIsAlias, T("ON")))	// Alias Checkbox selected
	{
		// Update Alias IP here
		char_t	*pAliasAdd = ifx_httpdGetVar(wp, T("aliasAdd"), T(""));
		char_t	*pDelflag = ifx_httpdGetVar(wp, T("delflag"), T(""));
		int nIndex = 0, nCurNum = 0;

		// Submit data from press "Add" button
		if (pAliasAdd[0])
		{
			char_t	*pAIP1 = ifx_httpdGetVar(wp, T("AIP1"), T(""));
			char_t	*pAIP2 = ifx_httpdGetVar(wp, T("AIP2"), T(""));
			char_t	*pAIP3 = ifx_httpdGetVar(wp, T("AIP3"), T(""));
			char_t	*pAIP4 = ifx_httpdGetVar(wp, T("AIP4"), T(""));
			char_t	*pANM1 = ifx_httpdGetVar(wp, T("ANM1"), T(""));
			char_t	*pANM2 = ifx_httpdGetVar(wp, T("ANM2"), T(""));
			char_t	*pANM3 = ifx_httpdGetVar(wp, T("ANM3"), T(""));
			char_t	*pANM4 = ifx_httpdGetVar(wp, T("ANM4"), T(""));
			char_t	sAliasIpData[MAX_FILELINE_LEN];
		
			if ( pAIP1 == 0 || gatoi(pAIP1) > 255 || pAIP2 == 0 || gatoi(pAIP2) > 255 ||
			    pAIP3 == 0 || gatoi(pAIP3) > 255 || pAIP4 == 0 || gatoi(pAIP4) > 255)
			{
				ifx_httpdError(wp, 204, "Invalidate Alias IP address"); 
				return;
			}

			if ( pANM1 == 0 || gatoi(pANM1) > 255 || pANM2 == 0 || gatoi(pANM2) > 255 ||
			    pANM3 == 0 || gatoi(pANM3) > 255 || pANM4 == 0 || gatoi(pANM4) > 255)
			{
				ifx_httpdError(wp, 204, "Invalidate Alias Netmask IP address"); 
			    	return;
			}
			gsprintf(sAliasIpData, T("%s.%s.%s.%s netmask %s.%s.%s.%s"), pAIP1, pAIP2, pAIP3, pAIP4,
																	 pANM1, pANM2, pANM3, pANM4);

			// Get original data from file
			nCurNum = websSetData2Table(wp, FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, PREFIX_ALIASIP, IpAliasTable);
			if (nCurNum == -1)
			{
				ifx_httpdError(wp, 200, "Insufficient data for Alias Table");
				return;
			}

			// Update table and system
			for (nIndex=0; nIndex<=nCurNum; nIndex++)
			{
				// 1st, check duplicated
				// 2nd, check empty space
				// 3rd, Add to latest entry
				if (gstrncmp(IpAliasTable[nIndex].Data.sValue, sAliasIpData, sizeof(sAliasIpData)) == 0)
				{
					ifx_httpdError(wp, 200, T("<h2>Duplicate Alias IP Address</h2>\n"));
					return;
				}

				//trace(8, "IPAliasTable Index = %d, IPAliasTable sValue = %s\n", IpAliasTable[nIndex].nIndex, IpAliasTable[nIndex].sValue);
				if (IpAliasTable[nIndex].nIndex == 0 && !IpAliasTable[nIndex].Data.sValue[0])
				{
					IpAliasTable[nIndex].nIndex = nIndex;
					gstrcpy(IpAliasTable[nIndex].Data.sValue, sAliasIpData);

					// Update system
					gsprintf(sCommand, T("ifconfig %s:%d %s"), ADM_WAN_IF, nIndex, IpAliasTable[nIndex].Data.sValue);
					system(sCommand); 
					
					nCurNum = nIndex+1;
					break;
				}
			}

			// No more space to add data
			if (nIndex > IP_CFG_MAX_ALIAS_NUM)	
			{
				ifx_httpdError(wp, 200, T("<h2>Out of space to add Alias IP</h2>"));
				return;
			}

			////////// Update Table to File ///////////////
			memset(sBuf, 0, BUF_SIZE_1K);
			gsprintf(sBuf, T("%sCount=\"%d\"\n"), PREFIX_ALIASIP, nCurNum);			
			
			for (nIndex=0; nIndex<nCurNum; nIndex++)
			{	
				char_t sLine[MAX_DATA_LEN];
				gsprintf(sLine, T("%s%d=\"%s\"\n"), PREFIX_ALIASIP, nIndex, IpAliasTable[nIndex].Data.sValue);
				gstrcat(sBuf, sLine);				
			}

			websSetCfgData(FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, 1, sBuf);
		}

		// Submit data from press delete button
		if (!gstrcmp(pDelflag, T("1")))
		{
			char_t	*pDelIndex = ifx_httpdGetVar(wp, T("delindex"), T(""));
			int		nDelIndex = gatoi(pDelIndex);
			int		nTotalNum = 0;	
			
			//trace(8, "Delete Index = %d...............\n", nDelIndex);
			// Get original data from file
			nTotalNum = websSetData2Table(wp, FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, PREFIX_ALIASIP, IpAliasTable);
			if (nTotalNum == -1)
			{
				ifx_httpdError(wp, 204, "Insufficient data for Alias Table");
				return;
			}

			// I don't how to remove a specific entries here, so that I remove all
			// entries then update entries from IpAliasTable
			
			// Remove DelIndex from Table
			for (nIndex=0; nIndex<nTotalNum; nIndex++)
			{
				if (nIndex >= nDelIndex)
				{	
					IpAliasTable[nIndex].nIndex = IpAliasTable[nIndex+1].nIndex;
					gstrcpy(IpAliasTable[nIndex].Data.sValue, IpAliasTable[nIndex+1].Data.sValue);
				}

				// Update system
				gsprintf(sCommand, T("ifconfig %s:%d down"), ADM_WAN_IF, nIndex);
				system(sCommand);				
			}

			////////// Update Table to File ///////////////
			memset(sBuf, 0, BUF_SIZE_1K);
			gsprintf(sBuf, T("%sCount=\"%d\"\n"), PREFIX_ALIASIP, nTotalNum-1);

			for (nIndex=0; nIndex<nTotalNum; nIndex++)
			{	
				char_t sLine[MAX_DATA_LEN];
				gsprintf(sLine, T("%s%d=\"%s\"\n"), PREFIX_ALIASIP, nIndex, IpAliasTable[nIndex].Data.sValue);		
				gstrcat(sBuf, sLine);

				// Update system
				gsprintf(sCommand, T("ifconfig %s:%d %s"), ADM_WAN_IF, nIndex, IpAliasTable[nIndex].Data.sValue);
				system(sCommand); 				
			}			

			websSetCfgData(FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, 1, sBuf);
		}
	}

	ifx_get_check_wan_mode(0, T("FIXED"));

	// Runtime update
	// Move to update file
	// Update Wan Mode
	gsprintf(sCommand, "ipoption_adm1=\"FIXED\"\n");		
	websSetCfgData(FILE_RC_CONF, TAG_WAN_MAIN, 1, sCommand);

#ifdef IIP
	  /* Populate the structure of CM*/
     		memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	       xCmMsg.ucMsgType = IFX_CM_SET_REQ;
 	       xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
     		xCmMsg.ucChannel =0;
     		strcpy(xCmMsg.uxData.xNetAddrCfg.aucIPAddress, sIP);
     		strcpy(xCmMsg.uxData.xNetAddrCfg.aucSubnetMask, sNM);
     		xCmMsg.uxData.xNetAddrCfg.ucDhcp = gatoi(pDhcp);
     		if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
     		{
     			if (connection.allowed == 1)
				{
					ifx_httpdRedirect(wp, "voip_status_return.htm");
				}
				else
				{
       		ifx_httpdError(wp, 200, T("Call in Progress Cant Change Network Config"));
		       	}
       		return;
     		}
	 	 else
	  	{
        		if (gatoi(pDhcp) > 0)
        		{
           			system("/sbin/fw_setenv dhcp on");
           			system("/etc/init.d/udhcpc start");
	       	 	ifx_httpdNextPage(wp);               
		 	}
    		}
   		return;
#else
	//RunTime change.
#ifdef ATA
	system(SERVICE_RC_VOIP_STOP);
#endif //#ifdef ATA

	system("/etc/rc.d/rc.service");

#ifdef ATA
	system(SERVICE_RC_VOIP_RESTART);
#endif //#ifdef ATA

	system(SERVICE_RESTORE);

	// Force to update menu_advance.asp. Once the aliasStatus is updated, the left page won't take effect
	ifx_httpdRedirect(wp, "frame_setup.htm");
#endif
}          



