/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>


int ifx_get_wan_pptp(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name, sValue[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];
	int		nValue = 0;

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
   	memset(command, 0x00, MAX_FILELINE_LEN);
   	
   	if ( !gstrcmp(name, T("UserName")) )
	{
		gsprintf(command, T("grep %s %s | cut -f1"), "-v ^#", FILE_CHAP_SECRETS);
		if ( ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1 )
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("Password")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 -d* | cut -f2"), "-v ^#", FILE_CHAP_SECRETS);
		if ( ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1 )
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("PasswordVerify")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 -d* | cut -f2"), "-v ^#", FILE_CHAP_SECRETS);
		if ( ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1 )
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("HostName")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPTP, "PPTP_HN", sValue) == 1 )
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("ServerIP")) )
	{
		gsprintf(command, T("grep ^pty %s | cut -f3 -d\" \""), FILE_PPTP);
		if ( ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1 )
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("MyIP")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPTP, "PPTP_IP", sValue) == 1 )
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("Subnet")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPTP, "PPTP_SUBNET", sValue) == 1 )
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("ConnectionID")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPTP, "PPTP_CONNECTIONID", sValue) == 1 )
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("MTU")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 -d\" \""), "^mtu", FILE_OPTIONS_PPTP);
		if ( ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1 )
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("IdleTime")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPTP, "PPTP_IDLE", sValue) == 1 )
		{
			if (sValue[0])
			{
				nValue = gatoi(sValue);
				nValue = nValue / 60;
				gsprintf(sValue, T("%d"), nValue);
			}
			
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("Reconnect")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPTP, "PPTP_RECONNECT", sValue) == 1 )
		{
			if (gstrcmp(sValue, "1") == 0)
				ifx_httpdWrite(wp, T("CHECKED"));
			else
			if (gstrcmp(sValue, "0") == 0)
				ifx_httpdWrite(wp, T("UNCHECKED"));
		}
	}
	else
	if ( !gstrcmp(name, T("IsReconnect")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPTP, "PPTP_RECONNECT", sValue) == 1 )
		{
			if (gstrcmp(sValue, "1") == 0)
				ifx_httpdWrite(wp, T("true"));
			else
			if (gstrcmp(sValue, "0") == 0)
				ifx_httpdWrite(wp, T("false"));
		}
	}
	
	return 0;
}

void ifx_set_wan_pptp(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pUN, *pPWV, *pHN, *pServerip, *pIP, *pSubnet, *pConnectionid;
	char_t	*pMTU, *pIdle, *pReconnect;
	char_t	sUsername[MAX_DATA_LEN];
	char_t	sHN[96], sServerIP[MAX_FILELINE_LEN], sIP[MAX_DATA_LEN], sSubnet[96];
	char_t	sConnectionID[MAX_DATA_LEN], sMTU[MAX_DATA_LEN], sIdle[MAX_DATA_LEN], sReconnect[MAX_DATA_LEN];
	char_t	command[MAX_FILELINE_LEN], sPwd[MAX_DATA_LEN];
	int		nIdle = 0, nConnectionid = 0;
	
#ifdef ATA
        x_IFX_CM_Msg xCmMsg;
#endif
	
#ifdef ATA
   /* Populate the structure of CM*/
   memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
   xCmMsg.ucMsgType = IFX_CM_SET_REQ;
   xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
   xCmMsg.ucChannel =0;
   if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
   {
   	if (connection.allowed == 1)
	{
		ifx_httpdRedirect(wp, "voip_status_return.htm");
	}
	else
	{
      ifx_httpdError(wp, 200, T("Cant send Data to CM"));
    }
      return;
   }
   if (xCmMsg.ucMsgType == IFX_CM_SET_ERR_RSP)
   {
     ifx_httpdError(wp, 200, T("Call in Progress Cant Change Network Config"));
     return;
   }
#endif

	a_assert(wp);
	memset( command, 0x00, MAX_FILELINE_LEN);
	memset( sServerIP, 0x00, MAX_FILELINE_LEN);
	memset( sPwd, 0x00, MAX_DATA_LEN);

	// Get value from ASP file
	pUN = ifx_httpdGetVar(wp, T("UN"), T(""));
	pPWV = ifx_httpdGetVar(wp, T("PWV"), T(""));
	pHN = ifx_httpdGetVar(wp, T("HN"), T(""));
	pServerip = ifx_httpdGetVar(wp, T("serverip"), T(""));
	pIP = ifx_httpdGetVar(wp, T("IP"), T(""));
	pSubnet = ifx_httpdGetVar(wp, T("Subnet"), T(""));
	pConnectionid = ifx_httpdGetVar(wp, T("connectionid"), T(""));
	pMTU = ifx_httpdGetVar(wp, T("MTU"), T(""));
	pIdle = ifx_httpdGetVar(wp, T("idle"), T(""));
	pReconnect = ifx_httpdGetVar(wp, T("reconnect"), T(""));

	if (pConnectionid && *pConnectionid)
	{
		nConnectionid = gatoi(pConnectionid);
		gsprintf(sConnectionID, T("PPTP_CONNECTIONID=\"%d\"\n"), nConnectionid);
	}
	else
	{
		gsprintf(sConnectionID, T("PPTP_CONNECTIONID=\"0\"\n"));
	}

	if (pHN && *pHN)
	{
		gsprintf(sHN, T("PPTP_HN=\"%s\"\n"), pHN);
	}
	else
	{
		gsprintf(sHN, T("PPTP_HN=\"0\"\n"));
	}

	if (pIdle && *pIdle)
	{
		nIdle = gatoi(pIdle);
		nIdle = nIdle * 60;
		gsprintf(sIdle, T("PPTP_IDLE=\"%d\"\n"), nIdle);
	}
	else
	{
		gsprintf(sIdle, T("PPTP_IDLE=\"0\"\n"));
	}

	if (pReconnect && *pReconnect)
	{
        gsprintf(sReconnect, T("PPTP_RECONNECT=\"1\"\n"));
	}
	else
	{
		gsprintf(sReconnect, T("PPTP_RECONNECT=\"0\"\n"));
	}

	/*
	 * Data restore files:
	 * 
	 * User Name and Password    -> Write to /nv/chap-secrets
	 * HostName and ConnectionID -> Do nothing.
	 * ServerIP                  -> Write to /nv/pptp
	 * MyIP and Subnet           -> Write to /nv/pptp
	 * MTU						 -> Write to /nv/options.pptp
     *
	 * Idle Time and Auto-reconnect. Currently, not support. Need to modify protocol code.
	 */
                                    
	memset(command, 0x00, MAX_FILELINE_LEN);
	gsprintf(command, T("%s\t*\t%s\t*\n"), pUN, pPWV);
	websSetCfgData(FILE_CHAP_SECRETS, TAG_WAN_PPTP, 1, command);
	
	gsprintf(sServerIP, T("pty \"pptp %s --nolaunchpppd\"\n"), pServerip);
	gsprintf(sUsername, T("name %s\n"), pUN);
	websSetCfgData(FILE_PPTP, TAG_WAN_PPTP, 2, sServerIP, sUsername);
	// Set MTU in both place	
	gsprintf(sMTU, T("mtu %s\n"), pMTU);
	websSetCfgData(FILE_OPTIONS_PPTP, TAG_WAN_PPTP, 1, sMTU);

	memset(sMTU, 0x00, MAX_DATA_LEN);
	gsprintf(sMTU, T("PPTP_MTU=\"%s\"\n"), pMTU);

	gsprintf(sIP, T("PPTP_IP=\"%s\"\n"), pIP);
	gsprintf(sSubnet, T("PPTP_SUBNET=\"%s\"\n"), pSubnet);
	websSetCfgData(FILE_RC_CONF, TAG_WAN_PPTP, 7, sHN, sIP, sSubnet, sConnectionID, sIdle, sReconnect, sMTU);

	ifx_get_check_wan_mode(0, T("PPTP"));

	/* Update Wan Mode */
	gsprintf(command, "ipoption_adm1=\"PPTP\"\n");		
	websSetCfgData(FILE_RC_CONF, TAG_WAN_MAIN, 1,  command);

	//RunTime change.
#ifdef ATA
	system(SERVICE_RC_VOIP_STOP);
#endif //#ifdef ATA

	websChg2ExeMode(FILE_PPTP);
	system(SERVICE_PPTP_START);

#ifdef ATA
	system(SERVICE_RC_VOIP_RESTART);
#endif //#ifdef ATA

	system(SERVICE_RESTORE);
	ifx_httpdNextPage(wp);
}

