/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

extern int g_nCurrentAPMode;				//0:AP, 1:AP Client
extern int g_nCurrentConnectedAP_WEP;     //0: WEP disable ;1: WEP enable


#ifdef WILDPASS
//wireless_apmode.asp
int ifx_get_wlan_apmode(int eid, httpd_t wp, int argc, char_t **argv)
{

    	char_t	*name;
	char_t	sValue[MAX_FILELINE_LEN],sConnectedAP_BSSID[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];
	

	FILE* fp; 	
	 
	//char buffer[80];  
	//char sBeginTag[64];  
	char sLine[80];  
	char* sConnMAC=NULL;
	char* sDevice=NULL;      
	char* sBSSID=NULL;  
	char* sSSID=NULL;  
	char* sChannel=NULL; 
	char* sWEP=NULL;   
	char* sAwep;
	char* sBWEP=NULL;
	char* sMAC;      
	char* sDataRate;  
	//char seps[]="\t\n\""; 
	char seps[]="\n\" "; 
	char seps0[]="\n"; 
	char seps1[] = "\n\""; 
	char* p1String=NULL;
	char* sHidden=NULL;   //hidden SSID
	char* sBHidden=NULL;

	int iSelectedMode= 0;
	int iSelectedAP=0; //0:NOT BE SELECTED AP, 1:BE SELECTED AP
	int iDisableCheck=0; //0:not disable checkbox,1:disable
	int i=0;
	//int iWriteToWeb=0; //0:need to write line on web;1: not need to 

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(sConnectedAP_BSSID, 0x00, MAX_FILELINE_LEN);
	memset(command, 0x00, MAX_FILELINE_LEN);
	

      printf("\n--- enter  ifx_get_wlan_apmode c code\n");

	if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, T("WLAN_CURRENT_MODE"), sValue) == 1)
	{
	      if ( !gstrcmp(sValue, "1") )
	      {
			iSelectedMode= 1;
	      }
	      if ( !gstrcmp(sValue, "2") )
	      {
			iSelectedMode= 2; //WDS mode
	      }
			
	}
	
	if ( !gstrcmp(name, T("mode0")) )
	{
		
		
			if ( iSelectedMode== 0)
			{
				gstrcpy(sValue, "checked");
			}
			else
			{
				gstrcpy(sValue, "");
			}

			ifx_httpdWrite(wp, T("%s"), sValue);
		
	}
	else
	if ( !gstrcmp(name, T("mode1")) )
	{
		if ( iSelectedMode== 1)
		{
				gstrcpy(sValue, "checked");
		}
		else
		{
				gstrcpy(sValue, "");
		}

		ifx_httpdWrite(wp, T("%s"), sValue);
		
	}
	else
	if ( !gstrcmp(name, T("mode2")) )
	{
		if ( iSelectedMode== 2)
		{
				gstrcpy(sValue, "checked");
		}
		else
		{
				gstrcpy(sValue, "");
		}

		ifx_httpdWrite(wp, T("%s"), sValue);
		
	}
	else
	if ( !gstrcmp(name, T("get_mode")) )
	{
		if ( iSelectedMode== 1)
		{
				ifx_httpdWrite(wp, T("1"));//client mode
		}
		else if ( iSelectedMode== 0)
		{
				ifx_httpdWrite(wp, T("0"));//ap mode
		}
		else if ( iSelectedMode== 2)
		{
				ifx_httpdWrite(wp, T("2"));//wds mode
		}

		
		
	}
	else
	if ( !gstrcmp(name, T("show_mode")) )
	{
		if ( iSelectedMode== 1)
		{
				ifx_httpdWrite(wp, T("Wireless Client"));//client mode
		}
		else if ( iSelectedMode== 0)
		{
				ifx_httpdWrite(wp, T("Accesss Point"));//ap mode
		}
                else if ( iSelectedMode== 2)
		{
				ifx_httpdWrite(wp, T("WDS"));//wds mode
		}
		

		
		
	}
	else
	if (!gstrcmp(name, T("WDSmode_IsDisable")))
	{
		if ( iSelectedMode== 1)
		{
		       ifx_httpdWrite(wp, T("disabled")); //client mode default to make WDS disable
		}	   
	}	
	else
	if (!gstrcmp(name, T("get_connectedAPSSID")))
	{
	   memset(sValue, 0x00, MAX_FILELINE_LEN);
	   if (iSelectedMode==1)		   
	   {
	        if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, "WLAN_AP_ESSID", sValue) == 1 )
	   	{
                    if (!gstrcmp(sValue,"0"))
			 ifx_httpdWrite(wp, T(""));		
		      else
	      		ifx_httpdWrite(wp, T("%s"), sValue);
           	}
	   }
	   else
	   {

	      		ifx_httpdWrite(wp, T(""));
           }
          
	}
	else
	if (!gstrcmp(name, T("get_connectedAP_WEPKey"))) //get Connected AP WEP Key
	{
	   memset(sValue, 0x00, MAX_FILELINE_LEN);
	   if (iSelectedMode==1)		   
	   {
	        if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, "WLAN_AP_WEPKEY", sValue) == 1 )
	   	{
                    if (!gstrcmp(sValue,"0"))
			 ifx_httpdWrite(wp, T(""));		
		      else
	      		ifx_httpdWrite(wp, T("%s"), sValue);
           	}
	   }
	   else
	   {

	      		ifx_httpdWrite(wp, T(""));
           }
          
	}
	else
	if (!gstrcmp(name, T("get_connectedAP_WEP")))//get Connected AP WEP enable 
	{
	   memset(sValue, 0x00, MAX_FILELINE_LEN);
	   if (iSelectedMode==1)		   
	   {
	       // if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, "WLAN_AP_WEP", sValue) == 1 )
	   	//{
                                                                                                                                                                            
	      	//	ifx_httpdWrite(wp, T("%s"), sValue);
           	//}
           	if (g_nCurrentConnectedAP_WEP==1)
		   ifx_httpdWrite(wp, T("1"));
		else
		   ifx_httpdWrite(wp, T("0"));
	   }
	   else
	   {

	      		ifx_httpdWrite(wp, T("0"));
           }
          
	}
	else
	if (!gstrcmp(name, T("sitesurvey_connectAP")))
	{
	     memset(sValue, 0x00, MAX_FILELINE_LEN);
	     if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, "WLAN_AP_ESSID", sValue) == 1 )
	     {
                    if (!gstrcmp(sValue,"0"))
			 ifx_httpdWrite(wp, T(""));		
		      else
	      		ifx_httpdWrite(wp, T("%s"), sValue);
             }	   
	}	
	else
	if (!gstrcmp(name, T("apclient_connectAP")) )
	{
	       if (iSelectedMode==1)		   
	       {

                     ifx_httpdWrite(wp,T("\t\t\t<td width=\"36%\"><font class=\"subtitle\">\n"
		       "<input type=\"button\" name=\"SiteSurvey\" value=\"Site Survey\" onClick=\"return ShowWin();\"></font><font size=\"2\" face=\"Arial\">\n"                    
                      "</font></td>\n"));


              

   
		 }
		
	
	}
       else
	if (!gstrcmp(name, T("connectstatus_list")))
	{
	       //fp = fopen ("/ifx/web/connect_statustemp", "r");  //test data
	       //fp = fopen ("/proc/wildpass", "r");  //real code
	       fp = fopen (FILE_CONNECT_LIST, "r");  //real code
		if (fp==NULL)  
		{     printf ("-----OPEN Connect Status result ERROR: \n");    
		      return -1;  
	       }  
		//ifx_debug_printf ("----CONN-1: \n"); 

		

		i=0;
		
		while (feof(fp)==0) 
		{ 
		   fgets(sLine,80,fp);  


		   p1String= strstr (sLine, "MAC");  
		   //fgetpos(fp,&pos);    
		   if (p1String != NULL)    
		   {     
		   	if ((sMAC=strstr(p1String,"MAC"))!=NULL)   
			{	
				if (strtok(sMAC,"=")!=NULL)   
				{          
				     sMAC=strtok(NULL,seps1);  
				     sMAC=strtok(NULL,seps1);//need to repeat to get MAC
				     if (i==0) 
					 i++;

				     
				     ifx_httpdWrite(wp, T("\t\t\t<tr align=center bgcolor=\"#ffffff\">\n"));				    
				     ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%d</font></td>\n"),i);							 
				     ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font></td>\n"),sMAC);								     			
				     
                                  			 
				     //ifx_debug_printf ("-----MAC:%s\n",sMAC);   
				}          
			}    
		    } 
		   
		    p1String= strstr (sLine, "Data");  
			//fgetpos(fp,&pos);   
		    if (p1String != NULL)   
		   {      
		        if ((sDataRate=strstr(p1String,"Data"))!=NULL)   
			{	
			    if (strtok(sDataRate,"=")!=NULL)       
			    {           
			         sDataRate=strtok(NULL,seps1);    
				  sDataRate=strtok(NULL,seps1);//need to repeat to get Data Rate

			        // iWriteToWeb=1; // need to write to web
			         ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font></td>\n"),sDataRate);	
				  i=i+1;	//record number	
				  ifx_httpdWrite(wp, T("\t\t\t</tr>\n"));
				  //ifx_debug_printf ("-----Data Rate:%s\n",sDataRate);      
			    }         
			}    
		    }      
		   
		  

		        //sscanf (buffer, "SSID  = %s", sSSID);       


		     
		        //fgets(sLine,80,fp);  //printf("%s\n",sLine);    
		  }    //while

		  
 
                		  
		    /* Locate the line that starts with "model name".  */  //match = strstr (buffer, "cpu MHz"); 
		    //ifx_debug_printf ("-----Connect 2: \n");    
		    fclose (fp);
      

		   
	}	
	else
	if ( !gstrcmp(name, T("trigger_survey")) )
	{
              /* triger command to do site survey*/
	       ifx_debug_printf ("-----before triger site survey: \n"); 
	       memset(command, 0x00, MAX_FILELINE_LEN);
	       gsprintf(command, T("iwpriv eth0 apc_survey"));
		system(command);

		ifx_debug_printf ("-----after triger site survey: \n");
	 }
	else
	if ( !gstrcmp(name, T("sitesurvey_list")) )
	{

	       g_nCurrentConnectedAP_WEP=0;
              /* triger command to do site survey*/	       
		//system(command);
	     memset(sValue, 0x00, MAX_FILELINE_LEN);
	     if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, "WLAN_AP_ESSID", sValue) == 0 )
	     {
                    //sValue="0";
		      strcpy(sValue,"0");
             }

	      ifx_debug_printf ("-----Connected AP essid :%s \n",sValue); 


	      memset(sConnectedAP_BSSID, 0x00, MAX_FILELINE_LEN);
	     if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, "WLAN_AP_BSSID", sConnectedAP_BSSID) == 0 )
	     {
                    //sValue="0";
		      strcpy(sConnectedAP_BSSID,"0");
             }

	      ifx_debug_printf ("-----Connected AP Bssid :%s \n",sConnectedAP_BSSID); 

		//printf ("-----after triger site survey: \n");
		
	        /* Read the entire contents of arp_survey into the buffer.  */ 
		//fp = fopen ("/ifx/web/ckun_survey2", "r");  //test data
	       //fp = fopen ("/proc/net/apc_survey", "r");  //real code,ORIGINAL
	       fp = fopen (FILE_APC_SURVEY, "r");  //real code
		if (fp==NULL)  
		{     ifx_debug_printf ("-----OPEN Site Survey result ERROR: \n");    
		      return -1;  
	       }  
		ifx_debug_printf ("-----1: \n"); 

		

		i=0;
		
		while (feof(fp)==0) 
		{ 
		   fgets(sLine,80,fp);  
		   //printf("%s\n",sLine);  
		   

		   //get Connected AP MAC data
		   p1String= strstr (sLine, "Connected_AP_MAC");  
		   //fgetpos(fp,&pos);    
		   if (p1String != NULL)    
		   {     
		   	if ((sConnMAC=strstr(p1String,"Connected_AP_MAC"))!=NULL)   
			{	
				if (strtok(sConnMAC,"=")!=NULL)   
				{          
				     //sDevice=strtok(NULL,seps);  //original
				     sConnMAC=strtok(NULL,seps1); 
				     sConnMAC=strtok(NULL,seps1); //required to repeat
				     //if (i==0) 
					// i++;

				     
				    // ifx_httpdWrite(wp, T("\t\t\t<tr align=center bgcolor=\"#ffffff\">\n"));				    
				     //ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"device%d\" value=\"%s\"></td>\n"),sDevice,i,sDevice);								     			
				     
                                  			 
				     ifx_debug_printf ("-----cONNECTED AP: %s\n",sConnMAC);   
				}          
			}    
		    } 
		   
                  //get device type data
		   p1String= strstr (sLine, "Device");  
		   //fgetpos(fp,&pos);    
		   if (p1String != NULL)    
		   {     
		   	if ((sDevice=strstr(p1String,"Device"))!=NULL)   
			{	
				if (strtok(sDevice,"=")!=NULL)   
				{          
				     //sDevice=strtok(NULL,seps);  //original
				     sDevice=strtok(NULL,seps1); 
				     sDevice=strtok(NULL,seps1); //required to repeat
				     if (i==0) 
					 i++;

				     
				     ifx_httpdWrite(wp, T("\t\t\t<tr align=center bgcolor=\"#ffffff\">\n"));				    
				     ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"device%d\" value=\"%s\"></td>\n"),sDevice,i,sDevice);								     			
				     
                                  			 
				     ifx_debug_printf ("-----Device Type: %s\n",sDevice);   
				}          
			}    
		    } 


		   p1String= strstr (sLine, "Channel");  //fgetpos(fp,&pos);   

		   if (p1String != NULL)   
		   {     
		       if ((sChannel=strstr(p1String,"Channel"))!=NULL)   
		      {	
		          if (strtok(sChannel,"=")!=NULL)        
		          {          
		              //sChannel=strtok(NULL,seps);   //original
		              sChannel=strtok(NULL,seps1); 
			       sChannel=strtok(NULL,seps1); //required to repeat
			       ifx_httpdWrite(wp, T("\t\t\t<input type=\"hidden\" name=\"Channel%d\" value=\"%s\"></td>\n"),i,sChannel);	//temp mark
			       
			       ifx_debug_printf ("-----Channel:%s\n",sChannel);     
			   }          
		      }    
		    }

		    p1String= strstr (sLine, "Hidden");   
		    if (p1String != NULL)    
		    {     
		        if ((sHidden=strstr(p1String,"Hidden"))!=NULL)  
			{	
			    printf ("-----Hidden SSID0:%s\n",sHidden);    
			    if (strtok(sHidden,"=")!=NULL)     
			    {         
			        
				 sHidden=strtok(NULL,seps1);
				// ifx_debug_printf ("-----Hidden SSID1:%s\n",sHidden); 
				 sHidden=strtok(NULL,seps1);//required to repeat				 
				
				 ifx_httpdWrite(wp, T("\t\t\t<input type=\"hidden\" name=\"IfHiddenSSID%d\" value=\"%s\"></td>\n"),i,sHidden);	
                           
				
				 ifx_debug_printf ("-----Hidden SSID2:%s\n",sHidden);    
				  
			     }         
		        }   
		     }    //


		   
		   
		    p1String= strstr (sLine, "BSSID");  
			//fgetpos(fp,&pos);   
		    if (p1String != NULL)   
		   {      
		        if ((sBSSID=strstr(p1String,"BSSID"))!=NULL)   
			{	
			    if (strtok(sBSSID,"=")!=NULL)       
			    {           
			         //sBSSID=strtok(NULL,seps);   //original  
			         sBSSID=strtok(NULL,seps1);				
				  sBSSID=strtok(NULL,seps1);   //required to repeat

			        // iWriteToWeb=1; // need to write to web
			         ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"BSSID%d\" value=\"%s\"></td>\n"),sBSSID,i,sBSSID);	
				 
				  ifx_debug_printf ("-----BSSID:%s\n",sBSSID);   
				 // if (!gstrcmp(sBSSID,sConnectedAP_BSSID))
				 // 	iSelectedAP=1;
				    if (!gstrcmp(sBSSID,sConnectedAP_BSSID))
				    {
				       ifx_debug_printf ("-----FIND CONNECT AP MAC--- \n");  
				       iSelectedAP=1;
				    }
			    }         
			}    
		    }   
		    p1String= strstr (sLine, "ESSID");  //fgetpos(fp,&pos);   

		   if (p1String != NULL)   
		   {     
		       if ((sSSID=strstr(p1String,"ESSID"))!=NULL)   
		      {	
		          if (strtok(sSSID,"=")!=NULL)        
		          {          
		              //sSSID=strtok(NULL,seps);   //original
		              //ifx_debug_printf ("-----ESSID0:%s\n",sSSID);  
			       sSSID=strtok(NULL,seps0);
				//ifx_debug_printf ("-----ESSID0-1:%s\n",sSSID); 
				//ifx_debug_printf ("-----str length:%d\n",strlen(sSSID)); 

                            //the following is original
				//if (!gstrcmp(sSSID,sValue))
				 // 	iSelectedAP=1;

				if (strlen(sSSID)>3)  //""-> length=3
				{
					sSSID=strtok(sSSID,seps1); 
			              //ifx_debug_printf ("-----ESSID1:%s\n",sSSID);  
				       sSSID=strtok(NULL,seps1);	
					//ifx_debug_printf ("-----ESSID2:%s\n",sSSID);  
					

					 iDisableCheck=0;
					 //the following is original
				        //if (!gstrcmp(sSSID,sValue))
				        //iSelectedAP=1;		       
			        
				}
				else
				{
					gstrcpy(sSSID,"");	
					//iDisableCheck=1; //TEMP MARK
			       }
				
			        
				     
			    }
			       ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"ESSID%d\" value=\"%s\"></td>\n"),sSSID,i,sSSID);	
			       
			       //ifx_debug_printf ("-----ESSID:%s\n",sSSID);     
		       }          
		      }    	   

		  

		    p1String= strstr (sLine, "WEP");   
		    if (p1String != NULL)    
		    {     
		        if ((sWEP=strstr(p1String,"WEP"))!=NULL)  
			{	
			    if (strtok(sWEP,"=")!=NULL)     
			    {         
			        //sWEP=strtok(NULL,"\t(");  
				 //sWEP=strtok(NULL,seps);  //original
				 sWEP=strtok(NULL,seps1);
				 sWEP=strtok(NULL,seps1);//required to repeat
				 
				//if ((sBWEP=strstr(sWEP,"1"))!=NULL) //original
				 if (!gstrcmp(sWEP,"1"))
				 {
				    sBWEP="ENABLE";
				    ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"WEP%d\" value=\"1\"></td>\n"),sBWEP,i);		
				    if (iSelectedAP== 1)	
				    {
				        ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">**</font></td>\n"));	
				 
					//ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"radio\" name=\"site\"  onClick=\"setSelectAP(%d,%s)\" value=\"%d\" CHECKED></td>\n"),i,"1",i);//original
					ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"radio\" name=\"site\"  onClick=\"setSelectAP(%d,%s)\" value=\"%d\" ></td>\n"),i,"1",i);
                                   g_nCurrentConnectedAP_WEP=1;
				       ifx_debug_printf("-----Connected AP WEP==1---\n");
				    }
				    else
				    	{
				    	   ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">&nbsp;</font></td>\n"));	
				    	  if (iDisableCheck==1)
					   ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"radio\" name=\"site\"  onClick=\"setSelectAP(%d,%s)\" value=\"%d\" disabled></td>\n"),i,"1",i);
					  else
				          ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"radio\" name=\"site\"  onClick=\"setSelectAP(%d,%s)\" value=\"%d\"></td>\n"),i,"1",i);
				    	}
				 }
				 else
				 {
				    sBWEP="DISABLE";
				    ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">%s</font><input type=\"hidden\" name=\"WEP%d\" value=\"0\"></td>\n"),sBWEP,i);		
				    if (iSelectedAP== 1)
       			    {
       			       ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">**</font></td>\n"));
					//ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"radio\" name=\"site\"  onClick=\"setSelectAP(%d,%s)\" value=\"%d\" CHECKED></td>\n"),i,"0",i);
					ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"radio\" name=\"site\"  onClick=\"setSelectAP(%d,%s)\" value=\"%d\" ></td>\n"),i,"0",i);
					 g_nCurrentConnectedAP_WEP=0;
				       ifx_debug_printf("-----Connected AP WEP==0---\n");
				    }
				    else
				    	{
				    	   ifx_httpdWrite(wp, T("\t\t\t<td><font face=\"Arial\" size=\"2\">&nbsp;</font></td>\n"));	
				    	  if (iDisableCheck==1)
					   ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"radio\" name=\"site\"  onClick=\"setSelectAP(%d,%s)\" value=\"%d\" disabled></td>\n"),i,"0",i);
					  else
					   ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"radio\" name=\"site\"  onClick=\"setSelectAP(%d,%s)\" value=\"%d\"></td>\n"),i,"0",i);
				    	}
				 }
                           
				 i=i+1;	//record number	
				 iSelectedAP=0; //RESET AP Selected
				 ifx_httpdWrite(wp, T("\t\t\t</tr>\n"));
				 //ifx_debug_printf ("-----WEP:%s\n",sWEP);    
				 //ifx_debug_printf ("-----BWEP:%s\n",sBWEP); 
			     }         
		        }   
		     }    //get_SiteSurveyDatafromString(p1String,sBSSID,sSSID);  
		        //sscanf (buffer, "SSID  = %s", sSSID);       


		     
		        //fgets(sLine,80,fp);  //printf("%s\n",sLine);    
		  }    //while

		  
 
                		  
		    /* Locate the line that starts with "model name".  */  //match = strstr (buffer, "cpu MHz"); 
		    printf ("-----2: \n");    
		    fclose (fp);
      
	
		
		
	} //sites survey
	
	
	return 0;
   
}

//////////////////////////////////////////////////////////////////////////////////
// wireless_apmode.asp for WILDPASS
//
void ifx_set_wlan_APMode(httpd_t wp, char_t *path, char_t *query)
{
	char_t	sMode[MAX_DATA_LEN],sWDSInit[MAX_DATA_LEN];
	char_t     sSelectedSSID[MAX_DATA_LEN];
	char_t	sDeviceType[MAX_DATA_LEN],sBSSID[MAX_DATA_LEN], sESSID[MAX_DATA_LEN],  sChannel[MAX_DATA_LEN],sWEP[MAX_DATA_LEN];
	char_t	sWEPKey[MAX_DATA_LEN],sIfHiddenSSID[MAX_DATA_LEN];
	char_t	*pMode = ifx_httpdGetVar(wp, T("Mode"), T(""));
	char_t     *pSelectedSSID = ifx_httpdGetVar(wp, T("selectAPSSID"), T(""));
	char_t     *pSelectedWEPKEY = ifx_httpdGetVar(wp, T("selectAPWEP"), T(""));
	char_t	command[MAX_FILELINE_LEN];
	//for WDS
	char_t	sTempIp1[MAX_FILELINE_LEN],sTempIp2[MAX_FILELINE_LEN],sTempIp3[MAX_FILELINE_LEN],sTempIp4[MAX_FILELINE_LEN];
       char_t	sValue[MAX_FILELINE_LEN];
	char_t	sEncryType[MAX_DATA_LEN], sAuthType[MAX_DATA_LEN];//, sWepType[MAX_DATA_LEN];
	char_t	sKeyUsed[MAX_DATA_LEN], sKey1[MAX_FILELINE_LEN], sKey2[MAX_FILELINE_LEN];
	char_t	sKey3[MAX_FILELINE_LEN], sKey4[MAX_FILELINE_LEN];//, sCommand[MAX_FILELINE_LEN];
	char_t	sPsk[MAX_FILELINE_LEN], sPassPhrase[MAX_FILELINE_LEN];	
	char_t 	sWepKey[MAX_FILELINE_LEN];
	char_t     sRadiusSecret[MAX_FILELINE_LEN];
	char_t     sRadiusIp1[MAX_FILELINE_LEN];
	char_t     sRadiusPort[MAX_FILELINE_LEN];
	char_t     sWEPKeyLength[MAX_DATA_LEN];
	int		n_getServerIP;


	
	char_t     *pSubmittype=ifx_httpdGetVar(wp, T("submittype"), T(""));
	
	memset(sMode,  0x00, MAX_DATA_LEN);
	memset(sWDSInit,  0x00, MAX_DATA_LEN);
	memset(sSelectedSSID,  0x00, MAX_DATA_LEN);
	//memset(sSelectedWEPKey,  0x00, MAX_DATA_LEN);
	memset(sBSSID,  0x00, MAX_DATA_LEN);
	memset(sESSID,   0x00, MAX_DATA_LEN);
	memset(sChannel,   0x00, MAX_DATA_LEN);
	memset(sWEP,  0x00, MAX_DATA_LEN);
       memset(sWEPKey,  0x00, MAX_DATA_LEN);
	memset(sIfHiddenSSID,  0x00, MAX_DATA_LEN);
       //for WDS
       memset(sTempIp1,0x00,MAX_FILELINE_LEN);
	memset(sTempIp2,0x00,MAX_FILELINE_LEN);
	memset(sTempIp3,0x00,MAX_FILELINE_LEN);
	memset(sTempIp4,0x00,MAX_FILELINE_LEN);	
	memset(sValue,0x00,MAX_FILELINE_LEN);
	memset(sWepKey, 0x00, MAX_FILELINE_LEN);	
	memset(sKey1,0x00,MAX_FILELINE_LEN);
	memset(sKey2,0x00,MAX_FILELINE_LEN);
	memset(sKey3,0x00,MAX_FILELINE_LEN);
	memset(sKey4,0x00,MAX_FILELINE_LEN);	
	memset(sRadiusPort,0x00,MAX_FILELINE_LEN);
	memset(sEncryType,0x00,MAX_DATA_LEN);
	memset(sAuthType,0x00,MAX_DATA_LEN);
	
	

	if ( !gstrcmp(pSubmittype, "1") )   //site survey
	{
	      /* triger command to do site survey*/
	       ifx_debug_printf ("-----before triger site survey: \n"); 
	       memset(command, 0x00, MAX_FILELINE_LEN);
	       gsprintf(command, T("iwpriv eth0 apc_survey"));
		system(command);

		ifx_debug_printf ("-----after triger site survey: \n");
		ifx_httpdRedirect(wp, T("wireless_apscan.asp"));
	
	}
	else
	if ( !gstrcmp(pSubmittype, "2") )   //connect status
	{
		ifx_httpdRedirect(wp, T("wireless_connectionstatus.asp"));
	
	}
	else
	{
		// for AP Mode
	
       	if ( !gstrcmp(pMode, "1") )
		{
	        	ifx_debug_printf("pMode-1\n");
	        	gsprintf(sMode, T("WLAN_CURRENT_MODE=\"%s\"\n"), pMode);
			gsprintf(sWDSInit, T("WDS_MODE_INIT=\"0\"\n"));
		}
		else if ( !gstrcmp(pMode, "0") )
		{
	      		 ifx_debug_printf("pMode-0\n");
			gsprintf(sMode, T("WLAN_CURRENT_MODE=\"0\"\n"));
			gsprintf(sWDSInit, T("WDS_MODE_INIT=\"0\"\n"));
		}   	
		else if ( !gstrcmp(pMode, "2") )
		{
	       	ifx_debug_printf("---pMode-2------\n");
			gsprintf(sMode, T("WLAN_CURRENT_MODE=\"2\"\n"));
			gsprintf(sWDSInit, T("WDS_MODE_INIT=\"1\"\n"));

			//turn down Wireless QOS 
			gsprintf(command, T("iwpriv eth0 11ed8 26 0 0"));
			ifx_debug_printf ("----- QOS main setting: %s---\n",command);
			system(command);
			gsprintf(command, T("cp -f %s %s"),FILE_11E_INFO,FILE_NV_11EINFO);
			ifx_debug_printf ("----- save command: %s---\n",command);
			system(command);

			//set wireless security to open
			n_getServerIP=1;

			if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 1,  sTempIp1) != 1)
   				 n_getServerIP=0; //ERROR

 			if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 2,  sTempIp2) != 1)
    				n_getServerIP=0; //ERROR

			if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 3,  sTempIp3) != 1)
  				 n_getServerIP=0; //ERROR
		      
			if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 4,  sTempIp4) != 1)
   				n_getServerIP=0; //ERROR
   				
                     if (n_getServerIP==1)
			   gsprintf(sRadiusIp1,  T("WLAN_RADIUS_SERVER_IP=\"%s.%s.%s.%s\"\n"), sTempIp1, sTempIp2, sTempIp3, sTempIp4);					 
			else
			   gsprintf(sRadiusIp1,  T("WLAN_RADIUS_SERVER_IP=\"0.0.0.0\"\n"));		

			if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_RADIUS_SERVER_SECRET", sValue) == 1 )
    				gsprintf(sRadiusSecret, T("WLAN_RADIUS_SERVER_SECRET=\"%s\"\n"), sValue);	
			else
    				gsprintf(sRadiusSecret, T("WLAN_RADIUS_SERVER_SECRET=\"0\"\n"));	
		
			gsprintf(sEncryType, T("WLAN_ENCRY_TYPE=\"0\"\n"));
			gsprintf(sAuthType, T("WLAN_AUTH_TYPE=\"1\"\n"));
			gsprintf(sWEPKeyLength, T("WLAN_8021X_KEYLEN=\"0\"\n")); 	
			gsprintf(sKeyUsed, T("WLAN_KEY_USED=\"0\"\n"));
			gsprintf(sKey1, T("WLAN_KEY1=\"0\"\n"));
			gsprintf(sKey2, T("WLAN_KEY2=\"0\"\n"));
			gsprintf(sKey3, T("WLAN_KEY3=\"0\"\n"));
			gsprintf(sKey4, T("WLAN_KEY4=\"0\"\n"));	
			gsprintf(sPsk,  T("WLAN_PSK=\"0\"\n"));	
			

		//websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,13,sWEPKeyLength,sRadiusIp1,sRadiusPort,sRadiusSecrct,sEncryType,sAuthType,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_PASSPHRASE=\"0\"\n");//old
//not do		       websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,12,sRadiusIp1,sRadiusSecret,sEncryType,sAuthType,sWEPKeyLength,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_PASSPHRASE=\"0\"\n");
				
			
			system(SERVICE_RESTORE);
		}   	


		//ifx_httpdWrite(wp,T("<br><center><b>The device is restarting. Please wait and then press back button....</b></center><br>"));

		//ifx_httpdRedirect(wp, T("wireless_apmode_ok.htm"));//temp mark
	
		 //sleep(3); 
		

		//websSetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, 1,sMode);//OLD
		websSetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, 2,sMode,sWDSInit);


		 // for AP Mode
           
	       ifx_debug_printf("psETAP-1\n");
		gsprintf(sDeviceType, T("WLAN_AP_DEVICETYPE=\"%s\"\n"), "0");
		gsprintf(sBSSID, T("WLAN_AP_BSSID=\"%s\"\n"), "0");
		ifx_debug_printf("-----WLAN_AP_BSSID str len:%d\n", strlen(pSelectedSSID));
		
              if (pSelectedSSID && *pSelectedSSID)
              {
		     if (strlen(pSelectedSSID)<3)  //if "" replace into "0"
		      gstrcpy(pSelectedSSID,"0");

		     gsprintf(sESSID, T("WLAN_AP_ESSID=\"%s\"\n"), pSelectedSSID);
		     ifx_debug_printf("psETAP-2-a\n");
              }
		else
		     gsprintf(sESSID, T("WLAN_AP_ESSID=\"0\"\n"));

		//ifx_debug_printf("psETAP-2\n");
		//gsprintf(sESSID, T("WLAN_AP_ESSID=\"%s\"\n"), pSelectedSSID);
		gsprintf(sChannel, T("WLAN_AP_CHANNEL=\"%s\"\n"), "1");
		gsprintf(sWEP, T("WLAN_AP_WEP=\"%s\"\n"), "0");

              //get WEP Key
              if (pSelectedWEPKEY&& *pSelectedWEPKEY)
              {
		     if (strlen(pSelectedWEPKEY)<3)  //if "" replace into "0"
		      gstrcpy(pSelectedWEPKEY,"0");

		     gsprintf(sWEP, T("WLAN_AP_WEP=\"%s\"\n"), "1");
		     gsprintf(sWEPKey, T("WLAN_AP_WEPKEY=\"%s\"\n"), pSelectedWEPKEY);
		     ifx_debug_printf("psETAP-2-a\n");
              }
		else
		     gsprintf(sWEPKey, T("WLAN_AP_WEPKEY=\"%s\"\n"), "0");
		
		//gsprintf(sWEPKey, T("WLAN_AP_WEPKEY=\"%s\"\n"), "0");
		gsprintf(sIfHiddenSSID, T("WLAN_AP_IFHIDDENSSID=\"%s\"\n"), "0");
		//gsprintf(sDeviceType, T("WLAN_AP_DEVICETYPE=\"%s\"\n"), pDeviceType);	
	
	      //ifx_debug_printf("psETAP-3\n");

	       //websSetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, 6, sDeviceType, sBSSID,sESSID,sChannel,sWEP,sWEPKey);//ORIGINAL
		websSetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, 7, sDeviceType, sBSSID,sESSID,sChannel,sWEP,sWEPKey,sIfHiddenSSID);

	       //ifx_httpdNextPage(wp);
		system(SERVICE_RESTORE);
		//system(sDisableIfCmd);	//sharont01182005 add --> for disable WLAN interface while radio on/off
		//system(SERVICE_WLAN); //CALVINC20050127 modified

	       reboot(RB_AUTOBOOT); //reboot
	
		                                
	                      
		//system(sCommand);
	}
	
	

}


void ifx_set_wlan_setAP(httpd_t wp, char_t *path, char_t *query)
{
       char_t	*pSelAPNumber, *pDeviceType,*pBSSID, *pESSID, *pChannel,*pWEP,*pWEPKey;
	char_t	sDeviceType[MAX_FILELINE_LEN],sBSSID[MAX_FILELINE_LEN], sESSID[MAX_FILELINE_LEN],  sChannel[MAX_FILELINE_LEN],sWEP[MAX_FILELINE_LEN],buf[MAX_FILELINE_LEN];
	char_t	sAPMode[MAX_DATA_LEN],sWEPKey[MAX_FILELINE_LEN];
	char_t     *pIfHiddenSSID;
	char_t	 sIfHiddenSSID[MAX_FILELINE_LEN];
	char_t	sValue[MAX_FILELINE_LEN];

	int iLoop=0;
	int iSelAPNum=0;
	

	a_assert(wp);
	memset(sBSSID,  0x00, MAX_FILELINE_LEN);
	memset(sESSID,   0x00, MAX_FILELINE_LEN);
	memset(sChannel,   0x00, MAX_FILELINE_LEN);
	memset(sWEP,  0x00, MAX_FILELINE_LEN);
       memset(sWEPKey,  0x00, MAX_FILELINE_LEN);
	memset(sIfHiddenSSID,  0x00, MAX_FILELINE_LEN);
	memset(sAPMode,  0x00, MAX_DATA_LEN);
	memset(sValue, 0x00, MAX_FILELINE_LEN);

       //ifx_debug_printf("-----enter ifx_set_wlan_setAP\n");
	pSelAPNumber= ifx_httpdGetVar(wp, T("selapnumber"), T(""));
	iSelAPNum=atoi(pSelAPNumber);
	ifx_debug_printf("-----select AP number:%d\n",iSelAPNum);

	memset(buf, 0x00, MAX_FILELINE_LEN);
	gsprintf(buf, T("ESSID%d"),0);
	pBSSID  = ifx_httpdGetVar(wp, buf, T(""));
	

	if (iSelAPNum>0)
	{
            
               // Get value from ASP file
                            

		memset(buf, 0x00, MAX_FILELINE_LEN);
		gsprintf(buf, T("device%d"), iSelAPNum);
		pDeviceType  = ifx_httpdGetVar(wp, buf, T(""));
		
		memset(buf, 0x00, MAX_FILELINE_LEN);
		gsprintf(buf, T("BSSID%d"), iSelAPNum);
		pBSSID  = ifx_httpdGetVar(wp, buf, T(""));

		memset(buf, 0x00, MAX_FILELINE_LEN);
		gsprintf(buf, T("ESSID%d"),iSelAPNum);
		pESSID  = ifx_httpdGetVar(wp, buf, T(""));
		
		if (strlen(pESSID)<3)  //if "" replace into "0"
		  gstrcpy(pESSID,"0");

		memset(buf, 0x00, MAX_FILELINE_LEN);
		gsprintf(buf, T("Channel%d"),iSelAPNum);
		pChannel= ifx_httpdGetVar(wp, buf, T(""));

		memset(buf, 0x00, MAX_FILELINE_LEN);
		gsprintf(buf, T("WEP%d"),iSelAPNum);
		pWEP  = ifx_httpdGetVar(wp, buf, T(""));

		memset(buf, 0x00, MAX_FILELINE_LEN);
		gsprintf(buf, T("IfHiddenSSID%d"),iSelAPNum);
		pIfHiddenSSID= ifx_httpdGetVar(wp, buf, T(""));

		pWEPKey  = ifx_httpdGetVar(wp, T("wepkey"), T(""));


		// for AP Mode
           
	       ifx_debug_printf("psETAP-1\n");
		gsprintf(sDeviceType, T("WLAN_AP_DEVICETYPE=\"%s\"\n"), pDeviceType);
		gsprintf(sBSSID, T("WLAN_AP_BSSID=\"%s\"\n"), pBSSID);
		ifx_debug_printf("-----WLAN_AP_BSSID=%s\n", sBSSID);
		gsprintf(sESSID, T("WLAN_AP_ESSID=\"%s\"\n"), pESSID);
		gsprintf(sChannel, T("WLAN_AP_CHANNEL=\"%s\"\n"), pChannel);
		gsprintf(sWEP, T("WLAN_AP_WEP=\"%s\"\n"), pWEP);

	       if ( !gstrcmp(pWEP, "1") )   //enable
	       {
		gsprintf(sWEPKey, T("WLAN_AP_WEPKEY=\"%s\"\n"), pWEPKey);
	       }
		else  //wep disable ,use default value
		{
		    if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, T("WLAN_AP_WEPKEY"), sValue) == 1)
	           {
	              gsprintf(sWEPKey, T("WLAN_AP_WEPKEY=\"%s\"\n"), sValue);
		    }
		   else
		       gsprintf(sWEPKey, T("WLAN_AP_WEPKEY=\"%s\"\n"), pWEPKey);
		}
		
		
		gsprintf(sIfHiddenSSID, T("WLAN_AP_IFHIDDENSSID=\"%s\"\n"), pIfHiddenSSID);
		//gsprintf(sDeviceType, T("WLAN_AP_DEVICETYPE=\"%s\"\n"), pDeviceType);	
	
	       ifx_httpdNextPage(wp);

	       //websSetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, 6, sDeviceType, sBSSID,sESSID,sChannel,sWEP,sWEPKey);//ORIGINAL
		websSetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, 7, sDeviceType, sBSSID,sESSID,sChannel,sWEP,sWEPKey,sIfHiddenSSID);		   

		
		
	       gsprintf(sAPMode, T("WLAN_CURRENT_MODE=\"1\"\n"));	

		websSetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, 1,sAPMode);

		

              // Save to nv
	       system(SERVICE_RESTORE);
	       //system(sDisableIfCmd);	//sharont01182005 add --> for disable WLAN interface while radio on/off
	       //system(SERVICE_WLAN); //CALVINC20050127 modified
	       
	        system(SERVICE_WLAN_RECONNECTAP); 

              //reboot(RB_AUTOBOOT); //reboot
	
	                     
           
	}
	else
	{
	       memset(sValue, 0x00, MAX_FILELINE_LEN);
	      //memset(command, 0x00, MAX_FILELINE_LEN);
	

           ifx_debug_printf("\n--- enter  ifx_get_wlan_apmode c code\n");

	     if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, T("WLAN_AP_DEVICETYPE"), sValue) == 1)
	     {
	         gsprintf(sDeviceType, T("WLAN_AP_DEVICETYPE=\"%s\"\n"), sValue);
			
	      }
	      else	       
		  gsprintf(sDeviceType, T("WLAN_AP_DEVICETYPE=\"%s\"\n"), "0");

		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, T("WLAN_AP_BSSID"), sValue) == 1)
	     {
	         gsprintf(sBSSID, T("WLAN_AP_BSSID=\"%s\"\n"), sValue);
			
	      }else  
		  gsprintf(sBSSID, T("WLAN_AP_BSSID=\"%s\"\n"), "0");
		  
		ifx_debug_printf("-----WLAN_AP_BSSID=%s\n", sBSSID);

		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, T("WLAN_AP_ESSID"), sValue) == 1)
	     {
	         gsprintf(sESSID, T("WLAN_AP_ESSID=\"%s\"\n"), sValue);
			
	      }else  
		   gsprintf(sESSID, T("WLAN_AP_ESSID=\"%s\"\n"), "0");

		  
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, T("WLAN_AP_CHANNEL"), sValue) == 1)
	      {
	         gsprintf(sChannel, T("WLAN_AP_CHANNEL=\"%s\"\n"), sValue);
			
	      }else   
		    gsprintf(sChannel, T("WLAN_AP_CHANNEL=\"%s\"\n"), "0");

		  
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, T("WLAN_AP_WEP"), sValue) == 1)
	      {
	         gsprintf(sWEP, T("WLAN_AP_WEP=\"%s\"\n"), sValue);
			
	      }else  
		   gsprintf(sWEP, T("WLAN_AP_WEP=\"%s\"\n"), "0");


		pWEPKey  = ifx_httpdGetVar(wp, T("wepkey"), T(""));

	       if ( !gstrcmp(sValue, "1") )   //enable
	       {
		gsprintf(sWEPKey, T("WLAN_AP_WEPKEY=\"%s\"\n"), pWEPKey);
	       }
		else  //wep disable ,use default value
		{
		    if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, T("WLAN_AP_WEPKEY"), sValue) == 1)
	           {
	              gsprintf(sWEPKey, T("WLAN_AP_WEPKEY=\"%s\"\n"), sValue);
		    }
		   else
		       gsprintf(sWEPKey, T("WLAN_AP_WEPKEY=\"%s\"\n"), pWEPKey);
		}
		
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, T("WLAN_AP_IFHIDDENSSID"), sValue) == 1)
	      {
	         gsprintf(sIfHiddenSSID, T("WLAN_AP_IFHIDDENSSID=\"%s\"\n"), sValue);
			
	      }else  
		   gsprintf(sIfHiddenSSID, T("WLAN_AP_IFHIDDENSSID=\"%s\"\n"), "0");
		//gsprintf(sDeviceType, T("WLAN_AP_DEVICETYPE=\"%s\"\n"), pDeviceType);	
	
	       ifx_httpdNextPage(wp);

	       //websSetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, 6, sDeviceType, sBSSID,sESSID,sChannel,sWEP,sWEPKey);//ORIGINAL
		websSetCfgData(FILE_RC_CONF, TAG_WLAN_SEL_APDATA, 7, sDeviceType, sBSSID,sESSID,sChannel,sWEP,sWEPKey,sIfHiddenSSID);		   

		   system(SERVICE_RESTORE);
	       //system(sDisableIfCmd);	//sharont01182005 add --> for disable WLAN interface while radio on/off
	       //system(SERVICE_WLAN); //CALVINC20050127 modified
	       
	        system(SERVICE_WLAN_RECONNECTAP); 

              //reboot(RB_AUTOBOOT); //reboot

	}

       ifx_httpdNextPage(wp);
}

void ifx_set_wlan_sitesurveypage(httpd_t wp, char_t *path, char_t *query)
{
      ifx_httpdNextPage(wp);
}



void ifx_set_DHCPC_settings(httpd_t wp, char_t *path, char_t *query)
{
      char_t	command[MAX_FILELINE_LEN];
      char_t	sStatus[MAX_DATA_LEN];
      char_t      sDHCPCStatus[MAX_DATA_LEN];
      char_t	sValue[MAX_DATA_LEN];
      int           nOrgStatus;
      int           nNewStatus;
      char_t     *pSubmittype=ifx_httpdGetVar(wp, T("submittype"), T(""));
      char_t	*pConnect = ifx_httpdGetVar(wp, T("connectflag"), T(""));
      char_t	*pStatus = ifx_httpdGetVar(wp, T("dhcpc_clientstatus"), T(""));	
	
	
	
	a_assert(wp);
	memset(sStatus,   0x00, MAX_DATA_LEN);
	memset(sDHCPCStatus,   0x00, MAX_DATA_LEN);

	memset(sValue, 0x00, MAX_DATA_LEN);  

	ifx_debug_printf ("-----ifx_set_DHCPC_settings ---: \n"); 

	
      //GET Current status for DHCP Client Enable
      if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APCLIENT_DHCPC, "DHCPC_APCLIENT_ENABLE", sValue) == 1 )
	{
           if ( !gstrcmp(sValue, "0") )
	      nOrgStatus=0; //ap
	    else  
	      nOrgStatus=1;
	    
	}

	if ( !gstrcmp(pSubmittype, "1") )   //RELASE OR RECONNECT
	{
	   if (nOrgStatus==1)
	   {
             ifx_debug_printf ("-----submit type:1 ---: \n"); 
	      if (!gstrcmp(pConnect, "1"))	// Release
		{
		       system(SERVICE_APCLIENT_DHCPC_STOP);
			ifx_debug_printf ("-----connectflag:1 ---: \n"); 
       		
        	}	
		else if (!gstrcmp(pConnect, "2"))	// ReConnect/Renew
		{
       		system(SERVICE_APCLIENT_DHCPC_RESTART);
			ifx_debug_printf ("-----connectflag:2 ---: \n"); 
		}
	   
	   }      
	   ifx_httpdNextPage(wp);
	
	}
	else
	if ( !gstrcmp(pSubmittype, "2") )   //connect status
	{
		//ifx_httpdRedirect(wp, T("wireless_connectionstatus.asp"));
		ifx_debug_printf ("-----before set DHCPC ---: \n"); 
		//printf ("-----before set DHCPC ---: \n"); 
		memset(command, 0x00, MAX_FILELINE_LEN);
	
		if (pStatus && *pStatus)
		{
	    		gsprintf(sDHCPCStatus, T("DHCPC_APCLIENT_ENABLE=\"1\"\n"));
	    		nNewStatus=1;
			ifx_debug_printf ("----- DHCPC  setting: 1 \n");
		}
		else
		{
	   		 gsprintf(sDHCPCStatus, T("DHCPC_APCLIENT_ENABLE=\"0\"\n"));
	    		nNewStatus=0;
			ifx_debug_printf ("----- DHCPC  setting: 0 \n");
		}
	
		//ifx_debug_printf ("----- DHCPC  setting: %s---\n",command);
		//system(command);
	
	
		//if (pStatus && *pStatus)	
	 	//   gsprintf(sStatus,    T("WLAN_QOS_ENABLE=\"%s\"\n"), pStatus);
		//else
		//   gsprintf(sStatus,    T("WLAN_QOS_ENABLE=\"0\"\n"));		//default	
	
		
		
		websSetCfgData(FILE_RC_CONF, TAG_WLAN_APCLIENT_DHCPC, 1, sDHCPCStatus);

		if (nNewStatus==1)
		{
	 		 if (nOrgStatus==0)  //OLD STATUS --OFF,  NEW STSUS--ON
	    			system(SERVICE_APCLIENT_DHCPC_START);
		}
		else
		{
	   		if (nOrgStatus==1)  //OLD STATUS --ON,  NEW STSUS--OFF
	    			system(SERVICE_APCLIENT_DHCPC_STOP);
		}
		//system(command);
		system(SERVICE_RESTORE);
    		//end add

		//reboot(RB_AUTOBOOT); //reboot

		ifx_httpdNextPage(wp);
	
	}
	
	
}




int ifx_get_DHCPC_settings(int eid, httpd_t wp, int argc, char_t **argv)
{
     
      char_t	*name;
      char_t	sValue[MAX_FILELINE_LEN];
      char_t      sLanIP[MAX_DATA_LEN];
      char_t      sGateway[MAX_DATA_LEN];
	
	
	
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(sLanIP, 0x00, MAX_DATA_LEN);
	memset(sGateway, 0x00, MAX_DATA_LEN);
	
	if ( !gstrcmp(name, T("dhcpc_clientstatus")) )
	{
		//if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_STATUS, "wlan_enable", sValue) == 1 )
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APCLIENT_DHCPC, "DHCPC_APCLIENT_ENABLE", sValue) == 1 )
		{
			if ( !gstrcmp(sValue, "1") )
			{
				ifx_httpdWrite(wp, T("checked"));
			}
			else
			{
				ifx_httpdWrite(wp, T(""));
			}
		}
	}
	else
	if ( !gstrcmp(name, T("LanIP")) )
	{
		websGetInterfaceIP(ADM_APCLIENT_LAN_IF, 4, FALSE, sLanIP);
		
		ifx_httpdWrite(wp, sLanIP);
	}
	else
	if ( !gstrcmp(name, T("LanMask")) )
	{
		websGetNetmask(ADM_APCLIENT_LAN_IF, 4, FALSE, sValue);
    		ifx_httpdWrite(wp, sValue);
	}
	else
	if ( !gstrcmp(name, T("GatewayIP")) )
	{
		websGetGateway(4, FALSE, sGateway);
	

		if (sGateway[0])
			ifx_httpdWrite(wp, T("%s"), sGateway);
		else
			ifx_httpdWrite(wp, T("0.0.0.0"));
	}

	return 0;
}


#endif //#ifdef WILDPASS
