/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include	 <netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

extern int g_nCurrentAPMode;

int g_nRegulationDomain=0;  //default 0:FCC,
                             // 1:IC
                             // 2:ETSI
                             // 3:Spain
                             // 4:France
                             // 5:MKK
                             // 6:MKKII
//
enum
{
	WIRELESS_MODE_11B = 1,
	WIRELESS_MODE_11G = 2,
	WIRELESS_MODE_MIX = 3,
	WIRELESS_MODE_11A = 4
};
                             
CGI_ENUMSEL_S web_Enum_Domain_List[] =
{
	{0, "FCC"},
	{1, "IC"},
	{2, "ETSI"},
	{3, "Spain"},
	{4, "France"},
	{5, "MKK"},
	{6, "MKKII"}
};

CGI_ENUMSEL_S web_Enum_ChannelMode_List [] =
{
	{0, "Auto"},
	{1, "Channel 1"},
	{2, "Channel 2"},
	{3, "Channel 3"},
	{4, "Channel 4"},
	{5, "Channel 5"},
	{6, "Channel 6"},
	{7, "Channel 7"},
	{8, "Channel 8"},
	{9, "Channel 9"},
	{10, "Channel 10"},
	{11, "Channel 11"},
	{12, "Channel 12"},
	{13, "Channel 13"},
	{14, "Channel 14"}
};

CGI_ENUMSEL_S web_Enum_Channel_LuckyWarp_List [] =
{
	{0, "         "},
	{34, "Channel 34"},
	{36, "Channel 36"},
	{40, "Channel 40"},
	{42, "Channel 42"},
	{44, "Channel 44"},
	{46, "Channel 46"},
	{48, "Channel 48"},
	{52, "Channel 52"},
	{56, "Channel 56"},
	{60, "Channel 60"},
	{64, "Channel 64"},
	{100, "Channel 100"},
	{104, "Channel 104"},
	{108, "Channel 108"},
	{112, "Channel 112"},
	{116, "Channel 116"},
	{120, "Channel 120"},
	{124, "Channel 124"},
	{128, "Channel 128"},
	{132, "Channel 132"},
	{136, "Channel 136"},
	{140, "Channel 140"},
	{149, "Channel 149"},
	{153, "Channel 153"},
	{157, "Channel 157"},	
	{161, "Channel 161"}
};



CGI_ENUMSEL_S web_Enum_RateMode_List [] =
{
	{0, "Auto"},
	{1, "1 Mbps"},
	{2, "2 Mbps"},
	{3, "5.5 Mbps"},
	{4, "11 Mbps"},
	{5, "6 Mbps"},	
	{6, "9 Mbps"},
	{7, "12 Mbps"},
	{8, "18 Mbps"},	
	{9, "24 Mbps"},
	{10, "36 Mbps"},	
	{11, "48 Mbps"},
	{12, "54 Mbps"}	
};

CGI_ENUMSEL_S web_Enum_DataRate_Mix_List[] =
{
	{0, "Auto"},
	{1, "1 Mbps"},
	{2, "2 Mbps"},
	{3, "5.5 Mbps"},
	{4, "6 Mbps"},	
	{5, "9 Mbps"},
	{6, "11 Mbps"},
	{7, "12 Mbps"},
	{8, "18 Mbps"},	
	{9, "24 Mbps"},
	{10, "36 Mbps"},	
	{11, "48 Mbps"},
	{12, "54 Mbps"}
};
CGI_ENUMSEL_S web_Enum_DataRate_11b_List[] =
{
	{0, "Auto"},
	{1, "1 Mbps"},
	{2, "2 Mbps"},
	{3, "5.5 Mbps"},
	{4, "11 Mbps"}
};
CGI_ENUMSEL_S web_Enum_DataRate_11g_List[] =
{
	{0, "Auto"},
	{1, "6 Mbps"},	
	{2, "9 Mbps"},
	{3, "12 Mbps"},
	{4, "18 Mbps"},	
	{5, "24 Mbps"},
	{6, "36 Mbps"},	
	{7, "48 Mbps"},
	{8, "54 Mbps"}
};

CGI_ENUMSEL_S web_Enum_PowerLevel_List[] =
{
	{0, "1"},
	{1, "2"},
	{2, "3"},
	{3, "4"},
	{4, "5"}
};

CGI_ENUMSEL_S web_Enum_Operation_Luckywarp_List [] =
{
		{1,"B Mode Only"},
		{2,"G Mode Only"},
		{3,"B/G Mixed Mode"},
		{4,"A Mode Only"}
};


CGI_ENUMSEL_S web_Enum_OperationMode_List [] =
{
		{1,"B Mode Only"},
		{2,"G Mode Only"},
		{3,"B/G Mixed Mode"}
};


CGI_ENUMSEL_S web_Enum_PreambleMode_List [] =
{
	{1, "Short Preamble"},
	{2, "Long Preamble"},
	{3, "Auto"}
};


#if (defined(SPURS) || defined(WILDPASS))
int ifx_get_wlan_Domain(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;//, sValue[MAX_FILELINE_LEN];
	//int		 nSelIdx = 0;//i

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}
	if ( !gstrcmp(name, T("Domain")) )
	{
		strcpy(argv[0], "RegulationDomain");
       	if (ifx_get_wlan_settings(eid, wp, argc, argv)==0)
			ifx_httpdWrite(wp,"\t\t\tFCC");
		else	 if(ifx_get_wlan_settings(eid, wp, argc, argv)==1)	
			ifx_httpdWrite(wp,"\t\t\tIC");				
		else if (ifx_get_wlan_settings(eid, wp, argc, argv)==2)
			ifx_httpdWrite(wp,"\t\t\tETSI");				
		else if (ifx_get_wlan_settings(eid, wp, argc, argv)==3)			
			ifx_httpdWrite(wp,"\t\t\tSpain");				
		else if (ifx_get_wlan_settings(eid, wp, argc, argv)==4)				
			ifx_httpdWrite(wp,"\t\t\tFrance");
		else if (ifx_get_wlan_settings(eid, wp, argc, argv)==5)					
			ifx_httpdWrite(wp,"\t\t\tMKK");
		else if (ifx_get_wlan_settings(eid, wp, argc, argv)==6)				
			ifx_httpdWrite(wp,"\t\t\tMKKII");	
	}

	return 0;
}

int ifx_get_wlan_settings(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name, sValue[MAX_FILELINE_LEN];
	int		i, nSelIdx = 0;
	static int          CountryChannel_Index=0;//0~6
	int          nProject_Index=1; //0:Airoha& old,Channel 1-14
	              //  2:Lucky Warp,Operation mode =A,Channel 34,36,40,42,44,46,48,52,56,60,64,100,104,108,112,116,120,124,128,132,136,140,149,153,157,161
	int          nOperateIdx =0;		
	FILE* 	fp;
	int          nProject=0;
	char       sProj[2],chProj;
	
	//
	CGI_ENUMSEL_S* pDataRateList = web_Enum_DataRate_Mix_List;
	int nDataRateListSize = 13;
	
	int nWirelessMode;
	

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);


	//Get the regulation domain
	if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_DOMAIN", sValue) == 1 )
	{
		nSelIdx = gatoi(sValue);
		//
		g_nRegulationDomain= nSelIdx;
	
	}

	//Get Info from Proc file to indentify projetc
      //fp = fopen ("/ifx/web/testproj", "r");  //test code
      //fp = fopen ("/proc/adm8668wlan/wlan_rf_type", "r");  //real code,original
      fp = fopen (FILE_11A_RFTYPE, "r");  //real code
      if (fp!=NULL)  
	{     

 	    if (feof(fp)==0)
	   {
	    fgets(sProj, 2, fp);
	    ifx_debug_printf ("-----project index: %s\n",sProj); 
	    chProj=sProj[0];
	    ifx_debug_printf ("-----project index ch: %c\n",chProj); 
	    nProject_Index=atoi(sProj); //get project type
	    
	   }
	    fclose(fp);	        
	}  

	if ( !gstrcmp(name, T("RegulationDomain")) )
	{
		CountryChannel_Index = g_nRegulationDomain;
		
		ifx_httpdWrite(wp, "<select name=\"wlan_domain\"");
		if (g_nCurrentAPMode==1)
		{
			ifx_httpdWrite(wp, T(" disabled"));
		}	   
		ifx_httpdWrite(wp, " onChange=\"updateChannel()\">\n");

		for (i = 0; i < 7; i++)
		{
			if (i == g_nRegulationDomain)
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_Domain_List[i].str);
			}
			else
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_Domain_List[i].str);
			}
		}
		ifx_httpdWrite(wp, "</select>");
		//return g_nRegulationDomain; //1201		
	}
	else
	if ( !gstrcmp(name, T("WlanInterface")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_STATUS, "wlan_radio", sValue) == 1 )
		{
			//if ( !gstrcmp(sValue, "YES") )
			if ( !gstrcmp(sValue, "ON") )
			{
				gstrcpy(sValue, "1");
				ifx_httpdWrite(wp,"checked");
			}
			else
			{
				gstrcpy(sValue, "0");
				ifx_httpdWrite(wp,"");
			}
		}
	}
	else
	if ( !gstrcmp(name, T("hiddenSSID")) )
	{
		//if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_STATUS, "wlan_enable", sValue) == 1 )
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_HIDDEN_SSID", sValue) == 1 )
		{
			if ( !gstrcmp(sValue, "1") )
			{
				ifx_httpdWrite(wp, T("checked"));
			}
			else
			{
				ifx_httpdWrite(wp, T(""));
			}
		}
	}
	else
	if ( !gstrcmp(name, T("channel")) )
	{
	   if (nProject_Index==1)
         {
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_CHANNEL", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);
			
			//
			if (0 == nSelIdx)
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), 0, web_Enum_ChannelMode_List[0].str);
			}
			else
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), 0, web_Enum_ChannelMode_List[0].str);
			}
			
			if(CountryChannel_Index == 0 || CountryChannel_Index == 1) // channel 1-11
			{
				for (i = 1; i <= 11; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			}else
			if(CountryChannel_Index == 2) // channel 1-13
			{
				for (i = 1; i <= 13; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			
			}else
			if(CountryChannel_Index == 3)//chaennel 10-11
			{
				for (i = 10; i <= 11; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			}else
			if(CountryChannel_Index == 4)//chaennel 10-13
			{
				for (i = 10; i <= 13; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			}else
			if(CountryChannel_Index == 5)//chaennel 14
			{
				for (i = 14; i <= 14; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			}
			else                                       //CountryChannel_Index == 6 chaennel 1- 14 
			{
				for (i = 1; i <= 14; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			}
		}		 
	   } //nProject_Index==0
	   else  if (nProject_Index==2)
         {
		//for Operation mode select box
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_OP_RATE", sValue) == 1 )
		{
			nOperateIdx = gatoi(sValue);
		}

		memset(sValue, 0x00, MAX_FILELINE_LEN);
		 
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_CHANNEL", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);

			if (nOperateIdx==4)
			{     //802.11a
			     for (i = 1; i <= 26; i++)
			     {
				if (web_Enum_Channel_LuckyWarp_List[i].value == nSelIdx)
				{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_Channel_LuckyWarp_List[i].value, web_Enum_Channel_LuckyWarp_List[i].str);
				}
				else
				{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_Channel_LuckyWarp_List[i].value, web_Enum_Channel_LuckyWarp_List[i].str);
				}
			     }
			}
			else
			{
			if(CountryChannel_Index == 0 || CountryChannel_Index == 1) // channel 1-11
			{
				for (i = 1; i <= 11; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			}else
			if(CountryChannel_Index == 2) // channel 1-13
			{
				for (i = 1; i <= 13; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			
			}else
			if(CountryChannel_Index == 3)//chaennel 10-11
			{
				for (i = 10; i <= 11; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			}else
			if(CountryChannel_Index == 4)//chaennel 10-13
			{
				for (i = 10; i <= 13; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			}else
			if(CountryChannel_Index == 5)//chaennel 14
			{
				for (i = 14; i <= 14; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			}
			else                                       //CountryChannel_Index == 6 chaennel 1- 14 
			{
				for (i = 1; i <= 14; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_ChannelMode_List[i].str);
					}
				}
			}
			        
			}//operateIndx
			
			
			
		}
		
		 
	  } //nProject_Index==1
	 
		
	}
	else
	if ( !gstrcmp(name, T("essid")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_ESSID", sValue) == 1 )
		{
		
			ifx_httpdWrite(wp, sValue);
		
		}
	}
	else
	if ( !gstrcmp(name, T("apmode_IsDisable")) )
	{
#ifdef WILDPASS
		   if (g_nCurrentAPMode==1)
		   {
		       ifx_httpdWrite(wp, T("disabled"));
		   }	   
		
#endif
	}
	else
	if ( !gstrcmp(name, T("ap_name")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_AP_NAME", sValue) == 1 )
		{
			ifx_httpdWrite(wp, sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("basic_rate")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_BASIC_RATE", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_RateMode_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == nSelIdx)
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_RateMode_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_RateMode_List[i].str);
				}
			}
		}
	}
	else
	if ( !gstrcmp(name, T("OperationMode")) )
	{
	     //--Airoha, Operation Mode List:           
		//{1,"B Mode Only"},
		//{2,"G Mode Only"},
		//{3,"B/G Mixed Mode"}
		
             //--Lucky Warp, Operation Mode List:
                //{1,"A Mode Only"},
		//{2,"B Mode Only"},
		//{3,"G Mode Only"},
		//{4,"B/G Mixed Mode"}
		             
		
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_OP_RATE", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);
			
			//keep mode
			nWirelessMode = nSelIdx;

			if (nProject_Index==1) //Airoha
			{
			for (i = 0; i < sizeof(web_Enum_OperationMode_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == (nSelIdx-1))
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_OperationMode_List[i].value, web_Enum_OperationMode_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_OperationMode_List[i].value, web_Enum_OperationMode_List[i].str);
				}
			}
		}
			else   //Lucky Warp
			{
			    for (i = 0; i < sizeof(web_Enum_Operation_Luckywarp_List)/sizeof(CGI_ENUMSEL_S); i++)
			   {
				if (i == (nSelIdx-1))
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_Operation_Luckywarp_List[i].value, web_Enum_Operation_Luckywarp_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_Operation_Luckywarp_List[i].value, web_Enum_Operation_Luckywarp_List[i].str);
				}
			    }
			    
			}

			
		}
	}
	else if (!gstrcmp(name, T("DataRate")))
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_DATA_RATE", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);
			
			if (nWirelessMode == WIRELESS_MODE_11B)
			{
				pDataRateList = web_Enum_DataRate_11b_List;
				nDataRateListSize = 5;
			}
			else if (nWirelessMode == WIRELESS_MODE_11G)
			{
				pDataRateList = web_Enum_DataRate_11g_List;
				nDataRateListSize = 9;
			}
			else
			{
				pDataRateList = web_Enum_DataRate_Mix_List;
				nDataRateListSize = 13;
			}
			
			//
			for (i = 0; i < nDataRateListSize; i++)
			{
				if (i == nSelIdx)
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, pDataRateList[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, pDataRateList[i].str);
				}
			}
		}
	}
	else if (!gstrcmp(name, T("PowerLevel")))
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_POWER_LEVEL", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);
			for (i = 0; i < 5; i++)
			{
				if (i == nSelIdx)
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_PowerLevel_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_PowerLevel_List[i].str);
				}
			}
		}
	}
	else
	if ( !gstrcmp(name, T("preamble")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_PREAMBLE", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);
			
			for (i = 0; i < sizeof(web_Enum_PreambleMode_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == (nSelIdx-1))
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_PreambleMode_List[i].value, web_Enum_PreambleMode_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_PreambleMode_List[i].value, web_Enum_PreambleMode_List[i].str);
				}
			}	
		}
	}
	else
	if ( !gstrcmp(name, T("BeaconInterval")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_BEACON_INT", sValue) == 1 )
		{
			ifx_httpdWrite(wp, sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("rts")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_RTS", sValue) == 1 )
		{
			ifx_httpdWrite(wp, sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("get_project")) )
	{
		if ( nProject_Index== 1)
		{
				ifx_httpdWrite(wp, T("1"));//Lucky Warp
		}
		else
		{
				ifx_httpdWrite(wp, T("0"));//Airoha
		}

		
		
	}
	else
	if ( !gstrcmp(name, T("fts")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_FTS", sValue) == 1 )
		{
			ifx_httpdWrite(wp, sValue);
		}
	}
	else
	if (!gstrcmp(name, T("hiddenssid_checkbox")))
	{
#ifdef WILDPASS
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_HIDDEN_SSID", sValue) == 1 )
		{
			if ( !gstrcmp(sValue, "1") )
			{
#ifdef WILDPASS
				      if (g_nCurrentAPMode==1)
				    	{
						ifx_httpdWrite(wp,T("\t\t\t<tr>\n"
		                   		 "<td width=\"30%\" height=\"25\">\n"
		                   	 	"<p><font class=\"subtitle\">SSID Broadcast </font></p>\n"
		                    		"</td>\n"
		                    		"<td width=\"70%\" height=\"25\">\n"
		                    		"<font class=\"subtitle\">\n"
		                    		"<input type=\"checkbox\" name=\"hiddenSSID\"  value=\"1\" checked disabled>Disable</font> \n"
		                    		"</td>\n"
		                    		"</tr>\n"));
						
				    	}
				    else
				    	{

						ifx_httpdWrite(wp,T("\t\t\t<tr>\n"
		                   		 "<td width=\"30%\" height=\"25\">\n"
		                   	 	"<p><font class=\"subtitle\">SSID Broadcast </font></p>\n"
		                    		"</td>\n"
		                    		"<td width=\"70%\" height=\"25\">\n"
		                    		"<font class=\"subtitle\">\n"
		                    		"<input type=\"checkbox\" name=\"hiddenSSID\"  value=\"1\" checked>Disable</font> \n"
		                    		"</td>\n"
		                    		"</tr>\n"));
				    	}
#else //#ifdef WILDPASS
					ifx_httpdWrite(wp,T("\t\t\t<tr>\n"
		                   		 "<td width=\"30%\" height=\"25\">\n"
		                   	 	"<p><font class=\"subtitle\">SSID Broadcast </font></p>\n"
		                    		"</td>\n"
		                    		"<td width=\"70%\" height=\"25\">\n"
		                    		"<font class=\"subtitle\">\n"
		                    		"<input type=\"checkbox\" name=\"hiddenSSID\"  value=\"1\" checked>Disable</font> \n"
		                    		"</td>\n"
		                    		"</tr>\n"));
#endif //#ifdef WILDPASS
			
			}
			else
			{
#ifdef WILDPASS
				 if (g_nCurrentAPMode==1)
				 {
				    ifx_httpdWrite(wp,T("\t\t\t<tr>\n"
		                    "<td width=\"30%\" height=\"25\">\n"
		                    "<p><font class=\"subtitle\">SSID Broadcast </font></p>\n"
		                    "</td>\n"
		                    "<td width=\"70%\" height=\"25\">\n"
		                    "<font class=\"subtitle\">\n"
		                    "<input type=\"checkbox\" name=\"hiddenSSID\"  value=\"0\" disabled>Disable</font> \n"
		                    "</td>\n"
		                    "</tr>\n"));
				 }
				 else
				 {
				    ifx_httpdWrite(wp,T("\t\t\t<tr>\n"
		                    "<td width=\"30%\" height=\"25\">\n"
		                    "<p><font class=\"subtitle\">SSID Broadcast </font></p>\n"
		                    "</td>\n"
		                    "<td width=\"70%\" height=\"25\">\n"
		                    "<font class=\"subtitle\">\n"
		                    "<input type=\"checkbox\" name=\"hiddenSSID\"  value=\"0\" >Disable</font> \n"
		                    "</td>\n"
		                    "</tr>\n"));
				 }
				 
#else //#ifdef WILDPASS
				 ifx_httpdWrite(wp,T("\t\t\t<tr>\n"
		                    "<td width=\"30%\" height=\"25\">\n"
		                    "<p><font class=\"subtitle\">SSID Broadcast </font></p>\n"
		                    "</td>\n"
		                    "<td width=\"70%\" height=\"25\">\n"
		                    "<font class=\"subtitle\">\n"
		                    "<input type=\"checkbox\" name=\"hiddenSSID\"  value=\"0\" >Disable</font> \n"
		                    "</td>\n"
		                    "</tr>\n"));
			     	
#endif //#ifdef WILDPASS
			}
		}
#endif //#ifdef WILDPASS
	}
	
	

	return 0;
}

#endif //#if (defined(SPURS) || defined(WILDPASS))


#if defined(RALINK)
void ifx_set_wlan_settings(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pTxBurst = ifx_httpdGetVar(wp, T("TxBurst"), T(""));
	char_t  *pTbRate = ifx_httpdGetVar(wp, T("TbRate"), T(""));
	char_t  *pChannel = ifx_httpdGetVar(wp, T("channel"), T(""));
	char_t 	*pESSID = ifx_httpdGetVar(wp, T("essid"), T(""));
//	char_t  *pAPName = ifx_httpdGetVar(wp, T("ap_name"), T(""));
//	char_t	*pBasicRate = ifx_httpdGetVar(wp, T("basic_rate"), T(""));
	char_t  *pDataRate = ifx_httpdGetVar(wp, T("data_rate"), T(""));
	char_t	*pPreamble = ifx_httpdGetVar(wp, T("preamble"), T(""));
	char_t	*pBeacon = ifx_httpdGetVar(wp, T("BeaconInterval"), T(""));
	char_t	*pRTS = ifx_httpdGetVar(wp, T("rts"), T(""));
	char_t	*pFTS = ifx_httpdGetVar(wp, T("fts"), T(""));
	char_t	sDomain[MAX_DATA_LEN], sTxBurst[MAX_DATA_LEN], sTbRate[MAX_DATA_LEN], sChannel[MAX_DATA_LEN];
	char_t	sESSID[MAX_DATA_LEN]/*, sAPName[MAX_DATA_LEN], sBasicRate[MAX_DATA_LEN]*/;
	char_t	sDataRate[MAX_DATA_LEN], sPreamble[MAX_DATA_LEN], sBeacon[MAX_DATA_LEN];
	char_t	sRTS[MAX_DATA_LEN], sFTS[MAX_DATA_LEN], sCommand[MAX_FILELINE_LEN];	
	
	if (pChannel[0] == 0 && pESSID[0] == 0 && pDataRate[0] == 0 && pPreamble[0] == 0 &&
	 	pBeacon[0] == 0 && pRTS[0] == 0 && pFTS[0] == 0)	
	{
		ifx_httpdError(wp, 200, "Failed to get data from HTML page!\n");
		return;
	}		
	// Set to rc.conf file
	gsprintf(sDomain, T("WLAN_DOMAIN=\"0\"\n"));				// The domain should check the TimeZone setting...Roger...

	if (!gstrcmp(pTxBurst, T("1")))
		gsprintf(sTxBurst, "WLAN_TXBURST=\"1\"\n");
	else		
		gsprintf(sTxBurst, "WLAN_TXBURST=\"0\"\n");

	if (!gstrcmp(pTbRate, T("1")))
		gsprintf(sTbRate, "WLAN_TBRATE=\"1\"\n");
	else		
		gsprintf(sTbRate, "WLAN_TBRATE=\"0\"\n");	
	
	gsprintf(sChannel, T("WLAN_CHANNEL=\"%s\"\n"), pChannel);
	gsprintf(sESSID, T("WLAN_ESSID=\"%s\"\n"), pESSID);
//	gsprintf(sAPName, T("WLAN_AP_NAME=\"%s\"\n"), pAPName);
//	gsprintf(sBasicRate, T("WLAN_BASIC_RATE=\"%s\"\n"), pBasicRate);
	gsprintf(sDataRate, T("WLAN_DATA_RATE=\"%s\"\n"), pDataRate);
	gsprintf(sPreamble, T("WLAN_PREAMBLE=\"%s\"\n"), pPreamble);
	gsprintf(sBeacon, T("WLAN_BEACON_INT=\"%s\"\n"), pBeacon);
	gsprintf(sRTS, T("WLAN_RTS=\"%s\"\n"), pRTS);
	gsprintf(sFTS, T("WLAN_FTS=\"%s\"\n"), pFTS);

	websSetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, 10, sDomain, sTxBurst, sTbRate, sChannel,
														sESSID,/* sAPName, sBasicRate,*/sDataRate,
														sPreamble, sBeacon, sRTS, sFTS );
#if 0 //p		no 												
	//RunTime change.
	memset(sCommand, 0x00, MAX_FILELINE_LEN);
	gsprintf(sCommand, T("iwpriv %s set Channel=%s,TxRate=%s,TxPreamble=%s,BeaconPeriod=%s,RTSThreshold=%s,FragThreshold=%s,TxBurst=%s,TurboRate=%s"), 
													ADM_WLAN_IF, pChannel, pDataRate, pPreamble,
													pBeacon, pRTS, pFTS, pTxBurst, pTbRate);	//set Channel
	system(sCommand);	
	memset(sCommand, 0x00, MAX_FILELINE_LEN);
	gsprintf(sCommand, T("iwconfig %s essid \"%s\""), ADM_WLAN_IF, pESSID);
	system(sCommand);
#endif 
	//add by calvinc 20040519 save to flash
	system(SERVICE_RESTORE);
        //end add	

	ifx_httpdNextPage(wp);
}
//#endif #ifdef RALINK
#elif defined(INPROCOMM)
//#ifdef INPROCOMM
void ifx_set_wlan_settings(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pTxBurst = ifx_httpdGetVar(wp, T("TxBurst"), T(""));
	char_t  *pTbRate = ifx_httpdGetVar(wp, T("TbRate"), T(""));
	char_t  *pChannel = ifx_httpdGetVar(wp, T("channel"), T(""));
	char_t 	*pESSID = ifx_httpdGetVar(wp, T("essid"), T(""));
//	char_t  *pAPName = ifx_httpdGetVar(wp, T("ap_name"), T(""));
//	char_t	*pBasicRate = ifx_httpdGetVar(wp, T("basic_rate"), T(""));
	char_t  *pDataRate = ifx_httpdGetVar(wp, T("data_rate"), T(""));
//	char_t	*pPreamble = ifx_httpdGetVar(wp, T("preamble"), T(""));
	char_t	*pBeacon = ifx_httpdGetVar(wp, T("BeaconInterval"), T(""));
	char_t	*pRTS = ifx_httpdGetVar(wp, T("rts"), T(""));
	char_t	*pFTS = ifx_httpdGetVar(wp, T("fts"), T(""));
	char_t	sDomain[MAX_DATA_LEN], sTxBurst[MAX_DATA_LEN], sTbRate[MAX_DATA_LEN], sChannel[MAX_DATA_LEN];
	char_t	sESSID[MAX_DATA_LEN]/*, sAPName[MAX_DATA_LEN], sBasicRate[MAX_DATA_LEN]*/;
	char_t	sDataRate[MAX_DATA_LEN], sPreamble[MAX_DATA_LEN], sBeacon[MAX_DATA_LEN];
	char_t	sRTS[MAX_DATA_LEN], sFTS[MAX_DATA_LEN], sCommand[MAX_FILELINE_LEN];	
	char_t 	*aDataRate[]  = {"0", "1000000", "2000000", "5500000", "6000000", "9000000", "11000000",
							 "12000000", "18000000", "24000000", "36000000", "48000000", "54000000"};
		
	
	if (pChannel[0] == 0 && pESSID[0] == 0 && pDataRate[0] == 0 && /*pPreamble[0] == 0 &&*/
	 	pBeacon[0] == 0 && pRTS[0] == 0 && pFTS[0] == 0)	
	{
		ifx_httpdError(wp, 200, "Failed to get data from HTML page!\n");
		return;
	}		
	// Set to rc.conf file
	gsprintf(sDomain, T("WLAN_DOMAIN=\"0\"\n"));				// The domain should check the TimeZone setting...Roger...

	if (!gstrcmp(pTxBurst, T("1")))
		gsprintf(sTxBurst, "WLAN_TXBURST=\"1\"\n");
	else		
		gsprintf(sTxBurst, "WLAN_TXBURST=\"0\"\n");
	
	if (!gstrcmp(pTbRate, T("1")))
		gsprintf(sTbRate, "WLAN_TBRATE=\"1\"\n");
	else		
		gsprintf(sTbRate, "WLAN_TBRATE=\"0\"\n");	
	
	gsprintf(sChannel, T("WLAN_CHANNEL=\"%s\"\n"), pChannel);
	gsprintf(sESSID, T("WLAN_ESSID=\"%s\"\n"), pESSID);
//	gsprintf(sAPName, T("WLAN_AP_NAME=\"%s\"\n"), pAPName);
//	gsprintf(sBasicRate, T("WLAN_BASIC_RATE=\"%s\"\n"), pBasicRate);
	gsprintf(sDataRate, T("WLAN_DATA_RATE=\"%s\"\n"), pDataRate);
//	gsprintf(sPreamble, T("WLAN_PREAMBLE=\"%s\"\n"), pPreamble);
	gsprintf(sPreamble, T("WLAN_PREAMBLE=\"0\"\n"));				// Key this to used the same rc.conf
	gsprintf(sBeacon, T("WLAN_BEACON_INT=\"%s\"\n"), pBeacon);
	gsprintf(sRTS, T("WLAN_RTS=\"%s\"\n"), pRTS);
	gsprintf(sFTS, T("WLAN_FTS=\"%s\"\n"), pFTS);

	websSetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, 10, sDomain, sTxBurst, sTbRate, sChannel, 
														sESSID,/* sAPName, sBasicRate,*/sDataRate,
														sPreamble, sBeacon, sRTS, sFTS );
#if 0 //p no														
	//RunTime change.
	memset(sCommand, 0x00, MAX_FILELINE_LEN);
//	gsprintf(sCommand, T("iwpriv %s set Channel=%s,TxRate=%s,TxPreamble=%s,BeaconPeriod=%s,RTSThreshold=%s,FragThreshold=%s,TxBurst=%s,TurboRate=%s"), 
//													ADM_WLAN_IF, pChannel, pDataRate, pPreamble,
//													pBeacon, pRTS, pFTS, pTxBurst, pTbRate);	//set Channel
	gsprintf(sCommand, T("iwpriv %s channel %s"), ADM_WLAN_IF, pChannel);	
	system(sCommand);	
	gsprintf(sCommand, T("iwpriv %s rate %d"), ADM_WLAN_IF, aDataRate[atoi(pChannel)]);	
	system(sCommand);
	gsprintf(sCommand, T("iwpriv %s beaconperiod %s"), ADM_WLAN_IF, pBeacon);	
	system(sCommand);
	gsprintf(sCommand, T("iwpriv %s rts %s"), ADM_WLAN_IF, pRTS);
	system(sCommand);
	gsprintf(sCommand, T("iwpriv %s flag %s"), ADM_WLAN_IF, pFTS);	
	system(sCommand);
	gsprintf(sCommand, T("iwpriv %s burstmode %s"), ADM_WLAN_IF, pTxBurst);	
	system(sCommand);
	gsprintf(sCommand, T("iwpriv %s essid \"%s\""), ADM_WLAN_IF, pESSID);
	system(sCommand);		
#endif //p
	//add by calvinc 20040519 save to flash
	system(SERVICE_RESTORE);
        //end add
		
	ifx_httpdNextPage(wp);
}
//#endif //#ifdef INPROCOMM
#elif (defined(WILDPASS) || (defined(GATEWAY) && defined(SPURS)))
//#if defined(WILDPASS) || (defined(GATEWAY) && defined(SPURS))
void ifx_set_wlan_settings(httpd_t wp, char_t *path, char_t *query)
{
       char_t	sValue[MAX_FILELINE_LEN];
	char_t	*pDomain = ifx_httpdGetVar(wp, T("wlan_domain"), T(""));
	char_t	*pTxBurst = ifx_httpdGetVar(wp, T("TxBurst"), T(""));
	char_t  *pTbRate = ifx_httpdGetVar(wp, T("TbRate"), T(""));
	char_t	*pWlanInterface = ifx_httpdGetVar(wp, T("WlanInterface"), T(""));
    char_t    *pHiddenSSID = ifx_httpdGetVar(wp, T("hiddenSSID"), T(""));
	char_t  *pChannel = ifx_httpdGetVar(wp, T("channel"), T(""));
	char_t 	*pESSID = ifx_httpdGetVar(wp, T("essid"), T(""));
	char_t 	*pAP_Name = ifx_httpdGetVar(wp, T("ap_name"), T(""));
	char_t  *pOPRate = ifx_httpdGetVar(wp, T("OperationMode"), T(""));
	char_t	*pDataRate = ifx_httpdGetVar(wp, T("data_rate"), T(""));
	char_t	*pPowerLevel = ifx_httpdGetVar(wp, T("power_level"), T(""));
	char_t  *pPreamble = ifx_httpdGetVar(wp,T("preamble"),T(""));
	char_t	*pBeacon = ifx_httpdGetVar(wp, T("BeaconInterval"), T(""));
	char_t	*pRTS = ifx_httpdGetVar(wp, T("rts"), T(""));
	char_t	*pFTS = ifx_httpdGetVar(wp, T("fts"), T(""));
	
	char_t	sDomain[MAX_DATA_LEN],  sChannel[MAX_DATA_LEN];
	char_t  sTxBurst[MAX_DATA_LEN], sTbRate[MAX_DATA_LEN];
	char_t  sWlanInterface[MAX_DATA_LEN],sOPRate[MAX_DATA_LEN];
	char_t	sESSID[MAX_DATA_LEN],sAP_Name[MAX_DATA_LEN],shidden_SSID[MAX_DATA_LEN];
	char_t	sPreamble[MAX_DATA_LEN], sBeacon[MAX_DATA_LEN];
	char_t	sRTS[MAX_DATA_LEN], sFTS[MAX_DATA_LEN];
	char_t	sDisableIfCmd[MAX_DATA_LEN];
	char_t	s11hCmd[MAX_DATA_LEN];
	
	char_t szDataRate[MAX_DATA_LEN];
	char_t szPowerLevel[MAX_DATA_LEN];
	
       int ESSID_LENGTH=0;
	char_t      sTMD[64],stmpTMD[64];
	int           TMDCount[64];
	int           i,j,count=0,TotalCount=0;
	int          APMode;
	bool_t      mTMD=FALSE;
		
	
	memset(TMDCount, 0x00, 64);	
	memset(sTMD, 0x00, 64);

	memset(sValue, 0x00, MAX_FILELINE_LEN);	

	memset(s11hCmd, 0x00, MAX_DATA_LEN);	

      //to check which mode 
      
	//char_t	sValue[MAX_DATA_LEN];
       //memset(sValue, 0x00, MAX_DATA_LEN); 

       //CHECK IF AP Client Mode
       if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, "WLAN_CURRENT_MODE", sValue) == 1 )
	{
           if ( !gstrcmp(sValue, "0") )
	      APMode=0; //ap
	    else  if ( !gstrcmp(sValue, "1") )
		APMode=1; //client
	    else  if ( !gstrcmp(sValue, "2") )
		APMode=2;  //wds 
	    
	}
	
	

	if (pChannel[0] == 0 &&  pBeacon[0] == 0 && pRTS[0] == 0 && pFTS[0] == 0)	
	{
		ifx_httpdError(wp, 200, "Failed to get data from HTML page!\n");
		return;
	}
	
	// Set to rc.conf file
	
	//domain
	gsprintf(sDomain, T("WLAN_DOMAIN=\"%s\"\n"), pDomain);				// The domain should check the TimeZone setting...Roger...

	//
	if (!gstrcmp(pTxBurst, T("1")))
		gsprintf(sTxBurst, "WLAN_TXBURST=\"1\"\n");
	else		
		gsprintf(sTxBurst, "WLAN_TXBURST=\"0\"\n");
	
	if (!gstrcmp(pTbRate, T("1")))
		gsprintf(sTbRate, "WLAN_TBRATE=\"1\"\n");
	else		
		gsprintf(sTbRate, "WLAN_TBRATE=\"0\"\n");	

	memset(sDisableIfCmd, 0x00, MAX_DATA_LEN);
	if (!gstrcmp(pWlanInterface, T("1")))
	{
		gsprintf(sWlanInterface, "wlan_radio=\"ON\"\n");
		gsprintf(sDisableIfCmd, "ifconfig %s up", ADM_WLAN_IF);
	}
	else		
	{
		gsprintf(sWlanInterface, "wlan_radio=\"OFF\"\n");
		gsprintf(sDisableIfCmd, "ifconfig %s down", ADM_WLAN_IF);
	}

      //AP Client mode UI field is disabled AND Need to get original value
	if (g_nCurrentAPMode==1)  
	{
	   ifx_debug_printf("-----g_nCurrentAPMode 1 setting fields--\n");
	   
	   //Channel field
	    if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_CHANNEL", sValue) == 1)
		  gsprintf(sChannel, T("WLAN_CHANNEL=\"%s\"\n"), sValue);
	    else
		  gsprintf(sChannel, T("WLAN_CHANNEL=\"0\"\n"));	

	   //ESSID  
	   if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_ESSID", sValue) == 1 )
	         gsprintf(sESSID, T("WLAN_ESSID=\"%s\"\n"), sValue);	
	   else	
                gsprintf(sESSID, T("WLAN_ESSID=\"0\"\n"));
 
         //AP Name
         if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_AP_NAME", sValue) == 1 )
		gsprintf(sAP_Name, T("WLAN_AP_NAME=\"%s\"\n"), sValue); 	
	  else
	  	gsprintf(sAP_Name, T("WLAN_AP_NAME=\"0\"\n"));

	  //Beacon Interval
	  if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_BEACON_INT", sValue) == 1 )
	       gsprintf(sBeacon, T("WLAN_BEACON_INTERVAL=\"%s\"\n"), sValue);
	  else
	  	gsprintf(sBeacon, T("WLAN_BEACON_INTERVAL=\"0\"\n"));

	  // for hidden SSID
         if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_HIDDEN_SSID", sValue) == 1 )
	  {
	      if ( !gstrcmp(sValue, "1") )		
		 gsprintf(shidden_SSID, T("WLAN_HIDDEN_SSID=\"%s\"\n"), "1");
	      else
		 gsprintf(shidden_SSID, T("WLAN_HIDDEN_SSID=\"0\"\n"));
	  }
	  else
	  {
	       //ifx_debug_printf("-----pHiddenSSID-0--\n");
		gsprintf(shidden_SSID, T("WLAN_HIDDEN_SSID=\"0\"\n"));
	  }
	  
	}
	else
	{
		//channel
		gsprintf(sChannel, T("WLAN_CHANNEL=\"%s\"\n"), pChannel);
		
		gsprintf(sESSID, T("WLAN_ESSID=\"%s\"\n"), pESSID);	
		gsprintf(sAP_Name, T("WLAN_AP_NAME=\"%s\"\n"), pAP_Name);

		
		ifx_debug_printf("######################pESSID = %c\n",pESSID[0]);

	
	//
		ESSID_LENGTH = gstrlen(pESSID);
		
		for(i=0;i<ESSID_LENGTH ;i++)
		{			
			gsprintf(stmpTMD,  T("%s"), &pESSID[i]);
			if(strncmp(stmpTMD,"%",1) == 0)
			{
				TMDCount[count]=i;
				count++;
				mTMD = TRUE;
			}
		}

		TotalCount = count;

		if(mTMD == TRUE)  
		{
			gsprintf(stmpTMD,  T("%s"), pESSID);
			switch(TotalCount){		
				case 1:
					
					for(i=0;i<ESSID_LENGTH;i++){
						count = 0;
						if(i<TMDCount[count]){
							sTMD[i] = stmpTMD[i];
						}
						else if(i== TMDCount[count]){
							sTMD[i]=sTMD[i+1] = stmpTMD[i];
						}else 
						{
							sTMD[i+count+1] = stmpTMD[i];
						}		
					}
				break;
				default:
					
					for(i=0;i<TotalCount;i++){
						for(j=0;j<ESSID_LENGTH;j++){
						   if(i==0)
						   {
								if(j<TMDCount[i]){
									sTMD[j] = stmpTMD[j];
								}
								else if(j== TMDCount[i]){
									sTMD[j]=sTMD[j+1] = stmpTMD[j];
								}else 
								{
									sTMD[j+i+1] = stmpTMD[j];
								}
							}else 
							{
								if(j<TMDCount[i]){
								;
							       }
								else if(j==TMDCount[i])
							   	{
								sTMD[TMDCount[i]+i]=sTMD[TMDCount[i]+i+1] = stmpTMD[j];
								}else if(j>TMDCount[i]){
									sTMD[j+i+1] = stmpTMD[j];
								}	
								
							}
					         }
				        }			
				break;			
		   }		
	    }
	    else{
		gsprintf(sTMD,  T("%s"), pESSID);
	    }
	    gsprintf(sESSID, T("WLAN_ESSID=\"%s\"\n"), sTMD);

	    gsprintf(sBeacon, T("WLAN_BEACON_INTERVAL=\"%s\"\n"), pBeacon);

	    // for hidden SSID
           if (pHiddenSSID && *pHiddenSSID)
	    {
	       ifx_debug_printf("-----pHiddenSSID-1--\n");
		//gsprintf(shidden_SSID, T("WLAN_HIDDEN_SSID=\"%s\"\n"), pHiddenSSID);//original
		gsprintf(shidden_SSID, T("WLAN_HIDDEN_SSID=\"%s\"\n"), "1");
	    }
	    else
	    {
	       ifx_debug_printf("-----pHiddenSSID-0--\n");
		gsprintf(shidden_SSID, T("WLAN_HIDDEN_SSID=\"0\"\n"));
	    }
	}//apclient mode
		
	//
	
	gsprintf(sOPRate, T("WLAN_OP_RATE=\"%s\"\n"), pOPRate);
	gsprintf(sPreamble, T("WLAN_PREAMBLE=\"%s\"\n"), pPreamble);
	
	gsprintf(sRTS, T("WLAN_RTS=\"%s\"\n"), pRTS);
	gsprintf(sFTS, T("WLAN_FTS=\"%s\"\n"), pFTS);

	//
	gsprintf(szDataRate, T("WLAN_DATA_RATE=\"%s\"\n"), pDataRate);
	gsprintf(szPowerLevel, T("WLAN_POWER_LEVEL=\"%s\"\n"), pPowerLevel);
	
	//websSetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, 10, sDomain, sChannel,
		//												shidden_SSID,sESSID,sAP_Name,sOPRate,
			//											sPreamble, sBeacon, sRTS, sFTS );
	websSetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, 12, sDomain, sChannel,
														shidden_SSID,sESSID,sAP_Name,sOPRate,
														sPreamble, sBeacon, sRTS, sFTS,
														szDataRate, szPowerLevel);

	websSetCfgData(FILE_RC_CONF, TAG_WLAN_STATUS, 1,sWlanInterface );

	
       if (!( !gstrcmp(pOPRate, "4")))      //op rate is not 11a Mode
       {
          gsprintf(s11hCmd, T("WLAN_11H_STATUS=\"0\"\n"));
          websSetCfgData(FILE_RC_CONF, TAG_WLAN_11HSETTINGS, 1,s11hCmd);
	   ifx_debug_printf("----update TAG_WLAN_11HSETTINGS 0----\n");
       }
		


	system(SERVICE_RESTORE);
#if 0 //p no	
	system(sDisableIfCmd);

	if (APMode==0)
	  system(SERVICE_WLAN); //AP
	else if (APMode==1)
	  system(SERVICE_WLAN_APCLIENT); //CLIENT MODE
       else if (APMode==2)
	  system(SERVICE_WLAN_WDS);  //WDS MODE
#endif //p	
	ifx_httpdNextPage(wp);	                                
//	sleep(3);
}
//#endif //#if defined(WILDPASS) || (defined(GATEWAY) && defined(SPURS))
#elif (defined(ATA) && defined(SPURS))
//#if (defined(ATA) && defined(SPURS))
void ifx_set_wlan_settings(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pTxBurst = ifx_httpdGetVar(wp, T("TxBurst"), T(""));
	char_t  *pTbRate = ifx_httpdGetVar(wp, T("TbRate"), T(""));
	char_t	*pWlanInterface = ifx_httpdGetVar(wp, T("WlanInterface"), T(""));
	char_t  *pChannel = ifx_httpdGetVar(wp, T("channel"), T(""));
	char_t 	*pESSID = ifx_httpdGetVar(wp, T("essid"), T(""));
	char_t 	*pAP_Name = ifx_httpdGetVar(wp, T("ap_name"), T(""));
	char_t  *pOPRate = ifx_httpdGetVar(wp, T("OperationMode"), T(""));
	char_t  *pPreamble = ifx_httpdGetVar(wp,T("preamble"),T(""));
	char_t	*pBeacon = ifx_httpdGetVar(wp, T("BeaconInterval"), T(""));
	char_t	*pRTS = ifx_httpdGetVar(wp, T("rts"), T(""));
	char_t	*pFTS = ifx_httpdGetVar(wp, T("fts"), T(""));
	char_t	sDomain[MAX_DATA_LEN],  sChannel[MAX_DATA_LEN];
	char_t  sTxBurst[MAX_DATA_LEN], sTbRate[MAX_DATA_LEN];
	char_t  sWlanInterface[MAX_DATA_LEN],sOPRate[MAX_DATA_LEN];
	char_t	sESSID[MAX_DATA_LEN],sAP_Name[MAX_DATA_LEN],shidden_SSID[MAX_DATA_LEN];
	char_t	sPreamble[MAX_DATA_LEN], sBeacon[MAX_DATA_LEN];
	char_t	sRTS[MAX_DATA_LEN], sFTS[MAX_DATA_LEN];
	char_t	sDisableIfCmd[MAX_DATA_LEN];
       int ESSID_LENGTH=0;
	char_t      sTMD[64],stmpTMD[64];
	int           TMDCount[64];
	int           i,j,count=0,TotalCount=0;
	bool_t      mTMD=FALSE;
		
	
		memset(TMDCount, 0x00, 64);	
		memset(sTMD, 0x00, 64);	

	if (pChannel[0] == 0 &&  pBeacon[0] == 0 && pRTS[0] == 0 && pFTS[0] == 0)	
	{
		ifx_httpdError(wp, 200, "Failed to get data from HTML page!\n");
		return;
	}		
	// Set to rc.conf file
	gsprintf(sDomain, T("WLAN_DOMAIN=\"0\"\n"));				// The domain should check the TimeZone setting...Roger...

	if (!gstrcmp(pTxBurst, T("1")))
		gsprintf(sTxBurst, "WLAN_TXBURST=\"1\"\n");
	else		
		gsprintf(sTxBurst, "WLAN_TXBURST=\"0\"\n");
	
	if (!gstrcmp(pTbRate, T("1")))
		gsprintf(sTbRate, "WLAN_TBRATE=\"1\"\n");
	else		
		gsprintf(sTbRate, "WLAN_TBRATE=\"0\"\n");	

	memset(sDisableIfCmd, 0x00, MAX_DATA_LEN);
	if (!gstrcmp(pWlanInterface, T("1")))
	{
		gsprintf(sWlanInterface, "wlan_radio=\"ON\"\n");
		gsprintf(sDisableIfCmd, "ifconfig %s up", ADM_WLAN_IF);
	}
	else
	{
		gsprintf(sWlanInterface, "wlan_radio=\"OFF\"\n");
		gsprintf(sDisableIfCmd, "ifconfig %s down", ADM_WLAN_IF);
	}

	
	gsprintf(sChannel, T("WLAN_CHANNEL=\"%s\"\n"), pChannel);
	gsprintf(sESSID, T("WLAN_ESSID=\"%s\"\n"), pESSID);	
	ifx_debug_printf("######################pESSID = %c\n",pESSID[0]);

	gsprintf(sAP_Name, T("WLAN_AP_NAME=\"%s\"\n"), pAP_Name);
	//
	ESSID_LENGTH = gstrlen(pESSID);
		
		for(i=0;i<ESSID_LENGTH ;i++)
		{			
			gsprintf(stmpTMD,  T("%s"), &pESSID[i]);
			if(strncmp(stmpTMD,"%",1) == 0)
			{
				TMDCount[count]=i;
				count++;
				mTMD = TRUE;
			}
		}

		TotalCount = count;

		if(mTMD == TRUE)  
		{
			gsprintf(stmpTMD,  T("%s"), pESSID);
			switch(TotalCount){		
				case 1:
					
					for(i=0;i<ESSID_LENGTH;i++){
						count = 0;
						if(i<TMDCount[count]){
							sTMD[i] = stmpTMD[i];
						}
						else if(i== TMDCount[count]){
							sTMD[i]=sTMD[i+1] = stmpTMD[i];
						}else 
						{
							sTMD[i+count+1] = stmpTMD[i];
						}		
					}
				break;
				default:
					
					for(i=0;i<TotalCount;i++){
						for(j=0;j<ESSID_LENGTH;j++){
							if(i==0){
								if(j<TMDCount[i]){
									sTMD[j] = stmpTMD[j];
								}
								else if(j== TMDCount[i]){
									sTMD[j]=sTMD[j+1] = stmpTMD[j];
								}else 
								{
									sTMD[j+i+1] = stmpTMD[j];
								}
							}else 
							{
								if(j<TMDCount[i]){
								;
							}
							else if(j==TMDCount[i])
							{
								sTMD[TMDCount[i]+i]=sTMD[TMDCount[i]+i+1] = stmpTMD[j];
							}else if(j>TMDCount[i]){
							sTMD[j+i+1] = stmpTMD[j];
							}						
						}
					}
				}			
				break;			
		}		
	}
	else{
		gsprintf(sTMD,  T("%s"), pESSID);
	}
	gsprintf(sESSID, T("WLAN_ESSID=\"%s\"\n"), sTMD);	
	//
	// for hidden SSID
	if (!gstrcmp(pESSID, T("")))
	{
		ifx_debug_printf("########################1");
		gsprintf(shidden_SSID, T("WLAN_HIDDEN_SSID=\"1\"\n"));
		gsprintf(sESSID, T("WLAN_ESSID=\" \"\n"));	
	}else
	{
			ifx_debug_printf("########################2");
		gsprintf(shidden_SSID, T("WLAN_HIDDEN_SSID=\"0\"\n"));
	}

	gsprintf(sOPRate, T("WLAN_OP_RATE=\"%s\"\n"), pOPRate);
	gsprintf(sPreamble, T("WLAN_PREAMBLE=\"%s\"\n"), pPreamble);
	gsprintf(sBeacon, T("WLAN_BEACON_INTERVAL=\"%s\"\n"), pBeacon);
	gsprintf(sRTS, T("WLAN_RTS=\"%s\"\n"), pRTS);
	gsprintf(sFTS, T("WLAN_FTS=\"%s\"\n"), pFTS);

	websSetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, 10, sDomain, sChannel,
														shidden_SSID,sESSID,sAP_Name,sOPRate,
														sPreamble, sBeacon, sRTS, sFTS );

	websSetCfgData(FILE_RC_CONF, TAG_WLAN_STATUS, 1,sWlanInterface );


	system(SERVICE_RESTORE);
#if 0 //p	
	system(sDisableIfCmd);
	system(SERVICE_WLAN);
#endif //p	
	ifx_httpdNextPage(wp);	                                
//	sleep(3);
}
#endif //#if defined(ATA) && defined(SPURS)
