/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

extern int g_nCurrentAPMode;

CGI_ENUMSEL_S web_Enum_WDSChannel_List [] =
{
	{0, "         "},
	{1, "Channel 1"},
	{2, "Channel 2"},
	{3, "Channel 3"},
	{4, "Channel 4"},
	{5, "Channel 5"},
	{6, "Channel 6"},
	{7, "Channel 7"},
	{8, "Channel 8"},
	{9, "Channel 9"},
	{10, "Channel 10"},
	{11, "Channel 11"},
	{12, "Channel 12"},
	{13, "Channel 13"},
	{14, "Channel 14"}
};


CGI_ENUMSEL_S web_Enum_WDSEncryType_List [] =
{
	{0, "None"},
	{1, "Share"},
	//{2, "802.1X"},
	
};

CGI_ENUMSEL_S web_Enum_WDSAuthType_List [] =
{
	{1, "Open System"},
	{2, "Shared Key"},
	{3, "Auto Switch"},	
};

CGI_ENUMSEL_S web_Enum_WDSWepType_List [] =
{
	{0, "Disable"},
	{1, "Enable 64"},
	{2, "Enable 128"}
};

CGI_ENUMSEL_S web_Enum_WDSKeyUsed_List [] =
{
//	{0, "None"},
	{1, "Key 1"},
	{2, "Key 2"},
	{3, "Key 3"},
	{4, "Key 4"},
};


#if (defined(SPURS) || defined(WILDPASS))
int ifx_get_wlan_wdssettings(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name, sValue[MAX_FILELINE_LEN];
	int		i, nSelIdx = 0;
	int          nEncrySelIdx = 0;
	int          CountryChannel_Index = 0;

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	if ( !gstrcmp(name, T("channel")) )
	{
	  	if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_CHANNEL", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);
			if(CountryChannel_Index == 0 || CountryChannel_Index == 1) // channel 1-11
			{
				for (i = 1; i <= 11; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
				}
			}else
			if(CountryChannel_Index == 2) // channel 1-13
			{
				for (i = 1; i <= 13; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
				}
			
			}else
			if(CountryChannel_Index == 3)//chaennel 10-11
			{
				for (i = 10; i <= 11; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
				}
			}else
			if(CountryChannel_Index == 4)//chaennel 10-13
			{
				for (i = 10; i <= 13; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
				}
			}else
			if(CountryChannel_Index == 5)//chaennel 14
			{
				for (i = 14; i <= 14; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
				}
			}
			else                                       //CountryChannel_Index == 6 chaennel 1- 14 
			{
				for (i = 1; i <= 14; i++)
				{
					if (i == nSelIdx)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
					else
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_WDSChannel_List[i].str);
					}
				}
			}
		}		 	 
		
	}
	else
	if ( !gstrcmp(name, T("essid")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_ESSID", sValue) == 1 )
		{
		       if (!gstrcmp(sValue,"0"))
			 ifx_httpdWrite(wp, T(""));		
		      else
	      		ifx_httpdWrite(wp, T("%s"), sValue);
			//ifx_httpdWrite(wp, sValue);
		
		}
	}
	else
	if ( !gstrcmp(name, T("wdsmode_IsDisable")) )
	{
		
		   if (g_nCurrentAPMode==2) //WDS mode default setting
		   {
		       ifx_httpdWrite(wp, T("disabled"));
		   }	   
		
		
	}
	else
   	if ( !gstrcmp(name, T("EncryType")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_ENCRY_TYPE", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);
			for (i = 0; i < sizeof(web_Enum_WDSEncryType_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == nSelIdx)
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_WDSEncryType_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_WDSEncryType_List[i].str);
				}
			}
		}
	}
	else if ( !gstrcmp(name, T("AuthType")) )
	{
		
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_AUTH_TYPE", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);
				
			for (i = 0; i < sizeof(web_Enum_WDSAuthType_List)/sizeof(CGI_ENUMSEL_S); i++) //original
			{
				 if (i == (nSelIdx-1))
				{
					 ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_WDSAuthType_List[i].value, web_Enum_WDSAuthType_List[i].str);
				}
				else
				{
				 	 ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_WDSAuthType_List[i].value, web_Enum_WDSAuthType_List[i].str);
				}
			}					
				
		}
	
		
	}
	else if ( !gstrcmp(name, T("KeyUsed")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_WDSSETTINGS, "WLAN_WDS_KEY_USED", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_WDSKeyUsed_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == (nSelIdx-1))
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_WDSKeyUsed_List[i].value, web_Enum_WDSKeyUsed_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"),web_Enum_WDSKeyUsed_List[i].value, web_Enum_WDSKeyUsed_List[i].str);
				}
			}
		}
	}
	else if ( !gstrcmp(name, T("Key1")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_WDSSETTINGS, "WLAN_WDS_KEY1", sValue) == 1 )
		{		
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
							
		}
	}
	else if ( !gstrcmp(name, T("Key2")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_WDSSETTINGS, "WLAN_WDS_KEY2", sValue) == 1 )
		{			
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
	else if ( !gstrcmp(name, T("Key3")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_WDSSETTINGS, "WLAN_WDS_KEY3", sValue) == 1 )
		{
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
	else if ( !gstrcmp(name, T("Key4")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_WDSSETTINGS, "WLAN_WDS_KEY4", sValue) == 1 )
		{
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
	else if ( !gstrcmp(name, T("PSK")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_WDSSETTINGS, "WLAN_WDS_PSK", sValue) == 1 )
		{			
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
	else if ( !gstrcmp(name, T("Passphrase")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_WDSSETTINGS, "WLAN_WDS_PASSPHRASE", sValue) == 1 )
		{
			if ( !gstrcmp(sValue, "1") )
			{
				gstrcpy(sValue, "1");
			}
			else
			{
				gstrcpy(sValue, "0");
			}
		}
		#if 0
		ejSetResult(eid, sValue);
		#else
		#endif
	}


	return 0;
}


void ifx_set_wlan_wdssettings(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pEncryType, *pAuthType, *pKeyUsed, *pKey1, *pKey2, *pKey3, *pKey4, *pPsk,*pRadiusSecret;	
	//char_t  *pRadiusIp1_1,*pRadiusIp1_2,*pRadiusIp1_3,*pRadiusIp1_4;//,*pRadius_Port;	
	char_t	sEncryType[MAX_DATA_LEN], sAuthType[MAX_DATA_LEN];//, sWepType[MAX_DATA_LEN];
	char_t	sKeyUsed[MAX_DATA_LEN], sKey1[MAX_FILELINE_LEN], sKey2[MAX_FILELINE_LEN];
	char_t	sKey3[MAX_FILELINE_LEN], sKey4[MAX_FILELINE_LEN];//, sCommand[MAX_FILELINE_LEN];
	char_t	sPsk[MAX_FILELINE_LEN], sPassPhrase[MAX_FILELINE_LEN];
	//char_t 	sESSID[MAX_FILELINE_LEN];
	char_t 	sWepKey[MAX_FILELINE_LEN];
	//char_t  sRadiusSecret[MAX_FILELINE_LEN];
	//char_t  sRadiusIp1[MAX_FILELINE_LEN];
	//char_t  sRadiusPort[MAX_FILELINE_LEN];
	char_t  sWEPKeyLength[MAX_DATA_LEN];
	int     WEPKeyLength=0,PSKKeyLength=0;
	char_t  sTMD[MAX_FILELINE_LEN],stmpTMD[MAX_FILELINE_LEN];		// TMD size must greater than input value(64+"/0")
	int     TMDCount[MAX_FILELINE_LEN];		
	int     i,j,count=0, TotalCount=0;
	bool_t  bPercent=FALSE;
       //char_t	sTempIp1[MAX_FILELINE_LEN],sTempIp2[MAX_FILELINE_LEN],sTempIp3[MAX_FILELINE_LEN],sTempIp4[MAX_FILELINE_LEN];
	char_t	sValue[MAX_FILELINE_LEN];
	//char_t	sESSID[MAX_DATA_LEN],  sChannel[MAX_DATA_LEN];
	//char_t  *pChannel = ifx_httpdGetVar(wp, T("channel"), T(""));
	//char_t 	*pESSID = ifx_httpdGetVar(wp, T("essid"), T(""));

	memset(TMDCount, 0x00, MAX_FILELINE_LEN);	
	memset(sTMD, 0x00, MAX_FILELINE_LEN);	
	memset(stmpTMD, 0x00, MAX_FILELINE_LEN);	
	
	a_assert(wp);
	memset(sPsk, 0x00, MAX_FILELINE_LEN);	
	memset(sPassPhrase, 0x00, MAX_FILELINE_LEN);	
//	memset(sESSID, 0x00, MAX_FILELINE_LEN);
	memset(sWepKey, 0x00, MAX_FILELINE_LEN);	

	memset(sKey1,0x00,MAX_FILELINE_LEN);
	memset(sKey2,0x00,MAX_FILELINE_LEN);
	memset(sKey3,0x00,MAX_FILELINE_LEN);
	memset(sKey4,0x00,MAX_FILELINE_LEN);	
	//memset(sRadiusPort,0x00,MAX_FILELINE_LEN);
	memset(sEncryType,0x00,MAX_DATA_LEN);
	memset(sAuthType,0x00,MAX_DATA_LEN);

       //memset(sTempIp1,0x00,MAX_FILELINE_LEN);
	//memset(sTempIp2,0x00,MAX_FILELINE_LEN);
	//memset(sTempIp3,0x00,MAX_FILELINE_LEN);
	//memset(sTempIp4,0x00,MAX_FILELINE_LEN);	

	memset(sValue,0x00,MAX_FILELINE_LEN);

	// Get value from ASP file
	pEncryType = ifx_httpdGetVar(wp, T("EncryType"), T(""));
	pAuthType = ifx_httpdGetVar(wp, T("AuthType"), T(""));
	pKeyUsed = ifx_httpdGetVar(wp, T("KeyUsed"), T(""));

   
	//gsprintf(sChannel, T("WLAN_WDS_CHANNEL=\"%s\"\n"), pChannel);
	//if (pESSID&& *pESSID)	
	//    gsprintf(sESSID,    T("WLAN_WDS_ESSID=\"%s\"\n"), pESSID);
	//else
	 //    gsprintf(sESSID,    T("WLAN_WDS_ESSID=\"0\"\n"));

	
	//pRadiusSecret = ifx_httpdGetVar(wp,T("secret1"),T(""));
	//pRadiusIp1_1 = ifx_httpdGetVar(wp, T("RadiusIp1_1"),T(""));
	//pRadiusIp1_2 = ifx_httpdGetVar(wp, T("RadiusIp1_2"),T(""));
	//pRadiusIp1_3 = ifx_httpdGetVar(wp, T("RadiusIp1_3"),T(""));
	//pRadiusIp1_4 = ifx_httpdGetVar(wp, T("RadiusIp1_4"),T(""));

	//ifx_debug_printf("--RadiusIp1_1 is:%s\n",pRadiusIp1_1);
	//ifx_debug_printf("--RadiusIp1_2 is:%s\n",pRadiusIp1_2);
	//ifx_debug_printf("--RadiusIp1_3 is:%s\n",pRadiusIp1_3);
	//ifx_debug_printf("--RadiusIp1_4 is:%s\n",pRadiusIp1_4);
	//ifx_debug_printf("---RadiusSecret is:%s\n",pRadiusSecret);


	gsprintf(sEncryType, T("WLAN_WDS_ENCRY_TYPE=\"%s\"\n"), pEncryType);
	gsprintf(sAuthType, T("WLAN_WDS_AUTH_TYPE=\"%s\"\n"), pAuthType);

	switch (atoi(pAuthType))				
	{
	//case WLAN_ENCRY_NONE: // Normal mode		
	case WLAN_AUTH_NONE:
		switch(atoi(pEncryType))
		{
			case WLAN_ENCRY_NONE:
				gsprintf(sWEPKeyLength, T("WLAN_WDS_8021X_KEYLEN=\"0\"\n")); 	
				gsprintf(sKeyUsed, T("WLAN_WDS_KEY_USED=\"0\"\n"));
				gsprintf(sKey1, T("WLAN_WDS_KEY1=\"0\"\n"));
				gsprintf(sKey2, T("WLAN_WDS_KEY2=\"0\"\n"));
				gsprintf(sKey3, T("WLAN_WDS_KEY3=\"0\"\n"));
				gsprintf(sKey4, T("WLAN_WDS_KEY4=\"0\"\n"));	
				gsprintf(sPsk,  T("WLAN_WDS_PSK=\"0\"\n"));	

				break;
			case WLAN_ENCRY_SHARED:
				pKey1 = ifx_httpdGetVar(wp, T("Key1"), T(""));
				pKey2 = ifx_httpdGetVar(wp, T("Key2"), T(""));
				pKey3 = ifx_httpdGetVar(wp, T("Key3"), T(""));
				pKey4 = ifx_httpdGetVar(wp, T("Key4"), T(""));
				if ( !pKey1[0] ) gsprintf(pKey1, "0");
				if ( !pKey2[0]) gsprintf(pKey2, "0");
				if ( !pKey3[0]) gsprintf(pKey3, "0");
				if ( !pKey4[0]) gsprintf(pKey4, "0");
				gsprintf(sWEPKeyLength, T("WLAN_WDS_8021X_KEYLEN=\"0\"\n")); 	
			       gsprintf(sKeyUsed, T("WLAN_WDS_KEY_USED=\"%s\"\n"), pKeyUsed);		
				gsprintf(sKey1, T("WLAN_WDS_KEY1=\"%s\"\n"), pKey1);
				gsprintf(sKey2, T("WLAN_WDS_KEY2=\"%s\"\n"), pKey2);
				gsprintf(sKey3, T("WLAN_WDS_KEY3=\"%s\"\n"), pKey3);
				gsprintf(sKey4, T("WLAN_WDS_KEY4=\"%s\"\n"), pKey4);		
				gsprintf(sPsk,  T("WLAN_WDS_PSK=\"0\"\n"));				
				break;
			default:
				ifx_httpdError(wp, 200, "Wrong Encripytion Type!\n");
			return;
		}
		//gsprintf(sRadiusIp1,  T("WLAN_RADIUS_SERVER_IP=\"%s.%s.%s.%s\"\n"), pRadiusIp1_1, pRadiusIp1_2, pRadiusIp1_3, pRadiusIp1_4);
		//gsprintf(sRadiusPort, T("WLAN_RADIUS_SERVER_PORT=\"1812\"\n")); 	
		//gsprintf(sRadiusSecret, T("WLAN_RADIUS_SERVER_SECRET=\"%s\"\n"), pRadiusSecret);

		//websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,13,sWEPKeyLength,sRadiusIp1,sRadiusPort,sRadiusSecrct,sEncryType,sAuthType,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_PASSPHRASE=\"0\"\n");//old
		websSetCfgData(FILE_RC_CONF, TAG_WLAN_WDSSETTINGS,10,sEncryType,sAuthType,sWEPKeyLength,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_WDS_PASSPHRASE=\"0\"\n");
		break;
		
       case WLAN_AUTH_SHARED:       
	case WLAN_AUTH_1X:
		pKey1 = ifx_httpdGetVar(wp, T("Key1"), T(""));
		pKey2 = ifx_httpdGetVar(wp, T("Key2"), T(""));
		pKey3 = ifx_httpdGetVar(wp, T("Key3"), T(""));
		pKey4 = ifx_httpdGetVar(wp, T("Key4"), T(""));
		if ( !pKey1[0] ) gsprintf(pKey1, "0");
		if ( !pKey2[0]) gsprintf(pKey2, "0");
		if ( !pKey3[0]) gsprintf(pKey3, "0");
		if ( !pKey4[0]) gsprintf(pKey4, "0");
		gsprintf(sWEPKeyLength, T("WLAN_WDS_8021X_KEYLEN=\"0\"\n")); 	
		gsprintf(sKeyUsed, T("WLAN_WDS_KEY_USED=\"%s\"\n"), pKeyUsed);		
		gsprintf(sKey1, T("WLAN_WDS_KEY1=\"%s\"\n"), pKey1);
		gsprintf(sKey2, T("WLAN_WDS_KEY2=\"%s\"\n"), pKey2);
		gsprintf(sKey3, T("WLAN_WDS_KEY3=\"%s\"\n"), pKey3);
		gsprintf(sKey4, T("WLAN_WDS_KEY4=\"%s\"\n"), pKey4);		
		gsprintf(sPsk,  T("WLAN_WDS_PSK=\"0\"\n"));

		//gstrcpy(sWepKeyIdx, atoi(pKeyUsed));		
		if (atoi(pKeyUsed) == 1)
		{
			gstrcpy(sWepKey, pKey1);
		}
		else if (atoi(pKeyUsed) == 2)
		{
			gstrcpy(sWepKey, pKey2);
		}
		else if (atoi(pKeyUsed) == 3)
		{
			gstrcpy(sWepKey, pKey3);			
		}
		else if (atoi(pKeyUsed) == 4)
		{
			gstrcpy(sWepKey, pKey4);			
		}
		WEPKeyLength = gstrlen(sWepKey);
		
		if(WEPKeyLength == 10)
			gsprintf(sWEPKeyLength, T("WLAN_WDS_8021X_KEYLEN=\"5\"\n")); 	
		else if(WEPKeyLength == 26)
			gsprintf(sWEPKeyLength, T("WLAN_WDS_8021X_KEYLEN=\"13\"\n"));
		else
			ifx_httpdError(wp, 200, "The Key length is not allow !\n");		  
		
			

		websSetCfgData(FILE_RC_CONF, TAG_WLAN_WDSSETTINGS,10,sEncryType,sAuthType,sWEPKeyLength,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_WDS_PASSPHRASE=\"0\"\n");
		break;
		
       
		
	default:
			ifx_httpdError(wp, 200, "Wrong Encripytion Type!\n");
			return;
	}

	system(SERVICE_RESTORE);	
	//system(SERVICE_WLAN);
	ifx_httpdNextPage(wp);

}
#endif //#if (defined(SPURS) || defined(WILDPASS))
