/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

CGI_ENUMSEL_S web_Enum_IPDSCPClass_List [] =
{
	{0, "Best Effort"},
	{1, "Assured Forwarding-Class 1 Low"},
	{2, "Assured Forwarding-Class 1 Medium"},
	{3, "Assured Forwarding-Class 1 High"},
	{4, "Assured Forwarding-Class 2 Low"},
	{5, "Assured Forwarding-Class 2 Medium"},
	{6, "Assured Forwarding-Class 2 High"},
	{7, "Assured Forwarding-Class 3 Low"},
	{8, "Assured Forwarding-Class 3 Medium"},
	{9, "Assured Forwarding-Class 3 High"},
	{10, "Assured Forwarding-Class 4 Low"},
	{11, "Assured Forwarding-Class 4 Medium"},
	{12, "Assured Forwarding-Class 4 High"},		
	{13, "Class Selector 1"},
	{14, "Class Selector 2"},
	{15, "Class Selector 3"},
	{16, "Class Selector 4"},
	{17, "Class Selector 5"},
	{18, "Class Selector 6"},
	{19, "Class Selector 7"},
	{20, "Expedited Forwarding"}
};

CGI_ENUMSEL_S web_Enum_IPDSCPService_List [] =
{
	{0, "Best Effort (0)"},
	{1, "Background (1)"},
	{2, "Spare (2)"},
	{3, "Excellent (3)"},
	{4, "Control Lead (4)"},
	{5, "Video <100ms Latency (5)"},
	{6, "Voice <100ms Latency (6)"},
	{7, "Network Control"}	
};

#if (defined(SPURS) || defined(WILDPASS))
int ifx_get_wlan_qossettings(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name,*mode;
	char_t	sValue[MAX_DATA_LEN];
	FILE* 	fp;
	char 	sLine[80];
	int		i, nSelIdx = 0;
	int           iIPChk=0;
	char 	seps[]="\n\" "; 
	char 	seps0[]="\n"; 
	char 	seps1[] = "\n\""; 
	char* 	p1String=NULL;
	char*      sStatus=NULL; 
	char_t	sQAPCWminString[16];
	char*	sQAPCWmin=NULL;
	char_t	sQSTACWminString[16];
	char*	sQSTACWmin=NULL;
	char_t	sQAPCWmaxString[16];
	char*	sQAPCWmax=NULL;
	char_t	sQSTACWmaxString[16];
	char*	sQSTACWmax=NULL;
	char_t	sQAPAIFSNString[16];
	char*	sQAPAIFSN=NULL;
	char_t	sQSTAAIFSNString[16];
	char*	sQSTAAIFSN=NULL;
	char_t	sQAPTXOPString[15];
	char*	sQAPTXOP=NULL;
	char_t	sQSTATXOPString[15];
	char*	sQSTATXOP=NULL;
	char_t	sACMString[14];
	char* 	sACM=NULL;   
	char* 	sAwep;
	char* 	sBACM=NULL;
	int           iACM=0;
	char_t	sDSCPString[15];
	char*	sDSCP=NULL;
	int           nPri=0; //priority value
	int           nLoop=0; //for loop value
	int           n_currentAPMode=0;

	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

 	memset(sValue, 0x00, MAX_DATA_LEN);  	
       memset(sQAPCWminString, 0x00, 16);
       memset(sQAPCWmaxString, 0x00, 16);
	memset(sQAPAIFSNString, 0x00, 16);
	memset(sQAPTXOPString, 0x00, 15);
	memset(sACMString, 0x00, 14);

	
      //if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_QOSSETTINGS, T("WLAN_QOS_IPDSCPCHK"), sValue) == 1)
	//{
	//		if ( !gstrcmp(sValue, "1") )
	//		{
	//			iIPChk= 1;
	//		}
			
	//}
	
      memset(sValue, 0x00, MAX_DATA_LEN);  

      if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, "WLAN_CURRENT_MODE", sValue) == 1 )
	{
           if ( !gstrcmp(sValue, "0") )
	      n_currentAPMode=0; //ap
	    else  if ( !gstrcmp(sValue, "1") )
		n_currentAPMode=1; //client
	    else  if ( !gstrcmp(sValue, "2") )
		n_currentAPMode=2;  //wds 
	    
	}


	  

	
   	if (!gstrcmp(name, T("qosStatus")))
   	{
#if 0
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_QOSSETTINGS, T("WLAN_QOS_ENABLE"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "QOS status not found");
			return -1;	
		}
	
		if (!gstrcmp(sValue, "1") )	// DDNS is enabled
		{
			ifx_httpdWrite(wp, T("checked"));
		}
		else
		{
			ifx_httpdWrite(wp, T(""));
		}
#endif
             // fp = fopen ("/ifx/web/11e_info", "r");  //test data
	       //fp = fopen ("/proc/net/11e_info", "r");  //real code
	       //fp = fopen (FILE_NV_11EINFO, "r");  //real code
	       fp = fopen (FILE_NV_11EINFO, "r");  //real code
		if (fp!=NULL)  
		{   
                     ifx_debug_printf ("----CONN-1: \n"); 
			//ifx_debug_printf ("----CONN-11: \n"); 

		       while (feof(fp)==0) 
			{ 
			      //ifx_debug_printf ("----CONN-1-2: \n"); 
		   		fgets(sLine,80,fp);  

                           ifx_debug_printf ("----CONN-2: \n"); 
			      ifx_debug_printf ("-----ssLine: %s\n",sLine);
		   		
		    		p1String= strstr (sLine, "QoS_State");  
			//fgetpos(fp,&pos);   
		    		if (p1String != NULL)   
		   		{      
		   		       ifx_debug_printf ("----CONN-3: \n"); 
					//ifx_debug_printf ("-----sp1String: %s\n",p1String); 
		        		if ((sStatus=strstr(p1String,"QoS_State"))!=NULL)   
					{	
                                        // ifx_debug_printf ("-----status00a: %s\n",sStatus); 
					        ifx_debug_printf ("----CONN-4: \n"); 
						 ifx_debug_printf ("-----status00: %s\n",sStatus); 
			   			 if (strtok(sStatus,"=")!=NULL)       
			    			{        
			    			       // ifx_debug_printf ("-----status0: %s\n",sStatus); 	
			        			 sStatus=strtok(NULL,seps1); 
							 ifx_debug_printf ("-----status1: %s\n",sStatus); 	 
				 			 //sStatus=strtok(NULL,seps1);//need to repeat to get Data Rate
				 			 //ifx_debug_printf ("-----status2: %s\n",sStatus); 

			        			if (!gstrcmp(sStatus,"1"))
				 				ifx_httpdWrite(wp, T("checked"));
							else
								ifx_httpdWrite(wp, T(""));
				 			 ifx_debug_printf ("-----QOS Status:%s\n",sStatus);      
			    			}         
					}    
		    		}       
		  		        
		  	}    //while

                		  
		    /* Locate the line that starts with "model name".  */  //match = strstr (buffer, "cpu MHz"); 
		    ifx_debug_printf ("-----Connect 2: \n");    
		    fclose (fp);			
		
	       } 
		else
		   ifx_debug_printf ("-----OPEN 11e result ERROR: \n");    
   	}
	else
	if ( !gstrcmp(name, T("get_mode")) )  //get current mode
	{
	      if ( n_currentAPMode== 1)		
	      {	
	           ifx_httpdWrite(wp, T("1"));//client mode		
	      }	
	      else if ( n_currentAPMode== 0)	
	     {				
	           ifx_httpdWrite(wp, T("0"));//ap mode		
	      }		
	      else if ( n_currentAPMode== 2)	
	     {				
	            ifx_httpdWrite(wp, T("2"));//wds mode	
	      }	
	}
	else
	if (!gstrcmp(name, T("WDSmode_IsDisable")))
	{
		if (n_currentAPMode== 2)
		   {
		       ifx_httpdWrite(wp, T("disabled")); //wds mode default
		   }	   
	}	
	else
	if ( !gstrcmp(name, T("QOSQAP_list")) )  //get QOS QAP data
	{
         #if 0
	     for (i=0; i<=3;i++)
	     {

               ifx_debug_printf ("-----QAP 1-----\n");
		//get AC CWmin data
 		 //sprintf(sQAPCWminString, "(QAP AC%d) CWmin", i);
		//ifx_debug_printf ("-----sQAPCWminString:%s-----",sQAPCWminString);
		 sprintf(sQAPCWmin, T("grep \"%s\" %s | cut -f2 -d\\\""), "(QAP AC0) CWmin", "/ifx/web/11e_info");
                 ifx_debug_printf ("-----QAP 2-----\n");
		 ifx_httpdWrite(wp, T("\t\t\t<tr class=\"subtitle\" bgcolor=\"#ffffff\">\n"));	
               ifx_httpdWrite(wp, T("\t\t\t<td>Background<BR> (CoS 1-2)</td>"));

		ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"text\" name=\"cwmin%d\" maxlength=\"20\" size=\"8\" value=\"%s\"></td>\n"),i+1,sQAPCWmin);				     						    
   			
				              			 
		ifx_debug_printf ("-----QAP %d CWmin: %s\n",i,sQAPCWmin);   
		ifx_httpdWrite(wp, T("\t\t\t</tr>\n"));  
	     }

	#endif
	       //fp = fopen ("/ifx/web/11e_info", "r");  //test data
              //fp = fopen ("/proc/net/11e_info", "r");  //real code
              fp = fopen (FILE_NV_11EINFO, "r");  //real code
		if (fp!=NULL)  
		{     
		       i=0; //loop counter

			ifx_debug_printf ("---before while loop---");
			
			while (feof(fp)==0) 
			{ 
                           if (i > 3)
			         break;
			
		   		fgets(sLine,80,fp);  

			       //if (i > 3)
			       //   break;
		    		//get AC CWmin data
 				//sprintf(sQAPCWminString, "(QAP AC%d) CWmin", i);

				ifx_debug_printf ("sline:%s\n",sLine);
				//ifx_debug_printf ("---sQAPCWminString:%s---\n",sQAPCWminString);
					
		   		//p1String= strstr (sLine, sQAPCWminString); 
		   		 if (i==0)
					p1String= strstr (sLine, "QAP_AC0_ECWmin"); 
				 if (i==1)
					p1String= strstr (sLine, "QAP_AC1_ECWmin"); 
				 if (i==2)
					p1String= strstr (sLine, "QAP_AC2_ECWmin"); 
				 if (i==3)
					p1String= strstr (sLine, "QAP_AC3_ECWmin"); 
				//ifx_debug_printf ("---p1string cwmin----\n");
				//p1String= strstr (sLine, "(QAP AC0) CWmin"); //test
		  		//fgetpos(fp,&pos);    
		   		if (p1String!= NULL)    
		   		{     
		   		       ifx_debug_printf ("---sQAPCWminString p1string1---\n");
		   			if ((sQAPCWmin=strstr(p1String,"ECWmin"))!=NULL)   
					{	
						if (strtok(sQAPCWmin,"=")!=NULL)   
						{       				     
				     			sQAPCWmin=strtok(NULL,seps1); 
				     			//sQAPCWmin=strtok(NULL,seps1); //required to repeat	 

							 ifx_httpdWrite(wp, T("\t\t\t<tr class=\"subtitle\" bgcolor=\"#ffffff\">\n"));	
							 if (i==0)
              					    ifx_httpdWrite(wp, T("\t\t\t<td>Best Effort<BR> (CoS 0,3)</td>"));
							 if (i==1)
							    ifx_httpdWrite(wp, T("\t\t\t<td>Background<BR> (CoS 1-2)</td>"));              					  
							 if (i==2)
              					   ifx_httpdWrite(wp, T("\t\t\t<td>Video<BR> (CoS 4-5)</td>"));
							 if (i==3)
              					   ifx_httpdWrite(wp, T("\t\t\t<td>Voice<BR> (CoS 6-7)</td>"));

							ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"text\" name=\"cwmin%d\" maxlength=\"20\" size=\"8\" value=\"%s\"></td>\n"),i+1,sQAPCWmin);
				     						    
				     			
				              			 
				     			ifx_debug_printf ("-----QAP %d CWmin: %s\n",i,sQAPCWmin);   
						}          
					}    
		    		} 

				
				//gsprintf(sQAPCWmaxString, T("(QAP AC%d) CWmax"), i);
				//ifx_debug_printf ("---sQAPCWmaxString:%s---\n",sQAPCWmaxString);
				//p1String= strstr (sLine, sQAPCWmaxString); 
                            //get QAP CWmax data
                            if (i==0)
				   p1String= strstr (sLine, "QAP_AC0_ECWmax"); 
				 if (i==1)
				   p1String= strstr (sLine, "QAP_AC1_ECWmax"); 
				 if (i==2)
				   p1String= strstr (sLine, "QAP_AC2_ECWmax"); 
				 if (i==3)
				   p1String= strstr (sLine, "QAP_AC3_ECWmax"); 
				 
				//ifx_debug_printf ("---p1string cwmax----");
		  		//fgetpos(fp,&pos);    
		   		if (p1String!= NULL)    
		   		{  
		   		        ifx_debug_printf ("---sQAPCWmaxString p1string1---\n");
		   			if ((sQAPCWmax=strstr(p1String,"ECWmax"))!=NULL)   
					{	
						if (strtok(sQAPCWmax,"=")!=NULL)   
						{       				     
				     			sQAPCWmax=strtok(NULL,seps1); 
				     			//sQAPCWmax=strtok(NULL,seps1); //required to repeat	 

							 ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"text\" name=\"cwmax%d\" maxlength=\"20\" size=\"8\" value=\"%s\"></td>\n"),i+1,sQAPCWmax);                      
			    		     			              			 
				     			printf ("-----QAP %d CWmax: %s\n",i,sQAPCWmax);   
						}          
					}    
		    		} 


				if (i==0) 
				 p1String= strstr (sLine, "QAP_AC0_AIFSN"); 	
				if (i==1) 
				 p1String= strstr (sLine, "QAP_AC1_AIFSN"); 
				if (i==2) 
				 p1String= strstr (sLine, "QAP_AC2_AIFSN"); 
				if (i==3) 
				 p1String= strstr (sLine, "QAP_AC3_AIFSN"); 

				//gsprintf(sQAPAIFSNString, T("(QAP AC%d) AIFSN"), i);
				//p1String= strstr (sLine, sQAPAIFSNString);  
		  		//fgetpos(fp,&pos);    
		   		if (p1String!= NULL)    
		   		{   
		   		        ifx_debug_printf ("---sQAPAIFSNString p1string1---\n");
		   			if ((sQAPAIFSN=strstr(p1String,"AIFSN"))!=NULL)   
					{	
						if (strtok(sQAPAIFSN,"=")!=NULL)   
						{       				     
				     			sQAPAIFSN=strtok(NULL,seps1); 
				     			//sQAPAIFSN=strtok(NULL,seps1); //required to repeat	 
							 
							 ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"text\" name=\"aifsn%d\" maxlength=\"20\" size=\"8\" value=\"%s\"></td>\n"),i+1,sQAPAIFSN);
			    		     			              			 
				     			printf ("-----QAP  %d AIFSN: %s\n",i,sQAPAIFSN);   
						}          
					}    
		    		} 

				//get QAP ACM data

				 iACM=0;

				if (i==0)
				  p1String= strstr (sLine, "QAP_AC0_ACM"); 
				if (i==1)
				  p1String= strstr (sLine, "QAP_AC1_ACM"); 
				if (i==2)
				  p1String= strstr (sLine, "QAP_AC2_ACM"); 
				if (i==3)
				  p1String= strstr (sLine, "QAP_AC3_ACM"); 
				
				//gsprintf(sACMString, T("(QAP AC%d) ACM"), i);
				//p1String= strstr (sLine, sACMString);  
		  		//fgetpos(fp,&pos);    
		   		if (p1String!= NULL)    
		   		{     
		   		       ifx_debug_printf ("---sQAP ACM String p1string1---\n");
		   			if ((sACM=strstr(p1String,"ACM"))!=NULL)   
					{	
						if (strtok(sACM,"=")!=NULL)   
						{       				     
				     			sACM=strtok(NULL,seps1); 
				     			//sACM=strtok(NULL,seps1); //required to repeat	 

							 if (!gstrcmp(sACM,"1"))
				 			{
				 			    iACM=1;
				 			    //ifx_httpdWrite(wp, T("\t\t\t<td><input type=CHECKBOX name=\"chkacm%d\" value=1 checked>Enable</td>\n"),i+1);
							 }
							 
							 if (iACM==1)
							 	ifx_httpdWrite(wp, T("\t\t\t<td><input type=CHECKBOX name=\"chkacm%d\" value=1 checked disabled>Enable</td>\n"),i+1);
							 else
							 	 ifx_httpdWrite(wp, T("\t\t\t<td><input type=CHECKBOX name=\"chkacm%d\" value=1 disabled>Enable</td>\n"),i+1);
							  ifx_httpdWrite(wp, T("\t\t\t</tr>\n"));  	
							 i=i+1;	//record number	
							 iACM=0;//RESET FLAG
			    		     			              			 
				     			printf ("-----QAP %d ACM: %s\n",i,sACM);   
						}          
					}    
		    		} 

				//get QAP TXOP data
				if (i==0)
				 p1String= strstr (sLine, "QAP_AC0_TXOP"); 
				if (i==1)
				 p1String= strstr (sLine, "QAP_AC1_TXOP"); 
				if (i==2)
				 p1String= strstr (sLine, "QAP_AC2_TXOP"); 
				if (i==3)
				 p1String= strstr (sLine, "QAP_AC3_TXOP"); 	
				

				//gsprintf(sQAPTXOPString, T("(QAP AC%d) TXOP"), i);
				//p1String= strstr (sLine, sQAPTXOPString);  
		  		//fgetpos(fp,&pos);    
		   		if (p1String!= NULL)    
		   		{   
		   			ifx_debug_printf ("---sQAP TXOP String p1string1---\n");
		   			if ((sQAPTXOP=strstr(p1String,"TXOP"))!=NULL)   
					{	
						if (strtok(sQAPTXOP,"=")!=NULL)   
						{       				     
				     			sQAPTXOP=strtok(NULL,seps1); 
				     			//sQAPTXOP=strtok(NULL,seps1); //required to repeat	 

							 //if (iACM==1) //old
							 //	ifx_httpdWrite(wp, T("\t\t\t<td><input type=CHECKBOX name=\"chkacm%d\" value=1 checked>Enable</td>\n"),i+1);
							 //else
							 //	 ifx_httpdWrite(wp, T("\t\t\t<td><input type=CHECKBOX name=\"chkacm%d\" value=1 >Enable</td>\n"),i+1);
							 
							 ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"text\" name=\"txop%d\" maxlength=\"20\" size=\"8\" value=\"%s\"></td>\n"),i+1,sQAPTXOP);
			    		     		 //ifx_httpdWrite(wp, T("\t\t\t</tr>\n"));  	              			 
				     			 ifx_debug_printf ("-----QAP %d CTXOP: %s\n",i,sQAPTXOP);   
							 //i=i+1;	//record number	--old
							// iACM=0;//RESET FLAG  ---old
						}          
					}    
		    		} 				  
				
		     }    //WHILE		       
                		  
		    /* Locate the line that starts with "model name".  */  //match = strstr (buffer, "cpu MHz"); 
		    printf ("-----2: \n");    
		    fclose (fp);
			 
	       } 
		else
		 printf ("-----CANNOT OPEN QOS QAP LIST -- \n");    
	//#endif	      	
	
	}
	else
	if ( !gstrcmp(name, T("QOSQSTA_list")) )
	{
	  
	       //fp = fopen ("/ifx/web/11e_info", "r");  //test data
             // fp = fopen ("/proc/net/11e_info", "r");  //real code
              //fp = fopen (FILE_11E_INFO, "r");  //real code
              fp = fopen (FILE_NV_11EINFO, "r");  //real code
		if (fp!=NULL)  
		{     
		       i=0; //loop counter

			ifx_debug_printf ("---before while loop---\n");
			
			while (feof(fp)==0) 
			{ 
                           if (i > 3)
			         break;
			
		   		fgets(sLine,80,fp);  

			       //if (i > 3)
			       //   break;
		    		//get AC CWmin data
 				//sprintf(sQAPCWminString, "(QAP AC%d) ECWmin", i);

				ifx_debug_printf ("sline:%s\n",sLine);
				
		   		 if (i==0)
					p1String= strstr (sLine, "QSTA_AC0_ECWmin"); 
				 if (i==1)
					p1String= strstr (sLine, "QSTA_AC1_ECWmin"); 
				 if (i==2)
					p1String= strstr (sLine, "QSTA_AC2_ECWmin"); 
				 if (i==3)
					p1String= strstr (sLine, "QSTA_AC3_ECWmin"); 
				//ifx_debug_printf ("---p1string cwmin----\n");
				//p1String= strstr (sLine, "(QAP AC0) ECWmin"); //test
		  		//fgetpos(fp,&pos);    
		   		if (p1String!= NULL)    
		   		{     
		   		       ifx_debug_printf ("---sQSTACWminString p1string1---\n");
		   			if ((sQSTACWmin=strstr(p1String,"ECWmin"))!=NULL)   
					{	
						if (strtok(sQSTACWmin,"=")!=NULL)   
						{       				     
				     			sQSTACWmin=strtok(NULL,seps1); 
				     			//sQSTACWmin=strtok(NULL,seps1); //required to repeat	 

							 ifx_httpdWrite(wp, T("\t\t\t<tr class=\"subtitle\" bgcolor=\"#ffffff\">\n"));	
							 if (i==0)
							   ifx_httpdWrite(wp, T("\t\t\t<td>Best Effort<BR> (CoS 0,3)</td>"));              					   
							 if (i==1)
              					   ifx_httpdWrite(wp, T("\t\t\t<td>Background<BR> (CoS 1-2)</td>"));
							 if (i==2)
              					   ifx_httpdWrite(wp, T("\t\t\t<td>Video<BR> (CoS 4-5)</td>"));
							 if (i==3)
              					   ifx_httpdWrite(wp, T("\t\t\t<td>Voice<BR> (CoS 6-7)</td>"));

							ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"text\" name=\"cwmin%d\" maxlength=\"20\" size=\"8\" value=\"%s\"></td>\n"),i+1,sQSTACWmin);
				     						    
				     			
				              			 
				     			ifx_debug_printf ("-----QSTA %d CWmin: %s\n",i,sQSTACWmin);   
						}          
					}    
		    		} 

				
				//gsprintf(sQAPCWmaxString, T("(QAP AC%d) CWmax"), i);
				//ifx_debug_printf ("---sQAPCWmaxString:%s---\n",sQAPCWmaxString);
				//p1String= strstr (sLine, sQAPCWmaxString); 
                            //get QAP CWmax data
                            if (i==0)
				   p1String= strstr (sLine, "QSTA_AC0_ECWmax"); 
				 if (i==1)
				   p1String= strstr (sLine, "QSTA_AC1_ECWmax"); 
				 if (i==2)
				   p1String= strstr (sLine, "QSTA_AC2_ECWmax"); 
				 if (i==3)
				   p1String= strstr (sLine, "QSTA_AC3_ECWmax"); 
				 
				//ifx_debug_printf ("---p1string cwmax----");
		  		//fgetpos(fp,&pos);    
		   		if (p1String!= NULL)    
		   		{  
		   		        ifx_debug_printf ("---sQSTA CWmaxString p1string1---\n");
		   			if ((sQSTACWmax=strstr(p1String,"ECWmax"))!=NULL)   
					{	
						if (strtok(sQSTACWmax,"=")!=NULL)   
						{       				     
				     			sQSTACWmax=strtok(NULL,seps1); 
				     			//sQSTACWmax=strtok(NULL,seps1); //required to repeat	 

							 ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"text\" name=\"cwmax%d\" maxlength=\"20\" size=\"8\" value=\"%s\"></td>\n"),i+1,sQSTACWmax);                      
			    		     			              			 
				     			printf ("-----QSTA %d CWmax: %s\n",i,sQSTACWmax);   
						}          
					}    
		    		} 


				if (i==0) 
				 p1String= strstr (sLine, "QSTA_AC0_AIFSN"); 	
				if (i==1) 
				 p1String= strstr (sLine, "QSTA_AC1_AIFSN"); 
				if (i==2) 
				 p1String= strstr (sLine, "QSTA_AC2_AIFSN"); 
				if (i==3) 
				 p1String= strstr (sLine, "QSTA_AC3_AIFSN"); 

				//gsprintf(sQAPAIFSNString, T("(QAP AC%d) AIFSN"), i);
				//p1String= strstr (sLine, sQAPAIFSNString);  
		  		//fgetpos(fp,&pos);    
		   		if (p1String!= NULL)    
		   		{   
		   		        ifx_debug_printf ("---sQSTA AIFSNString p1string1---\n");
		   			if ((sQSTAAIFSN=strstr(p1String,"AIFSN"))!=NULL)   
					{	
						if (strtok(sQSTAAIFSN,"=")!=NULL)   
						{       				     
				     			sQSTAAIFSN=strtok(NULL,seps1); 
				     			//sQSTAAIFSN=strtok(NULL,seps1); //required to repeat	 
							 
							 ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"text\" name=\"aifsn%d\" maxlength=\"20\" size=\"8\" value=\"%s\"></td>\n"),i+1,sQSTAAIFSN);
			    		     			              			 
				     			printf ("-----QSTA  %d AIFSN: %s\n",i,sQSTAAIFSN);   
						}          
					}    
		    		} 

				

				//get QSTA TXOP data
				
				if (i==0)
				 p1String= strstr (sLine, "QSTA_AC0_TXOP"); 
				if (i==1)
				 p1String= strstr (sLine, "QSTA_AC1_TXOP"); 
				if (i==2)
				 p1String= strstr (sLine, "QSTA_AC2_TXOP"); 
				if (i==3)
				 p1String= strstr (sLine, "QSTA_AC3_TXOP"); 
				

				//gsprintf(sQAPTXOPString, T("(QSTA AC%d) TXOP"), i);
				//p1String= strstr (sLine, sQSTATXOPString);  
		  		//fgetpos(fp,&pos);    
		   		if (p1String!= NULL)    
		   		{   
		   			ifx_debug_printf ("---sQSTA TXOP String p1string1---\n");
		   			if ((sQSTATXOP=strstr(p1String,"TXOP"))!=NULL)   
					{	
						if (strtok(sQSTATXOP,"=")!=NULL)   
						{       				     
				     			sQSTATXOP=strtok(NULL,seps1); 
				     			//sQSTATXOP=strtok(NULL,seps1); //required to repeat	 


							 ifx_httpdWrite(wp, T("\t\t\t<td><input type=\"text\" name=\"txop%d\" maxlength=\"20\" size=\"8\" value=\"%s\"></td>\n"),i+1,sQSTATXOP);
			    		     		 ifx_httpdWrite(wp, T("\t\t\t</tr>\n"));  	              			 
				     			 ifx_debug_printf ("-----QSTA %d CTXOP: %s\n",i,sQSTATXOP);   
							 i=i+1;	//record number	
							 iACM=0;//RESET FLAG
						}          
					}    
		    		} 				  
				
		     }    //WHILE		       
                		  
		    /* Locate the line that starts with "model name".  */  //match = strstr (buffer, "cpu MHz"); 
		    printf ("-----2: \n");    
		    fclose (fp);
			 
	       } 
		else
		 printf ("-----CANNOT OPEN QOS QSTA LIST -- \n");    
	//#endif	      	    
	}
	else
	if ( !gstrcmp(name, T("QOSDSCP_list")) )
	{
	  
	      // fp = fopen ("/ifx/web/11e_info", "r");  //test data
             // fp = fopen ("/proc/net/11e_info", "r");  //real code
              //fp = fopen (FILE_11E_INFO, "r");  //real code
              fp = fopen (FILE_NV_11EINFO, "r");  //real code
		if (fp!=NULL)  
		{     
		       i=0; //loop counter

			ifx_debug_printf ("---before while loop---\n");
			
			while (feof(fp)==0) 
			{ 
                           if (i > 7)
			         break;
			
		   		fgets(sLine,80,fp);  

			       //if (i > 3)
			       //   break;
		    		//get AC CWmin data
 				//sprintf(sQAPCWminString, "(QAP AC%d) CWmin", i);

				printf ("sline:%s\n",sLine);
				
		   		 if (i==0)
					p1String= strstr (sLine, "DSCP_0"); 
				 if (i==1)
					p1String= strstr (sLine, "DSCP_1"); 
				 if (i==2)
					p1String= strstr (sLine, "DSCP_2"); 
				 if (i==3)
					p1String= strstr (sLine, "DSCP_3"); 
				 if (i==4)
					p1String= strstr (sLine, "DSCP_4"); 
				 if (i==5)
					p1String= strstr (sLine, "DSCP_5"); 
				 if (i==6)
					p1String= strstr (sLine, "DSCP_6"); 
				 if (i==7)
					p1String= strstr (sLine, "DSCP_7"); 
				//ifx_debug_printf ("---p1string cwmin----\n");
				//p1String= strstr (sLine, "(QAP AC0) CWmin"); //test
		  		//fgetpos(fp,&pos);    
		   		if (p1String!= NULL)    
		   		{     
		   		       printf ("---sDSCP p1string1---\n");
		   			if ((sDSCP=strstr(p1String,"Priority"))!=NULL)   
					{	

					    printf ("---0sDSCP:%s---\n",sDSCP);
						if (strtok(sDSCP,"=")!=NULL)   
						{    
						     printf ("---1sDSCP:%s---\n",sDSCP);
				     			sDSCP=strtok(NULL,seps1); 
						       printf ("---2sDSCP:%s---\n",sDSCP);
				     			//sDSCP=strtok(NULL,seps1); //required to repeat	 

							printf ("---DSCP %d priority:%s---\n",i,sDSCP);

							nPri=atoi(sDSCP);

							 ifx_httpdWrite(wp, T("\t\t\t<tr class=\"subtitle\" bgcolor=\"#ffffff\">\n"));	
							 if (i==0)
							 {
							     ifx_httpdWrite(wp, T("\t\t\t<td>Best Effort</td>"));
							     ifx_httpdWrite(wp, T("\t\t\t<td><select name=\"selBestEffort\">"));
							 }
							 if (i==1)
							 {
							     ifx_httpdWrite(wp, T("\t\t\t<td>Class Selector 1</td>"));
							     ifx_httpdWrite(wp, T("\t\t\t<td><select name=\"selClassSel1\">"));
							 }
							 if (i==2)
							 {
							     ifx_httpdWrite(wp, T("\t\t\t<td>Class Selector 2</td>"));
							     ifx_httpdWrite(wp, T("\t\t\t<td><select name=\"selClassSel2\">"));
							 }
							 if (i==3)
							 {
							     ifx_httpdWrite(wp, T("\t\t\t<td>Class Selector 3</td>"));
							     ifx_httpdWrite(wp, T("\t\t\t<td><select name=\"selClassSel3\">"));
							 }
							 if (i==4)
							 {
							     ifx_httpdWrite(wp, T("\t\t\t<td>Class Selector 4</td>"));
							     ifx_httpdWrite(wp, T("\t\t\t<td><select name=\"selClassSel4\">"));
							 }
							 if (i==5)
							 {
							     ifx_httpdWrite(wp, T("\t\t\t<td>Class Selector 5</td>"));
							     ifx_httpdWrite(wp, T("\t\t\t<td><select name=\"selClassSel5\">"));
							 }
							 if (i==6)
							 {
							     ifx_httpdWrite(wp, T("\t\t\t<td>Class Selector 6</td>"));
							     ifx_httpdWrite(wp, T("\t\t\t<td><select name=\"selClassSel6\">"));
							 }
							 if (i==7)
							 {
							     ifx_httpdWrite(wp, T("\t\t\t<td>Class Selector 7</td>"));
							     ifx_httpdWrite(wp, T("\t\t\t<td><select name=\"selClassSel7\">"));
							 }
							 for (nLoop= 0; nLoop < sizeof(web_Enum_IPDSCPService_List)/sizeof(CGI_ENUMSEL_S);nLoop++)
							 {
								if (nLoop == (nPri))
								{
									ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_IPDSCPService_List[nLoop].value, web_Enum_IPDSCPService_List[nLoop].str);
								}
								else
								{
									ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_IPDSCPService_List[nLoop].value, web_Enum_IPDSCPService_List[nLoop].str);
								}
							}//FOR
							ifx_httpdWrite(wp, T("\t\t\t</select></td> "));							
								 
							 ifx_httpdWrite(wp, T("\t\t\t</tr>"));				
              					   
							 i=i+1;	//record number
				              			 
				     			//ifx_debug_printf ("-----QSTA %d CWmin: %s\n",i,sQSTACWmin);   
						}//          
					} //   
		    		}// 	
		   			  
				
		     }    //WHILE		       
                		  
		    /* Locate the line that starts with "model name".  */  //match = strstr (buffer, "cpu MHz"); 
		    printf ("-----2: \n");    
		    fclose (fp);
			 
	       } 
		//else
		// printf ("-----CANNOT OPEN QOS DSCP LIST -- \n");    
	//#endif	      	    
	}
	
	

	return 0;
      	
}


void ifx_set_wlan_qossettings(httpd_t wp, char_t *path, char_t *query)
{
       char_t	command[MAX_FILELINE_LEN];
       char_t	sStatus[MAX_DATA_LEN];
	char_t	*pStatus = ifx_httpdGetVar(wp, T("qosStatus"), T(""));	
	
	
	
	a_assert(wp);
	memset(sStatus,   0x00, MAX_DATA_LEN);
	
	ifx_debug_printf ("-----before set QOS ---: \n"); 
	memset(command, 0x00, MAX_FILELINE_LEN);
	
	if (pStatus && *pStatus)
	    gsprintf(command, T("iwpriv eth0 11ed8 26 0 1"));
	else
	    gsprintf(command, T("iwpriv eth0 11ed8 26 0 0"));
	ifx_debug_printf ("----- QOS main setting: %s---\n",command);
	system(command);
	
	
	//if (pStatus && *pStatus)	
	 //   gsprintf(sStatus,    T("WLAN_QOS_ENABLE=\"%s\"\n"), pStatus);
	//else
	//   gsprintf(sStatus,    T("WLAN_QOS_ENABLE=\"0\"\n"));		//default	
	
		
	
		
		
	//websSetCfgData(FILE_RC_CONF, TAG_WLAN_QOSSETTINGS, 1, sStatus);
		
	

	//add by calvinc 20050601 save to flash
	gsprintf(command, T("cp -f %s %s"),FILE_11E_INFO,FILE_NV_11EINFO);
	ifx_debug_printf ("----- save command: %s---\n",command);
	system(command);
	system(SERVICE_RESTORE);
    //end add

	reboot(RB_AUTOBOOT); //reboot

	ifx_httpdNextPage(wp);
}




void ifx_set_wlan_qosdscp(httpd_t wp, char_t *path, char_t *query)
{
	char_t	command[MAX_FILELINE_LEN];	
	char_t	sBestEffort[MAX_DATA_LEN], sClassSel1[MAX_DATA_LEN];
	char_t	sClassSel2[MAX_DATA_LEN], sClassSel3[MAX_DATA_LEN];
	char_t	sClassSel4[MAX_DATA_LEN],sClassSel5[MAX_DATA_LEN];
	char_t	 sClassSel6[MAX_DATA_LEN], sClassSel7[MAX_DATA_LEN];
	char_t     *pBestEffort = ifx_httpdGetVar(wp, T("selBestEffort"), T(""));
	char_t     *pClassSel1 = ifx_httpdGetVar(wp, T("selClassSel1"), T(""));
	char_t     *pClassSel2 = ifx_httpdGetVar(wp, T("selClassSel2"), T(""));
	char_t     *pClassSel3 = ifx_httpdGetVar(wp, T("selClassSel3"), T(""));
	char_t     *pClassSel4 = ifx_httpdGetVar(wp, T("selClassSel4"), T(""));
	char_t     *pClassSel5 = ifx_httpdGetVar(wp, T("selClassSel5"), T(""));
	char_t     *pClassSel6 = ifx_httpdGetVar(wp, T("selClassSel6"), T(""));
	char_t     *pClassSel7 = ifx_httpdGetVar(wp, T("selClassSel7"), T(""));
	int           nBestEffort=0; //default
	int 		 nClassSel1 =0; 
	int 		 nClassSel2 =0; 
	int 		 nClassSel3 =0; 
	int 		 nClassSel4 =0; 
	int 		 nClassSel5 =0; 
	int 		 nClassSel6 =0; 
	int 		 nClassSel7 =0; 
	
	
	a_assert(wp);
	//memset(sStatus,   0x00, MAX_DATA_LEN);
	nBestEffort=atoi(pBestEffort);
	nClassSel1=atoi(pClassSel1);
	nClassSel2=atoi(pClassSel2);
	nClassSel3=atoi(pClassSel3);
	nClassSel4=atoi(pClassSel4);
	nClassSel5=atoi(pClassSel5);
	nClassSel6=atoi(pClassSel6);
	nClassSel7=atoi(pClassSel7);


	ifx_debug_printf ("-----before set QOS DSCP---: \n"); 
	memset(command, 0x00, MAX_FILELINE_LEN);
	//SET DSCP0
	gsprintf(command, T("iwpriv eth0 11ed8 25 0 0 %d"),nBestEffort);
	ifx_debug_printf ("----- QOS DSCP0: %s---\n",command);
	system(command);
	
	//SET DSCP1
	gsprintf(command, T("iwpriv eth0 11ed8 25 0 1 %d"),nClassSel1);
	ifx_debug_printf ("----- QOS DSCP1: %s---\n",command);
	system(command);

	//SET DSCP2
	gsprintf(command, T("iwpriv eth0 11ed8 25 0 2 %d"),nClassSel2);
	ifx_debug_printf ("----- QOS DSCP2: %s---\n",command);
	system(command);

	//SET DSCP3
	gsprintf(command, T("iwpriv eth0 11ed8 25 0 3 %d"),nClassSel3);
	ifx_debug_printf ("----- QOS DSCP3: %s---\n",command);
	system(command);

	//SET DSCP4
	gsprintf(command, T("iwpriv eth0 11ed8 25 0 4 %d"),nClassSel4);
	ifx_debug_printf ("----- QOS DSCP4: %s---\n",command);
	system(command);

	//SET DSCP5
	gsprintf(command, T("iwpriv eth0 11ed8 25 0 5 %d"),nClassSel5);
	ifx_debug_printf ("----- QOS DSCP5: %s---\n",command);
	system(command);

	//SET DSCP6
	gsprintf(command, T("iwpriv eth0 11ed8 25 0 6 %d"),nClassSel6);
	ifx_debug_printf ("----- QOS DSCP6: %s---\n",command);
	system(command);

	//SET DSCP7
	gsprintf(command, T("iwpriv eth0 11ed8 25 0 7 %d"),nClassSel7);
	ifx_debug_printf ("----- QOS DSCP7: %s---\n",command);
	system(command);
	
	//if (pStatus && *pStatus)	
	 //   gsprintf(sStatus,    T("WLAN_QOS_ENABLE=\"%s\"\n"), pStatus);
	//else
	//   gsprintf(sStatus,    T("WLAN_QOS_ENABLE=\"0\"\n"));		//default	

	//gsprintf(sBestEffort, T("WLAN_QOS_BESTEFFORT=\"%s\"\n"), pBestEffort);
	//gsprintf(sClassSel1, T("WLAN_QOS_CLASSSEL1=\"%s\"\n"), pClassSel1);
	//gsprintf(sClassSel2, T("WLAN_QOS_CLASSSEL2=\"%s\"\n"), pClassSel2);
	//gsprintf(sClassSel3, T("WLAN_QOS_CLASSSEL3=\"%s\"\n"), pClassSel3);
	//gsprintf(sClassSel4, T("WLAN_QOS_CLASSSEL4=\"%s\"\n"), pClassSel4);
	//gsprintf(sClassSel5, T("WLAN_QOS_CLASSSEL5=\"%s\"\n"), pClassSel5);
	//gsprintf(sClassSel6, T("WLAN_QOS_CLASSSEL6=\"%s\"\n"), pClassSel6);
	//gsprintf(sClassSel7, T("WLAN_QOS_CLASSSEL7=\"%s\"\n"), pClassSel7);
		
	
		
		
	//websSetCfgData(FILE_RC_CONF, TAG_WLAN_QOSSETTINGS, 9, sStatus,
	//				sBestEffort,sClassSel1,sClassSel2,sClassSel3);

		
	

	//add by calvinc 20050601 save to flash
	gsprintf(command, T("cp -f %s %s"),FILE_11E_INFO,FILE_NV_11EINFO);
	ifx_debug_printf ("----- save command: %s---\n",command);
	system(command);
	system(SERVICE_RESTORE);
    //end add

	ifx_httpdNextPage(wp);
}



void ifx_set_wlan_qosqap(httpd_t wp, char_t *path, char_t *query)
{
	//char_t	*pStatus = ifx_httpdGetVar(wp, T("qosStatus"), T(""));	
	char_t	command[MAX_FILELINE_LEN];
	
	char_t	*pCwmin1 = ifx_httpdGetVar(wp, T("cwmin1"), T(""));
	char_t	*pCwmax1 = ifx_httpdGetVar(wp, T("cwmax1"), T(""));
	char_t	*pAifsn1 = ifx_httpdGetVar(wp, T("aifsn1"), T(""));
	char_t	*pTxop1 = ifx_httpdGetVar(wp, T("txop1"), T(""));
	char_t     *pChkacm1 = ifx_httpdGetVar(wp, T("chkacm1"), T(""));
	char_t	*pCwmin2 = ifx_httpdGetVar(wp, T("cwmin2"), T(""));
	char_t	*pCwmax2 = ifx_httpdGetVar(wp, T("cwmax2"), T(""));
	char_t	*pAifsn2 = ifx_httpdGetVar(wp, T("aifsn2"), T(""));
	char_t	*pTxop2 = ifx_httpdGetVar(wp, T("txop2"), T(""));
	char_t     *pChkacm2 = ifx_httpdGetVar(wp, T("chkacm2"), T(""));
	char_t	*pCwmin3 = ifx_httpdGetVar(wp, T("cwmin3"), T(""));
	char_t	*pCwmax3 = ifx_httpdGetVar(wp, T("cwmax3"), T(""));
	char_t	*pAifsn3 = ifx_httpdGetVar(wp, T("aifsn3"), T(""));
	char_t	*pTxop3 = ifx_httpdGetVar(wp, T("txop3"), T(""));
	char_t     *pChkacm3 = ifx_httpdGetVar(wp, T("chkacm3"), T(""));
	char_t	*pCwmin4 = ifx_httpdGetVar(wp, T("cwmin4"), T(""));
	char_t	*pCwmax4 = ifx_httpdGetVar(wp, T("cwmax4"), T(""));
	char_t	*pAifsn4 = ifx_httpdGetVar(wp, T("aifsn4"), T(""));
	char_t	*pTxop4 = ifx_httpdGetVar(wp, T("txop4"), T(""));
	char_t     *pChkacm4 = ifx_httpdGetVar(wp, T("chkacm4"), T(""));
	
	
	int           nCwmin1=0; //default 
	int           nCwmax1=0; //default 
	int           nAifsn1=0; //default 
	int           nChkacm1=0; //default 
	int           nTxop1=0; //default 
	int           nCwmin2=0; //default 
	int           nCwmax2=0; //default 
	int           nAifsn2=0; //default 
	int           nChkacm2=0; //default 
	int           nTxop2=0; //default 
	int           nCwmin3=0; //default 
	int           nCwmax3=0; //default 
	int           nAifsn3=0; //default 
	int           nChkacm3=0; //default 
	int           nTxop3=0; //default 
	int           nCwmin4=0; //default 
	int           nCwmax4=0; //default 
	int           nAifsn4=0; //default 
	int           nChkacm4=0; //default 
	int           nTxop4=0; //default 
	

	a_assert(wp);

	ifx_debug_printf ("-----before set QOS QAP---: \n"); 
	memset(command, 0x00, MAX_FILELINE_LEN);

	
	//get QAP row1 data
	nCwmin1= atoi(pCwmin1);
	nCwmax1= atoi(pCwmax1);
	nAifsn1= atoi(pAifsn1);
	//nChkacm1= atoi(pChkacm1);//old
      // if (pChkacm1 && *pChkacm1) //original
	//     nChkacm1=1;
	nChkacm1=0;
	nTxop1= atoi(pTxop1);
	//ifx_debug_printf ("----- QOS QAP nChkacm1: %d---\n",nChkacm1);
	printf ("----- QOS QAP nChkacm1: %d---\n",nChkacm1);
	//get QAP row2 data
	nCwmin2= atoi(pCwmin2);
	nCwmax2= atoi(pCwmax2);
	nAifsn2= atoi(pAifsn2);
	//the following is original
      //if (pChkacm2 && *pChkacm2) 
	//     nChkacm2=1;
	nChkacm2=0;
	nTxop2= atoi(pTxop2);
	//ifx_debug_printf ("----- QOS QAP nChkacm2: %d---\n",nChkacm2);
	printf ("----- QOS QAP nChkacm2: %d---\n",nChkacm2);
	//get QAP row3 data
	nCwmin3= atoi(pCwmin3);
	nCwmax3= atoi(pCwmax3);
	nAifsn3= atoi(pAifsn3);
	//the following is original
       //if (pChkacm3 && *pChkacm3)
	 //    nChkacm3=1;
	 nChkacm3=0;
	
	nTxop3= atoi(pTxop3);
	//ifx_debug_printf ("----- QOS QAP nChkacm3: %d---\n",nChkacm3);
	printf ("----- QOS QAP nChkacm3: %d---\n",nChkacm3);
	//get QAP row4 data
	nCwmin4= atoi(pCwmin4);
	nCwmax4= atoi(pCwmax4);
	nAifsn4= atoi(pAifsn4);
	//the following is original
       //if (pChkacm4 && *pChkacm4)
	//     nChkacm4=1;
	nChkacm4=0;
	
	nTxop4= atoi(pTxop4);
	//ifx_debug_printf ("----- QOS QAP nChkacm4: %d---\n",nChkacm4);
	printf ("----- QOS QAP nChkacm4: %d---\n",nChkacm4);
	
	gsprintf(command, T("iwpriv eth0 11ed8 23 0 %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d"),
			nCwmin1,nCwmax1,nAifsn1,nTxop1,nChkacm1,nCwmin2,nCwmax2,nAifsn2,nTxop2,nChkacm2,
			nCwmin3,nCwmax3,nAifsn3,nTxop3,nChkacm3,nCwmin4,nCwmax4,nAifsn4,nTxop4,nChkacm4);
	ifx_debug_printf ("----- QOS QAP: %s---\n",command);
	system(command);
	
	
	ifx_debug_printf ("-----after set QOS QAP: \n");
	
	
		
		
	//websSetCfgData(FILE_RC_CONF, TAG_WLAN_QOS_QAPSETTINGS, 24,  
	//				sbackground1, sbackground2, sbackground3,sbackground4,schkbackground,
	//				sbesteffort1, sbesteffort2, sbesteffort3,sbesteffort4,schkbesteffort,
	//				svideo1, svideo2, svideo3,svideo4,schkvideo,
	//				svoice1, svoice2, svoice3,svoice4,schkvoice,
	//				sIPDSCPChk,sIPDSCPSel1,sIPDSCPSel2,sIPDSCPEdit);

		//Runtime Change		
		//system(SERVICE_DDNS_STOP);		// Remove old process 
		//system(SERVICE_DDNS_START);		
	
	

	//add by calvinc 20050601 save to flash
	gsprintf(command, T("cp -f %s %s"),FILE_11E_INFO,FILE_NV_11EINFO);
	ifx_debug_printf ("----- save command: %s---\n",command);
	system(command);
	system(SERVICE_RESTORE);
    //end add

	ifx_httpdNextPage(wp);
}

void ifx_set_wlan_qosqsta(httpd_t wp, char_t *path, char_t *query)
{
	char_t	command[MAX_FILELINE_LEN];
	
	char_t	*pCwmin1 = ifx_httpdGetVar(wp, T("cwmin1"), T(""));
	char_t	*pCwmax1 = ifx_httpdGetVar(wp, T("cwmax1"), T(""));
	char_t	*pAifsn1 = ifx_httpdGetVar(wp, T("aifsn1"), T(""));
	char_t	*pTxop1 = ifx_httpdGetVar(wp, T("txop1"), T(""));	
	char_t	*pCwmin2 = ifx_httpdGetVar(wp, T("cwmin2"), T(""));
	char_t	*pCwmax2 = ifx_httpdGetVar(wp, T("cwmax2"), T(""));
	char_t	*pAifsn2 = ifx_httpdGetVar(wp, T("aifsn2"), T(""));
	char_t	*pTxop2 = ifx_httpdGetVar(wp, T("txop2"), T(""));	
	char_t	*pCwmin3 = ifx_httpdGetVar(wp, T("cwmin3"), T(""));
	char_t	*pCwmax3 = ifx_httpdGetVar(wp, T("cwmax3"), T(""));
	char_t	*pAifsn3 = ifx_httpdGetVar(wp, T("aifsn3"), T(""));
	char_t	*pTxop3 = ifx_httpdGetVar(wp, T("txop3"), T(""));
	char_t	*pCwmin4 = ifx_httpdGetVar(wp, T("cwmin4"), T(""));
	char_t	*pCwmax4 = ifx_httpdGetVar(wp, T("cwmax4"), T(""));
	char_t	*pAifsn4 = ifx_httpdGetVar(wp, T("aifsn4"), T(""));
	char_t	*pTxop4 = ifx_httpdGetVar(wp, T("txop4"), T(""));	
	
	
	
	int           nCwmin1=0; //default 
	int           nCwmax1=0; //default 
	int           nAifsn1=0; //default 	
	int           nTxop1=0; //default 
	
	int           nCwmin2=0; //default 
	int           nCwmax2=0; //default 
	int           nAifsn2=0; //default 	
	int           nTxop2=0; //default 
	
	int           nCwmin3=0; //default 
	int           nCwmax3=0; //default 
	int           nAifsn3=0; //default 	
	int           nTxop3=0; //default 
	
	int           nCwmin4=0; //default 
	int           nCwmax4=0; //default 
	int           nAifsn4=0; //default 	
	int           nTxop4=0; //default 
	
	

	a_assert(wp);

	ifx_debug_printf ("-----before set QOS QSTA---: \n"); 
	memset(command, 0x00, MAX_FILELINE_LEN);

	
	//get QAP row1 data
	nCwmin1= atoi(pCwmin1);
	nCwmax1= atoi(pCwmax1);
	nAifsn1= atoi(pAifsn1);	
	nTxop1= atoi(pTxop1);
	//get QAP row2 data
	nCwmin2= atoi(pCwmin2);
	nCwmax2= atoi(pCwmax2);
	nAifsn2= atoi(pAifsn2);	
	nTxop2= atoi(pTxop2);
	//get QAP row3 data
	nCwmin3= atoi(pCwmin3);
	nCwmax3= atoi(pCwmax3);
	nAifsn3= atoi(pAifsn3);	
	nTxop3= atoi(pTxop3);
	//get QAP row4 data
	nCwmin4= atoi(pCwmin4);
	nCwmax4= atoi(pCwmax4);
	nAifsn4= atoi(pAifsn4);	
	nTxop4= atoi(pTxop4);
	gsprintf(command, T("iwpriv eth0 11ed8 24 0 %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d"),
			nCwmin1,nCwmax1,nAifsn1,nTxop1,nCwmin2,nCwmax2,nAifsn2,nTxop2,
			nCwmin3,nCwmax3,nAifsn3,nTxop3,nCwmin4,nCwmax4,nAifsn4,nTxop4);
	ifx_debug_printf ("----- QOS QSTA: %s---\n",command);
	system(command);
	
	
	//ifx_debug_printf ("-----after set QOS QSTA: \n");
	

       sleep(3);

	//add by calvinc 20050601 save to flash
	gsprintf(command, T("cp -f %s %s"),FILE_11E_INFO,FILE_NV_11EINFO);
	ifx_debug_printf ("----- save command: %s---\n",command);
	system(command);
	system(SERVICE_RESTORE);
    //end add	
	

	ifx_httpdNextPage(wp);
}
#endif
