/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

#include <stdio.h>
#include <dlfcn.h>
#include "ifx_emf.h"
#include "ifx_httpd_method.h"
#include "ifx_httpd.h"
#include "ifx_exportFunc.h"
#include "ifx_web_common.h"
#include "ifx_src_cgi.h"

#define IFX_BYPASS_URL	"login.asp goform/ifx_set_login flash/f1.swf"

#if 0
int (*ifx_sendHeaders)(int responseNum,char *redirectURL);
int (*ifx_read)(int fd, void *buf, int len);
int (*ifx_write)(int fd, const void *buf, int len);
void (*ifx_getHeaderData)(const char *,char **);
#else
IFX_SENDHEADERS 	ifx_sendHeaders;
IFX_READ 		ifx_read;
IFX_WRITE 		ifx_write;
IFX_GETHEADERDATA 	ifx_getHeaderData;
#endif
int web_image_length;

void *dlHandle;
struct connection_profil connection = {0,"0",0,0};

int ifx_main(){

	if (!dlHandle) 
	{
		fprintf (stderr, "%s\n", dlerror());
		fprintf(stderr,"\n ifx_main Error : dlopen fails.\n");
		return -1;
	}
	memset(connection.ipaddr,0x00,sizeof(connection.ipaddr));
	return 0;
}

int ifx_RegisterFunc(struct ifx_exportFuncList *pifx_exportedFunc)
{
	//printf("###Inside ifx_RegisterFunc.\n");
	ifx_sendHeaders = pifx_exportedFunc->ifx_sendHeaders;
	ifx_read = pifx_exportedFunc->ifx_read;
	ifx_write = pifx_exportedFunc->ifx_write;
	ifx_getHeaderData = pifx_exportedFunc->ifx_getHeaderData;
	dlHandle = pifx_exportedFunc->dlHandle;
	return ifx_main();
}

/****************************************************************************
 *
 > $Function: decodeString()
 *
 * $Description: Given a URL encoded string, convert it to plain ascii.
 *   Since decoding always makes strings smaller, the decode is done in-place.
 *   Thus, callers should strdup() the argument if they do not want the
 *   argument modified.  The return is the original pointer, allowing this
 *   function to be easily used as arguments to other functions.
 *
 * $Parameters:
 *      (char *) string . . . The first string to decode.
 *      (int)    flag   . . . 1 if require decode '+' as ' ' for CGI
 *
 * $Return: (char *)  . . . . A pointer to the decoded string (same as input).
 *
 * $Errors: None
 *
 ****************************************************************************/
static char *decodeString(char *orig, int flag_plus_to_space)
{
  /* note that decoded string is always shorter than original */
  char *string = orig;
  char *ptr = string;

  while (*ptr)
  {
    if (*ptr == '+' && flag_plus_to_space)    { *string++ = ' '; ptr++; }
    else if (*ptr != '%') *string++ = *ptr++;
    else  {
      unsigned int value;
      sscanf(ptr+1, "%2X", &value);
      *string++ = value;
      ptr += 3;
    }
  }
  *string = '\0';
  return orig;
}

// Get string between two pointers
int ifx_get_string(char *start_ptr,char *end_ptr,char *ifx_command_buff)
{
	if((start_ptr == NULL ) || (end_ptr == NULL) || (ifx_command_buff == NULL))
		return -1;
	memmove(ifx_command_buff,start_ptr,(char *)end_ptr - (char *)start_ptr);

	ifx_command_buff[end_ptr - start_ptr] = '\0';
	return strlen(ifx_command_buff);
}

// Check if arg is string and if successfull Get string between ""
int ifx_update_argument(char *arg)
{
	char *result= NULL;
	int ret =0 ;
	ret = strtol(arg,&result,10);
	if( (result != NULL) && (ret == 0))
	{
		ifx_debug_printf("\n Argument is string \n");
		if (ifx_get_string(((char *)strchr(arg,'"')+1),strrchr(arg,'"'),arg) < 0)
		{
			return -1;
		}
	}

	return 0;
}

// Get Function anme and update argument List
char *ifx_get_function(char *string,char **arg_list,int *no_of_arg)
{
	char *ifx_function_name = NULL;
	char *temp,*arg;

	ifx_function_name = (char *) calloc (IFX_FUN_NAME_LENGTH,sizeof(char));
	if (ifx_function_name == NULL)
		return NULL;
	*no_of_arg = 0;

	temp = strchr(string,'(');
	strncpy(ifx_function_name,string,(char *)temp - (char *)string );

	arg = temp + 1;

	while ( (temp = strchr(temp,',')) != NULL)
	{
		arg_list[*no_of_arg] = (char *)calloc(IFX_ARG_LEN,1);
		if (arg_list[*no_of_arg] == NULL)
			return NULL;
		strncpy(arg_list[*no_of_arg],arg,(char *)temp - (char *)arg);
		arg_list[*no_of_arg][(char *)temp - (char *)arg]= '\0';
		if (ifx_update_argument(arg_list[*no_of_arg]) < 0)
		{		
			*no_of_arg = *no_of_arg + 1;
			return NULL;
		}
		*no_of_arg = *no_of_arg + 1;
		temp = temp +1;
		arg = temp;
	}

	if ((temp = strchr(string,')')) != NULL)
	{
		// In case of now argument don't put space (fn())
		if ((arg == temp)  && (*no_of_arg == 0))
		{
			ifx_debug_printf("\n No argument Case .... \n");
			return ifx_function_name;
		}

		arg_list[*no_of_arg] = (char *)calloc(IFX_ARG_LEN,1);
		if (arg_list[*no_of_arg] == NULL)
					return NULL;
		strncpy(arg_list[*no_of_arg],arg,(char *)temp - (char *)arg);
		arg_list[*no_of_arg][(char *)temp - (char *)arg]= '\0';
		if (ifx_update_argument(arg_list[*no_of_arg]) < 0 )
		{
			*no_of_arg = *no_of_arg + 1;
			return NULL;
		}
		*no_of_arg = *no_of_arg + 1;

	}
	else
	{
		return NULL;
	}

	return ifx_function_name;
}

char *myPriorityStrStr(char *str)
{
	char *strCommBeg = NULL;
	char *strCommEnd = NULL;
	char *strTokBeg = NULL;

	strCommBeg = strstr(str,IFX_COMMENT_BEG) ? strstr(str,IFX_COMMENT_BEG) : (str + strlen(str)); 
	strCommEnd = strstr(str,IFX_COMMENT_END) ? strstr(str,IFX_COMMENT_END) : (str + strlen(str));
	strTokBeg = strstr(str,IFX_TOKEN_BEG) ? strstr(str,IFX_TOKEN_BEG) : (str + strlen(str));

	if((strCommBeg == strCommEnd) && (strCommEnd == strTokBeg))
		return NULL;
	if((strCommBeg < strCommEnd) && (strCommBeg < strTokBeg))
		return strCommBeg;
	if(strCommEnd < strTokBeg)
		return strCommEnd;
	return strTokBeg;
}

int ifx_sendDHTMLFile(char *buff,const char *host,int count,int writeFd,int *pbNewFile)
{
	char *rcv_buff;
	char *start_ptr = NULL ,*end_ptr = NULL,*write_ptr = NULL;
	char ifx_command_buff[IFX_COMMAND_LENGTH];
	int length ;
	struct ifx_wp ifx_wp_data;
	void *ifx_function_ptr = NULL ;
	char *ifx_function_name = NULL;
	char **arg_list;
	int no_of_arg = 0;
	int i;
	char *error;
	int writtenCount = 0;
	char *tempPtr = NULL;
	static int bNoEOC = 0;

	ifx_debug_printf("\nIn ifx_sendDHTMLFile() ... !\n");
	if(*pbNewFile){
		pbNewFile = 0;
		bNoEOC = 0;
	}

	rcv_buff=buff;
	rcv_buff[count]='\0'; /* Null terminate buffer to allow use of standard
							 string routines. */

	// Initially write_ptr should point to satrt of buffer
	write_ptr = rcv_buff;

	while ((start_ptr = strstr(write_ptr,"<%")) != NULL)
	{
		//Comment handling 
		if((strncmp(start_ptr,IFX_COMMENT_BEG,strlen(IFX_COMMENT_BEG)) == 0) || (strncmp(start_ptr,IFX_COMMENT_END,strlen(IFX_COMMENT_END)) == 0))
		{
			//Begining of the comment or end of the comment found.
			end_ptr = NULL;
			if(strncmp(start_ptr,IFX_COMMENT_END,strlen(IFX_COMMENT_END)) == 0)
			{
				//Previous comment is ending here.
				ifx_debug_printf("###In ifx_sendDHTMLFile : end of comment found start_ptr[%s]\n",start_ptr);
				end_ptr = start_ptr;
				bNoEOC = 0;
			}else if(strncmp(start_ptr,IFX_COMMENT_BEG,strlen(IFX_COMMENT_BEG)) == 0)
			{
				//Begining of the comment is found.
				ifx_debug_printf("###In ifx_sendDHTMLFile : begining of comment found start_ptr[%s]\n",start_ptr);
				end_ptr = strstr(start_ptr,IFX_COMMENT_END);
				ifx_debug_printf("###In ifx_sendDHTMLFile : end of comment found end_ptr[%s]\n",end_ptr);
			}

			if(end_ptr)
			{
				//End of the comment found.
				end_ptr += strlen(IFX_COMMENT_END);
				writtenCount = (*ifx_write)(writeFd,write_ptr, (end_ptr - write_ptr));
				if(writtenCount != (end_ptr - write_ptr))
					return write_ptr - rcv_buff + writtenCount;
				write_ptr = end_ptr;
				bNoEOC = 0;
				continue;
			}else{
				//End of the comment not found.
				bNoEOC = 1;
				break;
			}
		}
		//Begining of the IFX_TOKEN_BEG found.
		ifx_debug_printf("###In ifx_sendDHTMLFile : begining of TOKEN found with bNoEOC = %d\n",bNoEOC);
		if(bNoEOC)
		{
			//Previous comment has not ended yet so ignore this IFX_TOKEN_BEG
			write_ptr = start_ptr + strlen(IFX_TOKEN_BEG);
			continue;
		}

		//writtenCount = bb_full_write(a_c_w, write_ptr, (start_ptr - write_ptr));
		writtenCount = (*ifx_write)(writeFd,write_ptr, (start_ptr - write_ptr));
		if(writtenCount != (start_ptr - write_ptr))
			return write_ptr - rcv_buff + writtenCount;

		end_ptr = NULL;
		end_ptr = strstr(start_ptr,IFX_TOKEN_END);

		if(end_ptr == NULL)
		{
			// Case where full string is not in same buffer
			ifx_debug_printf("\nFound %s and no %s\n",IFX_TOKEN_BEG,IFX_TOKEN_END);
			return start_ptr - rcv_buff;
		}

		//Added to ignore spaces.
		start_ptr += strlen(IFX_TOKEN_BEG);
		while(isspace(*start_ptr++));
		start_ptr--;

		length = ifx_get_string(start_ptr , end_ptr ,ifx_command_buff);
		ifx_debug_printf("ifx_command is %s \n",ifx_command_buff);

		arg_list = (char **)calloc(IFX_MAX_NO_ARG,(sizeof(char **)));
		if (arg_list == NULL)
			return -1;

		(char *)ifx_function_name = ifx_get_function(ifx_command_buff,arg_list,&no_of_arg);

		if (ifx_function_name != NULL)
		{	
			ifx_debug_printf("No of arguments %d \n",no_of_arg);

			ifx_debug_printf("ifx_function_name is %s \n",ifx_function_name);
			for (i=0;i < no_of_arg; i++)
			{
				ifx_debug_printf("argument (%d) is (%s)\n ",i,arg_list[i]);
			}

			ifx_function_ptr = dlsym(dlHandle,(char *) ifx_function_name);
			if ((error = dlerror()) != NULL)
			{
				fprintf (stderr, "%s\n", error);
				fprintf(stderr,"\n Error : dlsym fails\n");
				//return start_ptr - rcv_buff;
			}else
			{
				//memset(ifx_wp_data.ifx_buff,0x00,IFX_DATA_BUFF);
				//ifx_wp_data.ifx_return_value = 10;
				strcpy(ifx_wp_data.host,host);
				ifx_wp_data.ifxReadFd = 0;
				ifx_wp_data.ifxWriteFd = writeFd;
				(*ifx_getHeaderData)("Remote IP",&tempPtr);
				if(tempPtr != NULL)
					strncpy(ifx_wp_data.ipaddr,tempPtr,32);
				ifx_wp_data.bSendHeader = 0;

				ifx_debug_printf("\n Try to call function ....\n");
				(*(int (*)(int,struct ifx_wp *,int,char **))ifx_function_ptr)(0,&ifx_wp_data,no_of_arg,arg_list);

				//ifx_debug_printf("\n Ret_buff is %s and retVal is %d\n",ifx_wp_data.ifx_buff,ifx_wp_data.ifx_return_value);
				//bb_full_write(a_c_w, ifx_wp_data.ifx_buff, strlen(ifx_wp_data.ifx_buff));
			}
		}

		if (no_of_arg > 0)
		{
			ifx_debug_printf("\n Tryin to free arg_list member Inside while loop \n");
			for (i =0 ; i<no_of_arg; i++)
			{
				IFX_FREE(arg_list[i]);
			}
			no_of_arg = 0;
		}

		IFX_FREE(arg_list);
		IFX_FREE(ifx_function_name);

		// shift buff to end of IFX_TOKEN_END
		write_ptr = end_ptr + strlen(IFX_TOKEN_END);	

	} // End of while Loop

	//bb_full_write(a_c_w, write_ptr, strlen(write_ptr));
	(*ifx_write)(writeFd,  write_ptr, strlen(write_ptr));
	return count;

} // end of function ifx_decode_string

void ifx_freeArgList(struct ifx_wp *pifx_wp)
{
	struct ifx_arg_list *pCurArg,*pNextArg;
	int i;
	
	pCurArg = pifx_wp->ifx_ptr_arg_list;
	while(pCurArg){
		pNextArg = pCurArg->next;
		IFX_FREE(pCurArg->pifx_param_name);
		if(pCurArg->numMultiBufs){
			for(i = 0;i < pCurArg->numMultiBufs; i++){
				IFX_FREE(pCurArg->ifx_param_value.pArrMultiBuf[i].buf);
			}
			IFX_FREE(pCurArg->ifx_param_value.pArrMultiBuf);
		}else{
			IFX_FREE(pCurArg->ifx_param_value.buf);
		}
		IFX_FREE(pCurArg);
		pCurArg = pNextArg;
	}
	IFX_FREE(pifx_wp->pBoundary);
}

struct ifx_arg_list* ifx_MakeArgNode(void)
{
	struct ifx_arg_list *pCurArg;
	(pCurArg) = (struct ifx_arg_list *)malloc(sizeof(struct ifx_arg_list));
	if(pCurArg == NULL)
		return NULL;
	(pCurArg)->pifx_param_name = NULL;
	(pCurArg)->ifx_param_value.buf = NULL;
	(pCurArg)->numMultiBufs = 0;
	(pCurArg)->next = NULL;
	(pCurArg)->totBufLen = 0;
	return pCurArg;
}

int ifx_parsePostArgBuf(char *inBuf,struct ifx_wp *ifx_data_ptr,int count, int *parg_incomplete)
{
	char *nextTok = NULL;
	char *strArgs = NULL;
	char *pCurParaValLoc = NULL;
	struct ifx_arg_list *pCurArg = NULL;
	struct ifx_arg_list *pPreArg = NULL;

	ifx_debug_printf("\n ORG_BUFF is %s \n",inBuf);

	if(count <= 0)
		return 0;

	//Reach till the end of the current argument list
	if(ifx_data_ptr->ifx_ptr_arg_list){
		pPreArg = ifx_data_ptr->ifx_ptr_arg_list;
		while(pPreArg->next)
			pPreArg = pPreArg->next;
	}
	
	strArgs = inBuf;
	do{
		int paramLen = 0;
		nextTok = strchr(strArgs,'&');
		if(*parg_incomplete > 0){
			if(*parg_incomplete == 1){
				//The previous argument name is spanning accross the packets.
				pCurParaValLoc = strchr(strArgs,'=');
				paramLen = strlen(pPreArg->pifx_param_name) + pCurParaValLoc - strArgs + 1;
				pPreArg->pifx_param_name = (char *)realloc(pPreArg->pifx_param_name,paramLen);
				strncat(pPreArg->pifx_param_name,strArgs,pCurParaValLoc - strArgs);
				pPreArg->pifx_param_name[paramLen - 1] = 0x00;
				strArgs =  pCurParaValLoc + 1;
				ifx_debug_printf("###In ifx_parsePostArgBuf : pifx_param_name [%s]\n",pPreArg->pifx_param_name);
				
			}

			if(nextTok == NULL){
				//The previous argument is the last argument of all and now we have the last part of the uncompleted argument value.
				paramLen = (pPreArg->ifx_param_value.buf ? strlen(pPreArg->ifx_param_value.buf) : 0) + strlen(strArgs) + 1;
			}else{
				//The previous argument completes here and there are more to follow.
				paramLen = (pPreArg->ifx_param_value.buf ? strlen(pPreArg->ifx_param_value.buf) : 0) + nextTok - strArgs + 1;
			}

			if(pPreArg->ifx_param_value.buf){
				//If buffer is already allocated for the current argument value then reallocate it.
				pPreArg->ifx_param_value.buf = (char *)realloc(pPreArg->ifx_param_value.buf,paramLen);
			}else{
				//If the buffer is not allocated yet then allocate it.
				pPreArg->ifx_param_value.buf = (char *)calloc(paramLen,sizeof(char));
			}
			strncat(pPreArg->ifx_param_value.buf,strArgs,paramLen - 1);
			pPreArg->totBufLen = paramLen - 1;
			pPreArg->ifx_param_value.buf[paramLen - 1] = 0x00;

			*parg_incomplete = 0;
		}else{
			//We have found new argument (name,value) pair.
			pCurArg = ifx_MakeArgNode();
			ifx_data_ptr->ifx_no_argument++;

			pCurParaValLoc = strchr(strArgs,'=');
			if(pCurParaValLoc == NULL){
				//The current argument name is incomplete.
				paramLen = strlen(strArgs) + 1;
				*parg_incomplete = 1;
			}else{
				paramLen = pCurParaValLoc - strArgs + 1;
			}
			pCurArg->pifx_param_name = (char *)calloc(paramLen,sizeof(char));
			memcpy(pCurArg->pifx_param_name,strArgs,paramLen - 1);

			strArgs = pCurParaValLoc + 1;
			if(*parg_incomplete == 0){
				if(nextTok == NULL)
				{
					//The current argument value is incomplete.
					paramLen = strlen(strArgs) + 1;
					*parg_incomplete = 2;
				}else if(pCurParaValLoc)
				{
					//The current argument value is complete.
					paramLen = nextTok - strArgs + 1;
				}
				pCurArg->ifx_param_value.buf = (char *)calloc(paramLen,sizeof(char));
				memcpy(pCurArg->ifx_param_value.buf,strArgs,paramLen - 1);
				pCurArg->totBufLen = paramLen - 1;
			}

			ifx_debug_printf("###In ifx_parsePostArgBuf : *parg_incomplete = %d\n",*parg_incomplete);
			if(ifx_data_ptr->ifx_ptr_arg_list == NULL)
				ifx_data_ptr->ifx_ptr_arg_list = pCurArg;

			if(pPreArg != NULL)
				pPreArg->next = pCurArg;
			pPreArg = pCurArg;

		}
		strArgs = nextTok + 1;
		if(*parg_incomplete != 1){
			//Decode the argument name and value.
			decodeString(pPreArg->ifx_param_value.buf,1);
			decodeString(pPreArg->pifx_param_name,1);
			ifx_debug_printf("###In ifx_parsePostArgBuf : pifx_param_name [%s] and ifx_param_value.buf [%s]\n",pPreArg->pifx_param_name,pPreArg->ifx_param_value.buf);
		}
	}while(nextTok != NULL);

	return 0;
}

/*Remove any extra unwanted characters at the begining or end of the string as per the direction. */
char *ifx_RmExtraChar(char *str,int dir)
{
	if(str){
		while(*str == '\r' || *str == '\n' || *str == '-'){
			if(dir == FORWARD)
				str++;
			else if(dir == BACKWARD)
				str--;
		}
	}
	return str;
}

/*Special strstr, which searches for Needle in the Heap till len, irrespective of null termination in Heap*/
char *xstrstr(char *strHeap,char *strNeedle,int len)
{
	int iLoc = 0;
	while(iLoc < len){
		if(strncmp(strHeap,strNeedle,strlen(strNeedle)) == 0)
			return strHeap;
		strHeap++;
		iLoc++;
	}
	return NULL;
}

int ifx_parseMPartArgBuf(char *inBuf,struct ifx_wp *ifx_data_ptr,int count, int *parg_incomplete,int *pbFirstTime)
{
	char *nextTok = NULL;
	char *strArgs = NULL;
	char *pCurParaValLoc = NULL;
	struct ifx_arg_list *pCurArg = NULL;
	struct ifx_arg_list *pPreArg = NULL;

	//ifx_debug_printf("\n ORG_BUFF is %s \n",inBuf);

	if(count <= 0)
		return 0;

	//Reach till the end of the current argument list
	if(ifx_data_ptr->ifx_ptr_arg_list){
		pPreArg = ifx_data_ptr->ifx_ptr_arg_list;
		while(pPreArg->next)
			pPreArg = pPreArg->next;
	}
	
	strArgs = inBuf;
	//If this is called for the first time then forward the pointer to 
	//escape the boundary in the begining of the buffer.
	if(*pbFirstTime == 1)
	{
		nextTok = xstrstr(strArgs,ifx_data_ptr->pBoundary,count);
		strArgs = nextTok + strlen(ifx_data_ptr->pBoundary);
		*pbFirstTime = 0;
	}
	
	do{
		int paramLen = 0;
		char *ptemp = NULL;
		
		nextTok = xstrstr(strArgs,ifx_data_ptr->pBoundary,count - (strArgs - inBuf));

		if(*parg_incomplete == 2)
		{
			//The previous argument value is spanning accross the packets.
			//We are not taking care of the case where the boundary or argument name spans accross the packets.
			if(nextTok){
				//The end of uncomplete argument value is reached.
				ptemp = ifx_RmExtraChar(nextTok,BACKWARD);
				ptemp += 1;
				paramLen = ptemp - strArgs + 1;
				*parg_incomplete = 0;
			}else{
				//Even this packet contains the argument value in partial form.
				paramLen = count + 1;
				*parg_incomplete = 2;
			}
			if(paramLen <= (MALLOC_BUF_SIZE / 2) && pPreArg->numMultiBufs == 0){
				//The paramLen is small enough to store the argument value in a single buffer.
				if(pPreArg->ifx_param_value.buf)
					pPreArg->ifx_param_value.buf = (char *)realloc(pPreArg->ifx_param_value.buf,paramLen + strlen(pPreArg->ifx_param_value.buf));
				else
					pPreArg->ifx_param_value.buf = (char *)calloc(paramLen,sizeof(char));
				strncat(pPreArg->ifx_param_value.buf,strArgs,nextTok - strArgs);
				pPreArg->totBufLen = paramLen - 1;
				//ifx_debug_printf("###In ifx_parseMPartArgBuf : pifx_param_name [%s] and ifx_param_value.buf [%s]\n",pPreArg->pifx_param_name,pPreArg->ifx_param_value.buf);
				printf("###In ifx_parseMPartArgBuf : pifx_param_name [%s] and ifx_param_value.buf [%s]\n",pPreArg->pifx_param_name,pPreArg->ifx_param_value.buf);				
			}else{
				//The paramLen large and hence the argument value should be stored in multiple buffers.
				if(pPreArg->numMultiBufs == 0 && pPreArg->ifx_param_value.buf){
					//The part of the current argument value came in the last packet.
					//So, attach the previously allocated single buffer as the first buffer of the multiple buffer
					ptemp = pPreArg->ifx_param_value.buf;
					pPreArg->ifx_param_value.buf = NULL;
					pPreArg->numMultiBufs += 1;
					pPreArg->ifx_param_value.pArrMultiBuf = (T_MULTI_BUF *)realloc(pPreArg->ifx_param_value.pArrMultiBuf,pPreArg->numMultiBufs * sizeof(T_MULTI_BUF));
					pPreArg->ifx_param_value.pArrMultiBuf[pPreArg->numMultiBufs - 1].buf = ptemp;
					pPreArg->ifx_param_value.pArrMultiBuf[pPreArg->numMultiBufs - 1].len = pPreArg->totBufLen;
					//ifx_debug_printf("###In ifx_parseMPartArgBuf : pifx_param_name [%s] and ifx_param_value.pArrMultiBuf[%d].len [%d]\n",pPreArg->pifx_param_name,pPreArg->numMultiBufs - 1,pPreArg->ifx_param_value.pArrMultiBuf[pPreArg->numMultiBufs - 1].len);
					printf("###In ifx_parseMPartArgBuf : pifx_param_name [%s] and ifx_param_value.pArrMultiBuf[%d].len [%d]\n",pPreArg->pifx_param_name,pPreArg->numMultiBufs - 1,pPreArg->ifx_param_value.pArrMultiBuf[pPreArg->numMultiBufs - 1].len);
				}

				//Allocate new mulitiple buffer structure and copy the argument value.
				pPreArg->numMultiBufs += 1;
				pPreArg->ifx_param_value.pArrMultiBuf = (T_MULTI_BUF *)realloc(pPreArg->ifx_param_value.pArrMultiBuf,pPreArg->numMultiBufs * sizeof(T_MULTI_BUF));

				pPreArg->ifx_param_value.pArrMultiBuf[pPreArg->numMultiBufs - 1].buf = (char *)calloc(paramLen,sizeof(char));
				memcpy(pPreArg->ifx_param_value.pArrMultiBuf[pPreArg->numMultiBufs - 1].buf,strArgs,paramLen - 1);
				pPreArg->ifx_param_value.pArrMultiBuf[pPreArg->numMultiBufs - 1].len = paramLen - 1;
				//Adjust the totBufLen to reflect the summation of the length of all the buffer of this multiple buffer.
				pPreArg->totBufLen += paramLen - 1;
				//ifx_debug_printf("###In ifx_parseMPartArgBuf : pifx_param_name [%s] and ifx_param_value.pArrMultiBuf[%d].len [%d]\n",pPreArg->pifx_param_name,pPreArg->numMultiBufs - 1,pPreArg->ifx_param_value.pArrMultiBuf[pPreArg->numMultiBufs - 1].len);
				printf("###In ifx_parseMPartArgBuf : pifx_param_name [%s] and ifx_param_value.pArrMultiBuf[%d].len [%d]\n",pPreArg->pifx_param_name,pPreArg->numMultiBufs - 1,pPreArg->ifx_param_value.pArrMultiBuf[pPreArg->numMultiBufs - 1].len);
			}
		}else{
			//We have found new argument (name,value) pair.
			pCurParaValLoc = strstr(strArgs,"Content-Disposition");
			if(pCurParaValLoc == NULL)
				break;

			pCurArg = ifx_MakeArgNode();
			ifx_data_ptr->ifx_no_argument++;

			strArgs = pCurParaValLoc + strlen("Content-Disposition");
			pCurParaValLoc = strstr(strArgs,"name=\"");
			strArgs = pCurParaValLoc + strlen("name=\"");
			ptemp = strchr(strArgs,'"');
			paramLen = ptemp - strArgs + 1;

			pCurArg->pifx_param_name = (char *)calloc(paramLen,sizeof(char));
			strncpy(pCurArg->pifx_param_name,strArgs,paramLen - 1);

			strArgs = ptemp + 1;
			strArgs = strchr(strArgs,'\n');
			strArgs = ifx_RmExtraChar(strArgs,FORWARD);
			//Ignore and forward the buffer if the strArg contains Content-Type
			if(strncmp(strArgs,"Content-Type",strlen("Content-Type")) == 0){
				strArgs = strstr(strArgs,"\n");
				strArgs = ifx_RmExtraChar(strArgs,FORWARD);
			}
			if(nextTok){
				//The current argument value is complete with in the read packet.
				ptemp = ifx_RmExtraChar(nextTok,BACKWARD);
				ptemp += 1;
				paramLen = ptemp - strArgs + 1;
			}else{
				//The current argument value spans accross the packets.
				paramLen = count - (strArgs - inBuf) + 1;
				*parg_incomplete = 2;
			}
			pCurArg->ifx_param_value.buf = (char *)calloc(paramLen,sizeof(char));
			memcpy(pCurArg->ifx_param_value.buf,strArgs,paramLen - 1);
			pCurArg->totBufLen = paramLen - 1;

			//ifx_debug_printf("###In ifx_parseMPartArgBuf : *parg_incomplete = %d\n",*parg_incomplete);
			printf("###In ifx_parseMPartArgBuf : *parg_incomplete = %d\n",*parg_incomplete);
			//Attach the current argument node in the argument list of the ifx_data_ptr.
			if(ifx_data_ptr->ifx_ptr_arg_list == NULL)
				ifx_data_ptr->ifx_ptr_arg_list = pCurArg;

			if(pPreArg != NULL)
				pPreArg->next = pCurArg;
			pPreArg = pCurArg;

			//ifx_debug_printf("###In ifx_parseMPartArgBuf : pifx_param_name [%s] and ifx_param_value.buf [%s] with len [%d]\n",pPreArg->pifx_param_name,pPreArg->ifx_param_value.buf,pCurArg->totBufLen);
			printf("###In ifx_parseMPartArgBuf : pifx_param_name [%s] and ifx_param_value.buf [%s] with len [%d]\n",pPreArg->pifx_param_name,pPreArg->ifx_param_value.buf,pCurArg->totBufLen);
		}
		//Forward the strArgs to point to the begining of the next argument.
		strArgs = nextTok + strlen(ifx_data_ptr->pBoundary);
	}while(nextTok != NULL);

	return 0;
}

// Just for debug
void print_arg_list(struct ifx_wp *ifx_data_ptr)
{
	struct ifx_arg_list *ptr;

	if (ifx_data_ptr == NULL)
		return;

	ptr = ifx_data_ptr->ifx_ptr_arg_list;

	ifx_debug_printf("\n No. of arguments is %d\n",ifx_data_ptr->ifx_no_argument);

	while (ptr)
	{
		ifx_debug_printf("\n ifx_ptr_arg->pifx_param_name = %s ",ptr->pifx_param_name);
		ifx_debug_printf("\n ifx_ptr_arg->ifx_param_value.buf %s",ptr->ifx_param_value.buf);
		ptr = ptr->next;
	}

	return;

}

//Check and extract the boundary.
void ifx_ExtractMPartBoundary(const char *content_type,struct ifx_wp *pifx_wp)
{
	if (content_type == NULL)
	{
		return;
	}
	if(strstr(content_type,"multipart/form-data"))
	{
		char *ptemp = NULL;
		ptemp = strstr(content_type,"boundary=");
		if(ptemp)
		{
			ptemp += strlen("boundary=");
			pifx_wp->pBoundary = strdup(ptemp);
			ifx_debug_printf("Multipart Boundary found as [%s]\n",pifx_wp->pBoundary);
		}
	}
}

int ifx_sendGoform(const char *url,
		const char *request, const char *urlArgs,
		int bodyLen, const char *cookie,
		const char *content_type,const char *host,int readFd,int writeFd)
{
	char wbuf[IFX_DATA_BUFF];
	int count;
	struct ifx_wp ifx_data_ptr;
	void *ifx_function_ptr = NULL ;
	char *ifx_function_name ;
	//void *handle = NULL;
	char *error;
	char *tempPtr = NULL;
	int	arg_incomplete_flag = 0;
	//int bFirstTime = 1;
	int tlen = 0;
	//
	int j=0;
	int StartPos=0,EndPos=0,end_count=0;
	unsigned long length;
	char *image_begin=NULL;	
	int numbytewritten=0;
	unsigned long left;

        //WILDPASS system_restore use
        int re_count = 0;
	int StartPosR = 0, EndPosR = 0;
	int ibRestore= 0;//0:not system_retore,1:system_restore
	//

	ifx_function_name = (char *)calloc(IFX_FUN_NAME_LENGTH,sizeof(char));
	if (ifx_function_name == NULL)
		return -1;
	memset(&ifx_data_ptr, 0x0, sizeof(ifx_data_ptr));
	ifx_data_ptr.ifx_no_argument = 0;
	ifx_data_ptr.ifx_ptr_arg_list = NULL;
	ifx_data_ptr.pBoundary = NULL;
	
	ifx_ExtractMPartBoundary(content_type,&ifx_data_ptr);

        //calvin move here
        ifx_debug_printf("url is %s\n",url);

	if(strncmp(url,"/goform/",8) == 0)
		url += 8;
	strncpy(ifx_function_name,url,IFX_FUN_NAME_LENGTH);

	ifx_debug_printf("Function to be execute is %s \n",ifx_function_name);     
        //move end

        ifx_debug_printf("call function is %s\n",ifx_function_name);
	ifx_debug_printf("bodyLen received is %d\n",bodyLen);
/* [ Ritesh taking care of multiple pages and the like */
	do{
		if(bodyLen - tlen > IFX_DATA_BUFF - 1)
			count = IFX_DATA_BUFF - 1;
		else
			count = bodyLen - tlen;

		memset(wbuf,'\0',IFX_DATA_BUFF);
		count = (*ifx_read)(readFd,wbuf,count);
		if (count == 0) {
			break;
		}

		
		if (count < 0) {
			fprintf(stderr, "\nConnection aborted when reading! \n");
			return -1;
		}
		tlen += count;

		if (bodyLen > 0 && tlen > bodyLen) {
			fprintf(stderr, "\nBytes Read [%d] exceeds Content-Length [%d]! \n",
					bodyLen, tlen);
			return -1;
		}
		/*
		 * The code below works on the assumption that all large form data
		 * is going to be in "multipart" form of HTTP and small form data
		 * will be normal POST/GET. So for "multipart", we keep the data
		 * in several smaller buffers (prevent malloc failure), while for
		 * the normal case, we just do a realloc (to prevent having to rewrite
		 * all functions which do string/memory operations on a single 
		 * contiguous buffer!) 
		 * Example of a large POST is firmware upgrade operation.  - Ritesh
		 */
		if(ifx_data_ptr.pBoundary){
			//

		#if defined(WILDPASS)	
		 if (strncmp(ifx_function_name,"ifx_set_system_upgrade",22) == 0)
		 {
			ifx_debug_printf("execute rc.kill\n");
		
			system("/etc/rc.d/rc.kill");
		 }else{
			ibRestore= 1;//system_restore
			ifx_debug_printf(" NOT execute rc.kill\n");
		 }	
		 #else
			system("/etc/rc.d/rc.kill");
               #endif

			//system("/etc/rc.d/rc.kill");
			//
			if ((image_begin = strstr(wbuf,"")))
			{
				 FILE *fp=fopen("/tmp/web_image","wb");
				 length = bodyLen;
				 ifx_debug_printf("do 1--\n");
				if(fp){
					 left = (unsigned long)(wbuf+sizeof(wbuf))-(unsigned long)image_begin-1;					 			
					//ifx_debug_printf("do left is %d\n",left);				 			
					length -= left;
					//ifx_debug_printf("do length is %d\n",length);				 	
					for(j=0;j<left;j++){
						if(wbuf[j] == 0x0D  && 
						    wbuf[j+1] == 0x0A &&
						    wbuf[j+2] == 0x0D &&
						    wbuf[j+3] == 0x0A ){
							    StartPos = j+4;
                                                         
							//the following is for system_retore use
#if defined(WILDPASS)	
                                                            if (re_count==1)
                                                             StartPosR = j+4;
							   
                                                             
							    re_count++;
#endif //#if defined(WILDPASS)	
								
							}//start position
					//}

							}

					ifx_debug_printf("do StartPos is %d\n",StartPos);
					ifx_debug_printf("do StartPosR is %d\n",StartPosR);
					ifx_debug_printf("do EndPosR is %d\n",EndPosR);
					ifx_debug_printf("ibREstore is %d\n",ibRestore);
					ifx_debug_printf("do image_begin is %d\n",image_begin);	
#if defined(WILDPASS)						
				       // if (StartPosR >0 && EndPosR >0 && ibRestore== 1)//original
				       if (StartPosR >0  && ibRestore== 1)
				       {
					    //fwrite(image_begin+StartPosR,sizeof(char),EndPosR-StartPosR,fp);	
					   fwrite(image_begin+StartPosR,sizeof(char),left-StartPosR,fp);
				        }
					else		 	
					fwrite(image_begin+StartPos,sizeof(char),left-StartPos,fp);
#else
					fwrite(image_begin+StartPos,sizeof(char),left-StartPos,fp);
#endif //#if defined(WILDPASS)						
					numbytewritten = left;
					ifx_debug_printf("do numbytewritten is %d\n",numbytewritten);
					//find end pos
					ifx_debug_printf("-------------------------- length=%d\n",length);
//#if defined(WILDPASS)				
//					if (strncmp(ifx_function_name,"ifx_set_system_upgrade",22) == 0){
//#endif						
					do{
						count = (*ifx_read)(readFd,wbuf,length>sizeof(wbuf)?sizeof(wbuf):length);
						ifx_debug_printf("do count is %d\n",count);
						length -= count;
						if (count>0)
						{
						     for(j=0;j<count;j++)
						    {
							if(wbuf[j] == 0x0D  && 
							    wbuf[j+1] == 0x0A &&
							    wbuf[j+2] == 0x2D &&
							    wbuf[j+3] == 0x2D ){
								EndPos = numbytewritten+j;						
								end_count = j;
							}					
						}
						}//if count>0
						
					
						if(end_count > 0){
							fwrite(wbuf,sizeof(char),end_count,fp);	
							}
						else
							fwrite(wbuf,sizeof(char),count,fp);
						numbytewritten +=count;

						//ifx_debug_printf("###### numbytewritten=%d\n",numbytewritten);
						//ifx_debug_printf("-------------------------- length=%d\n",length);
					}while (length > 0);
					printf("do EndPos is %d\n",EndPos);
#if defined(WILDPASS)					
                                        //};
				
					ifx_debug_printf("-------PRE WEB LENGTH------\n");
                              //      if (StartPosR >0 && EndPosR >0 && ibRestore==1)//ORIGINAL
                               if (StartPosR >0 && ibRestore==1)
					{
                            //              ifx_debug_printf("StartPosR--\n");
				//	  //web_imgae_length = EndPosR - StartPosR;
					  web_image_length = EndPos - StartPosR;
					}
					else
					web_image_length = EndPos - StartPos;
#else
					web_image_length = EndPos - StartPos;		
#endif// #if defined(WILDPASS)						
					ifx_debug_printf("-------><....------web_image_length = %d\n",web_image_length);
				}
				else
					ifx_debug_printf("Error in create web tmp file!!\n");

			if (fp)
			{
				ifx_debug_printf("OK - closing..");
				fclose(fp);
			}
			break;

			}
			
			}
		else
			ifx_parsePostArgBuf(wbuf,&ifx_data_ptr,count,&arg_incomplete_flag);
	}while(1);
	
	print_arg_list(&ifx_data_ptr);

	ifx_function_ptr = dlsym(dlHandle,(char *) ifx_function_name);
	if ((error = dlerror()) != NULL)
	{
		fprintf (stderr, "%s\n", error);
		fprintf(stderr,"\n Error : dlsym fails\n");
		ifx_freeArgList(&ifx_data_ptr);
		IFX_FREE(ifx_function_name);
		return -1;
	}
	else
	{

		ifx_debug_printf("Try to call post function ....\n");

		memset(ifx_data_ptr.host,'\0',sizeof(ifx_data_ptr.host));
		strncpy(ifx_data_ptr.host,host,sizeof(ifx_data_ptr.host));
		ifx_data_ptr.ifxReadFd = readFd;
		ifx_data_ptr.ifxWriteFd = writeFd;
		(*ifx_getHeaderData)("Remote IP",&tempPtr);
		if(tempPtr != NULL)
			strncpy(ifx_data_ptr.ipaddr,tempPtr,32);
		ifx_debug_printf("###Remote IP addr : %s\n",ifx_data_ptr.ipaddr);
		ifx_data_ptr.bSendHeader = 1;

		(*(int (*)(struct ifx_wp *,char *,char *))ifx_function_ptr)(&ifx_data_ptr,NULL,NULL);
		//ifx_debug_printf("\n ifx_data_ptr.ifx_return_value is %d and ifx_data_ptr.ifx_buff is %s\n",ifx_data_ptr.ifx_return_value,ifx_data_ptr.ifx_buff);

		//bb_full_write(a_c_w,ifx_data_ptr.ifx_buff,strlen(ifx_data_ptr.ifx_buff));
	}
	ifx_freeArgList(&ifx_data_ptr);
	IFX_FREE(ifx_function_name);

	return 0;
}


/******************************************************************************/
/*
 *	Home page handler
 */

int ifx_AuthHandler(char *url,int readFd, int writeFd)
{
	int now, timeout;
	httpdType wp;
	char *tempPtr = NULL;
	char_t	sIdleTime[MAX_DATA_LEN];

	now = time((time_t*)NULL);
	ifx_debug_printf("diff time is %d\n",now - connection.time);

	memset(sIdleTime, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_SYSTEM_AUTOLOGOUT, "AutoLogoutTime", sIdleTime) == 0)
	{		
		ifx_debug_printf("Cannot get idle time.");
		return -1;
	}

	timeout = atoi(sIdleTime);

	if((now - connection.time) > timeout)
	{
		ifx_debug_printf("Previous administrator's time has expired\n");
		memset(connection.ipaddr,0x00,sizeof(connection.ipaddr));
		connection.allowed = 0;
		connection.block = 0;
#ifdef ATA
		//IFX_CM_WebShut();
#endif
	}

	if (strstr(IFX_BYPASS_URL,url))
	{
		ifx_debug_printf("URL : %s\n",IFX_BYPASS_URL);
		return 0;
	}

	(*ifx_getHeaderData)("Remote IP",&tempPtr);
	strncpy(wp.ipaddr,tempPtr,sizeof(wp.ipaddr));

	(*ifx_getHeaderData)("Host",&tempPtr);
	strncpy(wp.host,tempPtr,sizeof(wp.host));
	wp.ifxReadFd = readFd;
	wp.ifxWriteFd = writeFd;

	if (strncmp(connection.ipaddr,wp.ipaddr,strlen(wp.ipaddr)) == 0)
	{
		ifx_debug_printf("the same ip is %s\n",connection.ipaddr);
		ifx_debug_printf("allowed\n");
		connection.time = now;
		return 0;
	}else{
		ifx_debug_printf("IP NOT allowed\n");
	}

	ifx_httpdRedirect(&wp, T("login.asp"));
	return 1;
}
