/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include "ifx_httpd_method.h"
#include "ifx_exportFunc.h"

#ifdef DMALLOC
#include "dmalloc.h"
#endif

#define WEBS_MAX_PASS 32
static char_t	websPassword[WEBS_MAX_PASS];	/* Access password (decoded) */
extern int (*ifx_sendHeaders)(int responseNum,char *redirectURL);
extern int (*ifx_read)(int fd, void *buf, int len);
extern int (*ifx_write)(int fd, const void *buf, int len);

#define  MAX_PAGE_BUF	1024
int  ifx_httpdWrite(httpd_t wp, char_t* fmt, ...)
{
	va_list vargs;
	char destBuf[MAX_PAGE_BUF];
#if 1
	char *s;
	int d;
	char *cp;
	int curLoc = 0;
	char tmpbuf[MAX_PAGE_BUF];
	memset(destBuf,0x00,MAX_PAGE_BUF);
	memset(tmpbuf,0x00,MAX_PAGE_BUF);
	va_start(vargs,fmt);
	for(cp=fmt; cp && *cp; cp++){
		if(*cp == '%'){
		//	continue;
		//if(*(cp-1) == '%')
			switch(*(cp+1)){
				case 'd':
					d = va_arg(vargs,int);
					snprintf(tmpbuf,MAX_PAGE_BUF,"%s%d",destBuf,d);
					strncpy(destBuf, tmpbuf,MAX_PAGE_BUF);	
					curLoc = strlen(destBuf);
					cp++;
					break;
				case 's':
					s = va_arg(vargs,char *);
					gstrncat(destBuf,s,strlen(s));
					curLoc += strlen(s);
					cp++;
					break;
				default:
					destBuf[curLoc++] = *cp;
					break;
			}
		}else{
			destBuf[curLoc++] = *cp;
		}
	}
	va_end(vargs);
	//wp->ifx_return_value = 0;
	//gstrncat(wp->ifx_buff,destBuf,strlen(destBuf));	
#else
	va_start(vargs, fmt);

	if (vsnprintf(destBuf, sizeof(destBuf) , fmt, vargs) >= sizeof(destBuf)) {
		ifx_debug_printf("ifx_httpdWrite : Truncated Line!\n");
	}
	va_end(vargs);
#endif
	(*ifx_write)(wp->ifxWriteFd,(const void *)destBuf,strlen(destBuf));
	ifx_debug_printf("ifx_httpdWrite : wrote [%s]\n",destBuf);
	return 0;
}

char msgBeg[] = T("<html><head><title>Document Error: %d</title></head>\r\n\
		<body><h2>Access Error: %d</h2>\r\n\
		<p>");
char msgEnd[] = T("</p></body></html>\r\n");
#define MAX_ERR_PAGE_LEN	512

void ifx_httpdError(httpd_t wp, int code, char_t *fmt, ...)
{
	va_list vargs;
	char destBuf[MAX_ERR_PAGE_LEN] = {0};
	char msg[MAX_ERR_PAGE_LEN];
	char tmpbuf[MAX_ERR_PAGE_LEN];
#if 0
	char *s;
	char *cp;
	int curLoc = 0;

	//wp->bSendHeader = 1;	//Enable seding of header
	//wp->responseCode = code;
	//strcpy(wp->redirectURL,"");
	//sendHeaders(code);	will be called from calling function.
#endif
	if(wp->bSendHeader)
		(*ifx_sendHeaders)(code,NULL);
	memset(msg,0x00,MAX_ERR_PAGE_LEN);
	strncat(msg,msgBeg,strlen(msgBeg));
#if 0
	strncat(msg,fmt,strlen(fmt));
	strcat(msg,msgEnd);
	
	memset(destBuf,0x00,MAX_ERR_PAGE_LEN);
	va_start(vargs,fmt);
	for(cp=msg; cp && *cp; cp++){
		if(*cp == '%'){
		//	continue;
		//if(*(cp-1) == '%')
			switch(*(cp+1)){
				case 'd':
					snprintf(tmpbuf,MAX_ERR_PAGE_LEN,"%s%d",destBuf,code);
					strncpy(destBuf, tmpbuf,MAX_ERR_PAGE_LEN);
					curLoc = strlen(destBuf);
					cp++;
					break;
				case 's':
					s = va_arg(vargs,char *);
					gstrncat(destBuf,s,strlen(s));
					curLoc += strlen(s);
					cp++;
					break;
				default:
					destBuf[curLoc++] = *cp;
					break;
			}
		}else{
			destBuf[curLoc++] = *cp;
		}
	}
	va_end(vargs);
#else
	va_start(vargs, fmt);

	vsnprintf(msg, sizeof(msg) , fmt, vargs);
	va_end(vargs);
	
	snprintf(tmpbuf, sizeof(tmpbuf),  msgBeg, code, code);
	snprintf(destBuf, sizeof(destBuf), "%s%s%s", tmpbuf, msg, msgEnd);

#endif

	//wp->ifx_return_value = -1;
	//gstrncat(wp->ifx_buff,destBuf,strlen(destBuf));
	//printf("From httpdError responseCode[%d] and string[%s]\n",code,destBuf);
	(*ifx_write)(wp->ifxWriteFd,(const void *)destBuf,strlen(destBuf));
	return;
}

/******************************************************************************/
/*
 *	Utility routine to crack Ejscript arguments. Return the number of args
 *	seen. This routine only supports %s and %d type args.
 
 *	Typical usage:
 *
 *		if (ejArgs(argc, argv, "%s %d", &name, &age) < 2) {
 *			error("Insufficient args\n");
 *			return -1;
 *		}
 */

int ejArgs(int argc, char_t **argv, char_t *fmt, ...)
{
	va_list	vargs;
	char_t	*cp, **sp;
	int		*ip;
	int		argn;

	va_start(vargs, fmt);

	if (argv == NULL) {
		return 0;
	}

	for (argn = 0, cp = fmt; cp && *cp && argv[argn]; ) {
		if (*cp++ != '%') {
			continue;
		}

		switch (*cp) {
		case 'd':
			ip = va_arg(vargs, int*);
			*ip = gatoi(argv[argn]);
			break;

		case 's':
			sp = va_arg(vargs, char_t**);
			*sp = argv[argn];
			break;

		default:
			break;
		}
		argn++;
	}

	va_end(vargs);
	return argn;
}

void ejSetResult(int eid, char_t *s)
{
}
/******************************************************************************/
/*
 *	Default error handler.  The developer should insert code to handle
 *	error messages in the desired manner.
 */

void defaultErrorHandler(int etype, char_t *msg)
{
#if 1 
	write(1, msg, gstrlen(msg));
#endif
}

/******************************************************************************/
/*
 *	Trace log. Customize this function to log trace output
 */

void defaultTraceHandler(int level, char_t *buf)
{
/*
 *	The following code would write all trace regardless of level
 *	to stdout.
 */
#ifdef DEBUG
	if (buf) {
		write(1, buf, gstrlen(buf));
	}
#endif
}


void ifx_httpdDone(httpd_t wp, int code){
	//wp->bSendHeader = 1;
	//wp->responseCode = code;
	(*ifx_sendHeaders)(code,NULL);
}
#if 0
int ifx_httpdGetVarBufLen(httpd_t wp,char *var)
{
	struct ifx_arg_list *pArgList = NULL;
	int i;
	
	pArgList = wp->ifx_ptr_arg_list;
	if(pArgList == NULL){
		ifx_debug_printf("ifx_httpdGetVarBufLen Error : wp->ifx_ptr_arg_list is NULL\n");
		return -1;
	}
	
	for(i = 0; i < wp->ifx_no_argument && pArgList; i++, pArgList = pArgList->next){
		if(gstrncmp(pArgList->pifx_param_name,var,strlen(var)) == 0){
			ifx_debug_printf("ifx_httpdGetVarBufLen : var %s found len as %d\n",var,pArgList->totBufLen);
			return pArgList->totBufLen;
		}
	}
	//printf("ifx_httpdGetVarBufLen : var %s not found. Returning %d\n",var,-1);
	return -1;

}

int ifx_httpdGetMBufNextBuf(httpd_t wp,char *var,char **retBuf,int readLoc)
{
	struct ifx_arg_list *pArgList = NULL;
	int i,j;
	
	pArgList = wp->ifx_ptr_arg_list;
	if(pArgList == NULL){
		ifx_debug_printf("ifx_httpdGetMBufNextBuf Error : wp->ifx_ptr_arg_list is NULL\n");
		return -1;
	}
	
	for(i = 0; i < wp->ifx_no_argument && pArgList; i++, pArgList = pArgList->next){
		if(gstrncmp(pArgList->pifx_param_name,var,strlen(var)) == 0){
			j = 0;
			ifx_debug_printf("ifx_httpdGetMBufNextBuf : var %s found with totBufLen %d.\n",var,pArgList->totBufLen);
			if(readLoc > pArgList->totBufLen){
				ifx_debug_printf("ifx_httpdGetMBufNextBuf : var %s has totBufLen %d while required readLoc is %d.\n",var,pArgList->totBufLen,readLoc);
				return -1;
			}
			while(readLoc >= pArgList->ifx_param_value.pArrMultiBuf[j].len && j < pArgList->numMultiBufs){
				readLoc -= pArgList->ifx_param_value.pArrMultiBuf[j].len;
				j++;
			}
			ifx_debug_printf("###ifx_httpdGetMBufNextBuf : readLoc [%d] cur numMultiBufs [%d] current len[%d]\n",readLoc,j,pArgList->ifx_param_value.pArrMultiBuf[j].len);
			*retBuf = pArgList->ifx_param_value.pArrMultiBuf[j].buf + readLoc;
			return pArgList->ifx_param_value.pArrMultiBuf[j].len - readLoc;
		}
	}
	//printf("ifx_httpdGetVarBufLen : var %s not found. Returning %d\n",var,-1);
	return -1;

}
#endif

char_t 	*ifx_httpdGetVar(httpd_t wp, char_t *var, char_t *defaultGetValue)
{
	
	struct ifx_arg_list *pArgList = NULL;
	int i;
	
	pArgList = wp->ifx_ptr_arg_list;
	if(pArgList == NULL){
		//printf("wensGetVar Error : wp->ifx_ptr_arg_list is NULL\n");
		return defaultGetValue;
	}
	
	for(i = 0; i < wp->ifx_no_argument && pArgList; i++, pArgList = pArgList->next){
		if((gstrncmp(pArgList->pifx_param_name,var,strlen(var)) == 0) && (strlen(pArgList->pifx_param_name) == strlen(var))){
			if(pArgList->numMultiBufs){
				ifx_debug_printf("ifx_httpdGetVar : var %s is multiBuf with numMultiBufs %d\n",var,pArgList->numMultiBufs);
				return NULL;
			}else{
				ifx_debug_printf("ifx_httpdGetVar : var %s found as %s\n",var,pArgList->ifx_param_value.buf);
				return pArgList->ifx_param_value.buf;
			}
		}
	}
	//printf("ifx_httpdGetVar : var %s not found. Returning %s\n",var,defaultGetValue);
	return defaultGetValue;
}

#define WEBS_MAX_URL 256
void ifx_httpdRedirect(httpd_t wp, char_t *url)
{
	char_t	*msgbuf, *urlbuf; //, *redirectFmt;

	urlbuf = NULL;
	msgbuf = NULL;
/*
 *	Some browsers require a http://host qualified URL for redirection
 */
	if (gstrstr(url, T("http://")) == NULL) {
		if (*url == '/') {
			url++;
		}

		//redirectFmt = T("http://%s/%s");
		urlbuf = (char *)calloc(WEBS_MAX_URL + 80,sizeof(char));
		//printf("From ifx_httpdRedirect : host_name [%s]\n",wp->host);
		snprintf(urlbuf,WEBS_MAX_URL + 80,"http://%s/%s",wp->host,url);

#ifdef WEBS_SSL_SUPPORT
		if (wp->flags & WEBS_SECURE) {
			//redirectFmt = T("https://%s/%s");
			snprintf(urlbuf,WEBS_MAX_URL + 80,"https://%s/%s",wp->host_name,url);
		}
#endif
		url = urlbuf;
	}

/*
 *	Add human readable message for completeness. Should not be required.
 */
	msgbuf = (char *)calloc(WEBS_MAX_URL + 200,sizeof(char));
	snprintf(msgbuf,WEBS_MAX_URL + 200, ("<html><head></head><body>\r\n\
        This document has moved to a new <a href=\"%s\">location</a>.\r\n\
        Please update your documents to reflect the new location.\r\n\
        </body></html>\r\n"), url);

	//wp->bSendHeader = 1;
	//wp->responseCode = 302;
	//strncpy(wp->redirectURL,url,IFX_REDIRECT_URL_LEN);
	//printf("From ifx_httpdRedirect responseCode[%d] and string[%s]\n",302,msgbuf);
	(*ifx_sendHeaders)(302,url);
	ifx_httpdWrite(wp, msgbuf, url);


	if(urlbuf != NULL)
		free(urlbuf);
	if(msgbuf != NULL)
		free(msgbuf);
}

void ifx_httpdSetPassword(char_t *password)
{
	memset(websPassword,0x00,TSZ(websPassword));
	gstrncpy(websPassword, password, TSZ(websPassword));
}

char_t 	*ifx_httpdGetPassword()
{
	return websPassword;
}

/******************************************************************************/
/*
 *	Convert integer to ascii string. Allow a NULL string in which case we
 *	allocate a dynamic buffer. 
 */
char_t *stritoa(int n, char_t *string, int width)
{
	char_t	*cp, *lim, *s;
	char_t	buf[16];						/* Just temp to hold number */
	int		next, minus;

	a_assert(string && width > 0);

	if (string == NULL) {
		if (width == 0) {
			width = 10;
		}
		if ((string = malloc(width + 1)) == NULL) {
			return NULL;
		}
	}
	if (n < 0) {
		minus = 1;
		n = -n;
		width--;
	} else {
		minus = 0;
	}

	cp = buf;
	lim = &buf[width - 1];
	while (n > 9 && cp < lim) {
		next = n;
		n /= 10;
		*cp++ = (char_t) (next - n * 10 + '0');
	}
	if (cp < lim) {
		*cp++ = (char_t) (n + '0');
	}

	s = string;
	if (minus) {
		*s++ = '-';
	}

	while (cp > buf) {
		*s++ = *--cp;
	}

	*s++ = '\0';
	return string;
}
/******************************************************************************/
/*
 *	Trace log. Customize this function to log trace output
 */

void trace(int level, char_t *fmt, ...)
{
	va_list 	args;

	va_start(args, fmt);
	va_end(args);
}
