/* ====================================================================
 * Copyright (c) 2004 - Infeneon-ADMtek Technologies AG.
 *
 * All rights reserved.
 * ====================================================================
 *
 * ====================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ====================================================================
 */
                                                                                
/* ====================================================================
 *
 * File Name: ifx_raw_drv.h
 * Author: Eric Tsai
 * Date:
 *
 * ====================================================================
 *
 * Projects: <ADM5120/Raw_Access>
 * Block: 
 *
 * ====================================================================
 * Contents:
 *
 * ====================================================================
 * References:
 */

#ifndef _IFX_RAW_DRV_H_
#define _IFX_RAW_DRV_H_

#include <asm/ioctl.h>
#include "ifx_raw_types.h"

// The types of chip platform
#define ADM5120		0x00
#define ADM5120P	0x01

// The types of flash
#define MX29LV160	0x00
#define MX29LV320	0x01

#ifndef FLASH_BLOCK_SIZE
#define FLASH_BLOCK_SIZE	0x10000 // 64k
#endif

#ifdef ADMPLAT

#define RAW_ACCESS_ADDR	AM5120_BOARD_CFG_ADDR 

#ifndef AM5120_BOARD_RESV_SIZE
#define AM5120_BOARD_RESV_SIZE 	0x1000  // Reserve 4K. Let's pray for no excess.
#endif

#ifndef AM5120_BASE_ADDR
#define AM5120_BASE_ADDR	0x1fc00000
#endif

#ifndef ADMTYPE
#define ADMTYPE		ADM5120P
#endif

#ifndef FLASHTYPE
#define FLASHTYPE	MX29LV320
#endif

#ifndef FLASHSIZE
#define FLASHSIZE	0x400000 // 4MB
#endif

#else /* Not ADMPLAT */

#define AM5120_BOARD_RESV_SIZE	0x1000  // must be the same with above
#endif

#define RAWDRV_IOC_MAGIC 'x'

#define RAWDRV_IOCRESET _IO(RAWDRV_IOC_MAGIC, 0)
#define RAWDRV_IOCSFUNCTION _IOW(RAWDRV_IOC_MAGIC, 1, int)
#define RAWDRV_IOCSRAWACSADDR _IOR(RAWDRV_IOC_MAGIC, 2, int)
#define RAWDRV_IOCGOUTLEN _IOR(RAWDRV_IOC_MAGIC, 10, int)
#define RAWDRV_IOCRSRAWDEV _IOR(RAWDRV_IOC_MAGIC, 20, int)
#define RAWDRV_IOCRSFLASH _IOR(RAWDRV_IOC_MAGIC, 21, int)
#define RAWDRV_IOCTEST _IOR(RAWDRV_IOC_MAGIC, 30, int)
#define RAWDRV_IOC_MAXNR 2

#define MAX_FILES	30

typedef struct t_ifx_raw_info {
  char8 cICode[6];
  int32 iNfile;
  char8 cFilename[MAX_FILES][40];
  int32 iPosOffset[MAX_FILES];
  int32 iSize[MAX_FILES];
  int32 iCompSize;
} T_IFX_RAW_INFO;

#endif		/* _IFX_RAW_DRV_H_ */

/* ====================================================================
 * Revision History:
 *
 * $Log: ifx_raw_drv.h,v $
 * Revision 1.1.1.1  2004/12/02 05:25:31  erict
 *
 *
 *
 *
 * ====================================================================
 */

