/* ====================================================================
 * Copyright (c) 2004 - Infeneon-ADMtek Technologies AG.
 *
 * All rights reserved.
 * ====================================================================
 *
 * ====================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ====================================================================
 */

/* ====================================================================
 *
 * File Name: ifx_raw_upkernel.c
 * Author: Eric Tsai
 * Date:
 *
 * ====================================================================
 *
 * Projects: <ADM5120/Raw_Access>
 * Block: 
 *
 * ====================================================================
 * Contents:
 *
 * ====================================================================
 * References:
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>

#include "ifx_raw_drv.h"

#define iMaxBufSize	0x50000 //64*5k
#define iBlockSize	0x10000 //64k

int main(int argc, char *argv[])
{
  int fd;
  char8 *cBuf = NULL;
  uint32 iBufOff, uiAddr;
  int32 i, iRet; 

  fd = open("/dev/rawdev", O_RDWR, 0);
  if (fd <= 0) {
    printf("Open rawdev error!\n");
    return -1;
  }
  printf("rawdev opened!\n");
  cBuf = (char8 *) malloc(iMaxBufSize);
  memset(cBuf, 0, iMaxBufSize);
  iBufOff = 0;
  ioctl(fd, RAWDRV_IOCRSRAWDEV, NULL);
  uiAddr = 0x1fc20000; //Base addr
  for(i=0; i<36; i++){
    int j=i%5;
    iBufOff = iBlockSize*j;
    uiAddr += iBlockSize; //raw access addr
    ioctl(fd, RAWDRV_IOCSRAWACSADDR, &uiAddr);
    printf("Set raw access addr: %x\n", uiAddr);
    iRet = write(fd, cBuf+iBufOff, iBlockSize);
    if (iRet != iBlockSize) {
      printf("Write to rawdev error! %d\n", iRet);
      break;
    }
    printf("Write %d bytes to rawdev!\n", iRet);
  }
  printf("Write raw access completely\n");
  ioctl(fd, RAWDRV_IOCRSRAWDEV, NULL);
  close(fd);

  if (cBuf)
    free(cBuf);
  return 0;
}

/* ====================================================================
 * Revision History:
 *
 * $Log: ifx_raw_upkernel.c,v $
 * Revision 1.1.1.1  2004/12/02 05:25:31  erict
 *
 *
 *
 *
 * ====================================================================
 */
