/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_ddns_cfg(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name,*mode;
	char_t	sValue[MAX_DATA_LEN];

	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

 	memset(sValue, 0x00, MAX_DATA_LEN);  	
   	if (!gstrcmp(name, T("status")))
   	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSSTATUS, T("ddns_enable"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "DDNS status not found");
			return -1;	
		}
	
		if (!gstrcmp(sValue, "YES") )	// DDNS is enabled
		{
			ifx_httpdWrite(wp, T("checked"));
		}
		else
		{
			ifx_httpdWrite(wp, T(""));
		}
   	}
   	else if (!gstrcmp(name, T("selradio")))
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, T("serviceIndex"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "DDNS select server index found");
			return -1;	
		}
		
		//ejSetResult(eid, sValue)
		
		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"1") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else 
		if(strncmp(sValue,"2",1) == 0 && strcmp(mode,"2") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else
		if(strncmp(sValue,"3",1) == 0 && strcmp(mode,"3") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else
			ifx_httpdWrite(wp, T(""));
	       
		
	}
	/* Data of dyn.dhs.org */
	else if ( !gstrcmp(name, T("host1")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, T("host1"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Hostname is not found");
			return -1;	
		}
		if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
		{
		    gstrcpy(sValue, "");
		}
		
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	else if ( !gstrcmp(name, T("user1")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, T("user1"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Username value is not found");
			return -1;	
		}
		if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
		{
		    gstrcpy(sValue, "");
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	else if ( !gstrcmp(name, T("pw1")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, T("passwd1"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Password value is not found");
			return -1;	
		}
		if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
		{
		    gstrcpy(sValue, "");
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	/* Data of dyndns.org */
	else if ( !gstrcmp(name, T("host2")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, T("host2"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Hostname is not found");
			return -1;	
		}
		if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
		{
		    gstrcpy(sValue, "");
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	else if ( !gstrcmp(name, T("user2")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, T("user2"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Username value is not found");
			return -1;	
		}
		if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
		{
		    gstrcpy(sValue, "");
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	else if ( !gstrcmp(name, T("pw2")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, T("passwd2"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Password value is not found");
			return -1;	
		}
		if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
		{
		    gstrcpy(sValue, "");
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	/* Data of dyns.cx */
	else if ( !gstrcmp(name, T("host3")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, T("host3"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Hostname is not found");
			return -1;	
		}
		if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
		{
		    gstrcpy(sValue, "");
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	else if ( !gstrcmp(name, T("user3")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, T("user3"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Username value is not found");
			return -1;	
		}
		if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
		{
		    gstrcpy(sValue, "");
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	else if ( !gstrcmp(name, T("pw3")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, T("passwd3"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Password value is not found");
			return -1;	
		}
		if ( !gstrcmp(sValue, "0") )  // Used "0" instead of Empty
		{
		    gstrcpy(sValue, "");
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	}

	return 0;
}

void ifx_set_ddns_config(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pStatus = ifx_httpdGetVar(wp, T("ddnsStatus"), T(""));
	char_t	*pselradio;
	char_t	*phost1 = ifx_httpdGetVar(wp, T("host1"), T(""));
	char_t	*puser1 = ifx_httpdGetVar(wp, T("user1"), T(""));
	char_t	*ppw1   = ifx_httpdGetVar(wp, T("pw1"), T(""));	
	char_t	*phost2 = ifx_httpdGetVar(wp, T("host2"), T(""));
	char_t	*puser2 = ifx_httpdGetVar(wp, T("user2"), T(""));
	char_t	*ppw2   = ifx_httpdGetVar(wp, T("pw2"), T(""));	
	char_t	*phost3 = ifx_httpdGetVar(wp, T("host3"), T(""));
	char_t	*puser3 = ifx_httpdGetVar(wp, T("user3"), T(""));
	char_t	*ppw3   = ifx_httpdGetVar(wp, T("pw3"), T(""));	
	char_t	sStatus[MAX_DATA_LEN], sSelIdx[MAX_DATA_LEN], sHost[APPS_DDNS_NUM][MAX_DATA_LEN], 
			sUser[APPS_DDNS_NUM][MAX_DATA_LEN], sPasswd[APPS_DDNS_NUM][MAX_DATA_LEN];

	a_assert(wp);
	memset(sStatus,   0x00, MAX_DATA_LEN);
	memset(sSelIdx,   0x00, MAX_DATA_LEN);

	if (pStatus && *pStatus)
	{
		 pselradio = ifx_httpdGetVar(wp, T("selradio"), T(""));
		
		gsprintf(sStatus, T("ddns_enable=\"YES\"\n"));		
		websSetCfgData(FILE_RC_CONF, TAG_DDNSSTATUS, 1, sStatus);
		
		// Update rc.conf file
		if (pselradio && *pselradio)
			gsprintf(sSelIdx,    T("serviceIndex=\"%s\"\n"), pselradio);
		else
			gsprintf(sSelIdx,    T("serviceIndex=\"1\"\n"));		//default
		
		// 1st item
		if (phost1 && *phost1)
			gsprintf(sHost[0],   T("host1=\"%s\"\n"), phost1);
		else
			gsprintf(sHost[0],   T("host1=\"0\"\n"));
		if (puser1 && *puser1)
			gsprintf(sUser[0],   T("user1=\"%s\"\n"), puser1);
		else
			gsprintf(sUser[0],   T("user1=\"0\"\n"));
		if (ppw1 && *ppw1)								
			gsprintf(sPasswd[0], T("passwd1=\"%s\"\n"), ppw1);
		else
			gsprintf(sPasswd[0], T("passwd1=\"0\"\n"));
		// 2nd item
		if (phost2 && *phost2)
			gsprintf(sHost[1],   T("host2=\"%s\"\n"), phost2);
		else
			gsprintf(sHost[1],   T("host2=\"0\"\n"));
		if (puser2 && *puser2)
			gsprintf(sUser[1],   T("user2=\"%s\"\n"), puser2);
		else
			gsprintf(sUser[1],   T("user2=\"0\"\n"));
		if (ppw2 && *ppw2)
			gsprintf(sPasswd[1], T("passwd2=\"%s\"\n"), ppw2);
		else
			gsprintf(sPasswd[1], T("passwd2=\"0\"\n"));
		// 3rd item
		if (phost3 && *phost3)
			gsprintf(sHost[2],   T("host3=\"%s\"\n"), phost3);
		else
			gsprintf(sHost[2],   T("host3=\"0\"\n"));
		if (puser3 && *puser3)
			gsprintf(sUser[2],   T("user3=\"%s\"\n"), puser3);
		else
			gsprintf(sUser[2],   T("user3=\"0\"\n"));
		if (ppw3 && *ppw3)								
			gsprintf(sPasswd[2], T("passwd3=\"%s\"\n"), ppw3);
		else
			gsprintf(sPasswd[2], T("passwd3=\"0\"\n"));
	
		
		websSetCfgData(FILE_RC_CONF, TAG_DDNSCONFIG, 10, sSelIdx, 
									 sHost[0], sUser[0], sPasswd[0],
									 sHost[1], sUser[1], sPasswd[1],
									 sHost[2], sUser[2], sPasswd[2]);

		//Runtime Change		
		system(SERVICE_DDNS_STOP);		// Remove old process 
		system(SERVICE_DDNS_START);		
	}
	else
	{
		gsprintf(sStatus, T("ddns_enable=\"NO\"\n"));
		//Runtime Change
		websSetCfgData(FILE_RC_CONF, TAG_DDNSSTATUS, 1, sStatus);		
		system(SERVICE_DDNS_STOP);
	}

	//add by calvinc 20040519 save to flash
	system(SERVICE_RESTORE);
    //end add

	ifx_httpdNextPage(wp);
}