/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"
#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

void ifx_Firewall_PageTitle(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t  str[20];

	memset(str, 0x00, 20);

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return ;
	}	

#ifdef ATA
	strcpy(str, "ATA");
#endif
#if defined(SPURS) && defined (ATA)
	strcpy(str, "WATA");
#endif

#ifdef GATEWAY
	strcpy(str, "Router");
#endif

#if defined(SPURS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

#if defined(WILDPASS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

	if (!gstrcmp(name, T("firewall_mainpage")))
	{
		ifx_httpdWrite(wp,T("The %s provides extensive firewall protection by restricting\n"
							"connection parameters to limit the risk of intrusion and defending\n"
							"against a wide array of common hacker attacks. However, for applications\n"
							"that require unrestricted access to the Internet, you can configure\n"
							"a specific client/server as a demilitarized zone (DMZ)."),str);
	}else
	if (!gstrcmp(name, T("firewall_macpage")))
	{
		ifx_httpdWrite(wp,"You can block certain client PCs accessing the Internet based on MAC addresses.");
	}else
	if (!gstrcmp(name, T("firewall_clientfilterpage")))
	{
		ifx_httpdWrite(wp,"You can block certain client PCs accessing the Internet based on time.");
	}else
	if (!gstrcmp(name, T("firewall_disablewanpage")))
	{
		ifx_httpdWrite(wp,T("\"Block WAN Scan\" allows you to prevent the hackers from testing the services of the %s.\n"
							"\"Discard ping from WAN side\" cause the %s to not respond to the hacker scan packets from the public WAN IP address."),str,str);
	}

}
