/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include "ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_firewall_clientfilter(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name,*mode;
	char_t	buf[MAX_DATA_LEN], sValue[MAX_FILELINE_LEN], sServerIP[MAX_DATA_LEN];
	char_t	getCommand[MAX_FILELINE_LEN];
	int		i;

	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
   	memset(buf, 0x00, MAX_DATA_LEN);
	memset(sServerIP, 0x00, MAX_DATA_LEN);
	
	websGetInterfaceIP(ADM_LAN_IF, 3, FALSE, sServerIP);

	if ( !gstrcmp(name, T("cfStatus")) )
	{
		//Get CF_STATUS# value from rc.firewall file.
		memset(buf, 0x00, MAX_DATA_LEN);
		memset(sValue, 0x00, MAX_FILELINE_LEN);
		gsprintf(buf, T("CF_STATUS"));
		
		if (ifx_GetCfgData(FILE_RC_FIREWALL, TAG_FIREWALL_CLIENTFILTER, T("CF_STATUS"), sValue) == 1)
		{
			if(!strcmp(sValue,"1"))
			ifx_httpdWrite(wp,T("checked"));
		}
		
	} 
	else if ( !gstrcmp(name, T("Info")) )
	{
		for(i = 1; i <= FIREW_CFILTER_NUM; i++)
		{
			ifx_httpdWrite(wp, T("\t\t\t<tr bgcolor=\"#ffffff\" align=left>\n"));
			ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap align=center>%d</td>\n"), i);
			ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap align=center><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s\n"), sServerIP);

			//Get CF_IP_START# value from rc.firewall file.
			memset(buf, 0x00, MAX_DATA_LEN);
			memset(sValue, 0x00, MAX_FILELINE_LEN);
			gsprintf(buf, T("CF_IP_START%d"), i);
			if (ifx_GetCfgData(FILE_RC_FIREWALL, TAG_FIREWALL_CLIENTFILTER, buf, sValue) == 0)
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"3\" name=\"%s\" size=\"3\" value=\"\">~\n"), buf);
			}
			else
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"3\" name=\"%s\" size=\"3\" value=\"%s\">~\n"), buf, sValue);
			}

			//Get CF_IP_END# value from rc.firewall file.
			memset(buf, 0x00, MAX_DATA_LEN);
			memset(sValue, 0x00, MAX_FILELINE_LEN);
			gsprintf(buf, T("CF_IP_END%d"), i);
			if (ifx_GetCfgData(FILE_RC_FIREWALL, TAG_FIREWALL_CLIENTFILTER, buf, sValue) == 0)
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"3\" name=\"%s\" size=\"3\" value=\"\"></font></td>\n"), buf);
			}
			else
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"3\" name=\"%s\" size=\"3\" value=\"%s\"></font></td>\n"), buf, sValue);
			}

			ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap align=center><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">\n"));

			//Get CF_PORT_START# value from rc.firewall file.
			memset(buf, 0x00, MAX_DATA_LEN);
			memset(sValue, 0x00, MAX_FILELINE_LEN);
			gsprintf(buf, T("CF_PORT_START%d"), i);
			if (ifx_GetCfgData(FILE_RC_FIREWALL, TAG_FIREWALL_CLIENTFILTER, buf, sValue) == 0)
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"5\" name=\"%s\" size=\"5\" value=\"\">~\n"), buf);
			}
			else
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"5\" name=\"%s\" size=\"5\" value=\"%s\">~\n"), buf, sValue);
			}

			//Get CF_PORT_END# value from rc.firewall file.
			memset(buf, 0x00, MAX_DATA_LEN);
			memset(sValue, 0x00, MAX_FILELINE_LEN);
			gsprintf(buf, T("CF_PORT_END%d"), i);
			if (ifx_GetCfgData(FILE_RC_FIREWALL, TAG_FIREWALL_CLIENTFILTER, buf, sValue) == 0)
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"5\" name=\"%s\" size=\"5\" value=\"\"></font></td>\n"), buf);
			}
			else
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"5\" name=\"%s\" size=\"5\" value=\"%s\"></font></td>\n"), buf, sValue);
			}

			ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap align=center><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">\n"));

			//Get CF_TYPE# value from rc.firewall file.
			memset(buf, 0x00, MAX_DATA_LEN);
			memset(sValue, 0x00, MAX_FILELINE_LEN);
			gsprintf(buf, T("CF_TYPE%d"), i);
			
			if (ifx_GetCfgData(FILE_RC_FIREWALL, TAG_FIREWALL_CLIENTFILTER, buf, sValue) == 0)
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" name=\"%s\" value=\"1\"%s>TCP<br>\n"), buf, " CHECKED");
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" name=\"%s\" value=\"2\">UDP</font>\n"), buf);
			}
			else
			{
				if ( !gstrcmp(sValue, PROTOCOL_TYPE_TCP) )
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" name=\"%s\" value=\"1\"%s>TCP<br>\n"), buf, " CHECKED");
					ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" name=\"%s\" value=\"2\">UDP</font>\n"), buf);
				}
				else
				if ( !gstrcmp(sValue, PROTOCOL_TYPE_UDP) )
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" name=\"%s\" value=\"1\">TCP<br>\n"), buf);
					ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"radio\" name=\"%s\" value=\"2\"%s>UDP</font>\n"), buf, " CHECKED");
				}
			}

			//Get CF_F# value from rc.firewall file.
			memset(buf, 0x00, MAX_DATA_LEN);
			memset(sValue, 0x00, MAX_FILELINE_LEN);
			gsprintf(buf, T("CF_F%d"), i);
			
			if (ifx_GetCfgData(FILE_RC_FIREWALL, TAG_FIREWALL_CLIENTFILTER, buf, sValue) == 0)
			{
				ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap align=center><input type=\"checkbox\" name=\"%s\" value=\"1\"></td></tr>\n"), buf);
			}
			else
			{
				if ( !gstrcmp(sValue, "1") )
				{
					ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap align=center><input type=\"checkbox\" name=\"%s\" value=\"1\"%s></td></tr>\n"), buf, " CHECKED");
				}
				else
				if ( !gstrcmp(sValue, "0") )
				{
					ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap align=center><input type=\"checkbox\" name=\"%s\" value=\"1\"%s></td></tr>\n"), buf, "");
				}
			}
		} //enf for

	}
	
	return 0;
}

void ifx_set_firewall_clientfilter(httpd_t wp, char_t *path, char_t *query)
{
	char_t 	*pCfStatus, *pStartIP, *pEndIP, *pStartPort, *pEndPort, *pType, *pCheck;
	char_t 	*buffer, buf[MAX_DATA_LEN], sServerIP[MAX_DATA_LEN], sCfStatus[MAX_DATA_LEN];
	char_t 	sStartIP[FIREW_CFILTER_NUM][MAX_DATA_LEN], sEndIP[FIREW_CFILTER_NUM][MAX_DATA_LEN];
	char_t 	sStartPort[FIREW_CFILTER_NUM][MAX_DATA_LEN], sEndPort[FIREW_CFILTER_NUM][MAX_DATA_LEN];
	char_t 	sType[FIREW_CFILTER_NUM][MAX_DATA_LEN], sCheck[FIREW_CFILTER_NUM][MAX_DATA_LEN];
	int 	i;

	a_assert(wp);

	memset(sServerIP, 0x00, MAX_DATA_LEN);
	memset(buf, 0x00, MAX_DATA_LEN);
	websGetInterfaceIP(ADM_LAN_IF, 3, FALSE, sServerIP);
	gsprintf(buf, T("WANIP_PREFIX=\"%s\"\n"), sServerIP);
	websSetCfgData(FILE_RC_FIREWALL, TAG_NAT_FIREWALL_SHARE, 1, buf);

	memset(sCfStatus, 0x00, MAX_DATA_LEN);

	pCfStatus = ifx_httpdGetVar(wp, T("cfStatus"), T("")); 
	
	if ( !gstrcmp(pCfStatus, T("1")))
	{
		gsprintf(sCfStatus, T("CF_STATUS=\"%s\"\n"), pCfStatus);
	}
	else
	{
		gsprintf(sCfStatus, T("CF_STATUS=\"0\"\n"));
	}

	for (i=0; i<FIREW_CFILTER_NUM; i++)
	{
		//Set CF_IP_START# to rc.conf.
		memset(sStartIP[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_DATA_LEN);

		gsprintf(buf, T("CF_IP_START%d"), i+1);
		pStartIP	= ifx_httpdGetVar(wp, buf, T(""));

		if (pStartIP[0])
		{
			gsprintf(sStartIP[i], T("%s=\"%s\"\n"), buf, pStartIP);
		}
		else
		{
			gsprintf(sStartIP[i], T("%s=\"\"\n"), buf);
		}
		
		//Set CF_IP_END# to rc.conf.
		memset(sEndIP[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_DATA_LEN);

		gsprintf(buf, T("CF_IP_END%d"), i+1);
		pEndIP	= ifx_httpdGetVar(wp, buf, T(""));

		if (pEndIP[0])
		{
			gsprintf(sEndIP[i], T("%s=\"%s\"\n"), buf, pEndIP);
		}
		else
		{
			gsprintf(sEndIP[i], T("%s=\"\"\n"), buf);
		}

		//Set CF_PORT_START# to rc.conf.
		memset(sStartPort[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_DATA_LEN);

		gsprintf(buf, T("CF_PORT_START%d"), i+1);
		pStartPort = ifx_httpdGetVar(wp, buf, T(""));

		if (pStartPort[0])
		{
			gsprintf(sStartPort[i], T("%s=\"%s\"\n"), buf, pStartPort);
		}
		else
		{
			gsprintf(sStartPort[i], T("%s=\"\"\n"), buf);
		}
		
		//Set CF_PORT_END# to rc.conf.
		memset(sEndPort[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_DATA_LEN);

		gsprintf(buf, T("CF_PORT_END%d"), i+1);
		pEndPort	= ifx_httpdGetVar(wp, buf, T(""));

		if (pEndPort[0])
		{
			gsprintf(sEndPort[i], T("%s=\"%s\"\n"), buf, pEndPort);
		}
		else
		{
			gsprintf(sEndPort[i], T("%s=\"\"\n"), buf);
		}

		//Set CF_TYPE# to rc.conf.		
		memset(sType[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_DATA_LEN);
		gsprintf(buf, T("CF_TYPE%d"), i+1);
		pType	= ifx_httpdGetVar(wp, buf, T(""));

		if (pType[0])
		{
			if (!gstrcmp(pType, T("1")))
			{
				gsprintf(sType[i], T("%s=\"%s\"\n"), buf, PROTOCOL_TYPE_TCP);
			}
			else
			if (!gstrcmp(pType, T("2")))
			{
				gsprintf(sType[i], T("%s=\"%s\"\n"), buf, PROTOCOL_TYPE_UDP);
			}
		}
		else
		{
			gsprintf(sType[i], T("%s=\"%s\"\n"), buf, PROTOCOL_TYPE_TCP);
		}

		//Set CF_F# to rc.conf.		
		memset(sCheck[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_DATA_LEN);

		gsprintf(buf, T("CF_F%d"), i+1);
		pCheck	= ifx_httpdGetVar(wp, buf, T(""));
		
		if (!gstrcmp(pCheck, "1"))
		{
			if ( (pStartIP && *pStartIP) && (pEndIP && *pEndIP) &&
				 (pStartPort && *pStartPort) && (pEndPort && *pEndPort) )
			{
				gsprintf(sCheck[i], T("%s=\"%s\"\n"), buf, pCheck);
			}
			else
			{
				gsprintf(sCheck[i], T("%s=\"0\"\n"), buf);
			}
		}
		else
		{
			gsprintf(sCheck[i], T("%s=\"0\"\n"), buf);
		}
	}

	buffer = (char_t*)malloc(sizeof(char_t)*(BUF_SIZE_50K));
	gstrcpy (buffer, "");
	gsprintf(buf, T("CF_NUM=\"%d\"\n"), FIREW_CFILTER_NUM);
	gstrcat (buffer, buf);
	gstrcat (buffer, sCfStatus);

	for (i = 0; i < FIREW_CFILTER_NUM; i++)
	{
		gstrcat (buffer, sStartIP[i]);
		gstrcat (buffer, sEndIP[i]);
		gstrcat (buffer, sStartPort[i]);
		gstrcat (buffer, sEndPort[i]);
		gstrcat (buffer, sType[i]);
		gstrcat (buffer, sCheck[i]);
	}

	websSetCfgData(FILE_RC_FIREWALL, TAG_FIREWALL_CLIENTFILTER, 1,  buffer);

	if(buffer && *buffer)
		free(buffer);
		
	//Runtime Change
	websChg2ExeMode(FILE_RC_IPTABLES);	
	websChg2ExeMode(FILE_RC_FIREWALL);
	system(SERVICE_NAT_RESTART);
	system(SERVICE_FIREWALL_RESTART);
	system(SERVICE_RESTORE);

	ifx_httpdNextPage(wp);
}