/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>


//////////////////////////////////////////////////////////////////////////////////
// firewall_notify.asp
//
//////////////////////////////////////////////////////////////////////////////////
// ifx_get_firewall_notify.asp
//
int ifx_get_firewall_notify(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name,*mode;
	char_t	sValue[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];

	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(command, 0x00, MAX_FILELINE_LEN);

	if (!strcmp(name, T("Status")))
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_NOTIFY, "NOTIFY_ENABLE", sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Fail to get Notify information!");
			return -1;
		}

		if(strcmp(sValue, "1") == 0 && strcmp(mode,"Enable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}
		else if(strcmp(sValue,"0") == 0 && strcmp(mode,"Disable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}
		else
		{
			ifx_httpdWrite(wp, "");
		}		
	}
	else if ( !strcmp(name, T("Event")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_NOTIFY, "NOTIFY_COUNT", sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Event count not found");
			return -1;	
		}		
		
		ifx_httpdWrite(wp, sValue);
	}
	else if ( !strcmp(name, T("Server")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_NOTIFY, "NOTIFY_SERVER", sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Notify Server info not found");
			return -1;	
		}
		
		if(strcmp(sValue,"0") == 0)
		{
			ifx_httpdWrite(wp, "");		// We don't want to disply "0" in this EditBox
		}
		else
		{
			ifx_httpdWrite(wp, sValue);			
		}
		
	}
	else if ( !strcmp(name, T("Subject")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_NOTIFY, "NOTIFY_SUBJECT", sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Notify Subject info not found");
			return -1;	
		}		
		
		if(strcmp(sValue,"0") == 0)
		{
			ifx_httpdWrite(wp, "");		// We don't want to disply "0" in this EditBox
		}
		else
		{
			ifx_httpdWrite(wp, sValue);			
		}
	}
	else if ( !strcmp(name, T("RecAddress")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_NOTIFY, "NOTIFY_ADDR", sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Notify Server info not found");
			return -1;	
		}
		
		if(strcmp(sValue,"0") == 0)
		{
			ifx_httpdWrite(wp, "");		// We don't want to disply "0" in this EditBox
		}
		else
		{
			ifx_httpdWrite(wp, sValue);			
		}
	}
	
	return 0;
}

void ifx_set_firewall_notify(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pStatus, *pEvent, *pServer, *pRecAddr, *pSubject;
	char_t	sStatus[MAX_FILELINE_LEN], sEvent[MAX_FILELINE_LEN], sServer[MAX_FILELINE_LEN];
	char_t	sRecAddr[MAX_FILELINE_LEN], sSubject[MAX_FILELINE_LEN];

	a_assert(wp);
	memset(sStatus,  0x00, MAX_FILELINE_LEN);
	memset(sEvent,   0x00, MAX_FILELINE_LEN);
	memset(sServer,  0x00, MAX_FILELINE_LEN);
	memset(sRecAddr, 0x00, MAX_FILELINE_LEN);
	memset(sSubject, 0x00, MAX_FILELINE_LEN);

	// Get value from ASP file
	pStatus  = ifx_httpdGetVar(wp, T("Status"), T(""));
	pEvent   = ifx_httpdGetVar(wp, T("Event"), T(""));
	pServer   = ifx_httpdGetVar(wp, T("Server"), T(""));
	pRecAddr = ifx_httpdGetVar(wp, T("RecAddr"), T(""));
	pSubject = ifx_httpdGetVar(wp, T("Subject"), T(""));

	if (atoi(pEvent) < 0) 
	{
     	ifx_httpdError(wp, 200, "Maximum event must equal to or greater than 0!");		
     	return;
	}
	
	if (pRecAddr)
	{
		if (strstr(pRecAddr, "@") == NULL)
		{
	     	ifx_httpdError(wp, 200, "Recipient's email-address format incorrect!");
	     	return;
		}
	}

	if ( !strcmp(pStatus, "1") )
	{
		sprintf(sStatus, "NOTIFY_ENABLE=\"%s\"\n", pStatus);
	}
	else
	{
		sprintf(sStatus, "NOTIFY_ENABLE=\"0\"\n");
	}

	sprintf(sEvent, "NOTIFY_COUNT=\"%s\"\n", pEvent);
	
	if (pServer)
	{
		sprintf(sServer, "NOTIFY_SERVER=\"%s\"\n", pServer);
	}
	else
	{
		sprintf(sServer, "NOTIFY_SERVER=\"0\"\n");
	}
	
	if (pRecAddr)
	{
		sprintf(sRecAddr, "NOTIFY_ADDR=\"%s\"\n", pRecAddr);
	}
	else
	{
		sprintf(sRecAddr, "NOTIFY_ADDR=\"0\"\n");
	}
	
	if (pSubject)
	{
		sprintf(sSubject, "NOTIFY_SUBJECT=\"%s\"\n", pSubject);
	}
	else
	{
		sprintf(sSubject, "NOTIFY_SUBJECT=\"0\"\n");
	}

	websSetCfgData(FILE_RC_CONF, TAG_FIREWALL_NOTIFY, 5,
				   sStatus, sEvent, sServer, sRecAddr, sSubject);
	
	// Save to nv
	system(SERVICE_RESTORE);	
	ifx_httpdNextPage(wp);
}


