/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>


int ifx_get_firewall_disablewan(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name,*mode;
	char_t	sValue[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];

	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(command, 0x00, MAX_FILELINE_LEN);

	if ( !gstrcmp(name, T("DoSProtect")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_DISABLEWAN, T("ENABLE_HACKER_ATTACK_PROTECT"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "DoSProtect status not found");
			return -1;	
		}
		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else
		if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}
	}
	else
	if ( !gstrcmp(name, T("C1")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_DISABLEWAN, T("DISCARD_PING_FROM_WAN_SIDE"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "C1 status not found");
			return -1;	
		}
		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else
		if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}
		
	}
	else
	if ( !gstrcmp(name, T("PingGW")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_DISABLEWAN, T("ALLOW_PING_THE_GW"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "PingGW status not found");
			return -1;	
		}
		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else
		if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}
		
	}
	else
	if ( !gstrcmp(name, T("PortScan")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_DISABLEWAN, T("FURTIVE_PORT_SCAN"), sValue) == 0)
		{
			ifx_httpdError(wp, 204, T("Port Scan value not found"));
			return -1;	
		}
		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else
		if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}
		
	}
	else
	if ( !gstrcmp(name, T("ScanSecu")) )
	{
		
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_DISABLEWAN, T("ALLOW_SCAN_SECURITY_PORT"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Scan Sec status not found");
			return -1;	
		}

		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else
		if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}
		
	}
	else
	if ( !gstrcmp(name, T("NetBios")) )
	{
		
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_DISABLEWAN, T("DISCARD_NETBIOS_PACKET"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "NetBios status not found");
			return -1;	
		}

		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else
		if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}
		
	}
	else
	if ( !gstrcmp(name, T("Defrag")) )
	{
		
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_DISABLEWAN, T("ACC_FRAG_PACKET"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "Defrag status not found");
			return -1;	
		}

		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else
		if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}
		
	}
	else
	if ( !gstrcmp(name, T("SendIcmpErr")) )
	{
	
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_FIREWALL_DISABLEWAN, T("SEND_ICMP_PACKET_ERR"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "SendIcmpErr status not found");
			return -1;	
		}

		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}else
		if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0)
		{
			ifx_httpdWrite(wp,T("checked"));
		}
		
	}
	
	return 0;
}



void ifx_set_firewall_disablewan(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pDoSProtect, *pC1, *pPingGW, *pPortScan, *pScanSecu, *pNetBios, *pDefrag, *pSendIcmpErr;
	char_t	sDoSProtect[MAX_FILELINE_LEN], sC1[MAX_FILELINE_LEN], sPingGW[MAX_FILELINE_LEN];
	char_t	sPortScan[MAX_FILELINE_LEN], sScanSecu[MAX_FILELINE_LEN], sNetBios[MAX_FILELINE_LEN];
	char_t	sDefrag[MAX_FILELINE_LEN], sSendIcmpErr[MAX_FILELINE_LEN];

	a_assert(wp);
	memset(sDoSProtect, 0x00, MAX_FILELINE_LEN);
	memset(sC1, 0x00, MAX_FILELINE_LEN);
	memset(sPingGW, 0x00, MAX_FILELINE_LEN);
	memset(sPortScan, 0x00, MAX_FILELINE_LEN);
	memset(sScanSecu, 0x00, MAX_FILELINE_LEN);
	memset(sNetBios, 0x00, MAX_FILELINE_LEN);
	memset(sDefrag, 0x00, MAX_FILELINE_LEN);
	memset(sSendIcmpErr, 0x00, MAX_FILELINE_LEN);

	// Get value from ASP file
	pDoSProtect = ifx_httpdGetVar(wp, T("DoSProtect"), T(""));
	pC1 = ifx_httpdGetVar(wp, T("C1"), T(""));
	pPingGW = ifx_httpdGetVar(wp, T("PingGW"), T(""));
	pPortScan = ifx_httpdGetVar(wp, T("PortScan"), T(""));
	pScanSecu = ifx_httpdGetVar(wp, T("ScanSecu"), T(""));
	pNetBios = ifx_httpdGetVar(wp, T("NetBios"), T(""));
	pDefrag = ifx_httpdGetVar(wp, T("Defrag"), T(""));
	pSendIcmpErr = ifx_httpdGetVar(wp, T("SendIcmpErr"), T(""));

	if ( !gstrcmp(pDoSProtect, "1") )
	{
		gsprintf(sDoSProtect, T("ENABLE_HACKER_ATTACK_PROTECT=\"%s\"\n"), pDoSProtect);
	}
	else
	{
		gsprintf(sDoSProtect, T("ENABLE_HACKER_ATTACK_PROTECT=\"0\"\n"));
	}

	if ( !gstrcmp(pC1, "1") )
	{
		gsprintf(sC1, T("DISCARD_PING_FROM_WAN_SIDE=\"%s\"\n"), pC1);
	}
	else
	{
		gsprintf(sC1, T("DISCARD_PING_FROM_WAN_SIDE=\"0\"\n"));
	}
	
	if ( !gstrcmp(pPingGW, "1") )
	{
		gsprintf(sPingGW, T("ALLOW_PING_THE_GW=\"%s\"\n"), pPingGW);
	}
	else
	{
		gsprintf(sPingGW, T("ALLOW_PING_THE_GW=\"0\"\n"));
	}
	
	if ( !gstrcmp(pPortScan, "1") )
	{
		gsprintf(sPortScan, T("FURTIVE_PORT_SCAN=\"%s\"\n"), pPortScan);
	}
	else
	{
		gsprintf(sPortScan, T("FURTIVE_PORT_SCAN=\"0\"\n"));
	}
	
	if ( !gstrcmp(pScanSecu, "1") )
	{
		gsprintf(sScanSecu, T("ALLOW_SCAN_SECURITY_PORT=\"%s\"\n"), pScanSecu);
	}
	else
	{
		gsprintf(sScanSecu, T("ALLOW_SCAN_SECURITY_PORT=\"0\"\n"));
	}
	
	if ( !gstrcmp(pNetBios, "1") )
	{
		gsprintf(sNetBios, T("DISCARD_NETBIOS_PACKET=\"%s\"\n"), pNetBios);
	}
	else
	{
		gsprintf(sNetBios, T("DISCARD_NETBIOS_PACKET=\"0\"\n"));
	}
	
	if ( !gstrcmp(pDefrag, "1") )
	{
		gsprintf(sDefrag, T("ACC_FRAG_PACKET=\"%s\"\n"), pDefrag);
	}
	else
	{
		gsprintf(sDefrag, T("ACC_FRAG_PACKET=\"0\"\n"));
	}
	
	if ( !gstrcmp(pSendIcmpErr, "1") )
	{
		gsprintf(sSendIcmpErr, T("SEND_ICMP_PACKET_ERR=\"%s\"\n"), pSendIcmpErr);
	}
	else
	{
		gsprintf(sSendIcmpErr, T("SEND_ICMP_PACKET_ERR=\"0\"\n"));
	}

	websSetCfgData(FILE_RC_CONF, TAG_FIREWALL_DISABLEWAN, 8,
					sDoSProtect, sC1, sPingGW, sPortScan, sScanSecu, sNetBios, sDefrag, sSendIcmpErr);
	
	//Runtime Change
	system(SERVICE_NAT_RESTART);
	system(SERVICE_FIREWALL_RESTART);
	
	//add by calvinc 20040519 save to flash
	system(SERVICE_RESTORE);
        //end add
	
	ifx_httpdNextPage(wp);
}