/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include "config.h"

#define EXTIF									adm1
#define DEBUG									// Mark this to hide debug message in stdout
//#define PC_SIMULATED
 
#define HARDWARE_VER							"1.00.00"
#define FIRMWARE_VER							"1.07.00"
#define FIRMWARE_DATE							"2004/11/19"
                                        	
#define PREFIX_STATICROUTE						"staticRoute"
#define PREFIX_ALIASIP							"aliasIP"
#define PREFIX_FIREWALLMAC						"MAC_DENY_"
#define PREFIX_FIREWALL_CLIENTFILTER			"CF_"

#define PREFIX_VLAN								"VLAN_DENY_"
#define PREFIX_STAICMACLAN						"STAICMAC_DENY_"
                                        	
#define PROTOCOL_TYPE_TCP						"TCP"
#define PROTOCOL_TYPE_UDP						"UDP"
#define IPTABLE_PREROUTING						"iptables -t nat  -A PREROUTING"
#define IPTABLE_POSTROUTING						"iptables -t nat -A POSTROUTING"
                                        	
#ifdef ATA
	#define APPS_PORT_NUM						2
#endif
#ifdef IIP
	#define APPS_PORT_NUM						1
#endif
#define NAT_TRIGGER_LINK_NUM					10
#define NAT_RD_LINK_NUM						20	// original 5	
#define NAT_VS_LINK_NUM							5
#define NAT_VS_CLONE_NUM						16
#define NAT_MASQ_NUM							5
#define FIREW_CFILTER_NUM						5
#define URL_FILTER_STR_LEN						50
#define FIREW_URL_FILTER_NUM					10
#define IP_CFG_MAX_ALIAS_NUM    				10
#define IP_BOOT_DHCPC							1
#define IP_BOOT_FIXED							2
#define IP_BOOT_PPPOE							3
#define IP_BOOT_PPTP							4
#define IP_CFG_MAX_ALIAS_NUM    				10
#define APPS_NUM_OF_STATIC_ROUTE_ENTRY  		10
#define APPS_NUM_OF_ETHFTR_ENTRY     			32
#define APPS_PASSWORD_MIN_SIZE					3
#define APPS_PASSWORD_MAX_SIZE         			12
#define APPS_SECURITYLOG_NUM					20
#define APPS_DDNS_NUM			    			3
#define ETHFTR_CFG_ALLOW						1
#define ETHFTR_CFG_DENY							0
#define CLIENT_FILTER_TABLE_TYPE				1
#define MAC_FILTER_TABLE_TYPE					2

// Common Macro
#define BUF_SIZE_50K							10240
#define BUF_SIZE_1K								1024
#define MAX_DATA_LEN							128 /* 64 */
#define MAX_FILELINE_LEN						256
#define MAX_FILENAME_LEN						256
#define MAX_TAG_LEN								64
#define MAX_NAME_LEN							96
                                        	
// Flash related Marco  
#define FLASH_BlOCK_SIZE	   					0x10000 //64k
#define KEL_BASEADDR 		   					0x1fc20000
#define RAWDRV_IOC_MAGIC 	   					'x'
#define RAWDRV_IOCRSRAWDEV     					_IOR(RAWDRV_IOC_MAGIC, 20, int)
#define RAWDRV_IOCRSFLASH      					_IOR(RAWDRV_IOC_MAGIC, 21, int)
#define RAWDRV_IOCSRAWACSADDR  					_IOR(RAWDRV_IOC_MAGIC, 2, int)
// End of Flash define Marco            		
                                        		
#ifdef PC_SIMULATED                     		
	#define FILE_SYSLOG							"../web_html/sys.log"
	#define FILE_IMAGE_KERNEL					"/tmp/mtd2"
#else
	#define FILE_IMAGE_KERNEL					"/dev/rawdev"
	#define FILE_SYSLOG							"../web/sys.log"	
#endif

// nv file name
#ifdef IIP

#define FILE_MESSAGES							"/var/log/messages"
#define FILE_RC_CONF							"/etc/rc.conf"
#define FILE_RESOLV_CONF						"/etc/resolv.conf"
#define FILE_UDHCPD_CONF						"/etc/udhcpd.conf"
#define FILE_OPTIONS_PPTP						"/etc/options.pptp"
#define FILE_CHAP_SECRETS						"/etc/chap-secrets"
#define FILE_PPTP								"/etc/pptp"
#define FILE_PPPOE_CONF							"/etc/pppoe.conf"
#define FILE_PAP_SECRETS						"/etc/pap-secrets"
#define FILE_RC_IPTABLES						"/etc/rc.iptables"
#define FILE_RC_FIREWALL						"/etc/rc.firewall"
#define FILE_RIPD_CONF							"/etc/ripd.conf"
#define FILE_CFG_FIFO							"/vinetic/cfg_fifo"
#define FILE_ROUTE_TMP							"/etc/route.tmp"

#else //#ifdef IIP

#define FILE_MESSAGES							"/var/log/messages"
#define FILE_RC_CONF							"/nv/rc.conf"
#define FILE_RESOLV_CONF						"/nv/resolv.conf"
#define FILE_UDHCPD_CONF						"/nv/udhcpd.conf"
#define FILE_OPTIONS_PPTP						"/nv/options.pptp"
#define FILE_CHAP_SECRETS						"/nv/chap-secrets"
#define FILE_PPTP								"/nv/pptp"
#define FILE_PPPOE_CONF						"/nv/pppoe.conf"
#define FILE_PAP_SECRETS						"/nv/pap-secrets"
#define FILE_RC_IPTABLES						"/nv/rc.iptables"
#define FILE_RC_FIREWALL						"/nv/rc.firewall"
#define FILE_RIPD_CONF							"/nv/ripd.conf"
#define FILE_CFG_FIFO							"/vinetic/cfg_fifo"
#define FILE_ROUTE_TMP							"/nv/route.tmp"
#define FILE_11A_RFTYPE							"/proc/adm8668wlan/wlan_rf_type"
#define FILE_APC_SURVEY							"/proc/net/apc_survey"
#define FILE_CONNECT_LIST						"/proc/wildpass"
#define FILE_11E_INFO							"/proc/net/11e_info"
#define FILE_NV_11EINFO							"/nv/11e_info"

#endif //#ifdef IIP

// scripts file name
#define SERVICE_WLAN_RECONNECTAP				"/etc/rc.d/rc.wlan_apclient reconnectAP"
#define SERVICE_WLAN							"/etc/rc.d/rc.wlan"
#define SERVICE_WLAN_APCLIENT					"/etc/rc.d/rc.wlan_apclient"
#define SERVICE_WLAN_WDS						"/etc/rc.d/rc.wlan_wds"
#define SERVICE_RC_VOIP_STOP					"killall aa&"
#define SERVICE_RC_VOIP_RESTART					"/etc/rc.d/rc.voip"
#define SERVICE_RC_HOST							"/etc/rc.d/rc.host"
#define SERVICE_PPPOE_STOP						"/etc/rc.d/init.d/pppoe stop"
#define SERVICE_PPPOE_START						"/etc/rc.d/init.d/pppoe start"			// Process in front-ground
#define SERVICE_PPTP_STOP						"/etc/rc.d/init.d/pptp stop"
#define SERVICE_PPTP_START						"/etc/rc.d/init.d/pptp start"
#define SERVICE_DHCPS_STOP						"/etc/rc.d/init.d/udhcpd stop"
#define SERVICE_DHCPS_START						"/etc/rc.d/init.d/udhcpd start"
#define SERVICE_DHCPS_RESTART					"/etc/rc.d/init.d/udhcpd restart"
#define SERVICE_DHCPC_STOP						"/etc/rc.d/init.d/udhcpc stop"
#define SERVICE_DHCPC_START						"/etc/rc.d/init.d/udhcpc start"
#define SERVICE_DHCPC_RESTART					"/etc/rc.d/init.d/udhcpc restart"
#define SERVICE_NAT_RESTART						"/etc/rc.d/rc.iptables"
#define SERVICE_FIREWALL_RESTART				"/etc/rc.d/rc.firewall"
#define SERVICE_RIPD_START						"/etc/rc.d/init.d/ripd start"
#define SERVICE_RIPD_STOP						"/etc/rc.d/init.d/ripd stop"
#define SERVICE_UPNPD_START						"/etc/rc.d/init.d/upnp start"
#define SERVICE_UPNPD_STOP						"/etc/rc.d/init.d/upnp stop"
#define SERVICE_UPNPD_RESTART					"/etc/rc.d/init.d/upnp restart"
#define SERVICE_WAN_STOP			    		"/etc/rc.d/init.d/wan_disconnect"
#define SERVICE_DDNS_STOP						"/etc/rc.d/init.d/ddns stop"        				
#define SERVICE_DDNS_START						"/etc/rc.d/init.d/ddns start"       				
#define SERVICE_DDNS_RESTART					"/etc/rc.d/init.d/ddns restart"     				
#define SERVICE_DNRD_RESTART						"/etc/rc.d/init.d/dnrd restart"
#define SERVICE_DNS_START						"/etc/rc.d/init.d/dns start"
#define SERVICE_RESTORE							"/usr/sbin/rawaccess -s"
#define SERVICE_TAPIDEMO_START					"/etc/rc.d/init.d/tapidemo start"		// ex: tapidemo -r -I 10.1.1.101&
#define SERVICE_TAPIDEMO_STOP					"/etc/rc.d/init.d/tapidemo stop"
#define SERVICE_QOS_RESTART       				"/etc/rc.d/rc.qos"                  				
#define SERVICE_RESTORE							"/usr/sbin/rawaccess -s"				//Add
#define SERVICE_QOS								"/etc/rc.d/init.d/qos"
#define SERVICE_UPDATE							"/etc/init.d/system_update.sh"
#define SERVICE_APCLIENT_DHCPC_STOP			"/etc/rc.d/init.d/udhcpc_apclient stop"
#define SERVICE_APCLIENT_DHCPC_START			"/etc/rc.d/init.d/udhcpc_apclient start"
#define SERVICE_APCLIENT_DHCPC_RESTART		"/etc/rc.d/init.d/udhcpc_apclient restart"


#ifdef CONFIG_CGI_OPEN_COMP_WLAN

#ifdef RALINK
	#define ADM_LAN_IF							"br0"	// adm0 (GW) must modify to br0(WL).
	#define ADM_WAN_IF							"adm1"	// adm1 must modify to adm1.
	#define ADM_PPP_IF							"ppp0"	// PPTP & PPPoE Interface
	#define ADM_WLAN_IF							"ra0"	// Wireless LAN Interface (Ralink - ra0; Inprocomm - wlan0)
#endif //#ifdef RALINK

#ifdef INPROCOMM
	#define ADM_LAN_IF							"br0"	// adm0 (GW) must modify to br0(WL).
	#define ADM_WAN_IF							"adm1"	// adm1 must modify to adm1.
	#define ADM_PPP_IF							"ppp0"	// PPTP & PPPoE Interface
	#define ADM_WLAN_IF							"wlan0"	// Wireless LAN Interface (Ralink - ra0; Inprocomm - wlan0)

	// Define Encripytion Type
	typedef enum {
		WLAN_ENCRY_NONE = 0,
		WLAN_ENCRY_WEP64,
		WLAN_ENCRY_WEP128,
		WLAN_ENCRY_WEP152,
		WLAN_ENCRY_TKIP,
		WLAN_ENCRY_AES
	} WLAN_ENCRY_MODE_T;
		
	// Define Authentication Type
	typedef enum {
		WLAN_AUTH_OPEN = 0,
		WLAN_AUTH_1X,
		WLAN_AUTH_SHARED,
		WLAN_AUTH_AUTO,
		WLAN_AUTH_WPA,
		WLAN_AUTH_PSK
	} WLAN_AUTH_MODE_T;
#endif //#ifdef INPROCOMM

// Define Encripytion Type
#ifdef SPURS
	#define ADM_LAN_IF							"br0"	// adm0 (GW) must modify to br0(WL).
	#define ADM_WAN_IF							"adm1"	// adm1 must modify to adm1.
	#define ADM_PPP_IF							"ppp0"	// PPTP & PPPoE Interface
	#define ADM_WLAN_IF							"eth0"	// Wireless LAN Interface (Ralink - ra0; Inprocomm - wlan0)

	// Define Encripytion Type
	typedef enum {
		WLAN_ENCRY_NONE = 0,
		WLAN_ENCRY_SHARED,
		WLAN_ENCRY_AUTOSWITCH,
		WLAN_ENCRY_WPATKIP,
		WLAN_ENCRY_WPAAES
	} WLAN_ENCRY_MODE_T;
		
	// Define Authentication Type
	typedef enum {
		WLAN_AUTH_NONE = 1,//090704 ask for bodi
		WLAN_AUTH_SHARED,
		WLAN_AUTH_1X,
		WLAN_AUTH_WPATKIP,
		WLAN_AUTH_WPAPSK
	} WLAN_AUTH_MODE_T;
#endif //#ifdef SPURS

#ifdef WILDPASS
	#define ADM_LAN_IF							"eth0"	// adm0 (GW) must modify to br0(WL).
	#define ADM_WAN_IF							"adm1"	// adm1 must modify to adm1.
	#define ADM_PPP_IF							"ppp0"	// PPTP & PPPoE Interface
	#define ADM_WLAN_IF							"eth0"	// Wireless LAN Interface (Ralink - ra0; Inprocomm - wlan0)
       #define ADM_APCLIENT_LAN_IF				"br0:0"	//  DHCP Client in AP Client mode.
	// Define Encripytion Type
	typedef enum {
		WLAN_ENCRY_NONE = 0,
		WLAN_ENCRY_SHARED,
		WLAN_ENCRY_AUTOSWITCH,
		WLAN_ENCRY_WPATKIP,
		WLAN_ENCRY_WPAAES,
		WLAN_ENCRY_WPATKIPAES
	} WLAN_ENCRY_MODE_T;
		
	// Define Authentication Type
	typedef enum {
		WLAN_AUTH_NONE = 1,//090704 ask for bodi
		WLAN_AUTH_SHARED,
		WLAN_AUTH_1X,
		WLAN_AUTH_WPATKIP,
		WLAN_AUTH_WPAPSK,
		WLAN_AUTH_WPA2TLS,
		WLAN_AUTH_WPA2PSK
	} WLAN_AUTH_MODE_T;
#endif //#ifdef WILDPASS

#else //#ifdef CONFIG_CGI_OPEN_COMP_WLAN
//#ifndef CONFIG_CGI_OPEN_COMP_WLAN

	#define ADM_LAN_IF							"adm0"	// adm0 (GW)
	#define ADM_WAN_IF							"adm1"	// adm1
	#define ADM_PPP_IF							"ppp0"	// PPTP & PPPoE Interface

#endif //#ifndef CONFIG_CGI_OPEN_COMP_WLAN


//////////////////////////////////////////////////////////////////////
// ADMtek tag define begin
//
#define TAG_SP	"sp"
#define TAG_HOSTNAME							"hostname"
#define TAG_TIME_ZONE 							"wizard_tz"
#define TAG_SYSTEM_PASSWORD						"system_password"
#define TAG_SYSTEM_AUTOLOGOUT					"system_autologout"
#define TAG_WAN_MAIN							"wan_main"
#define TAG_DHCP_BINPOND						"dhcp_bigpond"
#define TAG_WAN_DHCPC							"wan_dhcpc"
#define TAG_WAN_STATIC 							"wan_static"
#define TAG_WAN_STATIC_ALIAS					"wan_static_alias"
#define TAG_ROUTE_STATIC						"route_static"
#define TAG_FIREWALLMAC_STAT					"firewall_mac_status"
#define TAG_FIREWALLMAC							"firewall_mac"
#define TAG_UPNPCONFIG							"upnp_config"
#define TAG_DDNSSTATUS							"ddns_status"
#define TAG_DDNSCONFIG							"ddns_config"
#define TAG_WAN_PPPOE							"wan_pppoe"
#define TAG_WAN_PPTP							"wan_pptp"
#define TAG_WAN_DNS								"wan_dns"
#define TAG_LAN_DNS								"lan_dns"
#define TAG_LAN_DHCPS 							"lan_dhcps"
#define TAG_LAN_DHCP_CLIENTS					"lan_dhcp_clients"
#define TAG_WLAN_SETTINGS						"wlan_settings"
#define TAG_WLAN_SECURITY						"wlan_security"
#define TAG_NAT_FIREWALL_SHARE					"nat_firewall_share"
#define TAG_NAT_SPECIALAPP						"nat_specialapp"
#define TAG_NAT_VIRTUALSER						"nat_virtualser"
#define TAG_NAT_PORTMAP							"nat_portmap"
#define TAG_NAT_ADDRMAP							"nat_addrmap"
#define	TAG_FIREWALL_MAIN						"firewall_main"
#define TAG_FIREWALL_DMZ						"firewall_dmz"
#define TAG_FIREWALL_DISABLEWAN 				"firewall_disablewan"
#define TAG_FIREWALL_CLIENTFILTER				"firewall_clientfilter"
#define TAG_FIREWALL_CLIENTFILTER_STATUS		"firewall_clientfilter_status"
//#define TAG_FIREWALL_URLFILTER				"firewall_urlfilter"
#define TAG_ROUTE_DYNAMIC						"route_dynamic"
#define TAG_ROUTE_TABLE							"route_table"
#define TAG_WLAN_STATUS                 		"wlan_status"
#define TAG_ADSL_VCCHANNEL						"adsl_vcchannel"
#define TAG_QOS_CONFIG                  		"qos_config"
#define TAG_QOS_DIFFSERV_CONFIG         		"diffserv_config"
#define TAG_VOIP_TAPIDEMO             			"voip_tapidemo"
#define TAG_VOIP_CV             				"voip_cv"		// Codec and VAD
#define TAG_VLAN								"vlan_setting_table"
#define TAG_STAICMAC							"staicmac_setting_table"
#define TAG_ROUTE_DYNAMIC_WAN					"route_dynamic_wan"
#define TAG_ROUTE_DYNAMIC_LAN					"route_dynamic_lan"

#ifdef IIP
	#define TAG_STATIC_TABLE					"static_filter_table"
#endif

#define TAG_FILTER								"filter_setting"
#define TAG_VLAN_SETTINGS						"vlan_setting"
#define TAG_VLAN_ENTRY_TABLE					"vlan_entry_table"
#define TAG_UPDATE								"system_update"

#ifdef ATA
	#define TAG_PORT0_DATA						"port0_data"	//1; admin
	#define TAG_PORT1_DATA						"port1_data"	//port1
	#define TAG_PORT2_DATA						"port2_data"	//port2
#endif //#ifdef ATA

#if defined(WILDPASS) || defined(GATEWAY)
	#define TAG_SYSTEM_PASSWORD_REMOTE			"system_password_remote"
#endif

#ifdef WILDPASS
#define TAG_WLAN_APMODE							"wlan_apmode"
#define TAG_WLAN_SEL_APDATA					   	 "wlan_select_apdata"
#define TAG_FIREWALL_NOTIFY                				 "firewall_notify"
#define TAG_WLAN_QOSSETTINGS						"wlan_qossettings"
#define TAG_WLAN_WDSSETTINGS						"wlan_wdssettings"
#define TAG_WLAN_QOS_QAPSETTINGS					"wlan_qos_qapsettings"
#define TAG_WLAN_QOS_QSTASETTINGS				"wlan_qos_qstasettings"
#define TAG_WLAN_11HSETTINGS						"wlan_11hsettings"
#define TAG_WLAN_APCLIENT_DHCPC					"wlan_apclient_dhcpc"
#endif 
// ADMtek tag define end
//////////////////////////////////////////////////////////////////////

typedef struct 
{
	char_t sCF_IP_START[8];
	char_t sCF_IP_END[8];
	char_t sCF_PORT_START[8];
	char_t sCF_PORT_END[8];
	char_t sCF_TYPE[8];
	char_t sUnused[MAX_DATA_LEN - 8*5 ];

} CGI_TABLE_CLIENT_FILTER;


/* Web ASP Page Table structure */
typedef struct
{

	/* Web ASP Page Table index */
	//uint	nIndex;
	int	nIndex;
	/* Web ASP Page Table item status 0: Disable, 1: Enable */
	uint	nState;
	/* Web ASP Page Table item value */
	union {
		CGI_TABLE_CLIENT_FILTER CF_TABLE;
    		char_t	sValue8B[MAX_DATA_LEN/8][8];
    		char_t	sValue[MAX_DATA_LEN];
	} Data;
}
CGI_TABLE_S;

/* HTTP connection structure */
struct connection_profil
{
	/* HTTP Connected time */
    uint    time;
    /* HTTP Connected IP Address */
    char_t  ipaddr[32];
    /* HTTP Connected block flag */
    uint	block; 
    /* HTTP Connected Allow flag */
    uint    allowed;
}connection;

#define EATW(s)							{while (gisspace(*s)) s++;} // This MACRO is for eating white space.

typedef struct
{
    uint	nIndex;
    uint	nValue;
}
ST_LEASE_TIME;

typedef struct
{
	uint	nRangeIdx;
    char_t	sRetValue[MAX_DATA_LEN];
}
ST_NAT_PORT_MAP_LIST;



