/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include "ifx_emf.h"
#include <signal.h>
#include <unistd.h> 
#include <sys/types.h>
#include <sys/wait.h>
#include <ifx_common.h>
#include "ifx_httpd_method.h"
#include "ifx_incaip_cgi.h"
#include "ifx_common_defs.h"
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#include "ifx_web_common.h"

#ifdef DMALLOC
#include "dmalloc.h"
#endif

/*****************************************************************************
 *  Function Name   : ifx_get_voip_keymgt_srtcp
 *  Description     : This function is called voip_sip_keymgt.asp page
 *  Input Values    :
 *  Output Values   :
 *
 *  Return Value    : 0  - Success
 *                    -1 - Failure
 *  Notes           :
 ****************************************************************************/
int ifx_get_voip_keymgt_srtcp(int eid, httpd_t wp, int argc, char_t **argv)
{
#ifdef SRTP
	char_t  *name;        x_IFX_CM_Msg xCmMsg;
	int32 nIndex=0;

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}
        // Get Data from CM
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SRTCP_KEY_CFG;
	xCmMsg.ucChannel = 0;
	ifx_httpdWrite(wp, "document.tF0.CryptEntries.length = %d;", 5);
	if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
           ifx_httpdError(wp, 200, T("Fail to receive data from CM Fax1\n"));
		return -1;
	}

	for (nIndex=0; nIndex<5; nIndex++)
	{
		x_IFX_CM_SrtpKeyCfg entry;
		memset(&entry, 0, sizeof(x_IFX_CM_SrtpKeyCfg));
		entry = xCrypto[nIndex];
		ifx_httpdWrite(wp, "loc[%d]=%d\n", nIndex, nIndex);
		ifx_httpdWrite(wp, "field[%d]=%d\n", nIndex, nIndex);
		ifx_httpdWrite(wp, "document.tF0.CryptEntries[%d] = new Option(\"%d -- %s\");\n", nIndex, nIndex+1,
		               entry.xCryptoIndexParam.acIpaddress);
		ifx_httpdWrite(wp, "document.tF0.CryptEntries[%d].value = %d;", nIndex, nIndex);
		ifx_httpdWrite(wp, "AEt[%d]=\"%d\";\n", nIndex, entry.eEncrAlgo);
		ifx_httpdWrite(wp, "AAt[%d]=\"%d\";\n", nIndex, entry.eAuthAlgo);
		ifx_httpdWrite(wp, "AMk[%d]=\"%s\";\n", nIndex, entry.xMasterCryptoParam[0].acMasterKey);
		ifx_httpdWrite(wp, "AMs[%d]=\"%s\";\n", nIndex, entry.xMasterCryptoParam[0].acMasterSalt);
		ifx_httpdWrite(wp, "AMkf[%d]=\"%d\";\n", nIndex, entry.xMasterCryptoParam[0].cMkiIndicator);
		ifx_httpdWrite(wp, "AMkv[%d]=\"%d\";\n", nIndex, entry.xMasterCryptoParam[0].uiMkiValue);
		ifx_httpdWrite(wp, "ATp[%d]=\"%s\";\n", nIndex, entry.xCryptoIndexParam.acIpaddress);
	}
	return 0;

#endif /* end of SRTP */       
}

void ifx_set_voip_sip_keymgt_srtcp(httpd_t wp, char_t *path, char_t *query)
{
#ifdef SRTP
        char_t   *paddflag  = ifx_httpdGetVar(wp, T("addflag"), T(""));
	char_t   *pmodflag  = ifx_httpdGetVar(wp, T("modflag"), T(""));
	char_t   *pdelflag   = ifx_httpdGetVar(wp, T("delflag"), T(""));

	char_t  *psrtp_encr_tranf = ifx_httpdGetVar(wp, T("srtp_encr_tranf"), T(""));
	char_t  *psrtp_auth_tranf = ifx_httpdGetVar(wp, T("srtp_auth_tranf"), T(""));
	char_t  *pmasterkey  = ifx_httpdGetVar(wp, T("masterkey"), T(""));
	char_t  *pmastersalt   = ifx_httpdGetVar(wp, T("mastersalt"), T(""));
	char_t  *pmkiflag  = ifx_httpdGetVar(wp, T("mkiflag"), T(""));
	char_t  *pmkivalue  = ifx_httpdGetVar(wp, T("mkivalue"), T(""));
	char_t  *ptip = ifx_httpdGetVar(wp, T("tip"),T(""));
	char_t  *poldip = ifx_httpdGetVar(wp, T("oldip"),T(""));

	x_IFX_CM_Msg xCmMsg;
	a_assert(wp);
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SRTCP_KEY_CFG;
	xCmMsg.ucChannel = 0;

	if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
           ifx_httpdError(wp, 200, T("Fail to receive data from CM Fax1\n"));
           return -1;
	}

	xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SRTCP_KEY_CFG;
	xCmMsg.ucChannel = 0;

	/* fill the Structure */
	xCmMsg.uxData.xSrtpKeyCfg.eEncrAlgo = gatoi(psrtp_encr_tranf);
	xCmMsg.uxData.xSrtpKeyCfg.eAuthAlgo = gatoi(psrtp_auth_tranf);
	xCmMsg.uxData.xSrtpKeyCfg.unAuthTagLen = 80;
	xCmMsg.uxData.xSrtpKeyCfg.unSrtpPrefixLen = 0;
	xCmMsg.uxData.xSrtpKeyCfg.unPseudoRandomFunc = IFX_CM_AES_CM;
	if (strlen(pmasterkey)!=16)
	{
		ifx_httpdError(wp, 200, T("Invalid Master Key"));
		return;
	}

	strcpy(xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterKey,pmasterkey);
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMasterKeyLen = 128;
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMasterSaltLen = 112;
	strcpy(xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterSalt, pmastersalt);

	if (strlen(pmastersalt)!=14)
	{
		ifx_httpdError(wp, 200, T("Invalid Master Salt Key"));
		return;
	}

	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unSesEncrKeyLen = 128;
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unSesAuthKeyLen = 160;
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unSesSaltKeyLen = 112;
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiKeyDerivationRate = 0;
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ulFromIndex = 0;
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ulToIndex = IFX_CM_MAX_SRTP_LIFE_TIME-100;
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ulSrtpMaxLifeTime = IFX_CM_MAX_SRTP_LIFE_TIME-100;
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiSrtcpMaxLifeTime = IFX_CM_MAX_SRTCP_LIFE_TIME-100;
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].cMkiIndicator = gatoi(pmkiflag);
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMkiLength = 4;
	xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiMkiValue = gatoi(pmkivalue);

	/* if MKI flag is zero, set length and value to zero*/
	if (xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].cMkiIndicator == 0)
	{
		xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].unMkiLength = 0;
		xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiMkiValue = 0;
	}

	xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.uiSsrcValue = 0;
	xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.uiRoc = 0;
	xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.unSeqNumber = 0;
	xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.ulSrtcpIndex = 0;
	xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.unPort = 5000;

	if (strlen(ptip) == 0)
	{
		ifx_httpdError(wp, 200, T("Invalid IP Address"));
		return;
	}

   if ( IFX_ValidateIpAddress(ptip) < 0)
   {
             ifx_httpdError(wp, 200, T("Invalid IP address!!!"));
              return;
   }
   
	if (gatoi(pmodflag) == 1)
	{
		if (strcmp(poldip,ptip))
		{
			ifx_httpdError(wp, 200, T("IP Address cannot be Modified"));
			return;
		}
	}

	strcpy(xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.acIpaddress,ptip);

	if (gatoi(pdelflag) == 1) /* press Del button */
	{
		xCmMsg.uxData.xSrtpKeyCfg.xCryptoIndexParam.unPort = 0;
	}

	if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
    	if (connection.allowed == 1)
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		else
		{
		ifx_httpdError(wp, 200, T("Fail to send IFX_CM_SRTP_KEY_CFG data to CM"));
        }
		return;
	}

	if (xCmMsg.ucMsgType == IFX_CM_SET_ERR_RSP)
	{
		ifx_httpdError(wp, 200, T("Invalid Operation"));
		return;
	}
	ifx_httpdNextPage(wp);
#endif /* End of SRTP*/
}