/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

#ifdef WILDPASS
extern int g_nCurrentAPMode;
#endif //#ifdef WILDPASS

ST_LEASE_TIME nSelLeaseTime[] =
{
    { 0, 1800},
    { 1, 3600},
    { 2, 7200},
    { 3, 43200},
    { 4, 86400},
    { 5, 172800},
    { 6, 604800},
    { 7, 1209600},
//    { 8, "Forever"}		// 
};


CGI_ENUMSEL_S web_Enum_LeaseTimeList [] =
{
    { 0, "Half hour"},
    { 1, "One hour"},
    { 2, "Two hours"},
    { 3, "Half day"},
    { 4, "One day"},
    { 5, "Two days"},
    { 6, "One week"},
    { 7, "Two weeks"},
//    { 8, "Forever"}
};

int ifx_get_DhcpStatus(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sValue[MAX_DATA_LEN];
	char_t	sMode[MAX_DATA_LEN];
	int APMode;

	memset(sValue, 0x00, MAX_DATA_LEN);
	memset(sMode, 0x00, MAX_DATA_LEN);

	if (ifx_GetCfgData(FILE_RC_CONF, TAG_LAN_DHCPS, "dhcps_enable", sValue) == 1)
	{
		if ( !gstrcmp(sValue, "YES") )	//DHCP Enable
		{
			gstrcpy(sValue, "1");
		}
		else							//DHCP Disable
		{
			gstrcpy(sValue, "0");
		}
	}
	//ejSetResult(eid, sValue);

      //CHECK IF AP Client Mode
       if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, "WLAN_CURRENT_MODE", sMode) == 1 )
	{
           if ( !gstrcmp(sMode, "0") )
	      APMode=0; //ap
	    else  if ( !gstrcmp(sMode, "1") )
		APMode=1; //client
	    else  if ( !gstrcmp(sMode, "2") )
		APMode=2;  //wds 
	    
	}

	
	if(strncmp(sValue,"1",1) == 0)
	{
              if (APMode==1)	
		     ifx_httpdWrite(wp,T("Disable")); //AP Client mode
		else
		     ifx_httpdWrite(wp,T("Enable"));//ifx_httpdWrite(wp,"checked");
	}else
	if(strncmp(sValue,"0",1) == 0)
	{
		ifx_httpdWrite(wp,T("Disable"));//ifx_httpdWrite(wp,"checked");
	}	
	return 0;
}

int ifx_get_lan_dhcps(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	sValue[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(command, 0x00, MAX_FILELINE_LEN);

	if ( !gstrcmp(name, T("Netmask")) )
	{
		websGetNetmask(ADM_LAN_IF, 4, FALSE, sValue);
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	else
	if ( !gstrcmp(name, T("DhcpsStartIP4")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 | cut -f4 -d."), "^start", FILE_UDHCPD_CONF);
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
		else
		{
			ifx_httpdWrite(wp, T(""));
		}
	}
	else
	if ( !gstrcmp(name, T("DhcpsEndIP4")) )
	{
		gsprintf(command, T("grep %s %s | cut -f2 | cut -f4 -d."), "^end", FILE_UDHCPD_CONF);
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
		else
		{
			ifx_httpdWrite(wp, T(""));
		}
	}
	else
	if ( !gstrcmp(name, T("DN")) )
	{
		gsprintf(command, T("grep %s %s | grep -n %s | cut -f3"), "^option", FILE_UDHCPD_CONF, "domain");
		if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
		else
		{
			ifx_httpdWrite(wp, T(""));
		}
	}
#ifdef WILDPASS
	else
	if ( !gstrcmp(name, T("IsDHCP_Disable")) )
	{
		if (g_nCurrentAPMode==1)
		{
			ifx_httpdWrite(wp, T("disabled"));
		}
	}
#endif //#ifdef WILDPASS

	return 0;
}

int ifx_get_lan_dhcps_IP(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	sValue[MAX_FILELINE_LEN];

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);

   	if ( !gstrcmp(name, T("SysIP0")) )
	{
		ifx_debug_printf(T("%s"), ADM_LAN_IF);
		websGetInterfaceIP(ADM_LAN_IF, 3, FALSE, sValue);
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	else
   	if ( !gstrcmp(name, T("SysIP1")) )
	{
		websGetInterfaceIP(ADM_LAN_IF, 1, TRUE, sValue);
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	else
	if ( !gstrcmp(name, T("SysIP2")) )
	{
		websGetInterfaceIP(ADM_LAN_IF, 2, TRUE, sValue);
		ifx_httpdWrite(wp, T("%s"), sValue);

	}
	else
   	if ( !gstrcmp(name, T("SysIP3")) )
	{
		websGetInterfaceIP(ADM_LAN_IF, 3, TRUE, sValue);
		ifx_httpdWrite(wp, T("%s"), sValue);
	}
	else
	if ( !gstrcmp(name, T("SysIP4")) )
	{
		websGetInterfaceIP(ADM_LAN_IF, 4, TRUE, sValue);
		ifx_httpdWrite(wp, T("%s"), sValue);
	}

	return 0;
}

int ifx_get_lan_dhcps_LeaseTime(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sValue[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];
	int		i, nSelIdx, nLeaseTime = 0;

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(command, 0x00, MAX_FILELINE_LEN);

	nSelIdx = sizeof(web_Enum_LeaseTimeList)/sizeof(CGI_ENUMSEL_S);
	
	gsprintf(command, T("grep %s %s | grep -n %s | cut -f3"), "^option", FILE_UDHCPD_CONF, "lease");
	if (ifx_GetCfgData((char_t*)command, NULL, "1", sValue) == 1)
	{
		nLeaseTime = gatoi(sValue);
		
		if (nLeaseTime <= 7200 && nLeaseTime > 0)
		{
			nSelIdx = nLeaseTime / 3600;	//For one hour
		}
		else
		if (nLeaseTime <= 172800 && nLeaseTime > 7200)
		{
			nSelIdx = 3 + (nLeaseTime / 86400);	//For one day
		}
		else
		if (nLeaseTime <= 1209600 && nLeaseTime > 172800)
		{
			nSelIdx = 5 + (nLeaseTime / 604800);	//For one week;
		}
		else
		if (nLeaseTime > 1209600)
		{
			nSelIdx = -1;
		}
	}
	else
	{
		ifx_httpdWrite(wp, T(""));
	}

	for (i = 0; i < sizeof(web_Enum_LeaseTimeList)/sizeof(CGI_ENUMSEL_S); i++)
	{	
		// Get Selected option index from udhcpd.conf
		if (i == nSelIdx)
		{
			gstrcpy (sValue, " SELECTED");
		}
		else 
		{
			gstrcpy (sValue, "");
		}
		
		ifx_httpdWrite(wp, T("\t\t\t\t<option VALUE=\"%d\"%s> %s </option>\n"), i, sValue, web_Enum_LeaseTimeList[i].str);
	}
	return 0;
}





void ifx_set_lan_dhcps(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pSysIP1, *pSysIP2, *pSysIP3, *pSysIP4, *pIsDHCP;
	char_t	*pDhcpsStartIP4, *pDhcpsEndIP4, *pLeaseTime, *pDN;
	char_t	sRouter[MAX_FILELINE_LEN], sDhcpsStartIP[MAX_FILELINE_LEN], sDhcpsEndIP[MAX_FILELINE_LEN];
	char_t	sMaxLease[MAX_FILELINE_LEN], sSubnet[MAX_FILELINE_LEN], sDhcpStatus[MAX_FILELINE_LEN];
	char_t	sLeaseTime[MAX_FILELINE_LEN], sDN[MAX_FILELINE_LEN];
	char_t	getCommand[MAX_FILELINE_LEN], setCommand[MAX_FILELINE_LEN];
	int		nEnd = 0, nStart = 0, nLeaseTime = 0, i;
	char_t	sIfconfigLAN[MAX_FILELINE_LEN];
	char_t 	sLanIP_prefix[MAX_FILELINE_LEN];
	char_t	sDNSIP[MAX_FILELINE_LEN];
	char_t	sFQDN[MAX_FILELINE_LEN];

	a_assert(wp);
	memset(getCommand, 0x00, MAX_FILELINE_LEN);
	memset(setCommand, 0x00, MAX_FILELINE_LEN);
	memset(sIfconfigLAN, 0x00, MAX_FILELINE_LEN);
	memset(sLanIP_prefix, 0x00, MAX_FILELINE_LEN);
	memset(sDNSIP, 0x00, MAX_FILELINE_LEN);
	memset(sFQDN, 0x00, MAX_FILELINE_LEN);
	
	// Get value from ASP file
	pSysIP1 = ifx_httpdGetVar(wp, T("sysip1"), T(""));
	pSysIP2 = ifx_httpdGetVar(wp, T("sysip2"), T(""));
	pSysIP3 = ifx_httpdGetVar(wp, T("sysip3"), T(""));
	pSysIP4 = ifx_httpdGetVar(wp, T("sysip4"), T(""));
	pIsDHCP = ifx_httpdGetVar(wp, T("IsDHCP"), T(""));
	
	if ( (pSysIP1 && *pSysIP1) && (pSysIP2 && *pSysIP2) &&
		 (pSysIP3 && *pSysIP3) && (pSysIP4 && *pSysIP4))
	{
		gsprintf(sRouter, T("option\trouter\t%s.%s.%s.%s\n"), pSysIP1, pSysIP2, pSysIP3, pSysIP4);
	}

	gsprintf(getCommand, T("ifconfig %s | grep %s | cut -f4 -d:"), ADM_LAN_IF, "Mask:");
	
	if ( ifx_GetCfgData((char_t*)getCommand, NULL, "1", getCommand) == 1 )
	{
		gsprintf(sSubnet, T("option\tsubnet\t%s\n"), getCommand);
	}
	
	gsprintf(setCommand, T("ifconfig %s %s.%s.%s.%s netmask %s"),
						 ADM_LAN_IF, pSysIP1, pSysIP2, pSysIP3, pSysIP4, getCommand);
	gsprintf(sIfconfigLAN, T("ifconfig_adm0=\"%s.%s.%s.%s netmask 255.255.255.0\"\n"),
							 pSysIP1, pSysIP2, pSysIP3, pSysIP4);
	gsprintf(sLanIP_prefix, T("LANIP_PREFIX=\"%s.%s.%s.\"\n"),
							 pSysIP1, pSysIP2, pSysIP3);
	gsprintf(sDNSIP, T("option\tdns\t%s.%s.%s.%s\n"),
						pSysIP1, pSysIP2, pSysIP3, pSysIP4);

	if (pIsDHCP && *pIsDHCP)
	{
		gsprintf(sDhcpStatus, T("dhcps_enable=\"YES\"\n"));
		websSetCfgData(FILE_RC_CONF, TAG_LAN_DHCPS, 3, sDhcpStatus, sIfconfigLAN, sLanIP_prefix);
		pDhcpsStartIP4 = ifx_httpdGetVar(wp, T("DhcpsStartIP4"), T(""));
		pDhcpsEndIP4 = ifx_httpdGetVar(wp, T("DhcpsEndIP4"), T(""));
		pLeaseTime = ifx_httpdGetVar(wp, T("LeaseTime"), T(""));
		pDN = ifx_httpdGetVar(wp, T("DN"), T(""));
		
		nEnd = gatoi(pDhcpsEndIP4);
		nStart = gatoi(pDhcpsStartIP4);
		gsprintf(sDhcpsStartIP, T("start\t%s.%s.%s.%s\n"), pSysIP1, pSysIP2, pSysIP3, pDhcpsStartIP4);
		gsprintf(sDhcpsEndIP, T("end\t%s.%s.%s.%s\n"), pSysIP1, pSysIP2, pSysIP3, pDhcpsEndIP4);
		gsprintf(sMaxLease, T("max_leases\t%d\n"), nEnd - nStart + 1);
		memset(getCommand, 0x00, MAX_FILELINE_LEN);

		if (pDN && *pDN)
		{
			gsprintf(sDN, T("option\tdomain\t%s\n"), pDN);
			gsprintf(getCommand, T("hostname -s"));
			if ( ifx_GetCfgData((char_t*)getCommand, NULL, "1", getCommand) == 1 )
		        {
                		strcat(getCommand, T("."));
                		strcat(getCommand, pDN);
		        	gsprintf(sFQDN, T("hostname=\"%s\"\n"), getCommand);
			}
		}
		else
		{
			gsprintf(sDN, T("#option\tdomain\t\n"));
			gsprintf(getCommand, T("hostname"));
                        if ( ifx_GetCfgData((char_t*)getCommand, NULL, "1", getCommand) == 1 )
                        {
                                gsprintf(sFQDN, T("hostname=\"%s\"\n"), getCommand);
                        }

		}
		
		nLeaseTime = gatoi(pLeaseTime);

		for (i = 0; i < sizeof(nSelLeaseTime)/sizeof(ST_LEASE_TIME); i++)
		{
			if (nLeaseTime == i)
			{
				nLeaseTime = nSelLeaseTime[i].nValue;
			}
		}

		gsprintf(sLeaseTime	, T("option\tlease\t%d\n"), nLeaseTime);
	}
	else
	{
		gsprintf(sDhcpStatus, T("dhcps_enable=\"NO\"\n"));
		websSetCfgData(FILE_RC_CONF, TAG_LAN_DHCPS, 3, sDhcpStatus, sIfconfigLAN, sLanIP_prefix);
	}

	//RunTime change.
	system(SERVICE_DHCPS_STOP);
	system(setCommand);	

	websSetCfgData(FILE_UDHCPD_CONF, TAG_LAN_DNS, 1, sDNSIP);

	if (pIsDHCP && *pIsDHCP)
	{
		websSetCfgData(FILE_UDHCPD_CONF, TAG_LAN_DHCPS, 6, sDhcpsStartIP, sDhcpsEndIP, sMaxLease, sSubnet, sRouter, sLeaseTime);
		websSetCfgData(FILE_UDHCPD_CONF, TAG_HOSTNAME, 1, sDN);
		websSetCfgData(FILE_RC_CONF, TAG_HOSTNAME, 1, sFQDN);
		system(SERVICE_DHCPS_START);
	}

	// reset connection setting
	// Therefore, the belowc ommands is to erase the client's IP address.
	// And page will redirect to login.asp page.
    connection.allowed=0;
    connection.block=0;
    memset(connection.ipaddr,0x00,32);
	system(SERVICE_NAT_RESTART);
	system(SERVICE_FIREWALL_RESTART);
	system(SERVICE_RC_HOST);
	system(SERVICE_DNS_START);
	system(SERVICE_DNRD_RESTART);
	system(SERVICE_RESTORE);
	ifx_httpdNextPage(wp);
}
