/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include	"ifx_common_defs.h"
#include	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

/*****************************************************************************
 *  Function Name   : ifx_get_extn
 *  Description     : This function is called voip_sip_user.asp page
 *  Input Values    :
 *  Output Values   :
 *
 *  Return Value    : 0  - Success
 *                    -1 - Failure
 *  Notes           :
 ****************************************************************************/
int ifx_get_extn(int eid, httpd_t wp, int argc, char_t **argv)
{
        char_t  *name;
        x_IFX_CM_Msg xCmMsg;
	//<< sharont01262005 modify
	char_t	sPortUser1[MAX_DATA_LEN];
	char_t	sPortUser2[MAX_DATA_LEN];
	//>> sharont01262005 modify

    if (ejArgs(argc, argv, T("%s"), &name) < 1)
    {
            ifx_httpdError(wp, 200, T("Insufficient args\n"));
            return -1;
    }
    if (!gstrcmp(name, T("Freez")))
    {
		//<< sharont01262005 modify
#ifdef ATA
		// Get data from rc.conf instead of obtained from CM.
		// Cause of PPPoE mode can't initialize CM server.
		memset(sPortUser1, 0x00, MAX_DATA_LEN);
		memset(sPortUser2, 0x00, MAX_DATA_LEN);

		ifx_GetCfgData(FILE_RC_CONF, TAG_PORT1_DATA, T("port1"), sPortUser1);
		ifx_GetCfgData(FILE_RC_CONF, TAG_PORT2_DATA, T("port2"), sPortUser2);
		
		ifx_httpdWrite(wp, T("if (document.tF0.userlevel.value == 1)\n"));
		ifx_httpdWrite(wp, T("{\n"));
		ifx_httpdWrite(wp, T("	document.tF0.port.selectedIndex = 0;\n"));
	    if (gstrcmp(sPortUser1, T(" ")))
	    {
			ifx_httpdWrite(wp, T("	document.tF0.userName.value = \"%s\";\n"), sPortUser1);
		}
	    else
	    {
			ifx_httpdWrite(wp, T("	document.tF0.userName.value = \"\";\n"));
		}
		ifx_httpdWrite(wp, T("}\n"));
		ifx_httpdWrite(wp, T("else if (document.tF0.userlevel.value == 2)\n"));
		ifx_httpdWrite(wp, T("{\n"));
		ifx_httpdWrite(wp, T("	document.tF0.port.selectedIndex = 1;\n"));
 	    if (gstrcmp(sPortUser2, T(" ")))
	    {
			ifx_httpdWrite(wp, T("	document.tF0.userName.value = \"%s\";\n"), sPortUser2);
		}
	    else
	    {
			ifx_httpdWrite(wp, T("	document.tF0.userName.value = \"\";\n"));
		}		ifx_httpdWrite(wp, T("}\n"));
		ifx_httpdWrite(wp, T("else\n"));
		ifx_httpdWrite(wp, T("{\n"));
		ifx_httpdWrite(wp, T("	if (document.tF0.port.selectedIndex == 0)\n"));
		ifx_httpdWrite(wp, T("	{\n"));
	    if (gstrcmp(sPortUser1, T(" ")))
	    {
			ifx_httpdWrite(wp, T("	document.tF0.userName.value = \"%s\";\n"), sPortUser1);
		}
	    else
	    {
			ifx_httpdWrite(wp, T("	document.tF0.userName.value = \"\";\n"));
		}		ifx_httpdWrite(wp, T("	}\n"));
		ifx_httpdWrite(wp, T("	else\n"));
		ifx_httpdWrite(wp, T("	{\n"));
	    if (gstrcmp(sPortUser2, T(" ")))
	    {
			ifx_httpdWrite(wp, T("	document.tF0.userName.value = \"%s\";\n"), sPortUser2);
		}
	    else
	    {
			ifx_httpdWrite(wp, T("	document.tF0.userName.value = \"\";\n"));
		}		ifx_httpdWrite(wp, T("	}\n"));
		ifx_httpdWrite(wp, T("}\n"));
		ifx_httpdWrite(wp, T("return;\n"));
#endif //#ifdef ATA
		//>> sharont01262005 modify
    }
    else
    if (!gstrcmp(name, T("Freez1")))
    {
#ifdef IIP
        	// Get Data from CM
           memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
           xCmMsg.ucMsgType = IFX_CM_GET_REQ;
           xCmMsg.ucInfoType = IFX_CM_APP_ADD_NEW_USR;
           xCmMsg.ucChannel = 0;  /* For port 1*/

           if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
           {
                ifx_httpdError(wp, 200, T("Fail to receive USER data from CM\n"));
                return -1;
           }   
           ucName1 = xCmMsg.uxData.xAppUserCfg.ucName;
           
          	ifx_httpdWrite(wp, T("function Freez1()\n"));
          	ifx_httpdWrite(wp, T("{\n"));
        	ifx_httpdWrite(wp, T("\tdocument.tF0.userName.value = \"%s\"\n"), ucName1);
        	ifx_httpdWrite(wp, T("}\n"));
#endif //#ifdef IIP
    }

	return 0;

}

/////////////////////////////////////////////////////////////////////
//	login.asp                       
//
void ifx_set_login(httpd_t wp, char_t *path, char_t *query)
{                                   
	char_t	*pUserName = ifx_httpdGetVar(wp, T("usname"), T(""));
	char_t	*pPwdVerify = ifx_httpdGetVar(wp, T("pws"), T(""));
//	char_t  *pPort=ifx_httpdGetVar(wp, T("port"), T(""));
    x_IFX_CM_Msg xCmMsg;
	int i = 0, uflag=0;
	bool_t bExist = 0;
	char_t	sPort[MAX_DATA_LEN];
	char_t	sPortNum[MAX_DATA_LEN];
	char_t	sPortUser[MAX_DATA_LEN];
	char_t	sPortPwd[MAX_DATA_LEN];
         
	IFX_CM_WebInit();

#ifdef ATA
	if (gstrcmp(pUserName, "1") != 0) //common users
#endif
#ifdef IIP
	if (gstrcmp(pUserName, "ADMIN") != 0) //common users
#endif
	{
		//<< sharont01262005 modify
		// Get data from rc.conf instead of obtained from CM.
		// Cause of PPPoE mode can't initialize CM server.
		for (i=0; i<APPS_PORT_NUM; i++)	// Support 2 port only now
		{
			memset(sPort, 0x00, MAX_DATA_LEN);
			memset(sPortNum, 0x00, MAX_DATA_LEN);
			memset(sPortUser, 0x00, MAX_DATA_LEN);
			memset(sPortPwd, 0x00, MAX_DATA_LEN);

			gsprintf(sPort, "port%d", i+1);
			if (i == 0) //port 1
			{
				strcpy(sPortNum, TAG_PORT1_DATA);
			}
			else
			if (i == 1) //port 2
			{
				strcpy(sPortNum, TAG_PORT2_DATA);
			}

			if (ifx_GetCfgData(FILE_RC_CONF, sPortNum, sPort, sPortUser) == 1)
			{
				if (strlen(sPortUser)==0)
				{
					continue;
				}
	          
				memset(sPort, 0x00, MAX_DATA_LEN);
				gsprintf(sPort, "password%d", i+1);
				ifx_GetCfgData(FILE_RC_CONF, sPortNum, sPort, sPortPwd);

				if (!gstrcmp(sPortUser, pUserName) && !gstrcmp(sPortPwd, pPwdVerify))
	        {
				bExist = 1;
				uflag = i;
		    }
		}		
		}
		//>> sharont01262005 modify

		if (bExist != 1)
		{
            //websError(wp,200,T("Wrong user password for this port !"));
            ifx_httpdRedirect(wp,T("loginerr.htm"));
            return;
		}
		else
		{
			if (connection.ipaddr[0] == '\0')
			{	                        
				for (i = 0 ; i < 32 ; i++)
					connection.ipaddr[i] = wp->ipaddr[i];
			}
			
			connection.allowed = 1;  	            
			//trace(8, "User Password is correct!\n");
			g_nCurrentUserLevel=uflag+1; //common users
			strcpy(g_nCurrentUserName, pUserName);//keep current user name
         strcpy(g_nCurrentPassword,pPwdVerify); // keep current password
			ifx_httpdNextPage(wp);
		}
	}////common users
	else //admin
	{
		g_nCurrentUserLevel = 3;//reset user level

		//<< sharont01262005 modify
		// Get data from rc.conf instead of obtained from CM.
		// Cause of PPPoE mode can't initialize CM server.
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_PORT0_DATA, T("password0"), sPortPwd) == 1)
		{
			if (!gstrcmp(pPwdVerify, sPortPwd))
			{
				if ( !connection.ipaddr[0] )
				{	                        
					for (i = 0 ; i < 32 ; i++)
					connection.ipaddr[i] = wp->ipaddr[i];
					connection.time = time(NULL);
					//ifx_debug_printf("###Inside ifx_set_login : connection.ipaddr is %s and wp->ipaddr is %s and connection.time is %d\n",connection.ipaddr,wp->ipaddr,connection.time);
					printf("###Inside ifx_set_login : connection.ipaddr is %s and wp->ipaddr is %s and connection.time is %d\n",connection.ipaddr,wp->ipaddr,connection.time);
				}
				else if (gstrcmp(connection.ipaddr,wp->ipaddr) == 0)
				{                           
					//Jeffrey1014           
					//do nothing
					//ifx_debug_printf("###Inside ifx_set_login : connection.ipaddr is %s\n",connection.ipaddr);
					printf("###Inside ifx_set_login : connection.ipaddr is %s\n",connection.ipaddr);
				}                           
				else                        
				{                           
					//websError(wp, 200, T("Another IP now used"));
					// duplicate admin....			
					ifx_httpdError(wp, 200, T("<center><h1>Duplicate Administrator <br>This device is managed by %s currently!!<br></h1></center>"), connection.ipaddr);
					return;
				}                           
	            
				connection.allowed = 1;  	          
				g_nCurrentUserLevel=0; //admin
				strcpy(g_nCurrentUserName, "admin"); 
	         	strcpy(g_nCurrentPassword,pPwdVerify); // keep current password
				ifx_httpdNextPage(wp);     
			}
			else
			{
				ifx_httpdRedirect(wp,T("loginerr.htm"));
			}
		}
		//>> sharont01262005 modify
	} //else admin 

}