/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_nat_addrmap(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	buf[MAX_DATA_LEN], sMapIP[MAX_DATA_LEN];
	char_t	sValue[MAX_FILELINE_LEN], sServerIP[MAX_DATA_LEN], sWanIP[MAX_DATA_LEN];
	char_t	getCommand[MAX_FILELINE_LEN], setCommand[MAX_FILELINE_LEN];
	int		i, idx = 0, nAliasIPNum = 0;

	memset(setCommand, 0x00, MAX_FILELINE_LEN);
	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(sServerIP, 0x00, MAX_DATA_LEN);
	memset(sWanIP, 0x00, MAX_DATA_LEN);
	
	websGetInterfaceIP(ADM_LAN_IF, 3, FALSE, sServerIP);
	websGetInterfaceIP(ADM_WAN_IF, 4, FALSE, sWanIP);
	for (i = 1; i <= NAT_MASQ_NUM; i++)
	{
		ifx_httpdWrite(wp, T("\t\t\t<tr  bgcolor=\"#ffffff\" align=center width=\"100%%\">\n"));
		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap>%d</td>\n"), i);
		ifx_httpdWrite(wp, T("\t\t\t\t<td><font color=\"#FFFFCC\" size=\"2\" face=\"Arial, Helvetica, sans-serif\">\n"));
		
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, "aliasIPCount", sValue) == 1)
		{
			nAliasIPNum = gatoi(sValue);
			memset(buf, 0x00, MAX_DATA_LEN);
			gsprintf(buf, T("MASQ_MIP%d"), i);

			ifx_httpdWrite(wp, T("\t\t\t\t\t<select name=\"%s\" size=\"1\">\n"), buf);

			if (nAliasIPNum == 0)
			{	
				ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\" selected>%s</option>\n"), sWanIP, sWanIP);
			}
			else
			if (nAliasIPNum > 0)
			{
				memset(sMapIP, 0x00, MAX_DATA_LEN);

				if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_ADDRMAP, buf, sMapIP) == 1)
				{}

				for (idx = 0; idx < nAliasIPNum; idx++)
				{
					char *pWantIp;
					memset(sValue, 0x00, MAX_FILELINE_LEN);
					memset(getCommand, 0x00, MAX_FILELINE_LEN);
					gsprintf(buf, T("%s%d"), PREFIX_ALIASIP, idx);
					if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, buf, getCommand) == 1)					
					{
						if ((pWantIp = strtok(getCommand, " ")) == NULL) 	// Didnot found string like "10.1.1.1 netmask 255.255.255.0"
							strcpy(sValue, getCommand);
						else
							strcpy(sValue, pWantIp);
						
						if ( !gstrcmp(sValue, sMapIP) )
						{
							ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\" selected>%s</option>\n"), sValue, sValue);
						}
						else
						{
							ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\">%s</option>\n"), sValue, sValue);
						}
					}
				}

				if ( !gstrcmp(sWanIP, sMapIP) )
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\" selected>%s</option>\n"), sWanIP, sWanIP);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\">%s</option>\n"), sWanIP, sWanIP);
				}
			}

			ifx_httpdWrite(wp, T("\t\t\t\t\t</select>\n"));
			ifx_httpdWrite(wp, T("\t\t\t\t</font></td>\n"));
		}

		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s\n"), sServerIP);

		memset(buf, 0x00, MAX_DATA_LEN);
		memset(sValue, 0x00, MAX_FILELINE_LEN);
		memset(getCommand, 0x00, MAX_FILELINE_LEN);
		
		gsprintf(buf, T("MASQ_STARTIP%d"), i);
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_ADDRMAP, buf, sValue) == 0)	
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"3\" name=\"%s\" size=\"3\" value=\"\">~\n"), buf);
		}
		else
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"3\" name=\"%s\" size=\"3\" value=\"%s\">~\n"), buf, sValue);
		}
		
		memset(buf, 0x00, MAX_DATA_LEN);
		memset(sValue, 0x00, MAX_FILELINE_LEN);
		memset(getCommand, 0x00, MAX_FILELINE_LEN);
		
		gsprintf(buf, T("MASQ_ENDIP%d"), i);
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_ADDRMAP, buf, sValue) == 0)				
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"3\" name=\"%s\" size=\"3\" value=\"\"></font></td>\n"), buf);
		}
		else
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"3\" name=\"%s\" size=\"3\" value=\"%s\"></font></td>\n"), buf, sValue);
		}

		memset(buf, 0x00, MAX_DATA_LEN);
   		memset(sValue, 0x00, MAX_FILELINE_LEN);
		
		gsprintf(buf, T("MASQ_F%d"), i);
		
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_ADDRMAP, buf, sValue) == 0)
		{
			ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap align=center><input type=\"checkbox\" name=\"%s\" value=\"1\"></td>\n"), buf);
		}
		else
		{
			if ( !gstrcmp(sValue, "1") )
			{
				ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap align=center><input type=\"checkbox\" name=\"%s\" value=\"1\"%s></td>\n"), buf, " CHECKED");
			}
			else
			if ( !gstrcmp(sValue, "0") )
			{
				ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap align=center><input type=\"checkbox\" name=\"%s\" value=\"1\"></td>\n"), buf);
			}	
		}

   		ifx_httpdWrite(wp, T("\t\t\t</tr>\n"));
	}

	return 0;
}



void ifx_set_nat_addrmap(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pMIP, *pStartIP, *pEndIP, *pEnable, *buffer;
	char_t	sAlias[MAX_DATA_LEN];
	char_t	sMIP[NAT_MASQ_NUM][MAX_FILELINE_LEN], sStartIP[NAT_MASQ_NUM][MAX_FILELINE_LEN];
	char_t	sEndIP[NAT_MASQ_NUM][MAX_FILELINE_LEN], sEnable[NAT_MASQ_NUM][MAX_FILELINE_LEN];
	char_t	sServerIP[MAX_DATA_LEN], buf[MAX_FILELINE_LEN];
	int		i;
	char_t	sWanIface[MAX_DATA_LEN];
	
	a_assert(wp);

	for (i = 0; i < NAT_MASQ_NUM; i++)
	{
		//Set MASQ_STARTIP# to rc.iptables.
		memset(sStartIP[i], 0x00, MAX_FILELINE_LEN);
		memset(buf, 0x00, MAX_FILELINE_LEN);

		gsprintf(buf, T("MASQ_STARTIP%d"), i+1);
		pStartIP	= ifx_httpdGetVar(wp, buf, T(""));

		if (pStartIP[0])
		{
			gsprintf(sStartIP[i], T("%s=\"%s\"\n"), buf, pStartIP);
		}
		else
		{
			gsprintf(sStartIP[i], T("%s=\"\"\n"), buf);
		}
		
		//Set MASQ_ENDIP# to rc.iptables.
		memset(sEndIP[i], 0x00, MAX_FILELINE_LEN);
		memset(buf, 0x00, MAX_FILELINE_LEN);

		gsprintf(buf, T("MASQ_ENDIP%d"), i+1);
		pEndIP	= ifx_httpdGetVar(wp, buf, T(""));

		if (pEndIP[0])
		{
			gsprintf(sEndIP[i], T("%s=\"%s\"\n"), buf, pEndIP);
		}
		else
		{
			gsprintf(sEndIP[i], T("%s=\"\"\n"), buf);
		}

		//Set MASQ_F# to rc.iptables.		
		memset(sEnable[i], 0x00, MAX_FILELINE_LEN);
		memset(buf, 0x00, MAX_FILELINE_LEN);

		gsprintf(buf, T("MASQ_F%d"), i+1);
		pEnable	= ifx_httpdGetVar(wp, buf, T(""));
		
		if (!gstrcmp(pEnable, "1"))
		{
			if ( (pStartIP && *pStartIP) && (pEndIP && *pEndIP) )
			{
				gsprintf(sEnable[i], T("%s=\"%s\"\n"), buf, pEnable);

				//Set MASQ_MIP# to rc.iptables.
				memset(sMIP[i], 0x00, MAX_DATA_LEN);
				memset(buf, 0x00, MAX_DATA_LEN);
		
				gsprintf(buf, T("MASQ_MIP%d"), i+1);
				if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, "aliasStatus", sAlias) == 1)
				{
					if ( !gstrcmp(sAlias, "Enable") ) 
					{
						pMIP	= ifx_httpdGetVar(wp, buf, T(""));
						gsprintf(sMIP[i], T("%s=\"%s\"\n"), buf, pMIP);
					}
					else
					{
						memset(sServerIP, 0x00, MAX_DATA_LEN);
				        memset(sWanIface, 0x00, MAX_DATA_LEN);						
				        websGetWanIface(sWanIface);			// Depends on current wan mode				
						websGetInterfaceIP(sWanIface, 4, FALSE, sServerIP);
						gsprintf(sMIP[i], T("%s=\"%s\"\n"), buf, sServerIP);
					}
				}
			}
			else
			{
				gsprintf(sEnable[i], T("%s=\"0\"\n"), buf);
			}
		}
		else
		{
			gsprintf(sEnable[i], T("%s=\"0\"\n"), buf);
			gsprintf(sMIP[i], T("MASQ_MIP%d=\"\"\n"), i+1);
		}
	}

	buffer = (char_t*)malloc(sizeof(char_t)*(BUF_SIZE_50K));
	gstrcpy (buffer, "");
	gsprintf(buf, T("MASQ_NUM=\"%d\"\n"), NAT_MASQ_NUM);
	gstrcat (buffer, buf);
	
	for (i = 0; i < NAT_MASQ_NUM; i++)
	{
		gstrcat(buffer, sStartIP[i]);
		gstrcat(buffer, sEndIP[i]);
		gstrcat(buffer, sEnable[i]);
		gstrcat(buffer, sMIP[i]);
	}

	websSetCfgData(FILE_RC_IPTABLES, TAG_NAT_ADDRMAP, 1, buffer);

	if (buffer && *buffer)
		free(buffer);
		
	//Runtime Change
	websChg2ExeMode(FILE_RC_IPTABLES);	
	system(SERVICE_NAT_RESTART);
	system(SERVICE_FIREWALL_RESTART);
	system(SERVICE_RESTORE);
	ifx_httpdNextPage(wp);
}
