/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

const int websGetPortNums(char_t* pData, ST_NAT_PORT_MAP_LIST *pstPortList)
{
	int	i, nReturn = -1, nStartPort, nEndPort;
	long	lPort;
	char_t	*pNextToken = pData;
	char_t	*pEnd;

    	i = 0;
    	while (*pNextToken)
    	{
		EATW(pNextToken);
		if (*pNextToken == 0)
		{
			break;
		}

		// Get port from string to long
		lPort = gstrtol(pNextToken, &pEnd, 10);
		if (*pNextToken && pNextToken == pEnd)
		{
			goto fault;     // Null
		}

		EATW(pEnd);
		
		if (*pEnd == ';' || *pEnd == ',' || *pEnd == 0)
		{
			nStartPort = lPort;
			nEndPort = lPort;
		}
		else
		if (*pEnd == '-')
		{
			// Check dash here
			nStartPort = lPort;

			// Get end port
			pNextToken = pEnd + 1;
			EATW(pNextToken);

			lPort = gstrtol(pNextToken, &pEnd, 10);

			if (*pNextToken && pNextToken == pEnd)
			{
				goto fault;     // Null
			}

			EATW(pEnd);

			nEndPort = lPort;
		}
		else
		{
			goto fault;
		}

		// Insert to list queue
		if (nStartPort > nEndPort || nStartPort < 1 || nEndPort > 65535)
		{
			goto fault;
		}

		if (i >= NAT_VS_CLONE_NUM)
		{
		    nReturn = -2;
		    goto fault;
		}

		gsprintf(pstPortList[i].sRetValue, T("%d:%d"), nStartPort, nEndPort);
		// Advanced to next clone index
		i++;
		
		// Continue for next port range
		if (*pEnd == 0)
		{
			break;
		}
		
		pNextToken = pEnd + 1;
		//EATW(pNextToken);
	} //end while(*pNextToken)

	return i;

fault:
	return nReturn;
}

int ifx_get_nat_portmap(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	buf[MAX_DATA_LEN], sAliasStatus[MAX_DATA_LEN], sMapIP[MAX_DATA_LEN];
	char_t	sValue[MAX_FILELINE_LEN], sServerIP[MAX_DATA_LEN], sWanIP[MAX_DATA_LEN];
	char_t	getCommand[MAX_FILELINE_LEN], setCommand[MAX_FILELINE_LEN];
	int		i, idx = 0, nAliasIPNum = 0,DATA=0;

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

	if ( !gstrcmp(name, T("natprotmap")) )
	{
	memset(setCommand, 0x00, MAX_FILELINE_LEN);
	memset(sServerIP, 0x00, MAX_DATA_LEN);
	memset(sWanIP, 0x00, MAX_DATA_LEN);
	
	websGetInterfaceIP(ADM_LAN_IF, 3, FALSE, sServerIP);
	websGetInterfaceIP(ADM_WAN_IF, 4, FALSE, sWanIP);		// Move from loop
	
	for (i = 1; i <= NAT_VS_LINK_NUM; i++)
	{
		ifx_httpdWrite(wp, T("\t\t\t<tr align=center bgcolor=\"#ffffff\">\n"));
		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%d</font></td>\n"), i);

		if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, "aliasStatus", sAliasStatus) == 1)
		{
			if ( !gstrcmp(sAliasStatus, "Enable") ) 
			{
				ifx_httpdWrite(wp, T("\t\t\t\t<td><font color=\"#FFFFCC\" size=\"2\" face=\"Arial, Helvetica, sans-serif\">\n"));
				
				if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, "aliasIPCount", sValue) == 1)
				{
					nAliasIPNum = gatoi(sValue);
					memset(buf, 0x00, MAX_DATA_LEN);
					gsprintf(buf, T("CLONE_MIP%d"), i);

					ifx_httpdWrite(wp, T("\t\t\t\t\t<select name=\"%s\" size=\"1\">\n"), buf);
					
					if (nAliasIPNum == 0)
					{
						ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\" selected>%s</option>\n"), sWanIP, sWanIP);
					}
					else
					if (nAliasIPNum > 0)
					{
						memset(sMapIP, 0x00, MAX_DATA_LEN);

						if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_PORTMAP, buf, sMapIP) == 1)
						{}

						for (idx = 0; idx < nAliasIPNum; idx++)
						{
							char *pWantIp;
							memset(sValue, 0x00, MAX_FILELINE_LEN);
							memset(getCommand, 0x00, MAX_FILELINE_LEN);
							gsprintf(buf, T("%s%d"), PREFIX_ALIASIP, idx);
							if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, buf, getCommand) == 1)					
							{
								if ((pWantIp = strtok(getCommand, " ")) == NULL) 	// Didnot found string like "10.1.1.1 netmask 255.255.255.0"
									strcpy(sValue, getCommand);
								else
									strcpy(sValue, pWantIp);
								
								if ( !gstrcmp(sValue, sMapIP) )
								{
									ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\" selected>%s</option>\n"), sValue, sValue);
								}
								else
								{
									ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\">%s</option>\n"), sValue, sValue);
								}
							}
						}

						if ( !gstrcmp(sWanIP, sMapIP) )
						{
							ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\" selected>%s</option>\n"), sWanIP, sWanIP);
						}
						else
						{
							ifx_httpdWrite(wp, T("\t\t\t\t\t\t<option value=\"%s\">%s</option>\n"), sWanIP, sWanIP);
						}
					}
					ifx_httpdWrite(wp, T("\t\t\t\t\t</select>\n"));
				}
	
				ifx_httpdWrite(wp, T("\t\t\t\t</td>\n"));
			}
		}

		memset(buf, 0x00, MAX_DATA_LEN);
   		memset(sValue, 0x00, MAX_FILELINE_LEN);
   		memset(getCommand, 0x00, MAX_FILELINE_LEN);

		gsprintf(buf, T("CLONE_IP%d"), i);
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_PORTMAP, buf, sValue) == 0)
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<td nowrap><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s\n"), sServerIP);
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"3\" name=\"%s\" size=\"3\" value=\"\"></font></td>\n"), buf);
		}
		else
		{
			// We only need the last IP field, ex: 192.168.1.3 -> 3
			char *token;
			int nIdx = 0;
			token = strtok(sValue, ".");
			while (token != NULL && nIdx < 3)
			{
				token = strtok(NULL, ".");
				nIdx++;
			}		
			strcpy(sValue, (const char_t*)token);
			
			ifx_httpdWrite(wp, T("\t\t\t\t\t<td nowrap><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s\n"), sServerIP);
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"3\" name=\"%s\" size=\"3\" value=\"%s\"></font></td>\n"), buf, sValue);
		}
		
		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">\n"));
		
		memset(buf, 0x00, MAX_DATA_LEN);
   		memset(sValue, 0x00, MAX_FILELINE_LEN);
		
		gsprintf(buf, T("CLONE_PORTS%d"), i);
		
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_PORTMAP, buf, sValue) == 0)
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"120\" name=\"%s\" size=\"50\" value=\"\"></font></td>\n"), buf);
		}
		else
		{
			if ( gstrcmp(sValue, "0") != 0 )
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"120\" name=\"%s\" size=\"50\" value=\"%s\"></font></td>\n"), buf, sValue);
			}
			else
			if ( !gstrcmp(sValue, "0") )
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input maxLength=\"120\" name=\"%s\" size=\"50\" value=\"\"></font></td>\n"), buf);
			}
		}

		ifx_httpdWrite(wp, T("\t\t\t\t<td nowrap> <font size=\"2\" face=\"Arial, Helvetica, sans-serif\">\n"));

		memset(buf, 0x00, MAX_DATA_LEN);
   		memset(sValue, 0x00, MAX_FILELINE_LEN);
		
		gsprintf(buf, T("CLONE_ENABLE%d"), i);
		
		if (ifx_GetCfgData(FILE_RC_IPTABLES, TAG_NAT_PORTMAP, buf, sValue) == 0)
		{
			ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"checkbox\" name=\"%s\" value=\"1\"></font></td>\n"), buf);
		}
		else
		{
			if ( !gstrcmp(sValue, "1") )
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"checkbox\" name=\"%s\" value=\"1\"%s></font></td>\n"), buf, " CHECKED");
			}
			else
			if ( !gstrcmp(sValue, "0") )
			{
				ifx_httpdWrite(wp, T("\t\t\t\t\t<input type=\"checkbox\" name=\"%s\" value=\"1\"%s></font></td>\n"), buf, "");
			}	
		}
		
		ifx_httpdWrite(wp, T("\t\t\t</tr>\n"));
	}
	}else
	if ( !gstrcmp(name, T("natprotmapTitleBar")) )
	{
		DATA = ifx_get_AliasStatus(eid,wp,argc,argv);
		if(DATA == 1)
			ifx_httpdWrite(wp, T("<th nowrap>Mapping IP</th>"));
	}

	return 0;
}




void ifx_set_nat_portmap(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pMIP, *pCloneIP, *pClonePort, *pCloneEnable, *buffer;
	char_t	sAlias[MAX_DATA_LEN];
	char_t	sServerIP[MAX_DATA_LEN], buf[MAX_FILELINE_LEN];
	char_t	sCloneIP[NAT_VS_LINK_NUM][MAX_FILELINE_LEN], sClonePort[NAT_VS_LINK_NUM][MAX_FILELINE_LEN];
	char_t	sMIP[NAT_VS_LINK_NUM][MAX_FILELINE_LEN], sCloneEnable[NAT_VS_LINK_NUM][MAX_FILELINE_LEN];
	char_t	sSerialPort[NAT_VS_CLONE_NUM][MAX_DATA_LEN], sPortsNum[NAT_VS_LINK_NUM][MAX_DATA_LEN];
	int		i, idx, nRetNum[NAT_VS_LINK_NUM];
	ST_NAT_PORT_MAP_LIST	stPortList[NAT_VS_CLONE_NUM];
	char_t	sWanIface[MAX_DATA_LEN];
	
	a_assert(wp);
	for (i = 0; i < NAT_VS_LINK_NUM; i++)
	{
		//Set CLONE_IP# to rc.iptables.
		memset(sCloneIP[i], 0x00, MAX_FILELINE_LEN);
		memset(buf, 0x00, MAX_FILELINE_LEN);

		gsprintf(buf, T("CLONE_IP%d"), i+1);
		pCloneIP	= ifx_httpdGetVar(wp, buf, T(""));

		if (pCloneIP[0])
		{
			memset(sServerIP, 0x00, MAX_DATA_LEN);			
			websGetInterfaceIP(ADM_LAN_IF, 3, FALSE, sServerIP);			
			gsprintf(sCloneIP[i], T("%s=\"%s%s\"\n"), buf, sServerIP, pCloneIP);
		}
		else
		{
			gsprintf(sCloneIP[i], T("%s=\"\"\n"), buf);
		}
		
		//Set CLONE_PORTS# to rc.iptables.
		memset(sClonePort[i], 0x00, MAX_FILELINE_LEN);
		memset(buf, 0x00, MAX_FILELINE_LEN);
		gsprintf(buf, T("CLONE_PORTS%d"), i+1);
		pClonePort	= ifx_httpdGetVar(wp, buf, T(""));

		if ( pClonePort[0])
		{
			gsprintf(sClonePort[i], T("%s=\"%s\"\n"), buf, pClonePort);
		}
		else
		{
			gsprintf(sClonePort[i], T("%s=\"0\"\n"), buf);
		}

		//Set CLONE_ENABLE# to rc.iptables.		
		memset(sCloneEnable[i], 0x00, MAX_FILELINE_LEN);
		memset(buf, 0x00, MAX_FILELINE_LEN);

		gsprintf(buf, T("CLONE_ENABLE%d"), i+1);
		pCloneEnable	= ifx_httpdGetVar(wp, buf, T(""));
		
		if (!gstrcmp(pCloneEnable, "1"))
		{
			if ( (pCloneIP && *pCloneIP) && (pClonePort && *pClonePort) )
			{
				gsprintf(sCloneEnable[i], T("%s=\"%s\"\n"), buf, pCloneEnable);
				
				//Set CLONE_MIP# to rc.iptables.
				memset(sMIP[i], 0x00, MAX_DATA_LEN);
				memset(buf, 0x00, MAX_DATA_LEN);
		
				gsprintf(buf, T("CLONE_MIP%d"), i+1);
				if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, "aliasStatus", sAlias) == 1)
				{
					if ( !gstrcmp(sAlias, "Enable") ) 
					{
						pMIP	= ifx_httpdGetVar(wp, buf, T(""));
						gsprintf(sMIP[i], T("%s=\"%s\"\n"), buf, pMIP);
					}
					else
					{
						memset(sServerIP, 0x00, MAX_DATA_LEN);
				        memset(sWanIface, 0x00, MAX_DATA_LEN);						
				        websGetWanIface(sWanIface);			// Depends on current wan mode
						websGetInterfaceIP(sWanIface, 4, FALSE, sServerIP);						
						gsprintf(sMIP[i], T("%s=\"%s\"\n"), buf, sServerIP);
					}
				}
				pMIP	= ifx_httpdGetVar(wp, buf, T(""));
			}
			else
			{
				gsprintf(sCloneEnable[i], T("%s=\"0\"\n"), buf);
			}
		}
		else
		{
			gsprintf(sCloneEnable[i], T("%s=\"0\"\n"), buf);
			gsprintf(sMIP[i], T("CLONE_MIP%d=\"\"\n"), i+1);
		}
	}
	
	buffer = (char_t*)malloc(sizeof(char_t)*(BUF_SIZE_50K));
	gstrcpy (buffer, "");
	gsprintf(buf, T("CLONE_NUM=\"%d\"\n"), NAT_VS_LINK_NUM);
	gstrcat (buffer, buf);
	
	for (i = 0; i < NAT_VS_LINK_NUM; i++)
	{
		gstrcat(buffer, sCloneIP[i]);
		gstrcat(buffer, sClonePort[i]);

		//Set CLONE_PORTS#_NUM to rc.iptables.
		for (idx = 0; idx < NAT_VS_CLONE_NUM; idx++)
		{
			stPortList[idx].nRangeIdx = 0;
			memset(stPortList[idx].sRetValue, 0x00, MAX_DATA_LEN);
		}

		nRetNum[i] = -1;
		memset(buf, 0x00, MAX_FILELINE_LEN);
		gsprintf(buf, T("CLONE_PORTS%d"), i+1);
		pClonePort	= ifx_httpdGetVar(wp, buf, T(""));
		
		nRetNum[i] = websGetPortNums(pClonePort, stPortList);
		memset(sPortsNum[i], 0x00, MAX_DATA_LEN);
		memset(buf, 0x00, MAX_FILELINE_LEN);

		if ( nRetNum[i] == -1)
		{
			//ifx_httpdError(wp, 204, T("Mapping port Input format error!"));
			gsprintf(sPortsNum[i], T("CLONE_PORTS%d_NUM=\"0\"\n"), i+1);
			gstrcat(buffer, sPortsNum[i]);
		}
		else
		if ( nRetNum[i] == -2)
		{
			//ifx_httpdError(wp, 204, T("Cannot not set more than %d sets of ports!"), NAT_VS_CLONE_NUM);
			gsprintf(sPortsNum[i], T("CLONE_PORTS%d_NUM=\"0\"\n"), i+1);
			gstrcat(buffer, sPortsNum[i]);
		}
		else
		if ( nRetNum[i] > 0)
		{
			gsprintf(sPortsNum[i], T("CLONE_PORTS%d_NUM=\"%d\"\n"), i+1, nRetNum[i]);
			gstrcat(buffer, sPortsNum[i]);

			for (idx = 0; idx < NAT_VS_CLONE_NUM; idx++)
			{
				memset(sSerialPort[idx], 0x00, MAX_DATA_LEN);
			}

			for (idx = 0; idx < nRetNum[i]; idx++)
			{
				memset(buf, 0x00, MAX_FILELINE_LEN);
				gsprintf(sSerialPort[idx], T("CLONE_PORTS%d_%d=\"%s\"\n"), i+1, idx+1, stPortList[idx].sRetValue);
				gstrcat(buffer, sSerialPort[idx]);
			}
		}

		gstrcat(buffer, sCloneEnable[i]);
		gstrcat(buffer, sMIP[i]);
	}

	websSetCfgData(FILE_RC_IPTABLES, TAG_NAT_PORTMAP, 1, buffer);
	
	if (buffer && *buffer)
		free(buffer);

	//Runtime Change
	websChg2ExeMode(FILE_RC_IPTABLES);	
	system(SERVICE_NAT_RESTART);
	system(SERVICE_FIREWALL_RESTART);
	system(SERVICE_RESTORE);
	ifx_httpdNextPage(wp);
}
