/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_extended_qos_setting(int eid, httpd_t wp, int argc, char_t **argv)
{
	 int 	i,nSelIdx;
        char_t  *name, sValue[MAX_FILELINE_LEN];

        if (ejArgs(argc, argv, T("%s"), &name) < 1)
        {
                ifx_httpdError(wp, 400, T("Insufficient args\n"));
                return -1;
        }

        memset(sValue, 0x00, MAX_FILELINE_LEN);
	if ( !gstrcmp(name, T("ExtendedQos8021priority")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "port_priority_vlan_802_1", sValue) == 1 )
              {
              	nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosYESNOMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosYESNOMode[i].str);
			}
		}
	}else
	if ( !gstrcmp(name, T("ExtendedQosmanagement")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "management", sValue) == 1 )
              {
              	nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosZero2SevenMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosZero2SevenMode[i].str);
			}
		}
	}else
	if ( !gstrcmp(name, T("ExtendedQosmgnvid")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", T("mgn_vid"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "mgn_vid is not found");
			return -1;	
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }else
	if ( !gstrcmp(name, T("ExtendedQosvoip")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "voip", sValue) == 1 )
              {
              	nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosZero2SevenMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosZero2SevenMode[i].str);
			}
		}
	}else
	if ( !gstrcmp(name, T("ExtendedQosvoipvid")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", T("voip_vid"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "voip_vid is not found");
			return -1;	
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }else
	if ( !gstrcmp(name, T("ExtendedQossignaling")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "signaling", sValue) == 1 )
              {
              	nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosZero2SevenMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosZero2SevenMode[i].str);
			}
		}
	}else
	if ( !gstrcmp(name, T("ExtendedQossglvid")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", T("sgl_vid"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "sgl_vid is not found");
			return -1;	
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }else
	if ( !gstrcmp(name, T("ExtendedQosdata")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "data", sValue) == 1 )
              {
              	nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosZero2SevenMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosZero2SevenMode[i].str);
			}
		}
	}else
	if ( !gstrcmp(name, T("ExtendedQosdatavid")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", T("data_vid"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "data_vid is not found");
			return -1;	
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }else
	if ( !gstrcmp(name, T("dtpriority")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, "dscp_tos_priority", "dt_priority", sValue) == 1 )
              {
              	nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_QosYESNOMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_QosYESNOMode[i].str);
			}
		}
	}else
	if ( !gstrcmp(name, T("dtmanagement")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "dscp_tos_priority", T("dt_management"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "dt_management is not found");
			return -1;	
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }else
	if ( !gstrcmp(name, T("dtvoip")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "dscp_tos_priority", T("dt_voip"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "dt_voip is not found");
			return -1;	
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }else
	if ( !gstrcmp(name, T("dtsignaling")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "dscp_tos_priority", T("dt_signaling"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "dt_signaling is not found");
			return -1;	
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }else
	if ( !gstrcmp(name, T("dtdata")) )
	 {		
	 	if (ifx_GetCfgData(FILE_RC_CONF, "dscp_tos_priority", T("dt_data"), sValue) == 0)
		{
			ifx_httpdError(wp, 200, "dt_data is not found");
			return -1;	
		}
		ifx_httpdWrite(wp, T("%s"), sValue);
	 }
	
	return 0;
	
}


void ifx_set_extended_qos_setting(httpd_t wp, char_t *path, char_t *query)
{
	char_t  *pExtendedQos8021priority,*pExtendedQosmanagement,*pExtendedQosmgnvid,*pExtendedQosvoip,*pExtendedQosvoipvid,*pExtendedQossignaling,*pExtendedQossglvid,
		     *pExtendedQosdata,*pExtendedQosdatavid,*pdtpriority,*pdtmanagement,*pdtvoip,*pdtsignaling,*pdtdata;
	
	char_t  sExtendedQos8021priority[MAX_DATA_LEN], sExtendedQosmanagement[MAX_DATA_LEN],sExtendedQosmgnvid[MAX_DATA_LEN],
		    sExtendedQosvoip[MAX_DATA_LEN],sExtendedQosvoipvid[MAX_DATA_LEN],sExtendedQossignaling[MAX_DATA_LEN],
		    sExtendedQossglvid[MAX_DATA_LEN],sExtendedQosdata[MAX_DATA_LEN],sExtendedQosdatavid[MAX_DATA_LEN],
		    sdtpriority[MAX_DATA_LEN],sdtmanagement[MAX_DATA_LEN],sdtvoip[MAX_DATA_LEN],
		    sdtsignaling[MAX_DATA_LEN],sdtdata[MAX_DATA_LEN];

	 // Set to rc.conf file
	 // 1
	pExtendedQos8021priority = ifx_httpdGetVar(wp, T("ExtendedQos8021priority"), T(""));
 	gsprintf(sExtendedQos8021priority, T("port_priority_vlan_802_1=\"%s\"\n"), pExtendedQos8021priority);
	

	 // 2
	 pExtendedQosmanagement = ifx_httpdGetVar(wp, T("ExtendedQosmanagement"), T(""));
	gsprintf(sExtendedQosmanagement, T("management=\"%s\"\n"), pExtendedQosmanagement);

	 // 3
	 pExtendedQosmgnvid = ifx_httpdGetVar(wp, T("ExtendedQosmgnvid"), T(""));
	gsprintf(sExtendedQosmgnvid, T("mgn_vid=\"%s\"\n"), pExtendedQosmgnvid);

	 // 4
	 pExtendedQosvoip = ifx_httpdGetVar(wp, T("ExtendedQosvoip"), T(""));	 
	gsprintf(sExtendedQosvoip, T("voip=\"%s\"\n"), pExtendedQosvoip);

	 // 5
	 pExtendedQosvoipvid = ifx_httpdGetVar(wp, T("ExtendedQosvoipvid"), T(""));
	gsprintf(sExtendedQosvoipvid, T("voip_vid=\"%s\"\n"), pExtendedQosvoipvid);

	 // 6
	 pExtendedQossignaling =  ifx_httpdGetVar(wp, T("ExtendedQossignaling"), T(""));
	gsprintf(sExtendedQossignaling, T("signaling=\"%s\"\n"), pExtendedQossignaling);

	//7
	 pExtendedQossglvid =  ifx_httpdGetVar(wp, T("ExtendedQossglvid"), T(""));
	gsprintf(sExtendedQossglvid, T("sgl_vid=\"%s\"\n"), pExtendedQossglvid);

	//8
	 pExtendedQosdata =  ifx_httpdGetVar(wp, T("ExtendedQosdata"), T(""));
	gsprintf(sExtendedQosdata, T("data=\"%s\"\n"), pExtendedQosdata);

	 // 9
	pExtendedQosdatavid =  ifx_httpdGetVar(wp, T("ExtendedQosdatavid"), T(""));
	gsprintf(sExtendedQosdatavid, T("data_vid=\"%s\"\n"), pExtendedQosdatavid);
	
	 // 10
	 pdtpriority =  ifx_httpdGetVar(wp, T("dtpriority"), T(""));
	 gsprintf(sdtpriority, T("dt_priority=\"%s\"\n"), pdtpriority);
	
	 // 11
	 pdtmanagement =  ifx_httpdGetVar(wp, T("dtmanagement"), T(""));
	 gsprintf(sdtmanagement, T("dt_management=\"%s\"\n"), pdtmanagement);
	
	 // 12
	 pdtvoip =  ifx_httpdGetVar(wp, T("dtvoip"), T(""));
	 gsprintf(sdtvoip, T("dt_voip=\"%s\"\n"), pdtvoip);
	 
	 // 13
	 pdtsignaling =  ifx_httpdGetVar(wp, T("dtsignaling"), T(""));
	 gsprintf(sdtsignaling, T("dt_signaling=\"%s\"\n"), pdtsignaling);

	 // 14
	 pdtdata =  ifx_httpdGetVar(wp, T("dtdata"), T(""));
	 gsprintf(sdtdata, T("dt_data=\"%s\"\n"), pdtdata);
	 
	websSetCfgData(FILE_RC_CONF, "extension_priority", 9, sExtendedQos8021priority,sExtendedQosmanagement,sExtendedQosmgnvid,sExtendedQosvoip,sExtendedQosvoipvid,sExtendedQossignaling,sExtendedQossglvid,sExtendedQosdata,sExtendedQosdatavid);
	websSetCfgData(FILE_RC_CONF, "dscp_tos_priority", 5, sdtpriority, sdtmanagement,sdtvoip,sdtsignaling,sdtdata);

	// save setting
	if (ifx_web_Save_Setting()<=0)
	{
  		ifx_httpdError(wp, 200, "Fail to save Setting");
		return;
	}
	system(SERVICE_QOS);
        ifx_httpdNextPage(wp);

}