/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

CGI_ENUMSEL_S web_Enum_RtListenMode [] =
{
    { 0, "Disabled"},
    { 1, "RIP1"},
    { 2, "Both(RIP1+RIP2)"},
    { 3, "RIP2"}
};

CGI_ENUMSEL_S web_Enum_RtSupplyMode [] =
{
    { 0, "Disabled"},
    { 1, "RIP1"},
    { 2, "RIP2"}
};

int ifx_get_route_dynamic(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name,*mode;
	char_t	sValue[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];
	int		i, nSelIdx = 0;

	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(command, 0x00, MAX_FILELINE_LEN);

	if ( !gstrcmp(name, T("wkMode")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_ROUTE_DYNAMIC, "RDYN_STATUS", sValue) == 1)
		{
			if ( !gstrcmp(sValue, "1") )	//Enable
			{
				gstrcpy(sValue, "1");
			}
			else							//Disable
			{
				gstrcpy(sValue, "0");
			}
		}
		//ejSetResult(eid, sValue);
		if(strncmp(sValue,"1",1) == 0 && strcmp(mode,"Enable") == 0){
			ifx_httpdWrite(wp,T("checked"));
		}else if(strncmp(sValue,"0",1) == 0 && strcmp(mode,"Disable") == 0){
			ifx_httpdWrite(wp,T("checked"));
		}
	}
	else
	if ( !gstrcmp(name, T("RtListenMode")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_ROUTE_DYNAMIC, "RDYN_RTLISTENMODE", sValue) == 1)
		{
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_RtListenMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_RtListenMode[i].str);
			}
		}
	}
	else
	if ( !gstrcmp(name, T("RtSupplyMode")) )
	{
		if (ifx_GetCfgData(FILE_RC_CONF, TAG_ROUTE_DYNAMIC, "RDYN_RTSUPPLYMODE", sValue) == 1)
		{
			nSelIdx = gatoi(sValue);
		
			for (i = 0; i < sizeof(web_Enum_RtSupplyMode)/sizeof(CGI_ENUMSEL_S); i++)
			{
				// Get Selected option index from rc.conf
				if (i == nSelIdx)
				{
					gstrcpy (sValue, " SELECTED");
				}
				else 
				{
					gstrcpy (sValue, "");
				}
				
				ifx_httpdWrite(wp, T("\t\t\t\t<option value=\"%d\"%s> %s </option>"), i, sValue, web_Enum_RtSupplyMode[i].str);
			}
		}
	}
	
	return 0;
}



void ifx_set_route_dynamic(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pWkMode, *pRtListenMode, *pRtSupplyMode;
	char_t	sWkMode[MAX_DATA_LEN], sRtListenMode[MAX_DATA_LEN], sRtSupplyMode[MAX_DATA_LEN];
	char_t	sSupplyMode[MAX_DATA_LEN], sListenMode[MAX_DATA_LEN];
	int		nSupItem = 0, nListenItem = 0;
	
	a_assert(wp);
	memset (sWkMode, 0x00, MAX_DATA_LEN);
	memset (sRtListenMode, 0x00, MAX_DATA_LEN);
	memset (sRtSupplyMode, 0x00, MAX_DATA_LEN);
	memset (sSupplyMode, 0x00, MAX_DATA_LEN);	//for send
	memset (sListenMode, 0x00, MAX_DATA_LEN);	//for receive
	
	pWkMode = ifx_httpdGetVar(wp, T("wkMode"), T(""));
	
	if ( !gstrcmp(pWkMode, "1") )	//Enable
	{
		gsprintf(sWkMode, T("RDYN_STATUS=\"%s\"\n"), pWkMode);

		pRtListenMode = ifx_httpdGetVar(wp, T("RtListenMode"), T(""));
		gsprintf(sRtListenMode, T("RDYN_RTLISTENMODE=\"%s\"\n"), pRtListenMode);
		
		nListenItem = gatoi(pRtListenMode);
		switch (nListenItem)
		{
			case 0:
				gsprintf(sListenMode, T("#ip rip receive version 1 2\n"));
				break;
			case 1:
				gsprintf(sListenMode, T("ip rip receive version 1\n"));
				break;
			case 2:
				gsprintf(sListenMode, T("ip rip receive version 1 2\n"));
				break;
                        case 3:
                                gsprintf(sListenMode, T("ip rip receive version 2\n"));
                                break;
			default:
				gsprintf(sListenMode, T("#ip rip receive version 1 2\n"));
				break;
		}
	
		pRtSupplyMode = ifx_httpdGetVar(wp, T("RtSupplyMode"), T(""));
		gsprintf(sRtSupplyMode, T("RDYN_RTSUPPLYMODE=\"%s\"\n"), pRtSupplyMode);
		
		nSupItem = gatoi(pRtSupplyMode);
		switch (nSupItem)
		{
			case 0:
				gsprintf(sSupplyMode, T("#ip rip send version 1 2\n"));
				break;
			case 1:
			case 2:
				gsprintf(sSupplyMode, T("ip rip send version %d\n"), nSupItem);
				break;
			default:
				gsprintf(sSupplyMode, T("#ip rip send version 1 2\n"));
				break;
		}

		websSetCfgData(FILE_RC_CONF, TAG_ROUTE_DYNAMIC, 3, sWkMode, sRtListenMode, sRtSupplyMode);
		websSetCfgData(FILE_RIPD_CONF, TAG_ROUTE_DYNAMIC_WAN, 2, sSupplyMode, sListenMode);
		websSetCfgData(FILE_RIPD_CONF, TAG_ROUTE_DYNAMIC_LAN, 2, sSupplyMode, sListenMode);

		//Runtime Change
		if (nSupItem == 0&& nListenItem == 0)
		{
			system(SERVICE_RIPD_STOP);
		}
		else
		{
		system(SERVICE_RIPD_STOP);
		system(SERVICE_RIPD_START);
	        }
	}
	else
	if ( !gstrcmp(pWkMode, "0") )	//Disable
	{
		gsprintf(sWkMode, T("RDYN_STATUS=\"0\"\n"));
		gsprintf(sRtListenMode, T("RDYN_RTLISTENMODE=\"0\"\n"));
		gsprintf(sRtSupplyMode, T("RDYN_RTSUPPLYMODE=\"0\"\n"));

		gsprintf(sSupplyMode, T("#ip rip send version 1 2\n"));
		gsprintf(sListenMode, T("#ip rip receive version 1 2\n"));

		websSetCfgData(FILE_RC_CONF, TAG_ROUTE_DYNAMIC, 3, sWkMode, sRtListenMode, sRtSupplyMode);
		websSetCfgData(FILE_RIPD_CONF, TAG_ROUTE_DYNAMIC_WAN, 2, sSupplyMode, sListenMode);
		websSetCfgData(FILE_RIPD_CONF, TAG_ROUTE_DYNAMIC_LAN, 2, sSupplyMode, sListenMode);

		//Runtime Change
		system(SERVICE_RIPD_STOP);
	}

	system(SERVICE_RESTORE);

	ifx_httpdNextPage(wp);
}