/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_route_table(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sValue[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];
	FILE	*fd;
	int		i, nLine = 0;
	char *ptr_temp = NULL;

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
	memset(command, 0x00, MAX_FILELINE_LEN);

	gsprintf(command, T("netstat -rne > %s"), FILE_ROUTE_TMP);
	system(command);

	if( (fd = fopen( FILE_ROUTE_TMP, "r" )) != NULL )
	{
		while( fgets( sValue, MAX_FILELINE_LEN, fd ) != NULL)
		{
			nLine++;
		}
		fclose( fd );
		gremove(FILE_ROUTE_TMP);		
	}

	for(i = 3; i <= nLine; i++)
	{
		ifx_httpdWrite(wp, T("\t\t<tr align=\"left\" bgcolor=\"#ffffff\">\n")); 

		//Destination IP
		memset(sValue, 0x00, MAX_FILELINE_LEN);
		memset(command, 0x00, MAX_FILELINE_LEN);

		gsprintf(command, T("netstat -rne | awk '{ print $1 }'"));

		if (ifx_GetCfgData((char_t*)command, NULL, ptr_temp = stritoa(i, NULL, 0), sValue) == 1)
		{
			ifx_httpdWrite(wp, T("\t\t\t<td width=\"20%\">%s</td>\n"), sValue);			
			if (ptr_temp)
				free(ptr_temp);
		}

		//Subnet Mask
		memset(sValue, 0x00, MAX_FILELINE_LEN);
		memset(command, 0x00, MAX_FILELINE_LEN);

		gsprintf(command, T("netstat -rne | awk '{ print $3 }'"));
		if (ifx_GetCfgData((char_t*)command, NULL, ptr_temp = stritoa(i, NULL, 0), sValue) == 1)
		{
			ifx_httpdWrite(wp, T("\t\t\t<td width=\"20%\">%s</td>\n"), sValue);
			if (ptr_temp)
				free(ptr_temp);
		}

		//Gateway
		memset(sValue, 0x00, MAX_FILELINE_LEN);
		memset(command, 0x00, MAX_FILELINE_LEN);

		gsprintf(command, T("netstat -rne | awk '{ print $2 }'"));
		if (ifx_GetCfgData((char_t*)command, NULL, ptr_temp = stritoa(i, NULL, 0), sValue) == 1)
		{
			ifx_httpdWrite(wp, T("\t\t\t<td width=\"20%\">%s</td>\n"), sValue);
			if (ptr_temp)
				free(ptr_temp);
		}

		//Metric
		memset(sValue, 0x00, MAX_FILELINE_LEN);
		memset(command, 0x00, MAX_FILELINE_LEN);

		gsprintf(command, T("netstat -rne | awk '{ print $5 }'"));
		if (ifx_GetCfgData((char_t*)command, NULL, ptr_temp = stritoa(i, NULL, 0), sValue) == 1)
		{
			ifx_httpdWrite(wp, T("\t\t\t<td width=\"20%\">%s</td>\n"), sValue);
			if (ptr_temp)
				free(ptr_temp);
		}

		//Interface
		memset(sValue, 0x00, MAX_FILELINE_LEN);
		memset(command, 0x00, MAX_FILELINE_LEN);

		gsprintf(command, T("netstat -rne | awk '{ print $8 }'"));
		if (ifx_GetCfgData((char_t*)command, NULL, ptr_temp = stritoa(i, NULL, 0), sValue) == 1)
		{
			ifx_httpdWrite(wp, T("\t\t\t<td width=\"20%\">%s</td>\n"), sValue);
			if (ptr_temp)
				free(ptr_temp);
		}

		ifx_httpdWrite(wp, T("\t\t</tr>\n"));
	}	
	return 0;
}