/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

CGI_TABLE_S StaticRouteTable[APPS_NUM_OF_STATIC_ROUTE_ENTRY];


//route_static.asp
int ifx_get_route_static(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t  sValue[MAX_DATA_LEN], sCommand[MAX_DATA_LEN];
	char_t  sIP[MAX_DATA_LEN], sNetmask[MAX_DATA_LEN], sGateway[MAX_DATA_LEN];
	int     nCount, nIndex;
	char_t *args;

	//printf("inside func ifx_get_route_static\n");
	memset(sValue, 0x00, MAX_DATA_LEN);
	memset(sCommand, 0x00, MAX_DATA_LEN);
	memset(sIP, 0x00, MAX_DATA_LEN);
	memset(sNetmask, 0x00, MAX_DATA_LEN);
	memset(sGateway, 0x00, MAX_DATA_LEN);

	if(ejArgs(argc, argv, T("%s"),&args) < 1){
		printf("Not able to use ejArgs\n");
	}else{
		printf("args is %s\n",args);
	}

	gsprintf(sCommand, T("%sCount"), PREFIX_STATICROUTE);
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC_ALIAS, sCommand, sValue) == 0)
	{
		ifx_httpdError(wp, 200, T("%s not found"), sCommand);
		return -1;
	}
	
	nCount = gatoi(sValue);
	for (nIndex=0; nIndex < nCount; nIndex++)
	{
		// Get Netmask
		memset(sCommand, 0x00, MAX_DATA_LEN);
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f3 -d\" \""), PREFIX_STATICROUTE, nIndex, FILE_RC_CONF);
		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sNetmask) == 0)
		{
			ifx_httpdError(wp, 200, "Netmask not found");
			return -1;
		}

		// Get Gateway
		memset(sCommand, 0x00, MAX_DATA_LEN);		
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f5 -d\" \""), PREFIX_STATICROUTE, nIndex, FILE_RC_CONF);

		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sGateway) == 0)
		{
			ifx_httpdError(wp, 200, "Netmask not found");
			return -1;
		}

		// Get Destination IP
		memset(sCommand, 0x00, MAX_DATA_LEN);
		gsprintf(sCommand, T("grep ^%s%d %s | cut -f2 -d'\"' | cut -f1 -d\" \""), PREFIX_STATICROUTE, nIndex, FILE_RC_CONF);

		if ( ifx_GetCfgData((char_t*)sCommand, NULL, "1", sIP) == 0)
		{
			ifx_httpdError(wp, 200, T("Destination IP not found"));
			return -1;
		}		

		ifx_httpdWrite(wp, T("<tr align=\"center\" bgcolor=\"#ffffff\">\n"));
		ifx_httpdWrite(wp, T("<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"),sIP);
                ifx_httpdWrite(wp, T("<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"),sNetmask);
                ifx_httpdWrite(wp, T("<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">%s</font></td>\n"),sGateway);
		ifx_httpdWrite(wp, T("<td><input type=\"button\" value=\"Delete\" onClick=\"staticdel('%d');\"></td>\n"), nIndex);
		ifx_httpdWrite(wp, T("</tr>"));
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////////////////
// route_static.asp
//
void ifx_set_route_static(httpd_t wp, char_t *path, char_t *query)
{
	// Update Alias IP here
	char_t	*pAdd = ifx_httpdGetVar(wp, T("staticAdd"), T(""));
	char_t	*pDel = ifx_httpdGetVar(wp, T("delflag"), T(""));
	char_t 	sCommand[MAX_FILELINE_LEN];	
	int nIndex = 0, nCurNum = 0;
	char_t sBuf[BUF_SIZE_1K];

	// Get original data from file
	nCurNum = websSetData2Table(wp, FILE_RC_CONF, TAG_ROUTE_STATIC, PREFIX_STATICROUTE, StaticRouteTable);
	if (nCurNum == -1)
	{
		ifx_httpdError(wp, 200, "Insufficient data for static routing table");
		return;
	}
	
	// Submit data from press "Add" button
	if (pAdd[0])
	{
		char_t	*pAIP1 = ifx_httpdGetVar(wp, T("AIP1"), T(""));
		char_t	*pAIP2 = ifx_httpdGetVar(wp, T("AIP2"), T(""));
		char_t	*pAIP3 = ifx_httpdGetVar(wp, T("AIP3"), T(""));
		char_t	*pAIP4 = ifx_httpdGetVar(wp, T("AIP4"), T(""));
		char_t	*pANM1 = ifx_httpdGetVar(wp, T("ANM1"), T(""));
		char_t	*pANM2 = ifx_httpdGetVar(wp, T("ANM2"), T(""));
		char_t	*pANM3 = ifx_httpdGetVar(wp, T("ANM3"), T(""));
		char_t	*pANM4 = ifx_httpdGetVar(wp, T("ANM4"), T(""));
		char_t	*pAGW1 = ifx_httpdGetVar(wp, T("AGW1"), T(""));
		char_t	*pAGW2 = ifx_httpdGetVar(wp, T("AGW2"), T(""));
		char_t	*pAGW3 = ifx_httpdGetVar(wp, T("AGW3"), T(""));
		char_t	*pAGW4 = ifx_httpdGetVar(wp, T("AGW4"), T(""));
		
		char_t	sAddEntry[MAX_FILELINE_LEN];

		if ( pAIP1 == 0 || gatoi(pAIP1) > 255 || pAIP2 == 0 || gatoi(pAIP2) > 255 ||
		    pAIP3 == 0 || gatoi(pAIP3) > 255 || pAIP4 == 0 || gatoi(pAIP4) > 255)
		{
			    ifx_httpdError(wp, 200, "Invalidate IP address"); 
			    return;
		}

		if ( pANM1 == 0 || gatoi(pANM1) > 255 || pANM2 == 0 || gatoi(pANM2) > 255 ||
		    pANM3 == 0 || gatoi(pANM3) > 255 || pANM4 == 0 || gatoi(pANM4) > 255)
		{
		    ifx_httpdError(wp, 200, "Invalidate Netmask IP address"); 
		    return;
		}
		
		if ( pAGW1 == 0 || gatoi(pAGW1) > 255 || pAGW2 == 0 || gatoi(pAGW2) > 255 ||
		    pAGW3 == 0 || gatoi(pAGW3) > 255 || pAGW4 == 0 || gatoi(pAGW4) > 255)
		{
		    ifx_httpdError(wp, 200, "Invalidate Gateway IP address"); 
		    return;
		}
		
		gsprintf(sAddEntry, T("%s.%s.%s.%s netmask %s.%s.%s.%s gw %s.%s.%s.%s"),
							pAIP1, pAIP2, pAIP3, pAIP4,
							pANM1, pANM2, pANM3, pANM4, 
							pAGW1, pAGW2, pAGW3, pAGW4 );

		// Update table and system
		for (nIndex=0; nIndex<=nCurNum; nIndex++)
		{
			// 1st, check duplicated
			// 2nd, check empty space
			// 3rd, Add to latest entry
			if (gstrncmp(StaticRouteTable[nIndex].Data.sValue, sAddEntry, sizeof(sAddEntry)) == 0)
			{
				ifx_httpdError(wp, 200, "Duplicate static routing entry");
				return;
			}

			if (StaticRouteTable[nIndex].nIndex == 0 && !StaticRouteTable[nIndex].Data.sValue[0])
			{
				// Confirm system command OK then set to Table
				// Update system
				FILE    *fd;
				gsprintf(sCommand, T("route add -net %s dev %s 2>&1"), sAddEntry, ADM_WAN_IF);
				if ((fd = popen(sCommand, "r")) != NULL)
				{
					char buf[1024]; 
					int  nRead = 0; 
					while( !feof(fd) )
					{               
						memset(buf, '\0', 1024);				
					   	nRead = fread(buf, sizeof(char), 1024, fd);
					}               
					                
					if(nRead)       
					{
						ifx_httpdError(wp, 200, T("The gateway IP is not reachable."));
						return;							
					}
					else	//success
					{
						StaticRouteTable[nIndex].nIndex = nIndex;
						gstrcpy(StaticRouteTable[nIndex].Data.sValue, sAddEntry);						
						nCurNum = nIndex+1;
					}
				}	
				
				if (fd)	pclose(fd);				
				break;
			}
		}

		// No more space to add data
		if (nIndex > APPS_NUM_OF_STATIC_ROUTE_ENTRY)	
		{
			ifx_httpdError(wp, 200, T("Out of space to add static routing entry"));
			return;
		}

		////////// Update Table to File ///////////////
		memset(sBuf, 0, BUF_SIZE_1K);
		gsprintf(sBuf, T("%sCount=\"%d\"\n"), PREFIX_STATICROUTE, nCurNum);			
		
		for (nIndex=0; nIndex<nCurNum; nIndex++)
		{	
			char_t sLine[MAX_FILELINE_LEN];
			gsprintf(sLine, T("%s%d=\"%s\"\n"), PREFIX_STATICROUTE, nIndex, StaticRouteTable[nIndex].Data.sValue);
			gstrcat(sBuf, sLine);
		}

		websSetCfgData(FILE_RC_CONF, TAG_ROUTE_STATIC, 1, sBuf);
	}

	// Submit data from press delete button
	if (!gstrcmp(pDel, T("1")))
	{
		char_t	*pDelIndex = ifx_httpdGetVar(wp, T("delindex"), T(""));
		int		nDelIndex = gatoi(pDelIndex);

		// Update system
		gsprintf(sCommand, T("route del -net %s dev %s"), StaticRouteTable[nDelIndex].Data.sValue, ADM_WAN_IF);
		system(sCommand);		

		// Remove DelIndex from Table
		for (nIndex=0; nIndex<nCurNum; nIndex++)
		{
			if (nIndex >= nDelIndex)
			{	
				StaticRouteTable[nIndex].nIndex = StaticRouteTable[nIndex+1].nIndex;
				gstrcpy(StaticRouteTable[nIndex].Data.sValue, StaticRouteTable[nIndex+1].Data.sValue);
			}
		}

		////////// Update Table to File ///////////////
		memset(sBuf, 0, BUF_SIZE_1K);
		gsprintf(sBuf, T("%sCount=\"%d\"\n"), PREFIX_STATICROUTE,  nCurNum-1);

		for (nIndex=0; nIndex<nCurNum; nIndex++)
		{	
			char_t sLine[MAX_DATA_LEN];
			gsprintf(sLine, T("%s%d=\"%s\"\n"), PREFIX_STATICROUTE, nIndex, StaticRouteTable[nIndex].Data.sValue);		
			gstrcat(sBuf, sLine);

			// Update system
			gsprintf(sCommand, T("route add -net %s dev %s"), StaticRouteTable[nIndex].Data.sValue, ADM_WAN_IF);
			system(sCommand);
		}			

		websSetCfgData(FILE_RC_CONF, TAG_ROUTE_STATIC, 1, sBuf);
	}

	// Runtime update               
	// Move to update file          
	system(SERVICE_NAT_RESTART);
        system(SERVICE_FIREWALL_RESTART);
	system(SERVICE_RESTORE);     
                                    
	ifx_httpdNextPage(wp);
}
