/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"
#include 	"ifx_httpd_method.h"


#include "ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

extern int web_image_length;

void ifx_set_system_upgrade(httpd_t wp, char_t *path, char_t *query)
{
	int     locWrite;               
    int     nLeft;
    unsigned int nWrite;                 
    int     nRet;                   
	int 	fh=0;
	unsigned int iBufOff = 0, uiCurAddr = 0; 
	int		j = 0;
  	pid_t pid;
	char wbuf[FLASH_BlOCK_SIZE];
	FILE *fp;
	
	ifx_debug_printf("-------ifx_set_system_upgrade--------\n");	
	
       
    locWrite = 0;        
	
	nLeft =  web_image_length;
	fp=fopen("/tmp/web_image","rb");

    fh = open(FILE_IMAGE_KERNEL, O_RDWR|O_BINARY);
    if ( fh == -1 )                 
    {                               
		ifx_httpdError(wp, 200, T("Cannot open %s file"), FILE_IMAGE_KERNEL);
		close(fh);                  
		return;                     
    }                              
    else                            
    {
//		 ifx_debug_printf("Erase Flash data");
    		// Erase Flash data                         
 //   		ioctl(fh, RAWDRV_IOCRSFLASH, NULL);    	
    	
		uiCurAddr =  KEL_BASEADDR;  
		nWrite    =  FLASH_BlOCK_SIZE;
		// Reset rawaccess device
  		ioctl(fh, RAWDRV_IOCRSRAWDEV, NULL);	           

		while (nLeft > 0)           
		{	
			if(nLeft > FLASH_BlOCK_SIZE){
				fread(wbuf,sizeof(char),FLASH_BlOCK_SIZE,fp);
				}
			else{
				fread(wbuf,sizeof(char),nLeft,fp);
				}

    			iBufOff = nWrite*j;    		
			ioctl(fh, RAWDRV_IOCSRAWACSADDR, &uiCurAddr);
    			uiCurAddr += nWrite; //raw access addr			

			if (nWrite > nLeft) 	nWrite = nLeft;
				
			nRet = write(fh, &wbuf+iBufOff, nWrite);
			if (nRet != nWrite)      
			{ 
				ifx_httpdError(wp, 200, T("Error."));
				close(fh);          
				return;			    
			}                       
			locWrite += nWrite;     
		 	nLeft 	 -= nWrite;
		 	j++;  
	 	}
	 	
	 	ioctl(fh, RAWDRV_IOCRSRAWDEV, NULL);
		close(fh);       
		fclose(fp);
		reboot(RB_AUTOBOOT);
#if 0 //p
		if (nLeft == 0)
		{
			// Display update result
	   		ifx_httpdRedirect(wp, "upgrade_firm_return.htm");

			if ((pid = fork()) == 0)
			{
				reboot(RB_AUTOBOOT);
	    		_exit(0);
	    	}

	    	waitpid (pid, NULL, 0);
		}
		else
		{			
			ifx_httpdError(wp, 200, T("Error"));
			return;
		}   
#endif 		
    }
}
