/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	<netinet/in.h>
#include	<net/if.h>
#include	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_RuntimeWanIP(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t sValue[MAX_DATA_LEN];	
	int	nWanMode = websGetWanMode();

    	switch (nWanMode)
    	{
    		case IP_BOOT_DHCPC:
    		case IP_BOOT_FIXED:
	    websGetInterfaceIP(ADM_WAN_IF, 4, FALSE, sValue);
        	break;

    		case IP_BOOT_PPPOE:
    		case IP_BOOT_PPTP:
	    		websGetInterfaceIP(ADM_PPP_IF, 4, FALSE, sValue);
        	break;
    
    		default:
	    		//ifx_httpdError(wp, 200, T("Invalidate connection type to get WanIP"));	
			gstrcpy(sValue,"");
        	break;
    	}

	// IP Address not found, might in 	ing status
	if (!gstrcmp(sValue, ""))
	{
		gstrcpy(sValue, "0.0.0.0");
	}
	
	ifx_httpdWrite(wp, T("%s"), sValue);
	return 0 ;
}

int ifx_get_RuntimeWanMask(int eid, httpd_t wp, int argc, char_t **argv)
{    
	char_t sValue[MAX_DATA_LEN];	
	int		nWanMode = websGetWanMode();

    	switch (nWanMode)
    	{
    	case IP_BOOT_DHCPC:
    	case IP_BOOT_FIXED:
	    websGetNetmask(ADM_WAN_IF, 4, FALSE, sValue);
        	break;

    	case IP_BOOT_PPPOE:
    	case IP_BOOT_PPTP:
	    websGetNetmask(ADM_PPP_IF, 4, FALSE, sValue);
        	break;
    
    	default:
	    //ifx_httpdError(wp, 200, T("Invalidate connection type to get WanMask"));	
	    strcpy(sValue,"");
            break;
    }

	// IP Address not found, might in connecting status
	if (!gstrcmp(sValue, ""))
	{
		gstrcpy(sValue, "0.0.0.0");
	}
	
	ifx_httpdWrite(wp, T("%s"), sValue);
	return 0;

	
}

int ifx_get_RuntimeGatewayIP(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t sGateway[MAX_DATA_LEN];
	char_t sInterface[MAX_DATA_LEN];
	int	nWanMode = websGetWanMode();
	
	if (nWanMode == IP_BOOT_PPPOE || nWanMode == IP_BOOT_PPTP)
	{
		memset(sInterface, 0x00, MAX_DATA_LEN);
		gsprintf(sGateway, "ifconfig %s | grep \"P-t-P:\" | cut -f3 -d':' | cut -f1 -d' '", sInterface);
		gsprintf(sInterface, "%s", sGateway);
		memset(sGateway, 0x00, MAX_DATA_LEN);
		ifx_GetCfgData((char_t*)sInterface, NULL, "1", sGateway);
	}
	else
	{
		memset(sGateway, 0x00, MAX_DATA_LEN);
		websGetGateway(4, FALSE, sGateway);
	}

	if (sGateway[0])
		ifx_httpdWrite(wp, T("%s"), sGateway);
	else
		ifx_httpdWrite(wp, T("0.0.0.0"));
	
	return 0 ;
}

int ifx_get_RuntimeDNS1IP(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sValue[MAX_DATA_LEN];
	
	websGetDNS(1, 4, FALSE, sValue);
		
	if (sValue && *sValue)
		ifx_httpdWrite(wp, T("%s"), sValue);
	else
		ifx_httpdWrite(wp, T("0.0.0.0"));	

	return 0 ;
}

int	ifx_get_RuntimeDNS2IP(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	sValue[MAX_DATA_LEN];
	
	websGetDNS(2, 4, FALSE, sValue);
	
	if (sValue && *sValue)
		ifx_httpdWrite(wp, T("%s"), sValue);
	else
		ifx_httpdWrite(wp, T("0.0.0.0"));

	return 0 ;
}
int	ifx_get_LanIP(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t sLanIP[MAX_DATA_LEN];
	
	    websGetInterfaceIP(ADM_LAN_IF, 4, FALSE, sLanIP);
		
	ifx_httpdWrite(wp, sLanIP);
	return 0;
}

int	ifx_get_LanMask(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t sValue[MAX_DATA_LEN];
	    websGetNetmask(ADM_LAN_IF, 4, FALSE, sValue);
    	ifx_httpdWrite(wp, sValue);
    
	return 0 ;

}

int	ifx_get_DhcpClientNum(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t sCommand[MAX_DATA_LEN];
	char_t sValue[MAX_DATA_LEN];

	// "dumpleases" can list all DHCP Client information and all line content "seconds" text	
	// We use "grep -c" to count line, each line means one client
	
	gsprintf(sCommand, "dumpleases | grep -c seconds");
	if (ifx_GetCfgData((char_t*)sCommand, NULL, "1", sValue) == 0)
	{
		ifx_httpdError(wp, 500, "dumpleases command not found");		
		return -1;
	}
	ifx_httpdWrite(wp, sValue);
	return 0;	
}


int	ifx_get_LanMacaddr(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t sCommand[MAX_DATA_LEN];
	char_t sValue[MAX_DATA_LEN];

	gsprintf(sCommand, "ifconfig %s | grep \"HWaddr\" | awk '{ print $5 }'", ADM_LAN_IF);
	if (ifx_GetCfgData((char_t*)sCommand, NULL, "1", sValue) == 0)
	{
		ifx_httpdError(wp, 500, "uname command not found");
		return -1;
	}
	ifx_httpdWrite(wp, sValue);
	return 0;
}

int	ifx_get_RuntimeWanMac(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t sCommand[MAX_DATA_LEN];
	char_t sValue[MAX_DATA_LEN];

	gsprintf(sCommand, "ifconfig %s | grep \"HWaddr\" | cut -f11 -d\" \"", ADM_WAN_IF);
	if (ifx_GetCfgData((char_t*)sCommand, NULL, "1", sValue) == 0)
	{
		ifx_httpdError(wp, 500, "uname command not found");
		return -1;
	}
	ifx_httpdWrite(wp, sValue);
	return 0;
}



int	ifx_get_Hardwareversion(int eid, httpd_t wp, int argc, char_t **argv)
{
	ifx_httpdWrite(wp, HARDWARE_VER);
	return 0;
}

int	ifx_get_ConnectingStatus(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t sCommand[MAX_DATA_LEN];	
	char_t sInterface[MAX_DATA_LEN];
	
	int	nWanMode = websGetWanMode();

        switch (nWanMode)
    	{
    case IP_BOOT_FIXED:	    
        //ejSetResult(eid, "0");
    	return 0;   // skip         
        
    		case IP_BOOT_DHCPC:
	    		gstrcpy(sInterface, ADM_WAN_IF);
        	break;

    		case IP_BOOT_PPPOE:
    		case IP_BOOT_PPTP:
	    		gstrcpy(sInterface, ADM_PPP_IF);
        	break;
    
    		default:
        		//ejSetResult(eid, "0");
        		//ifx_httpdWrite(wp,"checked");
    			return 0;   // skip 
		break;
    	}

	gsprintf(sCommand, "ifconfig %s | grep \"inet addr:\" | cut -f2 -d':' | cut -f1 -d' '", sInterface);
	if (ifx_GetCfgData((char_t*)sCommand, NULL, "1", sInterface) == 1)
		return 1;//ifx_httpdWrite(wp,"checked");
	else
		return 0;//ifx_httpdWrite(wp,"checked");

	return 0;
}

int ifx_get_ConnectType(int eid, httpd_t wp, int argc, char_t **argv)
{
	int wanMode;
	
	wanMode = websGetWanMode();

	if(wanMode == IP_BOOT_DHCPC)
		ifx_httpdWrite(wp, T("DHCPC"));
	else if(wanMode ==IP_BOOT_FIXED)
		ifx_httpdWrite(wp, T("FIXED"));
	else if(wanMode ==IP_BOOT_PPPOE)
		ifx_httpdWrite(wp, T("PPPOE"));
	else if (wanMode ==IP_BOOT_PPTP)
		ifx_httpdWrite(wp, T("PPTP"));		
	else
		ifx_httpdWrite(wp, T("UNKNOW"));
	return 0;		

}

int ifx_get_ConnectTypeFunction(int eid, httpd_t wp, int argc, char_t **argv)
{
	int wanMode;
	int APMode;
	char_t	sValue[MAX_DATA_LEN];
       memset(sValue, 0x00, MAX_DATA_LEN); 

       //CHECK IF AP Client Mode
       if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, "WLAN_CURRENT_MODE", sValue) == 1 )
	{
           if ( !gstrcmp(sValue, "0") )
	      APMode=0; //ap
	    else  if ( !gstrcmp(sValue, "1") )
		APMode=1; //client
	    else  if ( !gstrcmp(sValue, "2") )
		APMode=2;  //wds 
	    
	}

	if (APMode!=1) 
	{
       	wanMode = websGetWanMode();
	  	if (wanMode == IP_BOOT_DHCPC)		
			ifx_httpdWrite(wp,T("			<td class=textCell><input type=\"button\" value=\"Release\" name=\"rlease\" onClick=\"suspend();\"></td>		  	<td class=textCell><input type=\"button\" value=\"Renew\" name=\"rnew\" onClick=\"resume();\"></td>		  	  "));
		else if (wanMode == IP_BOOT_PPPOE/* || wanMode == IP_BOOT_PPPOA*/)
			ifx_httpdWrite(wp,T("		  	  			<td class=textCell><input type=\"button\" value=\"Disconnect\" name=\"disconnect\" onClick=\"suspend();\"></td>			<td class=textCell><input type=\"button\" value=\"Connect\" name=\"connect\" onClick=\"resume();\"></td>			  "));
		else
			ifx_httpdWrite(wp,T("			  	  			<td class=textCell>&nbsp;</td>		  	<td class=textCell>&nbsp;</td>		  	  "));
	}		

	return 0;
	
}


int ifx_get_WanModeConnectAndDisconnet(int eid, httpd_t wp, int argc, char_t **argv)
{
	int wanMode,status;

	wanMode = websGetWanMode();
	status = ifx_get_ConnectingStatus(eid,wp,argc,argv);
	if (wanMode == 2)		
	{
		ifx_httpdWrite(wp,T("<tr>	"));
		ifx_httpdWrite(wp,T("<td class=textCell><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>"));
		ifx_httpdWrite(wp,T("<td class=textCell><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>"));
		ifx_httpdWrite(wp,T("</tr>"));		
	}else
	{
		ifx_httpdWrite(wp,T("<tr>	"));	
		ifx_httpdWrite(wp,T("<td class=textCell><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Cable/DSL</font></td>"));	
		ifx_httpdWrite(wp,T("<td class=textCell><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">	"));			
		if (status == 1)
			ifx_httpdWrite(wp,T("CONNECTED"));
		else
			ifx_httpdWrite(wp,T("DISCONNECTED"));
		ifx_httpdWrite(wp,T(" 	      </font></td>		</tr>"));
	}
	return 0;
}

void ifx_set_system_status(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pConnect = ifx_httpdGetVar(wp, T("connectflag"), T(""));
	int 	nWanMode = websGetWanMode();
	char_t	command[MAX_FILELINE_LEN];
	memset(command, 0x00, MAX_FILELINE_LEN);	

	if (!gstrcmp(pConnect, T("1")))	// Disconnect/Release
	{
       		switch (nWanMode)
        	{
        		case IP_BOOT_DHCPC:
				system(SERVICE_DHCPC_STOP);
            		break;

        		case IP_BOOT_PPPOE:
				system(SERVICE_PPPOE_STOP);
            		break;

        		case IP_BOOT_PPTP:
		    		system(SERVICE_PPTP_STOP);
            		break;
        
        		default:
		    		ifx_httpdError(wp, 200, T("Not specified Connection type"));
        	}
	}
	else if (!gstrcmp(pConnect, T("2")))	// Connect/Renew
	{
       		switch (nWanMode)
        	{
        		case IP_BOOT_DHCPC:
#if defined(ATA) || defined(IIP)
				system(SERVICE_RC_VOIP_STOP);
#endif
				system(SERVICE_DHCPC_RESTART);
#if defined(ATA) || defined(IIP)
				system(SERVICE_RC_VOIP_RESTART);
#endif
            		break;

        		case IP_BOOT_PPPOE:
#if defined(ATA) || defined(IIP)
				system(SERVICE_RC_VOIP_STOP);
#endif
				system(SERVICE_PPPOE_STOP);
				system(SERVICE_PPPOE_START);
#if defined(ATA) || defined(IIP)
				// Roger(2004/02/06): Check PPPoE connection status now
				memset(command, 0x00, MAX_FILELINE_LEN);	
				gsprintf(command, T("ifconfig %s | grep %s | cut -f2 -d: | cut -f1 -d\" \""),
						 ADM_PPP_IF, "\"inet addr:\"");
				if (ifx_GetCfgData((char_t*)command, NULL, "1", command) == 0)
				{
					ifx_httpdError(wp, 200, "PPPoE connecting failed, please check your wan connection or your ISP information");
					return;
				}
				// End
				system(SERVICE_RC_VOIP_RESTART);
#endif
            		break;

        		case IP_BOOT_PPTP:
#if defined(ATA) || defined(IIP)
				system(SERVICE_RC_VOIP_STOP);
#endif
		    		system(SERVICE_PPTP_STOP);
		    		system(SERVICE_PPTP_START);
#if defined(ATA) || defined(IIP)
				system(SERVICE_RC_VOIP_RESTART);
#endif
            		break;
        
        		default:
		    		ifx_httpdError(wp, 200, T("Not specified Connection type"));
            		break;
        	}
	}

	ifx_httpdNextPage(wp);
}