/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include	 <sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"
#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int   nRuntimeCodeclist = 0;


int strToHex(char *string)
{
    char c1;
    int i, len=0, var=0, shift=0;

    if (string == 0)
        return (-1);

    len = strlen(string);
    if (string[len] != 0)
        return (-1);

    for(i = 0; i<len; i++)
    {
      if (!isxdigit(string[i])) return -1;
      c1 = string[i];
      c1 = tolower(c1);
      c1 = (c1 < 'a')? (c1 - '0') : (c1 - 'a' + 10);
      shift = len - i - 1; 

      // Ex: 1FF = 1*16*16 + 15*16 + 15 
      if (shift)
        var += c1<<4*shift;
      else
        var += c1;
    }

    return var;
}

int GetCodecListFromFile()
{
	FILE *fd;
	char buf[50];
	memset(buf, 0, 50);
	if ((fd = fopen("/etc/codeclist", "r")) != 0)
	{
		fscanf(fd, "%s", buf);
		fclose(fd);	
	}

	return strToHex(buf);
}

int ifx_get_voip_sip_rm(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name,*mode;
	char_t	sValue[MAX_DATA_LEN];
	x_IFX_CM_Msg xCmMsg;
	int nSelIndex = 0, nIndex = 0;
	uint32 uPrefer=0;
//	uint8  *aucFile[] = {"TEST600.BIN", "ETSI.BIN", "GERMANY.BIN", "USACMP.BIN"};
   	
   	// Get Data from CM
   	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg)); 
   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_RM_CONFIG;		
	xCmMsg.ucChannel = 0;

// Add for dynamic codeclist display, Roger
	if (nRuntimeCodeclist == 0)
	{
		nRuntimeCodeclist = GetCodecListFromFile();
		if (nRuntimeCodeclist == -1) 
		ifx_httpdError(wp, 200, T("Fail to receive RM-CODEC data from File\n"));
		return -1;
		
	}
// end
    
    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		ifx_httpdError(wp, 200, T("Fail to receive RM-CODEC data from CM\n"));
		return -1;
	}
	if (ejArgs(argc, argv, T("%s%s"), &name,&mode) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}

 	memset(sValue, 0x00, MAX_DATA_LEN);  

	//trace(8, "codelist is %d\n",xCmMsg.uxData.xMediaCfg.uiCodecList);	
   	
   	if (!gstrcmp(name, T("bwidth")))
   	{
   		ifx_httpdWrite(wp, "%d", xCmMsg.uxData.xMediaCfg.unLinkBw);   
   	}
   	else if (!gstrcmp(name, T("frame")))
   	{
		nSelIndex = xCmMsg.uxData.xMediaCfg.unFrameSize;
	
		for (nIndex=0; nIndex<sizeof(web_Frame_Sizes)/sizeof(CGI_ENUMSEL_S); nIndex++)
		{	
			// Get Selected option index from rc.conf
			if (web_Frame_Sizes[nIndex].value == nSelIndex)
				gstrcpy(sValue, "selected");
			else 
				gstrcpy(sValue, "");
			
			ifx_httpdWrite(wp, T("\t<option value=\"%d\" %s>%s</option>\n"), web_Frame_Sizes[nIndex].value, sValue, web_Frame_Sizes[nIndex].str);
		}
   	}
	else if (!gstrcmp(name, T("g711_alaw")))
   	{
        if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G711_ALAW)               
		  ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid,"1");
   		else
		  ifx_httpdWrite(wp,T(""));//ejSetResult(eid,"2");

   	}
	else if (!gstrcmp(name, T("g711_ulaw")))
   	{
        if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G711_ULAW)               
		  ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid,"1");
   		else
		  ifx_httpdWrite(wp,T(""));//ejSetResult(eid,"2");
   	}
	else if (!gstrcmp(name, T("g729_8p")) && nRuntimeCodeclist&IFX_CM_RM_G729_8)
   	{
         ifx_httpdWrite(wp,"\nif (document.tF0.g729_8.checked == true)\n {\n index += 1;\n prefOpt[index] = \"G729_8\";\n }");
   	}
	else if (!gstrcmp(name, T("g729_8")) && nRuntimeCodeclist&IFX_CM_RM_G729_8)
   	{
          ifx_httpdWrite(wp,T("<tr class=\"celltext\" bgcolor=\"#ffffff\">\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"> \n"));
          ifx_httpdWrite(wp,T("G729_8 &nbsp;"));
          ifx_httpdWrite(wp,T("</td>"));
          ifx_httpdWrite(wp,T("<td width=\"20%\">"));
          ifx_httpdWrite(wp,T("<input type=\"checkbox\" value=\"1\" name=\"g729_8\""));

        if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G729_8)               
		  ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid,"1");
   		else
		  ifx_httpdWrite(wp,T(""));//ejSetResult(eid,"2");

          ifx_httpdWrite(wp,T(" onclick=\"updatePrefer();\"></td>\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"></td>\n"));
          ifx_httpdWrite(wp,T("</tr>\n"));
   	}
	else if (!gstrcmp(name, T("g729_ep")) && nRuntimeCodeclist&IFX_CM_RM_G729_E)
    {
         ifx_httpdWrite(wp,T("\nif (document.tF0.g729_e.checked == true)\n {\n index += 1;\n prefOpt[index] = \"G729_E\";\n }"));
    }
	else if (!gstrcmp(name, T("g729_e")) && nRuntimeCodeclist&IFX_CM_RM_G729_E)
   	{
          ifx_httpdWrite(wp,T("<tr class=\"celltext\" bgcolor=\"#ffffff\">\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"> \n"));
          ifx_httpdWrite(wp,T("G729_E &nbsp;"));
          ifx_httpdWrite(wp,T("</td>"));
          ifx_httpdWrite(wp,T("<td width=\"20%\">"));
          ifx_httpdWrite(wp,T("<input type=\"checkbox\" value=\"1\" name=\"g729_e\""));

         if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G729_E)               
		  	ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid,"1");
		else
		  	ifx_httpdWrite(wp,T(""));//ejSetResult(eid,"2");

          ifx_httpdWrite(wp,T(" onclick=\"updatePrefer();\"></td>\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"></td>\n"));
          ifx_httpdWrite(wp,T("</tr>\n"));
   	}
   	else if (!gstrcmp(name, T("g723")) && nRuntimeCodeclist&IFX_CM_RM_G723)
   	{
        ifx_httpdWrite(wp,"<tr class=\"celltext\" bgcolor=\"#ffffff\">\n");
        ifx_httpdWrite(wp,"<td width=\"20%\"> \n");
        ifx_httpdWrite(wp,"G723 &nbsp;");
        ifx_httpdWrite(wp,"</td>");
        ifx_httpdWrite(wp,"<td width=\"20%\">");
        ifx_httpdWrite(wp,"<input type=\"checkbox\" value=\"1\" name=\"g723\"");

        if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G723)               
			 ifx_httpdWrite(wp,"checked");
   		else
		  	ifx_httpdWrite(wp,"");

        ifx_httpdWrite(wp," onclick=\"updatePrefer();\"></td>\n");
        ifx_httpdWrite(wp,"<td width=\"20%\">\n");
        ifx_httpdWrite(wp,"<select name=\"p723list\" size=\"1\">\n"); 
        ifx_httpdWrite(wp,"<option value=0>G723_5_3</option>\n");        
        ifx_httpdWrite(wp,"<option value=1>G723_6_3</option>\n");
        ifx_httpdWrite(wp,"</select></td>\n");                
        ifx_httpdWrite(wp,"</tr>\n");
   	}
   	else if (!gstrcmp(name, T("g723p")) && nRuntimeCodeclist&IFX_CM_RM_G723)
   	{
	    ifx_httpdWrite(wp,"if (document.tF0.g723.checked == true)\n         {\n             index += 1;\n             prefOpt[index] = \"G723\";\n          }");
   	}
   	else if (!gstrcmp(name, T("g723p_check")) && nRuntimeCodeclist&IFX_CM_RM_G723)
   	{
   		ifx_httpdWrite(wp, T("if (document.tF0.userlevel.value == 0 && document.tF0.g723.checked == true)\n"));
   		ifx_httpdWrite(wp, T("{\n"));
   		ifx_httpdWrite(wp, T("\tdocument.tF0.p723list.disabled = false;\n"));
   		
   		nSelIndex = xCmMsg.uxData.xMediaCfg.uiPreferredCodec;
   		if (xCmMsg.uxData.xMediaCfg.uiG723PrefCodec == IFX_CM_RM_G723_5_3)
   			ifx_httpdWrite(wp, T("\tdocument.tF0.p723list.selectedIndex = 0;\n"));
		else   			
   			ifx_httpdWrite(wp, T("\tdocument.tF0.p723list.selectedIndex = 1;\n"));
   		
   		ifx_httpdWrite(wp, T("}\n"));
   		ifx_httpdWrite(wp, T("else\n"));
   		ifx_httpdWrite(wp, T("{\n"));
   		ifx_httpdWrite(wp, T("\tdocument.tF0.p723list.disabled = true;\n"));
   		ifx_httpdWrite(wp, T("}\n"));
   	}
	else if (!gstrcmp(name, T("g728")) && nRuntimeCodeclist&IFX_CM_RM_G728)
   	{
          ifx_httpdWrite(wp,T("<tr class=\"celltext\" bgcolor=\"#ffffff\">\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"> \n"));
          ifx_httpdWrite(wp,T("G728 &nbsp;"));
          ifx_httpdWrite(wp,T("</td>"));
          ifx_httpdWrite(wp,T("<td width=\"20%\">"));
          ifx_httpdWrite(wp,T("<input type=\"checkbox\" value=\"1\" name=\"g728\""));

        	if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G728)               
			 ifx_httpdWrite(wp,T("checked")); //ejSetResult(eid,"1");
   		else
		  	ifx_httpdWrite(wp,T(""));//ejSetResult(eid,"2");

          ifx_httpdWrite(wp,T(" onclick=\"updatePrefer();\"></td>\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"></td>\n"));
          ifx_httpdWrite(wp,T("</tr>\n"));
   	}	
  	else if (!gstrcmp(name, T("g728p")) && nRuntimeCodeclist&IFX_CM_RM_G728)
    {
         ifx_httpdWrite(wp,T("if (document.tF0.g728.checked == true)\n         {\n             index += 1;\n             prefOpt[index] = \"G728\";\n          }"));
    }
	else if (!gstrcmp(name, T("g726_16")) && nRuntimeCodeclist&IFX_CM_RM_G726_16)
   	{
          ifx_httpdWrite(wp,T("<tr class=\"celltext\" bgcolor=\"#ffffff\">\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"> \n"));
          ifx_httpdWrite(wp,T("G726_16 &nbsp;"));
          ifx_httpdWrite(wp,T("</td>"));
          ifx_httpdWrite(wp,T("<td width=\"20%\">"));
          ifx_httpdWrite(wp,T("<input type=\"checkbox\" value=\"1\" name=\"g726_16\""));

          if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G726_16)
		  ifx_httpdWrite(wp,T("checked"));
   		else
		  ifx_httpdWrite(wp,T(""));

          ifx_httpdWrite(wp,T(" onclick=\"updatePrefer();\"></td>\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"></td>\n"));
          ifx_httpdWrite(wp,T("</tr>\n"));
   	}	
    else if (!gstrcmp(name, T("g726_16p")) && nRuntimeCodeclist&IFX_CM_RM_G726_16)
   	{
         ifx_httpdWrite(wp,T("if (document.tF0.g726_16.checked == true)\n         {\n             index += 1;\n             prefOpt[index] = \"G726_16\";\n          }"));
   	}	
	else if (!gstrcmp(name, T("g726_24")) && nRuntimeCodeclist&IFX_CM_RM_G726_24)
   	{
          ifx_httpdWrite(wp,T("<tr class=\"celltext\" bgcolor=\"#ffffff\">\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"> \n"));
          ifx_httpdWrite(wp,T("G726_24 &nbsp;"));
          ifx_httpdWrite(wp,T("</td>"));
          ifx_httpdWrite(wp,T("<td width=\"20%\">"));
          ifx_httpdWrite(wp,T("<input type=\"checkbox\" value=\"1\" name=\"g726_24\""));

          if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G726_24)
		  ifx_httpdWrite(wp,T("checked"));
   		else
		  ifx_httpdWrite(wp,T(""));

          ifx_httpdWrite(wp,T(" onclick=\"updatePrefer();\"></td>\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"></td>\n"));
          ifx_httpdWrite(wp,T("</tr>\n"));
   	}			
    else if (!gstrcmp(name, T("g726_24p")) && nRuntimeCodeclist&IFX_CM_RM_G726_24)	
   	{
         ifx_httpdWrite(wp,T("if (document.tF0.g726_24.checked == true)\n         {\n             index += 1;\n             prefOpt[index] = \"G726_24\";\n          }"));
   	}	
	else if (!gstrcmp(name, T("g726_32")) && nRuntimeCodeclist&IFX_CM_RM_G726_32)
   	{
          ifx_httpdWrite(wp,T("<tr class=\"celltext\" bgcolor=\"#ffffff\">\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"> \n"));
          ifx_httpdWrite(wp,T("G726_32 &nbsp;"));
          ifx_httpdWrite(wp,T("</td>"));
          ifx_httpdWrite(wp,T("<td width=\"20%\">"));
          ifx_httpdWrite(wp,T("<input type=\"checkbox\" value=\"1\" name=\"g726_32\""));

        if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G726_32)               
		  ifx_httpdWrite(wp,T("checked"));
   		else
		  ifx_httpdWrite(wp,T(""));

          ifx_httpdWrite(wp,T(" onclick=\"updatePrefer();\"></td>\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"></td>\n"));
          ifx_httpdWrite(wp,T("</tr>\n"));
   	}	
    else if (!gstrcmp(name, T("g726_32p")) && nRuntimeCodeclist&IFX_CM_RM_G726_32)
      {
         ifx_httpdWrite(wp,T("if (document.tF0.g726_32.checked == true)\n         {\n             index += 1;\n             prefOpt[index] = \"G726_32\";\n          }"));
   	}	
	else if (!gstrcmp(name, T("g726_40")) && nRuntimeCodeclist&IFX_CM_RM_G726_40)
   	{
          ifx_httpdWrite(wp,T("<tr class=\"celltext\" bgcolor=\"#ffffff\">\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"> \n"));
          ifx_httpdWrite(wp,T("G726_40 &nbsp;"));
          ifx_httpdWrite(wp,T("</td>"));
          ifx_httpdWrite(wp,T("<td width=\"20%\">"));
          ifx_httpdWrite(wp,T("<input type=\"checkbox\" value=\"1\" name=\"g726_40\""));

        if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G726_40)               
		  ifx_httpdWrite(wp,T("checked"));
   		else
		  ifx_httpdWrite(wp,T(""));

          ifx_httpdWrite(wp,T(" onclick=\"updatePrefer();\"></td>\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"></td>\n"));
          ifx_httpdWrite(wp,T("</tr>\n"));
   	}
      else if (!gstrcmp(name, T("g726_40p")) && nRuntimeCodeclist&IFX_CM_RM_G726_40)
      {
         ifx_httpdWrite(wp,T("if (document.tF0.g726_40.checked == true)\n         {\n             index += 1;\n             prefOpt[index] = \"G726_40\";\n          }"));
   	}	
   else if (!gstrcmp(name, T("g722_64")) && nRuntimeCodeclist&IFX_CM_RM_G722_64)
      {
          ifx_httpdWrite(wp,T("<tr class=\"celltext\" bgcolor=\"#ffffff\">\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"> \n"));
          ifx_httpdWrite(wp,T("G722_64 &nbsp;"));
          ifx_httpdWrite(wp,T("</td>"));
          ifx_httpdWrite(wp,T("<td width=\"20%\">"));
          ifx_httpdWrite(wp,T("<input type=\"checkbox\" value=\"1\" name=\"g722_64\""));

        if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G722_64)              
        	ifx_httpdWrite(wp,T("checked"));
         else
        	ifx_httpdWrite(wp,T(""));

          ifx_httpdWrite(wp,T(" onclick=\"updatePrefer();\"></td>\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"></td>\n"));
          ifx_httpdWrite(wp,T("</tr>\n"));

      }
    else if (!gstrcmp(name, T("g722_64p")) && nRuntimeCodeclist&IFX_CM_RM_G722_64)
      {
         ifx_httpdWrite(wp,T("if (document.tF0.g722_64.checked == true)\n         {\n             index += 1;\n             prefOpt[index] = \"G722_64\";\n          }"));
      }
      else if (!gstrcmp(name, T("t38p")) && nRuntimeCodeclist&IFX_CM_RM_T38)
   	{
   		ifx_httpdWrite(wp,T("if (document.tF0.t38.checked == true)\n         {\n             index += 1;\n             prefOpt[index] = \"T38\";\n          }"));
   	}
	else if (!gstrcmp(name, T("t38")) && nRuntimeCodeclist&IFX_CM_RM_T38)
   	{
          ifx_httpdWrite(wp,T("<tr class=\"celltext\" bgcolor=\"#ffffff\">\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"> \n"));
          ifx_httpdWrite(wp,T("T38 &nbsp;"));
          ifx_httpdWrite(wp,T("</td>"));
          ifx_httpdWrite(wp,T("<td width=\"20%\">"));
          ifx_httpdWrite(wp,T("<input type=\"checkbox\" value=\"1\" name=\"t38\""));

        if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_T38)               
		  ifx_httpdWrite(wp,T("checked"));
   		else
		  ifx_httpdWrite(wp,T(""));

          ifx_httpdWrite(wp,T(" onclick=\"updatePrefer();\"></td>\n"));
          ifx_httpdWrite(wp,T("<td width=\"20%\"></td>\n"));
          ifx_httpdWrite(wp,T("</tr>\n"));
   	}	
	else if (!gstrcmp(name, T("plist")))
   	{
   		x_WEB_CodecOpt uiPreOpt[20];		
   		int i = 0, j = 0;
   		memset(uiPreOpt, 0, sizeof(x_WEB_CodecOpt)*20);
   		
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G711_ALAW)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_G711_ALAW;
			uiPreOpt[i].ucIdx = 0;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"G711_ALAW");
			i++;
		}
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G711_ULAW)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_G711_ULAW;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"G711_ULAW");
			i++;
		}
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G729_8)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_G729_8;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"G729_8");	
			i++;
		}
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G729_E)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_G729_E;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"G729_E");
			i++;
		}		
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G723)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_G723;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"G723");
			i++;
		}
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G728)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_G728;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"G728");
			i++;
		}			
     if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_LINEAR_256)
      {
         uiPreOpt[i].uiOpt = IFX_CM_RM_LINEAR_256;
         uiPreOpt[i].ucIdx = i;        // For selected index
	 strcpy(uiPreOpt[i].uacCodec,"LINEAR_256");
         i++;
      }
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_LINEAR_16)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_LINEAR_16;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"LINEAR_16");
			i++;
		}
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_LINEAR_8)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_LINEAR_8;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"LINEAR_8");
			i++;
		}		
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G726_16)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_G726_16;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"G726_16");
			i++;
		}
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G726_24)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_G726_24;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"G726_24");
			i++;
		}
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G726_32)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_G726_32;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"G726_32");
			i++;
		}
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G726_40)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_G726_40;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"G726_40");
			i++;
		}		   		
      if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_G722_64)
      {
         uiPreOpt[i].uiOpt = IFX_CM_RM_G722_64;
         uiPreOpt[i].ucIdx = i;        // For selected index
         strcpy(uiPreOpt[i].uacCodec,"G722_64");
         i++;
      }
		if (xCmMsg.uxData.xMediaCfg.uiCodecList & IFX_CM_RM_T38)
		{
			uiPreOpt[i].uiOpt = IFX_CM_RM_T38;
			uiPreOpt[i].ucIdx = i;			// For selected index
			strcpy(uiPreOpt[i].uacCodec,"T38");
			i++;
		}
		
//		trace(8, "Total option is %d\n", i);
   		uPrefer = xCmMsg.uxData.xMediaCfg.uiPreferredCodec;
		for (j=0; j< i; j++)	// Total option entries i
		{
			if (uPrefer & uiPreOpt[j].uiOpt)
   				ifx_httpdWrite(wp, T("%s"), uiPreOpt[j].uacCodec);
		}	
   	}
   	
	return 0;
}

void ifx_set_voip_sip_rm(httpd_t wp, char_t *path, char_t *query)
{   
	char_t	*pBwidth = ifx_httpdGetVar(wp, T("bwidth"), T(""));	
	char_t	*pFrame= ifx_httpdGetVar(wp, T("frame"), T(""));	
	char_t	*pg711_alaw = ifx_httpdGetVar(wp, T("g711_alaw"), T(""));
	char_t	*pg711_ulaw = ifx_httpdGetVar(wp, T("g711_ulaw"), T(""));
	char_t	*pg729_8 = ifx_httpdGetVar(wp, T("g729_8"), T(""));
	char_t	*pg729_e = ifx_httpdGetVar(wp, T("g729_e"), T(""));
	char_t	*pg723 = ifx_httpdGetVar(wp, T("g723"), T(""));
	char_t	*pg728 = ifx_httpdGetVar(wp, T("g728"), T(""));
	char_t	*plinear_256 = ifx_httpdGetVar(wp, T("linear_256"), T(""));
	char_t	*plinear_16 = ifx_httpdGetVar(wp, T("linear_16"), T(""));
	char_t	*plinear_8 = ifx_httpdGetVar(wp, T("linear_8"), T(""));
	char_t	*pg726_16 = ifx_httpdGetVar(wp, T("g726_16"), T(""));
	char_t	*pg726_24 = ifx_httpdGetVar(wp, T("g726_24"), T(""));
	char_t	*pg726_32 = ifx_httpdGetVar(wp, T("g726_32"), T(""));
	char_t	*pg726_40 = ifx_httpdGetVar(wp, T("g726_40"), T(""));
	char_t	*pg722_64 = ifx_httpdGetVar(wp, T("g722_64"), T(""));
	char_t	*pt38 = ifx_httpdGetVar(wp, T("t38"), T(""));
	char_t	*pplist = ifx_httpdGetVar(wp, T("plist"), T(""));
	char_t	*pp723list = ifx_httpdGetVar(wp, T("p723list"), T(""));
	x_IFX_CM_Msg xCmMsg;	
	uint32 uiPrefer[20];
	int i = 0;
	
			
	a_assert(wp);
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));	
	if (pBwidth == 0 || pFrame == 0)
	{                               
		ifx_httpdError(wp, 200, T("Setup Error"));
		return;                     
	}
		
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	xCmMsg.ucInfoType = IFX_CM_RM_CONFIG;
	xCmMsg.ucChannel = 0;	
	xCmMsg.uxData.xMediaCfg.unLinkBw = atoi(pBwidth);
	xCmMsg.uxData.xMediaCfg.unFrameSize=atoi(pFrame);
	//<< Roger(2004/10/15), Add for Line Impedance
	//gstrcpy(xCmMsg.uxData.xMediaCfg.aucCramFileName, aucFile[atoi(ptelspec)]);
	//>> End

	// Combine all checkbox for CodecList	
	if (pg711_alaw[0])
	{
		uiPrefer[i] = IFX_CM_RM_G711_ALAW;
		i++;		
	 	xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_G711_ALAW;
	}	
	if (pg711_ulaw[0])
	{
		uiPrefer[i] = IFX_CM_RM_G711_ULAW;		
		i++;
	 	xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_G711_ULAW;
	}
	
	if (pg729_8[0])
	{
		uiPrefer[i] = IFX_CM_RM_G729_8;
		i++;		
		xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_G729_8;
	}
	if (pg729_e[0])
	{
		uiPrefer[i] = IFX_CM_RM_G729_E;			
		i++;		
		xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_G729_E;
	}
	if (pg723[0])
	{
		uiPrefer[i] = IFX_CM_RM_G723;			
		i++;		
		xCmMsg.uxData.xMediaCfg.uiCodecList |=  IFX_CM_RM_G723;
		//trace(8, "PreferCodec723 is %d\n", atoi(pp723list));
		if (atoi(pp723list) == 0)
			xCmMsg.uxData.xMediaCfg.uiG723PrefCodec = IFX_CM_RM_G723_5_3;
		else
			xCmMsg.uxData.xMediaCfg.uiG723PrefCodec = IFX_CM_RM_G723_6_3;
	}
	if (pg728[0])
	{
		uiPrefer[i] = IFX_CM_RM_G728;		
		i++;		
		xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_G728;
	}		
   if (plinear_256[0])
   {
      uiPrefer[i] = IFX_CM_RM_LINEAR_256;
      i++;
      xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_LINEAR_256;
   }
	if (plinear_16[0])
	{
		uiPrefer[i] = IFX_CM_RM_LINEAR_16;		
		i++;		
		xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_LINEAR_16;
	}
	if (plinear_8[0])
	{
		uiPrefer[i] = IFX_CM_RM_LINEAR_8;		
		i++;		
		xCmMsg.uxData.xMediaCfg.uiCodecList |=  IFX_CM_RM_LINEAR_8;
	}
	if (pg726_16[0])
	{
		uiPrefer[i] = IFX_CM_RM_G726_16;		
		i++;		
	 	xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_G726_16;
	}
	if (pg726_24[0])
	{
		uiPrefer[i] = IFX_CM_RM_G726_24;		
		i++;		
	 	xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_G726_24;
	}
	if (pg726_32[0])
	{
		uiPrefer[i] = IFX_CM_RM_G726_32;		
		i++;		
	 	xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_G726_32;
	}
	if (pg726_40[0])
	{
		uiPrefer[i] = IFX_CM_RM_G726_40;		
		i++;		
	 	xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_G726_40;
	}
   if (pg722_64[0])
   {
      uiPrefer[i] = IFX_CM_RM_G722_64;   
      i++;    
      xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_G722_64;
   }
	if (pt38[0])
	{
		uiPrefer[i] = IFX_CM_RM_T38;		
		i++;		
	 	xCmMsg.uxData.xMediaCfg.uiCodecList |= IFX_CM_RM_T38;
	}
	
    xCmMsg.uxData.xMediaCfg.uiPreferredCodec=uiPrefer[atoi(pplist)];    
	//trace(8, "Set CodeList=%d and prefer code 0x%08x", xCmMsg.uxData.xMediaCfg.uiCodecList, uiPrefer[atoi(pplist)]);    
    
    /* Evaluate Frame Size based on prefered codec */
     if(xCmMsg.uxData.xMediaCfg.unFrameSize == 5)
     {
        /* check if either ulaw or Alaw or 722 is the prefered codec */
       if((xCmMsg.uxData.xMediaCfg.uiPreferredCodec != IFX_CM_RM_G711_ALAW)&&
          (xCmMsg.uxData.xMediaCfg.uiPreferredCodec != IFX_CM_RM_G711_ULAW)&&
          (xCmMsg.uxData.xMediaCfg.uiPreferredCodec != IFX_CM_RM_G722_64))
       {
          ifx_httpdError(wp, 200, T("For This Frame size only G711_ALAW or G711_ULAW or G722 Codecs are supported."));
          return;
       }
     }

     else if((xCmMsg.uxData.xMediaCfg.uiPreferredCodec == IFX_CM_RM_T38))
     {

        /* check if frame size is 20 */
        if(xCmMsg.uxData.xMediaCfg.unFrameSize != 20)
        {
          ifx_httpdError(wp, 200, T("For T38 the Frame size must be 20."));
         return;
        }
 
     }
     else if(xCmMsg.uxData.xMediaCfg.unFrameSize == 30)
     {
 
         if(xCmMsg.uxData.xMediaCfg.uiPreferredCodec != IFX_CM_RM_G723)
     {    
          ifx_httpdError(wp, 200, T("The Frame Size 30 is supported only by G723 codec."));
          return;
        }
     }
     else if(xCmMsg.uxData.xMediaCfg.uiPreferredCodec == IFX_CM_RM_G723)
     {
        if(xCmMsg.uxData.xMediaCfg.unFrameSize != 30)
        {
     
          ifx_httpdError(wp, 200, T(" G723 codec supports Frame size 30 only."));
          return;
        }
   }
	    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
   	 {
   	 	if (connection.allowed == 1)
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		else
		{
			ifx_httpdError(wp, 200, T("Fail to send RM-Codec data to CM"));
		}
			return;     	
   	 }

//	websSuccess(wp);	
	ifx_httpdNextPage(wp);
}

