/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <net/if.h>
#include <net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include "ifx_common_defs.h"
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

/*****************************************************************************
 *  Function Name   : ifx_get_voip_fax
 *  Description     : This function is called voip_sip_fax.asp page
 *  Input Values    :
 *  Output Values   :
 *
 *  Return Value    : 0  - Success
 *                    -1 - Failure
 *  Notes           :
 ****************************************************************************/
int ifx_get_voip_fax(int eid, httpd_t wp, int argc, char_t **argv)
{
#ifdef ATA
	 char_t  *name,*mode1,*mode2,*mode3,*mode4;
	 x_IFX_CM_Msg xCmMsg;

    if (ejArgs(argc, argv, T("%s%s%s%s%s"), &name,&mode1,&mode2,&mode3,&mode4) < 1)
    {
            ifx_httpdError(wp, 200, T("Insufficient args\n"));
            return -1;
    }
     /* Add this statement to reduce multiple get request for IFX_CM_RM_FAX_CFG */
        if (!gstrcmp(name, T("ptl")) || !gstrcmp(name, T("t38VerTcp")) || !gstrcmp(name, T("t38VerUdp")) ||
				!gstrcmp(name, T("rateMgnUdp")) ||!gstrcmp(name, T("rateMgnTcp")) ||!gstrcmp(name, T("bitRateUdp"))||
                !gstrcmp(name, T("bitRateTcp")) || !gstrcmp(name, T("opt")) || !gstrcmp(name, T("maxbuf")) ||
            !gstrcmp(name, T("maxData")) || !gstrcmp(name, T("errCrt")))
    {
                // Get Data from CM
            memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
            xCmMsg.ucMsgType = IFX_CM_GET_REQ;
            xCmMsg.ucInfoType = IFX_CM_RM_FAX_CFG;
            xCmMsg.ucChannel = 0;

        if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
            {
                    ifx_httpdError(wp, 200, T("Fail to receive data from CM Fax1\n"));                        return -1;
            }
			       if (!gstrcmp(name, T("t38VerUdp")))
            {
                    ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xFaxCfg[1].ucVersion);
            }
					 else if (!gstrcmp(name, T("t38VerTcp")))
            {
                    ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xFaxCfg[0].ucVersion);
            }
                else if (!gstrcmp(name, T("rateMgnUdp")))
            {
                        uint32 ucValue = xCmMsg.uxData.xFaxCfg[1].ucRateManagement;

                        if ((ucValue & IFX_CM_RM_CAP_FL_TCF_LOCAL) &&(ucValue & IFX_CM_RM_CAP_FL_TCF_TRANSFERRED))
                                ifx_httpdWrite(wp, "3");
                        else if (ucValue & IFX_CM_RM_CAP_FL_TCF_TRANSFERRED )
                                ifx_httpdWrite(wp, "2");
                    else
                                ifx_httpdWrite(wp, "1");
            }
					 else if (!gstrcmp(name, T("rateMgnTcp")))
            {
					     uint32 ucValue = xCmMsg.uxData.xFaxCfg[0].ucRateManagement;
                    if ((ucValue & IFX_CM_RM_CAP_FL_TCF_LOCAL) &&(ucValue & IFX_CM_RM_CAP_FL_TCF_TRANSFERRED))
                             ifx_httpdWrite(wp, "3");
                    else if (ucValue & IFX_CM_RM_CAP_FL_TCF_TRANSFERRED )
                             ifx_httpdWrite(wp, "2");
                    else
                             ifx_httpdWrite(wp, "1");
		         }
		         else if (!gstrcmp(name, T("bitRateUdp")))
               {
                       ifx_httpdWrite(wp, "%d", xCmMsg.uxData.xFaxCfg[1].unMaxBitRate);
               }
		         else if (!gstrcmp(name, T("bitRateTcp")))
               {
                       ifx_httpdWrite(wp, "%d", xCmMsg.uxData.xFaxCfg[0].unMaxBitRate);
            }
             else if (!gstrcmp(name, T("opt")))
            {
                        uint32 uiOpt = xCmMsg.uxData.xFaxCfg[1].uiBitOptions;

                    if (uiOpt & IFX_CM_RM_CAP_FL_OPT_FILL_BIT_REMOVAL)
                    {
                        if (uiOpt & IFX_CM_RM_CAP_FL_OPT_TRANSCODING_MMR)
                        {
                    	 	if (uiOpt & IFX_CM_RM_CAP_FL_OPT_TRANSCODING_JBIG )
                          	{
											if (!strcmp(mode4, "7"))	  
											{
			  					ifx_httpdWrite(wp,T("checked"));//)ejSetResult(eid, "7");
                            }
                            }
                            else
                            {
											if (!strcmp(mode2, "3"))
											{
			  					           ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "3");
											}
                            }
                        }
                        else
                        {
                    		if (uiOpt & IFX_CM_RM_CAP_FL_OPT_TRANSCODING_JBIG )
                            {
			  					         if(!strcmp(mode3, "5")|| !strcmp(mode2, "5"))
											{
			  					ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "5");
                            }
                            }
                            else
                            {
			  					         if (!strcmp(mode1, "1"))
										   {
											   ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "1");
											}
                            }
                        }
                   }
                   else
                   {
                     if (uiOpt & IFX_CM_RM_CAP_FL_OPT_TRANSCODING_MMR)
                     {
                       if (uiOpt & IFX_CM_RM_CAP_FL_OPT_TRANSCODING_JBIG )
                       {
                           if (!strcmp(mode3, "6"))
					             {
                           ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "6");
                       }
                       }
                       else
                       {
                           if (!strcmp(mode1, "2"))
									 {
										ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "2");
									 }
                       }
                     }
                     else
                     {
		   if (uiOpt & IFX_CM_RM_CAP_FL_OPT_TRANSCODING_JBIG )
                       {                        
                         if (!strcmp(mode1, "4"))
								  {
                         ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "4");
                       }
                       }
                       else
                       {
                         ifx_httpdWrite(wp,T(""));//ejSetResult(eid, "0");
                       }
                    }
               }
            }
            else if (!gstrcmp(name, T("maxbuf")))
            {
                    ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xFaxCfg[1].unUDPMaxBufferSize);
            }
            else if (!gstrcmp(name, T("maxData")))
            {
                    ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xFaxCfg[1].unUDPMaxDatagramSize);
            }
            else if (!gstrcmp(name, T("errCrt")))
            {
                    uchar8 ucErr = xCmMsg.uxData.xFaxCfg[1].ucUDPErrCorrection;

                    if (ucErr & IFX_CM_RM_CAP_FL_EC_REDUNDANCY)
                    {
                        if (ucErr & IFX_CM_RM_CAP_FL_EC_FEC)
                        {
							        if (!strcmp(mode2, "3"))
									  {
							ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "3");
                        }
                        }
                        else
                        {
							       if (!strcmp(mode1, "1"))
								    {
										ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "1");
									 }
                        }
                   }
                   else
                   {
                      if(ucErr & IFX_CM_RM_CAP_FL_EC_FEC)
                      {
	            			  if (!strcmp(mode1, "2"))
							     {
	            			ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "2");
                      }
                      }
                      else
                      {
	           				ifx_httpdWrite(wp,T(""));//ejSetResult(eid, "0");
                      }
                  }
            }
    }
     /* Add this statement to reduce multiple get request for IFX_CM_SIP_CFG_FAX_PORT */
    if (!gstrcmp(name, T("sPort")) || !gstrcmp(name, T("ePort")))
    {
            // Get Data from CM
            memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
            xCmMsg.ucMsgType = IFX_CM_GET_REQ;
            xCmMsg.ucInfoType = IFX_CM_SIP_CFG_FAX_PORT;
            xCmMsg.ucChannel = 0;

        if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
            {
                    ifx_httpdError(wp, 200, T("Fail to receive data from CM fax2\n"));
                    return -1;
            }

            if (!gstrcmp(name, T("sPort")))
            {
                    ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xFaxPortCfg.unPortStart);
            }
            else if (!gstrcmp(name, T("ePort")))
            {
                    ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xFaxPortCfg.unPortEnd);
            }
    }
     /* Add this statement to reduce multiple get request for IFX_CM_FA_T38_CFG */
    if (!gstrcmp(name, T("oldAsn")) || !gstrcmp(name, T("nsx")) || !gstrcmp(name, T("nsxinfo"))|| !gstrcmp(name, T("wtime")) ||
            !gstrcmp(name, T("hrPkt")) || !gstrcmp(name, T("lrPkt")) || !gstrcmp(name, T("priPkt")) ||
            !gstrcmp(name, T("frmLen")) || !gstrcmp(name, T("perCon")))
    {
            // Get Data from CM
            memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
            xCmMsg.ucMsgType = IFX_CM_GET_REQ;
            xCmMsg.ucInfoType = IFX_CM_FA_T38_CFG;
            xCmMsg.ucChannel = 0;

        if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
            {
                    ifx_httpdError(wp, 200, T("Fail to receive data from CM fax3\n"));
                    return -1;
            }

            if (!gstrcmp(name, T("oldAsn")))
            {
                   ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xT38Cfg.ucOldAsn1);			
            }
            else if (!gstrcmp(name, T("nsx")))
            {
                    ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xT38Cfg.ucNsxSize);
            }
            else if (!gstrcmp(name, T("nsxinfo")))
            {
                    ifx_httpdWrite(wp, T("%s"), xCmMsg.uxData.xT38Cfg.ucNsxInfoField);              
            }
            else if (!gstrcmp(name, T("wtime")))
            {
            	ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xT38Cfg.ucDataWaitTime);              
            }
            else if (!gstrcmp(name, T("hrPkt")))
            {
		ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xT38Cfg.unUdpHRErrRecPkts);
            }
            else if (!gstrcmp(name, T("lrPkt")))
            {
            	ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xT38Cfg.unUdpLRErrRecPkts);
            }
            else if (!gstrcmp(name, T("priPkt")))
            {
            	ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xT38Cfg.unUdpPriorFecPkts);                        
            }
            else if (!gstrcmp(name, T("frmLen")))
            {
		ifx_httpdWrite(wp, T("%d"), xCmMsg.uxData.xT38Cfg.unFrameLength);
            }
            else if (!gstrcmp(name, T("perCon")))
            {
                    if (xCmMsg.uxData.xT38Cfg.ucT38Conn == IFX_CM_FA_T38_CONN_UDP && !strcmp(mode1, "1"))
                            ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "1");
                    else if (xCmMsg.uxData.xT38Cfg.ucT38Conn == IFX_CM_FA_T38_CONN_TCP && !strcmp(mode1, "2"))
                            ifx_httpdWrite(wp,T("checked"));//ejSetResult(eid, "2");
       }
	}
#endif //#ifdef ATA
	return 0;
}

void ifx_set_voip_sip_fax(httpd_t wp, char_t *path, char_t *query)
{
#ifdef ATA
	  	  char_t  *pptl     = ifx_httpdGetVar(wp, T("ptl"), T(""));
        char_t  *pt38Ver  = ifx_httpdGetVar(wp, T("t38Ver"), T(""));
        char_t  *prateMgn = ifx_httpdGetVar(wp, T("rateMgn"), T(""));
        char_t  *pbitRate = ifx_httpdGetVar(wp, T("bitRate"), T(""));
        char_t  *poptFBR  = ifx_httpdGetVar(wp, T("optFBR"), T(""));
        char_t  *poptMMR  = ifx_httpdGetVar(wp, T("optMMR"), T(""));
        char_t  *poptJBIG = ifx_httpdGetVar(wp, T("optJBIG"), T(""));
        char_t  *pmaxbuf  = ifx_httpdGetVar(wp, T("maxbuf"), T(""));
        char_t  *pmaxData = ifx_httpdGetVar(wp, T("maxData"), T(""));
        char_t  *pecRed   = ifx_httpdGetVar(wp, T("ecRed"), T(""));
        char_t  *pecFec   = ifx_httpdGetVar(wp, T("ecFec"), T(""));
        char_t  *psPort   = ifx_httpdGetVar(wp, T("sPort"), T(""));
        char_t  *pePort   = ifx_httpdGetVar(wp, T("ePort"), T(""));
        char_t  *poldAsn  = ifx_httpdGetVar(wp, T("oldAsn"), T(""));
        char_t  *pnsx     = ifx_httpdGetVar(wp, T("nsx"), T(""));
        char_t  *pwtime   = ifx_httpdGetVar(wp, T("wtime"), T(""));
        char_t  *phrPkt   = ifx_httpdGetVar(wp, T("hrPkt"), T(""));
        char_t  *plrPkt   = ifx_httpdGetVar(wp, T("lrPkt"), T(""));
        char_t  *ppriPkt  = ifx_httpdGetVar(wp, T("priPkt"), T(""));
        char_t  *pfrmLen  = ifx_httpdGetVar(wp, T("frmLen"), T(""));
        char_t  *pperCon  = ifx_httpdGetVar(wp, T("perCon"), T(""));
        char_t  *pnsxinfo = ifx_httpdGetVar(wp, T("nsxinfo"),T(""));
        x_IFX_CM_Msg xCmMsg;
	
	
        a_assert(wp);
        memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	     xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	     xCmMsg.ucInfoType = IFX_CM_RM_FAX_CFG;
	     xCmMsg.ucChannel = 0;

        if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
        {
             ifx_httpdError(wp, 200, T("Fail to receive data form CM Fax1\n"));
				 return ;
	     }
		 
    //set IFX_CM_RM_FAX_CFG info then
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_RM_FAX_CFG;
    xCmMsg.ucChannel = 0;

        if (poptFBR[0])
        {
                xCmMsg.uxData.xFaxCfg[1].uiBitOptions |= IFX_CM_RM_CAP_FL_OPT_FILL_BIT_REMOVAL;
        }
        if (poptMMR[0])
        {
                xCmMsg.uxData.xFaxCfg[1].uiBitOptions |= IFX_CM_RM_CAP_FL_OPT_TRANSCODING_MMR;
        }
        if (poptJBIG[0])
        {
                xCmMsg.uxData.xFaxCfg[1].uiBitOptions |= IFX_CM_RM_CAP_FL_OPT_TRANSCODING_JBIG;
        }
        if ( gatoi(pptl) > 0)
		  {
          xCmMsg.uxData.xFaxCfg[1].uiTransportProtocol = gatoi(pptl);
          xCmMsg.uxData.xFaxCfg[1].ucVersion = gatoi(pt38Ver);
          xCmMsg.uxData.xFaxCfg[1].ucRateManagement = gatoi(prateMgn);
          xCmMsg.uxData.xFaxCfg[1].unMaxBitRate = gatoi(pbitRate);
          xCmMsg.uxData.xFaxCfg[1].unUDPMaxBufferSize = gatoi(pmaxbuf);
          xCmMsg.uxData.xFaxCfg[1].unUDPMaxDatagramSize = gatoi(pmaxData);
		 }
		 else
		 {
          xCmMsg.uxData.xFaxCfg[0].uiTransportProtocol = gatoi(pptl);
          xCmMsg.uxData.xFaxCfg[0].ucVersion = gatoi(pt38Ver);
          xCmMsg.uxData.xFaxCfg[0].ucRateManagement = gatoi(prateMgn);
          xCmMsg.uxData.xFaxCfg[0].unMaxBitRate = gatoi(pbitRate);
		 }
        if (pecRed[0])
        {
                xCmMsg.uxData.xFaxCfg[1].ucUDPErrCorrection |= IFX_CM_RM_CAP_FL_EC_REDUNDANCY;
        }
         if (pecFec[0])
        {
                xCmMsg.uxData.xFaxCfg[1].ucUDPErrCorrection |= IFX_CM_RM_CAP_FL_EC_FEC;
        }

    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
                ifx_httpdError(wp, 200, T("Fail to send IFX_CM_RM_FAX_CFG data to CM"));
                return;
    }

    //set IFX_CM_FA_T38_CFG info then
    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_FA_T38_CFG;
    xCmMsg.ucChannel = 0;

        xCmMsg.uxData.xT38Cfg.ucOldAsn1 = gatoi(poldAsn);
        xCmMsg.uxData.xT38Cfg.ucNsxSize = gatoi(pnsx);
        gstrcpy(xCmMsg.uxData.xT38Cfg.ucNsxInfoField, pnsxinfo);
        xCmMsg.uxData.xT38Cfg.ucDataWaitTime = gatoi(pwtime);
        xCmMsg.uxData.xT38Cfg.unUdpHRErrRecPkts = gatoi(phrPkt);
        xCmMsg.uxData.xT38Cfg.unUdpLRErrRecPkts = gatoi(plrPkt);
        xCmMsg.uxData.xT38Cfg.unUdpPriorFecPkts = gatoi(ppriPkt);
        xCmMsg.uxData.xT38Cfg.unFrameLength = gatoi(pfrmLen);

        if ( !gstrcmp(pperCon, "1") )
        {
                xCmMsg.uxData.xT38Cfg.ucT38Conn =IFX_CM_FA_T38_CONN_UDP;
        }
        else
        {
                xCmMsg.uxData.xT38Cfg.ucT38Conn = IFX_CM_FA_T38_CONN_TCP;
        }
 if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
                ifx_httpdError(wp, 200, T("Fail to send IFX_CM_FA_T38_CFG data to CM"));
                return;
    }

    //set IFX_CM_SIP_CFG_FAX_PORT info then

    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_SIP_CFG_FAX_PORT;
    xCmMsg.ucChannel = 0;

    xCmMsg.uxData.xFaxPortCfg.unPortStart = gatoi(psPort);
    xCmMsg.uxData.xFaxPortCfg.unPortEnd = gatoi(pePort);

    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
                ifx_httpdError(wp, 200, T("Fail to send IFX_CM_SIP_CFG_FAX_PORT data to CM"));
                return;
    }
#endif /* end of ATA */
        ifx_httpdNextPage(wp);
}
