/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>


int ifx_get_voip_sip_gw(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	sValue[MAX_DATA_LEN];
	x_IFX_CM_Msg xCmMsg;
	
   	
   	//SIP Gateway
   	// Get Data from CM
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));  
   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_GATEWAY;		
	xCmMsg.ucChannel = 0;
    
    if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		ifx_httpdError(wp, 200, T("Fail to receive GATEWAY data from CM\n"));
		return -1;
	}
         
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return -1;
	}

 	memset(sValue, 0x00, MAX_DATA_LEN);  	
   	
   	if (!gstrcmp(name, T("IP1")))
   	{
		if (xCmMsg.uxData.xGatewayCfg.cGatewayAddr[0])
		{
   		  websGetPartIP(xCmMsg.uxData.xGatewayCfg.cGatewayAddr, 1, sValue);
   		  ifx_httpdWrite(wp, sValue);   
		}
		else
		{
      		  ifx_httpdWrite(wp, "");
		}
   	}
   	else if (!gstrcmp(name, T("IP2")))
   	{
		if (xCmMsg.uxData.xGatewayCfg.cGatewayAddr[0])
		{
   		  websGetPartIP(xCmMsg.uxData.xGatewayCfg.cGatewayAddr, 2, sValue);
   		  ifx_httpdWrite(wp, sValue);  
		}
		else
		{
      		  ifx_httpdWrite(wp, "");
		}
		 
   	}   	
   	else if (!gstrcmp(name, T("IP3")))
   	{
		if (xCmMsg.uxData.xGatewayCfg.cGatewayAddr[0])
		{
   		  websGetPartIP(xCmMsg.uxData.xGatewayCfg.cGatewayAddr, 3, sValue);
   		  ifx_httpdWrite(wp, sValue);
		}
		else
		{
 		  ifx_httpdWrite(wp, "");
		}   
   	}  	
   	else if (!gstrcmp(name, T("IP4")))
   	{
		if (xCmMsg.uxData.xGatewayCfg.cGatewayAddr[0])
		{
   		 websGetPartIP(xCmMsg.uxData.xGatewayCfg.cGatewayAddr, 4, sValue);
   		 ifx_httpdWrite(wp, sValue);
		}
		else
		{
 		  ifx_httpdWrite(wp, "");
		}     
		 
   	}
    else if (!gstrcmp(name, T("port")))
   	{
   		ifx_httpdWrite(wp, "%d", xCmMsg.uxData.xGatewayCfg.unGatewayPort);   
   	}  	  
   	
   	
   	
   	//RTP Port Range   	
  	
   	
   	// Get Data from CM
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));  
   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_RTPPORTRANGE;		
	xCmMsg.ucChannel = 0;			
     	if (IFX_CM_RecvDataFromCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		ifx_httpdError(wp, 200, T("Fail to receive RTP data from CM\n"));
		return -1;
	}   
   
 	memset(sValue, 0x00, MAX_DATA_LEN);  	
   	
   	if (!gstrcmp(name, T("sport")))
   	{
   	
   		ifx_httpdWrite(wp, "%d", xCmMsg.uxData.xRtpCfg.unStartRTPPort);   
   	}  	
    	else if (!gstrcmp(name, T("eport")))
   	{
		ifx_httpdWrite(wp, "%d", xCmMsg.uxData.xRtpCfg.unEndRTPPort);
   	}     	
   	
   		
	return 0;
}


void ifx_set_voip_sip_gw(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pIP1 = ifx_httpdGetVar(wp, T("IP1"), T(""));	
	char_t	*pIP2 = ifx_httpdGetVar(wp, T("IP2"), T(""));	
	char_t	*pIP3 = ifx_httpdGetVar(wp, T("IP3"), T(""));	
	char_t	*pIP4 = ifx_httpdGetVar(wp, T("IP4"), T(""));
	char_t	*pPort = ifx_httpdGetVar(wp, T("port"), T(""));	
	char_t	*pSPort = ifx_httpdGetVar(wp, T("sport"), T(""));
	char_t	*pEPort = ifx_httpdGetVar(wp, T("eport"), T(""));
	
	char_t  sIPAddr[MAX_FILELINE_LEN];
	x_IFX_CM_Msg xCmMsg;
			
	a_assert(wp);
	memset(sIPAddr, 0x00, MAX_FILELINE_LEN);
	
	if (pIP1 == 0 || pIP2 == 0 || pIP3 == 0 || pIP4 ==0 ||
		pPort == 0 ||pSPort==0 ||pEPort == 0)
	{                               
		ifx_httpdError(wp, 200, T("Setup Error"));
		return;                     
	}   
	
	if (atoi(pIP1) > 255 || atoi(pIP1) < 0 || atoi(pIP2) > 255 || atoi(pIP2) < 0 ||
	    atoi(pIP3) > 255 || atoi(pIP3) < 0 || atoi(pIP4) > 255 || atoi(pIP4) < 0)
	{                               
		ifx_httpdError(wp, 200, T("IP Address Error"));
		return;                     
	}
	
	if (atoi(pPort) !=0)
	{
	if (atoi(pPort) > 32768 || atoi(pPort) < 1024)
	{                               
		ifx_httpdError(wp, 200, T("Port number Error"));
		return;                     
	}
	}
	
	if (atoi(pSPort) > 32768 || atoi(pSPort) < 1024)
	{                               
		ifx_httpdError(wp, 200, T("Start Port number Error"));
		return;                     
	}
	
	if (atoi(pEPort) > 32768 || atoi(pEPort) < 1024)
	{                               
		ifx_httpdError(wp, 200, T("End Port number Error"));
		return;                     
	}
		
	gsprintf(sIPAddr, "%s.%s.%s.%s", pIP1, pIP2, pIP3, pIP4); 
	   
	 //set gateway info first  
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));  
       	xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_GATEWAY;
	xCmMsg.ucChannel = 0;	
 	strcpy(xCmMsg.uxData.xGatewayCfg.cGatewayAddr,sIPAddr); 		
	xCmMsg.uxData.xGatewayCfg.unGatewayPort = atoi(pPort);
		
    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
		ifx_httpdError(wp, 200, T("Fail to send GATEWAY data to CM"));
		return;     	
    }
    
    //set RTP Port Range info then   
    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));  
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_SIP_CFG_RTPPORTRANGE;

    xCmMsg.uxData.xRtpCfg.unStartRTPPort = atoi(pSPort);
    xCmMsg.uxData.xRtpCfg.unEndRTPPort = atoi(pEPort);
	
	if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
		ifx_httpdError(wp, 200, T("Fail to send RTP data to CM"));
		return;     	
    }
//	websSuccess(wp);
	ifx_httpdNextPage(wp);
}

