/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_wan_pppoe(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name, sValue[MAX_FILELINE_LEN];
	char_t	command[MAX_FILELINE_LEN];
	int		nValue = 0;

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);
   	memset(command, 0x00, MAX_FILELINE_LEN);

   	if ( !gstrcmp(name, T("UserName")) )
	{
                if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPPOE, "PPPOE_USERNAME", sValue) == 1 )
                {
	               if ( !gstrcmp(sValue, "0") )  //DHCP Enable
        	       {
                	    gstrcpy(sValue, "");
				   }
				   
                   ifx_httpdWrite(wp, T("%s"), sValue);
                }

	}
	else
	if ( !gstrcmp(name, T("Password")) )
	{
                if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPPOE, "PPPOE_PASSWORD", sValue) == 1 )
                {
	               if ( !gstrcmp(sValue, "0") )  //DHCP Enable
        	       {
              	        gstrcpy(sValue, "");
			       }
                        ifx_httpdWrite(wp, T("%s"), sValue);
                }

	}
	else
	if ( !gstrcmp(name, T("PasswordVerify")) )
	{
                if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPPOE, "PPPOE_PASSWORD", sValue) == 1 )
                {
	               if ( !gstrcmp(sValue, "0") )  //DHCP Enable
        	       {
                	        gstrcpy(sValue, "");
			}
                        ifx_httpdWrite(wp, T("%s"), sValue);
                }

	}
	else
	if ( !gstrcmp(name, T("ServiceName")) )
	{
                if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPPOE, "PPPOE_SERVICENAME", sValue) == 1 )
                {
	               if ( !gstrcmp(sValue, "0") )  //DHCP Enable
        	        {
                	        gstrcpy(sValue, "");
                	}
       
      		        ifx_httpdWrite(wp, T("%s"), sValue);
                }

	}
	else
	if ( !gstrcmp(name, T("MTU")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPPOE, "PPPOE_MTU", sValue) == 1 )
		{
			ifx_httpdWrite(wp, T("%s"), sValue);
		}
	}
	else
	if ( !gstrcmp(name, T("IdleTime")) )
	{
        if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPPOE, "PPPOE_IDLE", sValue) == 1 )
        {
        	if (sValue[0])
			{
				nValue = gatoi(sValue);
				nValue = nValue / 60;
				gsprintf(sValue, T("%d"), nValue);
			}			
			ifx_httpdWrite(wp, T("%s"), sValue);
        }

	}
	else
	if ( !gstrcmp(name, T("Reconnect")) )
	{
                if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPPOE, "PPPOE_DEMAND", sValue) == 1 )
                {
                       // ifx_httpdWrite(wp, T("%s"), sValue);
            		if(strncmp(sValue,"1",1) == 0 ){
 				ifx_httpdWrite(wp,T("checked"));
			}else if(strncmp(sValue,"0",1) == 0){
				ifx_httpdWrite(wp,T(""));
			}
                }
	}
	else
	if ( !gstrcmp(name, T("IsReconnect")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_PPPOE, "PPPOE_DEMAND", sValue) == 1 )
		{
			if (gstrcmp(sValue, "1") == 0)
				ifx_httpdWrite(wp, T("true"));
			else
			if (gstrcmp(sValue, "0") == 0)
				ifx_httpdWrite(wp, T("false"));
		}
	}
	
	return 0;
}

void ifx_set_wan_pppoe(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pUN, *pPWV, *pSN, *pMTU, *pIdle, *pReconnect;
	char_t	sUN[MAX_NAME_LEN], sSN[MAX_NAME_LEN], sPwd[MAX_NAME_LEN], sMTU[MAX_DATA_LEN], sDemand[MAX_DATA_LEN], sIdle[MAX_DATA_LEN];
	char_t	command[MAX_FILELINE_LEN];
	int		nIdle = 0;

#ifdef ATA
    x_IFX_CM_Msg xCmMsg;
#endif

	a_assert(wp);
	memset(command, 0x00, MAX_FILELINE_LEN);
	memset(sPwd, 0x00, MAX_NAME_LEN);

	// Get value from ASP file
	pUN = ifx_httpdGetVar(wp, T("UN"), T(""));
	pPWV = ifx_httpdGetVar(wp, T("PWV"), T(""));
	pSN = ifx_httpdGetVar(wp, T("SN"), T(""));
	pMTU = ifx_httpdGetVar(wp, T("MTU"), T(""));
	pIdle = ifx_httpdGetVar(wp, T("idle"), T(""));
	pReconnect = ifx_httpdGetVar(wp, T("reconnect"), T(""));

#ifdef ATA
	// Populate the structure of CM
	memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
	xCmMsg.ucChannel =0;
	if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
	{
		if (connection.allowed == 1)
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		else
		{
			ifx_httpdError(wp, 200, T("Cant send Data to CM"));
		}
		return;
	}
	if (xCmMsg.ucMsgType == IFX_CM_SET_ERR_RSP)
	{
		ifx_httpdError(wp, 200, T("Call in Progress Cant Change Network Config"));
		return;
	}
#endif

	if (pReconnect && *pReconnect)
	{
		if (pIdle && *pIdle)
		{
			nIdle = gatoi(pIdle);
			nIdle = nIdle * 60;
			gsprintf(sDemand, T("PPPOE_DEMAND=1\n"));			// Not support, always 0, 2004/02/12, jeffrey said
			gsprintf(sIdle, T("PPPOE_IDLE=%d\n"), nIdle);

		}
	}
	else
	{
		gsprintf(sDemand, T("PPPOE_DEMAND=0\n"));
		if (pIdle && *pIdle)   //modofied 2005/04
		{
		      nIdle = gatoi(pIdle);
			nIdle = nIdle * 60;			
			gsprintf(sIdle, T("PPPOE_IDLE=%d\n"), nIdle);
		}
		else
		gsprintf(sIdle, T("PPPOE_IDLE=0\n"));
	}

	if (pSN && *pSN)
		gsprintf(sSN,  T("PPPOE_SERVICENAME=%s\n"), pSN);
	else
		gsprintf(sSN,  T("PPPOE_SERVICENAME=0\n"));   

	gsprintf(sUN,  T("PPPOE_USERNAME=%s\n"), pUN);
	gsprintf(sPwd, T("PPPOE_PASSWORD=%s\n"), pPWV);
	gsprintf(sMTU, T("PPPOE_MTU=\"%s\"\n"), pMTU);
	websSetCfgData(FILE_RC_CONF, TAG_WAN_PPPOE, 6, sUN, sPwd, sMTU, sSN, sDemand, sIdle );

	ifx_get_check_wan_mode(0, T("PPPOE"));

	// Update Wan Mode to rc.conf
	gsprintf(command, "ipoption_adm1=\"PPPOE\"\n");
	websSetCfgData(FILE_RC_CONF, TAG_WAN_MAIN, 1,  command);

	//RunTime change.
#ifdef ATA
	system(SERVICE_RC_VOIP_STOP);
#endif //#ifdef ATA

	system(SERVICE_PPPOE_START);
#ifdef ATA
	system(SERVICE_RC_VOIP_RESTART);
#endif //#ifdef ATA

	system(SERVICE_RESTORE);
	ifx_httpdNextPage(wp);
}


