/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>


void ifx_set_wizard_dns(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pDIP11, *pDIP12, *pDIP13, *pDIP14;
	char_t	*pDIP21, *pDIP22, *pDIP23, *pDIP24;
	char_t	sDns1[MAX_FILELINE_LEN], sDns2[MAX_FILELINE_LEN];
	char_t	sCommand[MAX_FILELINE_LEN];

	a_assert(wp);
	memset(sDns1, 0x00, MAX_FILELINE_LEN);
	memset(sDns2, 0x00, MAX_FILELINE_LEN);
	memset(sCommand, 0x00, MAX_FILELINE_LEN);
	
	// Get value from ASP file
	pDIP11 = ifx_httpdGetVar(wp, T("DIP11"), T(""));
	pDIP12 = ifx_httpdGetVar(wp, T("DIP12"), T(""));
	pDIP13 = ifx_httpdGetVar(wp, T("DIP13"), T(""));
	pDIP14 = ifx_httpdGetVar(wp, T("DIP14"), T(""));
	pDIP21 = ifx_httpdGetVar(wp, T("DIP21"), T(""));
	pDIP22 = ifx_httpdGetVar(wp, T("DIP22"), T(""));
	pDIP23 = ifx_httpdGetVar(wp, T("DIP23"), T(""));
	pDIP24 = ifx_httpdGetVar(wp, T("DIP24"), T(""));

	if ( pDIP11[0] && pDIP12[0] && pDIP13[0] && pDIP14[0] &&
		 pDIP21[0] && pDIP22[0] && pDIP23[0] && pDIP24[0])
	{
		gsprintf(sDns1, T("dns1=\"%s.%s.%s.%s\"\n"), pDIP11, pDIP12, pDIP13, pDIP14);		
		gsprintf(sDns2, T("dns2=\"%s.%s.%s.%s\"\n"), pDIP21, pDIP22, pDIP23, pDIP24);
	}
	else if (pDIP11[0] && pDIP12[0] && pDIP13[0] && pDIP14[0])
	{
		gsprintf(sDns1, T("dns1=\"%s.%s.%s.%s\"\n"), pDIP11, pDIP12, pDIP13, pDIP14);		
		gsprintf(sDns2, T("dns2=\"0.0.0.0\"\n"));
	}

	websSetCfgData(FILE_RC_CONF, TAG_WAN_DNS, 2, sDns1, sDns2);
	
	//RunTime change.
#ifdef ATA
	system(SERVICE_RC_VOIP_STOP);
#endif //#ifdef ATA

	system(SERVICE_DNS_START);
	system(SERVICE_DNRD_RESTART);

#ifdef ATA
	system(SERVICE_RC_VOIP_RESTART);
#endif //#ifdef ATA

	system(SERVICE_RESTORE);
	ifx_httpdNextPage(wp);
}

