/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

int ifx_get_change_wan_mode(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t	sCurrentWan[MAX_DATA_LEN];

	memset(sCurrentWan, 0x00, MAX_DATA_LEN);

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
   	{
   		ifx_httpdError(wp, 400, T("Insufficient args\n"));
   		return -1;
   	}

	ifx_get_check_wan_mode(wp, name);
}


void ifx_set_wizard_fixedip(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pIP1 = ifx_httpdGetVar(wp, T("IP1"), T(""));
	char_t	*pIP2 = ifx_httpdGetVar(wp, T("IP2"), T(""));
	char_t	*pIP3 = ifx_httpdGetVar(wp, T("IP3"), T(""));
	char_t	*pIP4 = ifx_httpdGetVar(wp, T("IP4"), T(""));
	char_t	*pNM1 = ifx_httpdGetVar(wp, T("NM1"), T(""));
	char_t	*pNM2 = ifx_httpdGetVar(wp, T("NM2"), T(""));
	char_t	*pNM3 = ifx_httpdGetVar(wp, T("NM3"), T(""));
	char_t	*pNM4 = ifx_httpdGetVar(wp, T("NM4"), T(""));
	char_t	*pGIP1 = ifx_httpdGetVar(wp, T("GIP1"), T(""));
	char_t	*pGIP2 = ifx_httpdGetVar(wp, T("GIP2"), T(""));
	char_t	*pGIP3 = ifx_httpdGetVar(wp, T("GIP3"), T(""));
	char_t	*pGIP4 = ifx_httpdGetVar(wp, T("GIP4"), T(""));
#ifdef IIP
	char_t	*pDhcp = ifx_httpdGetVar(wp, T("dhcp"), T(""));	
#endif
	char_t 	sCommand[MAX_FILELINE_LEN];
	char_t 	sIP[MAX_DATA_LEN], sNM[MAX_DATA_LEN], sGIP[MAX_DATA_LEN];
	char_t	sIfconfig_adm1[MAX_FILELINE_LEN], sDefaultRouter[MAX_FILELINE_LEN];
	char_t 	sAliasStatus[MAX_DATA_LEN];

	 
#if defined(ATA) || defined(IIP)
        x_IFX_CM_Msg xCmMsg;
#endif
	 
	if ( pIP1 == 0 || gatoi(pIP1) > 255 || pIP2 == 0 || gatoi(pIP2) > 255 ||
         pIP3 == 0 || gatoi(pIP3) > 255 || pIP4 == 0 || gatoi(pIP4) > 255)
	{
    	ifx_httpdError(wp, 204, "Invalidate IP address"); 
    	return;
	}

	if ( pNM1 == 0 || gatoi(pNM1) > 255 || pNM2 == 0 || gatoi(pNM2) > 255 ||
         pNM3 == 0 || gatoi(pNM3) > 255 || pNM4 == 0 || gatoi(pNM4) > 255)
	{
    	ifx_httpdError(wp, 204, "Invalidate Netmask IP address"); 
    	return;
	}

	if ( pGIP1 == 0 || gatoi(pGIP1) > 255 ||  pGIP2 == 0 || gatoi(pGIP2) > 255 ||
         pGIP3 == 0 || gatoi(pGIP3) > 255 ||  pGIP4 == 0 || gatoi(pGIP4) > 255)
	{
    	ifx_httpdError(wp, 204, "Invalidate Getway IP address"); 
    	return;
	}

	// Collect data
	gsprintf(sIP,  T("%s.%s.%s.%s"), pIP1, pIP2, pIP3, pIP4);
	gsprintf(sNM, T("%s.%s.%s.%s"), pNM1, pNM2, pNM3, pNM4);
	gsprintf(sGIP, T("%s.%s.%s.%s"), pGIP1, pGIP2, pGIP3, pGIP4);

#ifdef ATA
   /* Populate the structure of CM*/
	   memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	   xCmMsg.ucMsgType = IFX_CM_SET_REQ;
	   xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
	   xCmMsg.ucChannel =0;
	   strcpy(xCmMsg.uxData.xNetAddrCfg.aucIPAddress, sIP);
	   strcpy(xCmMsg.uxData.xNetAddrCfg.aucSubnetMask, sNM);

	   if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
	   {
	   	if (connection.allowed == 1)
		{
			ifx_httpdRedirect(wp, "voip_status_return.htm");
		}
		else
		{
	         ifx_httpdError(wp, 200, T("Cant send Data to CM"));
	    }
	      return;
	   }
	   if (xCmMsg.ucMsgType == IFX_CM_SET_ERR_RSP)
	   {
	     ifx_httpdError(wp, 200, T("Call in Progress Cant Change Network Config"));
	     return;
	   }
#endif
	                                
	gsprintf(sIfconfig_adm1, T("ifconfig_adm1=\"%s netmask %s\"\n"), sIP, sNM);
	gsprintf(sDefaultRouter, T("default_router=\"%s\"\n"), sGIP);

	memset (sAliasStatus, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, T("aliasStatus"), sAliasStatus) == 0)
	{		
		ifx_httpdError(wp, 200, T("Cannot get idle time."));
		return ;
	}
	
	if ( !gstrcmp(sAliasStatus, "Enable") )	//Enable Alias IP
	{
		gsprintf(sAliasStatus, "aliasStatus=\"Enable\"\n");
	}
	else
	{
		gsprintf(sAliasStatus, "aliasStatus=\"Disable\"\n");
	}
	
	//Update rc.conf
	websSetCfgData(FILE_RC_CONF, TAG_WAN_STATIC, 3, sIfconfig_adm1, sDefaultRouter, sAliasStatus);

	// Reset All WAN connection in advance, this service will reset IP as well
	system(SERVICE_WAN_STOP);

	// Runtime update
	gsprintf(sCommand, T("ifconfig %s %s netmask %s"), ADM_WAN_IF, sIP, sNM);	
	system(sCommand); 
	gsprintf(sCommand, T("/sbin/route add default gw %s"), sGIP);
	system(sCommand);

	ifx_get_check_wan_mode(0, T("FIXED"));

	// Runtime update
	// Move to update file
	// Update Wan Mode
	gsprintf(sCommand, "ipoption_adm1=\"FIXED\"\n");		
	websSetCfgData(FILE_RC_CONF, TAG_WAN_MAIN, 1,  sCommand);

#ifdef IIP
	  /* Populate the structure of CM*/
     		memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
	       xCmMsg.ucMsgType = IFX_CM_SET_REQ;
 	       xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
     		xCmMsg.ucChannel =0;
     		strcpy(xCmMsg.uxData.xNetAddrCfg.aucIPAddress, sIP);
     		strcpy(xCmMsg.uxData.xNetAddrCfg.aucSubnetMask, sNM);
     		xCmMsg.uxData.xNetAddrCfg.ucDhcp = gatoi(pDhcp);
     		if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
     		{
     			if (connection.allowed == 1)
				{
					ifx_httpdRedirect(wp, "voip_status_return.htm");
				}
				else
				{
       		                ifx_httpdError(wp, 200, T("Call in Progress Cant Change Network Config"));
		       	}
       		return;
     		}
	 	 else
	  	{
        		if (gatoi(pDhcp) > 0)
        		{
           			system("/sbin/fw_setenv dhcp on");
           			system("/etc/init.d/udhcpc start");
	       	 	ifx_httpdNextPage(wp);               
		 	}
    		}
   		return;
#else
	//RunTime change.

#ifdef ATA
	system(SERVICE_RC_VOIP_STOP);
#endif //#ifdef ATA

	system("/etc/rc.d/rc.service");

#ifdef ATA
	system(SERVICE_RC_VOIP_RESTART);
#endif //#ifdef ATA

	system(SERVICE_RESTORE);
	ifx_httpdNextPage(wp);
#endif
}

