/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include	 <netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>

extern int g_nCurrentAPMode;


#if (defined(SPURS) || defined(WILDPASS))
int ifx_get_wlan_11hsettings(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name, sValue[MAX_FILELINE_LEN];
	int		i, nSelIdx = 0;
	int          nDFS =0;		
	int          nTPC =0;	
	

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);      

	if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_11HSETTINGS, "WLAN_11H_STATUS", sValue) == 1 )
	{
			//if ( !gstrcmp(sValue, "YES") )
			if ( !gstrcmp(sValue, "1") )
			{
				//TPC=1
				nTPC=1;
				nDFS=0;
				//ifx_httpdWrite(wp,"checked");
			}
			else if ( !gstrcmp(sValue, "2") )
			{
				//DFS=1,TPC=0
				nTPC=0;
				nDFS=1;
			}
			else if ( !gstrcmp(sValue, "3") )
			{
				//DFS=1,TPC=1
				nTPC=1;
				nDFS=1;
			}
	}
	
   	
	if ( !gstrcmp(name, T("DFSstatus")) )
	{
		
			//if ( !gstrcmp(sValue, "YES") )
			if (nDFS==1)
			{
				
				ifx_httpdWrite(wp,"checked");
			}
			else
			{
				//gstrcpy(sValue, "0");
				ifx_httpdWrite(wp,"");
			}
		
	}
	else
	if ( !gstrcmp(name, T("TPCstatus")) )
	{
		
			//if ( !gstrcmp(sValue, "YES") )
			if (nTPC==1)
			{
				
				ifx_httpdWrite(wp,"checked");
			}
			else
			{
				//gstrcpy(sValue, "0");
				ifx_httpdWrite(wp,"");
			}
		
	}
	else
	if ( !gstrcmp(name, T("opmode_IsDisable")) )
	{
		    if (ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_OP_RATE", sValue) == 1)
           	     {
             		  if ( !gstrcmp(sValue, "4") )       //11a Mode
            		     ifx_httpdWrite(wp,"");
			  else
			     ifx_httpdWrite(wp,"disabled");
		     }		
		
	}
	 
		
	

	return 0;
}


void ifx_set_wlan_11hsettings(httpd_t wp, char_t *path, char_t *query)
{
       char_t	sValue[MAX_FILELINE_LEN];
	char_t	*pDFSstatus= ifx_httpdGetVar(wp, T("DFSstatus"), T(""));
	char_t     *pTPCstatus = ifx_httpdGetVar(wp, T("TPCstatus"), T(""));
	char_t	s11hstatus[MAX_DATA_LEN];
	char_t	command[MAX_FILELINE_LEN];
       int          nbTPC=0;
	int          nbDFS=0;  
	int          n11H=0;

	

	memset(sValue, 0x00, MAX_FILELINE_LEN);	
	memset(s11hstatus, 0x00, MAX_DATA_LEN);
	//memset(sTPCstatus, 0x00, MAX_DATA_LEN);

	ifx_debug_printf("---enter ifx_set_wlan_11hsettings---\n");

	//memset(sDisableIfCmd, 0x00, MAX_DATA_LEN);
	//if (!gstrcmp(pDFSstatus, T("1")))
	if (pDFSstatus && *pDFSstatus)
	{
		//gsprintf(sDFSstatus, "WLAN_DFS_STATUS=\"1\"\n");
		//gsprintf(sDisableIfCmd, "ifconfig %s up", ADM_WLAN_IF);
		nbDFS=1;//enable
		ifx_debug_printf("---DFS -1---\n");
	}
	

	//if (!gstrcmp(pTPCstatus, T("1")))
	if (pTPCstatus && *pTPCstatus)
	{
		//gsprintf(sTPCstatus, "WLAN_TPC_STATUS=\"1\"\n");
		//gsprintf(sDisableIfCmd, "ifconfig %s up", ADM_WLAN_IF);
		nbTPC=1;
		ifx_debug_printf("---TPC -1---\n");
	}
	
	
	if (nbTPC==1)
	{
	   if (nbDFS==1)
	   {
	   	gsprintf(command, T("iwpriv eth0 11hflag 3"));    //DFS=1,TPC=1
	   	gsprintf(s11hstatus, "WLAN_11H_STATUS=\"3\"\n");
	   }
	   else
         {
	   	gsprintf(command, T("iwpriv eth0 11hflag 1"));    //DFS=0,TPC=1
	   	gsprintf(s11hstatus, "WLAN_11H_STATUS=\"1\"\n");
	   }
	}
	else
	{
	   if (nbDFS==1)
	   {
	   	gsprintf(command, T("iwpriv eth0 11hflag 2"));    //DFS=1,TPC=0
	   	gsprintf(s11hstatus, "WLAN_11H_STATUS=\"2\"\n");
	   }
	   else
         {
	   	gsprintf(command, T("iwpriv eth0 11hflag 0"));    //DFS=0,TPC=0
	   	gsprintf(s11hstatus, "WLAN_11H_STATUS=\"0\"\n");
	  } 	
	}

	
	
	ifx_debug_printf ("----- 11H setting: %s---\n",command);

	//websSetCfgData(FILE_RC_CONF, TAG_WLAN_11HSETTINGS, 2, sDFSstatus, sTPCstatus	); //old
	websSetCfgData(FILE_RC_CONF, TAG_WLAN_11HSETTINGS, 1, s11hstatus);

	//websSetCfgData(FILE_RC_CONF, TAG_WLAN_STATUS, 1,sWlanInterface );


	system(SERVICE_RESTORE);

	memset(command, 0x00, MAX_FILELINE_LEN);
	

	
	system(command);
	//system(sDisableIfCmd);
	system(SERVICE_WLAN);
	ifx_httpdNextPage(wp);	                                
	sleep(3);
}
#endif //#if defined(WILDPASS) || (defined(GATEWAY) && defined(SPURS))


