/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"
#include 	"ifx_httpd_method.h"

#include 	"ifx_common_defs.h"
#include	"ifx_web_common.h"
#include	<sys/reboot.h>

void ifx_Wireless_PageTitle(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name;
	char_t  str[20];

	memset(str, 0x00, 20);
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 200, T("Insufficient args\n"));
		return ;
	}	

#if defined(SPURS) && defined (ATA)
	strcpy(str, "WATA");
#endif
#if defined(SPURS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

#if defined(WILDPASS) && defined(GATEWAY)
	strcpy(str, "Wireless Router");
#endif

	if (!gstrcmp(name, T("Wireless_mainpage")))
	{
		ifx_httpdWrite(wp,"The %s have provides wireless interface.",str);
	}else
	if (!gstrcmp(name, T("Wireless_Settingpage")))
	{
		ifx_httpdWrite(wp,"You can configuration wireless settings about Channel ID, ESSID....etc.");
	}else
	if (!gstrcmp(name, T("Wireless_Securitypage")))
	{
		ifx_httpdWrite(wp,"You can setting Encryption type and Authentication type ...etc.");
	}
#ifdef WILDPASS
	if (!gstrcmp(name, T("Wireless_APModepage")))
	{
		ifx_httpdWrite(wp,"The AP mode allows the user to specify the mode settings for the Access Point.\n"
             " This selection allows this AP to perform as an AP/ AP client/ WDS Repeater for other wireless devices to connect.");
	}else
	if (!gstrcmp(name, T("Wireless_QoSSettingpage")))
        {
                ifx_httpdWrite(wp,"QoS on wireless LANs provides prioritization of traffic based on traffice classification.");
        }else
	if (!gstrcmp(name, T("Wireless_WDSSettingpage")))
	{
		ifx_httpdWrite(wp,"The Wireless Distribution System(WDS) allows the user to connect to other AP through wireless.");
	}else
	if (!gstrcmp(name, T("Wireless_11hSettingpage")))
	{
		ifx_httpdWrite(wp,"802.11h defines mechanisms for dynamic frequency selection (DFS) and transmit power control (TPC)" 
				  " that may be used to satisfy requirements for operation in the 5 GHz band.");
	}
	

#endif //#ifdef WILDPASS
}

