/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#include	"ifx_emf.h"
#include	<signal.h>
#include	<unistd.h> 
#include	<sys/types.h>
#include	<sys/wait.h>
#include 	<sys/socket.h>
#include 	<sys/ioctl.h>
#include 	<arpa/inet.h>
#include 	<netinet/in.h>
#include 	<net/if.h>
#include 	<net/if_arp.h>
#include	<ifx_common.h>
#include	"./ifx_src_cgi.h"

#include 	"ifx_httpd_method.h"
#include 	"ifx_common_defs.h"

#if defined(ATA) || defined(IIP)
#include 	"ifx_iip_fifos.h"
#include 	"ifx_cm.h"
#endif

#include	"ifx_web_common.h"
#include	<sys/reboot.h>


#if defined(SPURS) || defined(WILDPASS)
int websGetIPAddress(const char_t* Tag, const char_t* symbol, int nReqIdx,  char_t* pRetValue)
{	
	char_t	sFullIPValue[MAX_FILELINE_LEN];
	char_t	sIpaddr[MAX_DATA_LEN];
	char_t	*ip;
	int		i = 0;
	int 	nIndex = 0;
	
	memset(sFullIPValue, 0x00, MAX_FILELINE_LEN);
	memset(sIpaddr, 0x00, MAX_DATA_LEN);
	gstrcpy(pRetValue, "");

	if (ifx_GetCfgData(FILE_RC_CONF, Tag,  symbol, sFullIPValue) == 0)
	{
		return -1;
	}
	
	for (i = 1; i <= nReqIdx; i++)
	{
		gstrcpy(sIpaddr, sFullIPValue);
		ip = strtok(sIpaddr, ".");	
		nIndex = 1;		
		while (ip != NULL && nIndex < i )
		{
			nIndex++;
			ip = strtok(NULL, ".");	
		}

		if (i == nReqIdx)
		{	
			gstrcpy(pRetValue, (const char_t*)ip);			
			return 1;
		}	
	}	

	return 1;
}
#endif //#if defined(SPURS) || defined(WILDPASS)


#ifdef RALINK
CGI_ENUMSEL_S web_Enum_AuthType_List [] =
{
	{0, "Open System"},
	{1, "Shard Key"},
	{2, "WPA-PSK"},
//	{2, "Both Type"},
//	{3, "Dot1xEAP"},
//	{4, "Dot1xPSK"},
};

CGI_ENUMSEL_S web_Enum_EncryType_List [] =
{
	{0, "None"},
	{1, "WEP"},
	{2, "TKIP"},
};

#endif //#ifdef RALINK


#if defined(SPURS) || defined(WILDPASS)
CGI_ENUMSEL_S web_Enum_EncryType_List [] =
{
	{0, "None"},
	{1, "Share"},
	{2, "802.1X"},
	{3, "TKIP"},
	{4, "AES"},
        {5, "TKIP/AES"},
};

CGI_ENUMSEL_S web_Enum_AuthType_List [] =
{
	{1, "Open System"},
	{2, "Shared Key"},
	{3, "Auto Switch"},
	{4, "WPA-TLS"},
	{5, "WPA-PSK"},
        {6, "WPA2-TLS"},
	{7, "WPA2-PSK"},
};
#endif //#if defined(SPURS) || defined(WILDPASS)


#ifdef INPROCOMM
CGI_ENUMSEL_S web_Enum_AuthType_List [] =
{
	{0, "Open System"},
	{1, "Open System with 802.1x"},
	{2, "Shard Key"},
	{3, "Auto Switch Open System/Shard Key"},
	{4, "WPA"},
	{5, "WPA-PSK"},
};

CGI_ENUMSEL_S web_Enum_EncryType_List [] =
{
	{0, "No Encription"},
	{1, "WEP 64  (10 digits)"},
	{2, "WEP 128 (26 digits)"},
	{3, "WEP 152 (32 digits)"},
	{4, "TKIP"},
	{5, "AES-CCMP"},
};
#endif //#ifdef INPROCOMM


CGI_ENUMSEL_S web_Enum_WepType_List [] =
{
	{0, "Disable"},
	{1, "Enable 64"},
	{2, "Enable 128"}
};

CGI_ENUMSEL_S web_Enum_KeyUsed_List [] =
{
//	{0, "None"},
	{1, "Key 1"},
	{2, "Key 2"},
	{3, "Key 3"},
	{4, "Key 4"},
};


#if defined(RALINK)
int ifx_get_wlan_security(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name, sValue[MAX_FILELINE_LEN];
	int		i, nSelIdx = 0;

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);

   	if ( !gstrcmp(name, T("EncryType")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_ENCRY_TYPE", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_EncryType_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == nSelIdx)
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_EncryType_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_EncryType_List[i].str);
				}
			}
		}
	}
	else if ( !gstrcmp(name, T("AuthType")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_AUTH_TYPE", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_AuthType_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == nSelIdx)
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_AuthType_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_AuthType_List[i].str);
				}
			}
		}
	}
	else if ( !gstrcmp(name, T("KeyUsed")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY_USED", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_KeyUsed_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == nSelIdx)
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_KeyUsed_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_KeyUsed_List[i].str);
				}
			}
		}
	}
	else if ( !gstrcmp(name, T("Key1")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY1", sValue) == 1 )
		{		
			if (strlen(sValue) == 10 || strlen(sValue) == 26)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, T(""));
							
		}
	}
	else if ( !gstrcmp(name, T("Key2")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY2", sValue) == 1 )
		{			
			if (strlen(sValue) == 10 || strlen(sValue) == 26)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, T(""));
		}
	}
	else if ( !gstrcmp(name, T("Key3")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY3", sValue) == 1 )
		{
			if (strlen(sValue) == 10 || strlen(sValue) == 26)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, T(""));
		}
	}
	else if ( !gstrcmp(name, T("Key4")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY4", sValue) == 1 )
		{
			if (strlen(sValue) == 10 || strlen(sValue) == 26)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, T(""));
		}
	}
	else if ( !gstrcmp(name, T("PSK")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_PSK", sValue) == 1 )
		{			
			if (strlen(sValue) == 64)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, T(""));
		}
	}
/*	else if ( !gstrcmp(name, T("Passphrase")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_PASSPHRASE", sValue) == 1 )
		{
			if ( !gstrcmp(sValue, "1") )
			{
				gstrcpy(sValue, "1");
			}
			else
			{
				gstrcpy(sValue, "0");
			}
		}

		ejSetResult(eid, sValue);
	}
*/	

	return 0;
}
//#endif //#elif defined(RALINK)

#elif defined(INPROCOMM)
int ifx_get_wlan_security(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name, sValue[MAX_FILELINE_LEN];
	int		i, nSelIdx = 0;
	
	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);

   	if ( !gstrcmp(name, T("EncryType")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_ENCRY_TYPE", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);
			
			for (i = 0; i < sizeof(web_Enum_EncryType_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == nSelIdx)
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_EncryType_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_EncryType_List[i].str);
				}
			}
		}
	}
	else if ( !gstrcmp(name, T("AuthType")) )
	{
	     	if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_AUTH_TYPE", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_AuthType_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == nSelIdx)
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_AuthType_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_AuthType_List[i].str);
				}
			}
		}
	}
	else if ( !gstrcmp(name, T("KeyUsed")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY_USED", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_KeyUsed_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == nSelIdx)
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_KeyUsed_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_KeyUsed_List[i].str);
				}
			}
		}
	}
	else if ( !gstrcmp(name, T("Key1")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY1", sValue) == 1 )
		{		
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, T(""));
							
		}
	}
	else if ( !gstrcmp(name, T("Key2")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY2", sValue) == 1 )
		{			
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, T(""));
		}
	}
	else if ( !gstrcmp(name, T("Key3")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY3", sValue) == 1 )
		{
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, T(""));
		}
	}
	else if ( !gstrcmp(name, T("Key4")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY4", sValue) == 1 )
		{
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, T(""));
		}
	}
	else if ( !gstrcmp(name, T("PSK")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_PSK", sValue) == 1 )
		{			
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, T(""));
		}
	}
	else if ( !gstrcmp(name, T("Passphrase")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_PASSPHRASE", sValue) == 1 )
		{
			if ( !gstrcmp(sValue, "1") )
			{
				gstrcpy(sValue, "1");
			}
			else
			{
				gstrcpy(sValue, "0");
			}
		}

		ejSetResult(eid, sValue);
	}

	return 0;
}
//#endif //#elif defined(INPROCOMM)

#elif (defined(SPURS) || defined(WILDPASS))
int ifx_get_wlan_security(int eid, httpd_t wp, int argc, char_t **argv)
{
	char_t	*name, sValue[MAX_FILELINE_LEN];
	int		i, nSelIdx = 0;
	int          nEncrySelIdx = 0;
	int          nWDSInit = 0;
	int          n_currentAPMode=0;//0:AP,1:ap client,2:WDS

	if (ejArgs(argc, argv, T("%s"), &name) < 1)
	{
		ifx_httpdError(wp, 400, T("Insufficient args\n"));
		return -1;
	}

   	memset(sValue, 0x00, MAX_FILELINE_LEN);  	
   	

	if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, "WLAN_CURRENT_MODE", sValue) == 1 )
	{
           if ( !gstrcmp(sValue, "0") )
	      n_currentAPMode=0;
	    else  if ( !gstrcmp(sValue, "1") )
		n_currentAPMode=1;
	    else  if ( !gstrcmp(sValue, "2") )
		n_currentAPMode=2;
	    
	}

	
   	if ( !gstrcmp(name, T("get_mode")) )	
	{	  
	    if ( n_currentAPMode== 1)		
	    {	
	           ifx_httpdWrite(wp, T("1"));//client mode		
	     }	
	     else if ( n_currentAPMode== 0)	
	    {				
	           ifx_httpdWrite(wp, T("0"));//ap mode		
	     }		
	     else if ( n_currentAPMode== 2)	
	    {				
	            ifx_httpdWrite(wp, T("2"));//wds mode	
	     }	
	}
	else if (!gstrcmp(name, T("WDSmode_IsDisable")))
	{
		if (n_currentAPMode== 2)
		   {
		       ifx_httpdWrite(wp, T("disabled"));
		   }	   
	}
	else  if ( !gstrcmp(name, T("EncryType")) )
	{
		if (n_currentAPMode==2) //wds       
		{  
                 nWDSInit=0;
		   if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, "WDS_MODE_INIT", sValue) == 1 )	
		   {	
		      nWDSInit=gatoi(sValue);
		   }

		   memset(sValue, 0x00, MAX_FILELINE_LEN);

		    
		    nSelIdx = 0; //default open for wds	
		    if (nWDSInit==0) //not ini for WDS
		    {

			  if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_ENCRY_TYPE", sValue) == 1 )			   	
		             nSelIdx = gatoi(sValue);	
		    }
		    //for (i = 0; i < sizeof(web_Enum_EncryType_List)/sizeof(CGI_ENUMSEL_S); i++)	//old
		    for (i = 0; i < 2; i++)	
		    {				
		         if (i == nSelIdx)		
		         {					
		                ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_EncryType_List[i].str);
			    }				
			  else				
			  {				    
			        // if (i!=2)	//old		
				    ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_EncryType_List[i].str);
			   }	//else		
		     }  //for          
		  }//if
		  else
		  {
		     if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_ENCRY_TYPE", sValue) == 1 )	
		     {			
		             nSelIdx = gatoi(sValue);			
			      for (i = 0; i < sizeof(web_Enum_EncryType_List)/sizeof(CGI_ENUMSEL_S); i++)
			      {				
			           if (i == nSelIdx)	
				     {				
				          ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), i, web_Enum_EncryType_List[i].str);	
				      }	
				      else		
				      {			
				             ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), i, web_Enum_EncryType_List[i].str);	
					}		
				}//for		
		     	}//if	      
		 }//else
	}
	else if ( !gstrcmp(name, T("AuthType")) )
	{
            if (n_currentAPMode==2) //wds     
            {    


		   nWDSInit=0;
		      if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, "WDS_MODE_INIT", sValue) == 1 )	
		      {	
		         nWDSInit=gatoi(sValue);
		      }

		      memset(sValue, 0x00, MAX_FILELINE_LEN);

		    
		      nSelIdx = 1; //default open for wds	
		      if (nWDSInit==0) //not ini for WDS
		     {

			  if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_AUTH_TYPE", sValue) == 1 )			   	
		             nSelIdx = gatoi(sValue);	
		      }
			  
		  for (i = 0; i < 3; i++)		 
 		  {	
                    		  
		       if (i == (nSelIdx-1))		
			{			
			      ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);	
			}			
			else		
			{		
			      ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);	
			}		
		   }         
		}//if
		else
		{
			//for auth type select box
			if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_ENCRY_TYPE", sValue) == 1 )
			{
				nEncrySelIdx = gatoi(sValue);
			}

			memset(sValue, 0x00, MAX_FILELINE_LEN);


			if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_AUTH_TYPE", sValue) == 1 )
			{
			   nSelIdx = gatoi(sValue);

			   switch (nEncrySelIdx)
			   {
                 		case 0:
		   		case 1:
					//for (i = 0; i < sizeof(web_Enum_AuthType_List)/sizeof(CGI_ENUMSEL_S); i++) //original
					for (i = 0; i < 3; i++)
					{
						if (i == (nSelIdx-1))
						{
							ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);
						}
						else
						{
							ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);
						}
					}
					break;
		   		case 2:			
					i=3; //only WPA-TLS
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);		
		     			break;			   			
		   		case 3:	
					for (i = 3; i < 5; i++)
					{
						if (i == (nSelIdx-1))
						{
							ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);
						}
						else
						{
							ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);
						}
					}		
		   			break;
		   		case 4:
					for (i = 3; i < 7; i++)
					{
						if (i == (nSelIdx-1))
						{
							ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);
						}
						else
						{
							ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);
						}
					}		
		   			break;
		
		   		case 5:
					for (i = 5; i < 7; i++)
					{
						if (i == (nSelIdx-1))
						{
							ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);
						}
						else
						{
							ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"), web_Enum_AuthType_List[i].value, web_Enum_AuthType_List[i].str);
						}
					}		
		   			break;
		
		   		default:
		   			break;
		
			    }//SWITCH
		      }		
		}//else
		
	}
	else if ( !gstrcmp(name, T("KeyUsed")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY_USED", sValue) == 1 )
		{
			nSelIdx = gatoi(sValue);

			for (i = 0; i < sizeof(web_Enum_KeyUsed_List)/sizeof(CGI_ENUMSEL_S); i++)
			{
				if (i == (nSelIdx-1))
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\" SELECTED>%s</option>\n"), web_Enum_KeyUsed_List[i].value, web_Enum_KeyUsed_List[i].str);
				}
				else
				{
					ifx_httpdWrite(wp, T("\t\t\t<option value=\"%d\">%s</option>\n"),web_Enum_KeyUsed_List[i].value, web_Enum_KeyUsed_List[i].str);
				}
			}
		}
	}
	else if ( !gstrcmp(name, T("Key1")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY1", sValue) == 1 )
		{		
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
							
		}
	}
	else if ( !gstrcmp(name, T("Key2")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY2", sValue) == 1 )
		{			
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
	else if ( !gstrcmp(name, T("Key3")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY3", sValue) == 1 )
		{
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
	else if ( !gstrcmp(name, T("Key4")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_KEY4", sValue) == 1 )
		{
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
	else if ( !gstrcmp(name, T("PSK")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_PSK", sValue) == 1 )
		{			
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
	else if ( !gstrcmp(name, T("Passphrase")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_PASSPHRASE", sValue) == 1 )
		{
			if ( !gstrcmp(sValue, "1") )
			{
				gstrcpy(sValue, "1");
			}
			else
			{
				gstrcpy(sValue, "0");
			}
		}
		#if 0
		ejSetResult(eid, sValue);
		#else
		#endif
	}

	else if ( !gstrcmp(name, T("RadiusIp1_1")) )
	{
		if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 1,  sValue) == 1)
		{			
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
	else if ( !gstrcmp(name, T("RadiusIp1_2")) )
	{
		if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 2,  sValue) == 1)
		{			
			if (strlen(sValue) != 0)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
		else if ( !gstrcmp(name, T("RadiusIp1_3")) )
	{
		if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 3,  sValue) == 1)
		{			
			if (strlen(sValue) != 0)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}

	else if ( !gstrcmp(name, T("RadiusIp1_4")) )
	{
		if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 4,  sValue) == 1)
		{			
			if (strlen(sValue) != 0)			
				ifx_httpdWrite(wp,sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}
	else if ( !gstrcmp(name, T("secret1")) )
	{
		if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_RADIUS_SERVER_SECRET", sValue) == 1 )
		{			
			if (strlen(sValue) != 1)			
				ifx_httpdWrite(wp, sValue);
			else				
				ifx_httpdWrite(wp, "");
		}
	}

	return 0;
}
#endif //#elif (defined(SPURS) || defined(WILDPASS))

#if defined(RALINK)
void ifx_set_wlan_security(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pEncryType, *pAuthType, /**pWepType,*/ *pKeyUsed, *pKey1, *pKey2, *pKey3, *pKey4, *pPsk, *pPassPhrase;	
	char_t	sEncryType[MAX_DATA_LEN], sAuthType[MAX_DATA_LEN], sWepType[MAX_DATA_LEN];
	char_t	sKeyUsed[MAX_DATA_LEN], sKey1[MAX_FILELINE_LEN], sKey2[MAX_FILELINE_LEN];
	char_t	sKey3[MAX_FILELINE_LEN], sKey4[MAX_FILELINE_LEN], sCommand[MAX_FILELINE_LEN];
	char_t	sPsk[MAX_FILELINE_LEN], sPassPhrase[MAX_FILELINE_LEN];
	char_t 	*aAuthParam[]  = {"OPEN", "SHARED", "WPAPSK"};
	char_t 	*aEncryParam[] = {"NONE", "WEP", "TKIP"/*, "AES"*/};
	char_t 	sESSID[MAX_FILELINE_LEN];
	
	a_assert(wp);

	// Get value from ASP file
	pEncryType = ifx_httpdGetVar(wp, T("EncryType"), T(""));
	pAuthType = ifx_httpdGetVar(wp, T("AuthType"), T(""));
//	pWepType = ifx_httpdGetVar(wp, T("WepType"), T(""));
	pKeyUsed = ifx_httpdGetVar(wp, T("KeyUsed"), T(""));

	if (pEncryType[0] == 0 && pAuthType[0] == 0 && pKeyUsed[0] == 0 && pPassPhrase[0] == 0)
	{
		ifx_httpdError(wp, 200, "Failed to get data from HTML page!\n");
		return;
	}	

	gsprintf(sEncryType, T("WLAN_ENCRY_TYPE=\"%s\"\n"), pEncryType);
	gsprintf(sAuthType, T("WLAN_AUTH_TYPE=\"%s\"\n"), pAuthType);
	//	gsprintf(sWepType, T("WLAN_WEP_TYPE=\"%s\"\n"), pWepType);
	gsprintf(sKeyUsed, T("WLAN_KEY_USED=\"%s\"\n"), pKeyUsed);
	
	switch (atoi(pEncryType))				
	{
	case 0: // Normal mode	
		gsprintf(sKey1, T("WLAN_KEY1=\"0\"\n"));
		gsprintf(sKey2, T("WLAN_KEY2=\"0\"\n"));
		gsprintf(sKey3, T("WLAN_KEY3=\"0\"\n"));
		gsprintf(sKey4, T("WLAN_KEY4=\"0\"\n"));	
		gsprintf(sPsk,  T("WLAN_PSK=\"0\"\n"));		
	break;
	
	case 1: // WEP 	
		pKey1 = ifx_httpdGetVar(wp, T("Key1"), T(""));
		pKey2 = ifx_httpdGetVar(wp, T("Key2"), T(""));
		pKey3 = ifx_httpdGetVar(wp, T("Key3"), T(""));
		pKey4 = ifx_httpdGetVar(wp, T("Key4"), T(""));
		if ( pKey1[0] == 0) gsprintf(pKey1, "0");
		if ( pKey2[0] == 0) gsprintf(pKey2, "0");
		if ( pKey3[0] == 0) gsprintf(pKey3, "0");
		if ( pKey4[0] == 0) gsprintf(pKey4, "0");
		gsprintf(sKey1, T("WLAN_KEY1=\"%s\"\n"), pKey1);
		gsprintf(sKey2, T("WLAN_KEY2=\"%s\"\n"), pKey2);
		gsprintf(sKey3, T("WLAN_KEY3=\"%s\"\n"), pKey3);
		gsprintf(sKey4, T("WLAN_KEY4=\"%s\"\n"), pKey4);		
		gsprintf(sPsk,  T("WLAN_PSK=\"0\"\n"));
		break;
		
	case 2: // TKIP
		pPsk = ifx_httpdGetVar(wp, T("PSK"), T(""));
		//if ( pPsk[0] == 0) 	gsprintf(pPsk, "0");
		gsprintf(sKey1, T("WLAN_KEY1=\"0\"\n"));
		gsprintf(sKey2, T("WLAN_KEY2=\"0\"\n"));
		gsprintf(sKey3, T("WLAN_KEY3=\"0\"\n"));
		gsprintf(sKey4, T("WLAN_KEY4=\"0\"\n"));				
		gsprintf(sPsk,  T("WLAN_PSK=\"%s\"\n"), pPsk);
		break;		
		
	default:
		ifx_httpdError(wp, 200, T("Encryption Range Error = %s"), pEncryType);
		return;
	}


	if (!gstrcmp(pPassPhrase, T("1")))
		gsprintf(sPassPhrase, "WLAN_PASSPHRASE=\"1\"\n");
	else		
		gsprintf(sPassPhrase, "WLAN_PASSPHRASE=\"0\"\n");

/*
	websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, 8, sEncryType, sAuthType, sWepType, sKeyUsed,
														sKey1, sKey2, sKey3, sKey4 );
*/														
	websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, 9, sEncryType, sAuthType, sKeyUsed,
														sKey1, sKey2, sKey3, sKey4, sPsk, sPassPhrase);

	//RunTime change.
	memset(sCommand, 0x00, MAX_FILELINE_LEN);
	// Set Mode
	gsprintf(sCommand, T("iwpriv %s set AuthMode=%s,EncrypType=%s"), ADM_WLAN_IF,
																	 aAuthParam[atoi(pAuthType)], 
																	 aEncryParam[atoi(pEncryType)]);
	system(sCommand);																		 

	if (atoi(pEncryType) == 1) // WEP
	{	
		memset(sCommand, 0x00, MAX_FILELINE_LEN);	
		gsprintf(sCommand, T("iwconfig %s key off"), ADM_WLAN_IF);
		system(sCommand);			
	
		memset(sCommand, 0x00, MAX_FILELINE_LEN);	
		gsprintf(sCommand, T("iwpriv %s set DefaultKeyID=%s"), pKeyUsed);
		system(sCommand);	
	}
	
	memset(sCommand, 0x00, MAX_FILELINE_LEN);	
	switch(atoi(pAuthType))
	{
	case 0:	// OPEN
		if (atoi(pEncryType) != 1) // WEP
				break;
	
		if (gstrlen(pKey1) == 10 || gstrlen(pKey1) ==26)	// 64 or 128		
		{
			gsprintf(sCommand, T("iwconfig %s key [1] %s open"), ADM_WLAN_IF, pKey1);
			system(sCommand);			
		}
		if (gstrlen(pKey2) == 10 || gstrlen(pKey2) ==26)	// 64 or 128		
		{
			gsprintf(sCommand, T("iwconfig %s key [2] %s open"), ADM_WLAN_IF, pKey2);
			system(sCommand);			
		}
		if (gstrlen(pKey3) == 10 || gstrlen(pKey3) ==26)	// 64 or 128		
		{
			gsprintf(sCommand, T("iwconfig %s key [3] %s open"), ADM_WLAN_IF, pKey3);
			system(sCommand);			
		}
		if (gstrlen(pKey4) == 10 || gstrlen(pKey4) ==26)	// 64 or 128		
		{
			gsprintf(sCommand, T("iwconfig %s key [4] %s open"), ADM_WLAN_IF, pKey4);
			system(sCommand);			
		}
		break;						
	
	case 1:	// SHARED	
		if (atoi(pEncryType) != 1) // WEP
			break;
		if (gstrlen(pKey1) == 10 || gstrlen(pKey1) ==26)	// 64 or 128		
		{
			gsprintf(sCommand, T("iwconfig %s key [1] %s restricted"), ADM_WLAN_IF, pKey1);
			system(sCommand);			
		}
		if (gstrlen(pKey2) == 10 || gstrlen(pKey2) ==26)	// 64 or 128		
		{
			gsprintf(sCommand, T("iwconfig %s key [2] %s restricted"), ADM_WLAN_IF, pKey2);
			system(sCommand);			
		}
		if (gstrlen(pKey3) == 10 || gstrlen(pKey3) ==26)	// 64 or 128		
		{
			gsprintf(sCommand, T("iwconfig %s key [3] %s restricted"), ADM_WLAN_IF, pKey3);
			system(sCommand);			
		}
		if (gstrlen(pKey4) == 10 || gstrlen(pKey4) ==26)	// 64 or 128		
		{
			gsprintf(sCommand, T("iwconfig %s key [4] %s restricted"), ADM_WLAN_IF, pKey4);
			system(sCommand);			
		}
		break;	
	
	case 2: // WAPPSK
 		gsprintf(sCommand, T("iwpriv %s set WPAPSK=%s"), ADM_WLAN_IF, pPsk); 	   
		system(sCommand); 	 
		break;
		  
	default:
		ifx_httpdError(wp, 200, T("Authentication Range Error = %s"), pAuthType);
		return;
	}

	memset(sCommand, 0x00, MAX_FILELINE_LEN);
	if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_ESSID", sESSID) == 1 )
	{
		trace(8, T("Get ESSID is %s\n"), sESSID);	
		gsprintf(sCommand, T("iwconfig %s essid \"%s\""), ADM_WLAN_IF, sESSID);
		system(sCommand);		
	}

	//add by calvinc 20040519 save to flash
	system(SERVICE_RESTORE);
        //end add		
														 	ifx_httpdNextPage(wp);
}
//#endif //#if defined(RALINK)

#elif defined(INPROCOMM)
void ifx_set_wlan_security(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pEncryType, *pAuthType, *pKeyUsed, *pKey1, *pKey2, *pKey3, *pKey4, *pPsk;	
	char_t	sEncryType[MAX_DATA_LEN], sAuthType[MAX_DATA_LEN], sWepType[MAX_DATA_LEN];
	char_t	sKeyUsed[MAX_DATA_LEN], sKey1[MAX_FILELINE_LEN], sKey2[MAX_FILELINE_LEN];
	char_t	sKey3[MAX_FILELINE_LEN], sKey4[MAX_FILELINE_LEN], sCommand[MAX_FILELINE_LEN];
	char_t	sPsk[MAX_FILELINE_LEN], sPassPhrase[MAX_FILELINE_LEN];
	char_t 	sESSID[MAX_FILELINE_LEN];
	char_t 	sWepKey[MAX_FILELINE_LEN], sWepKeyIdx[MAX_DATA_LEN];	
	
	a_assert(wp);
	memset(sPsk, 0x00, MAX_FILELINE_LEN);	
	memset(sPassPhrase, 0x00, MAX_FILELINE_LEN);	
	memset(sESSID, 0x00, MAX_FILELINE_LEN);
	memset(sWepKey, 0x00, MAX_FILELINE_LEN);	

	// Get value from ASP file
	pEncryType = ifx_httpdGetVar(wp, T("EncryType"), T(""));
	pAuthType = ifx_httpdGetVar(wp, T("AuthType"), T(""));
	pKeyUsed = ifx_httpdGetVar(wp, T("KeyUsed"), T(""));

	if (pEncryType[0] == 0 && pAuthType[0] == 0 && pKeyUsed[0] == 0)
	{
		ifx_httpdError(wp, 200, "Failed to get data from HTML page!\n");
		return;
	}	

	gsprintf(sEncryType, T("WLAN_ENCRY_TYPE=\"%s\"\n"), pEncryType);
	gsprintf(sAuthType, T("WLAN_AUTH_TYPE=\"%s\"\n"), pAuthType);
	gsprintf(sKeyUsed, T("WLAN_KEY_USED=\"%s\"\n"), pKeyUsed);
	
	switch (atoi(pEncryType))				
	{
	case WLAN_ENCRY_NONE: // Normal mode	
		gsprintf(sKey1, T("WLAN_KEY1=\"0\"\n"));
		gsprintf(sKey2, T("WLAN_KEY2=\"0\"\n"));
		gsprintf(sKey3, T("WLAN_KEY3=\"0\"\n"));
		gsprintf(sKey4, T("WLAN_KEY4=\"0\"\n"));	
		gsprintf(sPsk,  T("WLAN_PSK=\"0\"\n"));		
		
		// RunTime change.
		memset(sCommand, 0x00, MAX_FILELINE_LEN);	
		gsprintf(sCommand, T("iwpriv %s authmode 0"), ADM_WLAN_IF);
		system(sCommand);
		gsprintf(sCommand, T("iwpriv %s cipher 0"), ADM_WLAN_IF);
		system(sCommand);
//		gsprintf(sCommand, T("iwpriv %s mlmerestart"), ADM_WLAN_IF);
//		system(sCommand);
	break;
	
	case WLAN_ENCRY_WEP64: // WEP-64
	case WLAN_ENCRY_WEP128: // WEP-128
	case WLAN_ENCRY_WEP152: // WEP-152
		pKey1 = ifx_httpdGetVar(wp, T("Key1"), T(""));
		pKey2 = ifx_httpdGetVar(wp, T("Key2"), T(""));
		pKey3 = ifx_httpdGetVar(wp, T("Key3"), T(""));
		pKey4 = ifx_httpdGetVar(wp, T("Key4"), T(""));
		if ( pKey1[0] == 0) gsprintf(pKey1, "0");
		if ( pKey2[0] == 0) gsprintf(pKey2, "0");
		if ( pKey3[0] == 0) gsprintf(pKey3, "0");
		if ( pKey4[0] == 0) gsprintf(pKey4, "0");
		gsprintf(sKey1, T("WLAN_KEY1=\"%s\"\n"), pKey1);
		gsprintf(sKey2, T("WLAN_KEY2=\"%s\"\n"), pKey2);
		gsprintf(sKey3, T("WLAN_KEY3=\"%s\"\n"), pKey3);
		gsprintf(sKey4, T("WLAN_KEY4=\"%s\"\n"), pKey4);		
		gsprintf(sPsk,  T("WLAN_PSK=\"0\"\n"));

		//trace(8, T("Check Key used here..............\n"));	
		//trace(8, "Key used is %s\n", pKeyUsed);
				
		// Get Active Key
		gstrcpy(sWepKeyIdx, atoi(pKeyUsed));		
		if (atoi(pKeyUsed) == 0)
		{
			gstrcpy(sWepKey, pKey1);
		}
		else if (atoi(pKeyUsed) == 1)
		{
			gstrcpy(sWepKey, pKey2);			
		}
		else if (atoi(pKeyUsed) == 2)
		{
			gstrcpy(sWepKey, pKey3);			
		}
		else if (atoi(pKeyUsed) == 3)
		{
			gstrcpy(sWepKey, pKey4);			
		}

		//trace(8, T("Check Key used end.............\n"));			
		switch(atoi(pEncryType))
		{
		case WLAN_ENCRY_WEP64: // WEP-64
				if (atoi(pAuthType) != WLAN_AUTH_OPEN && atoi(pAuthType) != WLAN_AUTH_1X &&
				    atoi(pAuthType) != WLAN_AUTH_SHARED	)
				{
					ifx_httpdError(wp, 200, "The Authenication type is not allow for WEP-64!\n");
					return;
				}				    
				//trace(8, T("Check..............\n"));					
				
				
				gsprintf(sCommand, T("iwpriv %s authmode %s"), ADM_WLAN_IF, pAuthType);	
				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s cipher 1"), ADM_WLAN_IF);	// WEP-64: cipher 1
				system(sCommand);
//				gsprintf(sCommand, T("iwpriv %s mlmerestart"), ADM_WLAN_IF);
//				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s wepkeyid %s"), ADM_WLAN_IF, sWepKeyIdx);
				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s wepkey %s"), ADM_WLAN_IF, sWepKey);
				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s defwepkeyid %s"), ADM_WLAN_IF, sWepKeyIdx);
				system(sCommand);				
				break;
				
		case WLAN_ENCRY_WEP128: // WEP-128
				if (atoi(pAuthType) != WLAN_AUTH_OPEN && atoi(pAuthType) != WLAN_AUTH_1X &&
				    atoi(pAuthType) != WLAN_AUTH_SHARED	)
				{
					ifx_httpdError(wp, 200, "The Authenication type is not allow for WEP-128!\n");
					return;
				}

				gsprintf(sCommand, T("iwpriv %s authmode %s"), ADM_WLAN_IF, pAuthType);	
				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s cipher 5"), ADM_WLAN_IF);	// WEP-128: cipher 5
				system(sCommand);
//				gsprintf(sCommand, T("iwpriv %s mlmerestart"), ADM_WLAN_IF);
//				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s wepkeyid %s"), ADM_WLAN_IF, sWepKeyIdx);
				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s wepkey %s"), ADM_WLAN_IF, sWepKey);
				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s defwepkeyid %s"), ADM_WLAN_IF, sWepKeyIdx);
				system(sCommand);				
				break;
				
		case WLAN_ENCRY_WEP152: 
				if (atoi(pAuthType) != WLAN_AUTH_OPEN && atoi(pAuthType) != WLAN_AUTH_1X)
				{
					ifx_httpdError(wp, 200, "The Authenication type is not allow for WEP-152!\n");
					return;
				}

				gsprintf(sCommand, T("iwpriv %s authmode %s"), ADM_WLAN_IF, pAuthType);	
				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s cipher 6"), ADM_WLAN_IF);	// WEP-152: cipher 6
				system(sCommand);
//				gsprintf(sCommand, T("iwpriv %s mlmerestart"), ADM_WLAN_IF);
//				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s wepkeyid %s"), ADM_WLAN_IF, sWepKeyIdx);
				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s wepkey %s"), ADM_WLAN_IF, sWepKey);
				system(sCommand);
				gsprintf(sCommand, T("iwpriv %s defwepkeyid %s"), ADM_WLAN_IF, sWepKeyIdx);
				system(sCommand);
				break;
		default:
				ifx_httpdError(wp, 200, "Wrong Encripytion Type!\n");
				return;	
		}
		break;
		
	case WLAN_ENCRY_TKIP: 	// TKIP
	case WLAN_ENCRY_AES: 	// AES
		pPsk = ifx_httpdGetVar(wp, T("PSK"), T(""));
		//if ( pPsk[0] == 0) 	gsprintf(pPsk, "0");
		gsprintf(sKey1, T("WLAN_KEY1=\"0\"\n"));
		gsprintf(sKey2, T("WLAN_KEY2=\"0\"\n"));
		gsprintf(sKey3, T("WLAN_KEY3=\"0\"\n"));
		gsprintf(sKey4, T("WLAN_KEY4=\"0\"\n"));				
		gsprintf(sPsk,  T("WLAN_PSK=\"%s\"\n"), pPsk);
		
		switch(atoi(pEncryType))
		{
		case WLAN_ENCRY_TKIP:
			gsprintf(sCommand, T("iwpriv %s authmode %s"), ADM_WLAN_IF, pAuthType);	
			system(sCommand);
			gsprintf(sCommand, T("iwpriv %s cipher 2"), ADM_WLAN_IF);	// TKIP: 2
			system(sCommand);
//			gsprintf(sCommand, T("iwpriv %s mlmerestart"), ADM_WLAN_IF);
//			system(sCommand);
			gsprintf(sCommand, T("iwpriv %s passphrase \"%s\""), ADM_WLAN_IF, pPsk);
			system(sCommand);		
		break;
		
		case WLAN_ENCRY_AES:
			gsprintf(sCommand, T("iwpriv %s authmode %s"), ADM_WLAN_IF, pAuthType);	
			system(sCommand);
			gsprintf(sCommand, T("iwpriv %s cipher 4"), ADM_WLAN_IF);	// TKIP: 4
			system(sCommand);
//			gsprintf(sCommand, T("iwpriv %s mlmerestart"), ADM_WLAN_IF);
//			system(sCommand);
			gsprintf(sCommand, T("iwpriv %s passphrase \"%s\""), ADM_WLAN_IF, pPsk);
			system(sCommand);
		break;
		
		default:
			ifx_httpdError(wp, 200, "Wrong Encripytion Type!\n");
			return;
		}		
		break;		
		
	default:
		ifx_httpdError(wp, 200, T("Encryption Range Error = %s"), pEncryType);
		return;
	}

	websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, 9, sEncryType, sAuthType, sKeyUsed, 
			sKey1, sKey2, sKey3, sKey4, sPsk, "WLAN_PASSPHRASE=\"0\"\n"); 

	memset(sCommand, 0x00, MAX_FILELINE_LEN);
	if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SETTINGS, "WLAN_ESSID", sESSID) == 1 )
	{
		//trace(8, T("Get ESSID is %s\n"), sESSID);	
		gsprintf(sCommand, T("iwpriv %s essid \"%s\""), ADM_WLAN_IF, sESSID);
		system(sCommand);		
	}		
																	 
	//add by calvinc 20040519 save to flash
	system(SERVICE_RESTORE);
        //end add		
	ifx_httpdNextPage(wp);
}
//#endif //#elif defined(INPROCOMM)

#elif (defined(WILDPASS) || defined(SPURS))
void ifx_set_wlan_security(httpd_t wp, char_t *path, char_t *query)
{
	char_t	*pEncryType, *pAuthType, *pKeyUsed, *pKey1, *pKey2, *pKey3, *pKey4, *pPsk,*pRadiusSecret;	
	char_t     *pRadiusIp1_1,*pRadiusIp1_2,*pRadiusIp1_3,*pRadiusIp1_4;//,*pRadius_Port;	
	char_t	sEncryType[MAX_DATA_LEN], sAuthType[MAX_DATA_LEN];//, sWepType[MAX_DATA_LEN];
	char_t	sKeyUsed[MAX_DATA_LEN], sKey1[MAX_FILELINE_LEN], sKey2[MAX_FILELINE_LEN];
	char_t	sKey3[MAX_FILELINE_LEN], sKey4[MAX_FILELINE_LEN];//, sCommand[MAX_FILELINE_LEN];
	char_t	sPsk[MAX_FILELINE_LEN], sPassPhrase[MAX_FILELINE_LEN];
	char_t 	sESSID[MAX_FILELINE_LEN];
	char_t 	sWepKey[MAX_FILELINE_LEN];
	char_t     sRadiusSecret[MAX_FILELINE_LEN];
	char_t     sRadiusIp1[MAX_FILELINE_LEN];
	char_t     sRadiusPort[MAX_FILELINE_LEN];
	char_t    sWEPKeyLength[MAX_DATA_LEN];
	int          WEPKeyLength=0,PSKKeyLength=0;
	char_t  sTMD[MAX_FILELINE_LEN],stmpTMD[MAX_FILELINE_LEN];		// TMD size must greater than input value(64+"/0")
	int     TMDCount[MAX_FILELINE_LEN];		
	int           i,j,count=0,TotalCount=0;
	bool_t  bPercent=FALSE;
       char_t	sTempIp1[MAX_FILELINE_LEN],sTempIp2[MAX_FILELINE_LEN],sTempIp3[MAX_FILELINE_LEN],sTempIp4[MAX_FILELINE_LEN];
	char_t	sValue[MAX_FILELINE_LEN];
	char_t	sMode[MAX_DATA_LEN], sWDSInit[MAX_DATA_LEN];//, sWepType[MAX_DATA_LEN];

	int          APMode; 

	memset(TMDCount, 0x00, MAX_FILELINE_LEN);	
	memset(sTMD, 0x00, MAX_FILELINE_LEN);	
	memset(stmpTMD, 0x00, MAX_FILELINE_LEN);	
	
	a_assert(wp);
	memset(sPsk, 0x00, MAX_FILELINE_LEN);	
	memset(sPassPhrase, 0x00, MAX_FILELINE_LEN);	
	memset(sESSID, 0x00, MAX_FILELINE_LEN);
	memset(sWepKey, 0x00, MAX_FILELINE_LEN);	

	memset(sKey1,0x00,MAX_FILELINE_LEN);
	memset(sKey2,0x00,MAX_FILELINE_LEN);
	memset(sKey3,0x00,MAX_FILELINE_LEN);
	memset(sKey4,0x00,MAX_FILELINE_LEN);	
	memset(sRadiusPort,0x00,MAX_FILELINE_LEN);
	memset(sEncryType,0x00,MAX_DATA_LEN);
	memset(sAuthType,0x00,MAX_DATA_LEN);

        memset(sTempIp1,0x00,MAX_FILELINE_LEN);
	memset(sTempIp2,0x00,MAX_FILELINE_LEN);
	memset(sTempIp3,0x00,MAX_FILELINE_LEN);
	memset(sTempIp4,0x00,MAX_FILELINE_LEN);	

	memset(sValue,0x00,MAX_FILELINE_LEN);
	memset(sMode,0x00,MAX_DATA_LEN);
	memset(sWDSInit,0x00,MAX_DATA_LEN);

	// Get value from ASP file
	pEncryType = ifx_httpdGetVar(wp, T("EncryType"), T(""));
	pAuthType = ifx_httpdGetVar(wp, T("AuthType"), T(""));
	pKeyUsed = ifx_httpdGetVar(wp, T("KeyUsed"), T(""));
	
	pRadiusSecret = ifx_httpdGetVar(wp,T("secret1"),T(""));
	pRadiusIp1_1 = ifx_httpdGetVar(wp, T("RadiusIp1_1"),T(""));
        pRadiusIp1_2 = ifx_httpdGetVar(wp, T("RadiusIp1_2"),T(""));
        pRadiusIp1_3 = ifx_httpdGetVar(wp, T("RadiusIp1_3"),T(""));
        pRadiusIp1_4 = ifx_httpdGetVar(wp, T("RadiusIp1_4"),T(""));

	ifx_debug_printf("--RadiusIp1_1 is:%s\n",pRadiusIp1_1);
	ifx_debug_printf("--RadiusIp1_2 is:%s\n",pRadiusIp1_2);
	ifx_debug_printf("--RadiusIp1_3 is:%s\n",pRadiusIp1_3);
	ifx_debug_printf("--RadiusIp1_4 is:%s\n",pRadiusIp1_4);
	ifx_debug_printf("---RadiusSecret is:%s\n",pRadiusSecret);


	gsprintf(sEncryType, T("WLAN_ENCRY_TYPE=\"%s\"\n"), pEncryType);
	gsprintf(sAuthType, T("WLAN_AUTH_TYPE=\"%s\"\n"), pAuthType);



	//CHECK IF AP Client Mode
       if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, "WLAN_CURRENT_MODE", sValue) == 1 )
	{
           if ( !gstrcmp(sValue, "0") )
	      APMode=0; //ap
	    else  if ( !gstrcmp(sValue, "1") )
		APMode=1; //client
	    else  if ( !gstrcmp(sValue, "2") )
		APMode=2;  //wds 
	    
	}

	switch (atoi(pAuthType))				
	{
	//case WLAN_ENCRY_NONE: // Normal mode		
	case WLAN_AUTH_NONE:
		switch(atoi(pEncryType))
		{
			case WLAN_ENCRY_NONE:
				gsprintf(sWEPKeyLength, T("WLAN_8021X_KEYLEN=\"0\"\n")); 	
				gsprintf(sKeyUsed, T("WLAN_KEY_USED=\"0\"\n"));
				gsprintf(sKey1, T("WLAN_KEY1=\"0\"\n"));
				gsprintf(sKey2, T("WLAN_KEY2=\"0\"\n"));
				gsprintf(sKey3, T("WLAN_KEY3=\"0\"\n"));
				gsprintf(sKey4, T("WLAN_KEY4=\"0\"\n"));	
				gsprintf(sPsk,  T("WLAN_PSK=\"0\"\n"));		

				break;
			case WLAN_ENCRY_SHARED:
				pKey1 = ifx_httpdGetVar(wp, T("Key1"), T(""));
				pKey2 = ifx_httpdGetVar(wp, T("Key2"), T(""));
				pKey3 = ifx_httpdGetVar(wp, T("Key3"), T(""));
				pKey4 = ifx_httpdGetVar(wp, T("Key4"), T(""));
				if ( !pKey1[0] ) gsprintf(pKey1, "0");
				if ( !pKey2[0]) gsprintf(pKey2, "0");
				if ( !pKey3[0]) gsprintf(pKey3, "0");
				if ( !pKey4[0]) gsprintf(pKey4, "0");
				gsprintf(sWEPKeyLength, T("WLAN_8021X_KEYLEN=\"0\"\n")); 	
			       gsprintf(sKeyUsed, T("WLAN_KEY_USED=\"%s\"\n"), pKeyUsed);		
				gsprintf(sKey1, T("WLAN_KEY1=\"%s\"\n"), pKey1);
				gsprintf(sKey2, T("WLAN_KEY2=\"%s\"\n"), pKey2);
				gsprintf(sKey3, T("WLAN_KEY3=\"%s\"\n"), pKey3);
				gsprintf(sKey4, T("WLAN_KEY4=\"%s\"\n"), pKey4);		
				gsprintf(sPsk,  T("WLAN_PSK=\"0\"\n"));				
				break;
			default:
				ifx_httpdError(wp, 200, "Wrong Encripytion Type!\n");
			return;
		}
		gsprintf(sRadiusIp1,  T("WLAN_RADIUS_SERVER_IP=\"%s.%s.%s.%s\"\n"), pRadiusIp1_1, pRadiusIp1_2, pRadiusIp1_3, pRadiusIp1_4);
		gsprintf(sRadiusPort, T("WLAN_RADIUS_SERVER_PORT=\"1812\"\n")); 	
		gsprintf(sRadiusSecret, T("WLAN_RADIUS_SERVER_SECRET=\"%s\"\n"), pRadiusSecret);

		//websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,13,sWEPKeyLength,sRadiusIp1,sRadiusPort,sRadiusSecrct,sEncryType,sAuthType,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_PASSPHRASE=\"0\"\n");//old
		websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,12,sRadiusIp1,sRadiusSecret,sEncryType,sAuthType,sWEPKeyLength,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_PASSPHRASE=\"0\"\n");
		break;
		
       case WLAN_AUTH_SHARED:
	case WLAN_AUTH_1X:
		pKey1 = ifx_httpdGetVar(wp, T("Key1"), T(""));
		pKey2 = ifx_httpdGetVar(wp, T("Key2"), T(""));
		pKey3 = ifx_httpdGetVar(wp, T("Key3"), T(""));
		pKey4 = ifx_httpdGetVar(wp, T("Key4"), T(""));
		if ( !pKey1[0] ) gsprintf(pKey1, "0");
		if ( !pKey2[0]) gsprintf(pKey2, "0");
		if ( !pKey3[0]) gsprintf(pKey3, "0");
		if ( !pKey4[0]) gsprintf(pKey4, "0");
 	       gsprintf(sWEPKeyLength, T("WLAN_8021X_KEYLEN=\"0\"\n")); 	
              gsprintf(sKeyUsed, T("WLAN_KEY_USED=\"%s\"\n"), pKeyUsed);		
		gsprintf(sKey1, T("WLAN_KEY1=\"%s\"\n"), pKey1);
		gsprintf(sKey2, T("WLAN_KEY2=\"%s\"\n"), pKey2);
		gsprintf(sKey3, T("WLAN_KEY3=\"%s\"\n"), pKey3);
		gsprintf(sKey4, T("WLAN_KEY4=\"%s\"\n"), pKey4);		
		gsprintf(sPsk,  T("WLAN_PSK=\"0\"\n"));

		//gstrcpy(sWepKeyIdx, atoi(pKeyUsed));		
		if (atoi(pKeyUsed) == 1)
		{
			gstrcpy(sWepKey, pKey1);
		}
		else if (atoi(pKeyUsed) == 2)
		{
			gstrcpy(sWepKey, pKey2);
		}
		else if (atoi(pKeyUsed) == 3)
		{
			gstrcpy(sWepKey, pKey3);			
		}
		else if (atoi(pKeyUsed) == 4)
		{
			gstrcpy(sWepKey, pKey4);			
		}
		WEPKeyLength = gstrlen(sWepKey);
		
             if(WEPKeyLength == 10)
			gsprintf(sWEPKeyLength, T("WLAN_8021X_KEYLEN=\"5\"\n")); 	
	      else if(WEPKeyLength == 26)
		  	gsprintf(sWEPKeyLength, T("WLAN_8021X_KEYLEN=\"13\"\n"));
	      else
		  	ifx_httpdError(wp, 200, "The Key length is not allow !\n");


		if ((pRadiusIp1_1 ||*pRadiusIp1_1) || (pRadiusIp1_2 ||*pRadiusIp1_2) ||(pRadiusIp1_3 ||*pRadiusIp1_3) ||(pRadiusIp1_4 ||*pRadiusIp1_4))
		{
                  if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 1,  sTempIp1) != 1)
		    {			
			ifx_httpdError(wp, 200, " --- The WLAN_RADIUS_SERVER_IP1 is not got !\n");
		     }

		      if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 2,  sTempIp2) != 1)
		    {			
			ifx_httpdError(wp, 200, " --- The WLAN_RADIUS_SERVER_IP2 is not got !\n");
		     }

		     if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 3,  sTempIp3) != 1)
		    {			
			ifx_httpdError(wp, 200, " --- The WLAN_RADIUS_SERVER_IP3 is not got  !\n");
		     }

		      if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 4,  sTempIp4) != 1)
		    {			
			ifx_httpdError(wp, 200, " --- The WLAN_RADIUS_SERVER_IP4 is not got  !\n");
		     }

		     gsprintf(sRadiusIp1,  T("WLAN_RADIUS_SERVER_IP=\"%s.%s.%s.%s\"\n"), sTempIp1, sTempIp2, sTempIp3, sTempIp4);
		}
		else
		    gsprintf(sRadiusIp1,  T("WLAN_RADIUS_SERVER_IP=\"%s.%s.%s.%s\"\n"), pRadiusIp1_1, pRadiusIp1_2, pRadiusIp1_3, pRadiusIp1_4);

		if (pRadiusSecret || *pRadiusSecret)
		{
		     if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_RADIUS_SERVER_SECRET", sValue) != 1 )
	            {			
			ifx_httpdError(wp, 200, " --- The WLAN_RADIUS_SERVER_SECRET is not got  !\n");
		     	}

		    gsprintf(sRadiusSecret, T("WLAN_RADIUS_SERVER_SECRET=\"%s\"\n"), sValue);
		}
		else
		   gsprintf(sRadiusSecret, T("WLAN_RADIUS_SERVER_SECRET=\"%s\"\n"), pRadiusSecret);

		
		gsprintf(sRadiusPort, T("WLAN_RADIUS_SERVER_PORT=\"1812\"\n")); 	
		
		websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,12,sRadiusIp1,sRadiusSecret,sEncryType,sAuthType,sWEPKeyLength,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_PASSPHRASE=\"0\"\n");
		break;
		
       case WLAN_AUTH_WPATKIP:
#ifdef WILDPASS
	case WLAN_AUTH_WPA2TLS:
#endif
		gsprintf(sWEPKeyLength, T("WLAN_8021X_KEYLEN=\"0\"\n")); 	
		gsprintf(sKeyUsed, T("WLAN_KEY_USED=\"0\"\n"));
		gsprintf(sKey1, T("WLAN_KEY1=\"0\"\n"));
		gsprintf(sKey2, T("WLAN_KEY2=\"0\"\n"));
		gsprintf(sKey3, T("WLAN_KEY3=\"0\"\n"));
		gsprintf(sKey4, T("WLAN_KEY4=\"0\"\n"));	
		gsprintf(sPsk,  T("WLAN_PSK=\"0\"\n"));		
		gsprintf(sRadiusIp1,  T("WLAN_RADIUS_SERVER_IP=\"%s.%s.%s.%s\"\n"), pRadiusIp1_1, pRadiusIp1_2, pRadiusIp1_3, pRadiusIp1_4);
		gsprintf(sRadiusPort, T("WLAN_RADIUS_SERVER_PORT=\"1812\"\n")); 	
		gsprintf(sRadiusSecret, T("WLAN_RADIUS_SERVER_SECRET=\"%s\"\n"), pRadiusSecret);

		ifx_debug_printf("WLAN_AUTH_WPA2TLS or WLAN_AUTH_WPATKIP");

	   	//websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,13,sWEPKeyLength,sRadiusIp1,sRadiusPort,sRadiusSecrct,sEncryType,sAuthType,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_PASSPHRASE=\"0\"\n");//old
	   	websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,12,sRadiusIp1,sRadiusSecret,sEncryType,sAuthType,sWEPKeyLength,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_PASSPHRASE=\"0\"\n");
	   	break;
	case WLAN_AUTH_WPAPSK:
#ifdef WILDPASS
	case WLAN_AUTH_WPA2PSK:
#endif
		pPsk = ifx_httpdGetVar(wp, T("PSK"), T(""));
		gsprintf(sWEPKeyLength, T("WLAN_8021X_KEYLEN=\"0\"\n")); 	
		gsprintf(sKeyUsed, T("WLAN_KEY_USED=\"0\"\n"));
		gsprintf(sKey1, T("WLAN_KEY1=\"0\"\n"));
		gsprintf(sKey2, T("WLAN_KEY2=\"0\"\n"));
		gsprintf(sKey3, T("WLAN_KEY3=\"0\"\n"));
		gsprintf(sKey4, T("WLAN_KEY4=\"0\"\n"));				
		gsprintf(sPsk,  T("WLAN_PSK=\"%s\"\n"), pPsk);
		ifx_debug_printf("----WLAN_AUTH_WPA2PSK or WLAN_AUTH_WPAPSK\n");

		if ((pRadiusIp1_1 ||*pRadiusIp1_1) || (pRadiusIp1_2 ||*pRadiusIp1_2) ||(pRadiusIp1_3 ||*pRadiusIp1_3) ||(pRadiusIp1_4 ||*pRadiusIp1_4))
		{
                  if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 1,  sTempIp1) != 1)
		    {			
			ifx_httpdError(wp, 200, " --- The WLAN_RADIUS_SERVER_IP1 is not got !\n");
		     }

		      if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 2,  sTempIp2) != 1)
		    {			
			ifx_httpdError(wp, 200, " --- The WLAN_RADIUS_SERVER_IP2 is not got !\n");
		     }

		     if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 3,  sTempIp3) != 1)
		    {			
			ifx_httpdError(wp, 200, " --- The WLAN_RADIUS_SERVER_IP3 is not got  !\n");
		     }

		      if(websGetIPAddress(TAG_WLAN_SECURITY,"WLAN_RADIUS_SERVER_IP" , 4,  sTempIp4) != 1)
		    {			
			ifx_httpdError(wp, 200, " --- The WLAN_RADIUS_SERVER_IP4 is not got  !\n");
		     }

		    gsprintf(sRadiusIp1,  T("WLAN_RADIUS_SERVER_IP=\"%s.%s.%s.%s\"\n"), sTempIp1, sTempIp2, sTempIp3, sTempIp4);
		}
		else
		    gsprintf(sRadiusIp1,  T("WLAN_RADIUS_SERVER_IP=\"%s.%s.%s.%s\"\n"), pRadiusIp1_1, pRadiusIp1_2, pRadiusIp1_3, pRadiusIp1_4);


		if (pRadiusSecret || *pRadiusSecret)
		{
		     if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY, "WLAN_RADIUS_SERVER_SECRET", sValue) != 1 )
	            {			
			ifx_httpdError(wp, 200, " --- The WLAN_RADIUS_SERVER_SECRET is not got  !\n");
		     	}

		     gsprintf(sRadiusSecret, T("WLAN_RADIUS_SERVER_SECRET=\"%s\"\n"), sValue);
		}
		else
		     gsprintf(sRadiusSecret, T("WLAN_RADIUS_SERVER_SECRET=\"%s\"\n"), pRadiusSecret);

		// Search special characters and duplicate it, "%" -> "%%"
		PSKKeyLength = gstrlen(pPsk);
		for(i=0;i<PSKKeyLength ;i++)
		{			
			gsprintf(stmpTMD,  T("%s"), &pPsk[i]);
			if(strncmp(stmpTMD,"%",1) == 0)
			{
				TMDCount[count]=i;
				count++;
				bPercent = TRUE;
			}
		}

		// Total precent Marks (%)
		TotalCount = count;
		if(bPercent == TRUE)  
		{
			gsprintf(stmpTMD,  T("%s"), pPsk);
			switch(TotalCount)
			{		
			case 1:
				for(i=0;i<PSKKeyLength;i++)
				{
					count = 0;
					if(i<TMDCount[count])
					{
						sTMD[i] = stmpTMD[i];
					}
					else if(i== TMDCount[count])
					{
						sTMD[i]=sTMD[i+1] = stmpTMD[i];		// Duplicate string
					}
					else 
					{
						sTMD[i+count+1] = stmpTMD[i];
					}		
				}
				break;
			default:
				for(i=0;i<TotalCount;i++)
				{
					for(j=0;j<PSKKeyLength;j++)
					{
						if(i==0)
						{
							if(j<TMDCount[i])
							{
								sTMD[j] = stmpTMD[j];
							}
							else if(j== TMDCount[i])
							{
								sTMD[j]=sTMD[j+1] = stmpTMD[j];	// Duplicate string
							}
							else 
							{
								sTMD[j+i+1] = stmpTMD[j];
							}
						}
						else 
						{
							if(j<TMDCount[i])
							{
							;
							}
							else if(j==TMDCount[i])
							{
								sTMD[TMDCount[i]+i]=sTMD[TMDCount[i]+i+1] = stmpTMD[j];
							}
							else if(j>TMDCount[i])
							{
								sTMD[j+i+1] = stmpTMD[j];
							}						
						}
					}
			}			

			break;			
		    }		
		}
	else{
			gsprintf(sTMD,  T("%s"), pPsk);
		}
	

	gsprintf(sRadiusIp1,  T("WLAN_RADIUS_SERVER_IP=\"%s.%s.%s.%s\"\n"), sTempIp1, sTempIp2, sTempIp3, sTempIp4);
	gsprintf(sRadiusPort, T("WLAN_RADIUS_SERVER_PORT=\"1812\"\n")); 	
	gsprintf(sRadiusSecret, T("WLAN_RADIUS_SERVER_SECRET=\"%s\"\n"), sValue);

		if(PSKKeyLength == 64)
		{
	        ifx_debug_printf("--PSK 2-PSKKeyLength == 64-\n");
			gsprintf(sPsk,  T("WLAN_PSK=\"%s\"\n"), sTMD);
			//websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,13,sWEPKeyLength,sRadiusIp1,sRadiusPort,sRadiusSecrct,sEncryType,sAuthType,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_PASSPHRASE=\"0\"\n");//old
			websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,12,sRadiusIp1,sRadiusSecret,sEncryType,sAuthType,sWEPKeyLength,sKeyUsed, sKey1, sKey2,sKey3,sKey4,sPsk,"WLAN_PASSPHRASE=\"0\"\n");
		}
		else if(PSKKeyLength >=8 && PSKKeyLength <= 63)
		{

			memset(sPsk, 0x00, MAX_FILELINE_LEN);	
			ifx_debug_printf("--PSK 2-PSKKeyLength >=8--\n");
			gsprintf(sPsk,  T("WLAN_PASSPHRASE=\"%s\"\n"), sTMD);
			ifx_debug_printf("sPSK=%s\n", sPsk);
			//websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,13,sWEPKeyLength,sRadiusIp1,sRadiusPort,sRadiusSecrct,sEncryType,sAuthType,sKeyUsed, sKey1, sKey2,sKey3,sKey4,"WLAN_PSK=\"0\"\n",sPsk);//old
			websSetCfgData(FILE_RC_CONF, TAG_WLAN_SECURITY,12,sRadiusIp1,sRadiusSecret,sEncryType,sAuthType,sWEPKeyLength,sKeyUsed, sKey1, sKey2,sKey3,sKey4,"WLAN_PSK=\"0\"\n",sPsk);
		}
		else
		ifx_httpdError(wp, 200, " --- The PSK Key length is not allow !\n");

		break;
		
		default:
			ifx_httpdError(wp, 200, "Wrong Encripytion Type!\n");
			return;
		}


	if ( ifx_GetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE, "WLAN_CURRENT_MODE", sValue) == 1 )
	{
	      //check wds and rest wds_init tag
             if ( !gstrcmp(sValue, "2") )
	      {
	              gsprintf(sMode, T("WLAN_CURRENT_MODE=\"2\"\n"));
			gsprintf(sWDSInit, T("WDS_MODE_INIT=\"0\"\n"));   
	              websSetCfgData(FILE_RC_CONF, TAG_WLAN_APMODE,2,sMode,sWDSInit);
	      }
	    
	}

	system(SERVICE_RESTORE);	

	//
	//system(SERVICE_WLAN);
#if 0 //p no
	if (APMode==0)
	  system(SERVICE_WLAN); //AP
	else if (APMode==1)
	  system(SERVICE_WLAN_APCLIENT); //CLIENT MODE
       else if (APMode==2)
	  system(SERVICE_WLAN_WDS);  //WDS MODE
#endif //p
	
	ifx_httpdNextPage(wp);

}
#endif //#elif (defined(WILDPASS) || defined(SPURS))
