/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

#include "ifx_emf.h"
#include <signal.h>
#include <unistd.h> 
#include <sys/types.h>
#include <sys/wait.h>
#include <ifx_common.h>
#include "ifx_httpd_method.h"
#include "ifx_common_defs.h"
#include "ifx_iip_fifos.h"
#include "ifx_cm.h"
#ifdef IIP
#include <sys/ioctl.h>
#include <net/if.h>
#endif
#include "ifx_src_cgi.h"
#include "ifx_web_common.h"

#ifdef DMALLOC
#include "dmalloc.h"
#endif

char_t g_nCurrentUserName[12];  //char_t	sCommand[MAX_DATA_LEN];
char_t g_nCurrentPassword[12];  // Stores Current loged in password
int g_nCurrentUserLevel;				//0:admin, 1:common user, 2:general user, default = 2

CGI_ENUMSEL_S web_Enum_Status[2] =
     {
          {0, "OFF"},
          {1, "ON"},
     };
CGI_ENUMSEL_S web_Enum_VAD[2] =
     {
          {0, "OFF"},
          {1, "ON"},
     };
CGI_ENUMSEL_S web_JitterBufSetting_Types[2] =
     {
          {1, "Fixed"},
          {2, "Adaptive"},
     };
CGI_ENUMSEL_S web_Dtmf_Types[4] =
     {
          {1, "None"},
          {2, "RFC 2833 Event"},
          {3, "In Band Voice"},
          {4, "Both"},
     };
CGI_ENUMSEL_S web_Frame_Sizes[4] =
     {
          {5, "5"},
          {10, "10"},
          {20, "20"},
          {30, "30"},
     };

CGI_ENUMSEL_S web_TelSpec  [4] =
{
    {1, "Generic"},
    {2, "ETSI"},
    {3, "Germany"},
    {4, "USA"},    
};
CGI_ENUMSEL_S web_Enum_QosYESNOMode[2] =
     {
          { 0, "NO"},
          { 1, "YES"}
     };
CGI_ENUMSEL_S web_Enum_QosZero2SevenMode[8] =
     {
          { 0, "0"},
          { 1, "1"},
          { 2, "2"},
          { 3, "3"},
          { 4, "4"},
          { 5, "5"},
          { 6, "6"},
          { 7, "7"}
     };
CGI_ENUMSEL_S web_Enum_QosL2L3Mode[2] =
     {
          { 0, "use L2 priority"},
          { 1, "use L3 priority"}
     };
CGI_ENUMSEL_S web_Enum_QosHandlingQueuesMode[2] =
     {
          { 0, "strict priority"},
          { 1, "weighted fair queuing"}
     };
CGI_ENUMSEL_S web_Enum_QosLowHighMode[2] =
     {
          { 0, "low"},
          { 1, "high"}
     };
CGI_ENUMSEL_S web_Enum_QosLANPCMode[2] =
     {
          { 0, "LAN"},
          { 1, "PC"},
     };
CGI_ENUMSEL_S web_Enum_QosDenyAcceptMode[2] =
     {
          { 0, "Deny"},
          { 1, "Accept"}
     };
CGI_ENUMSEL_S web_Enum_QosSendTaggedorNoneMode[2] =
     {
          { 0, "Send untagged"},
          { 1, "Send tagged"}
     };
CGI_ENUMSEL_S web_Enum_QosAlltaggedMode[2] =
     {
          { 0, "All"},
          { 1, "only tagged"}
     };
CGI_ENUMSEL_S web_Enum_QosONOFFMode[2] =
     {
          { 0, "OFF"},
          { 1, "ON"}
     };
CGI_ENUMSEL_S web_Enum_QosZero2TwoMode[3] =
     {
          { 0, "LAN"},
          { 1, "PC"},
          { 2, "IP Phone"}
     };

void http_print(char* buff)
{
	FILE *con;

	con=fopen("/dev/console","a");
	fprintf(con,buff);
	fflush(con);
	fclose(con);
}

//***************************** Common API ********************************
////////////////////////////////////////////////////////////////////////////////
//websSetCfgData(...)
//	Variable Name	==>	File Name
//------------------------------------------------------------------------------
//	pFileName		==>	Open File Name
//	pTag			==>	TAG_xxx
//	nDataCount		==>	Data number for setting.
//	pData			==>	Data content for setting.
//
//	Return Value :	0 is FALSE. 1 is TRUE
//
int websSetCfgData(const char_t* pFileName, const char_t* pTag, int nDataCount,
                   const char_t* pData, ... )
{
	FILE   	*fdIn, *fdOut;
	char_t 	arrInLine[MAX_FILELINE_LEN];
	char_t	strTempName[MAX_FILENAME_LEN];
	char_t	buf[BUF_SIZE_50K];	
	char_t 	arrBeginTag[MAX_TAG_LEN], arrEndTag[MAX_TAG_LEN];
	bool_t 	bTagArea = FALSE;
	va_list	args;

	// First, extract data for list and store into buffer
    	va_start( args, pData );
	gstrcpy(buf, pData);
	
	
    	while( --nDataCount )
    	{    	
 		pData = va_arg(args, char_t *);
		gstrcat(buf, pData);
	}
    	va_end(args);

	memset(arrBeginTag, 0x00, MAX_TAG_LEN);
	memset(arrEndTag, 0x00, MAX_TAG_LEN);
    	gsprintf(arrBeginTag, "#<< %s", pTag);
    	gsprintf(arrEndTag, "#>> %s", pTag);    
	
	if ((fdIn = gfopen(pFileName, "r+t")) == NULL)
	{
		fclose(fdIn);
		return 0;
	}

	gsprintf(strTempName, T("%s.tmp"), pFileName);
	if ((fdOut = gfopen(strTempName, "w+")) == NULL)
	{
		fclose(fdOut);
		return 0;
	}

	while (gfgets(arrInLine, sizeof(arrInLine), fdIn))    
    	{
        	if (!gstrlen(arrInLine)) continue; //Null line 

		// remove "\n" and keep string only
        	arrInLine[gstrlen(arrInLine)-1] = 0; 
        
        	if (gstrncmp(arrInLine, arrBeginTag, sizeof(arrBeginTag)) == 0) 
        	{
        		//trace(8, "Tag found: %s\n", arrBeginTag);
	        	bTagArea = TRUE;
        	}
        
       		gfprintf(fdOut, "%s\n", arrInLine);        
       	
		if (bTagArea)
		{
			// Print all datas to file
			int ret;
			ret = gfprintf(fdOut, buf);			

			//trace(8, "Retrun value of fprintf:%d\n", ret);			
			while (gfgets(arrInLine, sizeof(arrInLine), fdIn))
			{
				arrInLine[gstrlen(arrInLine)-1] = 0;
		        	if (gstrncmp(arrInLine, arrEndTag, sizeof(arrEndTag)) == 0)
		        	{
					//trace(8, "%s of EndTag found: %s\n", pFileName, arrEndTag);
			       		gfprintf(fdOut, "%s\n", arrInLine);
					bTagArea = FALSE;
					break;
				}
			}			
		}        
    	}

	fclose(fdIn);
	fclose(fdOut);

	if (gremove(pFileName) == 0)
	{
		grename(strTempName, pFileName);	
	}
	else
	{
		//trace(3, T("Cannot remove %s file!!!"), pFileName);
	}
	
	return 1;
}

/*****************************************************************************
* Function Name: ifx_web_Save_Setting
* Description  : save configuration data 
* Input Value  : 
* Output Value :
* Return Value : 0:Fail 1: Success
* Notes	:
*****************************************************************************/
int ifx_web_Save_Setting(void)
{
	//trace(8,"in ifx_web_Save_Setting function\r\n");
	// save system configuration data
	system("/etc/rc.d/backup");
	return 1;

}

void ifx_httpdNextPage(httpd_t wp)
{
	// Redirect next page
	char_t *pNextPageUrl = ifx_httpdGetVar(wp, T("page"), T(""));   // hidden page
	//trace(8, "Next page: %s", pNextPageUrl);
	
	//wp->ifx_return_value = 0;
	if (pNextPageUrl && *pNextPageUrl)
		ifx_httpdRedirect(wp, pNextPageUrl);
	else
		ifx_httpdDone(wp, 200);
}

void ifx_httpdNextPageFail(httpd_t wp)
{
	// Redirect next page
	char_t *pNextPageUrl = ifx_httpdGetVar(wp, T("page-fail"), T(""));   // hidden page
	//trace(8, "Next page: %s", pNextPageUrl);

	//wp->ifx_return_value = 0;
	if (pNextPageUrl && *pNextPageUrl)
		ifx_httpdRedirect(wp, pNextPageUrl);
	else
		ifx_httpdDone(wp, 200);
}

/*****************************************************************************
 *  Function Name   : websGetPartIP
 *  Description     : This function is called by any function which require 
 					  partial IP address
 *  Input Values    : Completed IP addres and Partail Index
 					  ex: pFullIP -> 10.2.3.4, nReqIdx -> 3, return "3" 
 *  Output Values   : Partial IP
 *  Return Value    : 
 *  Notes           :
 ****************************************************************************/
void websGetPartIP(const char_t* pFullIP, int nReqIdx, char_t* pRetValue)
{
	char_t	sIpaddr[MAX_DATA_LEN];
	char_t	*ip;
	int		i = 0;
	int 	nIndex = 0;	

	//trace(8, "IP Address: %s\n", pFullIP);
	
	memset(sIpaddr, 0x00, MAX_DATA_LEN);
	gstrcpy(pRetValue, "");

	for (i = 1; i <= nReqIdx; i++)
	{
		gstrcpy(sIpaddr, pFullIP);
		ip = strtok(sIpaddr, ".");	
		nIndex = 1;		
		while (ip != NULL && nIndex < i )
		{
			nIndex++;
			ip = strtok(NULL, ".");	
		}

		if ((i == nReqIdx) && (ip))
		{	
			gstrcpy(pRetValue, (const char_t*)ip);			
			return;
		}
	}
}

#ifdef IIP
///////////////////////////////////////////////////////////////////////
//// get host info
int GetHostInfo(char8 *pc_Hostip)
{

	struct ifreq Interface;
	int iRetVal,i;
	int Fd;
	struct in_addr *pAddr;
	Fd =  socket(AF_INET, SOCK_DGRAM, 0);
	if(Fd<0)
	{
		//printf("\n Socket open failed");
	}
	memset(&Interface,0,sizeof(struct ifreq));
	Interface.ifr_ifru.ifru_addr.sa_family = AF_INET;

	strcpy(Interface.ifr_ifrn.ifrn_name,"eth0");
	iRetVal = ioctl(Fd,SIOCGIFADDR,&Interface);
	if(iRetVal < 0)
	{
		return -1;
	}
	Interface.ifr_ifru.ifru_addr.sa_family = AF_INET;
	for (i = 0; i < 16; i++)
		pAddr= (struct in_addr*)&Interface.ifr_ifru.ifru_addr.sa_data[2];
	strcpy(pc_Hostip,inet_ntoa(*pAddr));
	return iRetVal;
}

//////////////////////////////////////////////////////////////////
//Get net mask
int32 GetNetMask(uchar8 *IPName)
{
	struct ifreq Interface;
	int iRetVal=1,i;
	int Fd;
	struct in_addr *pAddr;
	Fd =  socket(AF_INET, SOCK_DGRAM, 0);
	if(Fd<0)
	{
		return -1;
	}
	memset(&Interface,0,sizeof(struct ifreq));
	Interface.ifr_ifru.ifru_addr.sa_family = AF_INET;
	strcpy(Interface.ifr_ifrn.ifrn_name,"eth0");
	iRetVal = ioctl(Fd,SIOCGIFNETMASK,&Interface);
	if(iRetVal < 0)
	{
		return -1;
	}
	Interface.ifr_ifru.ifru_addr.sa_family = AF_INET;
	for (i = 0; i < 16; i++)
	{
	}
	pAddr= (struct in_addr*)&Interface.ifr_ifru.ifru_addr.sa_data[2];
	strcpy(IPName,inet_ntoa(*pAddr));
	return iRetVal;
}
#endif /* IIP */

