/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

#ifndef	__IFX_WEB_SUPPORT
#define	__IFX_WEB_SUPPORT


#ifdef DMALLOC
#include "dmalloc.h"
#endif

#define IFX_COMMENT_BEG "<!--"
#define IFX_COMMENT_END "-->"
#define IFX_TOKEN_BEG 	"<%"
#define IFX_TOKEN_END	"%>"

// Length of command between <% %>
#define IFX_COMMAND_LENGTH 500
// Length of the name of get/set function
#define IFX_FUN_NAME_LENGTH 100 
// Length of IFX_TOKEN "<%" or "%>"
#define IFX_TOKEN_LENGTH 2
// 
#define IFX_MAX_NO_ARG 10
#define IFX_ARG_LEN 100
#define IFX_DATA_BUFF 1024*10
#define IFX_TEMP_BUFF 128
#define IFX_REDIRECT_URL_LEN	128
#define IFX_HOST_NAME_LEN 	256
#define IFX_PARA_NAME_LEN	64
#define IFX_PARA_VAL_LEN	64

#define MALLOC_BUF_SIZE	IFX_DATA_BUFF

#define FORWARD	1
#define BACKWARD 0

typedef struct multi_buf {
	char *buf;
	int  len;
}T_MULTI_BUF;

struct ifx_arg_list
{
	char *pifx_param_name;
	int	numMultiBufs;
	union param_value{
		char *buf;
		T_MULTI_BUF *pArrMultiBuf;
	}ifx_param_value;
	int totBufLen;
    struct ifx_arg_list *next;
};

struct ifx_wp
{
  int ifx_no_argument;
  struct ifx_arg_list * ifx_ptr_arg_list;
  char ipaddr[32];
#if 0
  int multiDatalen;
  char multiData[256];
#endif
  char host[IFX_HOST_NAME_LEN];
  int ifxReadFd;
  int ifxWriteFd;
  int bSendHeader;
  char *pBoundary;
};

typedef struct ifx_wp *httpd_t;
typedef struct ifx_wp httpdType;

#endif
