/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : 
 *        Block   : 
 *        Creator : 
 *        File    : 
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

#ifndef	IFX_WEB_COMMON_H
#define	IFX_WEB_COMMON_H

#include "ifx_common_defs.h"
#include <ifx_cm.h>

/******************************************************************************
 * Defines, Structures and Variables
 ******************************************************************************/

#define IFX_WEB_MAX_PB_ENTRIES 50
#define IFX_WEB_MAX_CRYPTO_ENTRIES 5

typedef struct
{
  uint32  uiOpt;		// Prefer codec
  uchar8  ucIdx;  
  uchar8  uacCodec[10];  
} x_WEB_CodecOpt;

/* Web ASP Page select structure */
typedef struct
{
	/* Web ASP selected option value index */
    uint	 value;
    /* Web ASP selected option value index content */
    char_t    *str;
} CGI_ENUMSEL_S;

extern char_t g_nCurrentUserName[12];  //char_t	sCommand[MAX_DATA_LEN]; 
extern char_t g_nCurrentPassword[12];  // Stores Current loged in password
extern int g_nCurrentUserLevel;				//0:admin, 1:common user, 2:general user, default = 2
extern int16 NoOfPbEntries;

#if defined(ATA) || defined(IIP)
extern x_IFX_CM_AppAddressBookEntry xPBEntry[IFX_WEB_MAX_PB_ENTRIES];

#ifdef SRTP
extern x_IFX_CM_SrtpKeyCfg xCrypto[IFX_WEB_MAX_CRYPTO_ENTRIES];
#endif //#ifdef SRTP
#endif //#if defined(ATA) || defined(IIP)

extern CGI_ENUMSEL_S web_Enum_Status[2];
extern CGI_ENUMSEL_S web_JitterBufSetting_Types[2];
extern CGI_ENUMSEL_S web_Dtmf_Types[4];
extern CGI_ENUMSEL_S web_Enum_VAD[2];
extern CGI_ENUMSEL_S web_Frame_Sizes[4];
extern CGI_ENUMSEL_S web_Enum_QosYESNOMode[2];
extern CGI_ENUMSEL_S web_Enum_QosZero2SevenMode[8];
extern CGI_ENUMSEL_S web_Enum_QosL2L3Mode[2];
extern CGI_ENUMSEL_S web_Enum_QosHandlingQueuesMode[2];
extern CGI_ENUMSEL_S web_Enum_QosLowHighMode[2];
extern CGI_ENUMSEL_S web_Enum_QosLANPCMode[2];
extern CGI_ENUMSEL_S web_Enum_QosDenyAcceptMode[2];
extern CGI_ENUMSEL_S web_Enum_QosSendTaggedorNoneMode[2];
extern CGI_ENUMSEL_S web_Enum_QosAlltaggedMode[2];
extern CGI_ENUMSEL_S web_Enum_QosONOFFMode[2];
extern CGI_ENUMSEL_S web_Enum_QosZero2TwoMode[3];

/******************************************************************************
 * Functions
 ******************************************************************************/

 PUBLIC char8 IFX_CM_WebShut(void);

void http_print(char* buff);
void trace(int level, char_t *fmt, ...);

int websSetCfgData(const char_t* pFileName, const char_t* pTag, int nDataCount, const char_t* pData, ... );
int ifx_web_Save_Setting(void);
void ifx_httpdNextPage(httpd_t wp);
void ifx_httpdNextPageFail(httpd_t wp);
void websGetPartIP(const char_t* pFullIP, int nReqIdx, char_t* pRetValue);

//void ifx_set_logout(httpd_t wp, char_t *path, char_t *query);
int ifx_get_currentUser_authority_CGI(int eid, httpd_t wp, int argc, char_t **argv); 
void ifx_get_currentUser_authority(int eid, httpd_t wp, int argc, char_t **argv);
int inline ifx_get_defineSRTP(int eid, httpd_t wp, int argc, char_t **argv);

#ifdef IIP
int GetHostInfo(char8 *pc_Hostip);
int32 GetNetMask(uchar8 *IPName);
#endif /* IIP */

#endif /* IFX_WEB_COMMON_H */

