/*****************************************************************************
;
;   (C) Unpublished Work of ADMtek Incorporated.  All Rights Reserved.
;
;       THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
;       PROPRIETARY AND TRADESECRET INFORMATION OF ADMTEK INCORPORATED.
;       ACCESS TO THIS WORK IS RESTRICTED TO (I) ADMTEK EMPLOYEES WHO HAVE A
;       NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS
;       AND (II) ENTITIES OTHER THAN ADMTEK WHO HAVE ENTERED INTO APPROPRIATE
;       LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED,
;       PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,
;       ABBRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,
;       TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF ADMTEK.
;       ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD
;       SUBJECT THE PERPERTRATOR TO CRIMINAL AND CIVIL LIABILITY.
;
;------------------------------------------------------------------------------
;
;    Project : VanGogh
;    Creator : Jeanson Hung, SDC, ADMtek Inc.
;    File    : vgioctl.h
;    Abstract: include file for VanGogh IOCTL functions 
;
;    Modification History:
;		2004/01/04 - Created by Jeanson Hung
;
;*****************************************************************************/

#include <linux/ioctl.h>

/* type definitions */
typedef unsigned char U8;
typedef unsigned short U16;
typedef unsigned int U32;

typedef struct _REGRW_
{
  unsigned int addr;
  unsigned int value;
  unsigned int mode;
}REGRW, *PREGRW;

/* IOCTL keys */
#define KEY_IOCTL_ADM_REGRW	0x01
#define KEY_IOCTL_ADM_REGRW1	0x02

#define KEY_IOCTL_MAX_KEY	0x05

/* IOCTL MAGIC */
static const unsigned char ADM_MAGIC = 'a'|'d'|'m'|'t'|'e'|'k';

/* IOCTL parameters */
#define ADM_IOCTL_REGRW		_IOWR(ADM_MAGIC, KEY_IOCTL_ADM_REGRW, REGRW)
#define ADM_IOCTL_REGRW1		_IOWR(ADM_MAGIC, KEY_IOCTL_ADM_REGRW1, REGRW)

#define REG_READ	0x0
#define REG_WRITE	0x1
#define REG_READ_W	0x2
#define REG_WRITE_W	0x3
#define REG_READ_B	0x4
#define REG_WRITE_B	0x5
